#include "stdafx.h"
#include "Cchess_1.h"
#include "Cchess_2.h"
#include "Move.h"
//#include "Cchess_4.h"

// Dfinitions de structures 



enum NODE_TYPE
{
NODE_ALL=-1,
NODE_PV=0,
NODE_CUT=1
};



enum ATTRIBUTION_DROIT_ROQUE
{
ATTRIBUTION_DROIT_PETIT_ROQUE=0,
ATTRIBUTION_DROIT_GRAND_ROQUE,
PERTE_DROIT_PETIT_ROQUE,
PERTE_DROIT_GRAND_ROQUE,
PERTE_TOUT_DROIT_ROQUE,
EFFECTUE_PETIT_ROQUE,
EFFECTUE_GRAND_ROQUE
};

enum SITUATION_ROQUE
{
PAS_DE_DROIT_A_ROQUER=0,
DROIT_PETIT_ROQUE=1,
DROIT_GRAND_ROQUE=2,
PETIT_ROQUE=4,  // ne doivent pas avoir de modulo 4
GRAND_ROQUE=8   // ne doivent pas avoir de modulo 4
};


enum CONTROLE_MATERIEL
{
MATERIEL_EXISTE=0,
BLANC_ANNULE=1,
NOIR_ANNULE=2,
QUASI_NULLE=3,
PARTIE_NULLE=4,
BLANC_GAIN_CERTAIN=5,
NOIR_GAIN_CERTAIN=6
};





// enum niveaux d'analyse
enum NIVEAU_ANALYSE_SEARCH
{
SEARCH_ANALYSE_NULLMOVE			=1<<0,
SEARCH_ANALYSE_HINT_MOVE		=1<<1,
SEARCH_ANALYSE_COUPS_FAVORABLES =1<<2,
SEARCH_ANALYSE_PRISES	=1<<5,
SEARCH_ANALYSE_KILLERMOVES =1<<6,   // dont echecs !
SEARCH_ANALYSE_COUPS_HEURISTIQUES =1<<7,   // dont echecs !
SEARCH_ANALYSE_ATTAQUES_PION =1<<8,
//SEARCH_ANALYSE_SELECTION_HISTORIQUE	=1<<8,
// SEARCH_ANALYSE_SELECTION_POSITION	=1<<9,
SEARCH_ANALYSE_AUTRES_COUPS		=1<<10,
//SEARCH_ANALYSE_COUPS_RESTANTS	=1<<11,
SEARCH_ANALYSE_LISTE			=1<<12
};



enum NIVEAU_ANALYSE_EXTEND
{
EXTEND_PASSE_PASSIF			 	=1<<0,
EXTEND_ANALYSE_HINT_MOVE		=1<<1,
EXTEND_ANALYSE_COUPS_FAVORABLES	=1<<2,
EXTEND_PRISES_FAVORABLES_PIONS	=1<<3,
EXTEND_ANALYSE_ECHANGES_PIECE	=1<<4,
EXTEND_ANALYSE_ECHANGES_PION	=1<<5,
EXTEND_PRISES_PIECE_INFERIEURE  =1<<6,
EXTEND_ANALYSE_PRISES_CANDIDATES_ECHEC=1<<7,
EXTEND_ANALYSE_AUTRES_COUPS	=1<<8,
EXTEND_ANALYSE_COUPS_RESTANTS =1<<12
};

// 16 bits
//#if defined MAIN
//const unsigned short SEARCH_ANALYSE_IS_SELECTION_FILTER=SEARCH_ANALYSE_ATTAQUES_PION|SEARCH_ANALYSE_SELECTION_HISTORIQUE|SEARCH_ANALYSE_SELECTION_POSITION;
const unsigned short SEARCH_ANALYSE_IS_LISTE_FILTER=~0 ^ SEARCH_ANALYSE_KILLERMOVES ^ SEARCH_ANALYSE_ATTAQUES_PION ^ SEARCH_ANALYSE_NULLMOVE ^ SEARCH_ANALYSE_HINT_MOVE;
//const unsigned short EXTEND_ANALYSE_IS_LISTE_FILTER=~0 ^ EXTEND_PASSE_PASSIF ^ EXTEND_PASSE_ACTIF ^ EXTEND_ANALYSE_HINT_MOVE;
#define SEARCH_ANALYSE_IS_LISTE(analysis)	(((analysis)&SEARCH_ANALYSE_IS_LISTE_FILTER)!=0)
//#define EXTEND_ANALYSE_IS_LISTE(analysis)	(((analysis)&EXTEND_ANALYSE_IS_LISTE_FILTER)!=0)




#if COLLECT_STATS==1
// Origine des coups retenus
enum ORIGINE_COUPS_SEARCH
{
OR_SEARCH_DEPART=0,
OR_SEARCH_ANALYSE_LISTE,
OR_SEARCH_ANALYSE_NULLMOVE,
OR_SEARCH_REPONSE_STOCKEE,
OR_SEARCH_ANALYSE_HINT_MOVE,
OR_SEARCH_COUP_FORCANT,
OR_SEARCH_PROMOTION,
OR_SEARCH_ANALYSE_COUPS_FAVORABLES,
OR_SEARCH_ANALYSE_KILLERMOVES,
OR_SEARCH_ANALYSE_COUPS_HEURISTIQUES,
OR_SEARCH_PRISE_PIECE_DERNIER_COUP,
OR_SEARCH_PRISE_PIECE_NON_DEFENDUE,
OR_SEARCH_KILLERMOVE_1,
OR_SEARCH_KILLERMOVE_2,
OR_SEARCH_KILLERMOVE_3,
OR_SEARCH_KILLERMOVE_4,
OR_SEARCH_KILLERMOVE_5,
OR_SEARCH_ANALYSE_ATTAQUES_PION,
OR_SEARCH_ANALYSE_PRISES_PIECE,
OR_SEARCH_ANALYSE_PRISES_PION,
OR_SEARCH_ANALYSE_ECHECS,
OR_SEARCH_ANALYSE_AUTRES_COUPS,
OR_SEARCH_ANALYSE_COUVERTURES_ECHECS,
OR_SEARCH_ANALYSE_COUP_DECLASSE,
OR_SEARCH_ABSENCE_SUITE,
OR_SEARCH_PAT,
OR_SEARCH_MAT,
OR_SEARCH_DRAW,
OR_MARQUAGE_FIN_ENUM_OR_SEARCH
};

#if defined MAIN
#ifndef __XOR_SEARCH__
#define __XOR_SEARCH__
char xor_search[OR_MARQUAGE_FIN_ENUM_OR_SEARCH+1][50]=
{
"OR_SEARCH_DEPART",
"OR_SEARCH_ANALYSE_LISTE",
"OR_SEARCH_ANALYSE_NULLMOVE",
"OR_SEARCH_REPONSE_STOCKEE",
"OR_SEARCH_ANALYSE_HINT_HMOVE",
"OR_SEARCH_COUP_FORCANT",
"OR_SEARCH_PROMOTION",
"OR_SEARCH_ANALYSE_COUPS_FAVORABLES",
"OR_SEARCH_ANALYSE_COUPS_HEURISTIQUES",
"OR_SEARCH_PRISE_PIECE_DERNIER_COUP",
"OR_SEARCH_PRISE_PIECE_NON_DEFENDUE",
"OR_SEARCH_KILLERMOVE_1",
"OR_SEARCH_KILLERMOVE_2",
"OR_SEARCH_KILLERMOVE_3",
"OR_SEARCH_KILLERMOVE_4",
"OR_SEARCH_KILLERMOVE_5",
"OR_SEARCH_ANALYSE_ATTAQUES_PION",
"OR_SEARCH_ANALYSE_PRISES",
"OR_SEARCH_ANALYSE_ECHECS",
"OR_SEARCH_ANALYSE_AUTRES_COUPS",
"OR_SEARCH_ANALYSE_COUVERTURES_ECHECS",
"OR_SEARCH_ANALYSE_COUP_DECLASSE",
"OR_SEARCH_ABSENCE_SUITE",
"OR_SEARCH_PAT",
"OR_SEARCH_MAT",
"OR_SEARCH_DRAW",
"OR_MARQUAGE_FIN_ENUM_OR_SEARCH"
};
#endif
#endif

enum ORIGINE_COUPS_EXTEND
{
OR_EXTEND_DEPART=0,
OR_EXTEND_PASSE_PASSIF,
OR_EXTEND_ANALYSE_HINT_HMOVE,
OR_EXTEND_COUPS_FORCANTS,
OR_EXTEND_PROMOTION,
OR_EXTEND_ANALYSE_COUPS_FAVORABLES,
OR_EXTEND_PRISES_FAVORABLES_PIONS,
OR_EXTEND_PRISE_PIECE_DERNIER_COUP,
OR_EXTEND_PRISE_PIECE_NON_DEFENDUE,
OR_EXTEND_PRISES_FAVORABLES_PIONS,
OR_EXTEND_ECHANGE_PION,
OR_EXTEND_ECHANGE_PIECE,
OR_EXTEND_PRISE_PIECE_INFERIEURE,
OR_EXTEND_ECHEC,
OR_EXTEND_PASSE_PASSIF_RECUPERATION,
OR_EXTEND_ANALYSE_COUP_DEFENSE,
OR_EXTEND_ANALYSE_COUPS_RESTANTS,
OR_EXTEND_ANALYSE_COUVERTURES_ECHECS,
OR_EXTEND_ABSENCE_SUITE,
OR_EXTEND_PAT,
OR_EXTEND_MAT,
OR_EXTEND_DRAW,
OR_MARQUAGE_FIN_ENUM_OR_EXTEND
};


#if defined MAIN
#ifndef __XOR_EXTEND__
#define __XOR_EXTEND__
PREFIX char xor_extend[OR_MARQUAGE_FIN_ENUM_OR_EXTEND+1][50]=
{
"OR_EXTEND_DEPART",
"OR_EXTEND_PASSE_PASSIF",
"OR_EXTEND_ANALYSE_HINT_HMOVE",
"OR_EXTEND_COUPS_FORCANTS",
"OR_EXTEND_PROMOTION",
"OR_EXTEND_ANALYSE_COUPS_FAVORABLES",
"OR_EXTEND_PRISE_PIECE_DERNIER_COUP",
"OR_EXTEND_PRISE_PIECE_NON_DEFENDUE",
"OR_EXTEND_PRISES_FAVORABLES_PIONS",
"OR_EXTEND_ECHANGE_PION",
"OR_EXTEND_ECHANGE_PIECE",
"OR_EXTEND_PRISE_PIECE_INFERIEURE",
"OR_EXTEND_ECHEC",
"OR_EXTEND_PASSE_PASSIF_RECUPERATION",
"OR_EXTEND_ANALYSE_COUP_DEFENSE",
"OR_EXTEND_ANALYSE_COUPS_RESTANTS",
"OR_EXTEND_ANALYSE_COUVERTURES_ECHECS",
"OR_EXTEND_ABSENCE_SUITE",
"OR_EXTEND_PAT",
"OR_EXTEND_MAT",
"OR_EXTEND_DRAW",
"OR_MARQUAGE_FIN_ENUM_OR_EXTEND"
};
#endif
#endif

#if !defined MAIN
extern char xor_search[OR_MARQUAGE_FIN_ENUM_OR_SEARCH+1][50];
extern char xor_extend[OR_MARQUAGE_FIN_ENUM_OR_SEARCH+1][50];
#endif

#endif



enum PHASE_GENERATION
{
PRISES=1,
AUTRES_COUPS=2
/*PRISES_FAVORABLES=1,
PRISES_PIONS=2,
ECHANGES=3,
ECHECS=4,
COUPS_HEURISTIQUES=5,
ATTAQUES_PION=6,
AUTRES_COUPS=7,
COUPS_DECLASSES=8
*/
};

enum GAME_RESULT
{
UNDECIDED=0,
WHITE_GIVES_MATE=1,
BLACK_GIVES_MATE=2,
WHITE_IS_MATE=3,
BLACK_IS_MATE=4,
PLAYER_IS_PAT=5,
DRAW_REPETITION=6,
DRAW_50_MOVES=7,
THEORETICAL_DRAW=8,
WHITE_RESIGNS=9,
BLACK_RESIGNS=10
};


enum TYPE_DIRECTION
{
COLONNE,
LIGNE,
DIAGONALE
}
;


/*
enum KING_SAFETY 
{
KS_UNSAFE=0,
KS_SAFE=1
}
;
*/


enum PAWN_STRUCTURE
{
COLONNE_OUVERTE,
COLONNE_SEMI_OUVERTE,
PION_OPPOSE_BLOQUE_PROTEGE,
PION_OPPOSE_BLOQUE_NON_PROTEGE_AVANCE,
PION_OPPOSE_BLOQUE_NON_PROTEGE_NON_AVANCE,
PION_OPPOSE_LIBRE_AVEC_ACOLYTE,
PION_OPPOSE_LIBRE_PROTEGE,
PION_OPPOSE_LIBRE_NON_PROTEGE_AVANCE,
PION_OPPOSE_LIBRE_NON_PROTEGE_NON_AVANCE,
PION_ARRIERE_MASQUE,
PION_PROTEGE_SUR_COLONNE_OUVERTE,
PION_AVEC_ACOLYTE_SUR_COLONNE_OUVERTE,
PION_ISOLE_SUR_COLONNE_OUVERTE,
PION_ARRIERE_SUR_COLONNE_OUVERTE,
PION_PASSE_ISOLE,
PION_PASSE_PROTEGE,
PION_PASSE_AVEC_ACOLYTE
};



enum END_RESULT
{
BLACK_WIN=-1,
DRAW=0,
WHITE_WIN=1
};




enum GAME_ASKMOVE_ANSWERS
{
CHANGE_MODE=88,
CHANGE_TIME=91,
TAKE_BACK=99
};


enum UCI_PARAMETERS // doit commencer  1
{
NOT_FIXED=0,
PARAM_AVAILABLE_TIME_WHITE=1,
PARAM_AVAILABLE_TIME_BLACK,
PARAM_MOVETIME,
PARAM_ADDITIONAL_TIME_WHITE,
PARAM_ADDITIONAL_TIME_BLACK,
PARAM_TIMER_OFF_FIXED_NUMBER_OF_NODES,
PARAM_TIMER_FIXED_TIME_PER_MOVE,
PARAM_MATE_IN_X,
PARAM_SEARCH_X_PLIES,
PARAM_MOVES_TO_GO,
PARAM_HASH_SIZE,
PARAM_OWNBOOK,
PARAM_UCI_TEMPS_MANIPULATION,
PARAM_FENSTRING,
PARAM_FENSTRING_TRAIT,
PARAM_FENSTRING_ROQUE,
PARAM_FENSTRING_CASE_EP,
PARAM_FENSTRING_INUTILISE,
PARAM_FENSTRING_NBCOUPS,
PARAM_NUMBER_OF_THREADS
};

enum XCOL
{
statut=0,
nbpion=1,
opp=2,
ppas=3,
pro=4,
aco=5,
blo=6,
};



/*
enum XCOL
{
statut=0,
nbpion=1,
opp=2,
ppas=3,
pro=4,
duo_g=5,
duo_d=6,
aco=7,
pro_g=8,
pro_d=9,
blo=10,
poss_duo_g=11,
poss_duo_d=12,
case_faible2=13
};
*/



/*
enum XDERNIER
{
pos_dernier=0,
num_dernier=1
};
*/






enum CATEGORIE_FINALE
{
MILIEU_DE_PARTIE=0,
FIN_DE_PARTIE_1=1,
FIN_DE_PARTIE_2=2,
ROI_VS_ROI=3
};

enum CHECK_TYPE
{
PAS_ECHEC=0,
ECHEC_PION='P',
ECHEC_CAVALIER='C',
ECHEC_FOU='F',
ECHEC_TOUR='T',
ECHEC_DAME='D',
ECHEC_DOUBLE=2
};

enum BILAN_AD_ENUM_3
{
//PERTE_MATERIELLE=-1, //dja dfini
PIECE_DEFENDUE=0
};


enum BILAN_AD_ENUM
{
GAIN_MATERIEL=1,
COUP_NEUTRE=0,
PERTE_MATERIELLE=-1,
BILAN_NON_CALCULE=-2
};


enum BILAN_AD_AC_SIMPLIFIE_ENUM
{
TAKES_UNPROTECTED=1,
NEUTRAL=0,
MATERIAL_LOSS=-1,
NOT_CALCULATED=-2
};





/*
enum BILAN_AD_2
{
PRISE_CANDIDATE=1,
PRISE_NON_CANDIDATE=0
};
*/

enum STATUT_COUP 
{
DEMARRAGE=0,
FIRSTMOVE=1,
LISTMOVES2=2,
LISTMOVES=3
};




/*
enum KING_SAFETY
{
MAYBE_SAFE=0;
OPEN_DIAGONALS=1;
OPEN_LINES=2;
//MAYBE_SAFE=0;
//MAYBE_NOT_SO_SAFE=1;
//MAYBE_NOT_SAFE_AT_ALL=2;
// LETS_RUN=3;
};
*/



enum LEGALITY
{
NON_DETERMINE=0,
LEGAL=1,
ILLEGAL=2,
CLOUAGE=3
};





enum CATEGORIE_COUP
{
COUP_FORCANT=0,
PROMOTION=1,
HINT_MOVE=2,
PRISE_FAVORABLE_PION=3,
ECHANGE_PIECE=4,
ECHANGE_PION=5,
PRISE_PIECE_INFERIEURE=6,
PRISE_PION_PAR_PIECE=7,
KILLERMOVE=8,
ECHEC=9,
COUP_HEURISTIQUE=10,
AUTRE_COUP=11
// AUTRE_COUP_2=12,
// COUP_DECLASSE=14,
// COUP_ELIMINE=15
};


/*
enum SAFETY_STATUS
{
SAFETY_NOT_DETERMINED=0,
//UNCERTAIN=1,
//PROBABLY_SAFE=2,
//PROBABLY_UNSAFE=3,
SAFE=4,
UNSAFE=5
};
*/


enum DRAW_STATUS
{
DRAW_STATUS_NOT_DETERMINED=0,
NOT_DRAW=1,
NOT_DRAW_DISTRUST_HASH_TABLE=2,
REPETITION_DRAW=3,
RULE_50_MOVES_DRAW=4
//REPETITION_DRAW_IN_ANALYSIS=5
};


enum CHECKING_STATUS
{
CHECK_NOT_DETERMINED=0,
NO_CHECK=-1,
CHECK=1
};


/*
struct KILLERMOVE
{
//char indice;
MOVE move;
char nb_hits;
short score;
};
*/

//typedef KILLERMOVE TAB_KILLERMOVE [NOMBRE_KILLERMOVES];


/*
struct CHAINE
{
CHAINE* previous;
MOVE*  move;
CHAINE* next;
};
*/


/*
struct ADR
{
MOVE *move;
char Fplay;
};
*/

/*
struct HISTORY
{
MOVE *move;
long hits; 
#if USE_MICROSOFT_64_BITS_INTEGERS==1
__int64 compteur;
#else
long compteur;
#endif
};
*/




struct H_CODE
{
  unsigned long address;
  unsigned long key;
};


struct LISTLEVEL
{
#if _DEBUG==1 
char dep88;
char arr88;
#endif
//char dep, arr;
char num;
char type;
//char move_nature;
//short capture_value;
char Fplay;
//bool coup_declasse;
MOVE move;
//LEGALITY legal;
bool wasbest;
//char selected_move;
#if _DEBUG==1
//char onceplayed;
#endif
//char categorie;  // peut tre modifi
//long history;
//short value;
//short oldvalue; 
//char justplayed;
//char valuestat;
//char categorie_elaguage;
//char is_registered_answer;
//bool in_listmoves2;
//char is_hint_move;
#if ALLOW_LEVEL_INTERMEDIAIRE==1
#if USE_IID_SELECTION==1
bool iid_selected;
#endif
#endif
CHECKING_STATUS givecheck;
//char bilan_coup;
long priority; 
char hit_ratio;
char draw_status;
char hash;
char hscore_status;
short hscore;
short score;
char hash_depth_moins_level;
H_CODE h;
MOVE hmove;
};


/*
struct LISTLEVEL2
{
#if _DEBUG==1 
char dep88;
char arr88;
#endif
char num;
char type;
char move_nature;
short capture_value;
char Fplay;
MOVE move;
LEGALITY legal;
#if _DEBUG==1#endif
char categorie;  // peut tre modifi
char is_hint_move;
char bilan_coup;
char draw_status;
char hash;
H_CODE h;
char index;
};

*/

struct DA
{
	char dep88;
	char arr88;
	char level;
	char color01;
};


struct ENTREE_BIBLIOTHEQUE_88
{
short nbcoups;
char dep88;
char arr88;
char special;
char prom;
char stat;
char F_match;
char F_interdiction;
short signature_blanc;
short signature_noir;
};




struct PIECE_SET
{
char posvalue;
char mobility;
char mobility_prises;
char mobility_others;
char mobility2;
char develop;
#if SUIVI_PRISES==1
char prises;
char prises_pion;
#endif
char tower;
#if USE_CASES_COUPS_FORCANTS==1 
unsigned __int64 cases_coup_forcant;
#endif
#if SEARCH_UNDEFENDED_PIECES==1 || NO_EXTEND_PASSE!=1
#if USE_PIECES_ATTAQUEES==1
unsigned __int32 pieces_attaquees;
#endif
#endif
#if USE_CASES_ACTUALISATION==1
unsigned __int64 cases_actualisation;
#endif
bool F_promotion;
// Sert pour le contrle de non double-actualisation
char levelmoves;  // level d'actualisation des coups
MOVE *moves;
MOVE *moves2;
PIECE_SET* oldptr;
};



// Dfinition d'une structure de pices
struct PIECE
{
char num_piece;
char nature;
char color;
char color01;
short value;
char pos;
char posx;
char posy;
//char diag1;
//char diag2;
//char code; // est compris entre 0 et 7 ( PB, PN, C, F, D, RB, RN )
//char code;
// type est compris entre 0 (PB) et 11 (RN)
char type;
char maxdir;
H_CODE hash_code;
//H_CODE pawn_hash_code;
#if SUIVI_PRISES==1
char prises;
char prises_pion;
#endif
PIECE_SET* psptr;
};

/*
#if CHECK_CHECKS==1
typedef PIECE *PIECEPTR;
#endif
*/


// Dfinition d'une structure d'chiquier
struct CASE
{
char nature;
char color;
char color01;
char num_piece;
short piece_value; // >0
PIECE* wptr;
char pos;
char posx;
char posy;
char diag1;
char diag2;
char posvalue[12];
};



/*
// pour recopie complte d'une structure de 64 octets
struct CASE3
{
char nature; // signed
#if _DEBUG==1
char unsigned_nature;
#endif
// char color01;
// char num_piece; // est-ce ncessaire ?
// short piece_value; // peut tre calcule
};


struct CASE2
{
char pos;
char pos64;
char pos88;
char posx;
char posy;
char diag1;
char diag2;
char posval[12];
};
*/

/*
struct REPT
{
char dep;
char arr;
char nature;
char color;
char match;
};
*/


/* General definition file for structures */

// move structure to encapsulate several important move parameters
// note: The char used below is treated like an integer.

/*
struct MOVE_T {
  char from;                   // from square
  char to;                     // to square
  char type;                   // type of move (defined below)
  char promote;                // type of piece to promote to (defined below)
};
*/

/*   Type of move  */
//     1 = capture
//     2 = castle
//     4 = en passant
//     8 = 2 square pawn advance (could leave an en passant square)
//    16 = pawn push 
//    32 = promotion

/*   Type of piece to promote to */
//     2 = Knight
//     3 = Bishop   
//     4 = Rook
//     5 = Queen 

// union of move_t and an integer to make comparison of 
// moves easier.  (as suggested in Tom Kerrigans simple chess program)

/*
union move {
  move_t b;
  int t;           // assuming a 32 bit integer
};
*/


/*
// Structure for a square

struct SQUARE {
  char type;             // type of piece (0 - 6)
  char side;                  // side which owns square (1 = white)
};
*/

// Structure for hash code and key of a position


// Structure pour fichier de partie
struct ENREGISTREMENT 
{
char  pgn[PGN_MOVE_LENGTH+1];
short xnbcoups;
short ynbcoups;
char demicoup;
char dep88;
char arr88;
char prom;
//unsigned __int32 special;
char special;
char piece_num;
char prise_nat;
char prise_num;
char status;
char check;
};



/*
// Structure for current board position.

struct POSITION {
  square sq[64];               // array of board squares
  char wtm;                   // flag for white to move
  char castle;                // castling status
  char ep;                    // location of an en-passant square (if any)
  char fifty;                 // fifty move count
  char has_castled[2];        // flag that side has castled
  char kingpos[2];            // location of kings
  char check;                 // is the side to move in check?
  char pieces[2];             // # of pieces(non-pawns)
  short material;              // material value from point of view of
                              // side to move
  move last;                  // last move made
  H_CODE hcode;               // hash code
};
*/



/* Standard hash record - 16 bytes long */
/* Respecter l'ordre des champs !! */
struct HASH_REC
{
  unsigned long key; // 4
  short score;		 // 2
  MOVE move; // 4 (int32 soit 4 octets)
  // pour mmoire un pointeur est 4 octets
  // Utilis aussi pour xnbcoups+xlevel en extend
  char depth_moins_level; // 2
  char flag; // 2
  char signature_nbcoups;
  //char hash_indice_generation;
  //char lv1_dep; // Case de dpart au niveau 1
  //unsigned __int16 lv1_move;
  //char lv2_dep;
  //char age; // signed - dmarre  -1
 };
// Remarque  implmenter
// flag2  n'est pas implment
// cela tombe bien
// Ceci doit permettre de stocker d'une part
// le xcompteur d'obtention
// et d'autre part la profondeur atteinte
// ide : si la position a dja t obtenue, mais  un level
// infrieur, c'est qu'il y a des rptitions et que la profondeur relle
// est infrieure => celle-ci doit tre diminue




struct HASH_PAWN_REC
{
  unsigned long key;
  short pawnstruct;
  char passed[2];
  char passed_maxpos[2]; 
  char colonnes_ouvertes;
  short roque[2];
  short king_safety[2];
};

struct SELECTION
{
// il vaut mieux permuter des char que des listmovesptr
// inconvnient, l'accs ultrieur n'est pas direct
LISTLEVEL *listmovesptr;
long priority; // l'heuristique history est long
};



//class checkclass;

struct THREADSTRUCT
{
public : 
//checkclass *checkinstance;

private :
};


struct STATEVALUES 
{
// Modifis EXCLUSIVEMENT AU LEVEL+1
#if MULTTHREADED==1
THREADSTRUCT thread;
#endif
short materiel;
short mobility;
char nb_promotions[2];
//short extensions;
#if USE_PIECES_ATTAQUEES==1
#if USE_SEARCH_ALL_UNDEFENDED_PIECES==1 || NO_EXTEND_PASSE==0
unsigned __int32 pieces_attaquees;
#endif
#endif
#if USE_CASES_COUPS_FORCANTS==1
unsigned __int64 cases_coup_forcant[2];
#endif
char developpement[2];
#if ALLOW_PAWN_SQUARE_CONTROL==1
char nombre_de_pions_par_couleur_de_cases[2][2];
#endif
char tower; // doublement des pices lourdes
short position;
short lastprise2;
#if USE_QUEEN_THREATS==1
char available_queen_move_extensions;
#endif
#if TRACK_QUEEN_POSITION==1
char queen_position[2];
#endif
bool F_node_is_former_PV;
//Inutile : car ne sont pas mis  jour
//ou rafraichis par la fonction get_hash_pawn
//char col[2][9][14];
//char premier_pion[2][9];
//char dernier_pion[2][9][2];
char colonnes_ouvertes;
char passed[2];
char passed_maxpos[2];
short pawnstruct;
short roque[2];
short king_safety[2];
short materiel_pieces[2];
char materiel_pions[2];
char materiel_dames[2];
char materiel_tours[2];
char materiel_fous[2];
char materiel_cavaliers[2]; 
char fou_de_couleur[2][2]; // noir et blanc
// unsigned __int64 cases_echec_pion[2];
// unsigned __int64 cases_echec_cavalier[2];
unsigned __int64 cases_echec_fou[2];
unsigned __int64 cases_echec_tour[2];
unsigned __int64 cases_echec_dame[2];
//unsigned __int64 cases_pieces_clouees[2];
//char clouages[32]; // contient la direction de clouage
#if KING_SAFETY==1
char king_open_diagonals[2];
char king_open_lines[2];
char king_open_columns[2];
#endif
// char o_o[2]; char o_o_o[2];
unsigned char droit_roque[2];
unsigned char equivalent_droit_roque[2];
// unsigned code_roque;
char finale;
bool F_echange_dame[2];
char roi_pos[2];
char roi_posx[2];
char roi_posy[2]; 
//char roi_diag1[2];
//char roi_diag2[2];
#if DEPRECIATE_CHECKS==1
char nb_checks[2];
#endif
#if INCREMENTAL_HASH==1
H_CODE hash_code;
H_CODE pawn_hash_code;
#endif
unsigned __int64 cases_pions[2];
unsigned __int64 cases_pieces[2];
#if FOLLOW_KNIGHTS==1
unsigned __int64 cases_cavaliers[2];
#endif
#if USE_BITBOARD_MOVE_GENERATION==1 || CHECK_MOVE_GENERATION_WITH_BITBOARDS==1
unsigned __int64 cases_toutes_pieces[2]; // inclut les pions qui ont cependant leur int64 spar
#endif
//MOVE liste_level[LENGTH_SEARCHLISTMOVES+1];
};


struct STATEVALUES2 // extend
{
}
;



/*
struct LEVELVALUES // level values
{
//char analysis;
char check;
unsigned __int64 cases_couverture_echecs; 
char ep_square64;
#if CHECK_CHECKS==1
char check2;
#endif
//char nb_coups_liste;
#if USE_RESTRICT_NULLMOVE==1
bool F_restrict_nullmove;
#endif
//unsigned __int64 cases_fourchette_pion[2];
//unsigned __int64 cases_attaque_pion[2];
//char wtm;
//char player;
//unsigned __int64 cases_interception;
//unsigned __int64 cases_protection;
//unsigned __int32 pieces_attaquees_dernier_coup;
//SELECTION select_protection[SELMAX_PROTECTION];
//SELECTION select_attaque_pion[SELMAX_ATTAQUE_PION];
//SELECTION select_history[SELMAX_HISTORY];
//SELECTION select_position[SELMAX_POSITION];
};
*/




struct BILAN_AD
{
char inc;
char nb_inc;
char nbinc_max;
char pos;
bool F_dir_cavalier;
char direction_interrompue;
};





