#include "stdafx.h"
#include "Move.h"


/* Number of hash related functions */
void open_hash();
void close_hash();
void set_hash_tables(short Hash_Mbytes, short Pawn_Mbytes); 
void reset_hash_table(void);
// void clean_hash_table(unsigned __int16 lv1_move);
void reset_hash_indice_generation(void);
void put_pawn_hash(H_CODE &h_key);
char get_hash(H_CODE &h_key,short depth_moins_level,
			  char &hash, MOVE& hmove, short& hscore, char& hscore_status,
			  char &hash_depth_moins_level,
			  char node_type
			  #if HASH_TRACK_PV==1
			  ,char requested_node_type
			  #endif
			  );
char get_pawn_hash(H_CODE &h_key);
void put_pawn_hash(H_CODE &h_key);
inline void or(H_CODE &A, H_CODE B);
H_CODE gen_code(bool F_inc);
H_CODE gen_code_pawn(void);
void put_hash(H_CODE &h_key, short score, short depth_moins_level, char F_alphabeta, MOVE hmove
			  #if HASH_TRACK_PV==1
			  ,char next_node_type
			  #endif
			  );
void start_code(void);
float ran(long *idum);

char cavalier(char arr,char color,char piece, char inc,
					 char *board);
char direction(char arr,char color,char piece, char inc, 
					  char *board);
void makeposvalue2(void);
//void xboard_posval(void);
char getON(char *a);
//short fctn_eval(SEARCH* sl,STATEVALUES *s);
char searchstart(void);
//void jouer(const MOVE move);
//void maj_roque2(STATEVALUES *statesptr, MOVE_BASE move);					
//void copieMOVE_special(MOVE *xpt, const MOVEypt);
char askmove(void);
char fct_repetition(MOVE lignemove, H_CODE &h, short lastprise2);
#if CHECK_REPET==1
char fct_repetition2(MOVE move, short lastprise2);
#endif
void affiche_stat_elag(void);
char getdiag1(char pos);
char getdiag2(char pos);
char searchroot(void); 
/*
short search(short previous_depthmove,
			 char node_type_original,short alpha,short beta,MOVE received_hint_move, short valuemoins ,
			 char a, char b, char aa, char bb
			 #if USE_ANSWER==1 
			 ,MOVE answer
			 #endif
			 ); 
*/
char french_to_english(char input);
void enregistre_coup_pgn(char F_write_to_pgn_file);
char adjust_book_stats(char result);
void reset_book_stats(void);
//void eval_pawnstruct(STATEVALUES *s);
//void eval_pawnstruct2(STATEVALUES *s);
bool pgn_compare(char* string1, char *string2);
void ajustement_parametres_globaux(void);
int cree_partie_pgn(int xhandle, char *xnom_game, 
				   ENREGISTREMENT *xpartie, short xnbcoups);
void reconstitution_ligne_principale(MOVE *mpt,char move_one_has_been_played);
void initialize_standard_board_english(char *board);
double get_time_in_seconds(void);
void log_error(char *string);
void log_to_file(char *string);
#if LOG_MOVES==1
void log_moves_to_file(char *string);
#endif
void log_info(char *string, unsigned __int64 compteur);
void log_info(char *string, short compteur);
void log_info(char *string, char compteur);
void log_info(char *string, bool compteur);
void log_info(char *string);
void log_error(char *string, unsigned __int64 compteur);
void log_error_no_stop(char *string, unsigned __int64 compteur);
bool MOVE_IS_OK_128(char dep64,char inc128);
bool MOVE_IS_OK_ASSERT(char dep,char arr,char inc64, bool F_cavalier);
bool MOVE_IS_OK_KNIGHT(char dep,char arr);
//bool KNIGHT_DEP_ARR_COMPATIBILITY(char dep,char arr);

void compact_piece_list(void);
void affiche(char i);
void affiche_ligne(MOVE *best, char move_one_has_been_played);
#if DEBUG==1
void affichage(MOVE move,
			   char analysis);
#endif
bool fourchetteC(char wtm,char arr);
bool fourchetteP(char wtm,char arr);
void copiebest(MOVE *bestplus, MOVE *best);
//void copiekeep(void);
void efface_ligne(char n);
char askmove_search(void);
char pgn_a1_to_88(char *buff);
char pgn_a1_to_64(char *buff);
void fixe_bornetemps(void);
void check_mate_score(MOVE *ligne, short &value);

#if HASH_TRACE==1
void hashtrace(h_code h);
#endif


void liste_coups_legaux(void);
char getposvalue(char nature, char color, 
						char arr);
//void dejouer(MOVE move,char actu);
void make_struct_moves(void);
void recompute_move_priorities(void);
//void actualise_all(SEARCH *sl, STATEVALUES *s);
void read_bibliotheque(char play_moves);
//void check_reset_state_values(STATEVALUES *s, char level, char reset);


void setvalue(PIECE *wptr);
void affiche(char i);
void setpcode(char num);

void Dispose(void);
char english_to_french(char input);
void debut(void);
void display_info(char *info_buffer);
void display_info_debug(char *info_buffer);
void display_info_force(char *info_buffer);
void formatte_move_to_uci(MOVE mpt, char *uci_move );
//char bilan_attaque_defense(STATEVALUES *s,char pos);
//char bilan_attaque_defense_avant_coup(STATEVALUES *s,MOVE move);
void controle_obligation_passe_actif(char aa, char bb);
#if USE_SEARCH_ALL_UNDEFENDED_PIECES==1
void inventaire_pieces_non_defendues(STATEVALUES *s,
									 char a,char b, 
									unsigned __int32 &pieces_non_defendues,
									bool &F_piece_non_defendue,
								 	//char &nb_pieces_non_defendues, char &nb_pions_non_defendus,
									//short &max_valeur_pieces_non_defendues,
									//short &max_valueprise_bilan,
									char &case_cible_heuristique_protection
	);
#else 
void inventaire_pieces_non_defendues(STATEVALUES *s,
									char a,char b, 
									unsigned __int32 &pieces_non_defendues,
									bool &F_piece_non_defendue);
#endif
char liste_pieces_attaquees(char &pieces_attaquees);
void affiche_coup(MOVE move);
void maj_droit_roque(unsigned char &roque, char droit); 
int uint32_compare(const void * a, const void * b);
int listlevel_compare(const void * a, const void * b);






