#include "stdafx.h"
#include "Cchess_1.h"
#include "Cchess_2.h"
//#include "Cchess_3.h"
#include "Cchess_4.h"
#include "Cchess_5.h"
#include "Cchess_6.h"
 


void SEARCH::extend_initialize_move_generator()
{
char dep, arr;
char cc,dd;
char move_nature;


F_hint_move_has_been_played=false;
F_utilisation_liste=false;
nb_prises=0;
nb_prises_pion=0;
nb_echanges_piece=0;
nb_echanges_pion=0;
nb_prises_piece_inferieure=0;
#if EXTEND_PRISES_INSUFFISANTES_CANDIDATES_ECHECS==1
nb_prises_candidates_echec=0;
#endif
nb_autres_coups=0;
nb_coups_declasses=0;
nb_coups_liste=0;
F_pas_de_prises=false;
MOVE move;
other_wtm_roi_pos=s->roi_pos[other_wtm];


#if EXTENDLEVEL_KILLERMOVE==1
if (hint_move==0)
{
	if (xlevel==xextendlevel)
	{
		if (previous_search_level->nbplayed!=1)
		{
			move=extend_oldbest;
			if (MOVE_IS_FORCING(move))
			{
				if (xboard[MOVE_ARR64(move)].nature!=0)
				{
					if (xboard[MOVE_DEP64(move)].nature==MOVE_NATURE(move))
					{
						hint_move=move;
					}
				}
			}
		}
	}
}
#endif


// Contrle de lgalit du hint_move
// et insertion dans liste hint_move
if (hint_move!=0) 
{
if (MOVE_IS_FOR_PLAY(hint_move))
{
dd=0;
do
{
	dep=MOVE_DEP64(hint_move);
	arr=MOVE_ARR64(hint_move);
	num=xboard[dep].num_piece;
	if (num<debut_blanc || num>fin_blanc)
	{
		#if DEBUG==1
		{
			log_error_no_stop("EM_814", xcompteur);
		}
		#endif
		break;
    }
	numptr=&xw[num];
	if (numptr->nature==0) break;
	if (MOVE_CAPTURE(hint_move)!=0 || MOVE_PROMOTION(hint_move)=='D')
	{
		moveptr=numptr->psptr->moves2;
	}
	else
	{
		moveptr=numptr->psptr->moves;
	}
	for(;;moveptr++)
	{
		move=*moveptr;
		if (move==0) break;
		
		if (SAME_MOVE(move,hint_move))
		{
			// Eviter les suites infinies d'checs
			if (!MOVE_IS_CAPTURE(move) && !MOVE_IS_PROMOTION(move) 
				#if USE_MATE_IN_ONE==1
				&& !F_case_de_mat
				#endif
				)
			{
				// Si au dela des checs, pas d'checs !
				if (xlevel>levelmax_echecs)
				{ break; }
				// Le coup donne-t-il chec, d'ailleurs ?
				// Vrification sommaire
				move_nature=MOVE_NATURE(move);
				cc=0;
				switch(move_nature)
				{
				case 'P' : if (givecheck_pion(MOVE_ARR64(move),wtm))
						   { cc=1; }
						   break;
				case 'C' : if (givecheck_cavalier(MOVE_ARR64(move)))
						   { cc=1; }
						   break;
				case 'F' : if (givecheck64(s->cases_echec_fou[wtm],MOVE_ARR64(move)))
						   { cc=1; }
						   break;
				case 'T' : if (givecheck64(s->cases_echec_tour[wtm],MOVE_ARR64(move))) 
						   { cc=1; }
						   break;
				case 'D' : if (givecheck64(s->cases_echec_dame[wtm],MOVE_ARR64(move)))
						   { cc=1; }
						   break;
				case 'R' : if (givecheck_roi(move))
						   { cc=1; }
				default : break;
				}
				if (cc!=1) break;
			}

			//legality=(LEGALITY) 0;		
			// Contrle lgalit
			#if USE_CASES_ACTUALISATION==1
			if (bit(pieces_with_possible_illegal_moves,numptr->num_piece))
			#endif
			{
				cc=SEARCH::legal(num,move,num_roi,*lignemoins);
				if (cc!=1) break;
			}

			dd=1; // hint_move est lgal : IMPORTANT
			nb_coups_liste=1;
			hint_moves[0]=move; // pas hint_move qui peut-tre uen capture
			hint_moves[1]=0;
			
			
			//listmovesptr->legal=LEGAL;
			//listmovesptr->move=move;
			//*listmovesptr=move;
			//listmovesptr->move_nature=MOVE_NATURE(move);
			//listmovesptr->num=num;
			//listmovesptr->categorie=(char) MOVE_CATEGORY(move);
			//listmovesptr->capture_value=MOVE_CAPTURE_VALUE(move);
			//listmovesptr->Fplay=0;
			//listmovesptr->bilan_coup=BILAN_NON_CALCULE;
			//listmovesptr->hash=HASH_NON_DETERMINE;
			//listmovesptr->draw_status=DRAW_STATUS_NOT_DETERMINED;
			break;
		}
	} 
	break;
} while(1);
// Annulation du hint_move si illgal
if (dd==0) 
{
	hint_move=0;
}
}
} // fin hint_move!=0


if (check!=0)
{
	// Cases de couverture
      //cases_couverture_echecs=xsearch_level[xlevel].couverture_echec_64;
	extend_cree_liste_prises();
	extend_cree_liste_autres_coups();
	if (!F_existe_coup_legal) return;
	phase_generation=AUTRES_COUPS;
	F_utilisation_liste=true;
	if (hint_move!=0) 
	{
		analysis=EXTEND_ANALYSE_HINT_MOVE;
	    #if COLLECT_STATS==1
	    origine_coups_analysis_extend=OR_EXTEND_ANALYSE_HINT_HMOVE;
	    #endif
		moveptr=&hint_moves[0]-1;
	}
	else 
	if (nb_prises>0)
	{
		analysis=EXTEND_ANALYSE_COUPS_FAVORABLES;
	    #if COLLECT_STATS==1
	    origine_coups_analysis_extend=OR_EXTEND_ANALYSE_COUPS_FAVORABLES;
	    #endif
		moveptr=&prises[0]-1;
	}
	else if (nb_prises_pion>0)
	{
		analysis=EXTEND_PRISES_FAVORABLES_PIONS;
	    #if COLLECT_STATS==1
	    origine_coups_analysis_extend=OR_EXTEND_PRISES_FAVORABLES_PIONS;
	    #endif
		moveptr=&prises_pion[0]-1;
		prises_pion[nb_prises_pion]=0;
	}
	else if (nb_echanges_piece>0)
	{
		analysis=EXTEND_ANALYSE_ECHANGES_PIECE;
	    #if COLLECT_STATS==1
	    origine_coups_analysis_extend=OR_EXTEND_ANALYSE_ECHANGE_PIECE;
	    #endif
		moveptr=&echanges_piece[0]-1;
		echanges_piece[nb_echanges_piece]=0;
	}
	else if (nb_echanges_pion>0)
	{
		analysis=EXTEND_ANALYSE_ECHANGES_PION;
	    #if COLLECT_STATS==1
	    origine_coups_analysis_extend=OR_EXTEND_ANALYSE_ECHANGE_PION;
	    #endif
		moveptr=&echanges_pion[0]-1;
		echanges_pion[nb_echanges_pion]=0;
	}
	else if (nb_prises_piece_inferieure>0)
	{
		analysis=EXTEND_PRISES_PIECE_INFERIEURE;
	    #if COLLECT_STATS==1
	    origine_coups_analysis_extend=OR_EXTEND_PRISE_PIECE_INFERIEURE;
	    #endif
		moveptr=&prises_piece_inferieure[0]-1;
		prises_piece_inferieure[nb_prises_piece_inferieure]=0;
	}
	else 
	{
		ASSERT(nb_autres_coups>0);
		analysis=EXTEND_ANALYSE_AUTRES_COUPS;
	    #if COLLECT_STATS==1
		if (check==0)
		origine_coups_analysis_extend=OR_EXTEND_ECHANGE_PIECE;
		else
		origine_coups_analysis_extend=OR_EXTEND_ANALYSE_COUVERTURES_ECHECS;
	    #endif
		moveptr=&autres_coups[0]-1;
	}
} // fin check!=0
else // check==0
{
	if (hint_move!=0) 
	{
		moveptr=&hint_moves[0]-1;
		phase_generation=PRISES;
		F_utilisation_liste=true;
		analysis=EXTEND_ANALYSE_HINT_MOVE;
	    #if COLLECT_STATS==1
		   origine_coups_analysis_extend=OR_EXTEND_ANALYSE_HINT_HMOVE;
		#endif
	}
	else 
	{
		phase_generation=PRISES;
		numptr=&xw[debut_blanc]; num=debut_blanc;
		while(num<=fin_blanc)
		{
			if (numptr->nature!=0 && numptr->psptr->mobility_prises!=0)
			{ break; }
			numptr++; num++;
		}
		// Si pas de prises sortir en crant liste de prises vides
		if (num>fin_blanc) 
		{
			analysis=EXTEND_ANALYSE_COUPS_FAVORABLES; // Quand mme
			F_utilisation_liste=true; 
			prises[0]=0; // Liste vide
			moveptr=&prises[0]-1;
			F_pas_de_prises=true;
			goto RETURN;
		}
		analysis=EXTEND_ANALYSE_COUPS_FAVORABLES;
	      #if COLLECT_STATS==1
		    origine_coups_analysis_extend=OR_EXTEND_ANALYSE_COUPS_FAVORABLES;
		#endif
		moveptr=numptr->psptr->moves2-1; // prises
		#if USE_CASES_ACTUALISATION==1
		F_piece_with_possibly_illegal_moves=bit(pieces_with_possible_illegal_moves,num);
		#endif
	}
}



RETURN:
return;
} // fin initialize




MOVE SEARCH::extend_get_move(void)
{
char cc;
//LEGALITY legality;
char arr;
char checking_nature;
char bilan_coup;
//char arr2;
short valeur_prise;
MOVE move;
char cat;
//bool F_move_takes_pawn;


NEXT_MOVE:
move=*(++moveptr);

if (move!=0)
{

PAS_UTILISATION_LISTE:
if (!F_utilisation_liste)
{

// Elimination du hint_move si dja jou
if (F_hint_move_has_been_played)
{
	if (SAME_MOVE(move,hint_move))
	{
		goto NEXT_MOVE;
	}
}

// Lgalit
#if USE_CASES_ACTUALISATION==1
if (F_piece_with_possibly_illegal_moves)
#endif
{
	cc=legal(num,move,num_roi,*lignemoins);
	if (cc!=1) // coup illgal
	{
		goto NEXT_MOVE;
	}
}

// Compteur de coups
nb_coups_liste++;

if (check==0 && phase_generation==PRISES 
	// analysis!=EXTEND_ANALYSE_HINT_MOVE car !f_utilisation_liste
	//&& move!=hint_move
	//&& F_allow_delta_pruning
	)
{


valeur_prise=MOVE_CAPTURE_VALUE(move);
if (valpos+valeur_prise+EXTEND_MARGIN<=sup_alpha_value)
{

	// Se justifie car mme si la prise est insuffisante
	// on pourrait pouvoir jouer  nouveau
	// Mais on joue le coup que  s'il donne chec
	// Le test de SEE sera fait aprs
	#if EXTEND_PRISES_INSUFFISANTES_CANDIDATES_ECHECS==1
	if (F_autorisation_echecs
		#if EXTEND_PRISES_INSUFFISANTES_CANDIDATES_ECHECS_ONLY_ON_PV==1
		&& node_type==NODE_PV
		#endif
		)
	{
		#if NO_EXTEND_QUEEN_CHECK_SACRIFICE==1
        if (MOVE_IS_QUEEN(move)) 
        {
	        #if USE_CASES_ACTUALISATION==1
                if (bit(cases_controlees_tour_adversaire,MOVE_ARR64(move)))
				{ goto PRISE_INSUFFISANTE2; }
			#else
				if (bilan_attaque_defense_avant_coup(move)==PERTE_MATERIELLE)
				{ goto PRISE_INSUFFISANTE2; }
			#endif
		}
		#endif
		prises_insuffisantes_candidates_echec[nb_prises_candidates_echec++]=move;
		goto NEXT_MOVE;
	}
	else // Elimination prise insuffisante
    #endif
	{
		PRISE_INSUFFISANTE2:	
		// Avec valeur_prise
		min_fail_low_value=sup(min_fail_low_value,valpos+valeur_prise+EXTEND_MARGIN); // fail-low - upperbound
		min_fail_low_value=inf(alpha,min_fail_low_value); 
		if (value<min_fail_low_value) value=min_fail_low_value;
		goto NEXT_MOVE;
		PRISE_INSUFFISANTE:
	    // Avec recalcul de la valeur prise
		min_fail_low_value=sup(min_fail_low_value,
			 valpos
			+MOVE_CAPTURE_VALUE(move)
			+EXTEND_MARGIN); // fail-low - upperbound
		min_fail_low_value=inf(alpha,min_fail_low_value); 
		if (value<min_fail_low_value) value=min_fail_low_value;
		goto NEXT_MOVE;
	}
}


// Traitement par catgorie
cat=MOVE_CATEGORY(move);
ASSERT(MOVE_CAPTURE(move)!='R');
// Mettre le coup en coup forant si la pice ou le pion de l'adversaire n'est pas protg
#if USE_CASES_ACTUALISATION==1
if (!bit(cases_controlees_adversaire,MOVE_ARR64(move)))
{
	if (MOVE_TAKES_PAWN(move))
	{
		cat=PRISE_FAVORABLE_PION;
	}
	else
	{
		cat=COUP_FORCANT;
	}
}
#endif
switch(cat)
{
case COUP_FORCANT :
	ASSERT(check==0);
	break;
case PROMOTION :
	ASSERT(check==0);
	//#if USE_CASES_ACTUALISATION==1
	//if (bit(cases_controlees_adversaire,MOVE_ARR64(move)))
	//{
	//	coups_declasses[nb_coups_declasses++]=move;
	//	goto NEXT_MOVE;
	//}
	//#endif
	bilan_coup=bilan_attaque_defense_avant_coup(MOVE_ARR64(move));
	if (bilan_coup==PERTE_MATERIELLE)
	{
		#if USE_EXTEND_NODE_PV==1
		if (node_type==NODE_PV)
	    {
		    coups_declasses[nb_coups_declasses++]=move;
			goto NEXT_MOVE;
		}
		#endif
		goto PRISE_INSUFFISANTE;
	}
	break;
case PRISE_FAVORABLE_PION :
	// Concerne les prises de pions non protgs
	// Les prises de pions protgs sotn valus
	// en prises de pice infrieure
	prises_pion[nb_prises_pion++]=move;
	goto NEXT_MOVE;
case ECHANGE_PIECE :
	ECHANGE_PIECE:
	echanges_piece[nb_echanges_piece++]=move;
	goto NEXT_MOVE;
case ECHANGE_PION :
	echanges_pion[nb_echanges_pion++]=move;
	goto NEXT_MOVE;
case PRISE_PIECE_INFERIEURE :
	prises_piece_inferieure[nb_prises_piece_inferieure++]=move;
	goto NEXT_MOVE;
case PRISE_PION_PAR_PIECE :
	prises_piece_inferieure[nb_prises_piece_inferieure++]=move;
	goto NEXT_MOVE;
 default :
	 ASSERT(false);
	break;
}

}
} // Fin gnration hors liste
UTILISATION_LISTE:
// Pas de else pour les coups sous listes
// qui sont valides
;
}
else // (move==0)
{
if (!F_utilisation_liste)
{
	switch(phase_generation)
	{
	case PRISES : 
		numptr++; num++;
		while(num<=fin_blanc)
		{
			if (numptr->nature!=0 && numptr->psptr->mobility_prises!=0)
			{ break; }
			numptr++; num++;
		}
		if (num>fin_blanc) 
		{ goto CHANGEMENT_ANALYSIS; }
		moveptr=numptr->psptr->moves2-1; 
		#if USE_CASES_ACTUALISATION==1
		F_piece_with_possibly_illegal_moves=bit(pieces_with_possible_illegal_moves,num);
		#endif
		goto NEXT_MOVE;
	    break;
	case AUTRES_COUPS :
		ASSERT(F_autorisation_echecs); // parce que sinon pas d'autres coups
		// Et si check!=0 on est en analyse liste
		numptr++; num++;
		while(num<=fin_blanc)
		{
			if (numptr->nature==0)
			{ numptr++; num++; continue; }
			// Voir si la pice est autorise  donner des checs
			// Si extension d'chec, elle l'est
			#if RECHERCHE_DECOUVERTES==1 && DECOUVERTES_ON_EXTEND==1
			if (F_decouverte)
			{
				if (decouverte_num==num)
				{
					F_nextlevel_try_anticipated_extend_cutoff=false;
					goto DECOUVERTE3;
				}
			}
			#endif
			if (check==0)
			{

				    #if EXTEND_ALLOW_ONE_QUEEN_CHECK_LEVEL_ANYWHERE_IN_QUIESCENCE==1
					if (xlevel>xextendlevel && !F_extension_echecs
						&& numptr->nature!='D')
					{
						// La dame seulement
						ASSERT(F_one_extend_queen_check_available);
						{numptr++; num++; continue;}
					}
					#endif

					switch (numptr->nature)
					{
					case 'P' : 
						#if NO_EXTEND_PAWN_CHECKS==1
						#if USE_EXTEND_NODE_PV==1
						//if (node_type!=NODE_PV)
						{
						#endif
						if (!F_extension_echecs)
						{
							numptr++; num++;
							continue;
						}
						#if USE_EXTEND_NODE_PV==1
						}
						#endif
						#endif
						if (abs(numptr->posx-s->roi_posx[other_wtm])>2)
						{
							numptr++; num++;
							continue;
						}
						break;
					case 'C' : 
						#if NO_EXTEND_KNIGHT_CHECKS==1
						#if USE_EXTEND_NODE_PV==1
						if (node_type!=NODE_PV)
						{
						#endif
						if (!F_extension_echecs)
						{
						numptr++; num++;
						continue;
						}
						#if USE_EXTEND_NODE_PV==1
						}
						#endif
						#endif
						//#if USE_CASES_ACTUALISATION==0
						// Plus efficace
						if (!(xcases_arrivee_cavalier[numptr->pos]&xcases_arrivee_cavalier[s->roi_pos[other_wtm]]))
						{
							numptr++; num++;
							continue;
						}
						//#endif
						// A CONSERVER 
						//#if USE_CASES_ACTUALISATION==1
						//if ((xcases_arrivee_cavalier[s->roi_pos[other_wtm]]&numptr->psptr->cases_actualisation)==0)
						//{
						//	numptr++; num++;
						//	continue;
						//}
						//#endif
						break;					
					case 'F' : 
						#if NO_EXTEND_BISHOP_CHECKS==1
						#if USE_EXTEND_NODE_PV==1
						if (node_type!=NODE_PV)
						{
						#endif
						if (!F_extension_echecs)
						{
						numptr++; num++;
						continue;
						}
						#if USE_EXTEND_NODE_PV==1
						}
						#endif
					    #endif
						#if USE_CASES_ACTUALISATION==0
						// Fou de la couleur du roi adverse ?
						if (M_2(X64(numptr->pos)+Y64(numptr->pos))
							!= M_2(X64(other_wtm_roi_pos)+Y64(other_wtm_roi_pos)))
						{
							numptr++; num++;
							continue;
						}
						#if USE_EXTEND_NODE_PV==1
						}
						#endif
						#endif
						#if USE_CASES_ACTUALISATION==1
						if ((s->cases_echec_fou[xwtm]&numptr->psptr->cases_actualisation)==0)
						{
							numptr++; num++;
							continue;
						}
						#endif
						break;
					case 'T' : 					
						#if NO_EXTEND_ROOK_CHECKS==1
						#if USE_EXTEND_NODE_PV==1
						if (node_type!=NODE_PV)
						{
						#endif
						if (!F_extension_echecs)
						{
						numptr++; num++;
						continue;
						}
						#if USE_EXTEND_NODE_PV==1
						}
						#endif
					    #endif						
						#if USE_CASES_ACTUALISATION==1
						if ((s->cases_echec_tour[xwtm]&numptr->psptr->cases_actualisation)==0)
						{
							numptr++; num++;
							continue;
						}
						#endif
						break;
					case 'D' : 					
						#if USE_CASES_ACTUALISATION==1
						if ((s->cases_echec_dame[xwtm]&numptr->psptr->cases_actualisation)==0)
						{
							numptr++; num++;
							continue;
						}
						#endif
						break;				
					case 'R' : 
						#if NO_EXTEND_KING_CHECKS==1
						#if USE_EXTEND_NODE_PV==1
						//if (node_type!=NODE_PV)
						{
						#endif
						if (!F_extension_echecs)
						{
						numptr++; num++;
						continue;
						}
						#if USE_EXTEND_NODE_PV==1
						}
						#endif
						#endif
						break;
					default :
						break;
					}
			}
			DECOUVERTE3:
			if (numptr->psptr->mobility_others==0)
			{ numptr++; num++; continue; }
			// Pice trouve 
			break;
		}
		if (num>fin_blanc) 
		{ goto CHANGEMENT_ANALYSIS; }
		moveptr=numptr->psptr->moves-1; 
		#if USE_CASES_ACTUALISATION==1
		F_piece_with_possibly_illegal_moves=bit(pieces_with_possible_illegal_moves,num);
		#endif
		goto NEXT_MOVE;
		break;
	}
}
else // move==0 && F_utilisation_liste
{
	CHANGEMENT_ANALYSIS:
	switch(analysis)
	{
		case EXTEND_ANALYSE_HINT_MOVE :
			      F_hint_move_has_been_played=true;
				  #if COLLECT_STATS==1
				  origine_coups_analysis_extend=OR_EXTEND_ANALYSE_COUPS_FAVORABLES;
				  #endif
				  analysis=EXTEND_ANALYSE_COUPS_FAVORABLES;
				  if (check!=0)
				  {
					  // La liste de coups a dja t cre
					  if (nb_prises==0) 
					  {
						  goto CHANGEMENT_ANALYSIS;
					  }
					  moveptr=&prises[0];
	  				  move=*moveptr;
					  prises[nb_prises]=0;  // marquage fin
					  F_utilisation_liste=true;
					  goto JOUER_COUP;
				  }
				  else
				  {
					  phase_generation=PRISES;
				 	  numptr=&xw[debut_blanc]; num=debut_blanc;
			  		  while(num<=fin_blanc)
					  {
						if (numptr->nature!=0 && numptr->psptr->mobility_prises!=0)
						{ break; }
						numptr++; num++;
					  }
					  // Si pas d'autres coups, sortir
					  if (num>fin_blanc) goto CHANGEMENT_ANALYSIS;
					  moveptr=numptr->psptr->moves2-1;
 	  				  #if USE_CASES_ACTUALISATION==1
					  F_piece_with_possibly_illegal_moves=bit(pieces_with_possible_illegal_moves,num);
					  #endif
					  F_utilisation_liste=false;
					  goto NEXT_MOVE; // pour contrle de lgalit
				  }
			break;
		case EXTEND_ANALYSE_COUPS_FAVORABLES : 
				  analysis=EXTEND_PRISES_FAVORABLES_PIONS;
  				  #if COLLECT_STATS==1
				  origine_coups_analysis_extend=OR_EXTEND_PRISES_FAVORABLES_PIONS;
				  #endif

				  if (nb_prises_pion==0) 
				  {
					goto CHANGEMENT_ANALYSIS;
				  }
				  moveptr=&prises_pion[0]-1;
  				  move=*moveptr;
				  prises_pion[nb_prises_pion]=0;  // marquage fin
				  F_utilisation_liste=true;
				  goto NEXT_MOVE;
				

		case EXTEND_PRISES_FAVORABLES_PIONS :
				  analysis=EXTEND_ANALYSE_ECHANGES_PIECE;
				  #if COLLECT_STATS==1
				  origine_coups_analysis_extend=OR_EXTEND_ECHANGE_PIECE;
				  #endif
				  if (nb_echanges_piece==0) 
				  {
					goto CHANGEMENT_ANALYSIS;
				  }
				  moveptr=&echanges_piece[0]-1;
				  move=*moveptr;
				  echanges_piece[nb_echanges_piece]=0;  // marquage fin
				  F_utilisation_liste=true;
				  goto NEXT_MOVE;

		case EXTEND_ANALYSE_ECHANGES_PIECE :
				  analysis=EXTEND_ANALYSE_ECHANGES_PION;
				  if (nb_echanges_pion>0)
				  {
					  moveptr=&echanges_pion[0];
  					  move=*moveptr;
					  echanges_pion[nb_echanges_pion]=0;  // marquage fin
					  F_utilisation_liste=true;
					  goto JOUER_COUP;
				  }
				  else 
				  {
					  goto CHANGEMENT_ANALYSIS;
				  }
				  break;
		
		
		case EXTEND_ANALYSE_ECHANGES_PION :

				  analysis=EXTEND_PRISES_PIECE_INFERIEURE;
				  if (nb_prises_piece_inferieure==0)
				  {
					goto CHANGEMENT_ANALYSIS;
				  }
  			      moveptr=&prises_piece_inferieure[0];
				  move=*moveptr;
				  prises_piece_inferieure[nb_prises_piece_inferieure]=0;  // marquage fin
				  F_utilisation_liste=true;
				  goto JOUER_COUP;
				  break;


		case EXTEND_PRISES_PIECE_INFERIEURE :
				  if (!F_autorisation_echecs 
					  && check==0
					  #if PRISES_CANDIDATES_ECHEC==1
					  && nb_prises_candidates_echec==0
					  #endif
					  && nb_coups_declasses==0
					  ) return 0;
				  
				  if (check!=0)
				  {
					  #if COLLECT_STATS==1
					  origine_coups_analysis_extend=OR_EXTEND_COUVERTURES_ECHECS;
					  #endif
					  // La liste de coups a dja t cre
					  analysis=EXTEND_ANALYSE_AUTRES_COUPS;
					  if (nb_autres_coups==0) 
					  {
						  goto CHANGEMENT_ANALYSIS;
					  }
					  moveptr=&autres_coups[0];
	  				  move=*moveptr;
					  autres_coups[nb_autres_coups]=0;  // marquage fin
					  F_utilisation_liste=true;
					  goto JOUER_COUP;
				  }
				  else // check==0
				  {
					  if (F_autorisation_echecs)
					  {
						  #if EXTEND_PRISES_INSUFFISANTES_CANDIDATES_ECHECS==1
						  if (nb_prises_candidates_echec>0)
						  {
							      // Coups dont-il faut vrifier qu'ils donnent 
								  #if COLLECT_STATS==1
								  origine_coups_analysis_extend=OR_EXTEND_ANALYSE_ECHECS;
								  #endif
								  // ou non chec
								  analysis=EXTEND_ANALYSE_PRISES_CANDIDATES_ECHEC;
								  moveptr=&prises_insuffisantes_candidates_echec[0];
	  							  move=*moveptr;
								  prises_insuffisantes_candidates_echec[nb_prises_candidates_echec]=0;  // marquage fin
								  F_utilisation_liste=true;
								  goto JOUER_COUP;
						  }
						  #endif
					  	  #if COLLECT_STATS==1
						  origine_coups_analysis_extend=OR_EXTEND_ANALYSE_ECHECS;
						  #endif
						  analysis=EXTEND_ANALYSE_AUTRES_COUPS;
						  phase_generation=AUTRES_COUPS;
				 		  numptr=&xw[debut_blanc]; num=debut_blanc;
			  			  while(num<=fin_blanc)
						  {
							if (numptr->nature==0)
							{numptr++; num++; continue;}

						    #if EXTEND_ALLOW_ONE_QUEEN_CHECK_LEVEL_ANYWHERE_IN_QUIESCENCE==1
							if (xlevel>xextendlevel && !F_extension_echecs
								&& numptr->nature!='D')
							{
								// La dame seulement
								ASSERT(F_one_extend_queen_check_available);
								{numptr++; num++; continue;}
							}
							#endif


							switch (numptr->nature)
							{
							case 'P' : 
								#if NO_EXTEND_PAWN_CHECKS==1
								#if USE_EXTEND_NODE_PV==1
								//if (node_type==NODE_PV)
								{
								#endif
								if (!F_extension_echecs)
								{
									numptr++; num++;
									continue;
								}
								#if USE_EXTEND_NODE_PV==1
								}
								#endif
								#endif
								if (abs(numptr->posx-s->roi_posx[other_wtm])>2)
								{
									numptr++; num++;
									continue;
								}
								break;
							case 'C' : 
								#if NO_EXTEND_KNIGHT_CHECKS==1
								#if USE_EXTEND_NODE_PV==1
								if (node_type==NODE_PV)
								{
								#endif
								if (!F_extension_echecs)
								{
								numptr++; num++;
								continue;
								}
								#if USE_EXTEND_NODE_PV==1
								}
								#endif
								#endif
								//#if USE_CASES_ACTUALISATION==0
								// Plus efficace
								if (!(xcases_arrivee_cavalier[numptr->pos]&xcases_arrivee_cavalier[s->roi_pos[other_wtm]]))
								{
									numptr++; num++;
									continue;
								}
								//#endif
								// A CONSERVER 
								//#if USE_CASES_ACTUALISATION==1
								//if ((xcases_arrivee_cavalier[s->roi_pos[other_wtm]]&numptr->psptr->cases_actualisation)==0)
								//{
								//	numptr++; num++;
								//	continue;
								//}
								//#endif
								break;					
							case 'F' : 
								#if NO_EXTEND_BISHOP_CHECKS==1
								#if USE_EXTEND_NODE_PV==1
								if (node_type==NODE_PV)
								{
								#endif
								if (!F_extension_echecs)
								{
								numptr++; num++;
								continue;
								}
								#if USE_EXTEND_NODE_PV==1
								}
								#endif
								#endif
								#if USE_CASES_ACTUALISATION==0
								// Fou de la couleur du roi adverse ?
								if (M_2(X64(numptr->pos)+Y64(numptr->pos))
									!= M_2(X64(other_wtm_roi_pos)+Y64(other_wtm_roi_pos)))
								{
									numptr++; num++;
									continue;
								}
								#endif
								#if USE_CASES_ACTUALISATION==1
								if ((s->cases_echec_fou[xwtm]&numptr->psptr->cases_actualisation)==0)
								{
									numptr++; num++;
									continue;
								}
								#endif
								break;
							case 'T' : 					
								#if NO_EXTEND_ROOK_CHECKS==1
								#if USE_EXTEND_NODE_PV==1
								if (node_type==NODE_PV)
								{
								#endif
								if (!F_extension_echecs)
								{
								numptr++; num++;
								continue;
								}
								#if USE_EXTEND_NODE_PV==1
								}
								#endif
								#endif						
								#if USE_CASES_ACTUALISATION==1
								if ((s->cases_echec_tour[xwtm]&numptr->psptr->cases_actualisation)==0)
								{
									numptr++; num++;
									continue;
								}
								#endif
								break;
							case 'D' : 					
								#if USE_CASES_ACTUALISATION==1
								if ((s->cases_echec_dame[xwtm]&numptr->psptr->cases_actualisation)==0)
								{
									numptr++; num++;
									continue;
								}
								#endif
								break;				
							case 'R' : 
								#if NO_EXTEND_KING_CHECKS==1
								#if USE_EXTEND_NODE_PV==1
								//if (node_type==NODE_PV)
								{
								#endif
								if (!F_extension_echecs)
								{
								numptr++; num++;
								continue;
								}
								#if USE_EXTEND_NODE_PV==1
								}
								#endif
								#endif
								break;
							default :
								break;
							}
							if (numptr->psptr->mobility_others==0)
							{ numptr++; num++; continue; }
							// Pice trouve 
							break;
						  }; // fin while
						  // Si pas d'autres coups, voir s'il reste des coups dclasss
						  // et sinon sortir
						  if (num>fin_blanc) 
						  {
							  if (nb_coups_declasses>0) goto CHANGEMENT_ANALYSIS;
							  else return 0;
						  }
						  moveptr=numptr->psptr->moves-1;
						  #if USE_CASES_ACTUALISATION==1
						  F_piece_with_possibly_illegal_moves=bit(pieces_with_possible_illegal_moves,num);
						  #endif
						  F_utilisation_liste=false;
						  goto NEXT_MOVE; // pour contrle de lgalit
					  }
					  else // Pas d'autorisation checs
					  {
						    // Passer aux coups dclasss
						    // en sautant les autres coups
							if (nb_coups_declasses==0) 
							{
								return 0;
							}
		  				    analysis=EXTEND_ANALYSE_COUPS_RESTANTS;
							moveptr=&coups_declasses[0];
  							move=*moveptr;
							coups_declasses[nb_coups_declasses]=0;  // marquage fin
							F_utilisation_liste=true;
						    goto PLAY_MOVE;
					  }
				  }
				  break;


	    #if EXTEND_PRISES_INSUFFISANTES_CANDIDATES_ECHECS==1
		case EXTEND_ANALYSE_PRISES_CANDIDATES_ECHEC :
				  if (!F_autorisation_echecs 
					  && check==0
					  && nb_coups_declasses==0
					  /*
					  #if USE_CASES_COUPS_FORCANTS==1
					  && !F_no_check_play_all_moves
					  #endif
					  */
					  ) return 0;
				  
					  ASSERT(check==0);
					  ASSERT(F_autorisation_echecs);
					  {
						  #if COLLECT_STATS==1
						  origine_coups_analysis_extend=OR_EXTEND_ANALYSE_ECHECS;
						  #endif
						  analysis=EXTEND_ANALYSE_AUTRES_COUPS;
						  phase_generation=AUTRES_COUPS;
				 		  numptr=&xw[debut_blanc]; num=debut_blanc;
			  			  while(num<=fin_blanc)
						  {
							if (numptr->nature==0)
							{numptr++; num++; continue;}
							#if RECHERCHE_DECOUVERTES==1 && DECOUVERTES_ON_EXTEND==1
							if (F_decouverte && num==decouverte_num)
							{ 
								F_nextlevel_try_anticipated_extend_cutoff=false;
								goto DECOUVERTE2; 
							}
							#endif

						    #if EXTEND_ALLOW_ONE_QUEEN_CHECK_LEVEL_ANYWHERE_IN_QUIESCENCE==1
							if (xlevel>xextendlevel && !F_mate_extension
								&& numptr->nature!='D')
							{
								// La dame seulement
								ASSERT(F_one_extend_queen_check_available);
								{numptr++; num++; continue;}
							}
							#endif

							switch (numptr->nature)
							{
							case 'P' : 
								#if NO_EXTEND_PAWN_CHECKS==1
								#if USE_EXTEND_NODE_PV==1
								//if (node_type!=NODE_PV)
								{
				                #endif
								if (!F_extension_echecs)
								{
									numptr++; num++;
									continue;
								}
								#if USE_EXTEND_NODE_PV==1
								}
								#endif
								#endif
								if (abs(numptr->posx-s->roi_posx[other_wtm])>2)
								{
									numptr++; num++;
									continue;
								}
							 break;
							case 'C' : 
								#if NO_EXTEND_KNIGHT_CHECKS==1
								#if USE_EXTEND_NODE_PV==1
								if (node_type!=NODE_PV)
								{
								#endif
								if (!F_extension_echecs)
								{
								numptr++; num++;
								continue;
								}
								#if USE_EXTEND_NODE_PV==1
								}
								#endif
								#endif
								//#if USE_CASES_ACTUALISATION==0
								// Plus efficace
								if (!(xcases_arrivee_cavalier[numptr->pos]&xcases_arrivee_cavalier[s->roi_pos[other_wtm]]))
								{
									numptr++; num++;
									continue;
								}
								//#endif
								// A CONSERVER 
								//#if USE_CASES_ACTUALISATION==1
								//if ((xcases_arrivee_cavalier[s->roi_pos[other_wtm]]&numptr->psptr->cases_actualisation)==0)
								//{
								//	numptr++; num++;
								//	continue;
								//}
								//#endif
								break;					
							case 'F' : 
								#if NO_EXTEND_BISHOP_CHECKS==1
								#if USE_EXTEND_NODE_PV==1
								if (node_type!=NODE_PV)
								{
				                #endif
								if (!F_extension_echecs)
								{
								numptr++; num++;
								continue;
								}
								#if USE_EXTEND_NODE_PV==1
								}
								#endif
								#endif
								#if USE_CASES_ACTUALISATION==0
								// Fou de la couleur du roi adverse ?
								if (M_2(X64(numptr->pos)+Y64(numptr->pos))
									!= M_2(X64(other_wtm_roi_pos)+Y64(other_wtm_roi_pos)))
								{
									numptr++; num++;
									continue;
								}
								#endif
								#if USE_CASES_ACTUALISATION==1
								if ((s->cases_echec_fou[xwtm]&numptr->psptr->cases_actualisation)==0)
								{
									numptr++; num++;
									continue;
								}
								#endif
								break;
							case 'T' : 					
								#if NO_EXTEND_ROOK_CHECKS==1
								#if USE_EXTEND_NODE_PV==1
								if (node_type!=NODE_PV)
								{
				                #endif
								if (!F_extension_echecs)
								{
									numptr++; num++;
									continue;
								}
								#if USE_EXTEND_NODE_PV==1
								}
								#endif
								#endif						
								#if USE_CASES_ACTUALISATION==1
								if ((s->cases_echec_tour[xwtm]&numptr->psptr->cases_actualisation)==0)
								{
									numptr++; num++;
									continue;
								}
								#endif
								break;
							case 'D' : 					
								#if USE_CASES_ACTUALISATION==1
								if ((s->cases_echec_dame[xwtm]&numptr->psptr->cases_actualisation)==0)
								{
									numptr++; num++;
									continue;
								}
								#endif
								break;				
							case 'R' : 
								#if NO_EXTEND_KING_CHECKS==1
								#if USE_EXTEND_NODE_PV==1
								//if (node_type!=NODE_PV)
								{
				                #endif
								if (!F_extension_echecs)
								{
									numptr++; num++;
									continue;
								}
								#if USE_EXTEND_NODE_PV==1
								}
								#endif
								#endif
								break;
							default :
								break;
							}
							DECOUVERTE2:
							if (numptr->psptr->mobility_others==0)
							{
								numptr++; num++;
								continue;
							}
							// Pice trouve 
							break;
						  }
						  // Si pas d'autres coups, voir s'il reste des coups dclasss
						  // et sinon sortir
						  if (num>fin_blanc) 
						  {
							  if (nb_coups_declasses>0) goto CHANGEMENT_ANALYSIS;
							  else return 0;
						  }
						  moveptr=numptr->psptr->moves-1;
						  #if USE_CASES_ACTUALISATION==1
						  F_piece_with_possibly_illegal_moves=bit(pieces_with_possible_illegal_moves,num);
						  #endif
						  F_utilisation_liste=false;
						  goto NEXT_MOVE; // pour contrle de lgalit
				  }
				  break;
		#endif

		case EXTEND_ANALYSE_AUTRES_COUPS :
				  analysis=EXTEND_ANALYSE_COUPS_RESTANTS;
				  #if USE_CASES_COUPS_FORCANTS==1
				  ASSERT(F_autorisation_echecs||check!=0
					  /*||F_no_check_play_all_moves*/
						 || node_type==NODE_PV);
				  #endif
				  #if COLLECT_STATS==1
				  if (check==0)
					  origine_coups_analysis_extend=OR_EXTEND_ANALYSE_COUPS_RESTANTS;
				  else
					  origine_coups_analysis_extend=OR_EXTEND_ANALYSE_COUVERTURES_ECHECS;
				  #endif
				  if (nb_coups_declasses==0) 
				  {
					return 0;
				  }
				  //ASSERT(check!=0 || node_type==NODE_PV);
				  moveptr=&coups_declasses[0];
  				  move=*moveptr;
				  coups_declasses[nb_coups_declasses]=0;  // marquage fin
				  F_utilisation_liste=true;
				  goto PLAY_MOVE;
		
		case EXTEND_ANALYSE_COUPS_RESTANTS  :
				  return 0;
	}
}
} // fin move==0
	

PLAY_MOVE:
switch (analysis)
{
	case EXTEND_ANALYSE_HINT_MOVE :

		return move;
		break;

	case EXTEND_ANALYSE_COUPS_FAVORABLES :

		#if _DEBUG==1
		cc=MOVE_CATEGORY(move);
		#endif
		//ASSERT(!(MOVE_TAKES_PAWN(move) && !MOVE_IS_FORCING(move)));

		// Prises favorables
		// Origine coups favorables
		#if COLLECT_STATS==1
		if ( check==0 )
		{ 
		if ( MOVE_CATEGORY(move)==COUP_FORCANT ) origine_coups_analysis_extend=OR_EXTEND_COUPS_FORCANTS;
		else if ( MOVE_CATEGORY(move)==PROMOTION ) origine_coups_analysis_extend=OR_EXTEND_PROMOTION;
		}
		#endif

		return move;
		break; 


	case EXTEND_PRISES_FAVORABLES_PIONS :
		return move;
		break;


	case EXTEND_ANALYSE_ECHANGES_PIECE :
		return move;
		break;

	case EXTEND_ANALYSE_ECHANGES_PION :
		return move;
		break;

	case EXTEND_PRISES_PIECE_INFERIEURE :

        // Elimination immdiate des prises de pices infrieures protges par
        // des pions (pour la dame en fait)
        // Les sacrifices de tours restent autoriss car les prises de
        // cavalier et de fou par des tours sont considrs 
		// comme des changes de pice

        // En dfinitive, tout ceci ne concerne que la dame
		// Et les prises de pions 
		#if ALLOW_EXTEND_ROOK_SACRIFICES==1
        ASSERT(MOVE_IS_QUEEN(move)||MOVE_TAKES_PAWN(move));
		#endif

        // Analyse du coup
        if (check==0)
		{
			// Un coup prenant  la dcouverte doit tre jou
			#if RECHERCHE_DECOUVERTES==1 && DECOUVERTES_ON_EXTEND==1
			if (F_decouverte)
			{
				if (MOVE_NUM_PIECE(move)==decouverte_num)
				return move;
			}
			#endif	
			#if USE_CASES_ACTUALISATION==0
            // Si USE_CASES_ACTUALISATION==1
            // le pawn_protected suffit
            if (is_pawn_protected(MOVE_ARR64(move),other_wtm))
            {
                #if USE_EXTEND_NODE_PV==1
                if (node_type==NODE_PV)
                {
                    coups_declasses[nb_coups_declasses++]=move;
                    goto NEXT_MOVE;
                }
                #endif
                valeur_prise=MOVE_CAPTURE_VALUE(move);
                min_fail_low_value=sup(min_fail_low_value,valpos+valeur_prise+EXTEND_MARGIN); // fail-low - upperbound
                min_fail_low_value=inf(alpha,min_fail_low_value);
                if (value<min_fail_low_value) value=min_fail_low_value;
                goto NEXT_MOVE;
            }
            #endif
            #if USE_CASES_ACTUALISATION==1
            if (MOVE_IS_QUEEN(move)) 
            {
                if (bit(cases_controlees_tour_adversaire,MOVE_ARR64(move)))
                {

					#if NO_EXTEND_QUEEN_TAKES_PROTECTED_PAWN==1
					if (MOVE_TAKES_PAWN(move))
					{ goto PRISE_INSUFFISANTE; }
					#endif

					#if USE_EXTEND_NODE_PV==1
					if (node_type==NODE_PV)
					{
						// Peut tre intressant
						// car les  dfenseurs peuvent tre clous
						coups_declasses[nb_coups_declasses++]=move;
		                goto NEXT_MOVE;
					}
					#endif
					#if EXTEND_PRISES_INSUFFISANTES_CANDIDATES_ECHECS_ONLY_ON_PV==0
					prises_insuffisantes_candidates_echec[nb_prises_candidates_echec++]=move;
					#endif
					goto NEXT_MOVE;
                }
            }
            // La case adverse est contrle par des pices adverses
            // sinon le coup aurait t un coup forant
            // mais il ne s'agit pas de pions ou de tours
            // Il peut s'agir d'une dame ou du roi adverse
            // Dans ce cas, un bilan coup est ncessaire
            #endif

			// Pawn protected ?
			ASSERT(wtm==xwtm);
			if (is_pawn_protected(MOVE_ARR64(move), 1-wtm))
			{
	  		    #if USE_EXTEND_NODE_PV==1
			    if (node_type==NODE_PV)
			    {
					 // Il faut jouer le coup
					 // car les  dfenseurs peuvent tre clous
				     coups_declasses[nb_coups_declasses++]=move;
		             goto NEXT_MOVE;
			    }
                #endif
			    #if PRISES_CANDIDATES_ECHEC_ONLY_ON_PV==0
				prises_insuffisantes_candidates_echec[nb_prises_candidates_echec++]=move;
				#endif
				goto NEXT_MOVE;
            }

            bilan_coup=bilan_attaque_defense_avant_coup(MOVE_ARR64(move));
            if (bilan_coup==PERTE_MATERIELLE)
            {
                #if USE_EXTEND_NODE_PV==1
                if (node_type==NODE_PV)
                {
                    coups_declasses[nb_coups_declasses++]=move;
                    goto NEXT_MOVE;
                }
                #endif
				#if EXTEND_PRISES_INSUFFISANTES_CANDIDATES_ECHECS_ONLY_ON_PV==0
				prises_insuffisantes_candidates_echec[nb_prises_candidates_echec++]=move;
				#endif
				goto NEXT_MOVE;
            }
        }
        return move;
        break;

    #if EXTEND_PRISES_INSUFFISANTES_CANDIDATES_ECHECS==1
	case EXTEND_ANALYSE_PRISES_CANDIDATES_ECHEC :
		goto PLAY_IF_GIVECHECK;
		break;
	#endif

	case EXTEND_ANALYSE_AUTRES_COUPS : // Echecs et couvertures d'checs

		if (check==0) // Echecs
		{
			PLAY_IF_GIVECHECK:
			ASSERT(check==0);


			// Vrification 
			// le coup donne-t-il chec ?
			// Les sous-promotions seulement si elles donnent chec
			checking_nature=MOVE_NATURE(move);
			if (MOVE_IS_PROMOTION(move))
			{ 
				checking_nature=MOVE_PROMOTION(move);
			}


			#if RECHERCHE_DECOUVERTES==1 && DECOUVERTES_ON_EXTEND==1
			//ASSERT(xboard[MOVE_DEP64(move)].num_piece=numptr->num_piece);
			do 
			{
			if (F_decouverte)
			{
				if (MOVE_NUM_PIECE(move)==decouverte_num)
				{	char nature;
					nature=xw[decouverte_num].nature;
					if (nature=='C') 
					{ 
					   if (xcases_arrivee_cavalier[MOVE_ARR64(move)]
					       & ( s->cases_pieces[other_wtm]
						       //| xcases_arrivee_roi[other_wtm]
							   )
								   )
					    goto DECOUVERTE; 
					}
					// Toujours vrai pour le cavalier
					if (abs(MOVE_INC64(move))
						!=abs(xinc64_from64_to64[MOVE_DEP64(move)][s->roi_pos[1-wtm]]))
					{ 
					    // Pour les pices autres, les obliger  attaquer une pice
						// Le test ne garantit pas
						// qu'on attaque uen pice adverse mais c'est mieux que rien.
					    cc=0;
						switch(nature)
						{
						case 'F' :
							 if (xcases_arrivee_fou[MOVE_ARR64(move)]
								 & ( s->cases_pieces[other_wtm]
						       //| xcases_arrivee_roi[other_wtm]
								 )
								 )
							 { cc=1; }
							 break;
						case 'T' : 
							 if (xcases_arrivee_tour[MOVE_ARR64(move)]
								 & ( s->cases_pieces[other_wtm]
						       //| xcases_arrivee_roi[other_wtm]
								 )
								 )
							 { cc=1; }
							 break;
						default : break;
						}
						if (cc==1)  { goto DECOUVERTE; }
					}
				}
			}
			break;
			} while(1);
			#endif
			


			// Limitation des checs de pices mineures
			// pourquoi un test NO_EXTEND_<PIECE>_CHECKS  ce niveau l ?
			// On pourrait venir des prises sur checs infrieures
			// Le tests NO_EXTEND sont ici en pratique inutiles
			// car un coup n'arrive ici en gnral qu'avec le droit de donner chec
			arr=MOVE_ARR64(move);
			switch(checking_nature)
			{
				case 'P' : 
    				#if NO_EXTEND_PAWN_CHECKS==1
	                #if USE_EXTEND_NODE_PV==1
					//if (node_type!=NODE_PV)
					{
					#endif
					if (!F_extension_echecs && phase_generation!=PRISES) 
					{
					if (MOVE_IS_CAPTURE(move))
					{
						goto PRISE_INSUFFISANTE;
					}
					goto NEXT_MOVE;
					}
	                #if USE_EXTEND_NODE_PV==1
					}
					#endif
					#endif
					if (!givecheck_pion(arr,wtm)) 
					{ 
					if (MOVE_IS_CAPTURE(move))
					{
						goto PRISE_INSUFFISANTE;
					}
					goto NEXT_MOVE;
				   	}	
				   	break;
				case 'C' :
					#if NO_EXTEND_KNIGHT_CHECKS==1
	                #if USE_EXTEND_NODE_PV==1
					if (node_type!=NODE_PV)
					{
					#endif
	                if (!F_extension_echecs && phase_generation!=PRISES)
					{ 
					if (MOVE_IS_CAPTURE(move))
					{
						goto PRISE_INSUFFISANTE;
					}
					goto NEXT_MOVE;
				   	}	
	                #if USE_EXTEND_NODE_PV==1
					}
					#endif
					#endif
					if (!SEARCH::givecheck_cavalier(arr))
					{ 
						if (MOVE_IS_CAPTURE(move))
						{
							goto PRISE_INSUFFISANTE;					
						}
						goto NEXT_MOVE;
				   	}	
			        break;
				case 'F' : 
					#if NO_EXTEND_BISHOP_CHECKS==1
	                #if USE_EXTEND_NODE_PV==1
					if (node_type!=NODE_PV)
					{
					#endif
	                if (!F_extension_echecs && phase_generation!=PRISES)
					{ 
						if (MOVE_IS_CAPTURE(move))
						{
							goto PRISE_INSUFFISANTE;
						}
						goto NEXT_MOVE;
				   	}	
	                #if USE_EXTEND_NODE_PV==1
					}
					#endif
					#endif
					if (!givecheck64(s->cases_echec_fou[wtm],arr) ) 
					{ 
						if (MOVE_IS_CAPTURE(move))
						{
							goto PRISE_INSUFFISANTE;
						}
						goto NEXT_MOVE;
				   	}	
					break;
				case 'T' : 
					#if NO_EXTEND_ROOK_CHECKS==1
	                #if USE_EXTEND_NODE_PV==1
					if (node_type!=NODE_PV)
					{
					#endif
                    if (!F_extension_echecs && phase_generation!=PRISES)
					{ 
						if (MOVE_IS_CAPTURE(move))
						{
							goto PRISE_INSUFFISANTE;
						}
						goto NEXT_MOVE;
				   	}	
	                #if USE_EXTEND_NODE_PV==1
					}
					#endif
					#endif
					if (!givecheck64(s->cases_echec_tour[wtm],arr) ) 
					{ 
						if (MOVE_IS_CAPTURE(move))
						{
							goto PRISE_INSUFFISANTE;
						}
						goto NEXT_MOVE;
				   	}	
				    break;
			    case 'D' : 
 				    if (!givecheck64(s->cases_echec_dame[wtm],arr) ) 
					{ 
						if (MOVE_IS_CAPTURE(move))
						{
							goto PRISE_INSUFFISANTE;
						}
						goto NEXT_MOVE;
				   	}	
					#if NO_EXTEND_QUEEN_CHECK_SACRIFICE==1
			        #if USE_CASES_ACTUALISATION==1
				        if (bit(cases_controlees_tour_adversaire,MOVE_ARR64(move)))
						{ 
							if (MOVE_IS_CAPTURE(move))
							{ 
								#if NO_EXTEND_QUEEN_TAKES_PROTECTED_PAWN==1
								if (MOVE_TAKES_PAWN(move))
								{ goto PRISE_INSUFFISANTE; }
								#endif
								#if USE_EXTEND_NODE_PV==1
								// Ne jouer la prise que si NODE_PV
								if (node_type!=NODE_PV) 
								{ goto PRISE_INSUFFISANTE; }		
								#else
								{ goto PRISE_INSUFFISANTE; }
								#endif
							}
							else
							{ goto NEXT_MOVE; }
						}
					#else
						if (bilan_attaque_defense_avant_coup(move)==PERTE_MATERIELLE)
						{ 
							if (MOVE_IS_CAPTURE(move))
							{ 
								#if NO_EXTEND_QUEEN_TAKES_PROTECTED_PAWN==1
								if (MOVE_TAKES_PAWN(move))
								{ goto PRISE_INSUFFISANTE; }
								#endif
								#if USE_EXTEND_NODE_PV==1
								// Ne jouer la prise que si NODE_PV
								if (node_type!=NODE_PV) 
								{ goto PRISE_INSUFFISANTE; }		
								#else
								{ goto PRISE_INSUFFISANTE; }
								#endif
							}
							else
								{ goto NEXT_MOVE; }
						}
					#endif
					#endif
					break;
				case 'R' :  		
					#if NO_EXTEND_KING_CHECKS==1
	                #if USE_EXTEND_NODE_PV==1
					//if (node_type!=NODE_PV)
					{
					#endif
	                if (!F_extension_echecs && phase_generation!=PRISES) goto NEXT_MOVE;
	                #if USE_EXTEND_NODE_PV==1
					}
					#endif
					#endif
					if (!SEARCH::givecheck_roi(move) ) 
					{ 
					if (MOVE_IS_CAPTURE(move))
					{
						goto PRISE_INSUFFISANTE;
					}
					goto NEXT_MOVE;
				   	}	
				break;
			      default : break;
			}
				
			
			// Bilan attaque-dfense
			//cc=MOVE_IS_TACTICAL(move);
			//cc=MOVE_IS_CAPTURE(move);
			ASSERT(!MOVE_IS_TACTICAL(move) && check==0
				|| (MOVE_IS_PROMOTION(move) && MOVE_PROMOTION(move)!='D')
				|| analysis==EXTEND_ANALYSE_PRISES_CANDIDATES_ECHEC
				|| num==decouverte_num
				);

		    // Les deux catgories ont dja t tudies
			#if _DEBUG
			cat=MOVE_CATEGORY(move);
			#endif
			ASSERT((cat!=COUP_FORCANT && cat!=ECHANGE_PIECE)
				   ||valpos+MOVE_CAPTURE_VALUE(move)+EXTEND_MARGIN<=sup_alpha_value
				   );
			
			// Bilan
			// On donne chec, sinon on est pas arriv l
			// Le bilan est inutile car il a dja t calcul
			// Si la prise est favorable, le coup a t jou
			// Si dfavorable et NODE_PV, coup dclass
			// Si dfavorable et pas NODE_PV, veut-on jouer le coup 
			// au motif qu'il donne chec ?
			// Rponse : oui, mais dans ce cas le bilan n'est pas ncessaire
			// D'o le ASSERT suivant
			ASSERT( !MOVE_IS_CAPTURE(move) 
				  || (MOVE_IS_CAPTURE(move) && 
				       (bilan_attaque_defense_avant_coup(move)==PERTE_MATERIELLE
					    || valpos+MOVE_CAPTURE_VALUE(move)+EXTEND_MARGIN<=sup_alpha_value)
					   )
				  );
			ASSERT(!MOVE_IS_CAPTURE(move) 
				|| analysis==EXTEND_ANALYSE_PRISES_CANDIDATES_ECHEC
				);


			
			// En node PV, on analyse tous les  checs
			// mme avec perte matrielle
			// Les sacrifices de dame, quant  eux
			// sont exclus ci-dessus
			#if USE_EXTEND_NODE_PV==1
			if (node_type!=NODE_PV)
			{
			#endif
			// En effet, si le coup est une prise
			// il est valu en prise
			// et s'il n'est pas valu en prise
			// c'est qu'il perd du matriel auquel cas il a t 
			// limin
			//if (cat!=COUP_FORCANT && cat!=ECHANGE_PIECE)
			// Les prises doivent tre analyses si elles donnent checs
			// et dans ce cas elles sont en perte matrielle
			// Seuls les autres coups ont besoin du bilan
			if (!MOVE_IS_CAPTURE(move))
			{
			if (bilan_attaque_defense_avant_coup(move)==PERTE_MATERIELLE)
			{ 
			// On saute ce test pour les DECOUVERTES
			// Ce contrle est donc inutile.
			//#if RECHERCHE_DECOUVERTES==1 && DECOUVERTES_ON_EXTEND==1
			// if (!(F_decouverte && num==decouverte_num))
			//#endif
			{
				ASSERT(!MOVE_IS_CAPTURE(move));
				goto NEXT_MOVE;
		   	}
			}
			}
            #if USE_EXTEND_NODE_PV==1
			}
			#endif


			#if RECHERCHE_DECOUVERTES==1 && DECOUVERTES_ON_EXTEND==1
			DECOUVERTE:
			#endif


			// Le coup donne chec et il faut actualiser au niveau suprieur
			F_nextlevel_try_anticipated_extend_cutoff=false;
			#if EXTEND_ALLOW_ONE_QUEEN_CHECK_LEVEL_ANYWHERE_IN_QUIESCENCE==1
	        F_one_extend_queen_check_available=false;
			#endif
			ASSERT(F_extension_echecs||MOVE_IS_QUEEN(move)
				  || xlevel==xextendlevel);


			#if COLLECT_STATS==1
		    if (check==0)
				origine_coups_analysis_extend=OR_EXTEND_ECHEC;
			else
				origine_coups_analysis_extend=OR_EXTEND_ANALYSE_COUVERTURES_ECHECS;
			#endif

		}
		else // check!=0 || node_type==NODE_PV  xextendlevel)
		{			
			#if USE_CASES_ACTUALISATION==1
			if (bilan_attaque_defense_avant_coup_simplifie(move)==MATERIAL_LOSS) 
			#endif
			#if USE_CASES_ACTUALISATION==0
			if (bilan_attaque_defense_avant_coup(move)==PERTE_MATERIELLE) 
			#endif
			{
				coups_declasses[nb_coups_declasses++]=move;
				goto NEXT_MOVE;
			}
		} // fin check

		break; // Fin AUTRES_COUPS

	case EXTEND_ANALYSE_COUPS_RESTANTS :
		// Coups dclasss
		return move;
		break;
	default : 
		ASSERT(false);
		break;

} // fin switch

JOUER_COUP:
return move;
} // fin get_move