#include "stdafx.h"
#include "Cchess_1.h"
#include "Cchess_2.h"
//#include "Cchess_3.h"
#include "Cchess_4.h"
#include "Cchess_5.h"
#include "Cchess_6.h"
 

#if DEBUG==2
char bilan_attaque_defense2(char pos);
char bilan_attaque_defense3(char pos);
#endif



bool SEARCH::time_and_keyboard_control(void)
{
char cc;
short int si1;
// Tests priodiques

if (M_16384(xcompteur)==0 )
{

// Test du clavier - fonction permanent brain
CONSOLE_MODE;
if (xpb_explo && !xpb_guessed)
{
#if COMPILER==2
cc=_kbhit();
#endif
#if COMPILER==1
cc=kbhit();
#endif
if (cc!=0)
{
if ( xenable_sound ) printf("\a");
cc=getch();
if (cc=='S' || cc=='s') 
{

// Demande du coup jou
cc=askmove_search();

 
// Echec anticipation
if (cc==0)
{
xpb_fail=true; // quitter la rflexion
xreturn=true; value=valpos;
return false;
}


// Coup devin
if (cc==1) 
{
xpb_guessed=true;
printf("   - Coup enregistr -\n");
// Affichage suite retenue au niveau 0
if (xcan_return)
{
printf("****************************\n");
printf("Evaluation - %d : %d \n",xlv1_depth>>FD,xlastvalue1);
affiche_ligne(&xkeep[1],0);

} // fin xcan_return
} // fin coup devin


// Interruption rflexion
if (cc==2) 
{
xreturn=true; value=valpos;
xpb_fail=true; // On ne peut pas savoir si la profondeur atteinte
            // est suffisante
//goto QUIT;
return false;
}

} // fin if 3
} // fin if 2
} // fin if 1
END_MODE;



// Test du clavier en mode UCI
UCI_MODE;
// uci_interface::call_mode=1; // search ou extend
uci_interface::get_and_process_uci_buffer(1);
if ( xreturn ) { value=valpos; return false; }
// Display de l'activit en mode UCI
if ( M_524288(xcompteur)==0 )
{
xtime=get_time_in_seconds();
strcpy(uci_interface::info_buffer, " nps ");
strcat(uci_interface::info_buffer, _ltoa((long) ((unsigned __int64) ((xcompteur-xcompteur_depart)/(unsigned __int64) (xtime-xtdebut_original+1))),xbuffer2,10));
strcat(uci_interface::info_buffer, " nodes ");
strcat(uci_interface::info_buffer, _ltoa((long) ((unsigned __int64)(xcompteur-xcompteur_depart)),xbuffer2,10)); 
#if USE_HASH_TABLE==1
// Le pourcentage de remplissage des hash_tables est donn par la 
// formule suivante :
// soit t1 et t2 les taux de remplissage
// soit p1 et p2 les probabilits de hits en supposant l'existence d'un hit
// Lorsqu'on effectue une entre, on introduit
// 1 entre et on dplace 1*t1 entre en deuxime partie
// L'univers des possibles est donc
// avec probabilit (1-t1) : une entre en premire partie
// avec probabilit t1 : une entre en premire partie 
// et une entre en deuxime partie
// L'esprance est donc : 1 entre en premire partie et t1 entre en seconde
// Ramen  une entre cela donne 
// p1 = 1 / (1+t1 ) et p2 = t1 / ( 1+t1)
// Si la premire table est remplie  100%, p1=p2=50%
// Si elle est vide p1=100%
// Si elle est  moiti pleine p1=2/3
// soit n1 et n2 le nombre de hits respectifs en premire et seconde partie
// On peut crire : 
// t1=(1/p1)-1 
// t1 = n2/n1 => CQFD !!!
strcat(uci_interface::info_buffer, " hashfull ");
memset(xbuffer2,0,sizeof(xbuffer2));
//strcat(uci_interface::info_buffer, _itoa(80,xbuffer2,10));
_ltoa((int)(
	(min(xhash_second_part_hits_this_attempt
		, xhash_first_part_hits_this_attempt)
	*1000L) // *10 pour UCI!
	/max(xhash_first_part_hits_this_attempt,xhash_second_part_hits_this_attempt+1)),
	   xbuffer2,10);
//strcat(uci_interface::info_buffer, _itoa(80,xbuffer2,10));
strcat(uci_interface::info_buffer, xbuffer2);
//xu=xnb_put_hash_collisions*1000/(xnb_put_hash+1);
#endif
display_info(uci_interface::info_buffer);
//sprintf(uci_interface::info_buffer, "xbornetemps %d", xbornetemps);
//display_info(uci_interface::info_buffer);
//sprintf(uci_interface::info_buffer, "xlevel %d", xlevel);
//display_info(uci_interface::info_buffer);
} // fin test display activit
END_MODE;


// Gestion du premier coup - xcps non calcul
// Premier coup - xcps non determin
// dtermin xcps sur les 65000 premier coups
if (!xFcalcul_first_xcps )
{
if (!xpb_explo || xpb_guessed)
{
if (xF_timer_on)
{
if (M_65536(xcompteur)==0)
{
xtime=get_time_in_seconds();
xcps_new=(long) (((double)(xcompteur-xcompteur_depart+385))/(xtime-xtdebut_original));
// +100% car premier coup hors bibiliothque
xbornetemps=xcompteur_depart+
             (unsigned __int64)(((double) xcps_new/(double) xcps) * (xbornetemps-xcompteur_depart) * 2);
xbornetemps_max=xcompteur_depart+
				(unsigned __int64)(((double) xcps_new/ (double) xcps) * (xbornetemps_max-xcompteur_depart));
if (xbornetemps>xbornetemps_max) xbornetemps=xbornetemps_max;
xbornetemps_depart=xbornetemps;
xFcalcul_first_xcps=true;
}
}
}
}


// Recherche infinie
if (xinfinite_search) return true; // contrle OK aprs gestion interruptions

// Urgence
if (xurgence_on) 
{
	ASSERT(!xcan_return);
	#if LOG_CRITICAL_ERRORS_TO_FILE==1
	if (xcan_return)
	{ log_to_file("xurgence_on and xcan_return"); }
	#endif
	// En cas d'urgence, on ne contrle pas le temps !
	return true;
}

// Contrle temps de rflexion
// Si xurgence_on, il faut revenir au moins un fois
if ((!xpb_explo || xpb_guessed) && !xurgence_on)
{
if (xFcalcul_first_xcps)
{

// Appel get_time_in_secondes
if (xmovestogo==1)
{
// Note : xtime peut avoir t calcul prcdemment
// pour le display de l'activit (nps)
if (M_65536(xcompteur)==0 || xtime>xtdebut+xusable_time_max)
{
xtime=get_time_in_seconds();
#if _DEBUG==1
sprintf(xbuffer,"\nxtime %f - max : %f", xtime, xtdebut+xusable_time_max);
display_info_force(xbuffer);
#endif
// Jump test sur xbornetemps
if (xtime>xusable_time_max+xtdebut) goto DEPASSEMENT_TEMPS;
}
}

// Note : xtime peut avoir t calcul prcdemment
// pour le display de l'activit (nps)
if (xcompteur>xbornetemps || xcompteur>=xbornetemps_max || xtime>xtdebut+xusable_time_max)
{
DEPASSEMENT_TEMPS:


// Procdure de retour d'urgence !
// Seulement si !xcan_return (sinon on peut revenir !!)
if (!xcan_return)
{
	xreturn=true; value=valpos;
	xurgence_restart=true;
	//goto QUIT;
	return false;
}

// Retour avec xcan_return=true sans 
if (xcompteur>xbornetemps_max || xtime>xtdebut+xusable_time_max)
{
    // On peut treen dessous de xbornetemps
	// quand xtime>xtdebut+xusable_time_max
	// avec xcompteur<xbornetemps
	#if LOG_CRITICAL_ERRORS_TO_FILE==1
		if (xcompteur<xbornetemps 
			&& xtime>xtdebut+xusable_time_max)
		{ log_to_file("Erreur J_97433 - xtime dpass avec xcompteur < borne");
		  sprintf(xbuffer," %d ",xbornetemps);
		  log_to_file(xbuffer);
		  sprintf(xbuffer," %d ",xbornetemps_max);
		  log_to_file(xbuffer);
		  sprintf(xbuffer," %d ",xtime-(xtdebut+xusable_time_max));
		  log_to_file(xbuffer);
		}
		if (xcompteur>xbornetemps 
			&& xtime>xtdebut+xusable_time_max)
		{ 
		  log_to_file("Erreur J_97434 - xtime dpass avec xcompteur > borne");
		  sprintf(xbuffer," %d ",xbornetemps);
		  log_to_file(xbuffer);
		  sprintf(xbuffer," %d ",xbornetemps_max);
		  log_to_file(xbuffer);
		  sprintf(xbuffer," %d ",xtime-(xtdebut+xusable_time_max));
		  log_to_file(xbuffer);
		}
	#endif
	xreturn=true; value=valpos;
	return false;
}

// Extension de temps
do
{
// Pas d'extension de temps si xmovestogo<=2
if (xmovestogo>0)
{
if (xmovestogo<=2)
{
xreturn=true; value=valpos;
//goto QUIT;
return false;
}
}

// Une seule extension possible	
if (xtime_extension)
{
xreturn=true; value=valpos;
//goto QUIT;
return false;
}

// Guess
if (xpb_explo && xpb_guessed)
{
xreturn=true; value=valpos;
//goto QUIT;
return false;
}


// Extension si la valeur root est MAT
if (   xlv1_value<xlv1_alpha 
	  && xlastvalue1<-MATE_VALUE_THRESHOLD 
   )
{
{
xtime_extension=true;
#if COLLECT_STATS==1
xnum_time_extension++;
#endif
xbornetemps+=(xbornetemps-xcompteur_depart);
if (xbornetemps>xbornetemps_max) xbornetemps=xbornetemps_max;
break;
}
}


// Extension si la profondeur atteinte est dangereusement 
// insuffisante
if (xlv1_depth>>FD<=(xlastdepth[wtm]>>FD)-1 && xlv1_depth>>FD<=4)
{
if (!xlv1_reprise_immediate)
// car si reprise immdiate on ne souhait pas faire d'extension
{
xtime_extension=true;
#if COLLECT_STATS==1
xnum_time_extension++;
#endif
xbornetemps+=(xbornetemps-xcompteur_depart);
if (xbornetemps>xbornetemps_max) xbornetemps=xbornetemps_max;
break;
}
}


// Extension si xretour1_num_moves<=1
// L'ide est que si on n'a un seul retour au level 1
// le temps de recherche investi est perdu
if (xretour1_num_moves<=1) 
{
if (!xlv1_reprise_immediate)
{
xtime_extension=true;
#if COLLECT_STATS==1
xnum_time_extension++;
#endif
xbornetemps+=(xbornetemps-xcompteur_depart);
if (xbornetemps>xbornetemps_max) xbornetemps=xbornetemps_max;
break;
}
}

// Note :
// En exploration sur le temps de l'adversaire
// !xpb_guessed tant qu'auncun coup n'a t entr
// et goto QUIT si mal devin ou xpb_guessed=1 si devin

// Extension ?
if (!xpb_explo || (xpb_explo && xpb_guessed))
{
// Si dgradation de la position suite  l'accroissement de profondeur
// alors extension
si1=PLAYER(player,xlv1_value*xlv1_player-xlastvalue1);
if (si1<-50) 
{
if (!xlv1_reprise_immediate) 
{
xtime_extension=true;
#if COLLECT_STATS==1
xnum_time_extension2++;
#endif
xbornetemps+=(xbornetemps-xcompteur_depart);
if (xbornetemps>xbornetemps_max) xbornetemps=xbornetemps_max;
break;
}
if (xlv1_reprise_immediate && si1<-200)
{
xtime_extension=true;
xbornetemps+=(xbornetemps-xcompteur_depart);
if (xbornetemps>xbornetemps_max) xbornetemps=xbornetemps_max;
#if COLLECT_STATS==1
xnum_time_extension2++;
#endif
break;
}
} // si<-50
} // fin condition 2

break;
} while(1);
}
}
} // fin contrle du temps de rflexion


} // Tests priodiques

return true;
} // fin time_control



bool SEARCH::is_pawn_protected(char pos, char color01)
{
#if USE_CASES_ACTUALISATION==1 && USE_CASES_CONTROLEES_JOUEUR==1 
if (F_actualisation_done)
{
if (color01==1-xwtm)
{
 ASSERT(bit(cases_controlees_pion_adversaire,pos)==
	 is_pawn_protected2(pos, color01));
 return bit(cases_controlees_pion_adversaire,pos);
}
else
{
 ASSERT(bit(cases_controle_exclusif_pion,pos)==
			is_pawn_protected2(pos, color01));
 return bit(cases_controle_exclusif_pion,pos);
}
}
else return SEARCH::is_pawn_protected2(pos, color01);
#else
return SEARCH::is_pawn_protected2(pos, color01);
#endif
}


bool SEARCH::is_pawn_protected2(char pos, char color01)
{
	char color;
	char arr2;

	color=TO_COLOR(color01);
	arr2=pos+COLOR(color,7);
	if (WITHIN_BOARD(arr2))
	{
		ASSERT(arr2>=0 && arr2<=63);
		if (bit(s->cases_pions[color01],arr2)) 
			return true;
	}
	arr2=pos-COLOR(color,9);
	if (WITHIN_BOARD(arr2))
	{
		ASSERT(arr2>=0 && arr2<=63);
		if (bit(s->cases_pions[color01],arr2)) 
			return true;
	}
	return false;
}



char SEARCH::bilan_attaque_defense(char position_depart)
{
// Cette nouvelle version de attaque dfense utilise directement
// l'chiquier
char dir;
char color;
// [ 8 directions de cavaliers et 8 directions  7 cases potentielles ] 
// on commence par la direction de cavalier qui sera frquemment renseigne
// On commence par les 8 directions de cavaliers
CASE *cptr;
CASE *cptr_depart;
short valeur_attaquant, valeur_defenseur;
short bilan_joueur;
//short bilan_joueur_initial;
// Les best sont maintenus pour pouvoir 
// conserver le meilleur rsultat pour chaque
// camp dans la suite d'valuation des prises
// short minorant_bilan_adversaire, majorant_bilan_joueur;
char attaquant_trouve, defenseur_trouve;
BILAN_AD  *bptr, *bptr_mem;
char nature2, color2;
char inc;
bool F_dir_cavalier;
char color01;
bool F_existe_possible_cavalier_attaquant;
bool F_existe_possible_cavalier_defenseur;
char dirmax;
BILAN_AD bilan_ad[16];


// Initialisations 
bptr_mem=NULL;
cptr_depart=&xboard[position_depart];
color=cptr_depart->color;
color01=TO_COLOR01(color);

#if COLLECT_STATS==1
xnb_bilan_pd++;
#endif



// Existence de cavaliers amis et adverses
if (xcases_arrivee_cavalier[position_depart]&(s->cases_pieces[1-color01]))
{
	F_existe_possible_cavalier_attaquant=true;
}
else
{
	F_existe_possible_cavalier_attaquant=false;
}
if (xcases_arrivee_cavalier[position_depart]&(s->cases_pieces[color01]))
{
	F_existe_possible_cavalier_defenseur=true;
}
else
{
	F_existe_possible_cavalier_defenseur=false;
}


// Initialisation des directions
if (F_existe_possible_cavalier_defenseur||F_existe_possible_cavalier_attaquant)
{
	dirmax=15;
}
else
{
	dirmax=7;
}

memcpy((char*)&bilan_ad[0],(char*)&xbilan_ad[position_depart][0],(dirmax+1)*sizeof(BILAN_AD));

/* REMPLACE LE BLOC SUIVANT
bptr=&bilan_ad[0];
for (dir=0; dir<=dirmax; dir++, bptr++ )
{
if (dir<8) bptr->F_dir_cavalier=false;
else       bptr->F_dir_cavalier=true;
bptr->inc=xinc64[dir];
bptr->pos=position_depart+bptr->inc; 
bptr->nb_inc=1;
bptr->nbinc_max=xnbinc_par_direction[position_depart][dir];
bptr->direction_interrompue=0;
// Contrle inutile - fait ensuite
// if (bptr->nbinc_max==0) bptr->direction_interrompue=1;
// else bptr->direction_interrompue=0;
}
*/

// Valeur dfenseur et bilan initial
valeur_defenseur=cptr_depart->piece_value;
bilan_joueur=0;


// Rem: le bilan_joueur est vu du point 
// de vue du camp pour lequel on teste
// => si le bilan_joueur est < 0, la pice n'est pas dfendue

// Initialisation bilan initiaux
// Le meilleur bilan d'attaque est initialis
// au bilan d'attaque initial
// il ne peut tre qu'amlior
//bilan_joueur=bilan_joueur_initial;
//minorant_bilan_adversaire=bilan_joueur_initial;
// Le best bilan de dfense est initialis  une mauvaise
// valeur initiale qui provoquera la mise  jour 
// au premier choix du dfenseur
// Si le dfenseur n'a pas de choix  oprer 
// c'est  dire si le camp attaquant n'a pas de prise
// on rajuste majorant_bilan_joueur au bilan initial
//majorant_bilan_joueur=bilan_joueur_initial-valeur_defenseur;

#if DEBUG==1
if (color==0)
log_error("\nErr J_911");
#endif

// Recherche attaque-dfense
do 
{

// Recherche attaquant
attaquant_trouve=0;
valeur_attaquant=7500; // Valeur roi = 5000

// Une direction de cavalier + 8 directions
if (F_existe_possible_cavalier_attaquant)
{
	dirmax=15;
}
else
{
	dirmax=7;
}
bptr=&bilan_ad[0];
for (dir=0; dir<=dirmax; dir++, bptr++ )
{
if ( bptr->direction_interrompue==1) continue;
F_dir_cavalier=bptr->F_dir_cavalier;
for(;;bptr->pos+=bptr->inc,bptr->nb_inc++)
{
if (bptr->nb_inc>bptr->nbinc_max) 
{ bptr->direction_interrompue=1; break; }
cptr=&xboard[bptr->pos];
nature2=cptr->nature;
if ( nature2==0 )
{ 
	if (F_dir_cavalier)
	{ bptr->direction_interrompue=1; break; }
	else continue; // continuer dans la direction
}

color2=cptr->color;
// Dfenseur potentiel
// On retarde dans ce cas l'analyse de direction interrompue
// au moment o on cherchera des dfenseurs
if ( color2==color ) break; // dfenseur et non attaquant

// Attaquant adverse
if ( F_dir_cavalier )
{
	if ( nature2!='C' )
	{ bptr->direction_interrompue=1; break; }          
}


switch(nature2)
{
case 'C' :
	if (F_dir_cavalier)
	{
		attaquant_trouve=1;
		// bptr->direction_interrompue=1; NON la pice n'est pas forcment consomme 
		// pas break puisque trouv
	}
	else
	{	bptr->direction_interrompue=1; goto NEXT_LOOP_1; } 
	break;
case 'P' :
	if (bptr->nb_inc>1) 
	{ bptr->direction_interrompue=1; goto NEXT_LOOP_1; }
	inc=bptr->inc;
	// pion ennemi ( forc )
    if ( inc==COLOR(color,-7) || inc==COLOR(color,+9) )
	{ attaquant_trouve=1; }
	else { bptr->direction_interrompue=1; goto NEXT_LOOP_1; }
	break;
case 'F' :
	inc=bptr->inc;
	if ( inc==-7 || inc==-9 || inc==+7 || inc==+9 )
	{ attaquant_trouve=1; }
	else { bptr->direction_interrompue=1; goto NEXT_LOOP_1; }
    break;
case 'T' :
	inc=bptr->inc;
	if ( inc==-1 || inc==+1 || inc==-8 || inc==+8 )
	{ attaquant_trouve=1; }
	else { bptr->direction_interrompue=1; goto NEXT_LOOP_1; }
	break;
case 'D' :
	{ attaquant_trouve=1; }
	break;
case 'R' :
	if ( bptr->nb_inc==1)
	{ 
		attaquant_trouve=1; 
		// bptr->direction_interrompue=1; NON
		// pas break puisque trouv
	}
	else { bptr->direction_interrompue=1; goto NEXT_LOOP_1; }
	break;
}

// Attaquant trouv sur cette direction
// On veut minimiser la valeur de l'attaquant
if ( cptr->piece_value<valeur_attaquant ) 
{ 
	valeur_attaquant=cptr->piece_value; 
	bptr_mem=bptr;
}
break; // sortie de cette direction
} // fin for cette direction
NEXT_LOOP_1:; // le ; est ncessaire pour compiler
} // fin for directions

// MAJ best bilan_joueur
// minorant_bilan_adversaire=inf(minorant_bilan_adversaire, bilan_joueur);
// En effet, il n'est pas certain 
// que noir va amliorer le bilan attaque en prenant
// Et par ailleurs, cette valeur ne peut pas tre
// suprieure au majorant_bilan_joueur
// En effet, le best_bilan defense reprsente la meilleure
// opportunit de sortie pour blanc
// minorant_bilan_adversaire=sup(minorant_bilan_adversaire, majorant_bilan_joueur);

// Attaquant trouv ?
if ( attaquant_trouve==0 ) 
{
	// Enregistrer l'opportunit pour blanc
	//majorant_bilan_joueur=sup(majorant_bilan_joueur, bilan_joueur);
	//majorant_bilan_joueur=inf(majorant_bilan_joueur, minorant_bilan_adversaire);
	break; // Evaluer
}
else
{ 
// Consommation attaquant
bptr_mem->pos+=bptr_mem->inc; bptr_mem->nb_inc++;

// Prise dfenseur
bilan_joueur-=valeur_defenseur; // prise de la pice menace

// Sortir si le bilan de l'adversaire n'a pas t amlior
//if ( bilan_joueur > minorant_bilan_adversaire ) 
//{
//	goto EVALUATION;
//}

// Sortir si le bilan joueur reste acceptable malgr la prise
ASSERT (bilan_joueur<50);
// N'arrive pas car est anticip
//if (bilan_joueur>=-50) 
//{
//	goto EVALUATION;
//}
// Sortir si mme la reprise de l'attaquant est insuffisante
if ( bilan_joueur+valeur_attaquant < -50) 
{
	bilan_joueur+=valeur_attaquant;
	goto EVALUATION;
}

// Recherche dfenseur
// (seulement si attaquant trouv )
defenseur_trouve=0;
valeur_defenseur=7500; // 5000 = valeur roi

// Une direction de cavalier + 8 directions
// Il y a t-il une pice amie sur les cases de cavalier adjacentes
if (F_existe_possible_cavalier_defenseur)
{
	dirmax=15;
}
else
{
	dirmax=7;
}
bptr=&bilan_ad[0];
for (dir=0; dir<=dirmax; dir++, bptr++ )
{
if (bptr->direction_interrompue==1) continue;
F_dir_cavalier=bptr->F_dir_cavalier;
for(;;bptr->pos+=bptr->inc,bptr->nb_inc++)
{
if (bptr->nb_inc>bptr->nbinc_max) 
{ bptr->direction_interrompue=1; break; }
cptr=&xboard[bptr->pos];
nature2=cptr->nature;
if ( nature2==0 )
{ 
	if (F_dir_cavalier)
	{ bptr->direction_interrompue=1; break; }
	else continue; // continuer dans la direction
}

/* inutile si pas avant coup
// Test d'limination de la pice  jouer
// Non fait car dja fait en analyse de 
// recherche attaquant 
// et la direction aura t close
// Non car la direction n'a pas forcment t explore
if ( cptr->wptr==piece_jouee ) 
{ 
	if (F_dir_cavalier )
	{ bptr->direction_interrompue=1; break; }
	else continue; // continuer dans la direction
}
*/

color2=cptr->color;
if ( color2==-color ) break; // attaquant et non dfenseur

if ( F_dir_cavalier )
{
	if ( nature2!='C' )
	{ bptr->direction_interrompue=1; break; }          
}


switch(nature2)
{
case 'C' :
	if (F_dir_cavalier)
	{ 
		defenseur_trouve=1; 
		// bptr->direction_interrompue=1; NON la pice n'est pas forcment consomme
		// pas break puisque trouv
	} 
	else
	{ bptr->direction_interrompue=1; goto NEXT_LOOP_2; } 
	break;
case 'P' :
	if (bptr->nb_inc>1) 
	{ bptr->direction_interrompue=1; goto NEXT_LOOP_2; }
	inc=bptr->inc;
	// pion dfenseur ( forc )
    if ( inc==COLOR(color,+7) || inc==COLOR(color,-9) )
	{ defenseur_trouve=1; }
	else { bptr->direction_interrompue=1; goto NEXT_LOOP_2; }
	break;
case 'F' :
	inc=bptr->inc;
	if ( inc==-7 || inc==-9 || inc==+7 || inc==+9 )
	{ defenseur_trouve=1; }
	else { bptr->direction_interrompue=1; goto NEXT_LOOP_2; }
    break;
case 'T' :
	inc=bptr->inc;
	if ( inc==-1 || inc==+1 || inc==-8 || inc==+8 )
	{ defenseur_trouve=1; }
	else { bptr->direction_interrompue=1; goto NEXT_LOOP_2; }
case 'D' :
	{ defenseur_trouve=1; }
    break;
case 'R' :
	if ( bptr->nb_inc==1) 
	{ 
		defenseur_trouve=1;
		// bptr->direction_interrompue=1; NON
		// pas break puisque trouv
	}
	else { bptr->direction_interrompue=1; goto NEXT_LOOP_2; }
	break;
}

// Dfenseur trouv sur cette direction
// On veut minimiser la valeur du dfenseur
if ( cptr->piece_value<valeur_defenseur ) 
{ 
	valeur_defenseur=cptr->piece_value; 
	bptr_mem=bptr;
}
break; // sortie de cette direction
} // fin for cette direction
NEXT_LOOP_2:; // le ; est ncessaire pour compiler
} // fin for directions


// MAJ majorant_bilan_joueur
//majorant_bilan_joueur=sup(majorant_bilan_joueur, bilan_joueur);
// En effet, il n'est pas certain 
// que blanc va rduire le bilan attaque en prenant
// Et par ailleurs, cette valeur ne peut pas tre
// infrieure au minorant_bilan_adversaire
//majorant_bilan_joueur=inf(majorant_bilan_joueur, minorant_bilan_adversaire);

if ( defenseur_trouve==0 ) 
{
	// Enregistrer l'opportunit pour noir
	//minorant_bilan_adversaire=inf(minorant_bilan_adversaire, bilan_joueur);
	//minorant_bilan_adversaire=sup(minorant_bilan_adversaire, majorant_bilan_joueur);
	break; // Evaluer
}
else
{
// Consommation dfenseur
bptr_mem->pos+=bptr_mem->inc; bptr_mem->nb_inc++;

// Prise attaquant
bilan_joueur+=valeur_attaquant; // prise de la pice menace

// Sortir si la reprise laisse malgr tout une perte matrielle au dfenseur
ASSERT(bilan_joueur>=-50);
// N'arrive pas car anticip
//if (bilan_joueur<-50)
//{
//	goto EVALUATION;
//}
// Sortir si mme la reprise du dfenseur sera insuffisante
//  tablir une perte matrielle
if ( bilan_joueur-valeur_defenseur > -50) 
{
	bilan_joueur-=valeur_defenseur;
	goto EVALUATION;
}

} // fin dfenseur trouv
} // fin attaquant trouv


} while(1);  // fin do itrations attaque-dfense


EVALUATION:
// Dtermination du bilan attaque
// on sait que 
// majorant_bilan_joueur<minorant_bilan_adversaire

// Evaluation
if ( bilan_joueur < -50 ) 
{
	//bilan_joueur=abs(bilan_joueur);
	//xmax_perte_materielle=sup(xmax_perte_materielle,bilan_joueur);
	#if COLLECT_STATS==1
	xnb_bilan_pm++;
	#endif
	return PERTE_MATERIELLE ; // non dfendu
}
else
{
	#if COLLECT_STATS==1
	xnb_bilan_pd++;
	#endif
	return PIECE_DEFENDUE; // dfendu 
}
}  // fin bilan attaque dfense



#if USE_SEARCH_UNDEFENDED_PIECES==1
#if USE_SEARCH_ALL_UNDEFENDED_PIECES==1
void SEARCH::inventaire_pieces_non_defendues(
    //STATEVALUES *s,
	//char a, char b,
	//unsigned __int32 &pieces_non_defendues, bool &F_piece_non_defendue,
	//char &nb_pieces_non_defendues, char &nb_pions_non_defendus,
	//short &max_valeur_pieces_non_defendues,
	//short &max_valueprise_bilan,
	//char &case_cible_heuristique_protection
	)
{
short max_valeur_pieces_non_defendues;
char i,j;
char liste_pieces_attaquees[16];
char pos;
char num;
STATEVALUES *statesptr;
char adversaire;
unsigned __int32 *pieces_attaquees;
char nb_pieces_attaquees;
PIECE* wptr;
short int si;


// Initialisations
F_inventaire_pieces_non_defendues=true;
adversaire=1-xwtm;
memset(liste_pieces_attaquees,-1, 16);
//nb_pieces_non_defendues=0;
//nb_pions_non_defendus=0;
//max_valueprise_bilan=0;
pieces_non_defendues=0;
max_valeur_pieces_non_defendues=0;
statesptr=&xstates[xlevel];
pieces_attaquees=&statesptr->pieces_attaquees;
nb_pieces_attaquees=0;
case_cible_heuristique_protection=-1;

do // Contrle passe passif
{

/* A CONSERVER
// Boucle sur les pices adverses
wptr=&xw[aa];
for ( i=aa; i<=bb; i++, wptr++ )
{
if ( wptr->nature==0 ) continue; // La pice n'est plus sur l'chiquier

// Contrle des pices attaques
// 8 pices attaques max par pice 
for (j=0;j<=7;j++)
{
k=wptr->psptr->liste_pieces_attaquees[j]; 
if ( k==-1 ) break; // k==-1
else 
{
#if DEBUG==1
if (k>=32 || k<0)
	log_error("\nErreur I_145");
#endif


#if SEARCH_CHECK_PAWN_PROTECTION==0
if (xw[k].nature=='P') continue;
#endif
	
// Si la pice n'tait pas dja menace, incrmenter nb_pieces_attaquees
if (bit(*pieces_non_defendues,k)==0) 
{ 
  nb_pieces_attaquees++; 
  liste_pieces_attaquees[nb_pieces_attaquees-1]=k;		
}
}
} // fin boucle pices attaques
} // fin boucle pices adverses
*/


// Boucle pour constituer la liste des pices attaques
j=0;
for (i=a;i<=b;i++)
{
#if LISTER_PIONS_ATTAQUES==1
#if SEARCH_CHECK_PAWN_PROTECTION==0
if (xw[i].nature=='P') continue;
#endif
#endif
if (bit(*pieces_attaquees,i)==1)
{
// La pice ne doit pas tre menace par un coup forant
// Sinon il est inutile de la rpertorier pour protection
if (bit(statesptr->cases_coup_forcant[1-xwtm],xw[i].pos)==0)
{
liste_pieces_attaquees[j]=i;
j++;
nb_pieces_attaquees++;
}
}
}



// Contrle de dfense des pices attaques
for (i=0; i<=nb_pieces_attaquees-1;i++)
{
num=liste_pieces_attaquees[i];
#if DEBUG==1
if (i<0 || i>15 || liste_pieces_attaquees[i]>31
	|| liste_pieces_attaquees[i] < 0 )
	log_error("\nErreur I_146");
#endif
pos=xw[num].pos;
if (bilan_attaque_defense(pos))
{  
	set_bit_to_1(pieces_non_defendues,num); 
	F_piece_non_defendue=1;
	wptr=&xw[num];
  	//#if SEARCH_CHECK_PAWN_PROTECTION==1
	//if (wptr->nature!='P') 
	//	nb_pieces_non_defendues++;
	//else	
	//	nb_pions_non_defendus++;
	//#else
	//nb_pieces_non_defendues++;
	//#endif
	si=abs(wptr->value);
	if (si>max_valeur_pieces_non_defendues)
	{ 
		max_valeur_pieces_non_defendues=si;
		case_cible_heuristique_protection=wptr->pos;
		//xpiece_cible_heuristique_protection=num;
	}
}
//else // Piece dfendue
//{
// Inutile : set_bit_to_0(*pieces_non_defendues,num);
//}
} // fin for sur les pices attaques

break;
} while(1); // fin do 


return;


} // fin inventaire_pieces_non_defendues
#else 
// USE_SEARCH_ALL_UNDEFENDED_PIECES==0
// On se contente de voir les pices attaques par le dernier coup
void SEARCH::inventaire_pieces_non_defendues(void)
{
// char a et b sont gardes pour compatibilit
char i;
//unsigned __int32 *pieces_attaquees_dernier_coup;

// Initialisations
F_inventaire_pieces_non_defendues=true;
pieces_non_defendues=0;
//pieces_attaquees_dernier_coup=&xw_pieces_attaquees_dernier_coup[xlevel];
//pieces_attaquees_dernier_coup=&xsearch_level[xlevel].pieces_attaquees_dernier_coup;
// est utilis dans maj.cpp

for (i=a;i<=b;i++)
{
if (bit(pieces_attaquees_dernier_coup,i)==1)
{
#if LISTER_PIONS_ATTAQUES==1
#if SEARCH_CHECK_PAWN_PROTECTION==0
if (xw[i].nature=='P') continue;
#endif
#endif
	if (bilan_attaque_defense(s,xw[i].pos)==PERTE_MATERIELLE)
	{
		F_piece_non_defendue=true;
		set_bit_to_1(pieces_non_defendues,i);
		/*
		// La pice ne doit pas tre menace par un coup forcant
		if (bit(xstates[xlevel].cases_coup_forcant[1-xwtm],xw[i].pos)==0)
		{
			set_bit_to_1(pieces_non_defendues,i);
			F_piece_non_defendue=true;
		}
		*/
	}
}
}
}
#endif
#endif


#if USE_CASES_ACTUALISATION==1
char SEARCH::bilan_attaque_defense_avant_coup_simplifie(MOVE move)
{
char arr;
char cc;
char move_nature;

	// L'objectif est d'approximer le plus souvent le bon rsultat
	// Les erreurs ne compromettent pas l'analyse

	arr=MOVE_ARR64(move);
	move_nature=MOVE_NATURE(move);

	if (MOVE_CAPTURE(move)==move_nature) return NEUTRAL;

	if (bit(cases_controlees_adversaire,arr)!=0)
	{
		cc=0;
		switch(move_nature)
		{
		case 'P' : if (MOVE_IS_CAPTURE(move)) 
				   { 
					   return TAKES_UNPROTECTED;
				   }
			       cc=bit(cases_controlees_adversaire,arr);
				   break;
		case 'C' : cc=bit(cases_controlees_pion_adversaire,arr);
				   break; 
		case 'F' : cc=bit(cases_controlees_pion_adversaire,arr);
				   break;
		case 'T' : cc=bit(cases_controlees_pion_adversaire,arr);
				   //cc=bit(cases_controlees_fou_adversaire,arr);
				   break;
		case 'D' : cc=bit(cases_controlees_tour_adversaire,arr);
					   break;                   
		default : break;
		}
		
		// Contrle de la case d'arrive par une pice de niveau infrieur
		// Prsomption de perte matrielle
		if (cc==1) { return MATERIAL_LOSS; }
	

		#if USE_CASES_CONTROLEES_JOUEUR==1
		// Si case controlees adversaire, il y a-t-il un soutien par une pice amie
		// Permet de vrifier si Dxf7 est une perte matrielle
		// Vrification contrle roi adverse
		// sinon le coup tait systmatiquement considr GAIN_MATERIEL
		// Rem : bit(cases_controlees_adversaire,arr)==1
		#if _DEBUG
		ASSERT(F_calculate_case_controlees_joueur);
		#endif
		//if (F_calculate_case_controlees_joueur) // coup OK et cases controlees joueur
		{
			// Si la case est controle par le roi adverse
			// et donc par cases_controlees_adversaire
			// vrifier que la pice est supporte par une pice d'une autre nature
			// Sinon c'est une perte matrielle quasi-certaine
			// Il y a une approximation car une pice pourrait tre soutenue par une pice du mme type
			// Mais le but est de classer rapidement les coups
			if (bit(cases_controlees_adversaire,arr))
			{
				switch(move_nature)
				{
				case 'P' : cc=1-bit(cases_controle_exclusif_dame|cases_controle_exclusif_tour|cases_controle_exclusif_fou|cases_controle_exclusif_roi,arr);
						   break;
				case 'C' : cc=1-bit(cases_controle_exclusif_dame|cases_controle_exclusif_tour|cases_controle_exclusif_pion|cases_controle_exclusif_roi,arr);
						   break; 
				case 'F' : cc=1-bit(cases_controle_exclusif_dame|cases_controle_exclusif_tour|cases_controle_exclusif_pion|cases_controle_exclusif_roi,arr);
						   break; 
				case 'T' : cc=1-bit(cases_controle_exclusif_dame|cases_controle_exclusif_fou|cases_controle_exclusif_pion|cases_controle_exclusif_roi,arr);
						   break;
				case 'D' : cc=1-bit(cases_controle_exclusif_tour|cases_controle_exclusif_fou|cases_controle_exclusif_pion|cases_controle_exclusif_roi,arr);
						   break;                   
				default : break;
				}
			}
		
		// Pas de support par une pice amie 
		// Prsomption de perte matrielle
		if (cc==1)
		{
			return MATERIAL_LOSS;
		}		
		}
		#else
			return NEUTRAL; // cote mal taile (case controles mais pas par une pice infrieure)
		#endif
		
		ASSERT(cc==0);
		if (MOVE_IS_FORCING(move))
		{ return TAKES_UNPROTECTED; }
		else 
		{ return NEUTRAL; }		
	}
	else // case non controlees par l'adversaire
	{
		if (MOVE_IS_FORCING(move))
		{ return TAKES_UNPROTECTED; }
		else 
		{ return NEUTRAL; }
	}
	
} // fin fonction
#endif


char SEARCH::bilan_attaque_defense_avant_coup(MOVE move)
{
// Cette nouvelle version de attaque dfense utilise directement 
// l'chiquier
char dir;
char color;
// [ 8 directions de cavaliers et 8 directions  7 cases potentielles ]
// on commence par la direction de cavalier qui sera frquemment renseigne
// On commence par les 8 directions de cavaliers
CASE *cptr;
CASE *cptr_depart;
// L'attaquant est celui qui joue la pice
short valeur_attaquant, valeur_defenseur;
short bilan_joueur, bilan_joueur_initial;
// Les best sont maintenus pour pouvoir
// conserver le meilleur rsultat pour chaque
// camp dans la suite d'valuation des prises
short minorant_bilan_adversaire, majorant_bilan_joueur;
char attaquant_trouve, defenseur_trouve;
BILAN_AD  *bptr, *bptr_mem;
char nature2, color2;
char inc;
char F_dir_cavalier;
char position_depart;
PIECE *piece_jouee;
char color01;
char piece_jouee_pos;
bool F_existe_possible_cavalier_defenseur, F_existe_possible_cavalier_attaquant;
char dirmax_attaquant, dirmax_defenseur;
BILAN_AD bilan_ad[16];
char cc;
//char arr2;
//char arr;

// Statistiques
#if COLLECT_STATS==1
xnb_bilan_avant_coup++;
#endif



// Contrles immdiats et rapides  effectuer
if (MOVE_CATEGORY(move)==COUP_FORCANT)
{
    #if COLLECT_STATS==1
    xnb_bilan_avant_coup_gm++;
    #endif
    return GAIN_MATERIEL;
}
// Les coups de roi qui ne sont pas des coups forants sont des
// coups neutres
if (MOVE_IS_KING(move))
{
    ASSERT(!MOVE_IS_FORCING(move));
    return COUP_NEUTRE;
}


#if USE_CASES_ACTUALISATION==1
// Si la pice adverse n'est pas protge
// COUP_FORCANT
if (MOVE_IS_CAPTURE(move))
{
	if (bit(cases_controlees_adversaire,MOVE_ARR64(move))==0)
	{
		return GAIN_MATERIEL;
	}
}
#endif		


// Les prises de pions sont de loin les plus frquentes
if (MOVE_TAKES_PAWN(move))
{
    if (MOVE_IS_PAWN(move))
    {
        #if COLLECT_STATS==1
        xnb_bilan_avant_coup_cn++;
        #endif
        return COUP_NEUTRE;
    }
    else // Prise de pion par pice
    {
    // Pawn protected ?
	ASSERT(xwtm==wtm);
	position_depart=MOVE_ARR64(move);
	if (is_pawn_protected(position_depart,1-wtm))
	{
        #if COLLECT_STATS==1
        xnb_bilan_avant_coup_cn++;
        #endif
        return PERTE_MATERIELLE;
    }

    } // fin else // Prise de pion par pice
}
else // Prise de pice
{
    // Initialisation
    position_depart=MOVE_ARR64(move);
}


// Autres initialisations
bptr_mem=NULL;
cptr_depart=&xboard[position_depart];
// Attention : la pice joue est encore sur la case de dpart !
piece_jouee_pos=MOVE_DEP64(move);
piece_jouee=xboard[piece_jouee_pos].wptr;
color=player;
ASSERT(color==piece_jouee->color);
color01=TO_COLOR01(color);

// Valeur attaquant et bilan initial

// Si promotion : le attaquant est maintenant la pice promue
// et il faut modifier dja le bilan d'origine
if (MOVE_IS_PROMOTION(move))
{
    switch(MOVE_PROMOTION(move))
    {
    case 'C' : valeur_attaquant=VALEUR_CAVALIER; break;
    case 'F' : valeur_attaquant=VALEUR_FOU; break;
    case 'T' : valeur_attaquant=VALEUR_TOUR; break;
    case 'D' : valeur_attaquant=VALEUR_DAME; break;
    }
    bilan_joueur_initial=cptr_depart->piece_value
        +valeur_attaquant-VALEUR_PION;
}
else
{
    valeur_attaquant=abs(piece_jouee->value);
    bilan_joueur_initial=cptr_depart->piece_value;
    ASSERT(!MOVE_IS_EN_PASSANT(move));
    // Les prises de pions par des pions ont dja t traites
    // A conserver pour le principe
    // if (MOVE_IS_EN_PASSANT(move))
    //{
    //    bilan_joueur_initial=VALEUR_PION;   
    //}
}

// Rem: le bilan_joueur est vu du point
// de vue du camp jouant le coup
// => si le bilan_joueur est < 0, le coup test est mauvais
// En cas de promotion, le bilan initial tient compte de la valeur de la promotion
// et la valeur de l'attaquant est gale  la valeur de la pice promue (voir plus haut)
// bilan_joueur_initial=MOVE_CAPTURE_VALUE(move);
// pb : la valeur suivante est prcise
// et pour avoir MOVE_CAPTURE_VALUE(move)
// il faudrait passer un __int64
// cela est ncessaire pour les comparaisons

// Initialisation bilan initiaux
// Le meilleur bilan d'attaque est initialis
// au bilan d'attaque initial
// il ne peut tre qu'amlior
bilan_joueur=bilan_joueur_initial;
minorant_bilan_adversaire=bilan_joueur_initial;
// Le best bilan de dfense est initialis  une mauvaise
// valeur initiale qui provoquera la mise  jour
// au premier choix du attaquant
// Si le attaquant n'a pas de choix  oprer
// c'est  dire si le camp defenseur n'a pas de prise
// on rajuste majorant_bilan_joueur au bilan initial
majorant_bilan_joueur=bilan_joueur_initial-valeur_attaquant;


// Sortie si prise suffisante
// Arrive quand un pion prend une dame (par exemple)
if (majorant_bilan_joueur>50)
{
    goto EVALUATION;
}


// Existence de cavaliers amis et adverses
if ((unsigned __int64)
    ((unsigned __int64)xcases_arrivee_cavalier[position_depart]
        &(unsigned __int64)(s->cases_pieces[1-color01])))
{
    F_existe_possible_cavalier_defenseur=true;
}
else
{
    F_existe_possible_cavalier_defenseur=false;
}
if ((unsigned __int64)
    (
       (unsigned __int64)xcases_arrivee_cavalier[position_depart]
       &
       (unsigned __int64)(s->cases_pieces[color01])
       &(~((unsigned __int64)1<<piece_jouee_pos))
       )
    )
{
    F_existe_possible_cavalier_attaquant=true;
}
else
{
    F_existe_possible_cavalier_attaquant=false;
}


// Initialisation des directions attaquant
if (F_existe_possible_cavalier_attaquant)
{
    dirmax_attaquant=15;
}
else
{
    dirmax_attaquant=7;
}
// Initialisation des directions dfenseur
if (F_existe_possible_cavalier_defenseur)
{
    dirmax_defenseur=15;
}
else
{
    dirmax_defenseur=7;
}

// Initialisation bilan_ad
memcpy((char*)&bilan_ad[0],(char*)&xbilan_ad[position_depart][0],(max(dirmax_defenseur,dirmax_attaquant)+1)*sizeof(BILAN_AD));
#if _DEBUG==1
bptr=&bilan_ad[0];
for (dir=0; dir<=max(dirmax_defenseur,dirmax_attaquant); dir++, bptr++ )
{
if (dir<8) ASSERT (bptr->F_dir_cavalier==false);
else       ASSERT (bptr->F_dir_cavalier==true);
ASSERT(bptr->inc==xinc64[dir]);
ASSERT(bptr->pos==position_depart+bptr->inc);
ASSERT(bptr->nb_inc==1);
ASSERT(bptr->nbinc_max==xnbinc_par_direction[position_depart][dir]);
ASSERT(bptr->direction_interrompue==0);
// Contrle inutile - fait ensuite
// if (bptr->nbinc_max==0) bptr->direction_interrompue=1;
// else bptr->direction_interrompue=0;
}
#endif


#if DEBUG==1
if (color==0)
log_error("\nErr J_911");
#endif


// Recherche attaque-dfense
do
{

// Recherche dfenseur
defenseur_trouve=0;
valeur_defenseur=7500; // Valeur roi = 5000

bptr=&bilan_ad[0];
for (dir=0;dir<=dirmax_defenseur; dir++, bptr++ )
{
if (bptr->direction_interrompue==1) continue;
F_dir_cavalier=bptr->F_dir_cavalier;
for(;;bptr->pos+=bptr->inc,bptr->nb_inc++)
{
if (bptr->nb_inc>bptr->nbinc_max)
{ bptr->direction_interrompue=1; break; }
cptr=&xboard[bptr->pos];
nature2=cptr->nature;
if ( nature2==0 )
{
    if (F_dir_cavalier)
    { bptr->direction_interrompue=1; break; }
    else continue; // continuer dans la direction
}

// Test d'limination de la pice  jouer
if ( cptr->wptr==piece_jouee )
{
    if (F_dir_cavalier)
    { bptr->direction_interrompue=1; break; }
    else continue; // continuer dans la direction
}


color2=cptr->color;
// Attaquant potentiel
// On retarde dans ce cas l'analyse de direction interrompue
// au moment o on cherchera des attaquants
if ( color2==color ) break; // attaquant et non defenseur

// Dfenseur adverse

if ( F_dir_cavalier )
{
    if ( nature2!='C' )
    { bptr->direction_interrompue=1; break; }         
}


switch(nature2)
{
case 'C' :
    if (F_dir_cavalier)
    {
        ASSERT(!(!F_existe_possible_cavalier_defenseur));
        defenseur_trouve=1;
        // bptr->direction_interrompue=1; NON
        // pas break puisque trouv
    }
    else
    { bptr->direction_interrompue=1; goto NEXT_LOOP_1; }
    break;
case 'P' :
    if (bptr->nb_inc>1)
    { bptr->direction_interrompue=1; goto NEXT_LOOP_1; }
    inc=bptr->inc;
    // pion ennemi ( forc )
    if ( inc==COLOR(color,-7) || inc==COLOR(color,+9) )
    { defenseur_trouve=1; }
    else { bptr->direction_interrompue=1; goto NEXT_LOOP_1; }
    break;
case 'F' :
    inc=bptr->inc;
    if ( inc==-7 || inc==-9 || inc==+7 || inc==+9 )
    { defenseur_trouve=1; }
    else { bptr->direction_interrompue=1; goto NEXT_LOOP_1; }
    break;
case 'T' :
    inc=bptr->inc;
    if ( inc==-1 || inc==+1 || inc==-8 || inc==+8 )
    { defenseur_trouve=1; }
    else { bptr->direction_interrompue=1; goto NEXT_LOOP_1; }
    break;
case 'D' :
    defenseur_trouve=1;
    break;
case 'R' :
    if ( bptr->nb_inc==1)
    {
        defenseur_trouve=1;
        // bptr->direction_interrompue=1;  NON
        // pas break puisque trouv
    }
    else { bptr->direction_interrompue=1; goto NEXT_LOOP_1; }
    break;
}

// Dfenseur trouv sur cette direction
// On veut minimiser la valeur de l'defenseur
if ( cptr->piece_value<valeur_defenseur )
{
    valeur_defenseur=cptr->piece_value;
    bptr_mem=bptr;
}
break; // sortie de cette direction
} // fin for cette direction
NEXT_LOOP_1:;
} // fin for directions

// MAJ best bilan_joueur
minorant_bilan_adversaire=inf(minorant_bilan_adversaire, bilan_joueur);
// En effet, il n'est pas certain
// que noir va amliorer le bilan attaque en prenant
// Et par ailleurs, cette valeur ne peut pas tre
// suprieure au majorant_bilan_joueur
// En effet, le best_bilan defense reprsente la meilleure
// opportunit de sortie pour blanc
minorant_bilan_adversaire=sup(minorant_bilan_adversaire, majorant_bilan_joueur);

// Dfenseur trouv ?
if ( defenseur_trouve==0 )
{
    // Enregistrer l'opportunit pour blanc
    majorant_bilan_joueur=sup(majorant_bilan_joueur, bilan_joueur);
    majorant_bilan_joueur=inf(majorant_bilan_joueur, minorant_bilan_adversaire);
    break; // Evaluer
}
else
{
// Consommation defenseur
bptr_mem->pos+=bptr_mem->inc; bptr_mem->nb_inc++;

// Prise attaquant
bilan_joueur-=valeur_attaquant; // prise de la pice menace

// Sortir si le bilan de l'adversaire n'a pas t amlior
// N'arrive pas car anticip
ASSERT(bilan_joueur <= minorant_bilan_adversaire);
//if ( bilan_joueur > minorant_bilan_adversaire )
//{
//    goto EVALUATION;
//}
// Sortir si le bilan du joueur restera
// ngatif mme en cas de consommation de l'defenseur
if ( bilan_joueur+valeur_defenseur < -50 || bilan_joueur<-VALEUR_ROI/2)
{
    //bilan_joueur+=valeur_defenseur;
    // Attention : ordre blanc noir important
    // Enregistrer l'oppportunit ventuelle pour blanc
    majorant_bilan_joueur=sup(majorant_bilan_joueur, bilan_joueur);
    majorant_bilan_joueur=inf(majorant_bilan_joueur, minorant_bilan_adversaire);
    // Enregistrer l'oppportunit ventuelle pour noir
    minorant_bilan_adversaire=inf(minorant_bilan_adversaire, bilan_joueur);
    minorant_bilan_adversaire=sup(minorant_bilan_adversaire, majorant_bilan_joueur);
    goto EVALUATION;
}
// Sortir si le bilan du joueur reste positif malgr la prise par l'defenseur
// Le attaquant n'a pas besoin de prendre pour rester en gain matriel
// N'arrive pas car anticip
ASSERT(bilan_joueur <= 50);
//if ( bilan_joueur > 50 )
//{
//    // Attention : ordre blanc noir important
//    // Enregistrer l'oppportunit ventuelle pour noir
//    minorant_bilan_adversaire=inf(minorant_bilan_adversaire, bilan_joueur);
//    minorant_bilan_adversaire=sup(minorant_bilan_adversaire, majorant_bilan_joueur);
//    // Enregistrer l'oppportunit ventuelle pour blanc
//    majorant_bilan_joueur=sup(majorant_bilan_joueur, bilan_joueur);
//    majorant_bilan_joueur=inf(majorant_bilan_joueur, minorant_bilan_adversaire);
//    goto EVALUATION;
//}


// Recherche attaquant
// (seulement si defenseur trouv )
attaquant_trouve=0;
valeur_attaquant=7500; // 5000 = valeur roi

bptr=&bilan_ad[0];
for (dir=0; dir<=dirmax_attaquant; dir++, bptr++ )
{
if (bptr->direction_interrompue==1) continue;
F_dir_cavalier=bptr->F_dir_cavalier;
for(;;bptr->pos+=bptr->inc,bptr->nb_inc++)
{
if (bptr->nb_inc>bptr->nbinc_max)
{ bptr->direction_interrompue=1; break; }
cptr=&xboard[bptr->pos];
nature2=cptr->nature;
if ( nature2==0 )
{
    if (F_dir_cavalier)
    { bptr->direction_interrompue=1; break; }
    else continue; // continuer dans la direction
}


// Test d'limination de la pice  jouer
// Non fait car dja fait en analyse de
// recherche defenseur
// et la direction aura t close
// Non : car la direction n'a pas forcment t explore
if ( bptr->pos==piece_jouee_pos )
{
    if (F_dir_cavalier)
    { bptr->direction_interrompue=1; break; }
    else continue; // continuer dans la direction
}


color2=cptr->color;
if ( color2==-color ) break; // defenseur et non attaquant

if ( F_dir_cavalier )
{
    if ( nature2!='C' )
    { bptr->direction_interrompue=1; break; }         
}


switch (nature2)
{
case 'C' :
    if (F_dir_cavalier)
    {
        ASSERT(F_existe_possible_cavalier_attaquant);
        attaquant_trouve=1;
        // bptr->direction_interrompue=1; NON : la pice n'est pas forcment consomme
        // pas break puisque trouv
    }
    else
    { bptr->direction_interrompue=1; goto NEXT_LOOP_2;    }
    break;
case 'P' :
    if (bptr->nb_inc>1)
    { bptr->direction_interrompue=1; goto NEXT_LOOP_2; }
    inc=bptr->inc;
    // pion attaquant ( forc )
    if ( inc==COLOR(color,+7) || inc==COLOR(color,-9) )
    { attaquant_trouve=1; }
    else { bptr->direction_interrompue=1; goto NEXT_LOOP_2; }
    break;
case 'F' :
    inc=bptr->inc;
    if ( inc==-7 || inc==-9 || inc==+7 || inc==+9 )
    { attaquant_trouve=1; }
    else { bptr->direction_interrompue=1; goto NEXT_LOOP_2; }
    break;
case 'T' :
    inc=bptr->inc;
    if ( inc==-1 || inc==+1 || inc==-8 || inc==+8 )
    { attaquant_trouve=1; }
    else { bptr->direction_interrompue=1; goto NEXT_LOOP_2; }
    break;
case 'D' :
    attaquant_trouve=1;
    break;
case 'R' :
    if (bptr->nb_inc==1)
    {
        attaquant_trouve=1;
        // bptr->direction_interrompue=1; NON
        // pas break puisque trouv
    }
    else
    {
        bptr->direction_interrompue=1;
        goto NEXT_LOOP_2;
    }
    break;
}

// Attaquant trouv sur cette direction
// On veut minimiser la valeur du attaquant
if ( cptr->piece_value<valeur_attaquant )
{
    valeur_attaquant=cptr->piece_value;
    bptr_mem=bptr;
}
break; // sortie de cette direction
} // fin for cette direction
NEXT_LOOP_2:;
} // fin for directions

// MAJ majorant_bilan_joueur
majorant_bilan_joueur=sup(majorant_bilan_joueur, bilan_joueur);
// En effet, il n'est pas certain
// que blanc va rduire le bilan attaque en prenant
// Et par ailleurs, cette valeur ne peut pas tre
// infrieure au minorant_bilan_adversaire
majorant_bilan_joueur=inf(majorant_bilan_joueur, minorant_bilan_adversaire);

if ( attaquant_trouve==0 )
{
    // Enregistrer l'opportunit pour l'defenseur
    minorant_bilan_adversaire=inf(minorant_bilan_adversaire, bilan_joueur);
    minorant_bilan_adversaire=sup(minorant_bilan_adversaire, majorant_bilan_joueur);
    break; // Evaluer
}
else
{
// Consommation attaquant
bptr_mem->pos+=bptr_mem->inc; bptr_mem->nb_inc++;

// Prise defenseur
bilan_joueur+=valeur_defenseur; // prise de la pice menace


// Sortir si le bilan du joueur n'est pas amlior
// N'arrive pas car anticip
ASSERT(bilan_joueur>=majorant_bilan_joueur);
//if ( bilan_joueur < majorant_bilan_joueur )
//{
//    goto EVALUATION;
//}
// Sortir si le bilan du joueur reste
// positif mme en cas de consommation du attaquant
if ( bilan_joueur-valeur_attaquant > 50 || bilan_joueur>VALEUR_ROI/2)
{
    //bilan_joueur-=valeur_attaquant;
    // Attention : ordre blanc noir important
    // Enregistrer l'oppportunit ventuelle pour noir
    minorant_bilan_adversaire=inf(minorant_bilan_adversaire, bilan_joueur);
    minorant_bilan_adversaire=sup(minorant_bilan_adversaire, majorant_bilan_joueur);
    // Enregistrer l'oppportunit ventuelle pour blanc
    majorant_bilan_joueur=sup(majorant_bilan_joueur, bilan_joueur);
    majorant_bilan_joueur=inf(majorant_bilan_joueur, minorant_bilan_adversaire);
    goto EVALUATION;
}
// Sortir si le bilan du joueur reste trop ngatif
// L'defenseur n'a pas mme besoin de reprendre
// N'arrive pas car anticip
ASSERT(bilan_joueur >= -50);
//if ( bilan_joueur < -50 )
//{
//    // Attention : ordre blanc noir important
//    // Enregistrer l'oppportunit ventuelle pour blanc
//    majorant_bilan_joueur=sup(majorant_bilan_joueur, bilan_joueur);
//    majorant_bilan_joueur=inf(majorant_bilan_joueur, minorant_bilan_adversaire);
//    // Enregistrer l'oppportunit ventuelle pour noir
//    minorant_bilan_adversaire=inf(minorant_bilan_adversaire, bilan_joueur);
//    minorant_bilan_adversaire=sup(minorant_bilan_adversaire, majorant_bilan_joueur);
//    goto EVALUATION;
//}

} // fin attaquant trouv
} // fin defenseur trouv


} while(1);  // fin do itrations attaque-dfense


EVALUATION:
ASSERT(majorant_bilan_joueur<=minorant_bilan_adversaire);

// Dtermination du bilan attaque
// on sait que
// majorant_bilan_joueur<minorant_bilan_adversaire

#if DEBUG==1
char dd;
if (majorant_bilan_joueur<-50) // Suprieur  la diffrence fou-cavalier
{
    cc=PERTE_MATERIELLE;
}
else if (minorant_bilan_adversaire>50) // Suprieur  la diffrence fou-cavalier
{
    cc=GAIN_MATERIEL;
}
// Autres cas
else cc=COUP_NEUTRE;
// Il y arrive qu'il y ait des diffrences rares car la premire version
// sait reconnatre la prise Sdu roi adverse contrairement  la version de contrle
dd=bilan_attaque_defense_avant_coup2(move);
if (cc!=dd)
    log_error("\nJ3_677 ");
#endif


// Pour xvalueprise_bilan, on retient la valeur la plus optimiste
// pour ne pas perdre d'opportunits
//xvalueprise_bilan=minorant_bilan_adversaire; // il ne faut pas signer le bilan !!!
//valueprise_bilan=minorant_bilan_adversaire;
if (majorant_bilan_joueur<-50) // Suprieur  la diffrence fou-cavalier
{
    #if COLLECT_STATS==1
    xnb_bilan_avant_coup_pm++;
    #endif
    #if ALLOW_EXTEND_ROOK_SACRIFICES==1
    if (xextend)
    {
    if (piece_jouee->nature=='T')
    {
        // Nature de la pice prise
        switch (cptr_depart->nature)
        {
            // Permettre le sacrifice tour contre fou en extend (quiescence)
            // en retournant SEE=0
            case 'C' :
                return COUP_NEUTRE;
            case 'F' :
                return COUP_NEUTRE;
        }
    }
    }
     #endif
    return PERTE_MATERIELLE;
   
}
if (minorant_bilan_adversaire>50) // Suprieur  la diffrence fou-cavalier
{
    #if COLLECT_STATS==1
    xnb_bilan_avant_coup_gm++;
    #endif
    return GAIN_MATERIEL;
}
#if COLLECT_STATS==1
xnb_bilan_avant_coup_cn++;
#endif
// Autres cas
return COUP_NEUTRE;

}  // fin bilan attaque dfense avant coup

#if DEBUG==1
char SEARCH::bilan_attaque_defense_avant_coup2(MOVE move)
{
// Cette nouvelle version de attaque dfense utilise directement
// l'chiquier
char dir;
char color;
// [ 8 directions de cavaliers et 8 directions  7 cases potentielles ] 
// on commence par la direction de cavalier qui sera frquemment renseigne
// On commence par les 8 directions de cavaliers
CASE *cptr;
CASE *cptr_depart;
// L'attaquant est celui qui joue la pice
short valeur_attaquant, valeur_defenseur;
short bilan_joueur, bilan_joueur_initial;
// Les best sont maintenus pour pouvoir 
// conserver le meilleur rsultat pour chaque
// camp dans la suite d'valuation des prises
short minorant_bilan_adversaire, majorant_bilan_joueur;
char attaquant_trouve, defenseur_trouve;
BILAN_AD  *bptr, *bptr_mem;
char nature2, color2;
char inc;
char F_dir_cavalier;
char position_depart;
PIECE *piece_jouee;
char color01;
char piece_jouee_pos;
bool F_existe_possible_cavalier_defenseur, F_existe_possible_cavalier_attaquant;
char dirmax_attaquant, dirmax_defenseur;
BILAN_AD bilan_ad[16];
char cc;
char arr2;


// Statistiques
#if COLLECT_STATS==1
xnb_bilan_avant_coup++;
#endif



// Contrles immdiats et rapides  effectuer
if (MOVE_CATEGORY(move)==COUP_FORCANT)
{
	#if COLLECT_STATS==1
	xnb_bilan_avant_coup_gm++;
	#endif
	return GAIN_MATERIEL;
}
// Les coups de roi qui ne sont pas des coups forants sont des 
// coups neutres
if (MOVE_IS_KING(move)) 
{
	ASSERT(!MOVE_IS_FORCING(move));
	return COUP_NEUTRE;
}

// Les prises de pions sont de loin les plus frquentes
if (MOVE_TAKES_PAWN(move))
{
	if (MOVE_IS_PAWN(move))
{
		#if COLLECT_STATS==1
		xnb_bilan_avant_coup_cn++;
		#endif
		return COUP_NEUTRE;
}
	else // Prise de pion par pice
	{
	// Pawn protected ?
	cc=0;
	position_depart=MOVE_ARR64(move);
	ASSERT(player==xboard[MOVE_DEP64(move)].color);
	do 
	{
	arr2=position_depart+COLOR(player,9);
	if (WITHIN_BOARD(arr2))
{
		ASSERT(arr2>=0 && arr2<=63);
		if (bit(s->cases_pions[other_wtm],arr2)) 
		{ cc=1; break; }
}
	arr2=position_depart-COLOR(player,7);
	if (WITHIN_BOARD(arr2))
{
		ASSERT(arr2>=0 && arr2<=63);
		if (bit(s->cases_pions[other_wtm],arr2)) 
		{ cc=1; break; }
}
	break;
	} while(false);

	if (cc==1) 
{
		#if COLLECT_STATS==1
		xnb_bilan_avant_coup_cn++;
		#endif
		return PERTE_MATERIELLE;
}

	} // fin else // Prise de pion par pice
}
else // Prise de pice
{
	// Initialisation
	position_depart=MOVE_ARR64(move);
}


// Autres initialisations 
bptr_mem=NULL;
cptr_depart=&xboard[position_depart];
// Attention : la pice joue est encore sur la case de dpart !
piece_jouee_pos=MOVE_DEP64(move);
piece_jouee=xboard[piece_jouee_pos].wptr;
color=player;
ASSERT(color==piece_jouee->color);
color01=TO_COLOR01(color);

// Valeur attaquant et bilan initial

// Si promotion : le attaquant est maintenant la pice promue
// et il faut modifier dja le bilan d'origine
if (MOVE_IS_PROMOTION(move))
{
	switch(MOVE_PROMOTION(move))
	{
	case 'C' : valeur_attaquant=VALEUR_CAVALIER; break;
	case 'F' : valeur_attaquant=VALEUR_FOU; break;
	case 'T' : valeur_attaquant=VALEUR_TOUR; break;
	case 'D' : valeur_attaquant=VALEUR_DAME; break;
	}
	bilan_joueur_initial=cptr_depart->piece_value
		+valeur_attaquant-VALEUR_PION;
}
else 
{
	valeur_attaquant=abs(piece_jouee->value);
	bilan_joueur_initial=cptr_depart->piece_value;
	ASSERT(!MOVE_IS_EN_PASSANT(move));
	// Les prises de pions par des pions ont dja t traites
	// A conserver pour le principe
	// if (MOVE_IS_EN_PASSANT(move))
	//{
	//	bilan_joueur_initial=VALEUR_PION;	
	//}
}

// Rem: le bilan_joueur est vu du point 
// de vue du camp jouant le coup
// => si le bilan_joueur est < 0, le coup test est mauvais
// En cas de promotion, le bilan initial tient compte de la valeur de la promotion
// et la valeur de l'attaquant est gale  la valeur de la pice promue (voir plus haut)
//bilan_joueur_initial=MOVE_CAPTURE_VALUE(move);
// pb : la valeur suivante est prcise 
// et pour avoir MOVE_CAPTURE_VALUE(move)
// il faudrait passer un __int64
// cela est ncessaire pour les comparaisons

// Initialisation bilan initiaux
// Le meilleur bilan d'attaque est initialis
// au bilan d'attaque initial
// il ne peut tre qu'amlior
bilan_joueur=bilan_joueur_initial;
minorant_bilan_adversaire=bilan_joueur_initial;
// Le best bilan de dfense est initialis  une mauvaise
// valeur initiale qui provoquera la mise  jour 
// au premier choix du attaquant
// Si le attaquant n'a pas de choix  oprer 
// c'est  dire si le camp defenseur n'a pas de prise
// on rajuste majorant_bilan_joueur au bilan initial
majorant_bilan_joueur=bilan_joueur_initial-valeur_attaquant;


// Sortie si prise suffisante
// Arrive quand un pion prend une dame (par exemple)
if (majorant_bilan_joueur>50)
{
	goto EVALUATION;
}


// Existence de cavaliers amis et adverses
if ((unsigned __int64)
	((unsigned __int64)xcases_arrivee_cavalier[position_depart]
		&(unsigned __int64)(s->cases_pieces[1-color01])))
{
	F_existe_possible_cavalier_defenseur=true;
}
else
{
	F_existe_possible_cavalier_defenseur=false;
}
if ((unsigned __int64)
	(
	   (unsigned __int64)xcases_arrivee_cavalier[position_depart]
       &
	   (unsigned __int64)(s->cases_pieces[color01])
	   &(~((unsigned __int64)1<<piece_jouee_pos))
	   )
	)
{
	F_existe_possible_cavalier_attaquant=true;
}
else
{
	F_existe_possible_cavalier_attaquant=false;
}


// Initialisation des directions attaquant
if (F_existe_possible_cavalier_attaquant)
{
	dirmax_attaquant=15;
}
else
{
	dirmax_attaquant=7;
}
// Initialisation des directions dfenseur
if (F_existe_possible_cavalier_defenseur)
{
	dirmax_defenseur=15;
}
else
{
	dirmax_defenseur=7;
}

// Initialisation bilan_ad
memcpy((char*)&bilan_ad[0],(char*)&xbilan_ad[position_depart][0],(max(dirmax_defenseur,dirmax_attaquant)+1)*sizeof(BILAN_AD));
#if _DEBUG==1
bptr=&bilan_ad[0];
for (dir=0; dir<=max(dirmax_defenseur,dirmax_attaquant); dir++, bptr++ )
{
if (dir<8) ASSERT (bptr->F_dir_cavalier==false);
else       ASSERT (bptr->F_dir_cavalier==true);
ASSERT(bptr->inc==xinc64[dir]);
ASSERT(bptr->pos==position_depart+bptr->inc); 
ASSERT(bptr->nb_inc==1);
ASSERT(bptr->nbinc_max==xnbinc_par_direction[position_depart][dir]);
ASSERT(bptr->direction_interrompue==0);
// Contrle inutile - fait ensuite
// if (bptr->nbinc_max==0) bptr->direction_interrompue=1;
// else bptr->direction_interrompue=0;
}
#endif


#if DEBUG==1
if (color==0)
log_error("\nErr J_911");
#endif


// Recherche attaque-dfense
do 
{

// Recherche dfenseur
defenseur_trouve=0;
valeur_defenseur=7500; // Valeur roi = 5000

bptr=&bilan_ad[0];
for (dir=0;dir<=dirmax_defenseur; dir++, bptr++ )
{
if (bptr->direction_interrompue==1) continue;
F_dir_cavalier=bptr->F_dir_cavalier;
for(;;bptr->pos+=bptr->inc,bptr->nb_inc++)
{
if (bptr->nb_inc>bptr->nbinc_max) 
{ bptr->direction_interrompue=1; break; }
cptr=&xboard[bptr->pos];
nature2=cptr->nature;
if ( nature2==0 )
{ 
	if (F_dir_cavalier )
	{ bptr->direction_interrompue=1; break; }
	else continue; // continuer dans la direction
}

// Test d'limination de la pice  jouer
if ( cptr->wptr==piece_jouee ) 
{ 
	if (F_dir_cavalier )
	{ bptr->direction_interrompue=1; break; }
	else continue; // continuer dans la direction
}


color2=cptr->color;
// Attaquant potentiel
// On retarde dans ce cas l'analyse de direction interrompue
// au moment o on cherchera des attaquants
if ( color2==color ) break; // attaquant et non defenseur

// Dfenseur adverse

if ( F_dir_cavalier )
{
	if ( nature2!='C' )
	{ bptr->direction_interrompue=1; break; }          
}


switch(nature2)
{
case 'C' :
	if (F_dir_cavalier)
	{
		ASSERT(!(!F_existe_possible_cavalier_defenseur));
		defenseur_trouve=1;
		// bptr->direction_interrompue=1; NON
		// pas break puisque trouv
	}
	else
	{ bptr->direction_interrompue=1; goto NEXT_LOOP_1; } 
	break;
case 'P' :
	if (bptr->nb_inc>1) 
	{ bptr->direction_interrompue=1; goto NEXT_LOOP_1; }
	inc=bptr->inc;
	// pion ennemi ( forc )
      if ( inc==COLOR(color,-7) || inc==COLOR(color,+9) )
	{ defenseur_trouve=1; }
	else { bptr->direction_interrompue=1; goto NEXT_LOOP_1; }
	break;
case 'F' :
	inc=bptr->inc;
	if ( inc==-7 || inc==-9 || inc==+7 || inc==+9 )
	{ defenseur_trouve=1; }
	else { bptr->direction_interrompue=1; goto NEXT_LOOP_1; }
	break;
case 'T' :
	inc=bptr->inc;
	if ( inc==-1 || inc==+1 || inc==-8 || inc==+8 )
	{ defenseur_trouve=1; }
	else { bptr->direction_interrompue=1; goto NEXT_LOOP_1; }
	break;
case 'D' :
	defenseur_trouve=1;
	break;
case 'R' :
	if ( bptr->nb_inc==1)
	{ 
		defenseur_trouve=1; 
		// bptr->direction_interrompue=1;  NON
		// pas break puisque trouv
	}
	else { bptr->direction_interrompue=1; goto NEXT_LOOP_1; }
	break;
}

// Dfenseur trouv sur cette direction
// On veut minimiser la valeur de l'defenseur
if ( cptr->piece_value<valeur_defenseur ) 
{ 
	valeur_defenseur=cptr->piece_value; 
	bptr_mem=bptr;
}
break; // sortie de cette direction
} // fin for cette direction
NEXT_LOOP_1:;
} // fin for directions

// MAJ best bilan_joueur
minorant_bilan_adversaire=inf(minorant_bilan_adversaire, bilan_joueur);
// En effet, il n'est pas certain 
// que noir va amliorer le bilan attaque en prenant
// Et par ailleurs, cette valeur ne peut pas tre
// suprieure au majorant_bilan_joueur
// En effet, le best_bilan defense reprsente la meilleure
// opportunit de sortie pour blanc
minorant_bilan_adversaire=sup(minorant_bilan_adversaire, majorant_bilan_joueur);

// Dfenseur trouv ?
if ( defenseur_trouve==0 ) 
{
	// Enregistrer l'opportunit pour blanc
	majorant_bilan_joueur=sup(majorant_bilan_joueur, bilan_joueur);
	majorant_bilan_joueur=inf(majorant_bilan_joueur, minorant_bilan_adversaire);
	break; // Evaluer
}
else
{ 
// Consommation defenseur
bptr_mem->pos+=bptr_mem->inc; bptr_mem->nb_inc++;

// Prise attaquant
bilan_joueur-=valeur_attaquant; // prise de la pice menace

// Sortir si le bilan de l'adversaire n'a pas t amlior
// N'arrive pas car anticip
ASSERT(bilan_joueur <= minorant_bilan_adversaire);
//if ( bilan_joueur > minorant_bilan_adversaire ) 
//{
//	goto EVALUATION;
//}
// Sortir si le bilan du joueur restera
// ngatif mme en cas de consommation de l'defenseur
if ( bilan_joueur+valeur_defenseur < -50 || bilan_joueur<-VALEUR_ROI/2) 
{
	//bilan_joueur+=valeur_defenseur;
	// Attention : ordre blanc noir important
	// Enregistrer l'oppportunit ventuelle pour blanc
	majorant_bilan_joueur=sup(majorant_bilan_joueur, bilan_joueur);
	majorant_bilan_joueur=inf(majorant_bilan_joueur, minorant_bilan_adversaire);
	// Enregistrer l'oppportunit ventuelle pour noir
	minorant_bilan_adversaire=inf(minorant_bilan_adversaire, bilan_joueur);
	minorant_bilan_adversaire=sup(minorant_bilan_adversaire, majorant_bilan_joueur);
	goto EVALUATION;
}
// Sortir si le bilan du joueur reste positif malgr la prise par l'defenseur
// Le attaquant n'a pas besoin de prendre pour rester en gain matriel
// N'arrive pas car anticip
ASSERT(bilan_joueur <= 50);
//if ( bilan_joueur > 50 ) 
//{
//	// Attention : ordre blanc noir important
//	// Enregistrer l'oppportunit ventuelle pour noir
//	minorant_bilan_adversaire=inf(minorant_bilan_adversaire, bilan_joueur);
//	minorant_bilan_adversaire=sup(minorant_bilan_adversaire, majorant_bilan_joueur);
//	// Enregistrer l'oppportunit ventuelle pour blanc
//	majorant_bilan_joueur=sup(majorant_bilan_joueur, bilan_joueur);
//	majorant_bilan_joueur=inf(majorant_bilan_joueur, minorant_bilan_adversaire);
//	goto EVALUATION;
//}


// Recherche attaquant
// (seulement si defenseur trouv )
attaquant_trouve=0;
valeur_attaquant=7500; // 5000 = valeur roi

bptr=&bilan_ad[0];
for (dir=0; dir<=dirmax_attaquant; dir++, bptr++ )
{
if (bptr->direction_interrompue==1) continue;
F_dir_cavalier=bptr->F_dir_cavalier;
for(;;bptr->pos+=bptr->inc,bptr->nb_inc++)
{
if (bptr->nb_inc>bptr->nbinc_max) 
{ bptr->direction_interrompue=1; break; }
cptr=&xboard[bptr->pos];
nature2=cptr->nature;
if ( nature2==0 )
{ 
	if (F_dir_cavalier )
	{ bptr->direction_interrompue=1; break; }
	else continue; // continuer dans la direction
}


// Test d'limination de la pice  jouer
// Non fait car dja fait en analyse de 
// recherche defenseur 
// et la direction aura t close
// Non : car la direction n'a pas forcment t explore
if ( bptr->pos==piece_jouee_pos ) 
{ 
	if (F_dir_cavalier )
	{ bptr->direction_interrompue=1; break; }
	else continue; // continuer dans la direction
}


color2=cptr->color;
if ( color2==-color ) break; // defenseur et non attaquant

if ( F_dir_cavalier )
{
	if ( nature2!='C' )
	{ bptr->direction_interrompue=1; break; }          
}


switch (nature2)
{
case 'C' :
	if (F_dir_cavalier)
	{ 
	    ASSERT(F_existe_possible_cavalier_attaquant);
		attaquant_trouve=1; 
		// bptr->direction_interrompue=1; NON : la pice n'est pas forcment consomme
		// pas break puisque trouv
	} 
	else
	{ bptr->direction_interrompue=1; goto NEXT_LOOP_2;	} 
	break;
case 'P' :
	if (bptr->nb_inc>1) 
	{ bptr->direction_interrompue=1; goto NEXT_LOOP_2; }
	inc=bptr->inc;
	// pion attaquant ( forc )
    if ( inc==COLOR(color,+7) || inc==COLOR(color,-9) )
	{ attaquant_trouve=1; }
	else { bptr->direction_interrompue=1; goto NEXT_LOOP_2; }
	break;
case 'F' :
	inc=bptr->inc;
	if ( inc==-7 || inc==-9 || inc==+7 || inc==+9 )
	{ attaquant_trouve=1; }
	else { bptr->direction_interrompue=1; goto NEXT_LOOP_2; }
	break;
case 'T' :
	inc=bptr->inc;
	if ( inc==-1 || inc==+1 || inc==-8 || inc==+8 )
	{ attaquant_trouve=1; }
	else { bptr->direction_interrompue=1; goto NEXT_LOOP_2; }
    break;
case 'D' :
	attaquant_trouve=1;
	break;
case 'R' :
	if ( bptr->nb_inc==1) 
	{ 
		attaquant_trouve=1;
		// bptr->direction_interrompue=1; NON
		// pas break puisque trouv
	}
	else 
	{ 
		bptr->direction_interrompue=1; 
		goto NEXT_LOOP_2;
	}
		break;
	}

// Attaquant trouv sur cette direction
// On veut minimiser la valeur du attaquant
if ( cptr->piece_value<valeur_attaquant ) 
{ 
	valeur_attaquant=cptr->piece_value; 
	bptr_mem=bptr;
}
break; // sortie de cette direction
} // fin for cette direction
NEXT_LOOP_2:;
} // fin for directions

// MAJ majorant_bilan_joueur
majorant_bilan_joueur=sup(majorant_bilan_joueur, bilan_joueur);
// En effet, il n'est pas certain 
// que blanc va rduire le bilan attaque en prenant
// Et par ailleurs, cette valeur ne peut pas tre
// infrieure au minorant_bilan_adversaire
majorant_bilan_joueur=inf(majorant_bilan_joueur, minorant_bilan_adversaire);

if ( attaquant_trouve==0 ) 
{
	// Enregistrer l'opportunit pour l'defenseur
	minorant_bilan_adversaire=inf(minorant_bilan_adversaire, bilan_joueur);
	minorant_bilan_adversaire=sup(minorant_bilan_adversaire, majorant_bilan_joueur);
	break; // Evaluer
}
else
{
// Consommation attaquant
bptr_mem->pos+=bptr_mem->inc; bptr_mem->nb_inc++;

// Prise defenseur
bilan_joueur+=valeur_defenseur; // prise de la pice menace


// Sortir si le bilan du joueur n'est pas amlior
// N'arrive pas car anticip
ASSERT(bilan_joueur>=majorant_bilan_joueur);
//if ( bilan_joueur < majorant_bilan_joueur ) 
//{
//	goto EVALUATION;
//}
// Sortir si le bilan du joueur reste 
// positif mme en cas de consommation du attaquant
if ( bilan_joueur-valeur_attaquant > 50 || bilan_joueur>VALEUR_ROI/2) 
{
	//bilan_joueur-=valeur_attaquant;
	// Attention : ordre blanc noir important
	// Enregistrer l'oppportunit ventuelle pour noir
	minorant_bilan_adversaire=inf(minorant_bilan_adversaire, bilan_joueur);
	minorant_bilan_adversaire=sup(minorant_bilan_adversaire, majorant_bilan_joueur);
	// Enregistrer l'oppportunit ventuelle pour blanc
	majorant_bilan_joueur=sup(majorant_bilan_joueur, bilan_joueur);
	majorant_bilan_joueur=inf(majorant_bilan_joueur, minorant_bilan_adversaire);
	goto EVALUATION;
}
// Sortir si le bilan du joueur reste trop ngatif
// L'defenseur n'a pas mme besoin de reprendre
// N'arrive pas car anticip
ASSERT(bilan_joueur >= -50);
//if ( bilan_joueur < -50 ) 
//{
//	// Attention : ordre blanc noir important
//	// Enregistrer l'oppportunit ventuelle pour blanc
//	majorant_bilan_joueur=sup(majorant_bilan_joueur, bilan_joueur);
//	majorant_bilan_joueur=inf(majorant_bilan_joueur, minorant_bilan_adversaire);
//	// Enregistrer l'oppportunit ventuelle pour noir
//	minorant_bilan_adversaire=inf(minorant_bilan_adversaire, bilan_joueur);
//	minorant_bilan_adversaire=sup(minorant_bilan_adversaire, majorant_bilan_joueur);
//	goto EVALUATION;
//}

} // fin attaquant trouv
} // fin defenseur trouv


} while(1);  // fin do itrations attaque-dfense


EVALUATION:
ASSERT(majorant_bilan_joueur<=minorant_bilan_adversaire);

// Dtermination du bilan attaque
// on sait que 
// majorant_bilan_joueur<minorant_bilan_adversaire

// Pour xvalueprise_bilan, on retient la valeur la plus optimiste
// pour ne pas perdre d'opportunits
//xvalueprise_bilan=minorant_bilan_adversaire; // il ne faut pas signer le bilan !!!
//valueprise_bilan=minorant_bilan_adversaire;
if (majorant_bilan_joueur<-50) // Suprieur  la diffrence fou-cavalier
{
	#if COLLECT_STATS==1
	xnb_bilan_avant_coup_pm++;
	#endif
	#if ALLOW_EXTEND_ROOK_SACRIFICES==1
	if (xextend)
	{
	if (piece_jouee->nature=='T')
	{
		// Nature de la pice prise
		switch (cptr_depart->nature)
		{
			// Permettre le sacrifice tour contre fou en extend (quiescence)
			// en retournant SEE=0
			case 'C' : 
				return COUP_NEUTRE;
			case 'F' : 
				return COUP_NEUTRE;
		}
	}
	}
 	#endif
	return PERTE_MATERIELLE;
	
}
if (minorant_bilan_adversaire>50) // Suprieur  la diffrence fou-cavalier
{
	#if COLLECT_STATS==1
	xnb_bilan_avant_coup_gm++;
	#endif
	return GAIN_MATERIEL;
}
#if COLLECT_STATS==1
xnb_bilan_avant_coup_cn++;
#endif
// Autres cas
return COUP_NEUTRE;

}  // fin bilan attaque dfense avant coup2
#endif

#if USE_REDUCTIONS==1
void SEARCH::set_allow_reduction()
{
F_allow_reduction=false;
//if (!F_level_impair) return;
if (check) return;
if (xpasse) return;
//if (xpasse && xlevel<xlevel_passe+4) return;
if (finale==ROI_VS_ROI) return;
if (node_type==NODE_PV) return;
//if (localretry) return; quivalent au test sur node_type

//if (previous_search_level->node_type==NODE_PV) return;
//if (node_type==NODE_PV && ((depthtarget>>FD)-xlevel)<=6) return;
//if (xlevel<=3 && (depthtarget>>FD)<=6) return;
/*if (xlevel>=3)
{   
if (previous_search_level->node_type==NODE_PV) return;
	if (xsearch_level[xlevel-2]->node_type==NODE_PV) return;
}
*/

#if USE_SIMPLE_HISTORY_PRUNING==1
//Les coups sont classs en fonction de l'history heuristique
// et de la priorit
// On ne diminue pas la profondeur des 12.5% de meilleurs coups
// On diminue la profondeur de 2 pour les 25% de coups les moins biens classs
if (nb_coups_liste<10) return; // Trop peu de coups
// Le dernier quart de coups
limite_idxmove_simple_pruning_1=
	nb_coups_liste-((nb_coups_liste-nb_coups_forcants)>>2);
	//nb_coups_forcants+((nb_coups_liste-nb_coups_forcants)>>1);
#if USE_LIMITE_IDXMOVE_SIMPLE_PRUNING_2==1
limite_idxmove_simple_pruning_2=
	nb_coups_liste-(((nb_coups_liste-nb_coups_forcants)*3)/4);
ASSERT(limite_idxmove_simple_pruning_2>limite_idxmove_simple_pruning_1);
#endif
//if (xlevel>=((xlv1_depthtarget>>FD)>>1))
{
	idxmove_simple_pruning_reduction_1=SIMPLE_HISTORY_PRUNING_REDUCTION;
	#if USE_LIMITE_IDXMOVE_SIMPLE_PRUNING_2==1
	idxmove_simple_pruning_reduction_2=4;
	#endif
}
/*
else
{
	idxmove_simple_pruning_reduction_1=2;
	#if USE_LIMITE_IDXMOVE_SIMPLE_PRUNING_2==1
	idxmove_simple_pruning_reduction_2=4;
	#endif
}
*/
#endif
#if USE_MINDEPTH==1
if (depth<=xlv1_mindepth) return;
#endif
F_allow_reduction=true;
return;
}
#endif



int uint32_compare(const void * a, const void * b)
{
MOVE moveb, movea;
char dep1, arr1, dep2, arr2;
movea=*((unsigned __int32*)a);
moveb=*((unsigned __int32*)b);
//return ( *((unsigned __int32*)b) - *((unsigned __int32*)a) );
dep1=MOVE_DEP64(movea);
dep2=MOVE_DEP64(moveb);
arr1=MOVE_ARR64(movea);
arr2=MOVE_ARR64(moveb);
if (dep1>dep2) return 1;
if (dep1<dep2) return -1;
if (arr1>arr2) return 1;
else return -1;
}


int listlevel_compare(const void * a, const void * b)
{
    // On passe des pointeurs vers des pointeurs
	// car les objets qu'on dplace sont des pointeurs
	return ( ((LISTLEVEL *)(*(LISTLEVEL **)b))->priority - ((LISTLEVEL *)(*(LISTLEVEL **)a))->priority );
}


#if KING_SAFETY==1
void SEARCH::king_safety(char color01)
{
// Utilise s

// Ide : dnombrer les lignes, colonnes et diagonales ouvertes
// sur le roi
// Critre : 
// ligne ouverte =  3 cases sans pions 
// diagonale ouverte = 2 cases sans pions
char dir;
char position_roi;
char color;
char *inc_ptr;
char *nb_open_lines;
char *nb_open_diagonals;
char *nb_open_columns;
//TYPE_DIRECTION type_direction;
char inc, nb_inc, nbinc_max;
CASE *cptr;
//char F_piece_amie;

// Faut-il caluler la king_safety ?
// Si droits  roquer, pas de prise en compte de la king_safety
if (s->droit_roque[color01]>=1 && s->droit_roque[1]<=3) return;


// Initialiasation
// NON : car si appel par majroque, la position 
// des rois n'a pas encore t actualise dans s
// cette actualisation a lieu dans actualise aprs
// maj_roque. On est donc oblig d'utiliser xnum_roi
//position_roi=s->roi_pos[color01];
position_roi=xw[xnum_roi[color01]].pos;
cptr=&xboard[position_roi];
color=cptr->color;
#if DEBUG==1
if (color==0)
log_error("\nErr _J431");
#endif
nb_open_diagonals=&s->king_open_diagonals[color01];
nb_open_lines=&s->king_open_lines[color01];
nb_open_columns=&s->king_open_columns[color01];
*nb_open_diagonals=0;
*nb_open_lines=0;
*nb_open_columns=0;

inc_ptr=&xinc64[0];
for (dir=0;dir<8;dir++,inc_ptr++)
{
cptr=&xboard[position_roi];
inc=*inc_ptr;
nbinc_max=NBINC_DIRECTION(position_roi,inc);

// Non prise en compte premire et huitime
if (abs(inc)==8)
{
if (color01==1 && cptr->posy==0) continue;
if (color01==0 && cptr->posy==7) continue;
}

for ( cptr+=*inc_ptr, nb_inc=1; 
	     nb_inc<=nbinc_max
	  && nb_inc<=3;
	  cptr+=*inc_ptr, nb_inc++
    )
{
// On s'arrte sur les pions amis seulements
// On ne s'arrte pas sur les pices, car leur couverture est provisoire
if ( cptr->color==color)
{ 
	if (cptr->nature=='P') break;
}
// On explore jusque 3 cases avant de tirer une conclusion
if (nb_inc<3) continue;
// nb_inc==3 : si maintenant on n'est pas sorti, ce n'est pas normal
// la direction est ouverte
switch(abs(inc))
{
case 1 :  (*nb_open_columns)++;
	break;
case 10 : (*nb_open_lines)++; 
	break;
default : (*nb_open_diagonals)++;
	break;
}
break;
} // fin for cette direction
} // fin for directions

} // fin king_safety 
#endif


bool MOVE_IS_OK_128(char dep64,char inc128)
{
	signed char arr128;
	arr128=TO128_FROM64(dep64)+inc128;
	ASSERT(arr128>=0 || (arr128<0 && (arr128 & 0x88)!=0));
	//if (arr128<0) return false;
    return !(arr128 & 0x88);
}


bool MOVE_IS_OK_KNIGHT(char dep,char arr)
{
char delta_x, delta_y;
if ( arr<0 || arr>63 ) return false;
delta_x=X64(arr)-X64(dep);
delta_y=Y64(arr)-Y64(dep);
return (abs(delta_x)+abs(delta_y)==3);
}



#if DEBUG==1
bool MOVE_IS_OK_ASSERT(char dep,char arr,char inc, bool F_cavalier)
{
char delta_x, delta_y;
if ( arr<0 || arr>63 ) return false;
delta_x=X64(arr)-X64(dep);
delta_y=Y64(arr)-Y64(dep);
switch(F_cavalier)
{
case true : return (abs(delta_x)+abs(delta_y)==3);
default : 
	if (abs(inc)==7)
	{ 
		if (delta_x==0 ) return false; // limine le cas 0=>7
		if (delta_y==0 ) return false; // limine le cas 0=>63 par incrments de 7
	}
	if (abs(inc)==1 && delta_x!=0) return false; // limine le cas 0=>8
	// Autres coups
	return (delta_x==0 || delta_y==0 || abs(delta_x)==abs(delta_y) );
}
}
#endif

/*
bool KNIGHT_MOVE_DEP_ARR_COMPATIBILITY(char dep,char arr)
{
//char delta_x;
char delta_y;
// Le contrles ne concernent que la compatibilit dep arr
// Exemple 7+17==24 => 8->41
// Le dbordement en hauteur se traduit par delta y trop important
// Remarque : ce contrle n'est pas suffisant pour vrifier qu'il s'agit bien d'un coup possible de cavalier
// il manque le contrle 0-63 et le contrle d'incrment

// Contrle de dbordement en hauteur
// Le seul  raliser si les deux cases dep et arr sont sur l'chiquier
delta_y=abs(Y64(arr)-Y64(dep));
return (delta_y<=2);

// Ancienne version
//delta_x=X64(arr)-X64(dep);
//delta_y=Y64(arr)-Y64(dep);
//return (abs(delta_x)+abs(delta_y)==3);
}
*/

/*
void search_listmoves2_resort(LISTLEVEL *(*listmoves2)[LENGTH_SEARCHLISTMOVES+1], char nb_coups_listmoves2)
{
LISTLEVEL *xliste_level_temp[LENGTH_SEARCHLISTMOVES+1]; // level 1
char idxmove, idxmove_temp, idxmove3, nb_classified;
char rang_insertion;
LISTLEVEL **ptr, **ptr2, **ptr3;

// En pratique, nb_classified est gal  idxmove;
nb_classified=0;

for (idxmove=0, ptr=&(*listmoves2)[0]; 
	 idxmove<nb_coups_listmoves2; idxmove++, nb_classified++, ptr++)
{
for (idxmove_temp=0, ptr2=&xliste_level_temp[0];;idxmove_temp++, ptr2++)
{
	// Insertion en fin de liste 
	if (idxmove_temp>nb_classified-1)
	{
		//xliste_level_temp[idxmove_temp]=(*listmoves2)[idxmove];
		*ptr2=*ptr;
		break;
	}
	// Tri sur le wasbest : conserver l'ordre
	//if ( xliste_level_temp[idxmove_temp]->wasbest==true )
	if ( (*ptr2)->wasbest==true )
	{	
		//if ((*listmoves2)[idxmove]->wasbest==false) continue;
		if ((*ptr)->wasbest==false) continue;
		// Tri sur le score
		// A score gal, plac aprs ce qui conserve l'ordre
		//if (   (*listmoves2)[idxmove]->score<=xliste_level_temp[idxmove_temp]->score )
		if (   (*ptr)->score<=(*ptr2)->score )
		continue;
	}
	else  // (*ptr2)->wasbest==false 
	{
	if ((*ptr)->wasbest==true) goto CLASSIFY;
	// A categorie gale
	  if (   (*ptr)->categorie>(*ptr2)->categorie 
		  || (*ptr)->score<(*ptr2)->score-200
		)
		continue;
	else
	// A score gal, plac aprs ce qui conserve l'ordre
	if ((*ptr)->history<=(*ptr2)->history) continue;  
	else
	{
		// if ((*ptr)->history>(*ptr2)->history) 
		goto CLASSIFY;
	}
	// Egalit
	// if ((*ptr)->priority>(*ptr2)->priority ) goto CLASSIFY;
	continue;
	}
	CLASSIFY:
	rang_insertion=idxmove_temp;
	// Libration rang insertion et dcalage des entres suivantes
	for (idxmove3=nb_classified-1, ptr3=&xliste_level_temp[idxmove3];
		 idxmove3>=rang_insertion; idxmove3--, ptr3--)
	{
		//xliste_level_temp[idxmove3+1]=xliste_level_temp[idxmove3];
		*(ptr3+1)=*ptr3;
	}
	// Insertion 
	//xliste_level_temp[rang_insertion]=(*listmoves2)[idxmove];
	*ptr2=*ptr;
	break;
}
}


// Recopie de la temp_liste
// a priori memcpy doit aller plus vite 
//memcpy(&(*listmoves2)[0],&xliste_level_temp[0],nb_coups_listmoves2*sizeof(LISTLEVEL *));
memcpy(listmoves2,&xliste_level_temp[0],nb_coups_listmoves2*sizeof(LISTLEVEL *));


// Recopie de la temp_liste
//for (idxmove=0, ptr=&(*listmoves2)[0], ptr2=&xliste_level_temp[0]; 
//	 idxmove<nb_coups_listmoves2; idxmove++)
//{
//	(*ptr++)=(*ptr2++);
//}

} // fin listmoves2_resort
*/








void SEARCH::search_listmoves2_create(
					   bool F_reset_priority,
					   bool F_reset_Fplay,
					   bool F_reset_fail_lows,
					   bool F_reset_hash
					   )
{
char idxmove, idxmove2, idxmove3, nb_classified;
char rang_insertion;
LISTLEVEL *ptr, **ptr2, **ptr3;
MOVE move;
char dep, arr;
char type;
LISTLEVEL **start_listmoves2;
long li1;

// En pratique, nb_classified est gal  idxmove; 
nb_classified=0;
start_listmoves2=&listmoves2[0];
#if USE_QSORT==1
ptr2=start_listmoves2;
#endif


for (idxmove=0, ptr=&listmoves[0]; 
	 idxmove<nb_coups_liste; idxmove++, nb_classified++, ptr++)
{
if (F_reset_priority)
{


if (   ptr->priority>=HistoryScore
	&& ptr->priority<MaxHistoryScore)
{
	
	// Safety analysis
	// Attribution BadScore pour les coups diffrents des prises
	// Les prises sont mises CaptureScore en Search
	// Calcul priority
	do
	{

		move=ptr->move;
		arr=MOVE_ARR64(move);
		dep=MOVE_DEP64(move);
        
		/*
		#if USE_CASES_ACTUALISATION==1
		if (!F_bilan_coup_effectue && !MOVE_IS_CAPTURE(move))
		{
		if (bit(cases_controlees_adversaire,arr)!=0)
		{
			cc=0;
			switch(MOVE_NATURE(move))
			{
			case 'C' : cc=bit(cases_controlees_pion_adversaire,arr);
					   break; 
			case 'F' : cc=bit(cases_controlees_pion_adversaire,arr);
					   break;
			case 'T' : cc=bit(cases_controlees_fou_adversaire,arr);
					   break;
			case 'D' : cc=bit(cases_controlees_tour_adversaire,arr);
					   break;                   
			default : break;
			}
			
			if (cc==1)
			{
				ptr->priority=BadScore;
				break;
			}

			// coteux .... et donc limit aux NODE_PV
			//if (node_type==NODE_PV)
			{
				bilan_coup=bilan_attaque_defense_avant_coup_simplifie(move);
				if (bilan_coup==MATERIAL_LOSS)
				{
					ptr->priority=BadScore;
					break;
				}
			}
		}
		} // fin Case controle par l'adversaire
		#endif
        */

		// Pions passs
		if (s->finale>=FIN_DE_PARTIE_1)
		{
		if (MOVE_IS_PAWN(move))
		{
			if (EST_PION_PASSE(wtm,arr,s))
			{
				ptr->priority=HeuristicScore;
				break;
			}
		}
		}
	

		// Calcul priority
		type=ptr->type;
		#if USE_REDUCTIONS==1
		#if USE_FRUIT_PRUNING==1
		ASSERT(type>=0 && type<=11 && arr>=0 && arr<=63);
		li1=(xhistory_move_good_move[type][arr]*100)/
			 (xhistory_move_attempts[type][arr]);
		ptr->hit_ratio=li1;
		if (li1>0)
		{
			ASSERT(li1<=100);
			ptr->priority=HeuristicScore+min(li1,100);
		}
 	 	else
		#endif
		#endif
		{
			ASSERT(type>=0 && type<=11 && arr>=0 && arr<=63 && dep>=0 && dep<=63);

			ptr->priority=
			  HistoryScore
		 	      + 200
				  #if USE_OLDSTYLE_HISTORY==1
				  + xhistory_heuristique[type][arr]
				  #endif
				  + xpriority[type][dep][arr];
			ASSERT(abs(xpriority[ptr->type][dep][arr])<200);
		}


	break;
	} while(1); // fin do
	
}
}


if (F_reset_Fplay)
{
	ptr->Fplay=0;
	if (F_reset_fail_lows)
	{
		#if RESET_HASH_ON_RETRY==1
		ptr->hash=HASH_NON_DETERMINE;
		#endif
		if (ptr->hscore_status==FAIL_LOW)
			ptr->hash=HASH_NON_DETERMINE;
	}
}
if (F_reset_hash)
{
	ptr->hash=HASH_NON_DETERMINE;
}


// Insertion dans la lismoves2 qui est une liste de pointeurs sur des LISTLEVEL
#if USE_QSORT==0
for (idxmove2=0, ptr2=start_listmoves2;;idxmove2++, ptr2++)
{
	// Insertion en fin de liste 
	if (idxmove2>nb_classified-1)
	{
		*ptr2=ptr;
		break;
	}
	if (ptr->priority<=(*ptr2)->priority) continue;
	rang_insertion=idxmove2;
	// Libration rang insertion et dcalage des entres suivantes
	for (idxmove3=nb_classified-1, ptr3=&listmoves2[idxmove3];
		 idxmove3>=rang_insertion; idxmove3--, ptr3--)
	{
		*(ptr3+1)=*ptr3;
	}
	// Insertion 
	*ptr2=ptr;
	break;
}
#endif
#if USE_QSORT==1
// Recopie des pointeurs dans la listmoves2
*(ptr2++)=ptr;
#endif
} // Fin for

#if USE_QSORT==1
qsort(&listmoves2[0],nb_coups_liste,sizeof(LISTLEVEL *),listlevel_compare);
#endif


// Liste cre et fin de liste
F_listmoves2_created=true; 
if (F_reset_priority) F_bilan_coup_effectue=true;
listmoves2[nb_coups_liste]=NULL;
} // fin listmoves2_create




void SEARCH::search_complete_liste_autres_coups()
{
PIECE* numptr;
char num;
LISTLEVEL *listmovesptr;
MOVE *moveptr;
MOVE move;
char cc;
char dep,arr; 


//cases_pieces_clouees_wtm=s->cases_pieces_clouees[xwtm];
listmovesptr=&listmoves[nb_coups_liste-1];
phase_generation=AUTRES_COUPS;


for (numptr=&xw[debut_blanc],num=debut_blanc;num<=fin_blanc;numptr++,num++)
{
if (numptr->nature==0) continue;
#if USE_CASES_ACTUALISATION==1
if (check!=0 || bit(pieces_with_possible_illegal_moves,num))
{
	F_piece_with_possibly_illegal_moves=true;
}
else
{
	F_piece_with_possibly_illegal_moves=false;
}
#endif
moveptr=numptr->psptr->moves;
//move_nature=numptr->nature;
for(;;moveptr++)
{
move=*moveptr;
if (move==0) break;

// Elimination du hint_move si dja jou
if (F_hint_move_has_been_played)
{
if (SAME_MOVE(move,hint_move))
{
	continue;
}
}

// Arr
dep=MOVE_DEP64(move);
arr=MOVE_ARR64(move);

// Attention : le test suivant ne suffit pas  exclure la prise 
// en passant (qui n'arrive pas sur une case de couverture, mais peut 
// tre une rponse valable  un chec
// Mais ici, on n'a pas les prises en passant
//if (!est_case_couverture_64(cases_couverture_echecs,arr) && num!=num_roi )
//	continue;
// Vrifier l'absence de clouage

#if USE_CASES_ACTUALISATION==1
if (F_piece_with_possibly_illegal_moves)
#endif
{
cc=legal(num,move,num_roi,*lignemoins);
if (cc!=1) // coup illgal
{
	continue;
}
}
#if DEBUG==1
else
{
ASSERT(legal(num,move,num_roi,*lignemoins)==1);
}
#endif

nb_coups_liste++;
++listmovesptr;
*listmovesptr=xempty_listlevel_entry;
listmovesptr->move=move;
listmovesptr->num=num;
listmovesptr->type=numptr->type;

#if _DEBUG==1
short int si1;
si1=MOVE_NUM_PIECE(move);
listmovesptr->dep88=MOVE_DEP88(move);
listmovesptr->arr88=MOVE_ARR88(move);
//listmovesptr->index=idxmove;
#endif
}
}

// Marquage de fin de liste
(listmovesptr+1)->move=0; 

} // fin search_complete_liste_autres_coups




void SEARCH::extend_cree_liste_autres_coups()
{
PIECE* numptr;
char num;
// LISTLEVEL2 *listmovesptr;
MOVE *moveptr;
MOVE move;
char cc;
char move_nature;
char arr; 

phase_generation=AUTRES_COUPS;

// N'est utilise qu'en prsence d'checs
ASSERT(check);

for (numptr=&xw[debut_blanc],num=debut_blanc;num<=fin_blanc;numptr++,num++)
{
if (numptr->nature==0) continue;
move_nature=numptr->nature;
moveptr=numptr->psptr->moves;
for(;;moveptr++)
{
move=*moveptr;
if (move==0) break;

// Elimination du hint_move si dja jou
if (hint_move)
{
if (SAME_MOVE(move,hint_move))
{
	continue;
}
}

// Arr
arr=MOVE_ARR64(move);

// Anticipation contrle de lgalit
{
// Attention : le test suivant ne suffit pas  exclure la prise 
// en passant (qui n'arrive pas sur une case de couverture, mais peut 
// tre une rponse valable  un chec
// Mais ici, on n'a pas les prises en passant
	if (num!=num_roi)
	{ 
		if (!est_case_couverture_64(cases_couverture_echecs,arr))
		{
			continue;
		}
	}
	// Vrifier l'absence de clouage
	cc=legal(num,move,num_roi,*lignemoins);
	if (cc!=1) // coup illgal
	{
	continue;
	}
}


nb_coups_liste++;
autres_coups[nb_autres_coups++]=move;
//++listmovesptr;
//*(++listmovesptr)=xempty_listlevel2_entry;
//listmovesptr->move=move;
//listmovesptr->move_nature=move_nature;
//listmovesptr->legal=legality;
//listmovesptr->num=num;
//listmovesptr->categorie=(char) MOVE_CATEGORY(move);
//listmovesptr->capture_value=0;
//listmovesptr->Fplay=0;
//listmovesptr->bilan_coup=BILAN_NON_CALCULE;
//listmovesptr->hash=HASH_NON_DETERMINE;
//listmovesptr->draw_status=DRAW_STATUS_NOT_DETERMINED;


}
}

// Marquage de fin de liste
autres_coups[nb_autres_coups]=0;
//(listmovesptr+1)->move=0; 

} // fin extend_complete_liste_autres_coups




void SEARCH::search_cree_liste_prises(void)
{
PIECE* numptr;
char num;
LISTLEVEL *listmovesptr;
MOVE *moveptr;
MOVE move;
char cc;
char move_nature;
char arr;

listmovesptr=&listmoves[nb_coups_liste-1];
phase_generation=PRISES;

for (numptr=&xw[debut_blanc],num=debut_blanc;num<=fin_blanc;numptr++,num++)
{
if (numptr->nature==0) continue;
if (numptr->psptr->mobility_prises==0) continue;
#if USE_CASES_ACTUALISATION==1
if (bit(pieces_with_possible_illegal_moves,num))
{
	F_piece_with_possibly_illegal_moves=true;
}
else
{
	F_piece_with_possibly_illegal_moves=false;
}
#endif
moveptr=numptr->psptr->moves2; // prises
for(;;moveptr++)
{
move=*moveptr;
if (move==0) break;

// Elimination du hint_move si dja jou
if (F_hint_move_has_been_played)
{
if (SAME_MOVE(move,hint_move))
{
	continue;
}
}


// Vrification immdiate de la lgalit si chec
// ou coup spcial ou coup de roi (pour givecheck)
// et limination du coup

move_nature=MOVE_NATURE(move);
arr=MOVE_ARR64(move);


// Lgalit
#if USE_CASES_ACTUALISATION==1
if (F_piece_with_possibly_illegal_moves)
#endif
{
cc=legal(num,move,num_roi,*lignemoins);
	if (cc!=1) // coup illgal
	{
	continue;
	}
}
#if DEBUG==1
{
ASSERT(legal(num,move,num_roi,*lignemoins)==1);
}
#endif

nb_coups_liste++;
++listmovesptr;
*listmovesptr=xempty_listlevel_entry;
listmovesptr->move=move;
//listmovesptr->move_nature=move_nature;
//listmovesptr->legal=legality;
listmovesptr->num=num;
//listmovesptr->categorie=(char) MOVE_CATEGORY(move);
//listmovesptr->capture_value=MOVE_CAPTURE_VALUE(move);


#if _DEBUG==1
short int si1;
si1=MOVE_NUM_PIECE(move);
listmovesptr->dep88=MOVE_DEP88(move);
listmovesptr->arr88=MOVE_ARR88(move);
//listmovesptr->index=idxmove;
#endif
}
}

// Marquage de fin de liste
(listmovesptr+1)->move=0; 

} // fin complete_liste_prises




void SEARCH::extend_cree_liste_prises()
{
PIECE* numptr;
char num;
//LISTLEVEL2 *listmovesptr;
MOVE *moveptr;
MOVE move;
char cc;
//LEGALITY legality;
char move_nature;

ASSERT(check!=0);

//listmovesptr=&xliste_level2[xlevel][nb_coups_liste-1];
phase_generation=AUTRES_COUPS;
for (numptr=&xw[debut_blanc],num=debut_blanc;num<=fin_blanc;numptr++,num++)
{
if (numptr->nature==0) continue;
if (numptr->psptr->mobility_prises==0) continue;

moveptr=numptr->psptr->moves2; // prises
for(;;moveptr++)
{
move=*moveptr;
if (move==0) break;

// Elimination du hint_move si dja jou
if (hint_move)
{
if (SAME_MOVE(move,hint_move))
{
	continue;
}
}


// Vrification immdiate de la lgalit si chec
// ou coup spcial ou coup de roi (pour givecheck)
// et limination du coup

move_nature=MOVE_NATURE(move);
// Lgalit
cc=legal(num,move,num_roi,*lignemoins);
if (cc!=1) // coup illgal
{
	continue;
}


nb_coups_liste++;
switch(MOVE_CATEGORY(move))
{
case COUP_FORCANT :
	prises[nb_prises++]=move;
	break;
case PROMOTION :
	prises[nb_prises++]=move;
	break;
case ECHANGE_PIECE :
	echanges_piece[nb_echanges_piece++]=move;
	break;
case ECHANGE_PION :
	echanges_pion[nb_echanges_pion++]=move;
	break;
case PRISE_PIECE_INFERIEURE :
	prises_piece_inferieure[nb_prises_piece_inferieure++]=move;
	break;
case PRISE_PION_PAR_PIECE :
	prises_pion[nb_prises_pion++]=move;
	break;
 default :
    ASSERT(false);
	break;
}

}
}

// Marquage de fin de liste (inutile)
prises[nb_prises]=0;
//(listmovesptr+1)->move=0; 

} // fin complete_liste_prises





