#include "stdafx.h"
#include "Cchess_1.h"
#include "Cchess_2.h"
//#include "Cchess_3.h"
#include "Cchess_4.h"
#include "Cchess_5.h"
#include "Cchess_6.h"
 


void SEARCH::search_initialize_move_generator()
{
char dep, arr;
char cc,dd;
MOVE move;

#if USE_REDUCTIONS==1
F_allow_reduction=false;
#endif
F_hint_move_has_been_played=false;
nb_coups_liste=0;
F_creation_liste=false;
F_utilisation_liste=false;
nb_attaques_pion=0;
idxmove=-1;
#if USE_CASES_ACTUALISATION==1
F_piece_with_possibly_illegal_moves=true;
#endif

// Contrle de lgalit du hint_move
// et insertion dans liste hint_move
if (hint_move!=0) 
{
if (MOVE_IS_FOR_PLAY(hint_move))
{
dd=0;
do
{
	dep=MOVE_DEP64(hint_move);
	arr=MOVE_ARR64(hint_move);
	num=xboard[dep].num_piece;
	if (num<debut_blanc || num>fin_blanc)
	{
		#if DEBUG==1
		{

			log_error("SM_814", xcompteur);
		}
		#endif
		break;
      }
	numptr=&xw[num];
	if (numptr->nature==0) break;
	if (MOVE_IS_CAPTURE(hint_move) || MOVE_PROMOTION(hint_move)=='D')
	{
		moveptr=numptr->psptr->moves2;
	}
	else
	{
		moveptr=numptr->psptr->moves;
	}
	for(;;moveptr++)
	{
		move=*moveptr;
		if (move==0) break;
		
		if (SAME_MOVE(move,hint_move))
		{
			// Contrle lgalit
			#if USE_CASES_ACTUALISATION==1
			if (bit(pieces_with_possible_illegal_moves,numptr->num_piece))
			#endif
			{
				cc=SEARCH::legal(num,move,num_roi,*lignemoins);
				if (cc!=1) break;
			}

			dd=1; // hint_move est lgal : IMPORTANT
			nb_coups_liste=1;
			listmovesptr=&listmoves[0];
			*listmovesptr=xempty_listlevel_entry;
			listmovesptr->move=move; // pas hint_move qui peut-tre uen capture
			(listmovesptr+1)->move=0;
			#if _DEBUG==1
			listmovesptr->dep88=MOVE_DEP88(move);
			listmovesptr->arr88=MOVE_ARR88(move);
			#endif
			listmovesptr->num=num;
			listmovesptr->type=numptr->type;
			//listmovesptr->legal=LEGAL;
			//F_hint_move_has_been_played=true; // si : pour la cration de liste 
			//*listmovesptr=move;
			//listmovesptr->move_nature=MOVE_NATURE(move);
			//listmovesptr->categorie=(char) MOVE_CATEGORY(move);
			//listmovesptr->capture_value=MOVE_CAPTURE_VALUE(move);
			//listmovesptr->Fplay=0;
			//listmovesptr->bilan_coup=BILAN_NON_CALCULE;
			//listmovesptr->hash=HASH_NON_DETERMINE;
			//listmovesptr->draw_status=DRAW_STATUS_NOT_DETERMINED;
			//F_nouvelle_piece=true; // ?? pas si utilisation liste
			F_utilisation_liste=true;
			ASSERT(!F_listmoves2_created);
			listmovesptr=&listmoves[0]-1;
			break;
		}
	} 
	break;
} while(1);
// Annulation du hint_move si illgal
if (dd==0) 
{
	hint_move=0;
}
}
} // fin hint_move!=0


// Attention : le hint_move peut avoir t annul
if (hint_move!=0) 
{
		phase_generation=PRISES;
		analysis=SEARCH_ANALYSE_HINT_MOVE;
	    #if COLLECT_STATS==1
		   origine_coups_analysis=OR_SEARCH_ANALYSE_HINT_MOVE;
		#endif
}
else 
{
		phase_generation=PRISES;
		listmovesptr=&listmoves[0]-1;
		listmoves[0].move=0;
		numptr=&xw[debut_blanc]; num=debut_blanc;
		while(num<=fin_blanc)
		{
			if (numptr->nature!=0 && numptr->psptr->mobility_prises!=0)
			{ break; }
			numptr++; num++;
		}
		// Si pas de prises sortir en crant une liste de prises vides
		if (num>fin_blanc) 
		{
			phase_generation=AUTRES_COUPS;
			numptr=&xw[debut_blanc]; num=debut_blanc;
			while(num<=fin_blanc)
			{
				if (numptr->nature!=0 && numptr->psptr->mobility_others!=0)
				{ break; }
				numptr++; num++;
			}
			if (check==0)
			{ analysis=SEARCH_ANALYSE_COUPS_HEURISTIQUES; }
			else
			{ analysis=SEARCH_ANALYSE_AUTRES_COUPS; }


		    #if COLLECT_STATS==1
			 origine_coups_analysis=OR_SEARCH_ANALYSE_COUPS_HEURISTIQUES;
			#endif
			F_nouvelle_piece=true; 
			#if USE_CASES_ACTUALISATION==1
			F_piece_with_possibly_illegal_moves=bit(pieces_with_possible_illegal_moves,num);
			#endif
			moveptr=numptr->psptr->moves; // 
			goto RETURN;
		}
		analysis=SEARCH_ANALYSE_COUPS_FAVORABLES;
	    #if COLLECT_STATS==1
		    origine_coups_analysis=OR_SEARCH_ANALYSE_COUPS_FAVORABLES;
		#endif
		F_nouvelle_piece=true; 
		#if USE_CASES_ACTUALISATION==1
		F_piece_with_possibly_illegal_moves=bit(pieces_with_possible_illegal_moves,num);
		#endif
		moveptr=numptr->psptr->moves2; // prises
		goto RETURN;
}


RETURN:
return;
} // fin initialize



// le SEARCH::get_move renvoie en fait le couple move+listmovesptr 
MOVE SEARCH::search_get_move(void)
{
char cc;
char bilan_coup;
char cat;
char i;
MOVE move,move2;
char dep, arr;
//char nature;
// MOVE* killermove_ptr;
//short capture_value;
//short valeur_prise;

//NEXT_MOVE:
// F_creation_liste
if (F_utilisation_liste)
{
	if (F_listmoves2_created || analysis==SEARCH_ANALYSE_ATTAQUES_PION)
	{
		NEXT_MOVE_LISTMOVES2:
		do {
		listmovesptr=*(++listmoves2ptr); 
		if (listmovesptr==NULL) return 0;
		idxmove++;
		}
		while(listmovesptr->Fplay!=0); 
		return listmovesptr->move;
		// pas de test sur Fplay
	}
	else 
	{
		NEXT_MOVE_LISTMOVES:
		ASSERT(!F_listmoves2_created);
		do {
			move=(++listmovesptr)->move; 

			if (move==0)
			{
				goto CHANGEMENT_ANALYSIS;
			}
			idxmove++;
		}
		while (listmovesptr->Fplay!=0);
		// NON : return move; le coup doit tre filtr
	}
}
else 
{
NEXT_MOVE_NO_LISTE:
// !F_utilisation_liste
if (F_nouvelle_piece)
{
	F_nouvelle_piece=false;
	move=*moveptr;
	ASSERT(move!=0);
}
else // !F_nouvelle_piece
{
	move=*(++moveptr);
	if (move==0)
	{
			switch(phase_generation)
			{
			case PRISES : 
				numptr++; num++;
				while(num<=fin_blanc)
				{
					if (numptr->nature!=0 && numptr->psptr->mobility_prises!=0)
					{ break; }
					numptr++; num++;
				}
				if (num>fin_blanc) 
				{ goto CHANGEMENT_ANALYSIS; }
				moveptr=numptr->psptr->moves2; 
				F_nouvelle_piece=true; 
				#if USE_CASES_ACTUALISATION==1
				F_piece_with_possibly_illegal_moves=bit(pieces_with_possible_illegal_moves,num);
				#endif
				goto NEXT_MOVE_NO_LISTE;
				break;
			case AUTRES_COUPS :
				numptr++; num++;
				while(num<=fin_blanc)
				{
					if (numptr->nature!=0 && numptr->psptr->mobility_others!=0)
					{ break; }
					numptr++; num++;
				}
				if (num>fin_blanc) 
				{ goto CHANGEMENT_ANALYSIS; }
				moveptr=numptr->psptr->moves; 
				F_nouvelle_piece=true; 
				#if USE_CASES_ACTUALISATION==1
				F_piece_with_possibly_illegal_moves=bit(pieces_with_possible_illegal_moves,num);
				#endif
				goto NEXT_MOVE_NO_LISTE;
				break;
			}
			// Seulement par goto
			CHANGEMENT_ANALYSIS:
			switch(analysis)
			{
				case SEARCH_ANALYSE_HINT_MOVE :
						  F_hint_move_has_been_played=true;
						  #if COLLECT_STATS==1
						  origine_coups_analysis=OR_SEARCH_ANALYSE_COUPS_FAVORABLES;
						  #endif
						  analysis=SEARCH_ANALYSE_COUPS_FAVORABLES;
						  phase_generation=PRISES;
			 			  numptr=&xw[debut_blanc]; num=debut_blanc;
		  				  while(num<=fin_blanc)
						  {
							if (numptr->nature!=0 && numptr->psptr->mobility_prises!=0)
							{ break; }
							numptr++; num++;
						  }
						  // Si pas d'autres coups, sortir
						  if (num>fin_blanc) 
						  {
							  F_pas_de_prises=true;
							  goto SEARCH_KILLERMOVES;
						  }		
						  F_utilisation_liste=false;
						  F_nouvelle_piece=true; 
						  #if USE_CASES_ACTUALISATION==1
						  F_piece_with_possibly_illegal_moves=bit(pieces_with_possible_illegal_moves,num);
						  #endif
						  idxmove=-1;
						  moveptr=numptr->psptr->moves2;
						  listmovesptr=&listmoves[nb_coups_liste]-1; // aprs le hint_move
						  goto NEXT_MOVE_NO_LISTE; // pour contrle de lgalit
				break;




				case SEARCH_ANALYSE_COUPS_FAVORABLES : 
 
				      // Cloture provisoire de liste
					  listmoves[nb_coups_liste].move=0;

					   ASSERT(F_allow_reduction==false);

						  analysis=SEARCH_ANALYSE_PRISES;
						  #if COLLECT_STATS==1
						  origine_coups_analysis=OR_SEARCH_ANALYSE_PRISES;
						  #endif


							#if USE_SEARCH_UNDEFENDED_PIECES==1
							// Inventaire des pices non dfendues
							if (!F_inventaire_pieces_non_defendues)
							{
							#if USE_SEARCH_ALL_UNDEFENDED_PIECES==1
							inventaire_pieces_non_defendues(
								//s,a,b,pieces_non_defendues,F_piece_non_defendue,
								//nb_pieces_non_defendues, nb_pions_non_defendus,
								//max_valeur_pieces_non_defendues,
								//max_valueprise_bilan,
								//case_cible_heuristique_protection
								);
							#else
							inventaire_pieces_non_defendues();
							#endif
							}
							#endif




					F_utilisation_liste=true;
					idxmove=-1;
					listmovesptr=&listmoves[0]-1;
					goto NEXT_MOVE_LISTMOVES;


				  break;


						  
				case SEARCH_ANALYSE_PRISES :



					SEARCH_KILLERMOVES:

					#if USE_SIMPLE_HISTORY_PRUNING==1
					nb_coups_forcants=nb_coups_liste;
					#endif


					  analysis=SEARCH_ANALYSE_KILLERMOVES;
				      #if COLLECT_STATS==1
				       origine_coups_analysis=OR_SEARCH_ANALYSE_KILLERMOVES;
					  #endif

					  F_utilisation_liste=true;
					  for (i=0;i<NOMBRE_KILLERMOVES;i++)
					  {
						  listlevel_killermoves[i]=xempty_listlevel_entry;
						  listlevel_killermoves[i].Fplay=0;
						  listlevel_killermoves[i].move=killermoves[i];
					  }
					  // Clture liste listlevel_killermoves
					  listlevel_killermoves[NOMBRE_KILLERMOVES].move=0;
					  listmovesptr=&listlevel_killermoves[0]-1;
					  idxmove=-1;
					  goto NEXT_MOVE_LISTMOVES;


				case SEARCH_ANALYSE_KILLERMOVES:


					// La recherche des coups heuristiques permet 
					// de crer la listmoves et donc la listmoves2 est d'ordonner les coups
					// par priorit, ce qui est intressant
					// si on compte appliquer depthmoves-2 derrire

					if (check==0
						#if SEARCH_ANALYSE_COUPS_HEURISTIQUES_ONLY_ON_DEPTHTARGET==1
						&&
						F_depthtarget_level_reached						
						#endif
						)
					{
						  analysis=SEARCH_ANALYSE_COUPS_HEURISTIQUES;
						  #if COLLECT_STATS==1
						  origine_coups_analysis=OR_SEARCH_ANALYSE_COUPS_HEURISTIQUES;
						  #endif

						#if USE_CASES_ATTAQUE_PION==1
						if (F_depthtarget_level_reached)
						{
						if (wtm==0)
						{
						cases_attaque_pion=
							(s->cases_pieces[1]<<9) // attention sens dcalage
							|
							(s->cases_pieces[1]>>7); // attention sens dcalage
						}
						else
						{
						cases_attaque_pion=
							(s->cases_pieces[0]<<7) // attention sens dcalage
							|
							(s->cases_pieces[0]>>9); // attention sens dcalage
						}	
						}
						else
						{
						if (wtm==0)
						{
						cases_attaque_pion=
							(s->cases_pieces[1]<<9) // attention sens dcalage
							|
							(s->cases_pieces[1]>>7); // attention sens dcalage
						}
						else
						{
						cases_attaque_pion=
							(s->cases_pieces[0]<<7) // attention sens dcalage
							|
							(s->cases_pieces[0]>>9); // attention sens dcalage
						}	
	
						}
						#endif


						  phase_generation=AUTRES_COUPS;
						  numptr=&xw[debut_blanc]; num=debut_blanc;
		  				  while(num<=fin_blanc)
						  {
							if (numptr->nature!=0 && numptr->psptr->mobility_others!=0)
							{ break; }
							numptr++; num++;
						  }				  // Si pas d'autres coups, sortir
						  if (num>fin_blanc) { goto CHANGEMENT_ANALYSIS; }
						  // Pour compltion par la suite des autres coups
						  moveptr=numptr->psptr->moves;
						  // Remarque : si on sort d'analyse des coups favorables
						  // listmovesptr pointe sur la premire entre nulle
						  // nb_coups_liste==listmovesptr-&listmoves[0]
						  // Si pas de prises, listmovesptr

						  //listmovesptr=&listmoves[nb_coups_liste];
					

						  listmovesptr=&listmoves[nb_coups_liste]-1;
						  idxmove=nb_coups_liste-1;
						  F_utilisation_liste=false;
						  F_nouvelle_piece=true; 
						  #if USE_CASES_ACTUALISATION==1
						  F_piece_with_possibly_illegal_moves=bit(pieces_with_possible_illegal_moves,num);
						  #endif
						  goto NEXT_MOVE_NO_LISTE;
					}
					else // !F_depthtarget_level
					{
							#if USE_SIMPLE_HISTORY_PRUNING==1
							// La liste n'est pas cre et le nombre n'est pas connu
							limite_idxmove_simple_pruning_1=nb_coups_forcants+5;
							#if USE_LIMITE_IDXMOVE_SIMPLE_PRUNING_2==1
							//limite_idxmove_simple_pruning_2=nb_coups_forcants+10;
							limite_idxmove_simple_pruning_2=CHAR_MAX;
							#endif
							#endif

							#if ALLOW_FUTILITY_4==1
							if (
								#if FUTILITY_4_ONLY_LASTDEPTH==1
								 xF_derniere_profondeur_en_cours
								&&
								#endif
								(
								 F_depthtarget_level_reached
								  #if ALLOW_FUTILITY_4_EXTENSION_1==1
								   || (xlevel>=depthtarget_level-1
									  && valpos+600<sup_alpha_value
 									  //&& alpha<MATE_VALUE_THRESHOLD
								  )
								  #endif
								  #if ALLOW_FUTILITY_4_EXTENSION_2==1
   								  || (xlevel>=depthtarget_level-2
									 && valpos+600<sup_alpha_value
   									 //&& alpha<MATE_VALUE_THRESHOLD
									)
								  #endif
									
								)
								&& check==0
								&& node_type!=NODE_PV
								//&& previous_search_level->node_type!=NODE_PV
								// && lmoins->check==0 // inutile : checs en heuristiques
								// Seules les reprises/echecs nous feraient passer au dessus de sup_alpha_value
								&& valpos+EXTEND_MARGIN<sup_alpha_value
								&& alpha<MATE_VALUE_THRESHOLD
								//&& F_real_move_has_been_registered
								//&& F_level_impair // pas de futilit 4 pour pair
								&& s->finale!=ROI_VS_ROI
								)
							{
								if (valpos+EXTEND_MARGIN>value)
								{
									Fsel=true;
									xcompteur++; if (!time_and_keyboard_control()) { xreturn=true; }
									#if COLLECT_STATS==1
									switch(node_type)
									{
										case NODE_PV  : xnodes_pv++; break;
										case NODE_CUT : xnodes_cut++; break;
										case NODE_ALL : xnodes_all++; break;
									}
									#endif
									value=inf(sup_alpha_value,valpos+EXTEND_MARGIN);
									*best=LigneEnd;
								}
								//min_fail_low_value=sup(min_fail_low_value,valpos+EXTEND_MARGIN);
								//min_fail_low_value=inf(valpos+EXTEND_MARGIN,alpha);
								ASSERT(value<=sup_alpha_value);
								// Court-circuite les "autres coups"
								return 0;
							}
							#endif
 			
						
						  analysis=SEARCH_ANALYSE_AUTRES_COUPS;
						  #if USE_REDUCTIONS==1
							SEARCH::set_allow_reduction();
						  #endif

						  #if COLLECT_STATS==1
						  origine_coups_analysis=OR_SEARCH_ANALYSE_AUTRES_COUPS;
						  #endif

						  phase_generation=AUTRES_COUPS;
						  numptr=&xw[debut_blanc]; num=debut_blanc;
		  				  while(num<=fin_blanc)
						  {
							if (numptr->nature!=0 && numptr->psptr->mobility_others!=0)
							{ break; }
							numptr++; num++;
						  }				  // Si pas d'autres coups, sortir
						  if (num>fin_blanc) { goto CHANGEMENT_ANALYSIS; }
						  // Pour compltion par la suite des autres coups
						  moveptr=numptr->psptr->moves;
						  // Remarque : si on sort d'analyse des coups favorables
						  // listmovesptr pointe sur la premire entre nulle
						  // nb_coups_liste==listmovesptr-&listmoves[0]
						  // Si pas de prises, listmovesptr

						  //listmovesptr=&listmoves[nb_coups_liste];
					

						  listmovesptr=&listmoves[nb_coups_liste]-1;
						  idxmove=nb_coups_liste-1;
						  F_utilisation_liste=false;
						  F_nouvelle_piece=true; 
						  #if USE_CASES_ACTUALISATION==1
						  F_piece_with_possibly_illegal_moves=bit(pieces_with_possible_illegal_moves,num);
						  #endif
						  goto NEXT_MOVE_NO_LISTE;
					}

				break;


				case SEARCH_ANALYSE_COUPS_HEURISTIQUES:
			
					  // Cloture de liste
					  listmoves[nb_coups_liste].move=0;

  
				  #if ALLOW_FUTILITY_4==1
						if (
							#if FUTILITY_4_ONLY_LASTDEPTH==1
							 xF_derniere_profondeur_en_cours
							&&
							#endif
							(
							 F_depthtarget_level_reached
						      #if ALLOW_FUTILITY_4_EXTENSION_1==1
							   || (xlevel>=depthtarget_level-1
                                  && valpos+600<sup_alpha_value
 								  //&& alpha<MATE_VALUE_THRESHOLD
							  )
							  #endif
							  #if ALLOW_FUTILITY_4_EXTENSION_2==1
   							  || (xlevel>=depthtarget_level-2
                                 && valpos+600<sup_alpha_value
   							     //&& alpha<MATE_VALUE_THRESHOLD
							    )
							  #endif
								
						    )
							&& check==0
							&& node_type!=NODE_PV
							//&& previous_search_level->node_type!=NODE_PV
							// && lmoins->check==0 // inutile : checs en heuristiques
							// Seules les reprises/echecs nous feraient passer au dessus de sup_alpha_value
							&& valpos+EXTEND_MARGIN<sup_alpha_value
							&& alpha<MATE_VALUE_THRESHOLD
							//&& F_real_move_has_been_registered
							//&& F_level_impair // pas de futilit 4 pour pair
							&& s->finale!=ROI_VS_ROI
							)
						{
							if (valpos+EXTEND_MARGIN>value)
							{
								Fsel=true;
								xcompteur++; if (!time_and_keyboard_control()) { xreturn=true;}
								#if COLLECT_STATS==1
								switch(node_type)
								{
									case NODE_PV  : xnodes_pv++; break;
									case NODE_CUT : xnodes_cut++; break;
									case NODE_ALL : xnodes_all++; break;
								}
								#endif
								value=inf(sup_alpha_value,valpos+EXTEND_MARGIN);
								*best=LigneEnd;
							}
							//min_fail_low_value=sup(min_fail_low_value,valpos+EXTEND_MARGIN);
							//min_fail_low_value=inf(valpos+EXTEND_MARGIN,alpha);
							ASSERT(value<=sup_alpha_value);
							// Court-circuite les "autres coups"
							return 0;
						}
				 #endif
 			
											  
					F_creation_liste=true;
					F_utilisation_liste=true;
					analysis=SEARCH_ANALYSE_AUTRES_COUPS;
					#if USE_REDUCTIONS==1
					SEARCH::set_allow_reduction();
					#endif
					#if COLLECT_STATS==1
					  origine_coups_analysis=OR_SEARCH_ANALYSE_AUTRES_COUPS;
					#endif
					if (F_no_listmoves2)
					{
						idxmove=-1;
						listmovesptr=&listmoves[0]-1;
						goto NEXT_MOVE_LISTMOVES;
					}
					else
					{
	  					search_listmoves2_create(
							true,false,false,false // ne pas tenir compte des wasbest pour le tri
							   );
						idxmove=-1;
						listmoves2ptr=&listmoves2[0]-1;
						goto NEXT_MOVE_LISTMOVES2;
					}

	
				break;



				#if USE_ATTAQUES_PION==1
				case SEARCH_ANALYSE_ATTAQUES_PION :

						#if ALLOW_SEARCH_ELAGAGE_SUITE_FAVORABLE==1
						// Elagage par suite suffisante a depthtarget
						if (check==0)
						{
						if (F_depthtarget_level_reached)
						{
						if (value>500)
						{
						return 0;
						}
						}
						}
						#endif

	
						
						#if ALLOW_FUTILITY_4==1
						if (
							#if FUTILITY_4_ONLY_LASTDEPTH==1
							 xF_derniere_profondeur_en_cours
							&&
							#endif
							(
  							  F_depthtarget_level_reached
 							  #if ALLOW_FUTILITY_4_EXTENSION_1==1
							  || (xlevel>=depthtarget_level-1
                                  && valpos+600<sup_alpha_value
 								  //&& alpha<MATE_VALUE_THRESHOLD
							      )
							  #endif
							  #if ALLOW_FUTILITY_4_EXTENSION_2==1
  							  || (xlevel>=depthtarget_level-2
                                  && valpos+600<sup_alpha_value
 						          //&& alpha<MATE_VALUE_THRESHOLD
							    )
						      #endif
							 )
							&& check==0
							&& node_type!=NODE_PV
							//&& previous_search_level->node_type!=NODE_PV
							// && lmoins->check==0 // inutile : checs en heuristiques
							// Seules les reprises/echecs nous feraient passer au dessus de sup_alpha_value
							&& valpos+EXTEND_MARGIN<sup_alpha_value
							&& alpha<MATE_VALUE_THRESHOLD
							//&& F_real_move_has_been_registered
							//&& F_level_impair // pas de futilit 4 pour pair
							//&& node_type!=NODE_PV
							&& s->finale!=ROI_VS_ROI
							)
						{
							if (valpos+EXTEND_MARGIN>value)
							{
								Fsel=true;
								xcompteur++; if (!time_and_keyboard_control() { xreturn=true; }
								#if COLLECT_STATS==1
								switch(node_type)
								{
									case NODE_PV  : xnodes_pv++; break;
									case NODE_CUT : xnodes_cut++; break;
									case NODE_ALL : xnodes_all++; break;
								}
								#endif
								value=inf(valpos+EXTEND_MARGIN,sup_alpha_value);
								*best=LigneEnd;
							}
							//min_fail_low_value=sup(min_fail_low_value,valpos+EXTEND_MARGIN);
							//min_fail_low_value=inf(valpos+EXTEND_MARGIN,alpha);
							ASSERT(value<=sup_alpha_value);
							// Court-circuite les "autres coups"
							return 0;
						}
						#endif

					F_creation_liste=true;
					F_utilisation_liste=true;
					analysis=SEARCH_ANALYSE_AUTRES_COUPS;
					SEARCH::set_allow_reduction();
					#if COLLECT_STATS==1
					  origine_coups_analysis=OR_SEARCH_ANALYSE_AUTRES_COUPS;
					#endif
					if (F_no_listmoves2)
					{
						idxmove=-1;
						listmovesptr=&listmoves[0]-1;
						goto NEXT_MOVE_LISTMOVES;
					}
					else
					{
	  					search_listmoves2_create(
							true,false,false,false // ne pas tenir compte des wasbest pour le tri
							   );
						idxmove=-1;
						listmoves2ptr=&listmoves2[0]-1;
						goto NEXT_MOVE_LISTMOVES2;
					}
					break;

				#endif



				case SEARCH_ANALYSE_AUTRES_COUPS :
					// Cloture de liste si direct depuis killermoves
					listmoves[nb_coups_liste].move=0;	
					
					return 0;
					break;

				case SEARCH_ANALYSE_LISTE :
					return 0;
					break;
			} 
			ASSERT(false);
	} // fin move==0
} // !F_nouvelle_piece
			

// Pas de test sur Fplay

// Elimination du hint_move si dja jou
if (F_hint_move_has_been_played)
{
if (SAME_MOVE(move,hint_move))
{
	goto NEXT_MOVE_NO_LISTE;
}
}


// Lgalit
#if USE_CASES_ACTUALISATION==1
if (F_piece_with_possibly_illegal_moves)
#endif
{
	cc=legal(num,move,num_roi,*lignemoins);
	if (cc!=1) // coup illgal
	{
		goto NEXT_MOVE_NO_LISTE;
	}
}
#if _DEBUG
cc=MOVE_NUM_PIECE(move);
cc=MOVE_ARR64(move);
ASSERT(legal(num,move,num_roi,*lignemoins)==1);
#endif

// Compteur de coups
nb_coups_liste++;
idxmove++;
listmovesptr++;
*listmovesptr=xempty_listlevel_entry;
listmovesptr->move=move;
listmovesptr->type=numptr->type;
//listmovesptr->move_nature=move_nature;
//listmovesptr->legal=LEGAL;
listmovesptr->num=num;
#if _DEBUG==1
listmovesptr->dep88=MOVE_DEP88(move);
listmovesptr->arr88=MOVE_ARR88(move);
#endif
//listmovesptr->categorie=(char) MOVE_CATEGORY(move);
//capture_value=MOVE_CAPTURE_VALUE(move);
//listmovesptr->capture_value=capture_value;
//move_nature=MOVE_NATURE(move);


/*
#if _DEBUG==1
short int si1;
si1=MOVE_NUM_PIECE(move);
listmovesptr->dep88=MOVE_DEP88(move);
listmovesptr->arr88=MOVE_ARR88(move);
//listmovesptr->index=idxmove;
#endif
*/

// Marquage de fin de liste
//(listmovesptr+1)->move=0; 
//*(listmovesptr+1)=0; 

} // fin !F_creation_liste


PLAY_MOVES:
switch (analysis)
{
case SEARCH_ANALYSE_HINT_MOVE :
		
        /*
	    #if ALLOW_FUTILITY_4==1
		short valeur_prise;
		valeur_prise=MOVE_CAPTURE_VALUE(move);
		if 
		(							
		 valpos+valeur_prise+600<sup_alpha_value
		 && node_type!=NODE_PV
		 && !F_case_de_mat
		 &&
		#if FUTILITY_4_ONLY_LASTDEPTH==1
		 xF_derniere_profondeur_en_cours
		&&
		#endif
			(
			F_depthtarget_level_reached
			#if ALLOW_FUTILITY_4_EXTENSION_1==1
  			|| (xlevel>=depthtarget_level-1
   			//&& alpha<MATE_VALUE_THRESHOLD
			)
			#endif
			
		 
			#if ALLOW_FUTILITY_4_EXTENSION_2==1
   			|| (xlevel>=depthtarget_level-2
    	     //&& alpha<MATE_VALUE_THRESHOLD
		    )
			#endif
			)
		 )
		{
			if (!(MOVE_IS_QUEEN(move) && SEARCH::givecheck(move,wtm))
				&& !MOVE_IS_FORCING(move)
		 && check==0
 		 //&& node_type!=NODE_PV
		 // && lmoins->check==0 // inutile : checs en heuristiques
		 // Seules les reprises/echecs nous feraient passer au dessus de sup_alpha_value

		 && alpha<MATE_VALUE_THRESHOLD
		 //&& F_level_impair // pas de futilit 4 pour pair
		 && s->finale!=ROI_VS_ROI
)
			{

							// Si enregistr > alpha, value
							// Sinon alpha
							// Donc :
							if (valpos+valeur_prise+EXTEND_MARGIN>value)
							{
								Fsel=true;
								xcompteur++; if (!time_and_keyboard_control() { xreturn = true;}
								#if COLLECT_STATS==1
								switch(node_type)
								{
									case NODE_PV  : xnodes_pv++; break;
									case NODE_CUT : xnodes_cut++; break;
									case NODE_ALL : xnodes_all++; break;
								}
								#endif
								if (valpos+valeur_prise+EXTEND_MARGIN>value)
								{ value=valpos+valeur_prise+EXTEND_MARGIN; }
								value=inf(valpos+valeur_prise+EXTEND_MARGIN,sup_alpha_value);
								*best=LigneEnd;
							}
							//min_fail_low_value=sup(min_fail_low_value,valpos+EXTEND_MARGIN);
							//min_fail_low_value=inf(valpos+si1+EXTEND_MARGIN,alpha);
							ASSERT(value<=sup_alpha_value);
							// Court-circuite les "autres coups"
							goto CHANGEMENT_ANALYSIS;
						}
				}
				 #endif
	*/

		listmovesptr->priority=TransScore; // Au minimum
		return move;
		break;

case SEARCH_ANALYSE_COUPS_FAVORABLES :

		cat=MOVE_CATEGORY(move);

		if (cat==COUP_FORCANT) 
		{ 
			listmovesptr->priority=MaterialWinScore;
			#if COLLECT_STATS==1
			origine_coups_analysis=OR_SEARCH_COUP_FORCANT;
			#endif
			return move;
		}



		// Promotion
		if (cat==PROMOTION) 
		{
		//if (node_type==NODE_PV)
		{
			bilan_coup=bilan_attaque_defense_avant_coup(move);
			switch(bilan_coup)
			{
				case GAIN_MATERIEL : 
							listmovesptr->priority=MaterialWinScore;
							#if COLLECT_STATS==1
							origine_coups_analysis=OR_SEARCH_PROMOTION;
							#endif
							return move;
							break;
				case PERTE_MATERIELLE :
							//listmovesptr->priority=BadScore;
						    listmovesptr->priority=CaptureScore;
							// NON : laisser le score historique
							//listmovesptr->priority=HistoryScore;
							goto NEXT_MOVE_NO_LISTE; 
							break;
				case COUP_NEUTRE :
							listmovesptr->priority=CaptureScore;
							goto NEXT_MOVE_NO_LISTE;
							break;
			}
		}
		}


		#if ALLOW_SEARCH_BILAN_AD==1
		// Prise de pices non dfendues hors pions
		//if (node_type==NODE_PV /*|| !MOVE_TAKES_PAWN(move)*/ )
		{
		//ASSERT(!MOVE_IS_EN_PASSANT(move));
		// rem : il est plus efficace de tester directement bilan_avant_coup
		// de manire  choisir la prise de pice !
		// Pas de notion safe/unsafe pour une prise
		bilan_coup=bilan_attaque_defense_avant_coup(move);
		switch (bilan_coup)
		{
			case GAIN_MATERIEL :
					#if COLLECT_STATS
					origine_coups_analysis=OR_SEARCH_PRISE_PIECE_NON_DEFENDUE;
					#endif
					listmovesptr->priority=MaterialWinScore;
					//listmovesptr->selected_move=true;
					return move;
					break;
			case PERTE_MATERIELLE :
					ASSERT(listmovesptr->givecheck==CHECK_NOT_DETERMINED);
					//if (listmovesptr->givecheck==CHECK_NOT_DETERMINED)
					//{
					//}
					listmovesptr->priority=CaptureScore;
					goto NEXT_MOVE_NO_LISTE;
					/*
					listmovesptr->givecheck=SEARCH::givecheck(move,wtm);
					if (listmovesptr->givecheck==CHECK)
					{
						// Laisser CaptureScore
						// pour permettre une analyse  depthtarget_level
						// au niveau des changes
						listmovesptr->priority=CaptureScore;
					}
					else
					{
						listmovesptr->priority=CaptureScore;
					}
					goto NEXT_MOVE_NO_LISTE;
					*/
					break;
			case COUP_NEUTRE :
			//case NEUTRAL : 
					listmovesptr->priority=CaptureScore;
					goto NEXT_MOVE_NO_LISTE; // Pas de gain matriel
					break;
		}
		}
		#endif



		#if ALLOW_SEARCH_BILAN_AD==0
		// Prise de la pice dernier coup
		// ( forte probabilit de bonne prise )
		if (MOVE_ARR64(move)==case_objectif_dernier_coup) 
		{
		#if COLLECT_STATS==1
		xprise_piece_dernier_coup_attempts++;
		#endif
		// Pas de notion safe/unsafe pour une prise
		// Ok pour la prise de la pice dernier coup
		// bilan_coup=bilan_attaque_defense_avant_coup(s,move);
		// LE BILAN COUP EST PRESUME FAVORABLE
		bilan_coup=GAIN_MATERIEL; // choix a priori
		#if COLLECT_STATS==1
		xprise_piece_dernier_coup_done++;
		origine_coups_analysis=OR_SEARCH_PRISE_PIECE_DERNIER_COUP;
		#endif
		listmovesptr->priority=MaterialWinScore;
		return move;
		}
		#endif


		#if DEBUG==1
		if (cat==COUP_FORCANT || cat==PROMOTION)
		log_error("\nErreur S221");
		#endif

		goto NEXT_MOVE_NO_LISTE;
		break; // case
		



	case SEARCH_ANALYSE_PRISES :


		// SEARCH_NO_NEED_TO_EXTEND
		#if SEARCH_NO_NEED_TO_EXTEND==1
		if (//xlevel>=depthtarget_level-1
			F_depthtarget_level_reached
			)
		{
		if (check==0 && node_type!=NODE_PV)
		{
			if (valpos+MOVE_CAPTURE_VALUE(move)
				//+(xlevel==depthtarget_level-1?550:0)
				+EXTEND_MARGIN
				<sup_alpha_value)
			{
			if (alpha<MATE_VALUE_THRESHOLD &&
				move!=hint_move)
			{
				if (listmovesptr->givecheck==CHECK_NOT_DETERMINED)
				{
					listmovesptr->givecheck=SEARCH::givecheck(move,wtm);
				}
				if (listmovesptr->givecheck==CHECK)
				{
					return move;
				}
				// Attention aux pions passs qu'il faut jouer 
				// car ils peuvent beaucoup augmenter 
				// la fonction d'valuation d'un coup sur l'autre
				if (MOVE_IS_PAWN(move)) 
				{
				   if(EST_PION_PASSE(wtm,MOVE_ARR64(move),s)) 
				   {
					   return move;
				   }
				}
				if (valpos+MOVE_CAPTURE_VALUE(move)+EXTEND_MARGIN>value)
				{
						Fsel=true;
					    xcompteur++; if (!time_and_keyboard_control()) { xreturn = true; }
						#if COLLECT_STATS==1
						switch(node_type)
						{
							case NODE_PV  : xnodes_pv++; break;
							case NODE_CUT : xnodes_cut++; break;
							case NODE_ALL : xnodes_all++; break;
						}
						#endif
						// On n'enregistre pas le coup
						value=valpos+MOVE_CAPTURE_VALUE(move)+EXTEND_MARGIN;
						ASSERT(valpos+MOVE_CAPTURE_VALUE(move)+EXTEND_MARGIN<sup_alpha_value);
						*best=LigneEnd;
				}
				listmovesptr->Fplay=2;
				//min_fail_low_value=sup(min_fail_low_value,valpos+MOVE_CAPTURE_VALUE(move)+EXTEND_MARGIN);
				//min_fail_low_value=inf(min_fail_low_value,alpha);
				goto NEXT_MOVE_LISTMOVES;
			}
			}
		}
		}
		#endif

		return move;
		break;


	case SEARCH_ANALYSE_KILLERMOVES:

/*
#if DEBUG==1
if (compteur_mem==65251)
{
	char cc;
	cc=0;
	cc=1/cc;
}
#endif
*/

		if (MOVE_IS_PASSE(move))
		{
				goto NEXT_MOVE_LISTMOVES;	
		}

		dep=MOVE_DEP64(move);
		arr=MOVE_ARR64(move);
		num=xboard[dep].num_piece;
		if (num<debut_blanc || num>fin_blanc)
		{
			goto NEXT_MOVE_LISTMOVES;	
		}
		numptr=&xw[num];
		if (numptr->nature==0) break;
		if (MOVE_IS_CAPTURE(move) || MOVE_PROMOTION(move)=='D')
		{
			moveptr=numptr->psptr->moves2;
		}
		else
		{
			moveptr=numptr->psptr->moves;
		}
		for(;;moveptr++)
		{
			move2=*moveptr;
			if (move2==0) break;
			
			if (SAME_MOVE(move2,move))
			{
				if SAME_MOVE(move,hint_move)
				{
					goto NEXT_MOVE_LISTMOVES;
				}
				// Contrle lgalit
				#if USE_CASES_ACTUALISATION==1
				if (bit(pieces_with_possible_illegal_moves,numptr->num_piece))
				#endif
				{
					cc=SEARCH::legal(num,move,num_roi,*lignemoins);
					if (cc!=1) 
					{
						goto NEXT_MOVE_LISTMOVES;
					}
				}
				listmovesptr->num=num;
				listmovesptr->type=numptr->type;
				return move2; // move2 de prfrence
			}
		} 
		
		goto NEXT_MOVE_LISTMOVES;
		break;



	case SEARCH_ANALYSE_COUPS_HEURISTIQUES:

		// Heuristiques supposant l'absence d'chec
		// if (check==0 /*&& NONNNN : node_type!=NODE_ALL*/)
		ASSERT(check==0);
		{
			#if USE_NULLMOVE_REFUTATION==1
			if (SAME_MOVE(move,previous_level_nullmove_refutation))
			{
				return move;
			}
			if (nullmove_refutation_arr>=0)
			{
				// Interdiction case d'arrive 
				// nullmove_refutation_arr
				// Objectif, contrler cette case, ou la quitter
				cc=0;
				// Fuir la case d'arrive
				if (
					MOVE_DEP64(move)==nullmove_refutation_arr
					// A depthtarget_level, rduire le nombre
					// de coups 
					//&& !F_deptharget_level_reached
					)
				{ cc=1; }
				else
				{
				if (!F_nullmove_refutation_cannot_be_defended)
				{
				// Le coup apporte-t-il de la protection ?
				arr=MOVE_ARR64(move);
				switch(MOVE_NATURE(move))
				{
				case 'D' : 
					ASSERT(arr==MOVE_ARR64(move));
					if (bit(xcases_arrivee_dame[arr],nullmove_refutation_arr))
					{ cc=1; }
					break;
				case 'T' : 
					ASSERT(arr==MOVE_ARR64(move));
					if (bit(xcases_arrivee_tour[arr],nullmove_refutation_arr))
					{ cc=1; }
					break;
				case 'F' : 
					ASSERT(arr==MOVE_ARR64(move));
					if (bit(xcases_arrivee_fou[arr],nullmove_refutation_arr))
					{ cc=1; }
					break;
				case 'C' : 
					ASSERT(arr==MOVE_ARR64(move));
					if (bit(xcases_arrivee_cavalier[arr],nullmove_refutation_arr))
					{ cc=1; }
					break;
				case 'P' :
					if (nullmove_refutation_arr==arr+PLAYER(player,9)
						||
						nullmove_refutation_arr==arr-PLAYER(player,7)
						)
					{ cc=1; }
					break;
				case 'R' : 
					ASSERT(arr==MOVE_ARR64(move));
					if (bit(xcases_arrivee_roi[arr],nullmove_refutation_arr))
					{ cc=1; }
					break;
				} // fin switch
				} // fin if
				} // fin else
				if (cc==1)
				{
					bilan_coup=bilan_attaque_defense_avant_coup_simplifie(move);
					if (bilan_coup==MATERIAL_LOSS)
					{
						 listmovesptr->priority=BadScore;
					}
					else
					{	
						//listmovesptr->priority=HeuristicScore;
						#if COLLECT_STATS
						origine_coups_analysis=OR_SEARCH_EVASION_PIECE_ATTAQUEE;
						#endif
						cat=COUP_HEURISTIQUE;
						//listmovesptr->categorie=COUP_HEURISTIQUE_2;
						return move;
					}
				}


			} // fin nullmove refutation
			#endif
			
					  #if USE_ATTAQUES_PION==1
					  if (nb_attaques_pion>0)
					  {
						analysis=SEARCH_ANALYSE_ATTAQUES_PION;
						#if COLLECT_STATS==1
						  origine_coups_analysis=OR_SEARCH_ANALYSE_ATTAQUES_PION;
						#endif
						// A grer comme une listmoves2
						listmoves2ptr=&attaques_pion[0]-1;
						attaques_pion[nb_attaques_pion]=&xempty_listlevel_entry;
						F_utilisation_liste=true;
						goto NEXT_MOVE_LISTMOVES;
					  }
					  #endif

					  #if UNCOMMENT
					// Menaces avec la dame
					//if (node_type!=NODE_PV)
					{
					if (s->materiel_dames[wtm]>0)
					{
					cc=0;
					if (MOVE_IS_QUEEN(move))
					{
					arr=MOVE_ARR64(move);
					if (&xcases_arrivee_dame[arr] && &xcases_arrivee_roi[s->roi_pos[1-wtm]])
					{
						if (DISTANCE_FROM64(arr,s->roi_pos[other_wtm])<=4)
						{
						// Menace-t-on une case adjacente au roi 
						// supporte par nous
						// mais non contrle par l'adversaire
						// si oui : extension
						// (excellent rsultat sur Rotman.fch)
						dep=MOVE_DEP64(move);
						if (
						 s->cases_echec_dame[wtm]
						&xcases_arrivee_dame[arr]
						&(~cases_controlees_adversaire_hors_roi)
						&cases_controlees
						//&(~cases_controle_exclusif_dame)
						&(~xcases_arrivee_dame[dep])
						&xcases_arrivee_roi[s->roi_pos[1-wtm]]
						)
						{
							//F_move_should_be_explored_without_reduction=true;
							cc=1;
							//break;
						}
						}
					}
					}
					
					else 
					// Menace avec l'aide d'autres pices
					{
					arr=MOVE_ARR64(move);
					dep=MOVE_DEP64(move);
					if (cases_controle_exclusif_dame&xcases_arrivee_roi[s->roi_pos[1-wtm]])
					{
					switch(MOVE_NATURE(move))
					{
					/* trop rare
					case 'P' :  if (xwtm==1)
								{
								if (
								cases_controle_exclusif_dame&xcases_arrivee_roi[s->roi_pos[1-wtm]]
								 &(unsigned __int64 ((1<<arr)<<9) || ((1<<arr)>>7))
								 &(~cases_controlees_adversaire_hors_roi)
								)
								{
			   						// Extension car fait augmenter l'arbre
									// depthmove+=((1<<FD));
									// Pas de rduction
									//F_move_should_be_explored_without_reduction=true;
									cc=1;
								}
								break;
								}
								else // wtm==0
								{
								if (
								cases_controle_exclusif_dame&xcases_arrivee_roi[s->roi_pos[1-wtm]]
								 &(unsigned __int64 ((1<<arr)>>9) || ((1<<arr)<<7))
								 &(~cases_controlees_adversaire_hors_roi)
								)
								{
			   						// Extension
									//depthmove+=((1<<FD));
									// Pas de rduction
									F_move_should_be_explored_without_reduction=true;
									cc=1;
								}
								break;
								}
					*/
					case 'C' : if (
							   cases_controle_exclusif_dame&xcases_arrivee_roi[s->roi_pos[1-wtm]]
							   &xcases_arrivee_cavalier[arr]
							   //&(~xcases_arrivee_cavalier[dep]) ralentit Rotman
							   &(~cases_controlees_adversaire_hors_roi)
							   )
							   {
			   						// Extension car fait augmenter l'arbre
									//depthmove+=((1<<FD)); 
									// Pas de rduction
									//F_move_should_be_explored_without_reduction=true;
								    cc=1;
							   }
								   break;
					case 'F' : if (
							   cases_controle_exclusif_dame&xcases_arrivee_roi[s->roi_pos[1-wtm]]
							   &xcases_arrivee_fou[arr]
							   &(~xcases_arrivee_fou[dep])
							   &(~cases_controlees_adversaire_hors_roi)
							   )
							   {
			   						// Extension
									//depthmove+=((1<<FD));
									// Pas de rduction
									//F_move_should_be_explored_without_reduction=true;
								   cc=1;
							   }
								   break;
					case 'T' : if (
							   cases_controle_exclusif_dame&xcases_arrivee_roi[s->roi_pos[1-wtm]]
							   &xcases_arrivee_tour[arr]
							   &(~xcases_arrivee_tour[dep])
							   &(~cases_controlees_adversaire_hors_roi)
							   )
							   {
			   						// Extension 
									//depthmove+=((1<<FD));
									// Pas de rduction
									//F_move_should_be_explored_without_reduction=true;
								    cc=1;
							   }
								   break;
					/* Trop rare
					case 'R' : if (
							   cases_controle_exclusif_dame&xcases_arrivee_roi[s->roi_pos[1-wtm]]
							   &xcases_arrivee_roi[arr]
							   &(~cases_controlees_adversaire_hors_roi)
							   )
							   {
			   						// Extension car fait augmenter l'arbre
									// depthmove+=((1<<FD));
									// Pas de rduction
									//F_move_should_be_explored_without_reduction=true;
									cc=1;
							   }
							   break;
					*/
					default : break; 
					} // fin switch
					} // fin if 
					} // fin else
			
				if (cc==1)
				{
					bilan_coup=bilan_attaque_defense_avant_coup_simplifie(move);
					if (bilan_coup==MATERIAL_LOSS)
					{
						 listmovesptr->priority=BadScore;
					}
					else
					{	
						// Extension
						listmovesptr->givecheck=SEARCH::givecheck(move,wtm);
						if (listmovesptr->givecheck!=CHECK) 
						{ depthmove+=((1<<FD)); }
						//listmovesptr->priority=HeuristicScore;
						#if COLLECT_STATS
						origine_coups_analysis=OR_SEARCH_EVASION_PIECE_ATTAQUEE;
						#endif
						cat=COUP_HEURISTIQUE;
						//listmovesptr->categorie=COUP_HEURISTIQUE_2;
						return move;
					}
				}

					} // fin matriel dame
					} // fin node_type
				#endif

		#if SEARCH_COUPS_HEURISTIQUES_ECHECS==1
		if (s->finale==MILIEU_DE_PARTIE
			//&& xlevel>=depthtarget_level-1
			)
		{
		// F_depthtarget_level_reached pour position Lasker
		if (true
			// Sinon on a des variantes ridicules
			// Noir joue d5 et blanc analyse 2 millions de coups 
			//  la profondeur 10 quand il y a mat en 1
			// F_depthtarget_level_reached 
			/*|| MOVE_IS_QUEEN(move)*/)
		//if (//F_depthtarget_level_reached
			//xF_derniere_profondeur_en_cours
		//	)
		{
		listmovesptr->givecheck=SEARCH::givecheck(move,wtm);
		if (listmovesptr->givecheck==CHECK) 
		{
			
			//goto NEXT_MOVE_NO_LISTE;
			//return move;
			#if COLLECT_STATS==1
			origine_coups_analysis=OR_SEARCH_ANALYSE_ECHEC;
			#endif
		    //return move;
			//bilan_coup=bilan_attaque_defense_avant_coup_simplifie(move);
			//if (bilan_coup==MATERIAL_LOSS)
			//bilan_coup=bilan_attaque_defense_avant_coup(move);
			//if (bilan_coup==PERTE_MATERIELLE)
			//{
			//	 listmovesptr->priority=BadScore;
			//}
			//else
			{	
			   //listmovesptr->priority=HeuristicScore;
				return move;
			}	
		}
		}
		}
		#endif

		// Enregistrement des coups en selection_attaque_pion
		// Slection de selmax coups
		#if USE_ATTAQUES_PION==1
		if (hint_move==0 && nb_attaques_pion<SELMAX_ATTAQUES_PION
			//&& 
			//!( F_depthtarget_level_reached && valpos<sup_alpha_value) 
			)
		{
		if (MOVE_NATURE(move)=='P' )
		{
		cc=Y64(MOVE_ARR64(move));
		if (cc==5 && wtm==1)
		{
			if (EST_PION_PASSE(wtm,MOVE_ARR64(move),s))
			{
				goto SELECTED;
			}
		}
		else 
		if (cc==2 && wtm==0)
		{
			if (EST_PION_PASSE(wtm,MOVE_ARR64(move),s))
			{
				goto SELECTED;
			}
		}
		else if (cc==6 || cc==1)
		{
			goto SELECTED;
		}
		#if USE_ATTAQUE_PION==1
		else if (bit(cases_attaque_pion,MOVE_ARR64(move))==1 )
		{
			goto SELECTED;
		}
		#endif
		goto NEXT_MOVE_NO_LISTE;
		SELECTED:
		attaques_pion[nb_attaques_pion++]=listmovesptr;  // OK coup entr dans?la slection
		goto NEXT_MOVE_NO_LISTE;
		}
		}
		#endif


		
		#if USE_CASES_COUPS_FORCANTS==1
		if (hint_move==0 && F_existe_coup_forcant_adversaire
			&& 
			(valpos>sup_alpha_value 
			//&& node_type!=NODE_PV
			)
			)
		{
		// Dplacement des pices menaces par des coups forants
		if (bit(s->cases_coup_forcant[other_wtm],MOVE_DEP64(move))==1)
		{
			bilan_coup=bilan_attaque_defense_avant_coup_simplifie(move);
			if (bilan_coup==MATERIAL_LOSS)
			{
				 listmovesptr->priority=BadScore;
			}
			else
			{	
		        //listmovesptr->priority=HeuristicScore;
				#if COLLECT_STATS
				origine_coups_analysis=OR_SEARCH_EVASION_PIECE_ATTAQUEE;
				#endif
				cat=COUP_HEURISTIQUE;
				//listmovesptr->categorie=COUP_HEURISTIQUE;
				return move;
			}
		}
		} // fin F_existe_coup_forant_adversaire
		#endif
		
		

		#if USE_SEARCH_UNDEFENDED_PIECES==1
		// Test pices non dfendues
		// sur la base d'un inventaire ou de la liste des dernires pices attaques
		// Et on en profite pour initialiser si besoin est 
		// l'heuristique de dtection des coups de protection
		// Attention : ne fait pas obligatoirement appels aux __int64
		if (F_piece_non_defendue 
			// Si coup forant adversaire, il ne suffit pas de dfendre
			//&& !F_existe_coup_forcant_adversaire
			// Si valpos<alpha, il ne suffira pas de dfendre
			//&& valpos<sup_alpha_value-500
			)
		{
		if (bit(pieces_non_defendues,num)==1)
		{
			bilan_coup=bilan_attaque_defense_avant_coup_simplifie(move);
			if (bilan_coup!=MATERIAL_LOSS) 
			{
			return move;
			}
		}
		}
		#endif

		/*
		// Initialisation heuristique protection
		// pour la pice menace la plus importante
		// On se limite  une pice d'o le flag
		if (!F_initialisation_protection && valpos>sup_alpha_value)
		{
			// Note : xpiece_cible_heuristique_protection
			// n'est pas forcment num 
			// car il peut y avoir plusieurs pice attaques
			  // mais une seule pice est prise en compte pour l'heuristique protection
			F_initialisation_protection=true;
			case_cible_heuristique_protection=dep;
			SEARCH::inventaire_cases_protection(wtm,case_cible_heuristique_protection); 
		}
		


		// Heuristique coups de protection
		// Le coup intercepte une menace ou protge
		// L'heuristique n'est initialise que si valpos>sup_alpha_value
		if (F_initialisation_protection)
		{
		cc=0;
		if (interception(*cases_interception,MOVE_ARR64(move))==1)
		{
			//if (MOVE_NUM_PIECE(move)!=piece_cible_heuristique_protection) 
			if (dep!=case_cible_heuristique_protection) 
			{ cc=1; }
		}
		else
		{
			if (SEARCH::give_protection(case_cible_heuristique_protection,move))
			{ cc=1; }
		}


		if (cc==1)
		{
			#if COLLECT_STATS==1
			origine_coups_analysis=OR_SEARCH_HEURISTIQUE_PROTECTION;
			#endif
			cat=COUP_HEURISTIQUE_2;
			//listmovesptr->selected_move=true;
			listmovesptr->categorie=COUP_HEURISTIQUE_2;
			//listmovesptr->priority=HeuristicScore;
			return move;
		} // fin if cc==1
		} // fin intitialisation protection
		} // fin pice non dfendue 1
		} // fin pice non dfendue 1
		#endif
		*/

		} // fin heuristiques sans checs
	    

		goto NEXT_MOVE_NO_LISTE;
		break;

	#if USE_ATTAQUES_PION==1
	case SEARCH_ANALYSE_ATTAQUES_PION :
			bilan_coup=bilan_attaque_defense_avant_coup(move);
			if (bilan_coup==PERTE_MATERIELLE)
			{
				 goto NEXT_MOVE_LISTMOVES;
			}
		return move;
    break;
	#endif


	case SEARCH_ANALYSE_AUTRES_COUPS :
			return move;
    			break;

	case SEARCH_ANALYSE_LISTE :
			return move;
		      break;

}

JOUER_COUP:
return move;
} // fin get_move