#include "stdafx.h"
#include "Cchess_1.h"
#include "Cchess_2.h"
#include "Move.h"
//#include "Cchess_3.h"
#include "Cchess_4.h"
#include "Cchess_5.h"
#include "Cchess_6.h"


// Fonctions globales 
void affiche_stat_elag(void);
// Fonctions locales
#if EXTEND_AUTORISATION_FOURCHETTES_P==1
static char subfourC(char local_player, char arr, char inc);
#endif

#if EXTEND_AUTORISATION_FOURCHETTES_P==1
#if CHECK_FOURCHETTES_PION==1
char subfourP(char local_player, char cible);
bool fourchetteP(char local_player, char arr);
#endif
#endif

void reconstitution_ligne_principale(MOVE* ligne, char move_one_has_been_played);
static void dejouer_reconstitution(MOVE* ligne, char compteur_coups_joues,
		char move_one_has_been_played);
static char legalite_coup_reconstitution(const MOVE mpt, MOVE lastmove);



void SEARCH::jouer(const MOVE move)
{
#if ALLOW_PAWN_SQUARE_CONTROL==1
char cc,dd;
#endif
bool move_is_promotion, move_is_special, move_is_castle, move_is_en_passant;
bool move_is_capture;
char prise_nature;
char dep, arr, prom;
char prise_num;
char local_player;
char static complement_roque=0;
char color, color01;
char color2, color2_01;
short prise_value;
MOVE move2;
char nature;
char num;
#if TRACK_QUEEN_POSITION==1
PIECE *wptr;
char k;
#endif
//char *ep_square64;
PIECE *awptr, *prise_wptr;
CASE *aptr, *dptr, *cptr;
//STATEVALUES *s;
PIECE_SET* prpsptr; 
#if DEBUG==1
short int si1;
#endif


#if DEBUG==1 && INCREMENTAL_HASH==1
gen_code(1);
#endif


// En premier
// Test PV
if (s->F_node_is_former_PV==1)
{
	if (complement_roque==0)
	{
	if (!SAME_MOVE(move,xkeep[xlevel]))
	{
		s->F_node_is_former_PV=0;
	}
	}
}



// Passe
ASSERT(!MOVE_IS_PASSE(move));
ASSERT(MOVE_IS_FOR_PLAY(move));
if (MOVE_IS_PASSE(move))
{	
	 // Attention : ne pas rinitialiser xpasse
	 // car il peut y avoir plusieurs nullmove (non conscutifs)
	 // xpasse=false; 
	xwtm=1-xwtm;
	return;
}


/* A CONSERVER
// Initialisations
if ( xlevel==0 ) 
{ 
	s=&xstates[0];
	ep_square64=&xsearch_level[0]->ep_square64;
}
else
{
	s=&xstates[xlevel+1];
	ep_square64=&xsearch_level[xlevel+1]->ep_square64;
}
*/

local_player=TO_PLAYER(xwtm);
dep=MOVE_DEP64(move);
arr=MOVE_ARR64(move);
move_is_capture=MOVE_IS_CAPTURE(move);
// ASSERT TRES UTILE !
ASSERT(((xboard[arr].nature>0)? true : false)==move_is_capture || MOVE_IS_EN_PASSANT(move));
#if _DEBUG==1
xp=MOVE_CAPTURE(move);
xp=MOVE_IS_EN_PASSANT(move);
#endif
move_is_special=MOVE_IS_SPECIAL(move);
if (move_is_special)
{
	prom=MOVE_PROMOTION(move);
	move_is_promotion=MOVE_IS_PROMOTION(move);
	move_is_castle=MOVE_IS_CASTLE(move);
	move_is_en_passant=MOVE_IS_EN_PASSANT(move);
	if (move_is_en_passant) move_is_capture=true; // mais dja fait
}
else 
{
	move_is_castle=false;
	move_is_en_passant=false;
	move_is_promotion=false;
}


// Note : jouer ne dpend plus de xwtm
// ide : rendu indpendant au moyen de num
// il n'y a pas de cas o num et xwtm soient
// en contradiction pour jouer().


#if DEBUG==1
// TEST IMPORTANT
if (move==0 || xboard[arr].color==xboard[dep].color)
{
char cc;
log_error("\nErr_J951 en : %d", xcompteur);
//cc=0;cc=1/cc;
}
#endif


// Dbogage
#if DEBUG==1
char ff;
ff=0;
if (local_player!=2*xwtm-1) ff=1;// A conserver
if (ff==1)
{
log_error("\nErreur J_201 : %d",xcompteur);
}
#endif


// Xlevel=struct_levelmax ?
#if DEBUG==1
if (xlevel>STMAX)
{
log_error("\nErreur J_001 : %d",xcompteur);
}
#endif


// Initialisations et sauvegardes cases et pices
dptr=&xboard[dep];
ASSERT(dptr->nature!=0);
aptr=&xboard[arr];
awptr=dptr->wptr;
num=awptr->num_piece;
nature=awptr->nature;
color01=dptr->color01;
color=TO_COLOR(color01);

#if DEBUG==1
if (color01!=awptr->color01 || TO_COLOR(color01)!=local_player)
{
log_error("\nErreur J_901 : %d",xcompteur);
//cc=0;cc=1/cc;
}
#endif

// Sauvegardes
if ( complement_roque==0 )
{
	savesquare[0]=*dptr;
	savesquare[1]=*aptr;
	savepiece[0]=*awptr;
}
else // Pour le coup de tour des roques
{
	savesquare[2]=*dptr;
	savesquare[3]=*aptr;
	savepiece[1]=*awptr;
}



// Destruction de pice prise
if (move_is_capture || move_is_en_passant)
{
if (move_is_en_passant)
{
// Rem : xlv.ep_square64 sert pour le moment juste pour le hashage
#if DEBUG==1
if (arr!=xsearch_level[xlevel]->ep_square64)
	log_error("\nErr J961 en : %d", xcompteur);
#endif


// case du pion pris
cptr=&xboard[arr-awptr->color];
// numro du pion pris
prise_num=cptr->num_piece;
// Sauvegarde de la case du pion prise en passant
savesquare[2]=*cptr;
// Rinitialisation de la case du pion
cptr->wptr=&xwnull;
cptr->color=0;
cptr->color01=-1;
cptr->num_piece=99;
cptr->piece_value=0;
cptr->nature=0;

#if DEBUG==1
if (cptr->nature=='R')
{
log_error("Erreur J_896 en %d", xcompteur);
}
#endif

} // fin en_passant
else // prise normale
{
// Autres coups que la prise en passant
{
	prise_num=aptr->num_piece;
	// Eviter l'utilisation mme accidentelle d'un prsptr null
	if (aptr->nature==0)
	{
		#if DEBUG==1
		log_error("\nErr J_365 en %d", xcompteur);
		#endif
	}
}
} // fin prises


// Destruction pice prise dans xw
prise_wptr=&xw[prise_num];
color2_01=1-color01;
color2=TO_COLOR(color2_01);
prise_value=prise_wptr->value;
prise_nature=prise_wptr->nature;
// Suppression pice
prise_wptr->nature=0;




#if _DEBUG==1
if (prise_nature=='R')
	log_error("\nJ_674");
#endif

#if DEBUG==1
	if (
		prise_num<0|| prise_num>31 || xlevel+1>STMAX+1 
		|| color2_01!=prise_wptr->color01 
		|| prise_nature!=MOVE_CAPTURE(move)
	   )
	{
		si1=MOVE_CAPTURE(move);
		log_error("\nErreur J_203 en : %d", xcompteur);
	}
#endif



// Ajustement xposition xdeveloppement et xmobility pour pice dtruite
// Mise  zro case_coup_forcant et pice attaque
#if USE_CASES_COUPS_FORCANTS==1
set_bit_to_0(s->cases_coup_forcant[color01],prise_wptr->pos);
#endif

#if USE_PIECES_ATTAQUEES==1
#if SEARCH_UNDEFENDED_PIECES!=0 || NO_EXTEND_PASSE!=1
set_bit_to_0(s->pieces_attaquees,prise_num);
#endif
#endif

// Prise en comptes des pices attaques par la pice supprime
// Remarque : avec cette mthode une pice attaque par deux pices diffrentes
// n'est plus marque comme attaque aprs le dplacement d'une seule des pices attaquante
#if USE_CASES_COUPS_FORCANTS==1
s->cases_coup_forcant[color2_01]&=~prise_wptr->psptr->cases_coup_forcant;
#endif
#if USE_PIECES_ATTAQUEES==1
#if SEARCH_UNDEFENDED_PIECES!=0 || NO_EXTEND_PASSE!=1
s->pieces_attaquees&=~prise_wptr->psptr->pieces_attaquees;
#endif
#endif

prpsptr=prise_wptr->psptr; 
s->mobility -= PLAYER(color2,prpsptr->mobility+prpsptr->mobility2);
s->position -= prpsptr->posvalue;
s->developpement[color2_01] -= prpsptr->develop;
s->tower -= PLAYER(color2,prpsptr->tower);
#if SUIVI_PRISES==1
s->prises[color2_01] -= prpsptr->prises;
s->prises_pion[color2_01] -= prpsptr->prises_pion;
#endif
// Mise  jour du matriel
s->materiel -= prise_value; 
switch ( prise_nature )
{
case 'P' :  s->materiel_pions[color2_01]--;
		break;
case 'C' :	s->materiel_cavaliers[color2_01]--;
			#if FOLLOW_KNIGHTS==1
	        set_bit_to_0(s->cases_cavaliers[color2_01],prise_wptr->pos);
			#endif
		break;
case 'F' :	s->materiel_fous[color2_01]--;
		    s->fou_de_couleur[color2_01][M_2(X64(arr)+Y64(arr))]=0;
		break;
case 'T' :	s->materiel_tours[color2_01]--;
		break;
case 'D' :s->materiel_dames[color2_01]--;
		  if (s->materiel_dames[color2_01]==0)
		  {
 	        s->F_echange_dame[color2_01]=1; // irrversible
		  }
		  #if TRACK_QUEEN_POSITION==1
		  if (prise_wptr->pos==s->queen_position[color2_01])
		  {  
			  // Si il existait une autre dame, renseigner queen_position
			  if (s->materiel_dames[color2_01]==0)
			  {
	  			  s->queen_position[color2_01]=-1; 
			  }
			  else // il reste au moins une dame
			  {
				    wptr=&xw[0+((1-color2_01)<<4)];
					// Boucle sur les pices
					for (k=0+((1-color2_01)<<4);k<=xw_size[color2_01];k++,wptr++)
					{
						if (wptr->nature!='D') continue;
						s->queen_position[color2_01]=wptr->pos;
						break;
					}
			  }
		  }
		  #if _DEBUG
		  else // il y a une deuxime dame
		  // et c'est elle qui est dsigne par queen_position
		  {
			  ASSERT(s->materiel_dames[color2_01]>0);
  		      wptr=&xw[0+((1-color2_01)<<4)];
			  // Boucle sur les pices
			  for (k=0+((1-color2_01)<<4);k<=xw_size[color2_01];k++,wptr++)
			  {
				if (wptr->nature!='D') continue;
				s->queen_position[color2_01]=wptr->pos;
				break;
			  }
			  ASSERT(s->queen_position[color2_01]==wptr->pos);
		  }
		  #endif
          #endif
		break;
default : break;
}


// Traitements suivant nature pice ou pion
// Aprs le calcul du matriel par pice 
//  cause de la MAJ de l'indicateur de finale
if ( prise_nature !='P' ) 
{   
   #if USE_BITBOARD_MOVE_GENERATION==1 || CHECK_MOVE_GENERATION_WITH_BITBOARDS==1
   set_bit_to_0(s->cases_toutes_pieces[color2_01],prise_wptr->pos);
   #endif
   set_bit_to_0(s->cases_pieces[color2_01],prise_wptr->pos);
   s->materiel_pieces[color2_01] -= abs(prise_value);
   maj_indicateur_finale();	
} 
else // pions
{
   #if USE_BITBOARD_MOVE_GENERATION==1 || CHECK_MOVE_GENERATION_WITH_BITBOARDS==1
   set_bit_to_0(s->cases_toutes_pieces[color2_01],prise_wptr->pos);
   #endif
   set_bit_to_0(s->cases_pions[color2_01],prise_wptr->pos);
   #if ALLOW_PAWN_SQUARE_CONTROL==1
   cc=prise_wptr->posx;
   dd=prise_wptr->posy;
   if ((color2_01==1 && dd<=4) || (color2_01==0 && dd>=3)) // modifi v64
   {
      s->nombre_de_pions_par_couleur_de_cases[color2_01][M_2(cc+dd)]--;
   }
   #endif
   maj_indicateur_finale();	
   s->nb_promotions[color2_01] -= prpsptr->F_promotion;
}
 



// Hashage incrmental
#if INCREMENTAL_HASH==1
s->hash_code.address^=prise_wptr->hash_code.address;
s->hash_code.key^=prise_wptr->hash_code.key;
//s->hash_code.key2^=prise_wptr->hash_code.key2;
ASSERT(prise_nature!='R');
if (prise_nature=='P')
{
		s->pawn_hash_code.address^=prise_wptr->hash_code.address;
		s->pawn_hash_code.key^=prise_wptr->hash_code.key;
		//s->pawn_hash_code.key2^=prise_wptr->hash_code.key2;
}
#endif

} // fin destruction pice




// Mise a jour du flag de prise en passant
// Et mise  jour du nombre de pions par cases de couleur
//  placer aprs l'exploitation de ep_square64
// Avant cela pose problme au level 0
// A placer aussi en dehors des prises !!
ep_square64=0; // par dfaut
// Suite maj flag ep
if (nature=='P' )
{
#if ALLOW_PAWN_SQUARE_CONTROL==1
dd=Y64(dep);
if ((color01==1 && dd<=4) || (color01==0 && dd>=3)) // modifi v64
{
	cc=M_2(X64(dep)+Y64(dep));
	s->nombre_de_pions_par_couleur_de_cases[color01][cc]--;
	dd=Y64(arr);
	if ((color01==1 && dd<=4) || (color01==0 && dd>=3)) // modifi v64
	{
	cc=M_2(X64(arr)+Y64(arr));
	s->nombre_de_pions_par_couleur_de_cases[color01][cc]++;
	}
}
#endif

if  (abs(dep-arr)==2)
{
if ( color01==1 ) 
{
if ( (xboard[arr-8].nature=='P' && xboard[arr-8].color==-1) 
     ||
     (xboard[arr+8].nature=='P' && xboard[arr+8].color==-1) 
   )
{
	ep_square64=MOVE_ARR64(move)-1;
}
}
else if ( color01==0 ) 
{
if ( (xboard[arr-8].nature=='P' && xboard[arr-8].color==1) 
     ||
     (xboard[arr+8].nature=='P' && xboard[arr+8].color==1) 
   )
{
	ep_square64=MOVE_ARR64(move)+1;
}
} // fin else
} // fin if abs(dep-arr)
} // fin if awptr





// Jeu sur case d'arrive
// Change la case de la pice
awptr->pos=arr; // simplement !!
awptr->posx=aptr->posx;
awptr->posy=aptr->posy;
// awptr->diag1=aptr->diag1;
// awptr->diag2=aptr->diag2;


// Maj piece_attaque et cases arrivees coups forcants
#if COUNT_PIECE_MOVES==1
awptr->nbplayed++;
#endif
// Traitement suivant nature pion ou pice
if (nature=='P')
{
	set_bit_to_0(s->cases_pions[color01],dptr->pos);
	if (!move_is_promotion) 
	{
		set_bit_to_1(s->cases_pions[color01],aptr->pos);
	}
	else
	{
		set_bit_to_1(s->cases_pieces[color01],aptr->pos);
		#if FOLLOW_KNIGHTS==1
		if (MOVE_PROMOTION(move)=='C')
			set_bit_to_1(s->cases_cavaliers[color01],aptr->pos);
		#endif
	}
}
else
{
	 set_bit_to_0(s->cases_pieces[color01],dptr->pos);
	 set_bit_to_1(s->cases_pieces[color01],aptr->pos);
	 #if FOLLOW_KNIGHTS==1
	 if (nature=='C')
	 {
		 set_bit_to_0(s->cases_cavaliers[color01],dptr->pos);
		 set_bit_to_1(s->cases_cavaliers[color01],aptr->pos);
	 }
	 #endif
}
#if USE_BITBOARD_MOVE_GENERATION==1 || CHECK_MOVE_GENERATION_WITH_BITBOARDS==1
set_bit_to_0(s->cases_toutes_pieces[color01],dep);
set_bit_to_1(s->cases_toutes_pieces[color01],arr);
#endif


// Concernant la pice elle-mme
#if USE_CASES_COUPS_FORCANTS==1
set_bit_to_0(s->cases_coup_forcant[1-color01],dep);
#endif
#if USE_PIECES_ATTAQUEES==1
#if SEARCH_UNDEFENDED_PIECES!=0 || NO_EXTEND_PASSE!=1
set_bit_to_0(s->pieces_attaquees,MOVE_NUM_PIECE(move));
#endif
#endif
// Et ses cases coups forcants et pices attaques
// On fait une ngation pour avoir 0, la ou il y a un
// puis un &
// Cela met  zro les bits qui taient  1
// et laisse inchangs ceux qui taient  zro
#if USE_CASES_COUPS_FORCANTS==1
s->cases_coup_forcant[color01]&=~awptr->psptr->cases_coup_forcant;
#endif
#if SEARCH_UNDEFENDED_PIECES!=0 || NO_EXTEND_PASSE!=1
#if USE_PIECES_ATTAQUEES==1
s->pieces_attaquees&=~awptr->psptr->pieces_attaquees;
#endif
#endif

// Pour tower, mobility, developement, etc ...
// on ne met rien  jour car la pice va 
// tre actualise

// Annulation valeur de hashage (avant promotion ventuelle)
#if INCREMENTAL_HASH==1
s->hash_code.address^=awptr->hash_code.address;
s->hash_code.key^=awptr->hash_code.key;
//s->hash_code.key2^=awptr->hash_code.key2;
// Faire la soustraction avant la promotion
switch(nature)
{
case 'P' :
	s->pawn_hash_code.address^=awptr->hash_code.address;
	s->pawn_hash_code.key^=awptr->hash_code.key;
	//s->pawn_hash_code.key2^=awptr->hash_code.key2;
	break;
case 'R' :
	s->pawn_hash_code.address^=awptr->hash_code.address;
	s->pawn_hash_code.key^=awptr->hash_code.key;
	//s->pawn_hash_code.key2^=awptr->hash_code.key2;
	break;
default : break;
}
#endif


// Promotion - avant la maj de la case d'arrive !!
if (move_is_promotion)
{
// A conserver mais inutile : set_bit_to_0(s->cases_pion[color01],aptr->pos);
s->materiel -= awptr->value;
awptr->nature=prom; nature=prom;
setvalue(awptr);
s->materiel += awptr->value;
// deja fait : set_bit_to_0(s->cases_pion[color01],dptr->pos);
/* NE PAS EFFACER - IMPORTANT
// C'est inutile il faut laisser faire l'actualisation
// C'est un bug aussi pour USE_xPIECE_SET==1
// En effet, suit la prise d'un pion qui disposait d'une promotion
// le s du level reste  1 car on n'actualise le level+1
// et quand on djoue on ne remet pas le F_promotion  1
s->nb_promotions[color01]-=awptr->psptr->F_promotion;
awptr->psptr->F_promotion=0;
*/
s->materiel_pions[color01]--;
#if ALLOW_PAWN_SQUARE_CONTROL==1
// Ne s'applique pas aux pions avancs
//s->nombre_de_pions_par_couleur_de_cases[color01][M_2(X64(dep)+Y64(dep))]--;
#endif
s->materiel_pieces[color01] += abs(awptr->value);
switch (nature)
{
case 'C' :  s->materiel_cavaliers[color01]++;
		break;
case 'F' :	s->materiel_fous[color01]++;
		break;
case 'T' :	s->materiel_tours[color01]++;
		break;
case 'D' :	s->materiel_dames[color01]++;
		break;
default : break;
}
maj_indicateur_finale();
} // fin promotion


// Prise en compte valeur de hashage (aprs promotion ventuelle)
// => Utiliser awptr->nature car nature peut voir t modifi si promotion
awptr->hash_code=xhval[awptr->type][awptr->pos];
switch(awptr->nature)
{
case 'P' :
	#if INCREMENTAL_HASH==1
	s->pawn_hash_code.address^=awptr->hash_code.address;
	s->pawn_hash_code.key^=awptr->hash_code.key;
	//s->pawn_hash_code.key2^=awptr->hash_code.key2;
	#endif
	break;
case 'R' :
	#if INCREMENTAL_HASH==1
	s->pawn_hash_code.address^=awptr->hash_code.address;
	s->pawn_hash_code.key^=awptr->hash_code.key;
	//s->pawn_hash_code.key2^=awptr->hash_code.key2;
	#endif
	break;
default :
	break;
}
#if INCREMENTAL_HASH==1
s->hash_code.address^=awptr->hash_code.address;
s->hash_code.key^=awptr->hash_code.key;
//s->hash_code.key2^=awptr->hash_code.key2;
#endif

// Remplit la case d'arrive
aptr->wptr=awptr;
aptr->num_piece=awptr->num_piece;
aptr->color=color;
aptr->color01=color01;
aptr->nature=nature;
aptr->piece_value=abs(awptr->value);
// Vide la case de dpart
dptr->nature=0;
dptr->wptr=&xwnull;
dptr->num_piece=99;
dptr->piece_value=0;
dptr->color=0;
dptr->color01=-1;
dptr->piece_value=0;


// Complment de coup pour les roques
if (move_is_castle)
{
switch ((short) arr)
{
case 48 : complement_roque=1; // Variable statique
		 move2=MOVE_MAKE('T',56,40,0,0);
		 jouer(move2);
	     	 complement_roque=0;
	     	 break;
case 16 : complement_roque=1; // Variable statique
		 move2=MOVE_MAKE('T',0,24,0,0);
		 jouer(move2);
	     	 complement_roque=0;
		 break;
case 55 : complement_roque=1; // Variable statique
		 move2=MOVE_MAKE('T',63,47,0,0);
		 jouer(move2);
	       complement_roque=0;
		 break;
case 23 : complement_roque=1; // Variable statique
		 move2=MOVE_MAKE('T',7,31,0,0);
		 jouer(move2);
	       complement_roque=0;
		 break;
default: break;
}
}

// Attention : lastmove est 
if (nature=='R')
{
	maj_coordonnees_roi(xwtm);
}



#if DEBUG==1
#if USE_BITBOARD_MOVE_GENERATION==1 || CHECK_MOVE_GENERATION_WITH_BITBOARDS==1
char i;
for (i=63;i>=0;i--)
{ 
	if (xboard[i].nature!=0)
	{
	if (bit(s->cases_toutes_pieces[xboard[i].color01], i)!=1)
	{
		log_error("\nErr J_8521 en : %d", xcompteur);

	}
	}
	if (xboard[i].nature==0)
	{
	if (
		bit(s->cases_toutes_pieces[0], i)==1
		|| bit(s->cases_toutes_pieces[1], i)==1
		)
	{
		log_error("\nErr J_8522 en : %d", xcompteur);

	}
	}
	if (xboard[i].nature=='P')
	{
	if (bit(s->cases_pions[xboard[i].color01], i)!=1)
	{
		log_error("\nErr J_8523 en : %d", xcompteur);

	}
	}
	if (bit(s->cases_pions[0], i)==1
		|| bit(s->cases_pions[1], i)==1
		)
	{
	if (xboard[i].nature!='P')
	{
		log_error("\nErr J_8524 en : %d", xcompteur);

	}
	}
}
#endif
#endif

#if DEBUG==1
if (xboard[arr].color01==-1)
	log_error("\nErr J_857 en : %d", xcompteur);

#endif

// Inversion xwtm en fin de jouer
if (complement_roque==0) { xwtm=1-xwtm; }


#if DEBUG==1
if (dptr->wptr==&xwnull && dptr->nature!=0)
	log_error("\nErreur J_925 : %d",xcompteur);
if (aptr->wptr==&xwnull && aptr->nature!=0)
	log_error("\nErreur J_926 : %d",xcompteur);
#endif


#if DEBUG==1 && INCREMENTAL_HASH==1
gen_code(1);
#endif

} // fin jouer


#if CHECK_CHECKS==1
// Seulement pour vrifier l'existence des checs
PIECE* SEARCH::check_analysis2(STATEVALUES *s,char level)
{
char a,b;
char statut_echec, F_echec_double;
PIECE *chk_ptr;
char nc=0;
char local_wtm;
char roi_num;

// Initialisations
statut_echec=0;
F_echec_double=0;
local_wtm=xwtm;
if (wtm==1) {a=0; b=xw_size[1];}
else        {a=16;b=xw_size[0];}
roi_num=xnum_roi[local_wtm];


// chk_analysis==0 : pas d'chec
// chk_analysis==1 : chec
// chk_analysis==2 : chec double


// Mise ... jour des clouages et des checs
full_testcheck(xw[roi_num].pos,local_wtm);
chk_ptr=full_testcheck_chkptr[xwtm];

if (testcheck_echecs_count>1) 
{
	statut_echec=(char) ECHEC_DOUBLE; // double
	F_echec_double=1;
}
else if (testcheck_echecs_count==1)
{
	statut_echec=chk_ptr->nature;
}
else statut_echec=(char) PAS_ECHEC; // 0


// xchk_analysis
xchk_analysis2[level]=statut_echec; 

// Sortie immdiate si pas chec
if (statut_echec==(char) ABSENCE_ECHEC)
{
return NULL;
}

return full_testcheck_chk_ptr;
} // fin fonction check_analysis



inline bool SEARCH::looklist(char *ptr, char arr)
{
// Routine de givecheck()
// et de give_protection();

*(ptr+7)=99; // prcaution
for(;;ptr++)
{
if (*ptr==99) return 0;
if (*ptr==arr) return 1;
}
return 0; // n'arrive jamais

/* Ancienne version
register char p;
// On conserve un compteur par prudence !
for (p=0; p<=6; p++, ptr++)
{
if (*ptr==99)  return 0;
if (*ptr==arr) return 1;
}
return 0;
*/

} // fin check::looklist



void SEARCH::inventaire_cases_echecs2(void)
{
// Cette fonction sert au camp attaquant pour dterminer les cases d'chec
// Remarque: il n'est pas ncessaire de prvoir deux listes
// car blanc commence par rechercher les checs de l'aversaire
// puis rutilise la liste pour son propre usage 
// pour inventorier les cases d'checs

// La fonction inventaire_cases_echecs() est exclusivement
// invoque par le camp attaquant pour dcompter les cases d'chec dont il dispose
// Le camp dfendant liste ses cases d'checs dans check_analysis si
// xlevel>=xextendlevel

char roi_pos;
char attacking_player;
char local_wtm;
char *start_ptr,*ptr;


// Roi adversaire
local_wtm=xwtm;
roi_pos=xw[xnum_roi[1-local_wtm]].pos;
attacking_player=TO_PLAYER(local_wtm);
start_ptr=&xcases_echec[xlevel][0][0];

// Fonction construisant la table des cases d'checs possibles
// pour consultation ultrieures par les fonctions givecheck2 et SEARCH::looklist


// premire diagonale
ptr=start_ptr; // &xcases_echec[local_wtm][0][0];
ptr=recherche_case_echec2(ptr,attacking_player,roi_pos,-9,'F');
ptr=recherche_case_echec2(ptr,attacking_player,roi_pos,+9,'F');
*ptr=99;

// deuxime diagonale
ptr=start_ptr+8; // &xcases_echec[local_wtm][1][0];
ptr=recherche_case_echec2(ptr,attacking_player,roi_pos,-7,'F');
ptr=recherche_case_echec2(ptr,attacking_player,roi_pos,+7,'F');
*ptr=99;

// verticale
ptr=start_ptr+16; // &xcases_echec[local_wtm][2][0];
ptr=recherche_case_echec2(ptr,attacking_player,roi_pos,-1,'T');
ptr=recherche_case_echec2(ptr,attacking_player,roi_pos,+1,'T');
*ptr=99;

// horizontale
ptr=start_ptr+24; // &xcases_echec[local_wtm][3][0];
ptr=recherche_case_echec2(ptr,attacking_player,roi_pos,-8,'T');
ptr=recherche_case_echec2(ptr,attacking_player,roi_pos,+8,'T');
*ptr=99;

} // fin inventaire_cases_echec2(ech)



inline char* SEARCH::recherche_case_echec2(char *ptr, char attacking_player,char roi_pos,char inc, char nat1)
{
char nbinc_max, nb_inc;
char casetest;
char compteur_pieces_attaquant;
char num;
char nature;
CASE *cptr;
char color2;



// Cette fonction sert au camp attaquant pour dterminer les cases d'chec

#if DEBUG==1
char y_casetest;
char dd;
#endif

// Initialisation
casetest=roi_pos+inc;
compteur_pieces_attaquant=0;
nb_inc=1;
nbinc_max=NBINC_DIRECTION(roi_pos,inc);

while(nb_inc<=nbinc_max)
{
cptr=&xboard[casetest];
//if ( cptr->nature==CASE_HORS_ECHIQUIER ) return ptr;
#if DEBUG==1
	dd=0;
	y_casetest=Y64(casetest);
	if ( y_casetest>7 ) dd=1;
	if ( y_casetest<0) dd=1;
	if ( casetest<0  ) dd=1;
	if ( casetest>63  ) dd=1;
	if (dd==1) 
	{
		log_error("\nErreur J_642 en : %d", xcompteur);
;
	}
#endif
color2=xboard[casetest].color;
if (color2==attacking_player && compteur_pieces_attaquant==0)
{
compteur_pieces_attaquant=1; // arme
num=xboard[casetest].num_piece;
}
else // 1
{
if (color2==attacking_player && compteur_pieces_attaquant==1)
{
nature=xboard[casetest].nature;
if (nature!=nat1 && nature!='D') break; // pas d'chec 
// ok batterie
//if (xbatterie[xlevel][0]==99) xbatterie[xlevel][0]=num;
//else 			            xbatterie[xlevel][1]=num;
break;
}
else // 2 : xp!=attacking_player
{
if (compteur_pieces_attaquant==0)
{
// les cases ne sont enregistrs que si compteur_piece_attaquant==0
// car si compteur_piece_attaquant==1 on a pass une pice du camp attaquant
*ptr=casetest;
ptr++;
}
casetest=casetest+inc; nb_inc++;
if (color2==0) continue;
if (color2==-attacking_player) break; // La pice est une pice du camp dfendant
} // fin else 2
} // fin else 1
} ;

return ptr;
// Explication
// - si on trouve une des ses propres pices : break
// - sinon on enregistre la case (vide ou pice adverse)
// - si pice adverse, break;

} // fin fonction recherche_case_echec2




CHECK_STATUS SEARCH::givecheck2(STATEVALUES *s, MOVE move)
{
char arr;
char checking_nature;
char diag1, diag2;
char num;
char posx, posy;
char roi_posx, roi_posy;
char roi_diag1, roi_diag2;
char roi_pos;
PIECE *wptr;
CASE *cptr;
char *start_ptr;
char c1;
//char color01;

// Fonction dterminant si un coup donne chec
// 4 grandes directions possibles
// + pions
// + cavaliers
// Sur chaque direction, 7 cases possibles
// 1 case supplmentaire prvue pour le marqueur de fin 99
// => tableaux  8 entres
// ptr    ->0 premire diagonale
// ptr+8  ->1 deuxime diagonale
// ptr+16 ->2 verticale
// ptr+24 ->3 horizontale

// Initialisations
//roi_pos=xw[xnum_roi[local_other_wtm]].pos;
roi_pos=s->roi_pos[other_wtm];
arr=MOVE_ARR64(move);
num=MOVE_NUM_PIECE(move);


// Retraitement pour les roques
if (MOVE_IS_CASTLE(move))
{
switch(arr)
{
case 48 : // Petit roque blanc
			num=xboard[56].num_piece;
			arr=40;
			break;
case 16 : // Grand roque blanc
			num=xboard[0].num_piece;
			arr=24;
			break;
case 55 : // Petit roque noir
			num=xboard[63].num_piece;
			arr=47;
			break;
case 23 : // Grand roque noir
			num=xboard[7].num_piece;
			arr=31;
			break;
default : break;
}		
}


// Structure listant les cases possibles 
start_ptr=&xcases_echec[xlevel][0][0]; // [4][8]

// Cible adverse
cptr=&xboard[roi_pos];
roi_posx=cptr->posx;
roi_posy=cptr->posy;
roi_diag1=cptr->diag1;
roi_diag2=cptr->diag2;

// Pice donnant chec ou protection
cptr=&xboard[arr];
posx=cptr->posx;
posy=cptr->posy;
diag1=cptr->diag1;
diag2=cptr->diag2;
wptr=&xw[num];

// Nature de la pice donnant chec
if (!MOVE_IS_PROMOTION(move)) 
	 checking_nature=wptr->nature;
else // promotion
	 checking_nature=MOVE_PROMOTION(move);

// Recherche 
switch (checking_nature)
{
case 'P' : 
	   c1=PLAYER(wptr->color,(roi_pos-arr));
	   if (c1==9 || c1==-7) return CHECK;
	   return NO_CHECK;

case 'D' : 
	   if ( diag1==roi_diag1) 
	   { if (looklist(start_ptr,arr  ) ==1) return CHECK; }
	   if ( diag2==roi_diag2) 
	   { if (looklist(start_ptr+8,arr) ==1) return CHECK; }
	   if ( posx==roi_posx ) // verticale
	   { if (SEARCH::looklist(start_ptr+16,arr)==1) return CHECK; }
	   if ( posy==roi_posy ) // horizontale
	   { if (looklist(start_ptr+24,arr)==1) return CHECK; }
	   return NO_CHECK;

case 'T' : 
	   if ( posx==roi_posx ) // verticale
	   { if (looklist(start_ptr+16,arr)==1) return CHECK; }
	   if ( posy==roi_posy ) // horizontale
	   { if (looklist(start_ptr+24,arr)==1) return CHECK; }
	   return NO_CHECK;

case 'F' : 
	   if ( diag1==roi_diag1) 
	   { if (looklist(start_ptr,arr)  ==1) return CHECK; }
	   if ( diag2==roi_diag2) 
	   { if (looklist(start_ptr+8,arr)==1) return CHECK; }
	   return NO_CHECK;

case 'C' : 
	   c1=abs(roi_pos-arr);
	   if (c1==17 || c1==15 || c1==10 || c1==6) 
	   {
		return KNIGHT_MOVE_DEP_ARR_COMPATIBILITY(arr,roi_pos);
	   }
	   return NO_CHECK; 
case 'R' : return NO_CHECK;
}
return NO_CHECK;
} // fin givecheck2
#endif



void SEARCH::dejouer(MOVE move,char actu)
{

PIECE *dwptr;     // local
char pion_ep;		// local - prise en passant
char prom;
MOVE move2;
char static complement_roque=0;
#if DEBUG==1
char local_player;
#endif
char i, n;
CASE *aptr, *dptr;
bool move_is_special, move_is_promotion, move_is_en_passant, move_is_capture, move_is_castle;
PIECE **pptr;
PIECE *wptr;

// Djouer
// - ne dpend pas de wtm

// Dpend de prise_nat et de prise_num
// dans xligne
// prise_num donne le numro de la pice prise
// Attention au cas de la prise en passant
// Prise_num doit tre renseign

// Attention : djouer rinitialise aussi REACTU
// trs important


// Ractualisation des pointeurs de toutes les pices concernes
// Doit tre plac aprs la restauration des pices
// ( sinon le test d'existence de la pice  restaurer ramne une erreur )
// ( Note : Cette actualisation est redondante pour les pices joues
//   avec le restore  partir de xsavepiece 
//   En effet, les pices restaures n'ont pas besoin de cette actualisation
//   la restauration ayant lieu aprs
// Par ailleurs, cette actualisation n'est pas ncessaire
// en cas de passe, car dans ce cas, aucune pice n'est actualise
// Enfin, cette actualisation ne peut pas tre place  la fin
// car  ce moment, le psptr des pices joues a dja t repositionn
// par le xsavepiece
// C'est aussi pour cette raison que cette opration doit obligatoirement
// tre faite au niveau de dejouer, et pas au niveau de xlevel--
// (sinon on fait 1 fois de trop cette opration).
// Cette opration doit aussi tre faite galement en cas de passe
// si l'option subactualise_all a t choisie
if (actu==1 && complement_roque==0)
{
pptr=search_level->reactu_liste;
n=search_level->reactu_liste_nombre;
for (i=0;i<n;i++, pptr++)
{
wptr=*pptr;
wptr->psptr=wptr->psptr->oldptr;
}
// Il pourait y avoir deux djouer conscutif (roque)
// mme si le deuxime dejouer et fait avec actu=0
// il ne faut pas repasser sur la liste ( qui a t en plus 
// mise  zro ). Donc :
search_level->reactu_liste_nombre=0;
}

// Contrle levelmoves
// levelmoves doit toujours tre infrieur ou gal  xlevel
// si levelmoves est suprieur, il y a pb
#if DEBUG==1
//char j;
wptr=&xw[31];
for (i=31; i>=0; i--,wptr--)
{
if (wptr->nature==0) continue;
if (wptr->psptr->levelmoves>xlevel && xlevel>1)
{
	log_error("\nJ_402 Pb xactu en : %d", xcompteur);
}
}
#endif


// Seulement si dernier coup gale passe
// Mais aprs la mise  jour par ractu
// par exemple parce qu'on peut souhaiter 
// faire un subactualise_all de debug systmatique (TOUT A FAIT !)
if (MOVE_IS_PASSE(move))
{	
	 // Attention : ne pas rinitialiser xpasse
	 // car il peut y avoir plusieurs nullmove (non conscutifs)
	 // xpasse=false; 
	 *ligne=LigneEnd;
	 xwtm=1-xwtm;
	 return;
}


// Initialisation
move_is_special=MOVE_IS_SPECIAL(move);
if (move_is_special)
{
	prom=MOVE_PROMOTION(move);
	move_is_promotion=MOVE_IS_PROMOTION(move);
	move_is_castle=MOVE_IS_CASTLE(move);
	move_is_en_passant=MOVE_IS_EN_PASSANT(move);
}
else 
{
	move_is_castle=false;
	move_is_en_passant=false;
	move_is_promotion=false;
}
move_is_capture=MOVE_IS_CAPTURE(move);



// Initialisations
dptr=&xboard[MOVE_DEP64(move)];
//dwptr=&xw[mpt->num_piece];
aptr=&xboard[MOVE_ARR64(move)];
dwptr=aptr->wptr;
//prise_nat=MOVE_CAPTURE(move);
//prise_num=mpt->prise_num;

#if DEBUG==1
char dep, arr;
dep=MOVE_DEP64(move);
arr=MOVE_ARR64(move);
local_player=aptr->color;
#endif


// Roques
// Avant toute chose car djouer appelle djouer !!!!!
// Ce qui pourrait poser des problmes de variables
if (move_is_castle)
{
complement_roque=1; // variable statique
switch((short) MOVE_ARR64(move))
{
case 48 :	 move2=MOVE_MAKE('T',56,40,0,0);
		 dejouer(move2,0); 
		 break;
case 16 :    move2=MOVE_MAKE('T',0,24,0,0);
		 dejouer(move2,0); 
		 break;
case 55 :    move2=MOVE_MAKE('T',63,47,0,0);
		 dejouer(move2,0); 
		 break;
case 23 :    move2=MOVE_MAKE('T',7,31,0,0);
		 dejouer(move2,0); 
		 break;
}
complement_roque=0; // Variable statique
} // fin roque



// Note : jouer ne dpend plus de xwtm
// ide : rendu indpendant au moyen de num
// il n'y a pas de cas o num et xwtm soient
// en contradiction pour jouer().
#if DEBUG==1
char cc;
cc=0;
// Dtecte les cas o xwtm est inexact !
if (local_player!=1-2*xwtm) cc=1;
if (arr<0 || arr>63) cc=1;
// Dtecte les cas o xwtm est inexact !
if (cc==1)
{
log_error("\nErreur J_xwtm3 : %d",xcompteur);
}
#endif





// Promotion
// (avant la rinitialisation des cases d'chiquier)
// ( +Pourquoi ? )
if (move_is_promotion) 
{
dwptr->nature='P';
setvalue(dwptr);
}


// Restauration case dpart et arrive et pice
if ( complement_roque==0 )
{
*dptr=savesquare[0];
*aptr=savesquare[1];
*dwptr=savepiece[0]; 
}
else // roque - coup de tour
{
*dptr=savesquare[2];
*aptr=savesquare[3];
*dwptr=savepiece[1];
}

// Restauration pice
// => assure par la ractualisation de psptr 

// Rsurrection de pice prise
if (move_is_capture)
{
if (move_is_en_passant) // prise en passant
{
// pour rinitialiser la case du pion pris
pion_ep=MOVE_ARR64(move)-dwptr->color;
xboard[pion_ep]=savesquare[2];
xw[xboard[pion_ep].num_piece].nature=xboard[pion_ep].nature;
}
else
{
// Restauration pice prise
// => on a juste  restaurer nature
aptr->wptr->nature=aptr->nature;
}

// fin de rsurrection de pice_prise
}

// Inversion xwtm en fin de djouer
if (complement_roque==0) xwtm=1-xwtm;

/*
#if DEBUG==1
if (complement_roque==0)
check_reset_state_values(xlevel,0);
#endif
*/

/*
// Contrle
#if DEBUG==1
cptr=&xboard[63];
for (i=63;i>=0;i--,cptr--)
{
if (cptr->wptr==&xwnull) continue;
if (cptr->posy==0 || cptr->posy==9) continue;
cc=0;
if (cptr->wptr->pos!=i) cc=1;
if (cptr->nature==0 && cptr->color!=0) cc=1;
if (cc==0) continue;
log_error("\nErreur S_701 en : %d", xcompteur);
}
#endif
*/

#if DEBUG==1 && INCREMENTAL_HASH==1
if (complement_roque==0)
{
// Ncessaire pour dbogage
xstates[xlevel+1]=xstates[xlevel];
//xsearch_level[xlevel+1]->ep_square64=xsearch_level[xlevel]->ep_square64;
gen_code(1);
}
#endif

*ligne=LigneEnd;
} // fin djouer


bool SEARCH::givecheck_cavalier(char arr)
{
return (bool) bit(xcases_arrivee_cavalier[s->roi_pos[1-xwtm]],arr);
} // fin


bool SEARCH::givecheck_pion(char arr, char wtm)
{
return (bool) bit(xcases_echec_pion[wtm][s->roi_pos[1-wtm]],arr);
} // fin



/* A conserver
bool SEARCH::givecheck_cavalier(char arr)
{
//char inc;
char posroi;
posroi=xw[xnum_roi[1-xwtm]].pos;
// Test givecheck
switch(abs(posroi-arr))
{
case 17 : break;
case 15 : break;
case 10 : break;
case 6  : break;
default : return false;
};
if (KNIGHT_MOVE_DEP_ARR_COMPATIBILITY(arr,posroi)) return true;
else 	return false;
} // fin
*/






bool SEARCH::givecheck_roi(const MOVE move)
{
bool F_gives_check;
char cc;

// Nouvelle version
#if DEBUG==1
// A conserver
// gen_code a besoin de xstates du level+1
// jouer met  jour xstates+1 temp_rec
// mais en mode de jeu normal pour un jouer-dejouer, le gen_code n'est pas vrifi dans jouer
// et l'actualisation de temp_rec au level suprieur n'est pas utile
xstates[xlevel+1]=xstates[xlevel]; // ncessaire pour gen_code et jouer
#endif


cc=legal(MOVE_NUM_PIECE(move),move,xnum_roi[xwtm],*lignemoins);
if (cc!=1) return false;


next_search_level->jouer(move);
// xwtm a chang
// testcheck est de type PIECE *
F_gives_check=limited_testcheck(move,s->roi_pos[xwtm],xwtm);
next_search_level->dejouer(move,0);

return F_gives_check;

/* Ancienne version
unsigned __int64 *cases_echec;

// Cette fonction est loin d'tre exhaustive
// Le roi blanc n'est pas transparent
// et pour les roques, seuls les checs verticaux sont donns
// Les dcouvertes de roi sont sans effet

// Echecs verticaux des roques
if (MOVE_IS_CASTLE(move))
{
cases_echec=&xstates[xlevel].cases_echec_tour[xwtm];
switch(MOVE_ARR64(move))
{
case 48 : // Petit roque blanc
			return givecheck64(*cases_echec,40); //to_64(61)	  
			break;
case 16 : // Grand roque blanc
			return givecheck64(*cases_echec,24); //to_64(41)		  
			break;
case 55 : // Petit roque noir
			return givecheck64(*cases_echec,47); //to_64(68)	  
			break;
case 23 : // Grand roque noir
			return givecheck64(*cases_echec,31); //to_64(48)
			break;
}		
}

return false;
*/

} // fin givecheck_roi



CHECKING_STATUS SEARCH::givecheck(const MOVE move, char local_wtm)
{
// MOVE pour rcprer le numro de pice
char arr64;
char checking_nature;
char cc;
#if DEBUG==1 
char dd; 
#endif
// MOVE pour le numro de pice

// Initialisations 
cc=0;


#if RECHERCHE_DECOUVERTES==1
if (F_decouverte
	#if DECOUVERTES_ON_EXTEND==1 // confirm : 1
	// En extend les choses sont gres diffremment
	// Si 0, F_decouverte=> !xextend
	&& !xextend
	#endif
	)
{
	if (MOVE_NUM_PIECE(move)==decouverte_num)
	{
			if (xw[decouverte_num].nature=='C') 
			{ return CHECK; }
			// Toujours vrai pour le cavalier
			// On prend tous les coups ici 
			// car on esten search
			if (abs(MOVE_INC64(move))
				!=abs(xinc64_from64_to64[MOVE_DEP64(move)][s->roi_pos[1-wtm]]))
			{ 
				#if _DEBUG==1
				cc=0;
				#endif
				return CHECK; 
			}
	}
}
#endif 


if (MOVE_IS_PROMOTION(move)) checking_nature=MOVE_PROMOTION(move);
else checking_nature=MOVE_NATURE(move);
arr64=MOVE_ARR64(move);

switch(checking_nature)
{
case 'P' : //if (givecheck64(s->cases_echec_pion[local_wtm],arr64) ) 
		   if (givecheck_pion(arr64,local_wtm)) 
		   { 
			   cc=1; 
			   break; 
		   }
	  break;
case 'C' : if (SEARCH::givecheck_cavalier(arr64))
		   { 
			   cc=1; 
			   break;
		   }
	  break;
case 'F' : if (givecheck64(s->cases_echec_fou[local_wtm],arr64)) 
		   { 
			   cc=1; 
			   break;
		   }
	  break;
case 'T' : if (givecheck64(s->cases_echec_tour[local_wtm],arr64)) 
		   { 
			   cc=1; 
			   break;
		   }
	  break;
case 'D' : if (givecheck64(s->cases_echec_dame[local_wtm],arr64)) 
		   { 
			   cc=1; 
			   break;
		   }
	  break;
case 'R' : if (SEARCH::givecheck_roi(move)) 
		   { 
			   cc=1; 
			   break;
		   }
	  break;
default : break;
}


#if CHECK_CHECKS==1
char dd;
dd=SEARCH::givecheck2(move);
if (cc!=dd)
log_error("\nErr J_281 en : %d", xcompteur);

#endif


if (cc==1) 
	return CHECK;
return NO_CHECK;
}




char fct_repetition(MOVE lignemove, H_CODE &h, short lastprise2)
{

#if DEBUG==1 && NO_REPETITION_CHECK==1
return 0;
#endif

char cc,dd; // Occurrences totales et en jeu virtuel
short i;
short limitebasse;
short jeu_virtuel;
H_CODE *key_ptr;
//H_CODE key;
char ci1, ci2;
short si;

// Astuce ?
if (MOVE_IS_CAPTURE(lignemove)) 
			return NOT_DRAW;
if (MOVE_IS_PAWN(lignemove))
			return NOT_DRAW;
if (MOVE_IS_SPECIAL(lignemove))
			return NOT_DRAW;



// Remarque : la condition de nulle est en fait
// 3 occurrences
// ou 2 occurrences dont une en jeu rel
// En effet :
// Jeu rel : Rg7 Dg4 Rf8
// 1 Df4 Rg7 2 Dg4+ Rf8 3 Dd4 reprsente la mme squence que
// 1 Dd4
// Consquence : Enregistrement de la suite avec un mauvais
// niveau de profondeur en hash table : 5 au lieu de 1
// Il faut donc corriger la profondeur enregistre en hash
// table et la reduire de 2 fois le nombre d'checs donns
// Par ailleurs, il est souhaitable de constater une rptition
// ds 2 Dg4, soit une occurrence en jeu rel et une en jeu virtuel
// (en jouant Dg4 on ralise une deuxime occurrence).


// Si passe, pas de rptition	

// Test rptition de coups
if (xnbcoups+xlevel-lastprise2<4) return NOT_DRAW;

// En effet, on a jou nbcoups+level+1
// lastprise blanc noir blanc noir blanc
// coups:     6     7    8    9     10
// lastprise: 6
// Prsent: 1ire       2ime      3ime
// Delta=     0     1    2    3     4
// Note : c'est bien au joueur qui va jouer de rclamer la rptition
// Elle s'obtient en jouant le coup.

// le stockage des oldpositions va jusqu'en nbcoups-lastprise1
// le stockage des newpositions est en nbcoups-lastprise1+level

// Note : xlastprise1 est la dernire prise en jeu rel
// Note : xlastprise2 est la dernire prise en jeu virtuel
// (les deux concident si xlevel==0 ou s'il n'y a pas eu de prises)


// Initialisations
// si : lieu de stockage de l'avant-avant dernire position
// Initialisations
cc=1;
dd=1;
si=xnbcoups-xlastprise1+xlevel-2;
jeu_virtuel=si-xlevel+1;
limitebasse=lastprise2-xlastprise1;


// Dbogage
#if DEBUG==1
if (si>=STMAX+2+100-1
	|| limitebasse<0)
{
 cc=1;
 log_error("\nErreur J_003 : %d",xcompteur);
}
#endif


// Comparaisons
key_ptr=&xliste50[si];

for (i=si; i>=limitebasse; i-=2,key_ptr-=2)
{
if (key_ptr->address==h.address)
{
	if(key_ptr->key==h.key)
	{
		if (i>=jeu_virtuel) 
		{
			dd++;
			if (xlevel>2) 
					return REPETITION_DRAW;
		}
		cc++;
	}
}
}


// Obtention c1 et c2
ci1=cc-dd; // c1==occurrences en jeu rel
ci2=dd;


// Problme :
// avec la rgle deux occurrences dont une en virtuel = nulle
// lorsque noir rptait en jeu rel avec avantage, 
// blanc rptait estimant avoir la nulle
// C'est une erreur, car il n'y a pas nulle et blanc
// peut avoir mieux  faire que rpter, ce qu'il peut 
// trouver en approfondissant l'analyse
// La nulle d'analyse ne s'obtient donc qu'avec deux rptitions
// en jeu virtuel
// Modification 2006-08
// La nulle d'analyse s'obtient aussi pour chaque camp
// lorsqu'il rpte un position du jeu rel alors qu'il a l'avantage

// Nouveau
// La rgle est finalement : 
// Nulle d'analyse : au moins 2 occurrences en jeu virtuel
// ou une en rel et une en virtuel
// Nulle  rclamer : 3 occurrences en rel ou
// deux occurrences en rel et une en virtuel
// Rem : 3 occurrences en rel ne doit pas arriver !
if (ci1==3 || (ci1==2 && ci2==1))
		return REPETITION_DRAW;
else
// Deux occurrences en virtuel
if (ci2>=2)
{
	 return REPETITION_DRAW;
}

// Une occurence en rel et une en virtuel
// ou deux en rel
// pour xlv1_player seulement
// Dans ce cas, on ne considre qu'il y a nulle
// que si le joueur au trait a l'avantage
// ( il n'a rien trouv de mieux que rpter )
if (ci1+ci2>=2)
{
	if (xlevel<3)
		return NOT_DRAW_DISTRUST_HASH_TABLE;
	else 
	    return REPETITION_DRAW;
}

return NOT_DRAW;


// La ligne peut avoir t enregistre sans rptition dans les hash_table
// Si blanc trouve la suite en hash_table, il pourrait retourner un score positif
// alors qu'il y a dja deux rptitions et que noir va pouvoir jouer la troisime
// Dans ce cas on retourne 2, et on ne regarde plus les hash_tables
// Ceci peut correspondre  2 entres en jeu rel, 1 en rel et 1 en virtuel et 2 en virtuel (mais dans ce cas on est dja sorti)
// ATTENTION : mme si on a 0 rptitions de la position pour blanc
// rien n'empche noir d'avoir au prochain coup une troisime rptition
// Il suffit que blanc n'ait pas vari les coups et que noir ait vari les coups !!!
// Pour cette raison, ne pas accepter les rsultats des hash tables au level 1

} // fin rptition



#if CHECK_REPET==1 && DEBUG==1
char fct_repetition2(MOVE move, short lastprise2)
{
char cc,dd;

// Astuce 
if (MOVE_IS_CAPTURE(move)) 
			return NOT_DRAW;
if (MOVE_IS_PAWN(move))
			return NOT_DRAW;
if (MOVE_IS_SPECIAL(move))
			return NOT_DRAW;




#if DEBUG==1 && NO_REPETITION_CHECK==1
return NOT_DRAW;
#endif

// cc nombre d'occurrences anciennes en jeu rel
// dd nombre d'occurrences anciennes en jeu virtuel

short yyy;
char num;
char ee;
short i;
short max;
ee=0;
short si;
char ci1, ci2;
char *ptr;
char r;

// Si passe, pas de rptition	
// if (xpasse) return NOT_DRAW;

// cc nombre d'occurrences anciennes en jeu rel
// dd nombre d'occurrences anciennes en jeu virtuel

// Test rptition de coups
if (xnbcoups+xlevel-lastprise2<4) return NOT_DRAW;


// En effet, on a jou nbcoups+level+1
// lastprise blanc noir blanc noir blanc
// coups:     6     7    8    9     10
// lastprise: 6
// Prsent: 1ire       2ime      3ime
// Delta=     0     1    2    3     4
// Note : c'est bien au joueur qui va jouer de rclamer la rptition
// Elle s'obtient en jouant le coup.

// le stockage des oldpositions va jusqu'en nbcoups-lastprise1
// le stockage des newpositions est en nbcoups-lastprise1+level+1

// Note : xlastprise1 est la dernire prise en jeu rel
// Note : xlastprise2 est la dernire prise en jeu virtuel
// (les deux concident si xlevel==0 ou s'il n'y a pas eu de prises)
// max : nombre de positions ... contr"ler
max=(xnbcoups+xlevel-lastprise2);
max=max-M_2(max);
// 2 comparaisons pour 4 et 5 demi-coups
// Attention % = oprateur modulo (!=division)
// (car on fait i=2; i<=max; i++, i++)

// test 1
#if DEBUG==1
if (xnbcoups-xlastprise1>=100)
{
ee=1;
log_error("\nErr J_003 : ", xcompteur);
}
#endif


num=MOVE_NUM_PIECE(xligne[xlevel]);
// si : lieu de stockage de la dernire position
si=xnbcoups-xlastprise1+xlevel;
yyy=xpositions[si][num];
ee=0;
dd=0;


// Comparaison pour la pice de rfrence
for (i=2; i<=max; i++,i++)
{
if (yyy==xpositions[si-i][num]) dd++;
}

// Deuxime tape ?
if (dd<1) {return NOT_DRAW;} // Pas d'occurrence de la position

// Deuxime tape : comparaison pour tout l'chiquier
dd=0; // nombre d'occurrences anciennes en jeu virtuel
cc=0; // nombre d'occurrences anciennes en jeu rel
ptr=&xpositions[si][0];
for (i=2; i<=max; i++,i++)
{
r=memcmp(ptr,&xpositions[si-i][0],32);
// note : risque de rotation des pices 
// mais pas plus de 32 pices par chiquier

if (r==0 && xlevel-i>0 ) dd++;
if (r==0 && xlevel-i<=0) cc++;
}

// cc nombre d'occurrences anciennes en jeu rel
// dd nombre d'occurrences anciennes en jeu virtuel

// Ajustement cc et dd pour ajouter occurrence prsente
if (xlevel==0) cc++; // une occurrence relle
else           dd++; // une occurrence virtuelle





// Obtention c1 et c2
ci1=cc-dd; // c1==occurrences en jeu rel
ci2=dd;


// Problme :
// avec la rgle deux occurrences dont une en virtuel = nulle
// lorsque noir rptait en jeu rel avec avantage, 
// blanc rptait estimant avoir la nulle
// C'est une erreur, car il n'y a pas nulle et blanc
// peut avoir mieux  faire que rpter, ce qu'il peut 
// trouver en approfondissant l'analyse
// La nulle d'analyse ne s'obtient donc qu'avec deux rptitions
// en jeu virtuel
// Modification 2006-08
// La nulle d'analyse s'obtient aussi pour chaque camp
// lorsqu'il rpte un position du jeu rel alors qu'il a l'avantage

// Nouveau
// La rgle est finalement : 
// Nulle d'analyse : au moins 2 occurrences en jeu virtuel
// ou une en rel et une en virtuel
// Nulle  rclamer : 3 occurrences en rel ou
// deux occurrences en rel et une en virtuel
// Trois occurrences 
if (ci1==3 || (ci1==2 && ci2==1))
		return REPETITION_DRAW;
else
// Deux occurrences en virtuel
if (ci2>=2)
{
	 return REPETITION_DRAW;
}

// Une occurence en rel et une en virtuel
// ou deux en rel
// pour xlv1_player seulement
// Dans ce cas, on ne considre qu'il y a nulle
// que si le joueur au trait a l'avantage
// ( il n'a rien trouv de mieux que rpter )
if (ci1+ci2>=2)
{
	if (xlevel<3)
		return NOT_DRAW_DISTRUST_HASH_TABLE;
	else 
		return REPETITION_DRAW;
}

return NOT_DRAW;


// La ligne peut avoir t enregistre sans rptition dans les hash_table
// Si blanc trouve la suite en hash_table, il pourrait retourner un score positif
// alors qu'il y a dja deux rptitions et que noir va pouvoir jouer la troisime
// Dans ce cas on retourne 2, et on ne regarde plus les hash_tables
// Ceci peut correspondre  2 entres en jeu rel, 1 en rel et 1 en virtuel et 2 en virtuel (mais dans ce cas on est dja sorti)
// ATTENTION : mme si on a 0 rptitions de la position pour blanc
// rien n'empche noir d'avoir au prochain coup une troisime rptition
// Il suffit que blanc n'ait pas vari les coups et que noir ait vari les coups !!!
// Pour cette raison, ne pas accepter les rsultats des hash tables au level 1



} // fin repetition2()
#endif




void SEARCH::inventaire_cases_echecs(char local_player,char roi_pos,char nat1,char inc)
{
// Fonction de recherche des echecs et cases d'checs
#if DEBUG==1
char dd;
#endif
char check;
char ci;
char casetest;
char nature;
char nb_inc;
char local_wtm;
unsigned __int64 *cases_echec;
//, *cases_echec_pion;
CASE *cptr;
char indice_inc;
char nbinc_max;

// Initialisations
local_wtm=TO_COLOR01(local_player);
check=0;
nbinc_max=NBINC_DIRECTION(roi_pos,inc);
indice_inc=INDICE_INC64(inc);
switch(nat1)
{
case 'F' : cases_echec=&s->cases_echec_fou[1-local_wtm];
	       // cases_echec_pion=&s->cases_echec_pion[1-local_wtm];
		break;
case 'T' : cases_echec=&s->cases_echec_tour[1-local_wtm];
		break;
}

// Mise  un des cases d'checs en une et une seule instruction
// Attention | logique, car la recherche peut tre faite conscutivement 
// avec les valeurs positive et ngative de l'incrment
// Quand la direction sera interrompue, les cases suivantes seront mises  zro
// N'a pas  tre fait avec les cases de pion
*cases_echec|=xmasque_direction[roi_pos][indice_inc];


// roi est la position du roi
// local_player est le joueur qui a le roi
// nat1 donne le type de pice pouvant donner chec
// &echecs est l'adresse du compteur d'checs

for(casetest=roi_pos+inc,nb_inc=1;nb_inc<=nbinc_max;nb_inc++,casetest+=inc)
{
#if DEBUG==1
	ASSERT(MOVE_IS_OK_ASSERT(roi_pos,casetest,inc,IsNotKnight));
	dd=0;
	if (casetest<0) dd=1;
	if (casetest>63) dd=1;
	if (dd==1)
	{
		log_error("\nErreur J_733 en : %d", xcompteur);

	}
#endif
	
	if (bit(cases_occupees,casetest)==0) 
	{
		// Case vide
		// Enregistrer la case comme case d'chec
		// La case a dja t positionne  1 !
		// set_bit_to_1(*cases_echec,casetest); // macros
		/*
		if ( nb_inc==1 )
		{ 
				ci2=PLAYER(local_player,inc);
				if ( ci2==9 || ci2==-7 ) 
					set_bit_to_1(*cases_echec_pion,casetest); // macros
		}
		*/
		// Passer  la case suivante	
		continue; 
	}
	cptr=&xboard[casetest];
	ci=cptr->color;
	// Dans le cas des limited_testcheck, la pice arrive sur une 
	// case car elle est joue, mais le bitboard n'a pas t mis  jour
	// car on utilise celui du level
	if (ci==local_player)       
	{
		// Important : le roi est considr 
		// transparent - Ceci permet de grer 
		// le problme de l'chec invisible sur case de fuite
		if ( cptr->nature=='R' ) 
		{
			continue;
		}
		else
		{
			// Si pas recherche clouage ou RAZ checs,
			// retour
			// Direction interrompue
				*cases_echec&=xmasque_inverse_direction[casetest][indice_inc];
				/*
				if ( nb_inc==1 )
				{ 
				ci2=PLAYER(local_player,inc);
					if ( ci2==9 || ci2==-7 ) 
					set_bit_to_1(*cases_echec_pion,casetest); // macros
				}
				*/
		    return;
		}
	}
	ASSERT(ci==-local_player);
	{
			// Direction interrompue
		// la pice adverse est incluse dans les cases d'chec
			*cases_echec&=xmasque_inverse_direction[casetest][indice_inc];
		// Il y a-t-il chec ?
		nature=cptr->nature;
		if (    (nature==nat1 || nature=='D')
			 || (nature=='P' && nb_inc==1
			     && (PLAYER(local_player,inc)==-7 || PLAYER(local_player,inc)==9)
				)
			 || (nature=='R'&& nb_inc==1)
		   )
		{
		echecs_count++; // il y a chec !!
		chk_inc[local_wtm]=inc;
		if (chkptr[local_wtm]==NULL) 
		{ 
			chkptr[local_wtm]=cptr->wptr;
			#if DEBUG==1
			if (chkptr[local_wtm]->color==local_player)
				log_error("\nErreur J_647 en : %d", xcompteur);

			#endif
		}
		else if (cptr->wptr!=chkptr[local_wtm])
		{ chkptr2[local_wtm]=cptr->wptr; }
		}
		return;
	} // fin (ci==-player)
} // fin for
} // fin inventaire_cases_echecs


inline void SEARCH::recherche_echec_pour_testcheck(char local_player,char roi_pos,char nat1,char inc)
{
// Fonction de recherche d'checs et de clouage par direction
// (appele entre autres par testcheck, la fonction qui dtermine
// si le roi ou une case est en chec)
#if DEBUG==1
char dd;
#endif
char nbinc_max;
char ci;
char casetest;
char nature;
char nb_inc;
char local_wtm;
CASE *cptr;
char indice_inc;

// Initialisations
local_wtm=TO_COLOR01(local_player);
nbinc_max=NBINC_DIRECTION(roi_pos,inc);
indice_inc=INDICE_INC64(inc);


// roi est la position du roi
// local_player est le joueur qui a le roi
// nat1 donne le type de pice pouvant donner chec
// &echecs est l'adresse du compteur d'checs

for(casetest=roi_pos+inc,nb_inc=1,cptr=&xboard[casetest];
	nb_inc<=nbinc_max;nb_inc++,casetest+=inc,cptr+=inc)
{
#if DEBUG==1
	ASSERT(MOVE_IS_OK_ASSERT(roi_pos,casetest,inc,IsNotKnight));
	dd=0;
	if (!WITHIN_BOARD(casetest)) dd=1;
	if (dd==1)
	{
		log_error("\nErreur J_733 en : %d", xcompteur);

	}
#endif
	
	ci=cptr->color;
	if (ci==0) continue;
	if (ci==local_player)        //
	{
		// Important : le roi est considr 
		// transparent - Ceci permet de grer 
		// le problme de l'chec invisible sur case de fuite
		if ( cptr->nature=='R' ) 
		{
			continue;
		}
		else
		{
		    return;
		}
	}
	ASSERT(ci==-local_player);
	{
		// Il y a-t-il chec ?
		nature=cptr->nature;
		if (    (nature==nat1 || nature=='D')
			 || (nature=='P' && nb_inc==1
			     && (PLAYER(local_player,inc)==-7 || PLAYER(local_player,inc)==9)
				)
			 || (nature=='R'&& nb_inc==1)
		   )
		{
		testcheck_echecs_count++; // il y a chec !!
		#if _DEBUG==1
		full_testcheck_chk_inc[local_wtm]=inc;
		if (full_testcheck_chkptr[local_wtm]==NULL) 
		{ 
			full_testcheck_chkptr[local_wtm]=cptr->wptr;
			#if DEBUG==1
			if (full_testcheck_chkptr[local_wtm]->color==local_player)
				log_error("\nErreur J_647 en : %d", xcompteur);

			#endif
		}
		else if (cptr->wptr!=full_testcheck_chkptr[local_wtm])
		{ full_testcheck_chkptr2[local_wtm]=cptr->wptr; }
		#endif
		}
		return;
	} // fin (ci==-local_player)
} // fin for
} // fin recherche_echec_pour_testcheck





#if CHECK_CHECKS==1
inline void SEARCH::search_echecs_clouages_decouvertes2(char player,char roi_pos,char nat1,char inc)
{
char side_checked01;
// Remarque : la vesion classique ( sans 64b )
// ne gre pas les checs de pions 
// qui sont grs dans testcheck
#if DEBUG==1
char dd;
//char y_casetest;
#endif
char nbinc_max;
char casetest;
char compteur_pieces_amies;
char compteur_pieces_adverses;
char nb_inc;
char nature;
CASE *cptr;
char color2;

// Initialisations
casetest=roi_pos+inc;
compteur_pieces_amies=0;
compteur_pieces_adverses=0;
nb_inc=1;
nbinc_max=NBINC_DIRECTION(roi_pos,inc);

// Fonction de recherche d'checs et de clouage par direction
// (appele entre autres par testcheck, la fonction qui dtermine
// si le roi ou une case est en chec)

// roi est la position du roi
// player est le joueur qui a le roi
// nat1 donne le type de pice pouvant donner chec
// &echecs est l'adresse du compteur d'checs
// F_clouages_dcouvertes_cases_echec est le flag autorisant la recherche des clouages


for(;nb_inc<=nbinc_max;casetest+=inc, nb_inc++)
{
cptr=&xboard[casetest];
//if ( cptr->nature==CASE_HORS_ECHIQUIER ) return;
#if DEBUG==1
	ASSERT(MOVE_IS_OK_ASSERT(roi_pos,casetest,inc,IsNotKnight));
	dd=0;
	if (casetest<0) dd=1;
	if (casetest>63) dd=1;
	if (dd==1)
	{
		log_error("\nErreur J_733 en : %d", xcompteur);

	}
#endif
color2=cptr->color;
if (compteur_pieces_amies==0 && compteur_pieces_adverses==0)
{
	if (color2==-player)
	{
		// Il y a-t-il chec ?
		nature=cptr->nature;
		if ( (nature==nat1 || nature=='D')
			|| (nature=='P' && nb_inc==1
			     && (PLAYER(player,inc)==-7 || inc*player==9))
			|| (nature=='R'&& nb_inc==1)
			)
		{
		side_checked01=TO_COLOR01(player);
		echecs_count2++; // il y a chec !!
		if (chkptr3[side_checked01]==NULL)
		{			
				chkptr3[side_checked01]=cptr->wptr;
		}
		else
		{
			if (chkptr3[side_checked01]!=cptr->wptr)
			{
				chkptr4[side_checked01]=cptr->wptr;
			}
		}
		#if DEBUG==1
			if (&xw[cptr->num_piece] != cptr->wptr)
			{
				log_error("\nErreur J_734 en : %d", xcompteur);
			}
		#endif
		// Si il y chec, il n'est pas utile 
		// de rechercher une batterie
		// La case n'est pas enregistre car il y a dja chec
		return; 
		}
		// Armer pour dcouverte potentielle
		compteur_pieces_adverses=1; // on arme pour batterie
		continue;
	} // fin (xp==-player)
	if (color2==player)        // on arme !
	{
		// Gestion de l'chec invisible sur case de fuite
		// ( le roi est considr transparent )
		if ( cptr->nature=='R' )
		{
			continue; 
		}
		else
		{
			compteur_pieces_amies=1; // on arme pour clouage
			// Pice potentiellement cloue
			//num_candidat_clouage=xboard[casetest].num_piece; 
			return;
			}
	} // fin pice amie
	// Case vide
	// Passer  la case suivante 
	continue;
} // fin (compteur_pieces_amies==0 && compteur_pieces_adverses==0) 
else if ( compteur_pieces_amies==1 ) // on a dja pass une pice
{
	if (color2==0) continue;
	if (color2==-player)
	{
	nature=xboard[casetest].nature;
	compteur_pieces_adverses++;
	return; 
	}
	if (color2==player) return; // La pice qui se cache est une pice amie !
	continue;
}
else // compteur_pieces_adverses==1
{
	if (color2==0) continue;
	if (color2==-player)
	{
	nature=xboard[casetest].nature;
	return; // batterie
	}
	if (color2==player) return; // La pice qui se cache est une pice amie !
	continue; 
} // fin compteur_pieces_adverses==1

} // fin for

} // fin search_echecs_clouages_decouvertes2
#endif







inline void SEARCH::subcheckcava(char local_player,char roi_pos, char inc, bool &F_echec_cava)
{
char casetest;
char local_wtm;
CASE *cptr;

casetest=roi_pos+inc;

// 
if (bit(xcases_arrivee_cavalier[roi_pos],casetest)==0) 
{
	#if DEBUG==1
	ASSERT(!MOVE_IS_OK_ASSERT(roi_pos, casetest,inc,IsKnight));
	#endif
	return;
}

#if DEBUG==1
ASSERT(MOVE_IS_OK_ASSERT(roi_pos, casetest,inc,IsKnight));
#endif
cptr=&xboard[casetest];
if (cptr->color==-local_player)
{
if (cptr->nature=='C')
{
local_wtm=TO_COLOR01(local_player);
testcheck_echecs_count++;
#if _DEBUG==1
F_echec_cava=true;
if (full_testcheck_chkptr[local_wtm]==NULL)
{
	full_testcheck_chkptr[local_wtm]=cptr->wptr;
}
else
{
	if (full_testcheck_chkptr[local_wtm]!=cptr->wptr)
	{
		full_testcheck_chkptr2[local_wtm]=cptr->wptr;
	}
}
#endif
}
// non utilis 
//car les echecs de cavaliers sont valus directement 
//dans givecheck
//else // Case d'chec pour cavalier
//{
//set_bit_to_1(xech_cavalier,casetest);
//}
// 

} 
return;
} // fin subcheckcava



#if CHECK_CHECKS==1
inline void SEARCH::subcheckcava2(char player,char roi_pos,char inc,bool &F_echec_cava2)
{
char casetest;
CASE *cptr;


// Initialisations	
casetest=roi_pos+inc;

if (!MOVE_IS_OK(roi_pos, casetest,inc,IsKnight)) 
{
	return;
}

cptr=&xboard[casetest];
if (cptr->color==-player)
{
if (cptr->nature=='C')
{
F_echec_cava2=1;
echecs_count2++;
if (chkptr3[TO_COLOR01(player)]==NULL)
{			
		chkptr3[TO_COLOR01(player)]=cptr->wptr;
}
else
{
	if (chkptr3[TO_COLOR01(player)]!=cptr->wptr)
	{
		chkptr4[TO_COLOR01(player)]=cptr->wptr;
	}
}
}
}
return;
} // fin subcheckcava2
#endif


#if EXTEND_AUTORISATION_FOURCHETTES_C==1
bool fourchetteC(char player,char arr)
{
char cc;
CASE *cptr;


cc=0;

// Vrification absence de prises par pion sur case d'arrive
if ( xlevel>= xextendlevel+2 )
{
if (MOVE_IS_OK_128(arr,PLAYER(player,17)))
//if (MOVE_IS_OK(arr,arr+PLAYER(player,9),9,IsNotKnight))
{
	cptr=&xboard[arr+PLAYER(player,9)];
	if (cptr->nature=='P' && cptr->color==-player) 
		return false;
}
if (MOVE_IS_OK_128(arr,PLAYER(player,15)))
//if (MOVE_IS_OK(arr,arr-PLAYER(player,7),7,IsNotKnight))
{
	cptr=&xboard[arr-PLAYER(player,7)];
	if (cptr->nature=='P' && cptr->color==-player) 
		return false;
}
}

// Recherche fourchette
if (MOVE_IS_OK_128(arr, PLAYER(player,+18))) cc+=subfourC(player,arr,+10);
if (MOVE_IS_OK_128(arr, PLAYER(player,+33))) cc+=subfourC(player,arr,+17);
if (MOVE_IS_OK_128(arr, PLAYER(player,+31))) cc+=subfourC(player,arr,+15);
if (MOVE_IS_OK_128(arr, PLAYER(player,+14))) cc+=subfourC(player,arr, +6);
if (MOVE_IS_OK_128(arr, PLAYER(player,-18))) cc+=subfourC(player,arr,-10);
if (MOVE_IS_OK_128(arr, PLAYER(player,-33))) cc+=subfourC(player,arr,-17);
if (MOVE_IS_OK_128(arr, PLAYER(player,-31))) cc+=subfourC(player,arr,-15);
if (MOVE_IS_OK_128(arr, PLAYER(player,-14))) cc+=subfourC(player,arr, -6);

if (cc>=10) return true;
else        return false;
} // fin fourchetteC()

static inline char subfourC(char player, char arr, char inc)
{
CASE *cptr;
char cib_nat;
char cible;
cible=arr+inc;

#if DEBUG==1
ASSERT(MOVE_IS_OK_ASSERT(arr,cible,inc,IsKnight));
#endif

cptr=&xboard[cible];
if (cptr->color==0) return 0;
if (cptr->color==player) return 0;
cib_nat=cptr->nature;


switch((char) cib_nat)
{
case 'P' : return 0;
case 'C' : return 0;
case 'F' : xfourchette_value=inf(VALEUR_FOU,xfourchette_value); return 3;
case 'T' : xfourchette_value=inf(VALEUR_TOUR,xfourchette_value); return 5;
case 'D' : xfourchette_value=inf(VALEUR_DAME,xfourchette_value); return 9;
case 'R' : xfourchette_value=inf(VALEUR_DAME,xfourchette_value); return 9;
}
// ide : il faut au moins atteindre
//         au total 10 (deux tours)
// Le roi est pris pour 5 (une tour)
return 0;
} // fin fourchetteC
#endif

#if EXTEND_AUTORISATION_FOURCHETTES_P==1
#if CHECK_FOURCHETTES_PION==1
bool fourchetteP(char player, char arr)
{
char cible;
char cc;
cc=0;

if (MOVE_IS_OK(arr,arr+PLAYER(player,9),9,IsNotKnight)
{
	cible=arr+PLAYER(player,9); cc+=subfourP(player, cible);
}
if (MOVE_IS_OK(arr,arr-PLAYER(player,7),7,IsNotKnight)
{
	cible=arr-PLAYER(player,7); cc+=subfourP(player, cible);
}

// Attaque de pions si au moins une pice vise
if (cc>=2) return true;
else return false;
}



inline char subfourP(char player, char cible)
{
CASE *cptr;
char cib_nat;


if (!MOVE_IS_OK(arr,cible,cible-arr,IsNotKnight)) return 0;

cptr=&xboard[cible];
if (cptr->color==0) return 0;
if (cptr->color==player) return 0;
cib_nat=cptr->nature;
if (cib_nat=='P') return 0;
// Sinon vise une pice
// Traitement spcifique pour les dames
// Pb : fait exploser l'arbre alors que la dame a pratiquement 
// toujours une case de fuite
// Les menaces sur la dame doivent tre values en search
//if (xlevel<=10) 
//{
//if (cib_nat=='D') return 2; // Attaque de dame = coup forant
//}

// Attaque d'une pice
switch((char) cib_nat)
{
case 'P' : return 0;
case 'C' : xfourchette_value=inf(VALEUR_CAVALIER,xfourchette_value); return 1;
case 'F' : xfourchette_value=inf(VALEUR_FOU,xfourchette_value); return 1;
case 'T' : xfourchette_value=inf(VALEUR_TOUR,xfourchette_value); return 1;
case 'D' : xfourchette_value=inf(VALEUR_DAME,xfourchette_value); return 1;
case 'R' : xfourchette_value=inf(VALEUR_DAME,xfourchette_value); return 1;
}
return 0;
} // fin subfourP
#endif
#endif


bool SEARCH::full_testcheck(char roi_pos, char side_checked01)
{
bool F_echec_cava;
char player;

// Initialisations
testcheck_echecs_count=0;
F_echec_cava=false;
full_testcheck_chkptr[side_checked01]=NULL;
full_testcheck_chkptr2[side_checked01]=NULL;

#if CHECK_CHECKS==1
bool F_echec_cava2;
testcheck_echecs_count2=0;
F_echec_cava2=false;
full_testcheck_chkptr3[side_checked01]=NULL;
#endif
player=TO_PLAYER(side_checked01);


// Note : si chec double, deux pices et il faut bouger le roi
// full_testcheck_chkptr est un pointeur unique

// player est la couleur du joueur ayant le roi
// pos est la position du roi
// &F_echec_cava, &testcheck_echecs_count permettent de renvoyer les rponses

// Recherche des checs


// Premire diagonale
recherche_echec_pour_testcheck(player,roi_pos,'F',-9);
recherche_echec_pour_testcheck(player,roi_pos,'F',+9);

// deuxime diagonale
recherche_echec_pour_testcheck(player,roi_pos,'F',-7);
recherche_echec_pour_testcheck(player,roi_pos,'F',+7);

// verticale
recherche_echec_pour_testcheck(player,roi_pos,'T',-1);
recherche_echec_pour_testcheck(player,roi_pos,'T',+1);

// horizontale
recherche_echec_pour_testcheck(player,roi_pos,'T',-8);
recherche_echec_pour_testcheck(player,roi_pos,'T',+8);


// quid des checs de cavalier ?
#if FOLLOW_KNIGHTS==0
subcheckcava(player,roi_pos,+10,F_echec_cava);
subcheckcava(player,roi_pos,+17,F_echec_cava);
subcheckcava(player,roi_pos,+15,F_echec_cava);
subcheckcava(player,roi_pos, +6,F_echec_cava);
subcheckcava(player,roi_pos,-10,F_echec_cava);
subcheckcava(player,roi_pos,-17,F_echec_cava);
subcheckcava(player,roi_pos,-15,F_echec_cava);
subcheckcava(player,roi_pos, -6,F_echec_cava);
#endif
#if FOLLOW_KNIGHTS==1
if ((s->cases_cavaliers[1-side_checked01]&xcases_arrivee_cavalier[roi_pos])!=0)
{
testcheck_echecs_count++; // il y a chec !!
#if _DEBUG==1 
subcheckcava(player,roi_pos,+10,F_echec_cava);
subcheckcava(player,roi_pos,+17,F_echec_cava);
subcheckcava(player,roi_pos,+15,F_echec_cava);
subcheckcava(player,roi_pos, +6,F_echec_cava);
subcheckcava(player,roi_pos,-10,F_echec_cava);
subcheckcava(player,roi_pos,-17,F_echec_cava);
subcheckcava(player,roi_pos,-15,F_echec_cava);
subcheckcava(player,roi_pos, -6,F_echec_cava);
#endif
}
#endif


#if CHECK_CHECKS==1
// premire diagonale

search_echecs_clouages_decouvertes2(player,roi_pos,'F',-9);
search_echecs_clouages_decouvertes2(player,roi_pos,'F',+9);


// deuxime diagonale
search_echecs_clouages_decouvertes2(player,roi_pos,'F',-7);
search_echecs_clouages_decouvertes2(player,roi_pos,'F',+7);

// verticale
search_echecs_clouages_decouvertes2(player,roi_pos,'T',-1);
search_echecs_clouages_decouvertes2(player,roi_pos,'T',+1);

// horizontale
search_echecs_clouages_decouvertes2(player,roi_pos,'T',-8);
search_echecs_clouages_decouvertes2(player,roi_pos,'T',+8);


// quid des checs de cavalier ?
subcheckcava2(player,roi_pos,+10,F_echec_cava2);
subcheckcava2(player,roi_pos,+17,F_echec_cava2);
subcheckcava2(player,roi_pos,+15,F_echec_cava2);
subcheckcava2(player,roi_pos, +6,F_echec_cava2);
subcheckcava2(player,roi_pos,-10,F_echec_cava2);
subcheckcava2(player,roi_pos,-17,F_echec_cava2);
subcheckcava2(player,roi_pos,-15,F_echec_cava2);
subcheckcava2(player,roi_pos, -6,F_echec_cava2);

if (testcheck_echecs_count!=testcheck_echecs_count2)
	log_error("\nErreur J_250 en : %d", xcompteur);

if ( F_echec_cava!=F_echec_cava2 )
	log_error("\nErreur J_251 en : %d", xcompteur);

if ( full_testcheck_chkptr[xwtm]!=full_testcheck_chkptr3[xwtm] )
	log_error("\nErreur J_252 en : %d", xcompteur);

#endif


// Retour
return (testcheck_echecs_count>0);
} // fin full_testcheck





bool SEARCH::limited_testcheck(MOVE lignemoins,char roi_pos, char side_checked01)
{
// limited parce que se borne  analyser si le coup pass en paramtre donne ou non chec
bool F_echec_cava;
char player;
char inc;
char type_piece;
char dep, arr;
//SEARCH *sl;

// Si coup spcial (prise en passant et promotions), analyse complte
if MOVE_IS_SPECIAL(lignemoins) 
{
	return full_testcheck(roi_pos,side_checked01);
}

// Initialisations
testcheck_echecs_count=0;
dep=MOVE_DEP64(lignemoins);
arr=MOVE_ARR64(lignemoins);
#if CHECK_CHECKS==1
bool F_echec_cava2;
testcheck_echecs_count2=0;
F_echec_cava2=0;
full_testcheck_chkptr[side_checked01]=NULL;
full_testcheck_chkptr3[side_checked01]=NULL;
#endif

// Les cases d'arrive et de dpart sont-elles compatibles ?
// Si la case d'arrive n'est pas une case d'chec "all"
// Si la case de dpart n'est pas une case d'chec dame (dcouverte possible)
// Alors pas chec
if (bit(xcases_arrivee_all[roi_pos],arr)==0 )
{
if  (bit(xcases_arrivee_dame[roi_pos],dep)==0 )
	return false;
}

F_echec_cava=0;
player=TO_PLAYER(side_checked01);

// Rem : on ne s'intresse pas  la MAJ des clouages
// car on sort si il n'y a pas d'chec
// Rem : une dcouverte possible est possible depuis la case de dpart
if (bit(xcases_arrivee_dame[roi_pos],dep))
{
	inc=xinc64_from64_to64[roi_pos][dep];
	if (abs(inc)==7 || abs(inc)==9) { type_piece='F'; } else { type_piece='T';}
	SEARCH::recherche_echec_pour_testcheck(player,roi_pos,type_piece,inc);
}
switch(MOVE_NATURE(lignemoins))
{
case 'C' :
	if (bit(xcases_arrivee_cavalier[roi_pos],arr))
	{
		F_echec_cava=true;
		testcheck_echecs_count++;
		// De toute faon on ractualise ensuite
		#if CHECK_CHECKS==1
		full_testcheck_chkptr[side_checked01]=xboard[arr].wptr;
		#endif
	}
	break;
case 'P' : 
	if (arr==roi_pos+PLAYER(9,player) || arr==roi_pos-PLAYER(9,player))
	{
		testcheck_echecs_count++;
		// De toute faon on ractualise ensuite
		#if CHECK_CHECKS==1
		full_testcheck_chkptr[side_checked01]=xboard[arr].wptr;
		#endif
	}
	break;
case 'F' : 
	if (bit(xcases_arrivee_fou[roi_pos],arr))
	{
		inc=xinc64_from64_to64[roi_pos][arr];
		SEARCH::recherche_echec_pour_testcheck(player,roi_pos,'F',inc);
	}
	break;
case 'T' :
	if (bit(xcases_arrivee_tour[roi_pos],arr))
	{
		inc=xinc64_from64_to64[roi_pos][arr];
		SEARCH::recherche_echec_pour_testcheck(player,roi_pos,'T',inc);
	}
	break;
case 'D' :
	if (bit(xcases_arrivee_tour[roi_pos],arr))
	{
		inc=xinc64_from64_to64[roi_pos][arr];
		SEARCH::recherche_echec_pour_testcheck(player,roi_pos,'T',inc);
	}
	else if (bit(xcases_arrivee_fou[roi_pos],arr))
	{
		inc=xinc64_from64_to64[roi_pos][arr];
		SEARCH::recherche_echec_pour_testcheck(player,roi_pos,'F',inc);
	}
	break;
case 'R' :
	// Le roi ne peut pas donner chec
	break;
}	


#if CHECK_CHECKS==1
// premire diagonale

search_echecs_clouages_decouvertes2(player,roi_pos,'F',-9);
search_echecs_clouages_decouvertes2(player,roi_pos,'F',+9);


// deuxime diagonale
search_echecs_clouages_decouvertes2(player,roi_pos,'F',-7);
search_echecs_clouages_decouvertes2(player,roi_pos,'F',+7);

// verticale
search_echecs_clouages_decouvertes2(player,roi_pos,'T',-1);
search_echecs_clouages_decouvertes2(player,roi_pos,'T',+1);

// horizontale
search_echecs_clouages_decouvertes2(player,roi_pos,'T',-8);
search_echecs_clouages_decouvertes2(player,roi_pos,'T',+8);


// quid des checs de cavalier ?
subcheckcava2(player,roi_pos,+10,F_echec_cava2);
subcheckcava2(player,roi_pos,+17,F_echec_cava2);
subcheckcava2(player,roi_pos,+15,F_echec_cava2);
subcheckcava2(player,roi_pos, +6,F_echec_cava2);
subcheckcava2(player,roi_pos,-10,F_echec_cava2);
subcheckcava2(player,roi_pos,-17,F_echec_cava2);
subcheckcava2(player,roi_pos,-15,F_echec_cava2);
subcheckcava2(player,roi_pos, -6,F_echec_cava2);

if (echecs_count!=echecs_count2)
	log_error("\nErreur J_254 en : %d", xcompteur);

if ( F_echec_cava!=F_echec_cava2 )
	log_error("\nErreur J_255 en : %d", xcompteur);

if ( chkptr[xwtm]!=chkptr3[xwtm] )
	log_error("\nErreur J_256 en : %d", xcompteur);

#endif


// Retour
return (testcheck_echecs_count>0);
} // fin limited_testcheck



bool SEARCH::testcheck_clouage(char local_wtm, char roi_pos, char dep)
{
// Remarque : le cas de la prise en passant doit tre trait
// Pion e5xf6 avec TNg5 et RBd5

char inc;
CASE *cptr;
char nbinc_max;
char nb_inc;
char casetest;

inc=xinc64_from64_to64[roi_pos][dep];
nbinc_max=NBINC_DIRECTION(dep,inc);


#if _DEBUG==1
char cc;
cc=abs(inc);
ASSERT(cc==1 || cc==8 || cc==7 || cc==9);
casetest=roi_pos+inc;
cptr=&xboard[casetest];
for (;WITHIN_BOARD(casetest) && casetest!=dep; casetest+=inc, cptr+=inc)
{
	ASSERT(cptr->nature==0);
}
#endif

// On part de la case qui vient d'tre quitte
casetest=dep+inc;
cptr=&xboard[casetest];
for(nb_inc=1;nb_inc<=nbinc_max;casetest+=inc, nb_inc++, cptr+=inc)
{
	if (cptr->nature==0) continue;
	if (cptr->color01==local_wtm) return false;
	ASSERT(cptr->color01==1-local_wtm);
	switch(cptr->nature)
	{
		case 'F' : if (inc==7 || inc==9 || inc==-7 || inc==-9)
					   return true;
			     else return false;
		case 'T' : if (inc==1 || inc==8 || inc==-1 || inc==-8) 
					   return true;
			     else return false;
		case 'D' : 
			     return true;
		default : return false;
	}
	return false;
}
// Retour
return false;
} // fin testcheck_clouage






/* A CONSERVER ABSOLUMENT 
inline char denombre_1_supegal2( int number16, char nb_bits ) // 16 bits max !
{
// retourne 0 si aucun bit positionn
// 1 si un bit positionn
// 2 si un ou plusieurs bits positionns

char number1, number2; // char 8 bits est suffisant
char new_nb_bits;

#if DEBUG==1
if (nb_bits>16)
{
log_error("\nErreur J_857 en : %d", xcompteur);

}
#endif

// Indispensable pour arrter le dcoupage
if ( number16==0 ) return 0;
if ( number16==1 ) return 1;

new_nb_bits=(nb_bits>>1); // division par 2
// Le nombre est coup en 2
number1=(number16>>new_nb_bits);
number2=((number16>>new_nb_bits),new_nb_bits);

if (number1==0) return denombre_1_supegal2(number2,new_nb_bits);
if (number2==0) return denombre_1_supegal2(number1,new_nb_bits);

// Si les deux nombres sont diffrents de zros
// alors le nombre de bits  1 est suprieur ou gal  2
return 2;
}


// A tester
inline char denombre_1_variante1( int number16, char nb_bits ) // 16 bits max !
{
char number1, number2; // char 8 bits est suffisant
char new_nb_bits;

#if DEBUG==1
if (nb_bits>16)
{
log_error("\nErreur J_857 en : %d", xcompteur);

}
#endif

// Indispensable
if ( number16==0 ) return 0;
if ( number16==1 ) return 1;

new_nb_bits=(nb_bits>>1); // division par 2
// Le nombre est coup en 2
number1=(number16>>new_nb_bits);
number2=((number16>>new_nb_bits),new_nb_bits);

if (number1==0) return denombre_1_variante1(number2,new_nb_bits);
if (number2==0) return denombre_1_variante1(number1,new_nb_bits);

return ( denombre_1_variante1(number1,new_nb_bits)+ denombre_1_variante1(number2,new_nb_bits) );
}




inline char denombre_1_total( register int number16 ) // 16 bits !
{
register count;
count=0;
// 1
count+=number16 & 1;
number16=(number16>>1);
// 2
count+=number16 & 1;
number16=(number16>>1);
// 3
count+=number16 & 1;
number16=(number16>>1);
// 4
count+=number16 & 1;
number16=(number16>>1);
// 5
count+=number16 & 1;
number16=(number16>>1);
// 6
count+=number16 & 1;
number16=(number16>>1);
// 7
count+=number16 & 1;
number16=(number16>>1);
// 8
count+=number16 & 1;
number16=(number16>>1);
// 9
count+=number16 & 1;
number16=(number16>>1);
// 10
count+=number16 & 1;
number16=(number16>>1);
// 11
count+=number16 & 1;
number16=(number16>>1);
// 12
count+=number16 & 1;
number16=(number16>>1);
// 13
count+=number16 & 1;
number16=(number16>>1);
// 14
count+=number16 & 1;
number16=(number16>>1);
// 15
count+=number16 & 1;
number16=(number16>>1);
// 16
count+=number16 & 1;
number16=(number16>>1);

return count;
}

*/



void SEARCH::copiekeep()
{
//MOVE *mptr;
MOVE *mptra, *mptrb;
mptra=&xkeep[1];
mptrb=best;
//mptrb=&xbest[1][1];
char i;

i=0;
while(MOVE_IS_LINE(*mptrb))
{
	// Prcaution
	if (++i>xdepthmax_struct)
	{
		#if _DEBUG==1
		log_error("\nErr J_546");
		#endif
		*mptra=LigneEndLevelMax;
		return;
	}

*mptra++=*mptrb++;
#if DEBUG==1
if (*mptrb==0)
{
	log_error("\nErr J_643");
	//char cc; STOP;
}
#endif
}
// Copie du marqueur de fin de ligne
*mptra=*mptrb;
} // fin copiekeep



void SEARCH::display_best(bool &F_first_display, bool F_force)
{
bool F_lowerbound, F_upperbound;
short si;
MOVE *mptr;


// Affichage (DISPLAY MOVES)
if (xregister1==1)
{
//if (xcan_return==1) // sinon affich ds le copiebest
{
// Affichage de la suite retenue
CONSOLE_MODE;
if (xregister1==1 && xreturn==0)
{
if (xpb_explo==0 || xpb_guessed==1)
{
// Pas d'affichage en permanent brain (xpb_explo==1)
if (xstop3==0 || F_force)
{
F_first_display=false;
// printf("****************************\n");
printf("\nEvaluation : %d - Depth : %d - %d\n",xlv1_value*xlv1_player,xlv1_depth>>FD,xcompteur);
// xregister1==1 donc on n'a pas d'upperbounds ici 
// xlv1_value>=xlv1_beta n'arrive donc pas
if (xlv1_value<=xlv1_alpha)
{ xbest[1][2]=LigneEndUpperbound; }
else if (xlv1_value>=xlv1_beta)
{ xbest[1][2]=LigneEndLowerbound; }
affiche_ligne(&xbest[1][1],0);
}
}
} 
END_MODE;

UCI_MODE;
#if !_DEBUG==1
if (depthtarget_level>=6 
	|| (abs(value)>=MATE_VALUE-1)
	|| F_force
	)
#endif
{
// Affichage profondeur, temps, ligne
// seulement si changement de la ligne principale
F_first_display=false;


// uci_interface::info_buffer doit tre suffisamment important
// pour viter tout risque de dbordement
strcpy(uci_interface::info_buffer, "depth ");
strcat(uci_interface::info_buffer, _itoa(xlv1_depthtarget>>FD,xbuffer2,10) );
#if DISPLAY_SELECTIVE_DEPTH==1
strcat(uci_interface::info_buffer, " seldepth ");
strcat(uci_interface::info_buffer, _itoa(xseldepth>>FD,xbuffer2,10) );
#endif
xtime=get_time_in_seconds();
strcat(uci_interface::info_buffer, " time ");
strcat(uci_interface::info_buffer, _ltoa((long)(xtime-xtdebut),xbuffer2,10)); 
strcat(uci_interface::info_buffer, " nodes ");
strcat(uci_interface::info_buffer, _ltoa(xcompteur-xcompteur_depart,xbuffer2,10)); 


// Affichage score
if ( xlv1_value<=xlv1_alpha ) 
{ si=xlv1_value; F_lowerbound=false; F_upperbound=true; }
else 
{
if ( xlv1_value>=xlv1_beta ) 
{ si=xlv1_value; F_lowerbound=true; F_upperbound=false; }
else { si=xlv1_value; F_lowerbound=false; F_upperbound=false; }
}



// Reconstitution ligne principale pour affichage
// Rem : en mode console, intgr dans la fonction affiche_ligne
// On ne peut pas afficher la ligne en upperbound
// car on n'a pas fait les copiebest()
// qui sont inutiles pour des suites qu'on ne retiendra pas
if (!F_upperbound 
	// Si F_upperbound, les coups n'ont pas t redescendus
	) 
{
	reconstitution_ligne_principale(&xbest[1][1],0); 
}
else // F_upperbound (fail-low)
{
	if (xcan_return)
	{ xbest[1][1]=xkeep[1]; xbest[1][2]=LigneEndUpperbound; }
	else xbest[1][2]=LigneEndUpperbound;
	//reconstitution_ligne_principale(&xbest[1][1],0); 
}
//else // F_upperbound ou F_lowerbound
//{
    //   remmettre
	//if (xcan_return && F_upperbound) FAUX !
	//{ xbest[1][1]=xkeep[1]; xbest[1][2]=LigneEndUpperbound; }
	//else 		
	//{ xbest[1][2]=LigneEndLowerbound; }
	// NEW
//}


// Affichage Mat (aprs reconstitution ligne)
if ( abs(si)>MATE_VALUE_THRESHOLD )
{
// Il arrive que les scores de mat soit lgrement faux
// les vrifier

check_mate_score(&xbest[1][1],si);
//sprintf(xbuffer,"value : %d", si);
//display_info_force(xbuffer);
strcat(uci_interface::info_buffer, " score mate ");
if (!F_lowerbound && !F_upperbound)
{
	strcat(uci_interface::info_buffer, 
	   _itoa(SIGNE(si)*((MATE_VALUE-abs(si)+1)>>1),xbuffer2,10)); 
}
else // Lower or upper bound
{
	strcat(uci_interface::info_buffer, 
	   _itoa(SIGNE(si)*99,xbuffer2,10));
}
}
else // pas de mat, affichage du score
{
strcat(uci_interface::info_buffer, " score cp ");
strcat(uci_interface::info_buffer, _ltoa((long)(si),xbuffer2,10)); 
}
if (F_lowerbound) 
	strcat(uci_interface::info_buffer, " lowerbound");
if (F_upperbound) 
	strcat(uci_interface::info_buffer, " upperbound");



// Affichage ligne princiaple
mptr=&xbest[1][1];
for (;MOVE_ROLE(*mptr)<LIGNE_END;mptr++)
{
if (mptr==&xbest[1][1])
{
	strcat(uci_interface::info_buffer, " pv ");
	// Affichage de xlastmove en exploration
	if ( xpb_explo==1 && xpb_guessed==0 )
	{
	formatte_move_to_uci(xlastmove, uci_interface::uci_move);
	strcat(uci_interface::info_buffer, uci_interface::uci_move);
	strcat(uci_interface::info_buffer, " ");
	}
}
#if _DEBUG==0
if ( MOVE_IS_PASSE(*mptr)) break;

#else
if ( MOVE_IS_PASSE(*mptr)) 
{
	strcat(uci_interface::info_buffer, " passe ");
	continue;
}
#endif
formatte_move_to_uci(*mptr, uci_interface::uci_move);
strcat(uci_interface::info_buffer, uci_interface::uci_move);
strcat(uci_interface::info_buffer, " ");

} // fin for
strcat(uci_interface::info_buffer, _itoa(MOVE_ROLE(*mptr),xbuffer2,10));
display_info(uci_interface::info_buffer);

//if (xzz<-50000) 
//{ char cc;STOP; }


#if UCI_DEBUG==2
sprintf(xbuffer, "%3d", xm2ptr->code);
strcpy(uci_interface::info_buffer, xbuffer);
sprintf(xbuffer, " %10d", xlv1_alphabeta[0]);
strcat(uci_interface::info_buffer, xbuffer);
sprintf(xbuffer, " %10d", xlv1_value);
strcat(uci_interface::info_buffer, xbuffer);
sprintf(xbuffer, " %10d", xlv1_alphabeta[1]);
strcat(uci_interface::info_buffer, xbuffer);
display_info_force(uci_interface::info_buffer);


sprintf(xbuffer, "\nAvailable time : %12f", xavailable_time[1]); 
strcpy(uci_interface::info_buffer, xbuffer);
display_info_force(uci_interface::info_buffer);
sprintf(xbuffer, "\nTemps consomm : %12f", xtimecumul[1]); 
strcpy(uci_interface::info_buffer, xbuffer);
display_info_force(uci_interface::info_buffer);
sprintf(xbuffer, "\nTemps prvu : %12f", xtempsprevu[1]); 
strcpy(uci_interface::info_buffer, xbuffer);
display_info_force(uci_interface::info_buffer);
sprintf(xbuffer, "\nBorne de temps : %12d", xbornetemps); 
strcpy(uci_interface::info_buffer, xbuffer);
display_info_force(uci_interface::info_buffer);
sprintf(xbuffer, "\nXcps : %12d", xcps); 
strcpy(uci_interface::info_buffer, xbuffer);
display_info_force(uci_interface::info_buffer);

// Dbogage
//sprintf(xbuffer, "\nXopening_book_was_used %d", xopeningbook_has_been_used); 
//strcpy(uci_interface::info_buffer,xbuffer );
//display_info_force(uci_interface::info_buffer);
#endif

}
END_MODE;
}
}
}



char SEARCH::legal(char num,MOVE move,char roi_num,MOVE lastmove)
{
char valide;
//char special=0;
//CASE *dptr;
char nb_inc, nbinc_max;
char arr2; 
char inc;
bool F_roi_trouve;
bool F_tour_trouvee;
char case_depart_prise_ep;
char case_pion_prise_ep;
CASE *cptr;
#if USE_CASES_ACTUALISATION==1
char inc1, inc2;
#endif
//bool F_clouage;
//char direction_clouage;
//unsigned __int64 cases_pieces_clouees;
char roi_pos;
//char xx,yy,zz,x,y;
char local_wtm, local_player;

// Initialisations
//echecs_count=0; Fait dans testcheck
//F_echec_cava=0; Fait dans testcheck
//num=MOVE_NUM_PIECE(move);
ASSERT(num==MOVE_NUM_PIECE(move));
local_wtm=xwtm; // non garanti car appel depuis liste coups lgaux
local_player=TO_COLOR(xwtm); // non garanti car appel depuis liste coups lgaux

// La fonction retourne etat==1 si lgal
// (ou etat==0 illgal, etat==7 clouage)
// La prparation est faite ... l'aide de cc
// cc=0 : coup lgal
// cc=1; break; : coup illgal


// Dbut analyse de lgalit
// tout break signifie un coup illgal (cc=1; break; etat=0)
do  //
{
// Initialisation
valide=1;



// Echec ?
if (check!=0)
{
if (num!=roi_num)
{
if (check==ECHEC_DOUBLE) {valide=0; break;} // echec double non couvrable
valide=0; // Echec ... couvrir
arr2=MOVE_ARR64(move);
valide=est_case_couverture_64(xsearch_level[xlevel]->cases_couverture_echecs,arr2);


// Cas du coup de dfense "prise en passant"
// si le pion adverse donne chec, 
// les seules cases d'interposition sont 
// - la case du pion adverse ( test prcdemment )
// - la case d'arrive du pion adverse-1 (si!) si le coup de dfense 
//   est une prise en passant ( Ex : Rd4 e5+ f5xe6 ep )
// En revanche, la case d'interception enregistre
// est invariablement celle du pion adverse
// Donc pour tester si une prise en passant 
// couvre un echec de pion, 
// il faut regarder si la case d'arrive - player
// est enregistre dans les cases de couverture
// - Sans les 64BI, la case de couverture est en 
//   premire position dans la liste de couverture 
//   car le seul cas o la prise en passant permet de couvrir 
//   l'echec adverse est le cas o le pion adverse est 
//   la pice qui donne echec ( ce n'est pas forc
//   car il peut s'agir d'une dcouverte par exemple
//   li au mouvement du pion adverse )
// - Avec les 64BI, on teste MOVE_ARR64(move)-player
//   mais en plus, il faut s'assurer en testant 
//   MOVE_ARR64(move)-local_player et pos_roi que le coup de pion adverse
//   donne bien echec
if (valide==0) // Coup illgal mais vrifier 
// s'il ne s'agit pas d'une prise en passant qui couvre 
{
if (MOVE_IS_EN_PASSANT(move))
{
if (est_case_couverture_64(xsearch_level[xlevel]->cases_couverture_echecs,MOVE_ARR64(move)-local_player)==1)
{
// Le roi est bien celui de local_player 
// puisque la prise en passant limine le pion
// donnant chec
//inc=-local_player*(xw[xnum_roi[(1+player)/2]].pos-(MOVE_ARR64(move)-player));
inc=PLAYER(local_player,((char)(MOVE_ARR64(move)-local_player)-xw[xnum_roi[local_wtm]].pos));
// Un test sur la valeur absolue ne serait pas suffisant
// Par exemple, b2b4 donne chec  RN en c3
// via une dame en a1 => la prise par noir en passant ne couvre pas l'chec
// On multiplie par -player 
// Ex : pion blanc donne echec au roi noir (b2b4)
// on cherche si prise en passant couvre
// local_player==-1 donc
if ( inc==-7 || inc==9 )
{
// Le pion donnait bien echec
// la prise en passant supprime donc la pice donnant chec
valide=1;
}
}

}
}


// IMPORTANT : Pas de break : il faut vrifie les clouages
// L'chec a-t-il t couvert ?
//if (cc==0) break; 
// PAS DE GOTO

} // fin if !roi
} // fin traitement echec ( et diffrent de roi )


// Coup de roi (dont particularit de l'chec invisible)
if (num==roi_num) // avec ou sans echec
{
// Roque : contrle de lgalit
if (MOVE_IS_CASTLE(move)) // num==roi & special!=0 : roque donc
{
// Test du droit ... roquer
// A : Echec
if (check!=PAS_ECHEC) {valide=0; break;}	// pas de roque si echec
// B : Droit perdu
if (!(s->droit_roque[local_wtm]&3))
{valide=0; break;}
// C : Roque possible
valide=1;
switch (MOVE_ARR64(move))
{
case 48 : 
	  /* Petit roque blanc */
	 if (!(s->droit_roque[1]&1)) {valide=0; break;}
	 if (xboard[40].nature!=0) {valide=0; break;}
	 if (xboard[48].nature!=0) {valide=0; break;}
	 #if USE_CASES_ACTUALISATION==0
	 full_testcheck(40,local_wtm);
	 if (testcheck_echecs_count>0)  {valide=0; break;}
	 #endif
	 #if USE_CASES_ACTUALISATION==1
	 if (bit(cases_controlees_adversaire,40)) {valide=0; break;}
	 #endif
	 break;
case 16 :
	 /* Grand roque blanc */
	 if (!(s->droit_roque[1]&2)) {valide=0;; break;}
	 if (xboard[8].nature!=0) {valide=0;; break;}
	 if (xboard[16].nature!=0) {valide=0; break;}
	 if (xboard[24].nature!=0) {valide=0; break;}
	 #if USE_CASES_ACTUALISATION==0
	 full_testcheck(24,xwtm);
	 if (testcheck_echecs_count>0)  {valide=0; break;}
	 #endif
	 #if USE_CASES_ACTUALISATION==1
	 if (bit(cases_controlees_adversaire,24)) {valide=0; break;}
	 #endif
	 break;
case 55 : 
	 /* Petit roque noir */
	 if (!(s->droit_roque[0]&1))   {valide=0; break;}
	 if (xboard[47].nature!=0) {valide=0; break;}
	 if (xboard[55].nature!=0) {valide=0; break;}
	 #if USE_CASES_ACTUALISATION==0
	 full_testcheck(47,local_wtm);
	 if (testcheck_echecs_count>0)  {valide=0; break;}
	 #endif
	 #if USE_CASES_ACTUALISATION==1
	 if (bit(cases_controlees_adversaire,47)) {valide=0; break;}
	 #endif
	 break;
case 23 : 
	 /* Grand roque noir */
	 if (!(s->droit_roque[0]&2)) {valide=0; break;}
	 if (xboard[15].nature!=0) {valide=0; break;}
	 if (xboard[23].nature!=0) {valide=0; break;}
	 if (xboard[31].nature!=0) {valide=0;break;}
	 #if USE_CASES_ACTUALISATION==0
	 full_testcheck(31,local_wtm);
 	 if (testcheck_echecs_count>0)  {valide=0; break;}
	 break;
	 #endif
	 #if USE_CASES_ACTUALISATION==1
	 if (bit(cases_controlees_adversaire,31) )
	 {valide=0; break;}
	 #endif
}


#if DEBUG==1
char cc;
// D : dernier contr"le anti-bug -  conserver
// Verification du droit de roquer
short int si1;
si1=0;
switch (MOVE_ARR64(move))
{
case 48 :
if (xboard[32].nature!='R') si1=1;
if (xboard[56].nature!='T') si1=1; break;
case 24 :
if (xboard[32].nature!='R') si1=1;
if (xboard[0].nature!='T') si1=1; break;
case 55 :
if (xboard[39].nature!='R') si1=1;
if (xboard[63].nature!='T') si1=1; break;
case 31 :
if (xboard[39].nature!='R') si1=1;
if (xboard[7].nature!='T') si1=1; break;
default : break;
}
if (valide==1 && si1==1)
{
cc=1;
log_error("\nErr J_002 en : %d", xcompteur);

} // fin if
#endif // DEBUG==1 

// Conclusion
if (valide==0) {break;} // roque impossible - cases de trajet contr"les
} // fin contrle roque


// Test : le roi est-il en chec sur sa case d'arrive
ASSERT(local_wtm==xwtm);
// ASSERT(wtm==xwtm); non pas dans legalite_coup_reconstitution
#if USE_CASES_ACTUALISATION==0
// full_testcheck qui gre le problme de l'chec sur case d'arrive
full_testcheck(MOVE_ARR64(move),local_wtm);
if (testcheck_echecs_count>0) {valide=0; break;}
#endif
#if USE_CASES_ACTUALISATION==1
if (bit(cases_controlees_adversaire,MOVE_ARR64(move)))
{valide=0; break;}
// Faire ce contrle si D,T,F ou chec double
if (check!=0)
{
if (check!='C' && check!='P' ) //if (check=='D' || check=='T' || check=='F' || check=="ECHEC_DOUBLE")
{
if (chkptr[local_wtm]->nature!='C' && chkptr[local_wtm]->nature!='P')
{
		ASSERT(chkptr[local_wtm]!=NULL);
         
		inc1=MOVE_ARR64(move)-MOVE_DEP64(move); // roi
		ASSERT(inc1==xinc64_from64_to64[MOVE_DEP64(move)][MOVE_ARR64(move)]);
		inc2=xinc64_from64_to64[chkptr[local_wtm]->pos][MOVE_DEP64(move)];
		if (inc1==inc2) 
		{valide=0; break;}
}
ASSERT(check!=ECHEC_DOUBLE || chkptr2[local_wtm]!=NULL);
if (chkptr2[local_wtm]!=NULL)
{
if (chkptr2[local_wtm]->nature!='C' && chkptr2[local_wtm]->nature!='P')
{
			inc1=MOVE_ARR64(move)-MOVE_DEP64(move); // roi
			inc2=xinc64_from64_to64[chkptr2[local_wtm]->pos][MOVE_DEP64(move)];
			if (inc1==inc2) 
			{valide=0; break;}
}		
}
}
/* A CONSERVER
		//valide=1; dja fait
	    ASSERT(valide==1);
		xx=X64(MOVE_DEP64(move));
		yy=Y64(MOVE_DEP64(move));
		//x=xboard[MOVE_ARR64(move)].posx;
		//y=xboard[MOVE_ARR64(move)].posy;
		x=X64(MOVE_ARR64(move));
		y=Y64(MOVE_ARR64(move));
		x=x-xx;
		y=y-yy; // valeur des incrments
		do
		{
			xx=xx-x;
			yy=yy-y;
			if (xx<0 || xx>7 || yy<0 || yy>7) break;
			zz=yy+8*xx;
			if (xboard[zz].color==0) continue;
			if (xboard[zz].color==local_player) break; //ok pice amie
			else // couleur oppose
			{
				// Teste chec invisible sur zone de fuite
				switch (xboard[zz].nature)
				{
					case 'D': valide=0; break;
					case 'F': if ((abs(x)+abs(y)==2)) valide=0; 
							break;
					case 'T': if ((abs(x)+abs(y)==1)) valide=0; 
							break;
					default : break;
				}
			}
			break;
		}while(1);
		*/
}
#endif


/* A CONSERVER ABSOLUMENT 
Remplac par une modification de testcheck
consistant  considrer que le roi est une pice 
amie "transparente" pour donner les checs
// Test echec invisible sur case de fuite
// rappel : elle peut-tre echec du fait du coup de roi !
if (check!=0 && echecs_count==0)
// seulement si il y a chec et si echecs_count==0 (pas d'echec sur case arrive)
{
cc=0;
xx=xw[roi].posx;
yy=xw[roi].posy;
x=xboard[MOVE_ARR64(move)].posx;
y=xboard[MOVE_ARR64(move)].posy;
x=x-xx;
y=y-yy; // valeur des incrments
do
{
xx=xx-x;
yy=yy-y;
if (xx<0 || xx>7 || yy<0 || yy>7) break;
xz=yy+8*xx;
if (xboard[xz].color==0) continue;
if (xboard[xz].color==local_player) break; //ok pice amie
else // couleur oppose
{
// Teste chec invisible sur zone de fuite
switch (xboard[xz].nature)
{
case 'D': cc=1; break;
case 'F': if ((abs(x)+abs(y)==2)) cc=1;
	  break;
case 'T': if ((abs(x)+abs(y)==1)) cc=1;
	  break;
default : break;
}
} // fin else
break;
} // fin do
while(1);
} // fin du if echec - contr"le de case de fuite
*/
break;

} // fin du if roi (test chec)


// En deuxime, il faut liminer 
// - les coups de pices cloues
// - les prises en passant impossibles

// Clouage ?
// On vrifie que le coup peut correspondre  celui d'une pice 
// pouvant tre cloue
// C'est a priori le cas, mais on ne peut pas prendre
// de risque et dclarer illgal un coup qui n'avait pas
//  tre control
// Garder ce test
// Il arrive que la fonction legal soit sollicite
// sans que la pice puisse avoir des coups illgaux
// Donc dans 95% des cas la pice est dclare pouvant avoir 
// des coups illgal et elle l'est parce qu'elle est en frontire
// des cases d'checs.
// Conserver ce test pour les 5% restants

// Si la pice est connue cloue
// Et comme il y a une seule direction de clouage possible
#if USE_CASES_ACTUALISATION==1
if (bit(pieces_clouees,num))
{
	ASSERT(num==MOVE_NUM_PIECE(move));
	roi_pos=s->roi_pos[local_wtm];
	if (abs(MOVE_INC64(move))!=abs(xinc64_from64_to64[roi_pos][MOVE_DEP64(move)]))
	{
		return CLOUAGE;
	}
}
#endif
if (bit(s->cases_echec_dame[1-local_wtm],MOVE_DEP64(move)))
{
#if USE_CASES_ACTUALISATION==1 && _DEBUG==1
	char cc;
	cc=MOVE_NUM_PIECE(move);
	cc=MOVE_DEP64(move);
	cc=MOVE_ARR64(move);
	if (!bit(pieces_with_possible_illegal_moves,MOVE_NUM_PIECE(move)))
	{
		cc=abs(MOVE_INC64(move));
		 if (SEARCH::testcheck_clouage(local_wtm,s->roi_pos[local_wtm],MOVE_DEP64(move)))
		{  log_error("J_89898",xcompteur); }
	}
#endif
{
// Il faut que la pice quitte sa direction initiale par rapport au roi 
// si le coup doit tre illgal
roi_pos=s->roi_pos[local_wtm];
if (abs(MOVE_INC64(move))!=abs(xinc64_from64_to64[roi_pos][MOVE_DEP64(move)]))
{
	if (SEARCH::testcheck_clouage(local_wtm,roi_pos,MOVE_DEP64(move)))
	{
		#if USE_CASES_ACTUALISATION==1
		set_bit_to_1(pieces_clouees,num);	
		#endif
		return CLOUAGE;
	}
}
// Il y a des test complmentaires pour la prise en passant
// (RBd5, TNG5, e5xf6 ep) 
// le pion en f5 interdit l'identification de l'chec si on a pas jou encore le coup
// le test est effectu ci-aprs - il n'y a rien  ajouter
} // fin if clouage
}


// Prise en passant
if (MOVE_IS_EN_PASSANT(move))
{
// la case d'arrive est-elle compatible ?
if (MOVE_ARR64(lastmove)!=MOVE_ARR64(move)-local_player) {valide=0; ;break;}
// le dernier coup est-il un coup de pion ?
if (xboard[MOVE_ARR64(move)-local_player].nature!='P') {valide=0; break;} // le plus sur - indpendant de lastmove
// Alternativement : if (xw[lastmove->num_piece].nature!='P') {valide=0; ;break;}
// Alternativement : if (lastmove->move->nature!='P') {valide=0; ;break;}
// le pion a-t-il avanc de deux cases
//if (2*(Y64(MOVE_DEP64(lastmove)))-5*local_player!=9) {valide=0; ;break;}
if (abs(MOVE_DELTA64(lastmove))!=2) {valide=0; ;break;}
// Le dernier coup est-il un passe 
// if (MOVE_IS_PASSE(lastmove)) {valide=0;break;} 

// Vrification absence clouage
// Ex : RBd5 PBe5xf6 e.p. avec TNg5 qui donne chec !!!
// Cette particularit est lie au fait que le clouage n'a pas t identifi
// car il y avait un pion noir en f5 qui disparat avec la prise en passant
if (s->roi_posy[local_wtm]==Y64(MOVE_DEP64(move)))
{
F_roi_trouve=0;
F_tour_trouvee=0;
case_depart_prise_ep=MOVE_DEP64(move);
case_pion_prise_ep=MOVE_ARR64(move)-TO_COLOR(local_wtm);

// A droite du pion pass
nbinc_max=NBINC_DIRECTION(case_depart_prise_ep,8);
for(nb_inc=1,cptr=&xboard[case_depart_prise_ep+8];nb_inc<=nbinc_max;cptr+=8,nb_inc++)
{
if (cptr->nature==0) { continue; }
if (cptr->color01==1-local_wtm && (cptr->nature=='T' || cptr->nature=='D')) 
	{ F_tour_trouvee=1; break;}
else
if (cptr->color01==local_wtm && cptr->nature=='R') 
	{ F_roi_trouve=1; break; }
else
if (cptr->pos==case_pion_prise_ep)
	{ continue; }
else // Autre pice faisant ncessairement cran entre 
     // le roi et la tour si l'un des deux avait t trouv
	{ F_tour_trouvee=0; F_roi_trouve=0; break; }
} // fin for

// A gauche du pion pass
// Inutile de chercher si on n'a pas dja trouv  droite soit le roi soit une tour adverse
if ( F_tour_trouvee==1 || F_roi_trouve==1 )
{
nbinc_max=NBINC_DIRECTION(case_depart_prise_ep,-8);
for(nb_inc=1,cptr=&xboard[case_depart_prise_ep-8];nb_inc<=nbinc_max;cptr+=-8,nb_inc++)
{
if (cptr->nature==0) { continue; }
if (cptr->color01==1-local_wtm && (cptr->nature=='T' || cptr->nature=='D')) 
	{ F_tour_trouvee=1; break;}
else
if (cptr->color01==xwtm && cptr->nature=='R') 
	{ F_roi_trouve=1; break;}
else
if (cptr->pos==case_pion_prise_ep )
	{ continue; }
else // Autre pice faisant ncessairement cran entre 
     // le roi et la tour si l'un des deux avait t trouv
	{ F_tour_trouvee=0; F_roi_trouve=0; break;}
} // fin for
} // fin condition pralable  droite


// Constatation chec ventuel
if ( F_tour_trouvee==1 && F_roi_trouve==1 ) 
{valide=0;  break; }
} // fin vrification absence clouage pion
// ok - prise jouable

} // fin prise en passant



// Sortie du while
break; 
} // fin du do/while
while(1);

// Retour fonction
if (valide==1) 
// Coup lgal 
{ 
	F_existe_coup_legal=1; // paramtre pass par rfrence
	return LEGAL;
}
else
{
	return ILLEGAL;
}
} // fin legal()






void check_mate_score(MOVE *mpt, short &value)
{
char compteur_coups_joues;
char signe=SIGNE(value);
compteur_coups_joues=0;
bool F_reconstitution_faite;

//display_info_force("ZZZZZZZZZZ");
// Securit
if (abs(value)<MATE_VALUE_THRESHOLD) return;
F_reconstitution_faite=false;

// Reconstitution
//*(mpt+1)=LigneEndHashTable;
//reconstitution_ligne_principale(mpt,false);

do
{
while(MOVE_IS_FOR_PLAY(*mpt))
{
	//sprintf(xbuffer,"DEP-aa : %d",MOVE_DEP88(*mpt));
    //display_info_force(xbuffer);
	//sprintf(xbuffer,"ARR-aa : %d",MOVE_ARR88(*mpt));
    //display_info_force(xbuffer);
	compteur_coups_joues++;
	mpt++;
}
if (*mpt==LigneEndHashTable && F_reconstitution_faite==false )
{
	F_reconstitution_faite=true; // prcaution anti-boucle
	reconstitution_ligne_principale(mpt,false);
	if (!MOVE_IS_FOR_PLAY(*mpt)) break;
	continue;
}
break;
} while(1);


    //sprintf(xbuffer,"end-line %d", MOVE_ROLE(*mpt));
    //display_info_force(xbuffer);
	//sprintf(xbuffer,"compteur %d", compteur_coups_joues);
	//display_info_force(xbuffer);
if (
       *mpt==LigneEndMat
	|| *mpt==LigneEndHashTable
	|| *mpt==LigneEndHashTable_Reconstitution
	)
{
  	value=inf(MATE_VALUE-compteur_coups_joues,MATE_VALUE-1)*signe;
	//display_info_force("Modified");
}
}



void reconstitution_ligne_principale(MOVE *ligne,char move_one_has_been_played)
{
MOVE *mpt2;
STATEVALUES states_mem;
#if INCREMENTAL_HASH==1
H_CODE h;
#endif
char hash;
char compteur_coups_joues;
char cc;
char level_mem;
MOVE hmove;
short hscore;
char hscore_status,hash_depth_moins_level;
MOVE lastmove;
//LISTLEVEL listlevel;

// Garde fou : n'est possible qu'au level 0 et 1
// if (xlevel>1) return;

#if NO_RECONSTITUTION==1
return;
#endif

// Initialisations
hash=HASH_MISS;
level_mem=xlevel;
mpt2=ligne;
if (xlevel<=1) lastmove=xlastmove; 
else           lastmove=xligne[xlevel-1]; // pas ligne-1 (car c'est le plus souvent xbest!)
compteur_coups_joues=0;
states_mem=xstates[xlevel]; // sauvegarder les valeurs de roque


// Si xlevel=0, il faut ajouter 1 pour 
// retrouver les conditions dans lesquelles la ligne a t
// enregistre
// C'est important car subactualise met  jour le numro de 
// pice dans move, et le move point dpend de xlevel
// Il est important que subactualise mette  jour le move point
// par ligne, et pas un autre
// 2010/10 : commentaire ancien ci-dessus
if (xlevel==0) 
{
// La copie de xlv est ncessaire pour les couvertures d'checs
xstates[1]=xstates[0]; 
xsearch_level[1]->check=xsearch_level[0]->check;
xsearch_level[1]->chkptr[0]=xsearch_level[0]->chkptr[0];
xsearch_level[1]->chkptr2[0]=xsearch_level[0]->chkptr2[0];
xsearch_level[1]->chkptr[1]=xsearch_level[0]->chkptr[1];
xsearch_level[1]->chkptr2[1]=xsearch_level[0]->chkptr2[1];
xsearch_level[1]->cases_couverture_echecs=xsearch_level[0]->cases_couverture_echecs;
xsearch_level[1]->finale=xsearch_level[0]->finale;
#if USE_CASES_ACTUALISATION==1
xsearch_level[1]->pieces_with_possible_illegal_moves=xsearch_level[0]->pieces_with_possible_illegal_moves;
xsearch_level[1]->pieces_clouees=0;
#endif
xsearch_level[1]->ep_square64=xsearch_level[0]->ep_square64;
xlevel++;
}
// Par ailleurs, si le premier coup de la ligne
// a t jou, incrmenter tout de suite de 1
if ( move_one_has_been_played==1 )
{
// La copie de xlv est ncessaire pour les couvertures d'checs
xstates[xlevel+1]=xstates[xlevel]; 
xsearch_level[xlevel+1]->check=xsearch_level[xlevel]->check;
xsearch_level[xlevel+1]->chkptr[0]=xsearch_level[xlevel]->chkptr[0];
xsearch_level[xlevel+1]->chkptr2[0]=xsearch_level[xlevel]->chkptr2[0];
xsearch_level[xlevel+1]->chkptr[1]=xsearch_level[xlevel]->chkptr[1];
xsearch_level[xlevel+1]->chkptr2[1]=xsearch_level[xlevel]->chkptr2[1];
xsearch_level[xlevel+1]->cases_couverture_echecs=xsearch_level[xlevel]->cases_couverture_echecs;
xsearch_level[xlevel+1]->finale=xsearch_level[xlevel]->finale;
#if USE_CASES_ACTUALISATION==1
xsearch_level[xlevel+1]->pieces_with_possible_illegal_moves=xsearch_level[xlevel]->pieces_with_possible_illegal_moves;
xsearch_level[xlevel+1]->pieces_clouees=0;
#endif
xsearch_level[xlevel+1]->ep_square64=xsearch_level[xlevel]->ep_square64;
xlevel++;
lastmove=*mpt2; mpt2++;
// Ne pas toucher  compteur_coup_joues
}

// Remarque 
// En gnral, depuis le level 0, on incrmente 2 fois xlevel
// et xlevel vaut donc 2
// Le premier coup a jouer est xkeep[2] qui pointe sur un move de level 2


for(;MOVE_IS_LINE(*mpt2);lastmove=*mpt2,mpt2++)
{
if (MOVE_IS_PASSE(*mpt2)) 
{ 
// voir s'il est possible de distinguer EXTEND_PASSE
xpasse=true;  
compteur_coups_joues++; 
xstates[xlevel+1]=xstates[xlevel]; 
xsearch_level[xlevel+1]->finale=xsearch_level[xlevel]->finale;
xsearch_level[xlevel+1]->check=0;
xlevel++;
xwtm=1-xwtm;
// Actualisation cases contrlees mme pour Nullmove
xsearch_level[xlevel]->actualise(NullMove);
continue;
} 
cc=legalite_coup_reconstitution(*mpt2,lastmove);
if (cc!=1) 
	{ 
		#if DEBUG==1
		strcpy(uci_interface::info_buffer, " pv ");
		formatte_move_to_uci(*mpt2, uci_interface::uci_move);
		strcat(uci_interface::info_buffer, uci_interface::uci_move);
		display_info(uci_interface::info_buffer);
		#endif
		//log_error_no_stop("\nErreur J_982 en : %d", xcompteur);
		log_error("\nErreur J_982 en : %d", xcompteur);
		
		//STOP;
		//}
		//#endif
		*mpt2=LigneEndHashTable_Reconstitution;
		goto RETURN; 
	}


xstates[xlevel+1]=xstates[xlevel]; // ncessaire pour les droits  roquer
xsearch_level[xlevel+1]->finale=xsearch_level[xlevel+1]->s->finale;
#if _DEBUG
		xligne2[xlevel].level=xlevel;
		xligne2[xlevel].color01=xwtm;
		xligne2[xlevel].dep88=MOVE_DEP88(*mpt2);
		xligne2[xlevel].arr88=MOVE_ARR88(*mpt2);
		xligne2[xlevel+1].level=xlevel+1;
		xligne2[xlevel+1].color01=1-xwtm;
		xligne2[xlevel+1].dep88=99;
		xligne2[xlevel+1].arr88=99;
#endif
xsearch_level[xlevel+1]->jouer(*mpt2); 
compteur_coups_joues++;	


// On suppose que c'est ce qu'il y a en dernier dans la 
// ligne et qui justifie que l'on fasse une reconstitution
if (*(mpt2+1)==LigneEndHashTable)
{
// Dernire recherche hash
// Mais  quoi sert-elle ?
// Elle sert  embrayer sur la suite,
// c'est  dire la reconstitution de la ligne depuis les
// hash tables
// La recherche hash doit tre faite juste aprs le jeu du coup 
// afin d'avoir la bonne valeur de xwtm 
h=gen_code(1);
// On recherche en extend (2) dans la hash_table
hash=get_hash(h,0,
  			  hash, 
			  hmove, 
			  hscore, 
			  hscore_status,
			  hash_depth_moins_level,
			  NODE_ALL
  			  #if HASH_TRACK_PV==1
			  ,NODE_ALL
			  #endif			  
			  );
}
// Augmenter le level de 1 pour actualiser
xlevel++;
xsearch_level[xlevel]->wtm=xwtm; 
xsearch_level[xlevel]->reactu_liste[0]=0; 
// L'actualisation est ncessaire :
// - pour les checs et donc le contrle de lgalit du coup
xsearch_level[xlevel]->maj_roque(*mpt2);
ASSERT(xsearch_level[xlevel]->finale==xsearch_level[xlevel]->s->finale);
xsearch_level[xlevel]->actualise(*mpt2); 

// Level maximum 
if (xlevel>=xdepthmax_struct)
{
	//display_info("YYYYYYY");
	*(mpt2+1)=LigneEndLevelMax;
	// A placer aprs le level++
	// car le dejouer reconstitution dbute par un level--
	goto RETURN;
}

} // fin for MOVE_IS_LINE

// Vrification code fin de ligne hash
if (MOVE_ROLE(*mpt2)!=LIGNE_END_HASH_TABLE) 
{ 
	goto RETURN; 
}


// Recherche en hash_tables
// Note : la premire recherche a dja t faite
// Rechercher en extend ( de cette faon, le correspondance extend-search est toujours assure )
for(;hash==HASH_HIT && xlevel<=xdepthmax_struct;
	lastmove=*mpt2,mpt2++)
{
//display_info("QQQQQ");
// Enregistrement et jeu du coup
*mpt2=hmove;
if (hmove==0)
{
	*mpt2=LigneEndHashTable_Reconstitution;
	goto RETURN; 
}

// Passe ?
if (MOVE_IS_PASSE(*mpt2)) 
{ 
xpasse=true; // ou extend passe
compteur_coups_joues++; 
xstates[xlevel+1]=xstates[xlevel]; 
xsearch_level[xlevel+1]->finale=xsearch_level[xlevel]->finale;
xwtm=1-xwtm;
goto GET_HASH;
} 

cc=legalite_coup_reconstitution(*mpt2,lastmove);
if (cc!=1)
{ 
		//#if DEBUG==1
		//{
		log_error("\nErreur J_984 en : %d", xcompteur);
            //STOP;
		//}
		//#endif
		*mpt2=LigneEndHashTable_Reconstitution;
		goto RETURN; 
}
xstates[xlevel+1]=xstates[xlevel]; // ncessaire pour les droits  roquer
xsearch_level[xlevel+1]->finale=xsearch_level[xlevel]->finale;
// SET_MOVE_ROLE(*mpt2,LIGNE_NORMAL_PLAY); Superflu ?
#if _DEBUG
		xligne2[xlevel].level=xlevel;
		xligne2[xlevel].color01=xwtm;
		xligne2[xlevel].dep88=MOVE_DEP88(*mpt2);
		xligne2[xlevel].arr88=MOVE_ARR88(*mpt2);
		xligne2[xlevel+1].level=xlevel+1;
		xligne2[xlevel+1].color01=1-xwtm;
		xligne2[xlevel+1].dep88=99;
		xligne2[xlevel+1].arr88=99;
#endif
xsearch_level[xlevel+1]->jouer(*mpt2);

// La recherche hash doit tre faite juste aprs le jeu du coup 
// afin d'avoir les bonnes valeurs de xwtm et xlevel
GET_HASH:
h=gen_code(1);
// On recherche en extend (2) dans la hash_table
hash=get_hash(h,0,
			  hash, 
			  hmove, 
			  hscore, 
			  hscore_status,
			  hash_depth_moins_level,
			  NODE_ALL
			  #if HASH_TRACK_PV==1
			  ,NODE_ALL
			  #endif			  
			  );
// Augmenter le level de 1 pour actualiser
xlevel++;
xsearch_level[xlevel]->reactu_liste[0]=0; 
xsearch_level[xlevel]->wtm=xwtm;
// L'actualisation reste ncessaire pour dterminer les checs
xsearch_level[xlevel]->maj_roque(*mpt2);					
xsearch_level[xlevel]->actualise(*mpt2);
compteur_coups_joues++;
// Rptition
if (xlevel>=9)
{
// Le coup a t jou  xlevel-1
// xlevel-1-7>=1 => xlevel>=9
if (   *(mpt2-0)==*(mpt2-4)
	&& *(mpt2-1)==*(mpt2-5)
	&& *(mpt2-2)==*(mpt2-6)
	&& *(mpt2-3)==*(mpt2-7)) break;
}
   
// Level maximum 
if (xlevel>=xdepthmax_struct)
{
	*(mpt2+1)=LigneEndLevelMax;
	// A placer aprs le level++
	// car le dejouer reconstitition dbute par un level--
	goto RETURN;
}
} // fin for


// Marquage fin de reconnaissance hash
//SET_MOVE_ROLE(*mpt2, LIGNE_END_HASH_TABLE_RECONSTITUTION);
*(mpt2+1)=LigneEndHashTable_Reconstitution;
//display_info("HHHHHHH");

// Djouer
// Restaurations
RETURN:
ASSERT(*mpt2!=0);
dejouer_reconstitution(ligne,compteur_coups_joues,move_one_has_been_played);
xlevel=level_mem;
xstates[xlevel]=states_mem;
xpasse=false;
} // fin reconstitution_ligne_principale



static char legalite_coup_reconstitution(MOVE move,MOVE lastmove)
{
PIECE *numptr;
MOVE move2;
char check;
char cc;

// Nullmove
if (SAME_MOVE(move,NullMove)) return 1;

// Obtention d'un move_iterator
MOVE_ITERATOR *mi=new MOVE_ITERATOR();

// Initialisations
// et pas num=mpt->actual_num_piece;
// car il faut que le coup point ait t actualis - et de surcroit au mme niveau
// et justement ce n'est pas le cas pour coup jou en level 2 ( qui avait t actualis en level==2 )!!
// et qui a t actualis en level 0 quand le coup xkeep[1] est jou en level 0
// En passant par mpt2, on trouve le bon numro de pice.
// Celui-ci permet de pointer dans xmoves la version actualise des coups disponibles
//numptr=MOVE_PIECE(mpt);
// plus conservateur
numptr=xboard[MOVE_DEP64(move)].wptr;

#if DEBUG==1
// Controle existence pice
if (numptr->nature==0)
{	
	log_error("\nJ2_857 en : %d", xcompteur);
	delete mi;
	return 0;
}
#endif


// Initialisation move_iterator
cc=0;
mi->init_piece(numptr);

// Echecs
// Suppose que l'actualisation ait t faite
check=xsearch_level[xlevel]->check;

// Suite initialisations

do // 2 boucle sur la pice
{
move2=mi->get_move();
if (move2!=0)
{
   if (!SAME_MOVE(move2,move)) continue;

   // Test de lgalit du coup
   cc=xsearch_level[xlevel]->legal(numptr->num_piece,move2,xnum_roi[xwtm],lastmove);
   
   // Correspondance trouve
   
   break;
} // fin test valid
else // nouvelle pice ?
{
  // Evidemment on se contente de la pice qui nous intresse
  break;
} // fin nouvelle pice
}
while (1); // fin do 2 bouclage sur la pice 


// Dernire vrification 
// Erreur hash table
// Le coup peut tre en apparence lgal
// mais tre catgoris en prise alors que ce n'est pas une prise !!
// Ensuite on n'utilise des pointeurs nuls au moment de jouer le coup
// Pour la prise en passant , le movecmp compare aussi les flags donc c'est OK
if (MOVE_IS_CAPTURE(move))
{
if (!MOVE_IS_EN_PASSANT(move))
{
// Il faut effectivement prendre une pice - sinon illgal
if (xboard[MOVE_ARR64(move)].nature==0) cc=0; 
}
}

// Le coup propos est-il un des coups lgaux de la pice ?
delete mi;
return cc;
} // fin legalite_coup_reconstitution




void dejouer_reconstitution(MOVE *ligne, char compteur_coups_joues,
							char move_one_has_been_played)
{
while(compteur_coups_joues>0)
{
xlevel--;
xsearch_level[xlevel+1]->dejouer(ligne[compteur_coups_joues-1+move_one_has_been_played],1);
compteur_coups_joues--;
};

// Rajustement flag passe
xpasse=false;

} // fin dejouer_reconstitution





