// SmallC_90.cpp : Defines the entry point for the console application.
//


#include "SmallC_92.h"
#include "stdafx.h"
CWinApp theApp;
#include "Cchess_1.h"
//#define MAIN // juste avant la dfinition de PREFIX
// Cette fonction est la seule  dfinir les objets 
#include "Cchess_2.h"
#include "Move.h"
//#include "Cchess_3.h"
#include "Cchess_4.h"
#include "Cchess_5.h"
#include "Cchess_6.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Fonctions locales
void fixe_bornetemps(void);
void jeu(void);
char searchstart1(void);
char searchstart(void);
char search_bibliotheque(void);
void liste_coups_legaux(void);
void pgn_translate(char dep,char arr,
				   char prom,char prise_nat,char special,char piece,
				   char *string, char *board);
void affiche_ligne(MOVE *mpt, char move_one_has_been_played);
void affiche(char i);


#if USE_BOOK_TRANSPOSITIONS==1
void play_88_game_from_bibliotheque(char *board, long game_number, short nbcoups);
#endif



/////////////////////////////////////////////////////////////////////////////
// The one and only application object


 using namespace std;

 int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		cout << _T("Fatal Error: MFC initialization failed") << endl;
		nRetCode = 1;
	}
	else
	{
		
		// TODO: code your application's behavior here.
		/*
		CString strHello;
		strHello.LoadString(IDS_HELLO);
		cout << (LPCTSTR)strHello << endl;
		*/

		//SearchThreadClass *t1= new SearchThreadClass();
		//SearchThreadClass *t2= new SearchThreadClass();
		//exit(0);

		// Mode console ou mode UCI
		xconsole_mode_from_command_line=false;
		if (argc==2)
		{
			if (strcmpi(argv[1],"-console")==0)
			{
				xconsole_mode_from_command_line=true;
			}
			if (strcmpi(argv[1],"console")==0)
			{
				xconsole_mode_from_command_line=true;
			}
			if (strcmpi(argv[1],"-uci")==0)
			{
				xuci_mode_from_command_line=true;
			}
			if (strcmpi(argv[1],"uci")==0)
			{
				xuci_mode_from_command_line=true;
			}
		}

		debut();
		jeu();

	}

	return nRetCode;
} // fin _tmain




void jeu(void)
{
short l;
__int64 l64_1, l64_2;



/* A CONSERVER 
Test du thread de lecture de l'entre standard
for(;;)
	{
        // Nous analysons une position
		Sleep(1); // une milliseconde
        // Ce sleep 1 permet de vrifier au moyen 
		// de CTRL-ALT-SUPPR
		// que le taux d'utilisation du CPU tombe  zro
		// avec cette boucle
		// En d'autres termes, la consommation de CPU
		// est ngligeable mme en regard d'une milliseconde

        // Nous verifions maintenat si nous avons recu quelque chose
     	if (uci_interface::IOManager.InputLinesAvailable)
		{
			cout << "j'ai recu " 
			<< (const char *)uci_interface::IOManager.wait4_user_input() 
					  << "\n";
			cout.flush();
		}
		
	}
*/
	
char cc;
short i,j,k;
char game, status;
END_RESULT result;
char F_pondered_answer;
//long li1;
CASE *cptr;

// Initialisations
xcompteur_depart=xcompteur=0;

// Recherche
do
{
xlevel=0;

#if UCI_DEBUG==1
display_info_debug("Avant lancement askmove");
#endif


if (!xmove_has_been_pondered) 
{
F_pondered_answer=false;
switch (xmode)
{
case 'A' : game=searchstart1(); break; 
case 'B' : if (xwtm==1)  {game=searchstart1(); break;}
		   else             {game=askmove(); break;}
case 'N' : if (xwtm==0)  {game=searchstart1(); break;}
	       else             {game=askmove(); break;}
case 'C' : game=askmove(); 
		if (xuci_mode)
		{
		// Gestion du mode UCI au premier passage
		if ( uci_interface::F_position_set_from_uci ) 
		{
			// Undispensable en mode UCI
			ajustement_parametres_globaux();
			//display_info_force("\nAjustement parametres globaux");
			uci_interface::F_position_set_from_uci=false;
			goto POSITION_SET_FROM_UCI;
		}
		}
	break;
}
} 
else // xmove_has_been_pondered
{
F_pondered_answer=true;
xmove_has_been_pondered=false; // rinitialise xmove_has_been_pondered
// Actualisation du temps de rflexion
// pour tenir compte du temps de manipulation
xtimecumul[1-xwtm]+=xconsole_tempsmanip1+xconsole_tempsmanip2;
// Rem : pas de temps ni de coups utiliss puisque
// xcompteur_start : a t positionn
// soit au moment de l'entre du coup
// soit en fin de recherche permanent brain ( =xcompteur dans ce cas ))

xkeep[1]=xpondering_answer;
xkeep[2]=xpondering_answer_answer;

// le reste de la ligne a t conserv dans xkeep
xlastvalue1=xpondering_answervalue;
//xlastvaluemat1=xpondering_answervaluemat;
game=UNDECIDED; // sinon askmove2 s'est arrt
}

#if UCI_DEBUG==1
sprintf(uci_interface::info_buffer,"Game : %d",game);
display_info_debug(uci_interface::info_buffer);
#endif


// Traitement du takeback
if (game==TAKE_BACK)
{
continue; // retour en dbut de boucle
}


// Changement de mode
if (game==CHANGE_MODE)
{
continue; // retour en dbut de boucle
}

/*
UNDECIDED=0,
WHITE_GIVES_MATE=1,
BLACK_GIVES_MATE=2,
WHITE_IS_MATE=3,
BLACK_IS_MATE=4,
PLAYER_IS_PAT=5,
DRAW_REPETITION=6,
DRAW_50_MOVES=7,
THORETICAL_DRAW=8,
WHITE_RESIGNS=9,
BLACK_RESIGNS=10,

*/

// Si Mat constat sans coup - ou Pat - : break;
// Idem si abandon
if (game==WHITE_IS_MATE || game==BLACK_IS_MATE || game==PLAYER_IS_PAT || game==WHITE_RESIGNS || game==BLACK_RESIGNS ) 
{
xpartie[xnbcoups].status=game;
// Recration de la partie - gestion du +# final
// ( On souhaite avoir Cf6# 1-0 et non Cf6+# 1-0 )
CONSOLE_MODE;
cree_partie_pgn(xhandle,xnom_game,xpartie,xnbcoups); 
break;
END_MODE;
}





if (xuci_mode)
{
// Gestion du mode UCI 
if ( uci_interface::F_position_set_from_uci ) 
{
	// Indispensable en mode UCI
	ajustement_parametres_globaux();
	//display_info_force("\nAjustement parametres globaux");
	uci_interface::F_position_set_from_uci=false;
	goto POSITION_SET_FROM_UCI;
}
}


// Jeu du coup
xnbcoups++;
if (xnbcoups>xmaxnbcoups) 
{
xpartie=(ENREGISTREMENT*)realloc(xpartie,(xmaxnbcoups+50+2)*sizeof(ENREGISTREMENT));
if (xpartie==0)
	log_error("\nErr Sm 165");
xmaxnbcoups+=50;
}

ASSERT(xlevel==0);
xsearch_level[0]->jouer(xkeep[1]);
xsearch_level[0]->maj_roque(xkeep[1]); // aprs jouer
// if (++xhash_indice_generation==127) xhash_indice_generation=0;
xsearch_level[0]->eval_pawnstruct();
xlastmove=xkeep[1];
// pour viter une actu partielle 
// et des pertes de coups dans xtable_pgn
xsearch_level[0]->actualise_all(); 

// Rinitalisation
// En effet, on risquerait sinon de dborder au fil du temps
// car cette valeur n'est sinon jamais rinitialise
xsearch_level[0]->reactu_liste_nombre=0;


// Rgle des 50 coups
// Ce dernier point est  vrifier. Pourquoi ?
// Jouer ne modifie pas num !!
// Mais exact dans search.cpp 'o les lignes ont t copies

if (MOVE_CHANGES_LASTPRISE(xlastmove))
{
xlastprise1=xnbcoups;
}
// Initialisation lastprise2
xstates[0].lastprise2=xlastprise1;
// par scurit mme si la copie de xstates est faite ensuite
// Test 50 coups
if (xnbcoups-xlastprise1>=100)
{game=DRAW_50_MOVES;} // mais le coup doit aussi tre enregistr


// Actualisation poids roque
// Egalement ncessaire en mode UCI avant pondering
ajustement_parametres_globaux();
UCI_MODE;
//display_info_force("\nAjustement parametres globaux aprs coup");
END_MODE;

// Recopie au level 1
//xstates[1]=xstates[0];


// Enregistrement en trace hash
#if HASH_TRACE==1
h_code h;
xstates[1]=xstates[0]; h=gen_code(0);
hashtrace(h);
#endif


// Copie du coup dans la xliste50
//xliste50[xnbcoups-xlastprise1]=xlastmove;
xliste50[xnbcoups-xlastprise1]=gen_code(0);


#if CHECK_REPET==1 && DEBUG==1
char dd;
char *ptr;
PIECE *wptr2;
char ci1;
// Copie de la position - rptition
// aprs le coup
ptr=&xpositions[xnbcoups-xlastprise1][0];
wptr2=&xw[31];
for (ci1=31; ci1>=0; ci1--, wptr2--, ptr++)
{
if (wptr2->nature==0) { *ptr=0; continue; }
*ptr=wptr2->pos;
}
dd=fct_repetition2(xlastmove, xlastprise1);
#endif



// Test rptition
H_CODE h;
h=gen_code(0);
cc=fct_repetition(xlastmove,h,xlastprise1);
# if CHECK_REPET==1 && DEBUG==1
if (cc!=dd)
{
log_error("\nPb - Search_Repet");
}
#endif


// Vrification rptition de coup
if (cc==REPETITION_DRAW)
{
game=DRAW_REPETITION;
}


// Affichage coup en mode console
// doit tre fait aprs le jeu du coup
CONSOLE_MODE;
// Pas d'affichage du coup si rptition
// Le coup est alors invoqu avec la rptition
if (game!=DRAW_50_MOVES && game!=DRAW_REPETITION)
{
// Message sonore
	if ( xenable_sound ) printf("\a");
	printf("\n"); 

// Affichage chiquier et valuation
printf("\n"); 
//printf("");
for(cptr=&xboard[0],i=0;i<=63;i++,cptr++)
{
if (cptr->posy==0)
{
printf(""); // Sparateur
}
if (cptr->nature==0) printf("%c",' ');
else  printf("%c",cptr->nature);
} //fin for
printf("");


// Affichage valuation
printf("\nEvaluation : ");
if ((xmode=='B' && xwtm==0) || (xmode=='N' && xwtm==1) || xmode=='C')
{
printf("%d",xsearch_level[0]->fctn_eval()); 
}
else
{
if (xlastvalue1>-MATE_VALUE_THRESHOLD && xlastvalue1<MATE_VALUE_THRESHOLD)
{
printf("%d",xlastvalue1);
}
else
{
check_mate_score(&xkeep[1],xlastvalue1);
l=xlastvalue1;
if (l>0) {l=MATE_VALUE-l; printf("+");}
else	 {l=MATE_VALUE+l; printf("-");}
l=DIV2(l);
if (l<1L) printf("mat : %d", xlastvalue1 );
else      printf("mat en %d : %d\n",l,xlastvalue1) ;
}
}
if (xtrait==1)
	printf("\nNbcoups : %d",DIV2(xnbcoups)+M_2(xnbcoups));
else // xtrait==0
	printf("\nNbcoups : %d",DIV2(xnbcoups)+M_2(xnbcoups));
if (xwtm==1) printf("-N  ");
else 	     printf("-B  ");
printf("Tmps : "); 
l64_1=(xavailable_time[xwtm]-xtimecumul[xwtm]);
l64_2=l64_1%60; // Modulo minute
l64_1=l64_1-l64_2; // Nombre entier de minutes
l64_1+=(l64_2*6)/10;
printf ("%5.2f",(double) l64_1/60);
printf ("  Tpc : ");
printf ("%5.2f",xtempsprevu[xwtm]-xconsole_tempsmanip1-xconsole_tempsmanip2);
printf(" Cpt : %d",xcompteur);
printf(" Cps : %d",xcps);
printf(" Pr : %d",xlv1_depth>>FD);
printf ("\n"); 
affiche_ligne(&xkeep[1],1); // le coup a t t jou
printf(" ");
affiche_coup(xkeep[1]);
if (MOVE_IS_PROMOTION(xkeep[1])) printf(":%c",MOVE_PROMOTION(xkeep[1]));

if (xstop6==1) affiche_stat_elag();

// Saut de plusieurs espaces
printf("\n\n\n\n\n"); 

// Fin affichage chiquier 

} // fin game 6 et 7
END_MODE; // mode console



// Affichage du coup en mode UCI
UCI_MODE;
if (uci_interface::F_suppress_bestmove_answer) 
		uci_interface::F_suppress_bestmove_answer=false;
else
{
if ( // Lister les exclusions
	 // note xnbcoups n'a pas encore t incrment
	 // si le coup n'a pas t jou en mode UCI
	 // => ajouter 1 
	 // et retrancher uci_interface::F_position_set_from_uci
	    !( xmode=='B' && M_2((1-xtrait)+xnbcoups-uci_interface::F_position_set_from_uci)==0 )
	 && !( xmode=='N' && M_2((1-xtrait)+xnbcoups-uci_interface::F_position_set_from_uci)==1 )
   )
{
	formatte_move_to_uci(xkeep[1], uci_interface::uci_move);
	if ( xenable_sound ) { putch(7); }
	cout << "bestmove " << uci_interface::uci_move;

	if ( xpermanentbrain_is_on
		 && game!=WHITE_GIVES_MATE
		 && game!=BLACK_GIVES_MATE
		 && MOVE_IS_FOR_PLAY(xkeep[2])
		 ) 
	{   formatte_move_to_uci(xkeep[2], uci_interface::uci_move);
		cout << " ponder " << uci_interface::uci_move;
	}
	cout << "\n";
	cout.flush();
} // fin if exclusions
} // fin suppress_bestmove
END_MODE;
// Fin affichage coup


// Ajustement des statistiques de la bibliothque d'ouverture
if (    abs(xlastvalue1)>WIN_THRESHOLD
     && !xopeningbook_in_use
     && !xopeningbook_has_been_updated 
     && xenable_book_learning 
     && xopeningbook_has_been_used
     && !xreset_book_stats)
{
display_info("\nMise  jour bibliothque d'ouverture en cours ...\n"); 

if ( xlastvalue1>WIN_THRESHOLD ) result=WHITE_WIN;
else			   result=BLACK_WIN;

cc=adjust_book_stats(result);
xopeningbook_has_been_updated=true;
if (cc==0) 
{
display_info("\nMise  jour termine\n"); 
}
else
{ 
display_info("\nEchec mise  jour\n"); 
}
}




// Statut du coup
status=game; // plus simple non ?
/*
switch(game)
{
case WHITE_GIVES_MATE :       status=1; // mat 1-0 donn
case BLACK_GIVES_MATE :       status=2; // mat 0-1 donn
case WHITE_IS_MATE :       status=0; // mat 1-0 reu 
case BLACK_IS_MATE :       status=0; // mat 0-1 reu
case PLAYER_IS_PAT :       status=5; // pat ( subi )
case DRAW_REPETITION :       status=6; // nulle par rptition
case DRAW_50_MOVES :       status=7; // nulle par 50 coups
case THORETICAL_DRAW :       status=8; // nulle ( insuffisance matriel )
case BLACK_RESIGNS :       status=9;  // black resigns
case WHITE_RESIGNS:       status=10; // white resigns
default:       status=0;  // 
}
*/

/*
enum GAME_RESULT
{
UNDECIDED=0,
WHITE_GIVES_MATE=1,
BLACK_GIVES_MATE=2,
WHITE_IS_MATE=3,
BLACK_IS_MATE=4,
PLAYER_IS_PAT=5,
DRAW_REPETITION=6,
DRAW_50_MOVES=7,
THORETICAL_DRAW=8,
BLACK_RESIGNS=9,
WHITE_RESIGNS=10
};
*/



// Rptition de coup
// En tant puriste on ne joue pas le coup
// Pour faire simple, on joue le coup et cela permet d'alimenter 
// le fichier PGN le plus simplement

/*
// Enregistrement dans liste de partie
if (xnbcoups>xmaxnbcoups) 
{
// Curieusement, il arrive que la fonction realloc
// choue - sans raison dtermine
// en particulier quand le programme fonctionne sous ARENA
// D'o finalement un calloc systmatique
xpartie_temp=(ENREGISTREMENT*)calloc(xmaxnbcoups+50,sizeof(ENREGISTREMENT));
if (xpartie_temp==NULL)
{
	log_error("\nErreur C_103 - Echec calloc");
}
memcpy(xpartie_temp, xpartie, (xmaxnbcoups+1)*sizeof(ENREGISTREMENT));
free(xpartie);
xpartie=xpartie_temp;
xmaxnbcoups+=50;
} 
*/

if (xnbcoups>xmaxnbcoups) 
{
//if (xpartie==0)
//	log_error("\Err Sm 4342");
xpartie=(ENREGISTREMENT*)realloc(xpartie,(xmaxnbcoups+50+2)*sizeof(ENREGISTREMENT));
if (xpartie==0)
	log_error("\nErr Sm 4343");
xmaxnbcoups+=50;
}


xpartie[xnbcoups].ynbcoups=DIV2(xnbcoups+1);
xpartie[xnbcoups].demicoup=2-xnbcoups%2;
xpartie[xnbcoups].xnbcoups=xnbcoups;
xpartie[xnbcoups].dep88=MOVE_DEP88(xkeep[1]);
xpartie[xnbcoups].arr88=MOVE_ARR88(xkeep[1]);
xpartie[xnbcoups].prom=MOVE_PROMOTION(xkeep[1]);
xpartie[xnbcoups].special=MOVE_GET_SPECIAL(xkeep[1]);
xpartie[xnbcoups].piece_num=MOVE_NUM_PIECE(xkeep[1]);
xpartie[xnbcoups].prise_nat=MOVE_CAPTURE(xkeep[1]);
//xpartie[xnbcoups].prise_num=xboard[xpartie[xnbcoups].arr].nature;
xpartie[xnbcoups].status=status;
xpartie[xnbcoups].check=xsearch_level[xlevel]->echecs_count;



// Enregistrement du coup sur xpartie et fichier PGN 
// - aprs les calculs
// - aprs les affichages
CONSOLE_MODE;
enregistre_coup_pgn(1);
END_MODE;


// Reset des hash tables
// aprs les affichages
// et aprs le position set from uci
#if USE_HASH_TABLE==1
#if RESET_HASH_TABLE==1 
// Le flag sert  l'alternance blanc noir
reset_hash_table();
#endif

#if RESET_HASH_TABLE==0
//xold_lv1_dep=MOVE_DEP64(xkeep[1]);
//clean_hash_table((unsigned __int16) xkeep[1]);
//if (xhash_indice_generation==126) reset_hash_indice_generation();
#endif
#endif



// UCI
// Lorsque la position est saisie depuis l'interface UCI
// le dernier coup a dja t jou
POSITION_SET_FROM_UCI:

// Compactage de la liste de coups
compact_piece_list();

// Initialisation xlastvalue0
xlastvalue0=xlastvalue1;
//xlastvaluemat0=xlastvaluemat1;

#if UCI_DEBUG==1
display_info_debug("Fin affichage");
#endif

// Cration de la liste de coups
// Cration de la liste au format PGN
// Utilis aussi pour la bibliothque d'ouverture
// et dans la fonction askmove
// et dans la fonction askmove3 
// (demande de coup en permanent brain)

if (xmode!='A' || xopeningbook_in_use)
{
liste_coups_legaux();
} // fin cration liste de coups jouables de l'adversaire


// Contr"le intgrit matriel
// (aprs l'affichage du coup - gain de temps)
#if DEBUG==1
short int si1;
PIECE *wptr;
if ( !xuci_mode )
{
si1=0;
wptr=&xw[31];
for (i=31;i>=0;i--,wptr--)
{
	if (wptr->nature==0) continue;
	si1+=wptr->value;
}
if  (si1!=xstates[0].materiel)
{
log_error("\nErr C_019 en : %d",xcompteur);
}
}
#endif



#if DEBUG==1
// Contrle xboard.ptr
for (i=63;i>=0;i--)
{
if (xboard[i].wptr==&xwnull) continue;
if (xboard[i].wptr->nature!=xboard[i].nature)
{
log_error("\nProblme C_801 en : ",xcompteur);
}
}
#endif


// Interruption entre les coups
CONSOLE_MODE;
if (xstop2)
{
if (game==UNDECIDED) // Pas de pause s'il y a mat
{
// xcompteur5=0; // rinitialisation compteur xlistmoves
if (xmode=='A')
{
printf("\nFaites ENTER pour poursuivre ...\n");
getch();
}
}
} // if xstop2
END_MODE;


#if UCI_DEBUG==1
display_info_debug("Avant controle fin partie");
#endif



// Break fin de partie
CONSOLE_MODE;
if (game>0) break; // partie termine
END_MODE;


#if UCI_DEBUG==1
display_info_debug("Aprs contrle fin partie");
#endif

CONSOLE_MODE;
// Sauvegarde de la position
// (pour identifier les pions dans askmove3)
// (mode de stockage diffrent de celui des positions)
for (j=63; j>=0; j--) { xmempos[j]=0; }
for (i=31; i>=0; i--)
{
if (xw[i].nature==0) continue;
k=xw[i].pos;
xmempos[k]=(xw[i].nature)*(xw[i].color);
#if DEBUG == 1
if ((k<0 || k>64) && k!=0)
{
log_error("\nErreur I_020");
}
#endif
}
END_MODE;

CONSOLE_MODE;
// Diffrentiel temporaire d'valuation
// (aprs le jeu du coup)
// diffrence entre l'valuation de la position et la situation
// matrielle relle
//xsearch_level[0].valposmat=TO_PLAYER(xwtm)*(long)xstates[0].materiel;
if (xkeep[2]==LigneEndAskmove) // si coup jou sur askmove
{
//xlastvaluemat1=TO_PLAYER(xwtm)*xsearch_level[0].valposmat;
//xlastvaluemat1=PLAYER(TO_PLAYER(xwtm),xstates[0].materiel);
// En effet, aprs askmove xvaluemat n'a pas t calcul
// et doit tre rinitialis
// xdiffval est donc considr comme gal  zro
}
// Si blanc vient de prendre mais que noir va reprendre
// xvalposmat est suprieur  xlastvaluemat
// xdiffval est ngatif
// C'est ce qu'il faut ajouter  xvalposmat[0] pour
// retrouver la valeur de xlastvaluemat0
//xdiffval=xlastvaluemat0-TO_PLAYER(xwtm)*xsearch_level[0].valposmat;
//xdiffval=xlastvaluemat0-PLAYER(TO_PLAYER(xwtm),xstates[0].materiel);
END_MODE;

} while (1); // fin du do

UCI_MODE;
display_info_force("\nFin de partie");
sprintf(uci_interface::info_buffer,"Game : %d",game);
display_info_force(uci_interface::info_buffer);
log_error("\nFin de partie");
END_MODE;


FIN:

// Affichage conclusion de la partie
CONSOLE_MODE;
printf("\nFaire <Entrer> pour continuer");
getch();


switch (game)
{
case WHITE_GIVES_MATE : printf("\n\n1-0 MAT\n");		       break;
case BLACK_GIVES_MATE : printf("\n\n0-1 MAT\n");		       break;
case WHITE_IS_MATE : printf("\n\n1-0 MAT\n");		       break;
case BLACK_IS_MATE : printf("\n\n0-1 MAT\n");		       break;
case PLAYER_IS_PAT : printf("\n\nPAT\n");			       break;
case DRAW_REPETITION : printf("\n\nNulle - Rptition (");
	 affiche(MOVE_DEP88(xkeep[1]));
	 affiche(MOVE_ARR88(xkeep[1])); printf(")\n"); 	       break;
case DRAW_50_MOVES : printf("\n\nNulle - 50 coups (");
	 affiche(MOVE_DEP88(xkeep[1]));
	 affiche(MOVE_ARR88(xkeep[1])); printf(")\n"); 	       break;
case THEORETICAL_DRAW : printf("\n\nNulle - Matriel insuffisant\n"); break;
case WHITE_RESIGNS : printf("\n\n0-1 Abandon\n");		       break;
case BLACK_RESIGNS : printf("\n\n1-0 Abandon\n");		       break;
} // fin du switch


// Ajustement des statistiques de la bibliothque d'ouverture
// si cet ajustement n'a pas t fait ( en particulier pour les parties nulles )
if (    !xopeningbook_in_use
     && !xopeningbook_has_been_updated 
     && xenable_book_learning 
     && xopeningbook_has_been_used
     && !xreset_book_stats)
{
display_info("\nMise  jour bibliothque d'ouverture en cours ...\n"); 
xopeningbook_has_been_updated=true;



switch(game)
{
case UNDECIDED : result=DRAW; break;
case WHITE_GIVES_MATE  : result=WHITE_WIN; break;
case BLACK_GIVES_MATE  : result=BLACK_WIN; break;
case PLAYER_IS_PAT  : result=DRAW; break;
case DRAW_REPETITION  : result=DRAW; break;
case DRAW_50_MOVES  : result=DRAW; break;
case THEORETICAL_DRAW  : result=DRAW; break;
case WHITE_RESIGNS : result=BLACK_WIN; break;
case BLACK_RESIGNS : result=WHITE_WIN; break;
default : result=DRAW; break;
}

cc=adjust_book_stats(result);
if (cc==0) 
{
display_info("\nMise  jour termine\n"); 
}
else
{ 
display_info("\nEchec mise  jour\n"); 
}
}


// Affichages de fin de partie
printf("\nFaire <Entree> pour continuer"); getch();


if ( xenable_sound ) printf("\a");
END_MODE;


#if DEBUG==1
#if COLLECT_STATS==1
printf("\nTaille maximale de la liste de coups interne : ");
printf("%d",xlengthmax_listmoves);
long li1;
li1=0;
for ( i=0; i<=(char) OR_MARQUAGE_FIN_ENUM_OR_SEARCH-1; i++)
{
li1+=xorigine_search[i];
}
printf("\n%Essais - %Enregistrs - %Window-match - Enregistrs - %Efficacit");
printf("\nOR_SEARCH - POURCENTAGE ELUCIDE : %3.2f ", ( float )  
               100*li1/xorigine_search_total);
for ( i=0; i<=(char) OR_MARQUAGE_FIN_ENUM_OR_SEARCH-1; i++)
{
	printf("\n%s : ", xor_search[i]);
	printf("%3.1f - %3.1f - %3.1f", 
		( float ) xorigine_search_essais[i]*100/xorigine_search_essais_total,
                ( float ) xorigine_search[i]*100/xorigine_search_total,
		( float ) xorigine_search_window_match[i]*100/xorigine_search_window_match_total);
        printf(" - %d", xorigine_search[i]);
		if ( xorigine_search_essais[i]>0 ) { printf(" - Eff. : %3.1f\%", (float) xorigine_search[i]*100/(xorigine_search_essais[i])); }
}
// Extend
li1=0;
for ( i=0; i<=(char) OR_MARQUAGE_FIN_ENUM_OR_EXTEND-1; i++)
{
li1+=xorigine_extend[i];
}
printf("\nOR_EXTEND - POURCENTAGE ELUCIDE : %3.2f ",
	   ( float ) 100*li1/xorigine_extend_total);
for ( i=0; i<=(char) OR_MARQUAGE_FIN_ENUM_OR_EXTEND-1; i++)
{
	printf("\n%s : ", xor_extend[i]);
	printf("%3.1f - %3.1f", 
		( float ) xorigine_extend_essais[i]*100/xorigine_extend_essais_total,
		( float ) xorigine_extend[i]*100/xorigine_extend_total);
	printf(" - %d", xorigine_extend[i]);
		if ( xorigine_extend_essais[i]>0 ) 
		  { printf(" - Eff. : %3.1f\%", (float) xorigine_extend[i]*100/(xorigine_extend_essais[i])); }
}


printf("\nFaire <Entree> pour continuer"); getch();
getch();


#if MAIN_STATISTICS_ONLY!=1
for (i=1;i<=15;i++)
{
printf("\nPourcentage de coups au niveau ");
printf("%d",i); printf(" : ");
printf("%5.2f%",(double)
	   xlevel_hits[i]/xcompteur*100);
}
printf("\nFaire <Entree> pour continuer"); getch();

for (i=5;i<=10;i++)
{
printf("\nPourcentage de hit hash au niveau ");
printf("%d",i); printf(" : ");
printf("%5.2f",(double)
	   xhhits_level[i]/(xlevel_hits[i]+1)*100);
}
printf("\nRatio d'amelioration aspiration : ");
printf("%5.2f",(double) xratio_improvement);
printf("\nPlus grand level atteint : %d", (short) xmaxlevel_reached);
printf("\nRatio d'accroissement : ");
if (xmode=='A') printf("%5.2f",(double) DIV2(xratio[0]+xratio[1]));
if (xmode=='B') printf("%5.2f",(double) xratio[1]);
if (xmode=='N') printf("%5.2f",(double) xratio[0]);

printf("\nFaire <Entree> pour continuer"); getch();
#endif
// fin endif main_statistics_only

printf("\nPourcentage de visites en search : ");
printf("%5.2f",(double) xvisites_search*100/(xvisites_search+xvisites_extend));
printf("\nPourcentage de visites en extend : ");
printf("%5.2f",(double) xvisites_extend*100/(xvisites_search+xvisites_extend));
printf("\nPourcentage de suites en search : ");
printf("%5.2f",(double) xcompteur_search*100/xcompteur);
printf("\nPourcentage de suites en extend : ");
printf("%5.2f",(double) xcompteur_extend*100/xcompteur);
printf("\nPourcentage de coups search passe : ");
printf("%5.2f",(double) xcompteur_searchpasse*100/xcompteur);
printf("\nPourcentage de coups extend passe : ");
printf("%5.2f",(double) xcompteur_extendpasse*100/xcompteur);
printf("\nPourcentage de coups en analyse11 : ");
printf("%5.2f",(double) xcompteur_extend_analysis11/xcompteur*100);
printf("\nPourcentage de coups en analyse12 : ");
printf("%5.2f",(double) xcompteur_extend_analysis12/xcompteur*100);
printf("\nPourcentage de recherche de bonus echec : ");
printf("%5.2f",(double) xnb_check_bonus_attempts/xcompteur_extend*100);
printf("\nPourcentage d'attribution de bonus echec sur tentatives : ");
printf("%5.2f",(double) xnb_check_bonus_given/xnb_check_bonus_attempts*100);
printf("\nNombre de reprises immediates en level1 : ");
printf("%d", xnb_reprise_immediate_level1);
printf("\nPourcentage de level de reprises immediates (sauf level 1) : ");
printf("%5.2f",(double) xnb_reprise_immediate_autres_levels/xnb_search_levels*100);
printf("\nPourcentage d'liminations pour reprise immdiate : ");
printf("%5.2f",(double) xelag_reprise_immediate/xcompteur_search*100);
printf("\nPourcentage de menaces dtectes sur passe-actif : ");
printf("%5.2f",(double) xcompteur_extend_threat_detected/(xcompteur_extend_passeactif+1)*100);
printf("\nPourcentage de menaces couvertes sur menaces dtectes : ");
printf("%5.2f",(double) 100 - (double) xcompteur_extend_threat_covered/(xcompteur_extend_threat_detected+1)*100);
printf("\nPourcentage d'checs en aspiration : ");
printf("%5.2f",(double) 
(xaspi_lowfailure+xaspi_uppfailure)/
	(xaspi_success+xaspi_lowfailure+xaspi_uppfailure)*100);
printf("\nPourcentage de recherche lanc en mode try_zerowindow : ");
printf("%5.2f", (double)
	xcompteur_try_zerowindow/(xcompteur_fullwindow+1+xcompteur_try_zerowindow+xcompteur_zerowindow+1)*100);
printf("\nPourcentage de recherche lanc en mode zerowindow : ");
printf("%5.2f", (double)
	xcompteur_zerowindow/(xcompteur_fullwindow+xcompteur_try_zerowindow+xcompteur_zerowindow+1)*100);
printf("\nPourcentage de recherche lanc en mode fullwindow : ");
printf("%5.2f", (double)
	xcompteur_fullwindow/(xcompteur_fullwindow+xcompteur_try_zerowindow+xcompteur_zerowindow+1)*100);
printf("\nPourentage de relance en mode try_zerowindow : ");
printf("%5.2f", (double) xcompteur_localretry/(xcompteur_try_zerowindow+1)*100);
printf("\nPourcentage d'anomalie localretry2 : ");
printf("%5.2f", (double)
xcompteur_localretry_problem/(xcompteur_localretry+1)*100);
printf("\nPourcentage de fail_high en mode try_zerowindow : ");
printf("%5.2f", (double)
xcompteur_zerowindow_fail_high/(xcompteur_try_zerowindow+1)*100);
/*
printf("\nPourcentage de recherche lanc en mode try_zerowindow_ex : ");
printf("%5.2f", (double)
	xcompteur_try_zerowindow_ex/(xcompteur_fullwindow_ex+1+xcompteur_try_zerowindow_ex+xcompteur_zerowindow_ex)*100);
printf("\nPourcentage de recherche lanc en mode zerowindow_ex : ");
printf("%5.2f", (double)
	xcompteur_zerowindow_ex/(xcompteur_fullwindow_ex+xcompteur_try_zerowindow_ex+xcompteur_zerowindow_ex+1)*100);
printf("\nPourcentage de recherche lanc en mode fullwindow_ex : ");
printf("%5.2f", (double)
	xcompteur_fullwindow_ex/(xcompteur_fullwindow_ex+xcompteur_try_zerowindow_ex+xcompteur_zerowindow_ex+1)*100);
printf("\nPourentage de relance en mode try_zerowindow_ex : ");
printf("%5.2f", (double) xcompteur_localretry_ex/(xcompteur_try_zerowindow_ex+1)*100);
printf("\nPourcentage d'anomalie localretry2 : ");
printf("%5.2f", (double)
xcompteur_localretry_problem_ex/(xcompteur_localretry_ex+1)*100);
*/
printf("\nPourcentage de nodes en node_pv : ");
printf("%5.2f",(double) (xnodes_pv*100)/xcompteur);
printf("\nPourcentage de nodes en node_cut : ");
printf("%5.2f",(double) (xnodes_cut*100)/xcompteur);
printf("\nPourcentage de nodes en node_all : ");
printf("%5.2f",(double) (xnodes_all*100)/xcompteur);
printf("\nPourcentage de nodes en node_extend : ");
printf("%5.2f",(double) (xnodes_extend*100)/xcompteur);
printf("\nPourcentage d'checs en lancement search : ");
printf("%5.2f",(double) xlaunch_lastdepth_time_failure/xlaunch_lastdepth*100);
printf("\nPourcentage d'extensions pour xregister0 : ");
printf("%5.2f",(double) xnum_time_extension/xlaunch_lastdepth*100);
printf("\nPourcentage d'extensions pour suite insuffisante : ");
printf("%5.2f",(double) xnum_time_extension2/xlaunch_lastdepth*100);
printf("\nPourcentage total d'extensions : ");
printf("%5.2f",(double) (xnum_time_extension+xnum_time_extension2)
	                     /xlaunch_lastdepth*100);
printf("\nPourcentage d'chec des extensions : ");
printf("%5.2f",(double) xtime_extend_failure/(xnum_time_extension+1)*100);

printf("\nFaire <Entree> pour continuer"); getch();
getch();

printf("\nPourcentage moyen de remplissage hash_table : ");
printf("%5.2f",(double) xhash_second_part_hits
	   /(xhash_first_part_hits+1)*100);
printf("\nPourcentage moyen de remplissage hash_table_pawn : ");
printf("%5.2f",(double) xpawnhash_second_part_hits
	   /(xpawnhash_first_part_hits+1)*100);
printf("\nPourcentage de hits en search (reste en extend) : ");
printf("%5.2f",(double) xsearch_hits/(xhhits)*100);
printf("\nPourcentage de suites au plafond : ");
printf("%5.2f",(double)
	  (xlevel_hits[STMAX-1]+xlevel_hits[STMAX])/xcompteur*100);
printf("\nNombre de coups retenus avant le meilleur en search ( idealement 0 ) : ");
printf("%5.1f",(double) xcompteur_nbplayed_before_best/xcompteur_nbplayed_num);
printf("\nNombre de coups retenus avant le meilleur en extend ( idealement 0 ) : ");
printf("%5.1f",(double) xcompteur_nbplayed_before_best_ex/xcompteur_nbplayed_num_ex);
printf("\nNombre de coups retenus avant le meilleur en search ( fail-low ) : ");
printf("%5.1f",(double) xcompteur_nbplayed_before_best2/xcompteur_nbplayed_num2);
printf("\nNombre de coups retenus avant le meilleur en extend ( fail-low ) : ");
printf("%5.1f",(double) xcompteur_nbplayed_before_best_ex2/xcompteur_nbplayed_num_ex2);
printf("\nPourcentage fail-low/total en search a depthtarget : ");
printf("%5.2f",(double) xcompteur_fail_low*100/(xcompteur_not_fail_low+xcompteur_fail_low));
printf("\nPourcentage d'lagage de futilit prises impaires en extend : ");
printf("%5.1f",(double) xelag_elagage_prise_impaire/xcompteur_extend*100);
printf("\nPourcentage d'lagage de futilit prises impaires sur tentatives : ");
printf("%5.1f",(double) xelag_elagage_prise_impaire/xelag_elagage_prise_impaire_tentatives*100);
printf("\nPourcentage d'lagage de couvertures checs : ");
printf("%5.1f",(double) xelag_couvertures_echec_ex/xcompteur_search*100);
printf("\nPourcentage d'lagage de couvertures checs 2: ");
printf("%5.1f",(double) xelag_couvertures_echec_ex_2/xcompteur_search*100);
printf("\nPourcentage d'lagage par level_intermediaire sur xcompteur_search : ");
printf("%5.1f",(double) xelag_level_intermediaire/xnb_search_levels*100);
printf("\nPourcentage d'lagage par nullmove sur xcompteur_search : ");
printf("%5.1f",(double) xelag_nullmove/xnb_search_levels*100);
printf("\nPourcentage de tentatives de nullmove en search: ");
printf("%5.1f",(double) xnb_level_nullmove/xcompteur_search*100);
printf("\nPourcentage d'lagage par nullmove sur xnb_level_nullmove: ");
printf("%5.1f",(double) xelag_nullmove/xnb_level_nullmove*100);
printf("\nPourcentage de suites sous nullmove en search: ");
printf("%5.1f",(double) xcompteur_search_sous_nullmove/xcompteur_search*100);
printf("\nPourcentage d'lagag par futilit : ");
printf("%5.1f",(double) xnb_futility/xcompteur_search*100);
printf("\nPourcentage d'lagag par futilit tendue: ");
printf("%5.1f",(double) xnb_extended_futility/xcompteur_search*100);
printf("\nPourcentage d'lagage par futilit-2 : ");
printf("%5.1f",(double) xnb_futility2/xcompteur_search*100);
printf("\nPourcentage d'lagage par futilit-3 : ");
printf("%5.1f",(double) xnb_futility3/xcompteur_search*100);
printf("\nPourcentage de retry a profondeur nominale : ");
printf("%5.1f",(double) xnb_retry_fulldepth/xcompteur_search*100);
printf("\nPourcentage de gain materiel en bilan_avant_coup : ");
printf("%5.1f",(double) xnb_bilan_avant_coup_gm/xnb_bilan_avant_coup*100);
printf("\nPourcentage de perte materielle en bilan_avant_coup : ");
printf("%5.1f",(double) xnb_bilan_avant_coup_pm/xnb_bilan_avant_coup*100);
printf("\nPourcentage de coups neutres en bilan_avant_coup : ");
printf("%5.1f",(double) xnb_bilan_avant_coup_cn/xnb_bilan_avant_coup*100);
printf("\nPourcentage de perte matrielle en bilan : ");
printf("%5.1f",(double) xnb_bilan_pm/xnb_bilan*100);
printf("\nPourcentage de pices dfendues en bilan : ");
printf("%5.1f",(double) xnb_bilan_pd/xnb_bilan*100);



printf("\nPourcentage de prise pice dernier coup tent sur possible : ");
printf("%5.1f",(double) xprise_piece_dernier_coup_done/xprise_piece_dernier_coup_attempts_ex*100);
printf("\nPourcentage de prise pice dernier coup en extend tent sur possible : ");
printf("%5.1f",(double) xprise_piece_dernier_coup_done_ex/xprise_piece_dernier_coup_attempts_ex*100);

printf("\nNombre moyens de coups jouables : ");
printf("%5.1f",(double) xaverage_nb_coups_liste/xcompteur_nbplayed_num-1);
printf("\nPourcentage de hits exacts en hash-table : ");
printf("%5.2f",(double) xhhits/(xcompteur+1)*100);
printf("\nPourcentage de hits en hash-table : ");
printf("%5.2f",(double) xhhits2/(xcompteur+1)*100);
printf("\nPourcentage de hits en pawn-hash-table : ");
printf("%5.2f",(double) (xpawnhash_first_part_hits+xpawnhash_second_part_hits)
	   /(xpawnhash_attempts+1)*100);
printf("\nVitesse moyenne (Cps) : ");
printf("%d",xspeed_cumul/(xspeed_cumul_num+1));
printf("\nPourcentage utilisation du temps prvu : ");
printf("%5.2f",(double)xtime_consumed/(xtime_forecast+1)*100);
printf("\nPourcentage utilisation du temps prvu + extensions : ");
printf("%5.2f",(double)xtime_consumed2/(xtime_forecast+1)*100);
printf("\nProfondeur moyenne atteinte en level 1 : ");
if (xdepth_num>0) printf("%3.1f%",(double) xdepth_total/(xdepth_num+1));
printf("\nLevel moyen : ");
printf("%3.1f",(double) xaverage_level/(xaverage_level_num+1));
printf("\nNombre de coups : ");
printf("%d", xcompteur);

// Fin COLLECT_STAT
#endif
#endif


// Fermeture fichier PGN
close(xhandle);


// Fin affichage
CONSOLE_MODE;
printf("\n_END_\n"); 
END_MODE;


// Pour conserver le programme en tat actif
do
{}



while(1);

} // fin jeu



void affiche_ligne(MOVE *ligne, 
				   char move_one_has_been_played)
{
//char cc;
char code;
char k;
bool ligne_principale_complete;
bool separateur_affiche;
MOVE *mpt;


//Initialisations
mpt=ligne;
k=1;
ligne_principale_complete=false;
separateur_affiche=false;


do
{
code=MOVE_ROLE(*mpt);
if (code==LIGNE_END_HASH_TABLE)
{
	   if (!ligne_principale_complete)
	   {
		   if (separateur_affiche) printf("\b\b\b>> ");
		   else printf(">> ");

		 #if DEBUG==1 || DEBUG==2
	     xsearch_level[xlevel]->check_reset_state_values(xlevel,0);
		 #endif 
		 reconstitution_ligne_principale(ligne, move_one_has_been_played); 
		 ligne_principale_complete=true; 
		 #if DEBUG==1 || DEBUG==2
	     xsearch_level[xlevel]->check_reset_state_values(xlevel,0);
		 #endif 
		 continue; 
	   }
}
affiche_coup(*mpt);
if (END_OF_LINE(*mpt)) break; // Sortie de boucle

printf(" ");
if (M_2(k)==0) 
{ 
	printf("// "); 
	separateur_affiche=true;
}
else 
{
	separateur_affiche=false;
}
if (k>0 && M_12(k)==0) printf("\n");
k++; mpt++;
}
while (k<=xdepthmax_struct);
printf("\n");
if (xstop) getch();
} // fin affiche_ligne


#if DEBUG==1
void affichage(MOVE move, 
			   char analysis)
{
char code;
char dep, arr;
code=MOVE_ROLE(move);
dep=MOVE_DEP88(move);
arr=MOVE_ARR88(move);

if (xstop3)
{
if (MOVE_IS_FOR_PLAY(move))
{
printf("\n");
affiche(dep);
affiche(arr);
}
else
{
printf("\nPasse");
}
printf("    Level :%d - %d", xlevel, analysis);
printf("\nxcompteur : %d", xcompteur);
printf("\n");
printf(" %d\n", xstates[0].materiel);
}
}
#endif


void affiche_coup(MOVE move)
{
char code;
if (MOVE_IS_FOR_PLAY(move))
{
affiche(MOVE_DEP88(move));
affiche(MOVE_ARR88(move));
//if (MOVE_IS_PROMOTION(move) printf(":%c",MOVE_PROMOTION(move)]));
}
else
{
code=MOVE_ROLE(move);
switch((int)code)
{
case  LIGNE_NORMAL_PLAY  : // retour : doit tre transparent car prsent dans xbest
	if (MOVE_IS_PASSE(move)) // forcment cela
	{
		//printf(""); 
		printf("Null");
	}
	break;
case  LIGNE_END : 
       printf("End");
	   break;
case LIGNE_END_PASSE_PASSIF_RECUPERATION : 
	   printf("End2");
	   break;
case LIGNE_END_DRAW_50 :
	   printf("50m");
	   break;
case LIGNE_END_DRAW_REPETITION :
	   printf("Rep");
	   break;
//case LIGNE_END_DRAW_REPETITION_IN_ANALYSIS :
//	   printf("Rep");
//	   break;
case LIGNE_END_MAT :
	   printf("Mat");
	   break;
case LIGNE_END_PAT :
	   printf("Pat");
	   break;
case LIGNE_END_PASSE_ACTIF :
	   printf("PA");
	   break;
case LIGNE_END_ABSENCE_SUITE :
	   printf("AS");
	   break;
case LIGNE_END_LEVELMAX :
	   printf("LMax");
	   break;
case LIGNE_END_ASKMOVE :
	   printf("Ask");
	   break;
case LIGNE_END_HASH_TABLE :
	   printf("Hash");
	   break;
case LIGNE_END_HASH_TABLE_RECONSTITUTION :
	   printf("HEnd");
	   break;
case LIGNE_END_UPPERBOUND :
	   printf("Upperbound");
	   break;
case LIGNE_END_LOWERBOUND :
	   printf("Lowerbound");
	   break;
default : break;
}
}
}





void affiche(char pos)
{
char px, py;
px=X88(pos);
py=Y88(pos);
px+=64; // passe de 1  'A'
// xpx+='A'-1 devrait donner le mme rsultat
printf("%c%d",px,py);
} // fin affiche


/* Ancienne gestion du mode ansi
   => voir Chess82 : dernire version ayant conserv tout le code
void efface_ligne(char n)
{
char i;
for (i=1;i<=n-1;i++) printf("\r\x1B[K\x1B[A\x1B[K");
}
*/



void liste_coups_legaux(void)
{
short nbcoups;
char dep88,arr88;
char piece;
char prise_nat;
char check;
char special;
char prom;
char level;
char *board;
char num;
short idxmove; // de LENGTH_SEARCHLISTMOVES
char cc;
char color;
PIECE *numptr;
MOVE move;
MOVE *moveptr;
//bool F_legal_par_1;
//LEGALITY legal_par_2;
char phase;
long li1;

// Initialisations
level=0;
phase=PRISES;
nbcoups=0;
check=0;
board=xxboard_current_english;
xxboard_current_english_signature_blanc=0;
xxboard_current_english_signature_noir =0;



// Il faut rester dans la limite de la bibiothque d'ouverture
if (!xF_start_from_standard_position) xopeningbook_in_use=false;
if (xnbcoups>OPENING_BOOK_LENGTH+2) xopeningbook_in_use=false;
// +2 pour autoriser des petites diffrences de coups ( ex : e5-Fg5 contre e6-e5-Fe3-Fg5 )
if (xopeningbook_in_use)
{
// Initialisation board 
// xboard ne peut pas tre utilis 
// Les pices y sont en franais !!
initialize_standard_board_english(board);

// Jeu du coup
for (nbcoups=1;nbcoups<=xnbcoups;nbcoups++) 
{
// Initialisations
dep88=xpartie[nbcoups].dep88;
arr88=xpartie[nbcoups].arr88;
color=TO_COLOR(IMPAIR(nbcoups));
ASSERT (dep88+arr88!=0);

// Mise  jour signature
if (color==1) 
{ 
	xxboard_current_english_signature_blanc+=arr88*arr88-dep88*dep88;
}
else
{ 
	xxboard_current_english_signature_noir +=arr88*arr88-dep88*dep88;
}



// Test fin de partie 
if (dep88==0 || arr88==0) break;

// Suite initialisations
special=xpartie[nbcoups].special;
prom=xpartie[nbcoups].prom;

// Jeu du coup
board[arr88]=board[dep88]; // tout simplement
board[dep88]=0;

// Complment des coups spciaux
switch((int) special)
{
case 1 : 
		switch(arr88)
		{
			case 71 : board[61]= 'R';board[81]=0; break;
				break;
			case 31 : board[41]= 'R';board[11]=0; break;
				break;
			case 78 : board[68]=-'R';board[88]=0; break;
				break;
			case 38 : board[48]=-'R';board[18]=0; break;
				break;
		}
		break;
case 2 : // prise en passant
		 if (Y88(arr88)>Y88(dep88)) board[arr88-1]=0;
		 if (Y88(arr88)<Y88(dep88)) board[arr88+1]=0;
		 break;
case 3 : // promotion
		if (board[arr88]>0) board[arr88]=prom;
		else		        board[arr88]=-prom;
}

} // fin for

} // fin xnbcoups <= OPENING_BOOK_LENGTH


// Cration de la liste des coups jouables au format xx-xx
check=xsearch_level[0]->check;
for (li1=0; li1<=LENGTH_SEARCHLISTMOVES ; li1++) 
{
strcpy(xtablepgn[li1],"\0");
xtablexx[li1]=0;
}


// Nouvelle mthode avec les listes
num=(1-xwtm)<<4;
numptr=&xw[num];
while (numptr->nature==0 && num<=xw_size[xwtm]) { numptr++; num++; }
moveptr=(MOVE*)&xw_liste_coups_piece[0][num][0]-1;
idxmove=-1;
phase=AUTRES_COUPS;

do // Boucle sur la pice
{
	moveptr++;
	move=*moveptr;
	if (move==0)
	{
		if (phase==AUTRES_COUPS)
		{
			phase=PRISES;
			moveptr=(MOVE*)&xw_liste_coups2_piece[0][num][0]-1;
			continue;
		}
		else // Autre pice
		{
		   num++; 
		   numptr++;
           while (num<=xw_size[xwtm] && numptr->nature==0) { num++; numptr++; }
		   if (num>xw_size[xwtm]) break; 
		   else 
		   {
			 moveptr=(MOVE*)&xw_liste_coups_piece[0][num][0]-1;
			 phase=AUTRES_COUPS;
			 continue;
		   }
		}
	} // Fin fin de liste

	// Test de lgalit du coup
	// num=xboard[move->dep].ptr->num_piece;
	cc=xsearch_level[0]->legal(num,move,xnum_roi[xwtm],xlastmove);
	// Illgal
	if (cc!=LEGAL) continue;
 
   // Remplissage table de correspondance au format xx-xx
   idxmove++;
   //ADJUST_MOVE_NUM_PIECE(move);
   xtablexx[idxmove]=move;
   #if DEBUG==1
   if (idxmove>LENGTH_SEARCHLISTMOVES)
   {
	   log_error("\nPb C_202 : xtablexx");
   }
   #endif

   // Remplissage table de correspondance au format PGN
   // n'est utile que pour la bibliothque
   // attention la structure board
   // n'est renseigne que dans la limite de OPENING_BOOK_LENGTH 
   if (xopeningbook_in_use )
   {
   dep88=MOVE_DEP88(move);
   arr88=MOVE_ARR88(move);
   check=0;
   
   // Solutions  partir de board
   piece=abs(board[dep88]);
   prise_nat=abs(board[arr88]); // anciennement board[arr88] sans abs
   prom=french_to_english(MOVE_PROMOTION(move)); // pour tous les coups 
   special=MOVE_GET_SPECIAL(move);

   
   // Vrification cohrence board
   #if DEBUG==1
   char i;
   for (i=11;i<=88;i++)
   {
    if (Y88(i)==0) continue;
    if (Y88(i)==9) continue;
    if (french_to_english(xboard[TO64(i)].nature)!=abs(board[i]))
    {
		log_error("\nErreur C_546");
		//cc=0;cc=1/cc;
		cc=TO64(i);
    }
   } // fin for 
   #endif

   // Inscription dans xtablepgn
   pgn_translate(dep88,arr88,
				 prom,
				 prise_nat,
				 special,
				 piece,
	                   xtablepgn[idxmove],
				 board);

   } // fin xopeningbook
} while (1); // fin do 2 bouclage sur la pice 

} // fin liste_coups_legaux


#if USE_BOOK_TRANSPOSITIONS==0
char search_bibliotheque(void)
{
// Lister les parties au format PGN afin de comparer
bool Fcomment;
bool Fstat;
bool Fnew_game;
bool Fmatch;
char a;
short nbcoups;
char i;
char cc;
char string[10];
char *ptr;
long compteur;
char matches;
char selection_list[OPENING_BOOK_SELECTION_SIZE][8];
long weights[OPENING_BOOK_SELECTION_SIZE];
char choice;
long random_number, sum_weights, total_partiel;
short stat;
bool Fstat_was_given;
short maxstat, indice_max;
char prev_a;

// Initialisations
prev_a=-1; a=-1;
total_partiel=0;
sum_weights=0;
compteur=0;
matches=0;
for (i=0;i<=OPENING_BOOK_SELECTION_SIZE-1;i++)
{ strcpy(selection_list[i],"\0"); weights[i]=0; }
// Important : poids = 0 par dfaut 
ptr=xbibliotheque-1;
Fcomment=false;
Fstat_was_given=false;

// Boucle de lecture
while (++compteur<=xtaille_bibliotheque)
{
ptr++;
// Ignorer '\r'
if (*ptr=='\r') continue;
// Ignore le caractre @ ( ligne  viter )
// ( La prise en compte de caractre interdit que le coup
//   xnbcoups+1 soit reconnu => la ligne ne peut plus tre 
//   joue par l'ordinateur )
if (*ptr=='@' && nbcoups<xnbcoups+1) continue;
// Stocker le caractre prcdent aprs filtrage des '\r'
prev_a=a; a=*ptr;
// Ignorer deux espaces ou \n conscutifs
if ( (a==' ' || a=='\n') ) { if ( (prev_a==' ' || prev_a=='\n') ) continue; }
// Gestion des commentaires de dbut de partie
// Remarque : signalent le dbut d'une nouvelle partie
if (a=='[') { Fcomment=true; continue; }
if (Fcomment && a!=']') continue;
if (Fcomment && a==']') 
{ 
Fcomment=false; 
// Dbut nouvelle partie
for (i=0; i<=OPENING_BOOK_LENGTH; i++) 
		strcpy(xbook[i],"\0");
Fmatch=true;
nbcoups=1;
Fstat=false;
Fnew_game=true;
Fstat_was_given=false;
continue;
}
// Si l'ouverture en cours ne matche pas, continuer
if (!Fmatch) continue;
// Gestion des poids
if (a=='(') { Fstat=true; continue; }
if (a==')') { Fstat=false; Fstat_was_given=true; continue; }
if (Fstat) continue;
// Si le nombre de coup de l'ouverture excde
// le nombre de coup actuellement jou + 1
// rechercher la suite suivante
if (nbcoups>xnbcoups+1) continue;
// nbcoups peut atteindre OPENING_BOOK_LENGTH mais pas plus
// sinon on continue  lire
if (nbcoups>OPENING_BOOK_LENGTH) continue;
if (a==' ' || a=='\n') 
{
 if (!Fstat_was_given && !Fnew_game && nbcoups<=OPENING_BOOK_LENGTH) 
 {
 // Comparaison jusqu' xnbcoups
 if (nbcoups<=xnbcoups && nbcoups<=OPENING_BOOK_LENGTH)
 {

 strcpy(string,xpartie[nbcoups].pgn);
  

 // xbook = bibliothque au format PGN
 // xpartie_pgn = partie au format PGN
 // pb : la correspondance n'est pas si vidente
 // xbook peut atteindre OPENING_BOOK_LENGTH mais c'est tout
 if (pgn_compare(xbook[nbcoups],string)) Fmatch=false; 
 } // fin (nbcoups<=xnbcoups && nbcoups<=OPENING_BOOK_LENGTH)
 // Aller jusqu'a xnbcoups+1
 // La comparaison a t faite de 1  xnbcoups
 if (nbcoups==xnbcoups+1 && Fmatch) 
 { 
   Fmatch=false; // il n'est plus utile de comparer au dela de xnbcoups+1
   cc=0;
   // Le coup contient-il le caractre @ ( A evier )
   for (i=0;i<=PGN_MOVE_LENGTH;i++)
   { if (xbook[nbcoups][i]=='@') 
		{cc=1; break;} 
   }
   // Le coup a-t-il dja t enregistr ?
   for (i=0;i<=matches-1;i++)
   {
   if (pgn_compare(selection_list[i],xbook[nbcoups])) { cc=1; break; }
   }
   // Stockage du coup slectionn
   if (cc==0)
   {
   // Incrmentation de matches 
   matches++;
   strncpy(selection_list[matches-1],xbook[nbcoups],PGN_MOVE_LENGTH);
   selection_list[matches-1][PGN_MOVE_LENGTH]='\0';
   // Dtermination du poids
   // Poids par dfaut
   stat=xbook_default_stat; // par dfaut
   // rem : on vient de lire ' '
   if (xuse_book_stats)
   {
   // Si la stat existe, elle se situe de ptr+1  ptr+4
   if (ptr+4<=xbibliotheque+xtaille_bibliotheque-1 )
   {
	if (*(ptr+1)=='(' && *(ptr+4)==')')
		{
		string[0]=*(ptr+2);
		string[1]=*(ptr+3);
		string[2]='\0';
		stat=atoi(string);
		}
   }
   } // fin if xuse_book_stats

   weights[matches-1]=stat;
   // Si pas de randomisation des ouvertures, sortir sur la premire correspondance
   if (xchoose_first_opening) break;
   // Sortir si dja 20 choix
   if (matches>=OPENING_BOOK_SELECTION_SIZE) break;
   } // fin if coup  enregistrer
 } // fin match  xnbcoups+1
 if (!Fstat_was_given)  nbcoups++;
 } // fin if (!Fnew_game && nbcoups <= OPENING_BOOK_LENGTH) 
 // L'espace qui vient de suivre une stat est consomm
 // Le prochain caractre de sparation indique un coup
 Fstat_was_given=false;
 continue;
} // fin a==' ' || a=='\n'
if (a=='x') continue;
if (a=='+') continue;
if (a!=' ' && a!='\n') Fnew_game=false;

// Copier le caractre lu
#if DEBUG==1
if (nbcoups>LENGTH_SEARCHLISTMOVES)
{
log_error("\nPb C_194 : xbook\n");
}
#endif
strncat(xbook[nbcoups],&a,1);
} // fin while read bibiothque

// FIN
// Si correspondance trouve
if (matches>0) 
{
// Choix ventuel de la meilleure ouverture
if (xchoose_best_opening)
{
maxstat=0;
for (i=0;i<=matches-1;i++)
{ 
  if (weights[i]>maxstat) { maxstat=weights[i]; indice_max=i; }
} // fin for
matches=1;
weights[0]=maxstat; strcpy(selection_list[0],selection_list[indice_max]); 
} // fin if xchoose_best_opening
// Calculer la moyenne des statistiques pour normaliser
sum_weights=0;
for (i=0;i<=matches-1;i++) sum_weights+=weights[i];
// Normaliser les statistiques
for (i=0;i<=matches-1;i++) 
{ 
	// Prcaution contre division par zro lis au poids nuls
	if (weights[i]==0) { weights[i]=1; sum_weights+=1; }
}
for (i=0;i<=matches-1;i++) { weights[i]*=50; weights[i]=weights[i]*sum_weights/matches; }
// Calculer les pondrations  partir des statistiques
for (i=0;i<=matches-1;i++) 
{
stat=weights[i];
if ( stat<20 ) weights[i]=1;
else {
if ( stat<30 ) weights[i]=20+(stat-20)*3;
else {
if ( stat<40 ) weights[i]=50+(stat-30)*1.5;
else {
if ( stat<50 ) weights[i]=200+(stat-40)*80;
else {
if ( stat<60 ) weights[i]=1500+(stat-50)*50;
else {
	     	   weights[i]=2000+(stat-50)*50;
}}}}} // else
} // fin for
// Calculer la somme des pondrations
sum_weights=0;
for (i=0;i<=matches-1;i++) sum_weights+=weights[i];
// Choix d'un coup dans la liste de slection
// en fonction de la pondration des coups
if (xchoose_random_opening) 
{
random_number=inf(sum_weights,(rand()*sum_weights)/RAND_MAX);
// Par scurit
if ( random_number>sum_weights ) random_number=sum_weights;
for (choice=0;choice<=matches-1;choice++)
{
total_partiel+=weights[choice];
if (random_number<=total_partiel) break;
} // fin for
} // fin if random opening
else choice=0;

				
// Recherche dans xtablexx du coup slectionn
cc=0;
for (xu=0; xu<=LENGTH_SEARCHLISTMOVES; xu++)
{
if (xtablexx[xu]==0) break;
strcpy(string,xtablepgn[xu]);
if (pgn_compare(selection_list[choice],string)) {cc=1; break;}
} // fin for

// Succs
if (cc==1 && xtablexx[xu]!=0)
{
xopeningbook_has_been_used=true;
xopeningbook_has_been_updated=false;
xlast_opening_move_used=xnbcoups+1; // le coup n'a pas encore t jou
xkeep_game=0;
xkeep[1]=xtablexx[xu];
//ADJUST_MOVE_NUM_PIECE(xkeep[1]); xtablexx est  jour !
SET_MOVE_CAPTURE(xkeep[1], xboard[MOVE_ARR64(xtablexx[xu])].nature);
xkeep[2]=LigneEnd;
xlastvalue1=0;
xlastvaluemat1=0;
return 1;
} // fin succs
#if DEBUG==1
else
{
// Cette situation ne devrait pas arriver
log_error("\nErreur C_100");
}
#endif

} // fin if matches>0


// Echec 
xopeningbook_in_use=false;
// Librer la mmoire de la bibiothque
// free(xbibliotheque); // Non : garder la bibliothque pour les take_back
display_info("\nSortie de la bibliotheque d'ouverture"); 
return 0;
} // fin search_bibliotheque
#else // USE_BOOK_TRANSPOSITIONS==1
char search_bibliotheque(void)
{
unsigned long game_number;
short nbcoups;
char board[SIZE_OF_BOARD_88];
ENTREE_BIBLIOTHEQUE_88 *entree;
ENTREE_BIBLIOTHEQUE_88 selection_list[OPENING_BOOK_SELECTION_SIZE];
char matches;
short weights[OPENING_BOOK_SELECTION_SIZE];
char choice;
long random_number, sum_weights, total_partiel;
char cc;
char i;
short maxstat, indice_max;
short stat;
long int li1;

// Initialisations
matches=0;

// Recherche
for ( game_number=1; game_number<=xbibliotheque_nb_games; game_number++ )
{
// La correspondance peut tre obtenue avec 2 coups en plus ou en moins
for ( nbcoups=sup(xnbcoups-2,1); nbcoups<=xnbcoups+2 && nbcoups<=OPENING_BOOK_LENGTH-1; nbcoups++)
{
entree=&xbibliotheque_88[game_number-1][nbcoups-1];
if ( entree->signature_blanc!=xxboard_current_english_signature_blanc ) continue;
if ( entree->signature_noir !=xxboard_current_english_signature_noir ) continue;
// Les positions ont la mme signature
play_88_game_from_bibliotheque(board, game_number, nbcoups);
// Comparer les deux board
if ( memcmp( xxboard_current_english, board, SIZE_OF_BOARD_88 )==0 )
{
if ( (entree+1)->dep88!=0 )
{
cc=0;
for (i=0;i<=matches-1;i++)
{
  if (memcmp(entree+1,&selection_list[i],sizeof(entree))==0) { cc=1; break; }
}
if (cc==0) // Coup  enregistrer
{
   // Incrmentation de matches ( aprs son utilisation )
   matches++;
   selection_list[matches-1]=*(entree+1);   
   weights[matches-1]=(entree+1)->stat;
   // Si pas de randomisation des ouvertures, sortir sur la premire correspondance
   if (xchoose_first_opening) goto END_SEARCH_BIBLIOTHEQUE;
   // Sortir si dja 20 choix
   if (matches>=OPENING_BOOK_SELECTION_SIZE) goto END_SEARCH_BIBLIOTHEQUE;
} // fin if coup  enregistrer


} // fin condition
} // fin comparaison
} // fin for
} // fin for

END_SEARCH_BIBLIOTHEQUE:

// Si correspondance trouve
if (matches>0) 
{
// Choix ventuel de la meilleure ouverture
if (xchoose_best_opening)
{
maxstat=0;
for (i=0;i<=matches-1;i++)
{ 
  if (weights[i]>maxstat) { maxstat=weights[i]; indice_max=i; }
} // fin for
matches=1;
weights[0]=maxstat; selection_list[0]=selection_list[indice_max]; 
} // fin if xchoose_best_opening
// Calculer la moyenne des statistiques pour normaliser
sum_weights=0;
for (i=0;i<=matches-1;i++) sum_weights+=weights[i];
// Normaliser les statistiques
for (i=0;i<=matches-1;i++) 
{ 
	// Prcaution contre division par zro lis au poids nuls
	if (weights[i]==0) { weights[i]=1; sum_weights+=1; }
}
for (i=0;i<=matches-1;i++) { weights[i]*=50; weights[i]/=(short) (sum_weights/matches); }
// Calculer les pondrations  partir des statistiques
for (i=0;i<=matches-1;i++) 
{
stat=weights[i];
if ( stat<20 ) weights[i]=1;
else {
if ( stat<30 ) weights[i]=(short) (20+(stat-20)*3);
else {
if ( stat<40 ) weights[i]=(short) (50+(stat-30)*1.5);
else {
if ( stat<50 ) weights[i]=(short) (200+(stat-40)*80);
else {
if ( stat<60 ) weights[i]=(short)(1500+(stat-50)*50);
else {
	     	   weights[i]=(short) (2000+(stat-50)*50);
}}}}} // else
} // fin for
// Calculer la somme des pondrations
sum_weights=0;
for (i=0;i<=matches-1;i++) sum_weights+=weights[i];
// Choix d'un coup dans la liste de slection
// en fonction de la pondration des coups
if (xchoose_random_opening) 
{
// En deux instructions  cause du rand()
// ( sin on fait directement le inf, cela gnre deux rand )
random_number=(rand()*sum_weights)/RAND_MAX;
random_number=inf(sum_weights, random_number);
total_partiel=0;
for (choice=0;choice<=matches-1;choice++)
{
total_partiel+=weights[choice];
if (random_number<=total_partiel) break;
} // fin for
} // fin if random opening
else choice=0;

// Recherche dans xtablexx du coup slectionn
cc=0;
for (li1=0; li1<=LENGTH_SEARCHLISTMOVES; li1++)
{
if (xtablexx[li1]==0) break;
if (selection_list[choice].dep88==MOVE_DEP88(xtablexx[li1]) && 
    selection_list[choice].arr88==MOVE_ARR88(xtablexx[li1])) {cc=1; break;}
} // fin for

// Succs
if (cc==1 && xtablexx[li1]!=0)
{
xopeningbook_has_been_used=true;
if (xconsole_mode)
{ xlast_opening_move_used=xnbcoups+1; } // le coup n'a pas encore t jou
else // uci_mode
{ xlast_opening_move_used=xnbcoups; } 
xkeep_game=0;

xkeep[1]=xtablexx[li1];
// SET_MOVE_NUM_PIECE(xkeep[1],xboard[MOVE_DEP88(xkeep[1])].num_piece);
xkeep[2]=LigneEnd;
xlastvalue1=0;
//xlastvaluemat1=0;
return 1;
} // fin succs
#if DEBUG==1
else
{
// Cette situation ne devrait pas arriver
log_error("\nErreur C_100");
}
#endif

} // fin if matches>0


// Echec 
xopeningbook_in_use=false;
// Librer la mmoire de la bibiothque
// free(xbibliotheque); // Garder la bibliotheque pour les take_back
display_info("\nSortie de la bibliotheque d'ouverture\n\n"); 
return 0;

} // fin search_bibliotheque



void play_88_game_from_bibliotheque(char *board, long game_number, short nbcoups_a_atteindre)
{
short nbcoups;
ENTREE_BIBLIOTHEQUE_88 * entree;
char dep88, arr88;
char special, prom;

entree=&xbibliotheque_88[game_number-1][0];
initialize_standard_board_english(board);
for (nbcoups=1; 
	 nbcoups<=OPENING_BOOK_LENGTH 
		&& nbcoups<=nbcoups_a_atteindre;
	 nbcoups++, entree++)
{
// Initialisations
dep88=entree->dep88;
arr88=entree->arr88;

// Test fin de partie 
if (dep88==0 && arr88==0) break; 

// Suite initialisations
special=entree->special;
prom=entree->prom;

// Jeu du coup
board[arr88]=board[dep88]; // tout simplement
board[dep88]=0;

// Complment des coups spciaux
switch((int) special)
{
case 1 : 
		switch(arr88)
		{
			case 71 : board[61]= 'R';board[81]=0; break;
				break;
			case 31 : board[41]= 'R';board[11]=0; break;
				break;
			case 78 : board[68]=-'R';board[88]=0; break;
				break;
			case 38 : board[48]=-'R';board[18]=0; break;
				break;
		}
		break;
case 2 : // prise en passant
		 if (Y88(arr88)>Y88(dep88)) board[arr88-1]=0;
		 if (Y88(arr88)<Y88(dep88)) board[arr88+1]=0;
		 break;
case 3 : // promotion
		if (board[arr88]>0) board[arr88]=prom;
		else		        board[arr88]=-prom;
}

} // fin for nbcoups

} // fin play_88_game_from_bibliotheque(board)
#endif



char searchstart1()
{
#if DEBUG==1
	STATEVALUES states_mem;
#endif
char game;

//char cc; STOP;
// Fixation xbornetemps
fixe_bornetemps();


//sprintf(xbuffer,"\nxbornetemps : %d",xbornetemps);
//display_info(xbuffer);
//sprintf(xbuffer,"\nxavailable_time[1] : %d", (long) xavailable_time[1]);
//display_info(xbuffer);
//sprintf(xbuffer,"\nxtempsprevu[1] : %d", (long) xtempsprevu[1]);
//display_info(xbuffer);
//sprintf(xbuffer,"\nxcps : %d", (long) xcps);
//display_info(xbuffer);
//sprintf(xbuffer,"\nxzz64 : %d", (long) xzz64);
//display_info(xbuffer);


// Lancement de search
// Calcul du temps en 
// secondes et centimes de secondes
xtdebut_original=get_time_in_seconds();
// xtdebut est rinitialis si le coup adverse est devin 
// xtdebut_original n'est pas rinitialis
// ceci n'arrive en fait qu'avec searchstart2() qui lance le pondering
// xtdebut_search correspond au temps juste avant l'entre en search
xtdebut=xtdebut_original;
//xusable_time_max=xtdebut_original+xtempsprevu[xwtm]-xconsole_tempsmanip1-xconsole_tempsmanip2;

#if DEBUG==1 
states_mem=xstates[0];
#endif

// Searchstart normal
xpb_explo=false;
game=searchstart();

// Contrle
#if DEBUG==1 
if (
xstates[0].materiel!=states_mem.materiel ||
xstates[0].mobility!=states_mem.mobility ||
#if SUIVI_PRISES==1
xstates[0].force[0]!=states_mem.force[0] ||
xstates[0].force[1]!=states_mem.force[1] ||
xstates[0].prises[0]!=states_mem.prises[0] ||
xstates[0].prises[1]!=states_mem.prises[1] ||
xstates[0].prises_pion[0]!=states_mem.prises_pion[0] ||
xstates[0].prises_pion[1]!=states_mem.prises_pion[1] ||
#endif
xstates[0].developpement[0]!=states_mem.developpement[0] ||
xstates[0].developpement[1]!=states_mem.developpement[1] ||
xstates[0].tower!=states_mem.tower ||
xstates[0].position!=states_mem.position ||
//xstates[0].ligne_nb_checks[0]!=states_mem.ligne_nb_checks[0] ||
//xstates[0].ligne_nb_checks[1]!=states_mem.ligne_nb_checks[1] ||
//xstates[0].ligne_nb_prises!=states_mem.ligne_nb_prises ||
xstates[0].lastprise2!=states_mem.lastprise2 ||
xstates[0].passed[0]!=states_mem.passed[0] ||
xstates[0].passed[1]!=states_mem.passed[1] ||
xstates[0].pawnstruct!=states_mem.pawnstruct ||
xstates[0].materiel_pieces[0]!=states_mem.materiel_pieces[0] ||
xstates[0].materiel_pieces[1]!=states_mem.materiel_pieces[1] ||
//xstates[0].o_o[0]!=states_mem.o_o[0] ||
//xstates[0].o_o[1]!=states_mem.o_o[1] ||
//xstates[0].o_o_o[0]!=states_mem.o_o_o[0] ||
//xstates[0].o_o_o[1]!=states_mem.o_o_o[1] ||
xstates[0].droit_roque[0]!=states_mem.droit_roque[0] ||
xstates[0].droit_roque[1]!=states_mem.droit_roque[1] )
{
log_error("\nErreur C_811");
}
#endif


// Actualisation chronomtre
xtime=get_time_in_seconds();

xtempscoup=(long) (xtime-xtdebut);
xtempscoup+=(xconsole_tempsmanip1+xconsole_tempsmanip2);
// Statistique de pourcentage de consommation du temps prvu
// N'est pas calcul ( et ce n'est pas utile si coup en permanent brain )
if ( !xopeningbook_in_use )
{
if (xmode=='A' || (xmode=='B' && xwtm==1) || (xmode=='N' && xwtm==0) )
{
// Temps utilis moins temps rallous pour extensions et restarts
xtime_consumed+= (long) (xcompteur-xcompteur_depart
						 -(xbornetemps - xbornetemps_depart));	  
// Temps total utilis dont extensions et restarts
xtime_consumed2+=(xcompteur-xcompteur_depart);
#if COLLECT_STATS==1
xnum_time_consumed++;
#endif

// Temps prvu cumul
xtime_forecast+= (long) (xbornetemps_depart-xcompteur_depart+1)/xpourcentage_temps_de_base*100;

// Modification de xpourcentage_temps_de_base
// Idalement, la consommation effective de temps
// doit tre gale  l'allocation initiale divise par le pourcentage du temps de base
// Le ratio xtime_forcecast/xpourcentage temps de base est stable
// Mais xtime_consumed augmente avec l'augmentation de xtime_forcast
/*
sprintf(xbuffer,"xpourcentage_temps_de_base %d", xpourcentage_temps_de_base);
display_info(xbuffer);
sprintf(xbuffer,"xbornetemps %d", xbornetemps);
display_info(xbuffer);
sprintf(xbuffer,"xbornetemps_depart %d", xbornetemps_depart);
display_info(xbuffer);
sprintf(xbuffer,"xcompteur %d", xcompteur);
display_info(xbuffer);
sprintf(xbuffer,"xcompteur_depart %d", xcompteur_depart);
display_info(xbuffer);
*/

// On compare  l'allocation de temps initiale
// sans tenir compte des extensions
if (xcompteur-xcompteur_depart<=(xbornetemps_depart-xcompteur_depart)*100/xpourcentage_temps_de_base)
	 xpourcentage_temps_de_base=inf(20000, xpourcentage_temps_de_base+10); // prcaution ventuelle
else  xpourcentage_temps_de_base=sup(50,xpourcentage_temps_de_base-10);
}
}
if (xtempscoup==0) xtempscoup=1; // Precaution
if ( xF_timer_on )
{
	if ( xTIMER_ON_MODE==1 )
	{
	xtimecumul[xwtm]+=xtempscoup;
	xavailable_time[xwtm]+=xfischer_add[xwtm];
	}
	else
	{
	xtimecumul[xwtm]=0;
	xavailable_time[xwtm]=0;
	}
}
else // !timer_on
{
	xtimecumul[xwtm]=0;
	xavailable_time[xwtm]=0;
}


// Calcul du nombre de coups par millime de seconde
if (!xopeningbook_in_use)
{
if (xmode=='A' || (xmode=='B' && xwtm==1) || (xmode=='N' && xwtm==0))
{
if (xtempscoup-xconsole_tempsmanip1-xconsole_tempsmanip2!=0)
// Si mat, pas de coup jou
{
// Calcul xcps
// Note : si le dernier coup a t jou instantanment (only move)
// ne pas recalculer xcps
if (!F_lastmove_was_onlymove)
{
xcps=(long) (((double)(xcompteur-xcompteur_depart+385))/(xtime-xtdebut_original));
xFcalcul_first_xcps=true;
}
#if COLLECT_STATS==1
xspeed_cumul+=xcps;
xspeed_cumul_num++;
#endif
}
}
//}
}

// Attention : il faut corriger le calcul
// car les choses ne sont pas linaires...
// A titre indicatif, le programme, sur PII-300 Mhz
// joue 53 coups en 5 centimes de secondes
// soit une vitesse apparente de 10 cpcts
// soit 1000 coups par seconde
// Ceci reprsente une perte de 7000 coups
// Conclusion : le programme a pass 7000/8000=90%
// de son temps  ne pas calculer de coups
// Soit 5 centimes de secondes.
// Ceci reprsente un quivalent coups de 
// 8000*0.045=360 coups
// Il faut donc ajouter 360 coups au nombre de coups jous
// Ceci peut tre test en faisant varier le nombre de coups
// ajouts. Le temps doit rester stable en blitz 5 minutes.


return game;
}


void fixe_bornetemps(void)
{
__int64 int64;
char time_divide;
char time_reserve;
short valpos;
char player;

// Rem : xtempsprevu est une enveloppe qui inclue le temps de manipulation
// On dduit ensuite xconsole_tempsmanip
// pour obtenir xbornetemps
// xtempscoup inclut le temps de manipulation
// En revanche, la borne de temps exprime en coups 
// exclut les temps de manipulation
// xtime_max en revanche est ampute du temps de manipulation

// Lancement du chronomtre
// Ide : 40 coups ... jouer sur le temps restant

// Calcul du temps prvu
//xpourcentage_temps_de_base=POURCENTAGE_TEMPS_DE_BASE;
//if (xpermanentbrain) xpourcentage_temps_de_base+=20;

if ( xTIMER_ON_MODE==1 )
{
// Temps avec dcompte
// Partie au KO ( division du temps par 40 )
if (xfischer_add[xwtm]==0)
{
	time_divide=40;
	time_reserve=KO_TIME_RESERVE_SECONDS;
}
else // Mode Fischer
{
	time_divide=inf(40,80-(xnbcoups/2));
	if (time_divide<1) time_divide=1;
	time_reserve=FISCHER_TIME_RESERVE_SECONDES; // juste pour viter tout risque de tomber
}
if (!xuci_mode)
{
// En mode console le temps Fischer est ajout  xavailable_time aprs le jeu du coup
// et xavailable_time n'est pas rinitialis
if ( xmovestogo==0 ) 
{
	xtempsprevu[xwtm]=(xavailable_time[xwtm]-xtimecumul[xwtm]-time_reserve)/time_divide;
	xusable_time_max=
				sup(0,
				(
				(xavailable_time[xwtm]-xtimecumul[xwtm])
				// Conserver 10 secondes incompressibles
				// sauf en mode xmovestogo=1 et F_movetime=1
				/ time_divide
				*(time_divide>3?3:1)
				)
				-FINAL_TIME_RESERVE
				-CONSOLE_TEMPS_MANIPULATION_1 // temps en secondes de jeu du coup
				-CONSOLE_TEMPS_MANIPULATION_2 // temps en secondes de saisie coup adverse
				);
				
}
else
{
	xtempsprevu[xwtm]=(xavailable_time[xwtm]-xtimecumul[xwtm]-time_reserve)/xmovestogo;
	xusable_time_max=
				sup(0,
				(
				(xavailable_time[xwtm]-xtimecumul[xwtm])
				// Conserver 10 secondes incompressibles
				// sauf en mode xmovestogo=1 et F_movetime=1
				/xmovestogo
				*(xmovestogo>3?3:1)
				)
				// Note le (1-xFmovetime n'a pas lieu d'tre ici)
				// en mode console, on choisit un temps fixe 
				// par coup et on met 0 en temps de manipulation
				-FINAL_TIME_RESERVE
				-CONSOLE_TEMPS_MANIPULATION_1 // temps en secondes de jeu du coup
				-CONSOLE_TEMPS_MANIPULATION_2 // temps en secondes de saisie coup adverse
				);
}
} 
else // xmode==UCI
{
// dans le mode UCI, le temps disponible est rinitialis  chaque coup
// par l'interface UCI
// Il ne faut pas retrancher le cumul de temps
//char cc; STOP;
if ( xmovestogo==0 ) // KO
{
	xtempsprevu[xwtm]=
		        (
				(xavailable_time[xwtm]
					//-xnbcoups/2*5*xF_uci_temps_manipulation ??????
					-time_reserve // Conserver temps incompressibles
					// Ces secondes permettent de gagner au temps
				)/time_divide
				)
				-UCI_TEMPS_MANIPULATION*xF_uci_temps_manipulation
				;
	xusable_time_max=
				sup(0,
				(
					xavailable_time[xwtm]
					/time_divide
					*(time_divide>3?3:1)
				)
				-UCI_TEMPS_MANIPULATION*xF_uci_temps_manipulation
			    -FINAL_TIME_RESERVE // 2 secondes mininum
				);
				
	// Ajouter le temps Fischer, tant qu'il reste du temps
	// On ne peut pas ajouter simplement le temps Fischer car il n'est acquis
	// qu'aprs le jeu du coup
	if (xavailable_time[xwtm]>(xtempsprevu[xwtm]+xfischer_add[xwtm])*3) xtempsprevu[xwtm]+=xfischer_add[xwtm];
	xtempsprevu[xwtm]*=xpourcentage_temps_de_base;
	xtempsprevu[xwtm]/=100;
	sprintf(xbuffer,"xtemprevu : %d", xtempsprevu[xwtm]);
	display_info(xbuffer);
}				
else // xmovestogo=x, UCI
	// Attention : il ne faut pas dpasser le contrle de temps
	// du 40ime coup => garder 10 secondes incompressibles
	// xF_movetime quand le temps est donn par coup
{
	xtempsprevu[xwtm]=
		    (
			(xavailable_time[xwtm]
			-time_reserve*(1-xF_movetime)
			// Conserver 10 secondes incompressibles
			// sauf en mode xmovestogo=1 et F_movetime=1
			)/xmovestogo
			)
			-UCI_TEMPS_MANIPULATION*xF_uci_temps_manipulation
			 *(1-xF_movetime)
			;			
	xusable_time_max=
				sup(0,
				(
				xavailable_time[xwtm]
				/xmovestogo
				*(xmovestogo>1?3:1)
				)
				-UCI_TEMPS_MANIPULATION*xF_uci_temps_manipulation
				 *(1-xF_movetime)
				-FINAL_TIME_RESERVE*(1-xF_movetime)
				// Conserver 10 secondes incompressibles
				// sauf en mode xmovestogo=1 et xF_movetime=1
				);

	// Ajouter le temps Fischer, tant qu'il reste du temps
	// On ne peut pas ajouter simplement le temps Fischer car il n'est acquis
	// qu'aprs le jeu du coup
	if (xavailable_time[xwtm]>(xtempsprevu[xwtm]+xfischer_add[xwtm])*3) xtempsprevu[xwtm]+=xfischer_add[xwtm];
	xtempsprevu[xwtm]*=xpourcentage_temps_de_base;
	xtempsprevu[xwtm]/=100;
}
} // fin mode UCI
} // fin timer
else
{
	// Temps fixe en secondes
	// (temps exprim en centimes de seconde )
	xtempsprevu[xwtm]=xtimer_fixed_time_per_move;
	xusable_time_max=xtimer_fixed_time_per_move*2;
	xtempsprevu[xwtm]*=xpourcentage_temps_de_base;
	xtempsprevu[xwtm]/=100;
}

// Temps de rflexion minimum
if (xtempsprevu[xwtm]<xconsole_tempsmanip1+xconsole_tempsmanip2) 
{xtempsprevu[xwtm]=xconsole_tempsmanip1+xconsole_tempsmanip2;}
// Rem : xtempsprevu est une enveloppe qui inclue le temps de manipulation
// On dduit ensuite xconsole_tempsmanip
// pour obtenir xbornetemps
// xtempscoup inclut le temps de manipulation
// En revanche, la borne de temps exprime en coups 
// exclut les temps de manipulation

// Contrle positivit (scurit)
xtempsprevu[xwtm]=sup(0,xtempsprevu[xwtm]);

if ( xF_timer_on )
{
// Calcul des bornes de temps en nombres de coups
// (fonction du temps, mais exprim en nombre de coups)
int64=(__int64) (xtempsprevu[xwtm]-xconsole_tempsmanip1-xconsole_tempsmanip2)*xcps;
// 20000 coups minimum
int64=sup(20000,int64);
// Temps avec dcompte
xbornetemps=xcompteur+int64;

// Borne maximale destin  viter de tomber
// XCOMPTEUR_SECURITY_SECONDES secondes de scurit
//char cc; if (xpb_explo)  STOP;
int64=(__int64) ((__int64)(xavailable_time[xwtm]
				 // Temps enveloppe globale
				 -XCOMPTEUR_SECURITY_SECONDES*(1-xF_movetime) 
			 	 -(xconsole_tempsmanip1-xconsole_tempsmanip2)*(1-xF_movetime)
				 // Si le temps est donn par coup 
				 // prvoir une seconde de marge pour le coup
				 -1*xF_movetime  
				 ))*(__int64) xcps
				 // Ne tient pas compte du temps Fischer acquis aprs jeu du coup
				 ; // sans xpourcentage_temps_de_base
//sprintf(xbuffer,"\nxzz64 : %d", (__int64) xzz64);
//display_info(xbuffer);
int64=sup(20000,int64);
xbornetemps_max=xcompteur+int64;

// Ajout de temps si dernier coup = seul coup sous chec
// et donc jou instantanment (+50%)
// Pour mmoire le nombre de coup contient xcompteur qui ne cesse de s'incrmenter
if (F_lastmove_was_onlymove) xbornetemps+=(xbornetemps-xcompteur)/2;


// Rduction de temps si reprise immdiate
// Pour mmoire le nombre de coup contient xcompteur qui ne cesse de s'incrmenter
xlv1_reprise_immediate=false;
//if (xwtm==xlastvalue1_wtm_pour_reprise_immediate)
{
	if (MOVE_IS_CAPTURE(xlastmove))
	{
		player=TO_PLAYER(xwtm);
		valpos=PLAYER(player,xsearch_level[0]->fctn_eval());
		// Est-on en attente d'une reprise ?
		// Si oui, ne consacrer que 25% du temps prvu
		if (player*xlastvalue1_mem_pour_reprise_immediate-valpos>2*VALEUR_PION)
		{
			xbornetemps=xcompteur+((xbornetemps-xcompteur)/4);
			xlv1_reprise_immediate=true;
		}
	}
}




// Attention : xbornetemps part de xtempsprevu
// alors que xbornetemps_max part de xavailable_time
// Les 2 intgrent 10 secondes de scurit
// Mais surtout, xbornetemps_max n'intgre pas xpourcentage_temps_de_base
if (xbornetemps>xbornetemps_max) xbornetemps=xbornetemps_max;
#if _DEBUG
player=TO_PLAYER(xwtm);
valpos=PLAYER(player,xsearch_level[0]->fctn_eval());
log_info("xcompteur : ", xcompteur);
log_info("xbornetemps_max : ", xbornetemps_max);
log_info("xbornetemps : ", xbornetemps);
if (xlv1_reprise_immediate) log_info("recapture");
log_info("\nxlastvalue1 : ", xlastvalue1_mem_pour_reprise_immediate);
log_info("\nvalpos: ", valpos);
#endif




// Mmorisation xbornetemps_depart
// xbornetemps_depart=xbornetemps;

// Par ailleurs, pour xmovestogo==1
// on fera des appels  time pour ne pas excder 
// la limite relle de temps
// mme en cas de ralentissement de l'ordinateur

/*
cout << "\n" << xcps <<"\n";
cout << "\n" << xtempsprevu[xwtm] <<"\n";
cout << "\n" << xzz64 <<"\n";
cout << "\n" << xzz64 <<"\n";
cout << "\n" << xbornetemps <<"\n";
cout << "\n300000"; cout.flush();
*/

// 80% du temps de base seulement car 
// du fait des extensions et restarts, on dpasse souvent 100%
}
else // Temps fixe par coup
{
xbornetemps
	= xcompteur
	+ (int) (xtimer_off_number_of_nodes);
xbornetemps_max
	= xcompteur
	+ 4 * (int) (xtimer_off_number_of_nodes);
}
} // fin fix_bornetemps



char searchstart()
{
char cc;
short sum_weights;
char dep, arr;
long li1, li2, li3, li4;
PIECE *wptr;

//KILLERMOVE (*tab_killermoves)[NOMBRE_KILLERMOVES];
//KILLERMOVE *killermove;
char i,j;

// Commentaire sur le rle des diffrentes variables
// xcompteur_start : xcompteur de dpart
// xcompteur_depart : xcompteur de dpart
// xtempstotal : crdit de temps initial
// xtimecumul  : temps utilis
// xbornetemps_depart : mmorise la valeur initiale de
//                    xbornetemps
// xtdebut_original : temps de dbut correspondant
//					   l'entre du coup, ventuellement
//                    en permanent_brain
//					  => utils pour calculer la vitesse
// xtdebut : temps de dbut dcompt
//                    permet de calculer le temps 
//					  utilis par un joueur
// xtdebut_search : temps d'entre en search
//                  pour l'affichage de nps

// Rinitialisation diverses
UCI_MODE;
// un coup va tre retourn et la position 
//  mettre en place ne viendra pas directement de UCI
// Ex : 
// - readyok
// - position startpos moves d2d4 d7d5
//   qui part immdiatement en premanent brain
//   ( en pratique, dans la bibliothque d'ouverture
//     le programme ne propose pas le pondering
uci_interface::F_position_set_from_uci=false;
END_MODE;


// Mmorisations
xcompteur_depart=xcompteur;
xbornetemps_depart = xbornetemps;


// Choix du premier coup
if (   xopeningbook_in_use 
	&& xF_start_from_standard_position 
	&& xnbcoups==0 && !xchoose_best_opening)
{
// Total des poids d'ouverture
sum_weights=0;
for (li1=0;li1<=CHOIX_OUVERTURE_SIZE-1;li1++)
{
sum_weights+=xchoix_ouverture_poids[li1];
}
// Choix du coup
// Superbe bug
// La macro fait un remplacement textuel
// ce qui faisait deux rand au lieu d'un seul !!!
//xzz=inf(100,(rand()*sum_weights)/RAND_MAX);
li2=(rand()*sum_weights)/RAND_MAX;
li2=inf(100,li2);
#if DEBUG==1
	if ( li2>100 ) log_error("\nErreur C_724");
#endif
sum_weights=0;
for (li1=0;li1<=CHOIX_OUVERTURE_SIZE-1;li1++)
{
sum_weights+=xchoix_ouverture_poids[li1];
if ( li2<=sum_weights ) break; 
#if DEBUG==1
	// sur la dernire valeur d'ouverture
        // on doit atteindre un cumul de probabilit
	// de 100%
	if ( li2==CHOIX_OUVERTURE_SIZE-1 )
			log_error("\nErreur C_725");
#endif
}
li4=-1;
for (li3=0; li3<=LENGTH_SEARCHLISTMOVES ; li3++) 
{
// Pour dbogage apparemment
li2=(long) strlen(xtablepgn[li3]);
li2=(long) strlen(xchoix_ouverture[li1]);
// Suite
if (strcmp(xtablepgn[li3], xchoix_ouverture[li1])==0) 
	{ li4=li3; break; }
}
if ( li4==-1 )  
{
	#if DEBUG==1
	log_error("\nErreur C_723");
	#endif
}
else
{
// Enregistrement du coup choisi
xkeep_game=0;
wptr=MOVE_PIECE(xtablexx[li4]);
dep=MOVE_DEP64(xtablexx[li4]);
arr=MOVE_ARR64(xtablexx[li4]);
// Le premier coup est forcment un coup de cavalier
// ou de pion - ceci explique que l'on utilise
// seulement la direction 0
// Rem : 3 coups possibles pour le cavalier f1
if ( MOVE_ARR64(*(xmoves[dep][wptr->type][0]))==arr )
	 xkeep[1]=*(xmoves[dep][wptr->type][0]);
else if ( MOVE_ARR64(*(xmoves[dep][wptr->type][0]+1))==arr )
	 xkeep[1]=*(xmoves[dep][wptr->type][0]+1);
else if ( MOVE_ARR64(*(xmoves[dep][wptr->type][0]+2))==arr )
	 xkeep[1]=*(xmoves[dep][wptr->type][0]+2);
//ADJUST_MOVE_NUM_PIECE(xkeep[1]);
xkeep[2]=LigneEnd;
xlastvalue1=0;
//xlastvaluemat1=0;
return xkeep_game;
}
} // fin enregistrement premier coup



// Bibliothque d'ouvertures
if (xF_start_from_standard_position
	&& xopeningbook_in_use) // xF_start_from_standard_position est redondant 
{
//display_info_force("\nBibliotheque");
cc=search_bibliotheque();
if (cc==1) 
{	
	display_info_force("\nBook move found");
	return xkeep_game;
}
}


// Initialisation history
#if USE_OLDSTYLE_HISTORY==1
memset(&xhistory_heuristique[0][0],HistoryScore,12*64);
#endif
#if USE_REDUCTIONS==1
#if USE_FRUIT_PRUNING==1
for (i=11; i>=0; i--)
{
for (j=63; j>=0; j--)
{
xhistory_move_good_move[i][j]=0; 
xhistory_move_attempts[i][j]=1;
}
}
#endif
#endif

/*
// Initialisation des killermoves
// En effet, ils changent de couleur pour chaque level
cc=sizeof(KILLERMOVE[NOMBRE_KILLERMOVES]);
for (i=STMAX;i>=0;i--)
{
	memset(&xsearch_level[i].tab_killermoves[0],(char) 0,cc);
}
*/

/*
// Initialisation des killermoves_level
for (i=STMAX;i>=0;i--)
{
	memset(xsearch_level[i].tab_killermoves_level,0,sizeof(KILLERMOVE[NOMBRE_KILLERMOVES_LEVEL]));
	#if CLASSIFY_KILLERMOVES==1
	killermove=&xsearch_level[i].tab_killermoves_level[0];
	for (j=0;j<=NOMBRE_KILLERMOVES_LEVEL-1; killermove++, j++)
	{ killermove->indice=j; }
	#endif
}
*/


// Temps 
xtdebut_search=xtime=get_time_in_seconds();

#if USE_HASH_TABLE==1
// Peuplement statesptr->hash_code et pawn_hash_code
xstates[1]=xstates[0]; gen_code(0);
gen_code_pawn();
#endif

UCI_MODE;
strcpy(uci_interface::trace_location,"search");
END_MODE;

// Utilisation search
xsearch_on=true; //avanc  go
xreturn=false;
xcan_return=false;
xcan_return_urgency=false;
xshould_return_asap=false;
// Recopie de xstates[0]
xstates[1]=xstates[0];

xkeep_game=xsearch_level[1]->searchroot();
CONSOLE_MODE;
// xsearch_on=false; retard => il faut que le programme soit disponible
END_MODE;

UCI_MODE;
strcpy(uci_interface::trace_location,"end of search");
END_MODE;

#if UCI_DEBUG==1
sprintf(uci_interface::info_buffer,"Game : %d",xkeep_game);
display_info_debug(uci_interface::info_buffer);
#endif


return xkeep_game;

} // fin searchstart 




