

#include "stdafx.h"
#include "Cchess_1.h"
#define MAIN // juste avant la dfinition de PREFIX
#include "Cchess_2.h"
#include "Move.h"
//#include "Cchess_3.h"
#include "Cchess_4.h"
#include "Cchess_5.h"
#include "Cchess_6.h"
 

// Fonctions locales
char init(void);
char askmove(void);
void start_permanent_brain(void); 
char askmove_search(void);
void makepiece(char i, char j, char color);
char getON(char *a);
char getstring(char *ptr, char length);
char getstring_move(char *ptr);
long getlong(char maxlength);
//char getdiag1(char i);
//char getdiag2(char i);
void pose_pieces(void);
void genere_xw(void);
void setvalue(PIECE *wptr);
void makeposvalue(void);
void makeposvalue_finale(void);
char get_board(char *ptr);
void putsuffixe(char *nom_fich,char a, char b, char c);
void take_back(void);
char searchstart_pb(void);
void init_board(void);
void saisie_board(void);
void xboard_posvalue(void);
double get_time_in_seconds(void);
void dispose_engine(void);
void init_bitboards_and_others(void);
void compact_piece_list();
#if VALUE_MINOR_PIECES==1
void maj_liste_minor_pieces(void);
#endif



void uci_interface::allouer_nouvelles_commandes()
{
//display_info_force("\nRealloc");
nombre_max_commandes+=20;
uci_interface::uci_commandes=(char (*)[][UCI_COMMAND_SIZE+1])realloc(uci_interface::uci_commandes, nombre_max_commandes*(UCI_COMMAND_SIZE+1));
if (uci_interface::uci_commandes==NULL)
{
	log_error("\nErreur I_103 - Echec realloc");
}

}


/*
void uci_interface::enlarge_uci_buffer()
{
uci_buffer_size_in_moves+=50;
uci_interface::uci_buffer=(char (*)[])realloc(uci_interface::uci_buffer, uci_interface::uci_buffer_size_in_moves*UCI_BUFFER_SIZE_OF_MOVE);
if (uci_interface::uci_commandes==NULL)
{
	log_error("\nErreur I_104 - Echec realloc");
}
}
*/


void uci_interface::clear_uci_buffer(void)
{
	//(*uci_interface::uci_buffer)[0]='\0';
	uci_interface::uci_buffer.Empty();
	//uci_interface::uci_buffer.ReleaseBuffer();
	//free(uci_interface::uci_buffer);
}



void uci_interface::get_and_process_uci_buffer(char call_mode)
{
CString temp;
// Gestion call mode
uci_interface::call_mode=call_mode;

// Ne rien faire tant qu'il faut rgnrer une position et que le call_mode est > 0 ( search et extend )
if ( call_mode>0 && uci_interface::F_start_new_position ) return;
// Sinon traiter la nouvelle position
if ( uci_interface::F_start_new_position )
{
	uci_interface::start_new_position();
}

// Tester IOManager
if (uci_interface::IOManager.InputLinesAvailable)
{
	uci_interface::uci_buffer=uci_interface::IOManager.wait4_user_input();
	//#if _DEBUG==1
	if (uci_interface::uci_buffer.Compare("go1")==0)
	{
		uci_interface::uci_buffer="isready";
	} 
	else 
	if (uci_interface::uci_buffer.Compare("go2")==0)
	{
		uci_interface::uci_buffer="position startpos moves a2a3";
	} 
	else 
	if (uci_interface::uci_buffer.Compare("go3")==0)
	{
		uci_interface::uci_buffer="go btime 99999999 wtime 99999999";
	}
	if (uci_interface::uci_buffer.Compare("ps")==0)
	{
		uci_interface::uci_buffer="position startpos";
	}
	//#endif
	//strncpy(uci_interface::uci_buffer, 
	//	    temp, strlen(temp));
	//_strlwr(uci_interface::uci_buffer); Non  cause de fenstring
	process_uci_buffer(call_mode);
}
}



void uci_interface::process_uci_buffer(char call_mode)
{
short i;

// Gestion call mode

	uci_interface::call_mode=call_mode;

// Ne rien faire tant qu'il faut rgnrer une position et que le call_mode est > 0 ( search et extend )
if ( call_mode>0 && uci_interface::F_start_new_position ) return;
// Sinon traiter la nouvelle position
if ( uci_interface::F_start_new_position )
{
	uci_interface::start_new_position();
}

// Initialisations
uci_nombre_commandes=0;
command_iterator=0;
F_command_being_given=false;
F_new_startpos=false;
F_new_fenstring=false;
F_moves=false;
F_setoption=false;

for ( buffer_iterator=0; buffer_iterator<=uci_interface::uci_buffer.GetLength(); buffer_iterator++ )
{
uci_char=(char) uci_interface::uci_buffer.GetAt(buffer_iterator);
if ( uci_char!=' ' && uci_char!='\n' && uci_char!='\0')
{
// Nouvelle commande ?
if ( !F_command_being_given )
{
F_command_being_given=true;
uci_nombre_commandes++;
if ( uci_nombre_commandes>nombre_max_commandes ) { allouer_nouvelles_commandes(); } 
}
// Stockage caractere lu
if ( command_iterator<=UCI_COMMAND_SIZE )
(*uci_interface::uci_commandes)[uci_nombre_commandes-1][command_iterator++]=uci_char;
}
else // Separator
{
if ( F_command_being_given ) 
{ 
	(*uci_interface::uci_commandes)[uci_nombre_commandes-1][command_iterator]='\0'; // fin de chane
	F_command_being_given=false;
}
command_iterator=0;
}
} // fin for


// Traiter les commandes unitairement 
for (i=0;i<=uci_nombre_commandes-1;i++) 
{
process_uci_commande(i);
}


// Nouvelle position de dpart (standard)
if ( F_new_startpos || F_new_fenstring ) 
{
if (call_mode==1) 
{
// Appel depuis search ou extend
xshould_return_asap=true; // pour sortir de search ou extend
xcan_return=true;
xreturn=true;
xpb_fail=true; // pour le cas du pondering
// Pour initialiser la position ultrieurement
uci_interface::F_start_new_position=true;
}
else 
{
	uci_interface::start_new_position();
}

} // fin nouvelle position


uci_interface::clear_uci_buffer();
uci_interface::F_uci_commande_1=false;
uci_interface::F_uci_commande_2=false;
} // fin process_uci_buffer



void uci_interface::start_new_position()
{
char length;
short lastvalue0_mem;
//short  lastvaluemat0_mem;
MOVE move;
short i;
char color01; 
char nature;
MOVE_BASE flag_prom, flag;
short pourcentage_temps_de_base_mem;


// Nouvelle position de dpart (standard)
// A priori cette condition et toujours vrifie
// mais c'est sympa de la laisser pour 
// montrer les cas de figure
if ( F_new_startpos || F_new_fenstring ) 
{
// Initialisations
uci_interface::xnbcoups_mem=xnbcoups;
uci_interface::xopeningbook_in_use_mem=xopeningbook_in_use;
xnbcoups=0;

// Sauvegarde xlastvalue0 avant init()
// Afin de conserver xlastvalue0 et pourcentage_temps_de_base
// d'un coup sur l'autre ce que ne permet pas sinon le protocole UCI
lastvalue0_mem=xlastvalue0;
//lastvaluemat0_mem=xlastvaluemat0;
pourcentage_temps_de_base_mem=xpourcentage_temps_de_base;


// Init
cc=init();
// initialise via initvalue xposition et xmateriel
if (cc==0)
{
log_error("\nI_497 : Problme chiquier");
}


// Restauration xlastvalue0 - remis  zro par init()
xlastvalue0=lastvalue0_mem;
xlastvalue1=xlastvalue0;
//xlastvaluemat0=lastvaluemat0_mem;
xpourcentage_temps_de_base=pourcentage_temps_de_base_mem;


//sprintf(xbuffer,"\nroque blanc : %d", xstates[0].o_o[1]);
//display_info_force(xbuffer);


// Remplissage de xpartie  partir du tableau de commandes UCI
// et jeu des coups
if (xtrait==1) xwtm=1;
else		   xwtm=0;
// On part de 2 car on souhaite tester
// moves ou fen
for (i=2;i<=uci_nombre_commandes-1;i++ /*, xwtm=1-xwtm*/ )
{
if ( strcmp((*uci_interface::uci_commandes)[i],"")==0 ) break;
if ( strcmp((*uci_interface::uci_commandes)[i],"startpos")==0 ) continue; 
if ( strcmp((*uci_interface::uci_commandes)[i],"fen")==0 ) continue; 
if ( strcmp((*uci_interface::uci_commandes)[i],"moves")==0 ) 
	{ F_moves=true; continue; }

// Traitement des coups
if (F_moves!=1) continue;

_strlwr((*uci_interface::uci_commandes)[i]);
length=(char) strlen((*uci_interface::uci_commandes)[i]);
xnbcoups++;
if (xnbcoups>xmaxnbcoups) 
{
xpartie=(ENREGISTREMENT*)realloc(xpartie,(xmaxnbcoups+50+2)*sizeof(ENREGISTREMENT));
if (xpartie==0)
	log_error("\nErr I 166");
xmaxnbcoups+=50;
}
rptr=&xpartie[xnbcoups]; 

// Conversion du coup UCI
// Remarque importante : la lgalit des coups n'est pas vrifie
// Exemple : on peut ne pas couvrir un chec
//rptr->dep=(((*uci_interface::uci_commandes)[i][0]-'a')<<3)+((*uci_interface::uci_commandes)[i][1]-'1');
//rptr->arr=(((*uci_interface::uci_commandes)[i][0]-'a')<<3)+((*uci_interface::uci_commandes)[i][1]-'1');
rptr->dep88=((*uci_interface::uci_commandes)[i][0]-'a'+1)*10+((*uci_interface::uci_commandes)[i][1]-'1'+1);
rptr->arr88=((*uci_interface::uci_commandes)[i][2]-'a'+1)*10+((*uci_interface::uci_commandes)[i][3]-'1'+1);
rptr->special=0;
rptr->prom=0;
rptr->prise_nat=0;
flag_prom=0;
flag=0;
//rptr->prise_num=99

// Raccourcis
arr=TO64(rptr->arr88);
dep=TO64(rptr->dep88);
#if DEBUG==1
short int si1;
char ccc;
si1=X88(rptr->arr88);
si1=Y88(rptr->arr88);
si1=TO64(rptr->arr88);
ccc=TO64(rptr->arr88);
#endif

// Numero de pice
rptr->status=0;
rptr->piece_num=xboard[dep].num_piece;


// Identification des roques
if ( xboard[dep].nature=='R' )
{
if( rptr->dep88==51 && rptr->arr88==71 ) 
{
	rptr->special=1;
	flag=MoveCastle;
}
else 
if ( rptr->dep88==51 && rptr->arr88==31 )
{
	rptr->special=1;
	flag=MoveCastle;
}
else 
if ( rptr->dep88==58 && rptr->arr88==78 )
{
	rptr->special=1;
	flag=MoveCastle;
}
else 
if ( rptr->dep88==58 && rptr->arr88==38 )
{
	rptr->special=1;
	flag=MoveCastle;
}
}

// Identification des prises
if ( xboard[arr].nature!=0 )
{
	//rptr->prise_num=xboard[arr].num_piece;
	rptr->prise_nat=xboard[arr].nature;
}
// Identification des prise en passant
if ( xboard[dep].nature=='P' )
{
	if ( xboard[dep].color==1 && xboard[arr].posy==5 && xboard[arr].color==0
		 && xboard[arr-1].nature=='P' && xboard[arr-1].color==-1)
	{ 
		rptr->special=2;
		flag=MoveEnPassant;
		rptr->prise_nat='P';
		//rptr->prise_num=xboard[arr-1].wptr->num_piece; 
	}
	if ( xboard[dep].color==-1 && xboard[arr].posy==2 && xboard[arr].color==0 
		 && xboard[arr+1].nature=='P' && xboard[arr+1].color==1)
	{ 
		rptr->special=2;
		flag=MoveEnPassant;
		rptr->prise_nat='P';
		//rptr->prise_num=xboard[arr+1].wptr->num_piece; 
	}
}
// Promotions 
//if ( length==5 ) 
if (xboard[dep].nature=='P')
{
	if (
		(xboard[dep].color01==1 && Y64(dep)==6)
		||
		(xboard[dep].color01==0 && Y64(dep)==1)
	   )
{
	rptr->special=3;
	flag=MovePromote;
	rptr->prom=english_to_french((*uci_interface::uci_commandes)[i][4]);
	switch(rptr->prom)
	{
	case 'C' :  flag_prom=MovePromoteKnight;
			break;
	case 'F' :  flag_prom=MovePromoteBishop;
			break;
	case 'T' :  flag_prom=MovePromoteRook;
			break;
	case 'D' :  flag_prom=MovePromoteQueen;
			break;
	default : log_error("\nErr I_689");
	}
}
}

// Autres raccourcis
nature=xboard[dep].nature;
color01=xboard[dep].color01;
prom=rptr->prom;
special=rptr->special;
num=rptr->piece_num;
prise_nat=rptr->prise_nat;
//prise_num=rptr->prise_num;

move=MOVE_MAKE(nature,dep,arr,flag|flag_prom,0);
ASSERT(MOVE_NATURE(move)==nature);
SET_MOVE_CAPTURE(move,prise_nat);

// Impact possible sur le roque 
// intgr dans le MOVE_MAKE
//if (    bit(xmasque_impact_droit_roque,dep)
//    ||  bit(xmasque_impact_droit_roque,arr) ) 
//{ SET_MOVE_MAY_IMPACT_ROQUE(*mpt); }


// Jeu du coup
ASSERT(xlevel==0);
xsearch_level[0]->jouer(move);
// pas de if (++xhash_indice_generation==127) xhash_indice_generation=0;
xsearch_level[0]->maj_roque(move); // aprs le jeu du coup car obtention de num depuis la case d'arrive

// Suite renseignement xpartie
rptr->xnbcoups=xnbcoups;
rptr->ynbcoups=DIV2(xnbcoups+1);
rptr->demicoup=2-xnbcoups%2;

// Echec ou non ( pour xpartie )
rptr->status=xsearch_level[0]->check;

// Enregistrement du coup dans xpartie
// mais pas sur fichier PGN
// ( aprs les calculs )
enregistre_coup_pgn(0);


// Actualiser xlastmove  chaque fois
// Ncessaire pour de lastprise1
//  placer avant l'actualisation donc
// Apparement n'est pas utilis pour le contrle
// de la prise en passant qui est accepte telle quelle
// depuis le fichier au format PGN

// xlastmove
xlastmove=move;


// Rgle des 50 coups
// mise ... jour lastprise1 et lastprise2
if (MOVE_CHANGES_LASTPRISE(xlastmove))
{
xlastprise1=xnbcoups;
}
xstates[0].lastprise2=xlastprise1;

// Copie du coup dans la xliste50
//xliste50[xnbcoups-xlastprise1]=xlastmove;
xliste50[xnbcoups-xlastprise1]=gen_code(0);


#if CHECK_REPET==1
#if DEBUG==1
PIECE *wptr2;
char *ptr;
short si;
// Copie de la position - rptition
// aprs le coup
ptr=&xpositions[xnbcoups-xlastprise1][0];
wptr2=&xw[31];
for (si=31; si>=0; si--, wptr2--, ptr++)
{
if (wptr2->nature==0) { *ptr=0; continue; }
*ptr=wptr2->pos;
}
#endif
#endif

} // fin boucle sur liste de coups



// Initialisations de dbut de partie
// ( tests sur le nombre de coups pour ne pas faire 
//   systmatiquement ces tests )
if ( xnbcoups<=2 )
{
xlast_opening_move_used=0;
parametres_globaux::xF_roi_posx_mem[0]=xstates[0].roi_posx[0];
parametres_globaux::xF_roi_posx_mem[1]=xstates[0].roi_posx[1];
parametres_globaux::xF_make_posval_finale=false;
makeposvalue(); // dtermine les nouvelles valeurs de cases
xboard_posvalue(); // stocke les valeurs dans xboard
// Actualisation des priorits des coups 
recompute_move_priorities(); 
}

// Initialisations 
if (xtrait==1)
{
	if (xwtm==1) xmode='B';
	else xmode='N';
}
else // xtrait==0
{
	if (xwtm==0) xmode='N';
	else xmode='B';
}

// Ncessaire  l'obttention de la liste des coups lgaux
xlv1_wtm=xwtm; // pour searchmove
xsearch_level[0]->actualise_all(); 


// Vrification de lgalit de la position
// A implmenter en mode UCI
// Vrifier :
// - le nombre des pices et leurs emplacements
// - la cohrence trait / roi en chec 
cc=1;
if (xsearch_level[0]->full_testcheck(xstates[0].roi_pos[1],1)!=NULL && xwtm!=1) cc=0;
if (xsearch_level[0]->full_testcheck(xstates[0].roi_pos[0],0)!=NULL && xwtm!=0) cc=0;
if (cc==0)
{
	// Position illgale
	uci_interface::F_position_entered=false;
	sprintf(xbuffer,"\nPosition illegale");
	display_info_force(xbuffer);
	xsearch_on=false;
	return;
}


xsearch_level[0]->reactu_liste_nombre=0;
liste_coups_legaux();
// Mise  jour paramtres globaux
ajustement_parametres_globaux();
// Recalcul pawnstruct
xsearch_level[0]->eval_pawnstruct();
if (xnbcoups>uci_interface::xnbcoups_mem)
{
	// xdiffval=xlastvaluemat0-TO_PLAYER(xwtm)*xsearch_level[0].valposmat;
	// Si je viens de prendre une pice et que noir va reprendre
	// xdiffval est ngatif car valuemat0=0 et valposmat>0
	// xdiffval est positif en cas de reprise immdiate
	//xdiffval=xlastvaluemat0-PLAYER(TO_PLAYER(xwtm),xstates[0].materiel);
}
else 
{
	//xdiffval=0;
	// Rinitialisation
	xpourcentage_temps_de_base=POURCENTAGE_TEMPS_DE_BASE;
	xopeningbook_has_been_updated=false;
}
//sprintf(xbuffer,"\nxdiffval : %d",xdiffval);
//display_info(xbuffer);
// Si on tait sorti de la bibliothque d'ouverture, on reste sorti de la bibliothque d'ouverture
if (xnbcoups>uci_interface::xnbcoups_mem )
{ xopeningbook_in_use = uci_interface::xopeningbook_in_use_mem; }
if (xnbcoups>=OPENING_BOOK_LENGTH) xopeningbook_in_use=false;
// Pour le cas d'une rduction du nombre de coups
if (xlast_opening_move_used>xnbcoups) 
	{ xlast_opening_move_used = xnbcoups; }
// Recration de la partie au format PGN
// ( mais pas en pondering )
if (uci_interface::F_go)
{
//xhandle=cree_partie_pgn(xhandle,xnom_game,xpartie,xnbcoups);
}


} // fin nouvelle position de dpart standard



// Reset flag nouvelle position
F_start_new_position=false;
// Positionnement flag
uci_interface::F_position_set_from_uci=true;


} // fin uci_interface::start_new_position



void uci_interface::Dispose()
{
free(uci_interface::uci_commandes);
}


void uci_interface::process_uci_commande(short index_commande)
{
char *uci_commande;
char pos88;
char i,j;
char pos64v2;
char *ptr;


uci_commande=(*uci_interface::uci_commandes)[index_commande];
if ( strcmpi(uci_commande, "")==0 ) return;

// if ( uci_interface::F_uci_commande_1==0 )
// {
	if ( strcmpi(uci_commande, "isready")==0 )
	{
	cout << "readyok\n"; cout.flush();
	//uci_interface::F_readyok_given=true;
	//uci_interface::clear_uci_buffer();

	uci_interface::F_isready=true;
  	uci_interface::F_uci_commande_1=false;
	uci_interface::F_uci_commande_2=false;
	return;
	}
	if ( strcmpi(uci_commande, "stop")==0 
		&& (xsearch_on || !xsearch_on)  )
		// pour les retours prmaturs de pb
	{
	uci_interface::F_position_entered=false; // ne mange pas de pain
 	// Revenir le plus rapidement possible en jouant un coup ( go )
	// Attention : il faut jouer un coup et terminer par bestmove
	// ou interrompre le pondering ( go ponder )
	xbornetemps=xcompteur; // met le programme en crise de temps
	xtime_extension=true; // pour interdire toute nouvelle extension
	if ( xpb_explo ) 
		{ 
			// Interruption du pondering sans match (sans pondering)
			xshould_return_asap=true;
			xcan_return=true;
			xreturn=true;
			xpb_fail=true;
			// Parce que le protocole exige un bestmove
			// aprs un stop en pondering
			// mme s'il n'utilise pas les coups
			cout << "bestmove\n";
			cout << "info stopping pb\n";
			cout.flush();
			// Pour viter un double traitement
			//strcpy(uci_commande, "ponderhit");
			// Parce que le protocole exige un bestmove
			// aprs un stop en pondering
			//goto PONDERHIT;
		}
	else // Jeu normal
	{
		{
			xshould_return_asap=true;
			xreturn=true; // pour forcer 
		}
    }

	// Stop depuis init()
    // Il se peut que l'analyse en pondering soit termine quand l'ordre stop arrive
    // Ceci arrive en particulier si il y a mat en pondering ( dans ce cas on sort plus vite )
	// Ou si UCI envoie un STOP NON ATTENDU
	if ( uci_interface::call_mode==0 ) // appel depuis init
	{
		cout << "info situation is uci-wait\n";
		cout.flush();		
	}
	uci_interface::F_uci_commande_1=false;
	uci_interface::F_uci_commande_2=false;
	return;
	}
	if ( strcmpi(uci_commande, "quit")==0 )
	{
	dispose_engine(); 
	/* une solution alternative
	xbornetemps=xcompteur; 
      xtime_extension=true; // pour viter toute extension de temps
	xreturn=true;
	xexit=true;
      uci_interface::F_uci_commande_1=false;
	uci_interface::F_uci_commande_2=false;
	return;
	*/ 
	}
	if ( strcmpi(uci_commande, "ucinewgame")==0 )
	{
		xlastvalue1_mem_pour_reprise_immediate=0;
//		xlastvalue1_wtm_pour_reprise_immediate=99;
		xlast_opening_move_used=0;
		xlastvalue0=0;
		//		xlastvaluemat0=0;
		xpourcentage_temps_de_base=POURCENTAGE_TEMPS_DE_BASE;		
		#if USE_HASH_TABLE==1
		reset_hash_table();
		#endif
	  	uci_interface::F_uci_commande_1=false;
		uci_interface::F_uci_commande_2=false;
		return;
	}
	if ( strcmpi(uci_commande, "position")==0 && uci_interface::F_isready )
	{
		if (xsearch_on)
		{
		// Si "position" est donn alors qu'on cherche
		// la position ne peut pas tre joue
		// il faut stopper sans donner de bestmove
		uci_interface::F_suppress_bestmove_answer=true;
		uci_interface::F_position_entered=false;
		xshould_return_asap=true;  // pour mettre fin au pondering
		xcan_return=true;
		xreturn=true;
		xpb_fail=true; // pour mettre fin au pondering
		}
		else // Entre de position
		{
		uci_interface::F_suppress_bestmove_answer=false;
		uci_interface::F_position_entered=true;
		uci_interface::F_uci_commande_1=true;
		uci_interface::F_uci_commande_2=false;
		}
		return;
	}
	if ( strcmpi(uci_commande, "go")==0 && uci_interface::F_position_entered)
	{
		uci_interface::F_position_entered=false;
		if (xsearch_on)
		{
		// Si "go" est donn alors qu'on cherche
		// la position ne peut pas tre joue
		// il faut stopper sans donner de bestmove
		uci_interface::F_suppress_bestmove_answer=true;
		xcan_return=true;  // pour mettre fin au pondering
		xshould_return_asap=true;
		xreturn=true;
		xpb_fail=true; // pour mettre fin au pondering
		}
		else
		{
		xsearch_on=true;
		uci_interface::F_suppress_bestmove_answer=false;
		uci_interface::F_uci_commande_1=true;
		uci_interface::F_uci_commande_2=false;
		uci_interface::F_go=true;
		uci_interface::F_go_ponder=false;
		}
		return;
	}
	if ( strcmpi(uci_commande, "ponderhit")==0 )
	{
		// Attention : il faut que la recherche se soit termine en succs
		// Si la recherche ne s'est pas termine en succs
		// un coup est not comme entr mais xpb_guessed reste  1
		if ( xpb_explo && !xpb_fail ) 
			{ xpb_guessed=true; }
		xpb_move_entered=xpondered_move;
		xpb_move_has_been_entered=true;
		uci_interface::F_uci_commande_1=false;
		uci_interface::F_uci_commande_2=false;
		return;
	}
	if ( strcmpi(uci_commande, "setoption")==0 )
	{
		uci_interface::F_uci_commande_1=true;
		uci_interface::F_setoption=true;
		uci_interface::set_int_parameter=0;
		uci_interface::set_str_parameter=0;
		return;
	}
	if ( strcmpi(uci_commande, "where")==0
		 || strcmpi(uci_commande, "what")==0 )
	{
		display_info_force(uci_interface::trace_location);
		return;
	}
	

//} // fin if !uci_interface::F_uci_commande_1


if (uci_interface::F_uci_commande_1 && !uci_interface::F_uci_commande_2)
{
	if ( strcmpi(uci_commande, "startpos")==0 )
	{
		uci_interface::F_uci_commande_2=true;
		F_new_startpos=true;
		fenstring_ep=0;
		xF_start_from_standard_position=true;
		get_board(NULL); // Obtention board standard
		return;
	}

	if ( strcmpi(uci_commande, "fen")==0 )
	{
		uci_interface::F_uci_commande_2=true;
		set_str_parameter=PARAM_FENSTRING;
		F_new_fenstring=true;
		xF_start_from_standard_position=false;
		return;
	}

	if ( strcmpi(uci_commande, "ponder")==0 )
	{
		if ( uci_interface::F_setoption )
		{ 
			uci_commande=(*uci_interface::uci_commandes)[index_commande+2];
			if (strcmpi(uci_commande, "true")==0)
			{
				if (xenable_permanentbrain_option)
					xpermanentbrain_is_on=true;
				else
					xpermanentbrain_is_on=false;
			}
			if (strcmpi(uci_commande, "false")==0)
			{ xpermanentbrain_is_on=false; xshould_return_asap=true; xcan_return=true; xreturn=true; xpb_fail=true; }
			return;
		}

		// Si fenstring, pas de ponder move
		// Si startpos, pas de ponder move
		if (xnbcoups>0)
		{
		// Fixer le plus tt possible ces valeurs
		// afin d'accepter les "stop"
		xpb_explo=true; // le fixer le plus tot possible
		uci_interface::F_uci_commande_1=true;
		uci_interface::F_uci_commande_2=true;
		if ( uci_interface::F_go 
			 && xpermanentbrain_is_on ) 
		{ uci_interface::F_go=false; uci_interface::F_go_ponder=true; }
		return;
		}
	}
	if ( strcmpi(uci_commande, "name")==0 )
	{
		// Cette commande ne compte pas
		return;
	}
		if ( strcmpi(uci_commande, "value")==0 )
	{
		// Cette commande ne compte pas
		return;
	}
      if ( strcmpi(uci_commande, "sound")==0 )
	{
		// commande +2 pour sauter value
		uci_commande=(*uci_interface::uci_commandes)[index_commande+2];
		if ( strcmpi(uci_commande,"true")==0 ) xenable_sound=true;
		else xenable_sound=false;
		display_info("option Sound ok");
		return;
	}
}



if ( strcmp(uci_commande,"infinite" )==0 )
{
xF_timer_on=false;
xF_timer_fixed_time_per_move=false;
xF_timer_fixed_number_of_nodes=false;
xF_time_control=false;
xinfinite_search=true;
xmate_in_x=0; xF_mate_in_x=false;
xsearch_x_plies=0; xF_search_x_plies=false;
return;
}

if ( strcmpi(uci_commande, "hash")==0 )
{
	set_int_parameter=PARAM_HASH_SIZE;
	return;
}

if ( strcmpi(uci_commande, "ownbook")==0 )
{
	set_str_parameter=PARAM_OWNBOOK;
	return;
}

if ( strcmpi(uci_commande, "Allow_5_seconds_to_play_moves_on_real_bord")==0 )
{
	set_int_parameter=PARAM_UCI_TEMPS_MANIPULATION;
	return;
}

if ( strcmpi(uci_commande, "Number_of_threads")==0 )
{
	set_int_parameter=PARAM_NUMBER_OF_THREADS;
	return;
}


if ( strcmp(uci_commande,"wtime")==0 ) 
{
set_int_parameter=PARAM_AVAILABLE_TIME_WHITE;
xF_timer_on=true;
xTIMER_ON_MODE=1;
xF_movetime=false;
xmovestogo=0;
xF_timer_fixed_time_per_move=false;
xF_timer_fixed_number_of_nodes=false;
// xF_time_control=false;
xinfinite_search=false;
xmate_in_x=0; xF_mate_in_x=false;
xsearch_x_plies=0; xF_search_x_plies=false;
return;
}



if ( strcmp(uci_commande,"btime")==0 ) 
{
set_int_parameter=PARAM_AVAILABLE_TIME_BLACK;
xF_timer_on=true;
xTIMER_ON_MODE=1;
xF_movetime=false;
xmovestogo=0;
xF_timer_fixed_time_per_move=false;
xF_timer_fixed_number_of_nodes=false;
// xF_time_control=false;
xinfinite_search=false;
xmate_in_x=0; xF_mate_in_x=false;
xsearch_x_plies=0; xF_search_x_plies=false;
return;
}

if ( strcmp(uci_commande,"movetime")==0 ) 
{
set_int_parameter=PARAM_MOVETIME;
xF_timer_on=true;
xTIMER_ON_MODE=1;
xF_movetime=true;
xmovestogo=1;
xF_timer_fixed_time_per_move=false;
xF_timer_fixed_number_of_nodes=false;
// xF_time_control=false;
xinfinite_search=false;
xmate_in_x=0; xF_mate_in_x=false;
xsearch_x_plies=0; xF_search_x_plies=false;
return;
}


if ( strcmp(uci_commande,"winc")==0 ) 
{
set_int_parameter=PARAM_ADDITIONAL_TIME_WHITE;
return;
}

if ( strcmp(uci_commande,"binc")==0 ) 
{
set_int_parameter=PARAM_ADDITIONAL_TIME_BLACK;
return;
}


if ( strcmp(uci_commande,"movestogo")==0 ) 
{
set_int_parameter=PARAM_MOVES_TO_GO;
xF_timer_on=true;
xTIMER_ON_MODE=1;
xF_timer_fixed_time_per_move=false;
xF_timer_fixed_number_of_nodes=false;
xF_time_control=true;
xinfinite_search=false;
return;
}


if ( strcmp(uci_commande,"movetime")==0 ) 
{
// Sous UCI, movetime est donn en millisecondes
set_int_parameter=PARAM_TIMER_FIXED_TIME_PER_MOVE;
xF_timer_on=true;
xTIMER_ON_MODE=1;
xF_timer_fixed_time_per_move=true;
xF_timer_fixed_number_of_nodes=false;
xF_time_control=false;
xinfinite_search=false;
xmate_in_x=0; xF_mate_in_x=false;
xsearch_x_plies=0; xF_search_x_plies=false;
return;
}


if ( strcmp(uci_commande,"nodes")==0 ) 
{
set_int_parameter=PARAM_TIMER_OFF_FIXED_NUMBER_OF_NODES;
xF_timer_on=false;
xTIMER_ON_MODE=1;
xF_timer_fixed_time_per_move=false;
xF_timer_fixed_number_of_nodes=true;
xF_time_control=false;
xinfinite_search=false;
xmate_in_x=0; xF_mate_in_x=false;
xsearch_x_plies=0; xF_search_x_plies=false;
return;
}

if ( strcmp(uci_commande,"depth")==0 ) 
{
set_int_parameter=PARAM_SEARCH_X_PLIES;
xF_timer_on=false;
xF_timer_fixed_time_per_move=false;
xF_timer_fixed_number_of_nodes=false;
xF_time_control=false;
xinfinite_search=true;
xF_search_x_plies=true;
xmate_in_x=0; xF_mate_in_x=false;
return;
}

if ( strcmp(uci_commande,"mate")==0 )
{
set_int_parameter=PARAM_MATE_IN_X;
xF_timer_on=false;
xF_timer_fixed_time_per_move=false;
xF_timer_fixed_number_of_nodes=false;
xF_time_control=false;
xinfinite_search=true;
xF_mate_in_x=true;
xsearch_x_plies=0; xF_search_x_plies=false;
return;
}

// Renseignement d'un paramtre
if ( set_int_parameter>0 )
{
value=atol(uci_commande);
//sprintf(xbuffer, "\nParamater : %d, Value : %d", set_int_parameter, value);
//display_info_force(xbuffer);
switch( set_int_parameter )
{
case PARAM_AVAILABLE_TIME_WHITE : xavailable_time[1]=((long)value/1000L); 
	//sprintf(xbuffer, "\nTime : %d", (long) xavailable_time[1]);
	//display_info_force(xbuffer);
	uci_interface::set_int_parameter=0;
	break;
case PARAM_AVAILABLE_TIME_BLACK : xavailable_time[0]=(long) value/1000;
 	      uci_interface::set_int_parameter=0;
		break;
case PARAM_MOVETIME: xavailable_time[0]=(long) value/1000; 
  	 	xavailable_time[1]=(long) value/1000;
 	      uci_interface::set_int_parameter=0;
		break;
case PARAM_ADDITIONAL_TIME_WHITE: xfischer_add[1]=(short) value/1000; 
 	      uci_interface::set_int_parameter=0;
		break;
case PARAM_ADDITIONAL_TIME_BLACK: xfischer_add[0]=(short) value/1000;
 	      uci_interface::set_int_parameter=0;
		break;
case PARAM_TIMER_OFF_FIXED_NUMBER_OF_NODES: xtimer_off_number_of_nodes=value;
 	      uci_interface::set_int_parameter=0;
		break;
case PARAM_TIMER_FIXED_TIME_PER_MOVE: xtimer_fixed_time_per_move=value/1000;
 	      uci_interface::set_int_parameter=0;
		break;
case PARAM_MATE_IN_X: xmate_in_x=(char) value; 
	      xdepthmax_struct=inf(xmate_in_x,xdepthmax_struct);
 	      uci_interface::set_int_parameter=0;
		break;
case PARAM_SEARCH_X_PLIES: xsearch_x_plies=(char) value; 
 	      uci_interface::set_int_parameter=0;
		break;
case PARAM_MOVES_TO_GO: xmovestogo=(short) value; 
 	      uci_interface::set_int_parameter=0;
		break;
case PARAM_HASH_SIZE: 
	      xhash_size=value;
		  set_hash_tables((short) xhash_size, PAWN_HASH_SIZE);
 	      uci_interface::set_int_parameter=0;
		break;
case PARAM_FENSTRING_INUTILISE: 
 	      uci_interface::set_int_parameter=0;
 	      uci_interface::set_int_parameter=PARAM_FENSTRING_NBCOUPS;
		break;
case PARAM_FENSTRING_NBCOUPS: 
	      xpgn_move_offset=(char) (value/2)*2;
	      uci_interface::set_int_parameter=0;
		break;
//case PARAM_NUMBER_OF_THREADS:
//		xnumber_of_threads=(char) value;
//	      uci_interface::set_int_parameter=0;
//default:    uci_interface::set_int_parameter=0;
//		break;
break;
}
}

if ( set_str_parameter>0 )
{
switch( set_str_parameter )
{
case PARAM_OWNBOOK: 
	if (strcmp(uci_commande,"true")==0) 
	{	
		xopeningbook_allowed=true;
		xopeningbook_in_use=true;
		uci_interface::xopeningbook_in_use_mem=true;
		//strcpy(xbuffer,"Ownbook true");
		//display_info_force(xbuffer);
	}
	else 
	{
		uci_interface::xopeningbook_in_use_mem=false;
		xopeningbook_allowed=false;
		xopeningbook_in_use=false;
		//strcpy(xbuffer,"Ownbook false");
		//display_info_force(xbuffer);
	}
	uci_interface::set_str_parameter=0;
	break;
case PARAM_UCI_TEMPS_MANIPULATION:
	if (strcmp(uci_commande,"true")==0)
	{
		xF_uci_temps_manipulation=true;
	}
	else
	{
		xF_uci_temps_manipulation=false;
	}
	uci_interface::set_str_parameter=0;
	break;
case PARAM_FENSTRING_TRAIT: 
		for (ptr=&uci_commande[0]; *ptr!=0; ptr++)
		{
			switch(*ptr)
			{
				case 'w' : xtrait=1; xwtm=1;
					break;
				case 'b' : xtrait=0; xwtm=0;
					break;
			}
		}
	    uci_interface::set_str_parameter=PARAM_FENSTRING_ROQUE;
		uci_interface::set_int_parameter=0;
		break;
case PARAM_FENSTRING_ROQUE: 
	    //xroqueini[1][0]=0;
	    //xroqueini[1][1]=0;
	    //xroqueini[0][0]=0;
	    //xroqueini[0][1]=0;
	    xroqueini[1]=0;
	    xroqueini[0]=0;
	    for (ptr=&uci_commande[0]; *ptr!=0; ptr++)
	    {
			switch(*ptr)
			{
				case 'K' : maj_droit_roque(xroqueini[1],ATTRIBUTION_DROIT_PETIT_ROQUE);
					break;
				case 'Q' : maj_droit_roque(xroqueini[1],ATTRIBUTION_DROIT_GRAND_ROQUE);
					break;
				case 'k' : maj_droit_roque(xroqueini[0],ATTRIBUTION_DROIT_PETIT_ROQUE);
					break;
				case 'q' : maj_droit_roque(xroqueini[0],ATTRIBUTION_DROIT_GRAND_ROQUE);
					break;
				default : 
					break;
			}
		}
 		uci_interface::set_str_parameter=PARAM_FENSTRING_CASE_EP;
		uci_interface::set_int_parameter=0;
		break;
case PARAM_FENSTRING:
	// Syntaxe : position fen <fenstring> w KQkq <ep_square> <?> <nb_coups> 
	memcpy(uci_interface::fenstring,uci_commande, 99); // dernier caractre = 0
	ptr=fenstring;
	// Pour mmoire le xxboard_original est au format 88
	memset(xxboard_original_french,0,sizeof(SIZE_OF_BOARD_88));
	// Attention en fenstring on part de la fin de l'chiquier
	// soit 7 ou 18
	for(i=0,pos64v2=0,pos88=18;i<100,*ptr!=0;ptr++,i++)
	{
	switch(*ptr)
	{
	case '/' :  continue;
			break;
	case '1' :  for (j=1;j<=1;j++) 
			{
			xxboard_original_french[pos88]=0;
			pos64v2++; pos88=(pos64v2%8+1)*10+8-(pos64v2/8);
			}
			break;
	case '2' :  for (j=1;j<=2;j++) 
			{
			xxboard_original_french[pos88]=0;
			pos64v2++; pos88=(pos64v2%8+1)*10+8-(pos64v2/8);
			}
			break;
	case '3' :  for (j=1;j<=3;j++) 
			{
			xxboard_original_french[pos88]=0;
			pos64v2++; pos88=(pos64v2%8+1)*10+8-(pos64v2/8);
			}
			break;
	case '4' :  for (j=1;j<=4;j++) 
			{
			xxboard_original_french[pos88]=0;
			pos64v2++; pos88=(pos64v2%8+1)*10+8-(pos64v2/8);
			}
			break;
	case '5' :  for (j=1;j<=5;j++) 
			{
			xxboard_original_french[pos88]=0;
			pos64v2++; pos88=(pos64v2%8+1)*10+8-(pos64v2/8);
			}
			break;
	case '6' :  for (j=1;j<=6;j++) 
			{
			xxboard_original_french[pos88]=0;
			pos64v2++; pos88=(pos64v2%8+1)*10+8-(pos64v2/8);
			}
			break;
	case '7' :  for (j=1;j<=7;j++) 
			{
			xxboard_original_french[pos88]=0;
			pos64v2++; pos88=(pos64v2%8+1)*10+8-(pos64v2/8);
			}
			break;
	case '8' :  for (j=1;j<=8;j++) 
			{
			xxboard_original_french[pos88]=0;
			pos64v2++; pos88=(pos64v2%8+1)*10+8-(pos64v2/8);
			}
			break;
	case 'P' :  xxboard_original_french[pos88]='P';
			pos64v2++; pos88=(pos64v2%8+1)*10+8-(pos64v2/8);
			break;
	case 'N' :  xxboard_original_french[pos88]='C';
			pos64v2++; pos88=(pos64v2%8+1)*10+8-(pos64v2/8);
			break;
	case 'B' :  xxboard_original_french[pos88]='F';
			pos64v2++; pos88=(pos64v2%8+1)*10+8-(pos64v2/8);
			break;
	case 'R' :  xxboard_original_french[pos88]='T';
			pos64v2++; pos88=(pos64v2%8+1)*10+8-(pos64v2/8);
			break;
	case 'Q' :  xxboard_original_french[pos88]='D';
			pos64v2++; pos88=(pos64v2%8+1)*10+8-(pos64v2/8);
			break;
	case 'K' :  xxboard_original_french[pos88]='R';
			pos64v2++; pos88=(pos64v2%8+1)*10+8-(pos64v2/8);
			break;
	case 'p' :  xxboard_original_french[pos88]=-'P';
			pos64v2++; pos88=(pos64v2%8+1)*10+8-(pos64v2/8);
			break;
	case 'n' :  xxboard_original_french[pos88]=-'C';
			pos64v2++; pos88=(pos64v2%8+1)*10+8-(pos64v2/8);
			break;
	case 'b' :  xxboard_original_french[pos88]=-'F';
			pos64v2++; pos88=(pos64v2%8+1)*10+8-(pos64v2/8);
			break;
	case 'r' :  xxboard_original_french[pos88]=-'T';
			pos64v2++; pos88=(pos64v2%8+1)*10+8-(pos64v2/8);
			break;
	case 'q' :  xxboard_original_french[pos88]=-'D';
			pos64v2++; pos88=(pos64v2%8+1)*10+8-(pos64v2/8);
			break;
	case 'k' :  xxboard_original_french[pos88]=-'R';
			pos64v2++; pos88=(pos64v2%8+1)*10+8-(pos64v2/8);
			break;
	}
	}
	uci_interface::set_str_parameter=PARAM_FENSTRING_TRAIT;
	break;
case PARAM_FENSTRING_CASE_EP: 
		  uci_interface::fenstring_ep=0;
		  if (strcmp(uci_commande,"-")==0) 
		  { 
	 	      uci_interface::set_int_parameter=PARAM_FENSTRING_INUTILISE;		
	          uci_interface::set_str_parameter=0;
			  break;
		  }
		  uci_interface::fenstring_ep=pgn_a1_to_64(uci_commande);
 	        uci_interface::set_int_parameter=PARAM_FENSTRING_NBCOUPS;
	        uci_interface::set_str_parameter=0;
		  break;
default: break;
}

uci_interface::F_setoption=false;
// Non : relocalis dans le traitement des paramtres
// pour permettre l'enchanemnt des diffrents paramtres
//uci_interface::set_int_parameter=0;
//uci_interface::set_str_parameter=0;
} // Fin traitement paramtre

} // fin process_uci_command()




char uci_interface::get_uci_buffer(void)
{
	if (uci_interface::IOManager.InputLinesAvailable)
{
	//RETRY:
	//free((void *)uci_interface::uci_buffer);
	uci_interface::uci_buffer=uci_interface::IOManager.wait4_user_input();
	#ifdef _DEBUG
	if (uci_interface::uci_buffer.Compare("go1")==0)
	{
		uci_interface::uci_buffer="isready";
	} 
	else 
	if (uci_interface::uci_buffer.Compare("go2")==0)
	{
		uci_interface::uci_buffer="position startpos moves a2a3";
	} 
	else 
	if (uci_interface::uci_buffer.Compare("go3")==0)
	{
		uci_interface::uci_buffer="go wtime 99999999 btime 99999999";
	}
	#endif

	return 0;

}
else return -1;
} // fin get_uci_buffer




void debut(void)
{
char cc,dd;
char nn;
char F_saisie_position; // flag saisie board
char verif;
char i,j,k,l;
char uci_buffer_index;
double time, debut;
char si;
float a_developpement, b_developpement;
float a_mobilite, b_mobilite;
float a_roque, b_roque;
char num;
PIECE_SET *psptr;


// Gestion mode console ou uci
if (xconsole_mode_from_command_line) goto DEFINE_CONSOLE_MODE;
if (xuci_mode_from_command_line) goto DEFINE_UCI_MODE;
// UCI : Attente isready - Traitement des options en mode UCI
// APRES LA FIXATION STANDARD DES PARAMETRES
uci_interface::uci_buffer.Empty();
// Obtention temps de dpart
xtime=0;
debut=get_time_in_seconds();
// Dure d'attente de rception de la commande UCI = 10 secondes
uci_buffer_index=0;
//printf("\nquit pour gerer le mode uci sous la console\n");
do
{
time=get_time_in_seconds();
if (time-debut>10)
{
	uci_interface::uci_buffer="uci";
	break;
}
//printf("\nAttente mode UCI-1\n");
if ( uci_interface::get_uci_buffer()==-1) continue;
if ( strcmpi((uci_interface::uci_buffer).GetBuffer(),"uci")==0 ) break;
// mais sort plus vite du mode uci
if ( strcmpi(uci_interface::uci_buffer,"quit")==0 ) 
{  
	uci_interface::uci_buffer="uci";
	break;
}
if ( strcmpi(uci_interface::uci_buffer,"console")==0 ) break;
if ( strcmpi(uci_interface::uci_buffer,"cons")==0 ) break;
} while(1); // fin do

// Dfinition du mode CONSOLE ou UCI
if ( strcmpi(uci_interface::uci_buffer,"uci")==0 )
{
DEFINE_UCI_MODE:
xuci_mode=true;
xconsole_mode=false;
} // fin mode = UCI
else if (    strcmpi(uci_interface::uci_buffer,"console")==0 
		  || strcmpi(uci_interface::uci_buffer,"cons")==0
		 )
{
DEFINE_CONSOLE_MODE:
xuci_mode=false;
xconsole_mode=true;
uci_interface::IOManager.TerminationAsked=true;
Sleep(1000);
}


// Allocation mmoire 
// buffer UCI et liste de commande UCI
// le plus tt possible
//UCI_MODE;
//uci_interface::uci_buffer_size_in_moves=400;
//uci_interface::uci_buffer=(char (*)[])calloc(uci_interface::uci_buffer_size_in_moves,UCI_BUFFER_SIZE_OF_MOVE);
uci_interface::nombre_max_commandes=100;
//uci_interface::uci_commandes=(char (*)[][UCI_COMMAND_SIZE+1])
//	calloc(uci_interface::nombre_max_commandes,(UCI_COMMAND_SIZE+1));
uci_interface::uci_commandes=(char (*)[][UCI_COMMAND_SIZE+1])
	malloc(uci_interface::nombre_max_commandes*(UCI_COMMAND_SIZE+1));
//END_MODE;


#if DEBUG==1
// cout << "\nFin attente mode UCI\n\n"; cout.flush();
#endif


if (xconsole_mode)
{
printf("\nMove = %d",sizeof(MOVE));
printf("\nPointeur* = %d",sizeof(STATEVALUES*));
printf("\nint64 = %d",sizeof(__int64));
printf("\nint32 = %d",sizeof(__int32));
printf("\nlong = %d", sizeof(long));
printf("\nint = %d", sizeof(int));
printf("\nshort = %d", sizeof(short));
printf("\nchar = %d", sizeof(short));
printf("\nMOVE = %d",sizeof(MOVE));
printf("\nHash-rec = %d", sizeof(HASH_REC));
printf("\nHash-pawn-rec = %d", sizeof(HASH_PAWN_REC));
printf("\n\n**** Gibbon-(ex-Small-C)-");
printf("- Ultimate Chess Challenge - ");
printf( RELEASE_VERSION ); 
printf ("**************************\n");
printf ("\nLoading ...\n");
printf ("\nAvailable commands :");
printf ("\nFormat for moves is : E2E4");
printf ("\nTB : Take Back");
printf ("\nCM : Change Mode-Color");
printf ("\nA for Automatic-play, C for Control, B for white, N for black");
printf ("\nP : Force play by the program");
printf ("\nCTB or CTN : Change Time White/Black");
printf ("\n\nParameters :");

} // END_MODE


// Initialisations
// Capacit de rflexion sur le temps de l'adversaire
xenable_permanentbrain_option=PERMANENT_BRAIN; 
xpermanentbrain_is_on=false; // dsactiv par dfaut
xlastvalue1_mem_pour_reprise_immediate=0;
//xlastvalue1_wtm_pour_reprise_immediate=99;


if (xconsole_mode)
{
	xconsole_tempsmanip1=CONSOLE_TEMPS_MANIPULATION_1;
	xconsole_tempsmanip2=CONSOLE_TEMPS_MANIPULATION_2;
}
else
{
	xconsole_tempsmanip1=0;
	xconsole_tempsmanip2=0;
}


// Structure de recherche (on a besoin du level 0)
for (i=STMAX;i>=0;i--)
{
	SEARCH *sl;
	xsearch_level[i]=new SEARCH();
	sl=xsearch_level[i];
	sl->level=i;
	sl->search_level=xsearch_level[i];
	sl->F_level_impair=IMPAIR(i);
	sl->levelplus  = i+1;
	sl->levelmoins = i-1;
	sl->s=&xstates[i];
	sl->s_plus=sl->s+1;
	sl->s_moins=sl->s-1;;
	sl->bestplus=&xbest[i+1][i+1];
	sl->best=&xbest[i][i];	
	sl->ligne=&xligne[i];
	if (i>0) sl->lignemoins=&xligne[i-1];
}
// il faut attendre que les objets soient crs avant de les attribuer
for (i=0;i<=STMAX;i++)
{
	if (i<STMAX)
	{
		xsearch_level[i]->next_search_level=xsearch_level[i+1];
		if (i>=1) xsearch_level[i]->previous_search_level=xsearch_level[i-1];
	}
	else
	{
		xsearch_level[i]->next_search_level=NULL;
	}
}
// Initiaisation des pointeurs de listes de coups
for (num=0; num<=31; num++)
{
	for (i=0;i<=STMAX;i++)
	{
		psptr=&xpset[num][i];
		psptr->moves=&xw_liste_coups_piece[i][num][0]; 
		psptr->moves2=&xw_liste_coups2_piece[i][num][0]; 
	}
}

// Objet d'analyse des checs
//xcheckinstance=new checkclass();

xcurrent_hashtable_age=-1;

//xlevel_arret_extensions=0;

// Mappings pices
xmap_piece_to_flag[0]=0;
xmap_piece_to_flag['P']=1;
xmap_piece_to_flag['C']=2;
xmap_piece_to_flag['F']=3;
xmap_piece_to_flag['T']=4;
xmap_piece_to_flag['D']=5;
xmap_piece_to_flag['R']=6;

xmap_flag_to_piece[0]=0;
xmap_flag_to_piece[1]='P';
xmap_flag_to_piece[2]='C';
xmap_flag_to_piece[3]='F';
xmap_flag_to_piece[4]='T';
xmap_flag_to_piece[5]='D';
xmap_flag_to_piece[6]='R';

xmap_type_to_piece[0]='P';
xmap_type_to_piece[1]='P';
xmap_type_to_piece[2]='C';
xmap_type_to_piece[3]='C';
xmap_type_to_piece[4]='F';
xmap_type_to_piece[5]='F';
xmap_type_to_piece[6]='T';
xmap_type_to_piece[7]='T';
xmap_type_to_piece[8]='D';
xmap_type_to_piece[9]='D';
xmap_type_to_piece[10]='R';
xmap_type_to_piece[11]='R';

xmap_flag_to_capture_value[0]=0;
xmap_flag_to_capture_value[1]=VALEUR_PION;
xmap_flag_to_capture_value[2]=VALEUR_CAVALIER;
xmap_flag_to_capture_value[3]=VALEUR_FOU;
xmap_flag_to_capture_value[4]=VALEUR_TOUR;
xmap_flag_to_capture_value[5]=VALEUR_DAME;
xmap_flag_to_capture_value[6]=VALEUR_ROI;


//MoveCategory = ((unsigned __int32) (0xF))<< MoveCategory_offset;
//MovePriority = ((unsigned __int32) (0x7F))<< MovePriority_offset;
//MovePrioritySign = ((unsigned __int32)1)<<MovePrioritySign_offset;
//MoveCaptureValue = ((unsigned __int64) (0x7FF))<< MoveCaptureValue_offset;
//MoveAbsDirInd = ((unsigned __int64) 3)<< MoveAbsDirInd_offset;
//MoveDirInd = ((unsigned __int64) 7)<< MoveDirInd_offset;
//MoveDirInvInd = ((unsigned __int64) 7)<< MoveDirInvInd_offset;

// double droquement : 0
// droquement noir et roque blanc 
// droquement blanc et roque noir 
// combinaisons des deux roques 
xmasque_impact_droit_roque=(unsigned __int64) 
		(
		 ((unsigned __int64)1<<32)|((unsigned __int64)1<<39)|
		 ((unsigned __int64)1<<0) |((unsigned __int64)1<<7)|
		 ((unsigned __int64)1<<56)|((unsigned __int64)1<<63)
		 );
MoveMayImpactRoque=(unsigned __int64)1<<MoveMayImpactRoque_offset;


//xmasque_roque_non_impactable[1]=(unsigned __int64)
//		 (((unsigned __int64)1<<PAS_DE_DROIT_A_ROQUER)|
//		 ((unsigned __int64)1<<PETIT_ROQUE)|
//		 ((unsigned __int64)1<<GRAND_ROQUE);


// Initialisations xdirections
// Pices
xinc88[0]=+ 1;
xinc88[1]=+11;
xinc88[2]=+10;
xinc88[3]=+ 9;
xinc88[4]=- 1;
xinc88[5]=-11;
xinc88[6]=-10;
xinc88[7]= -9;
// Cavaliers
xinc88[8]= 12;
xinc88[9]= 21;
xinc88[10]= 19;
xinc88[11]=  8;
xinc88[12]=-12;
xinc88[13]=-21;
xinc88[14]=-19;
xinc88[15]= -8;


// Incrments 64 de direction
// Pices
xinc64[0]=+1;
xinc64[1]=+9;
xinc64[2]=+8;
xinc64[3]=+7;
xinc64[4]=-1;
xinc64[5]=-9;
xinc64[6]=-8; 
xinc64[7]=-7;
// Cavaliers 
xinc64[8]= 10;
xinc64[9]= 17;
xinc64[10]= 15;
xinc64[11]=  6;
xinc64[12]=-10;
xinc64[13]=-17;
xinc64[14]=-15;
xinc64[15]= -6;



// Incrments 128 de direction
// Pices
xinc128[0]=+1;
xinc128[1]=+9+8;
xinc128[2]=+8+8;
xinc128[3]=+7+8;
xinc128[4]=-1;
xinc128[5]=-9-8;
xinc128[6]=-8-8; 
xinc128[7]=-7-8;
// Cavaliers 
xinc128[8]=+10+8;
xinc128[9]=+17+16;
xinc128[10]=+15+16;
xinc128[11]=+6+8;
xinc128[12]=-10-8;
xinc128[13]=-17-16;
xinc128[14]=-15-16;
xinc128[15]= -6-8;


// Rcupration de l'indice d'incrment (directions de cavalier)
// et directions normales
for(i=0;i<=15;i++)
{
xindice_from_inc64[xinc64[i]+17]=i;
}


// xdirections64_from64_to64
// et autres
// i=from, j=to
for (i=63;i>=0;i--)
{
for (j=63;j>=0;j--)
{
if (i==j)
{
	xdirections64_from64_to64[i][j]=-1;
	xinc64_from64_to64[i][j]=0;
	xdistance_from64_to64[i][j]=0;
	continue;
}
l=DISTANCE_FROM64_V2(i,j); 
k=(j-i)/l; // incrment

// Initialisations
xinc64_from64_to64[i][j]=k;
xdistance_from64_to64[i][j]=l;

if (    DIAG64_1(i)!=DIAG64_1(j)
	 && DIAG64_2(i)!=DIAG64_2(j)
	 && X64(i)!=X64(j)
	 && Y64(i)!=Y64(j)
	 )
{
	// Direction de cavalier 
	if (MOVE_IS_OK_KNIGHT(i,j))
	{
		xinc64_from64_to64[i][j]=j-i;
		xdirections64_from64_to64[i][j]=INDICE_INC64(j-i);
	}
	else // Coups inexistants
	{
		xdirections64_from64_to64[i][j]=-1;
		xinc64_from64_to64[i][j]=99;
	}
	continue;
}
si=-1;
switch(k)
{
case 1: si=0; break;
case 9: si=1; break;
case 8: si=2; break;
case 7: si=3; break;
case -1 : si=4; break;
case -9 : si=5; break;
case -8 : si=6; break;
case -7 : si=7; break;
}
xdirections64_from64_to64[i][j]=si;
}
}

// Initialisation des bitboards
init_bitboards_and_others();

// Tests des macros
#if DEBUG==1
for (i=11;i<=88;i++)
{
	si=X88(i);
	if (si!=i/10)  
		log_error("\nErr I_814");
	
	si=Y88(i);
	if (si!=i%10)  
		log_error("\nErr I_814");
		
}

for (i=63;i>=0;i--)
{
	si=TO88(i);
	j=TO64(si);
	if (i!=j) 
		log_error("\nErr I_814");
}
#endif




// Initialisation xwnull
// ( utile car les cases pointent sur xwnull 
//   et attendent 99 comme numro de pice )
xwnull.color=0;
xwnull.color01=0;
xwnull.num_piece=99;
xwnull.nature=0;
//xwnull.code=99;
//xwull.code2=99;

xwnull.type=99;

// Initialisation xempty_listlevel_entry
xempty_listlevel_entry.Fplay=0;
xempty_listlevel_entry.move=NULL;
xempty_listlevel_entry.hash=HASH_NON_DETERMINE;
xempty_listlevel_entry.score=-MAX_VALUE;
xempty_listlevel_entry.wasbest=false;
xempty_listlevel_entry.priority=0;
xempty_listlevel_entry.h.address=0;
xempty_listlevel_entry.h.key=0;
xempty_listlevel_entry.hscore=-MAX_VALUE+1;
xempty_listlevel_entry.hmove=0;
xempty_listlevel_entry.givecheck=CHECK_NOT_DETERMINED; // par dfaut
xempty_listlevel_entry.draw_status=DRAW_STATUS_NOT_DETERMINED;
xempty_listlevel_entry.hscore_status=HASH_NON_DETERMINE;
xempty_listlevel_entry.hscore=-MAX_VALUE;
//xempty_listlevel_entry.bilan_coup=BILAN_NON_CALCULE;


//xnumber_of_threads=DEFAULT_NUMBER_OF_THREADS;


for (i=0;i<=sizeof(xligne)/sizeof(xligne[0])-1;i++)
	xligne[i]=0;

for (i=0;i<=sizeof(xkeep)/sizeof(xkeep[0])-1;i++)
{
	xkeep[i]=0;
}

for (i=0;i<=sizeof(xbest)/sizeof(xbest[0])-1;i++)
{
for (j=0;j<=sizeof(xbest[0])/sizeof(xbest[0][0])-1;j++)
{
	xbest[i][j]=0;
}
}

for (i=0;i<=sizeof(xtablexx)/sizeof(xtablexx[0])-1;i++)
{xtablexx[i]=0;}

MOVE_ITERATOR::init_tableau();

// Reset statistiques bibliotheque d'ouverture
if (xreset_book_stats)
{
reset_book_stats();
}


// Paramtrage xcps et xlastdepth 
// xcps recalcul en premier retour pour xlevel==1 et *depth==3
xcps=500000; // Valeur volontairement leve
xlastdepth[0]=1;
xlastdepth[1]=1;


// Taille de la liste de coups
// 7780 coups rls 
// nouvelle taille 10180-10200 donc 7780 coups rels
xmaxlistmoves=10200; 
// Allocation mmoire liste de coups
//xlc=(MOVE *)calloc((short)xmaxlistmoves,sizeof(MOVE));
xlc=(MOVE *)malloc((short)xmaxlistmoves*sizeof(MOVE));
if (xlc==NULL)
{
log_error("\nErreur I_001");
}

// Allocation mmoire pour la liste de la partie
xmaxnbcoups=GAME_MAX_NBCOUPS;
//xpartie=(ENREGISTREMENT *)calloc(xmaxnbcoups+2,sizeof(ENREGISTREMENT));
xpartie=(ENREGISTREMENT *)malloc((xmaxnbcoups+2)*sizeof(ENREGISTREMENT));
//+1 car on commence en xpartie[1] c'est important
if (xpartie==NULL)
{
log_error("\nErreur I_101");
}



// Makeposvalue et init_board sont galement relancs dans init()
// mais sont ncessaires pour make_struct_moves
// Les deux rinitialisent aussi dans init (par exemple cptr->wptr)
// Gnration des tables de valeurs
// makeposvalue(); // prmatur : la position des rois n'est pas encore connue
// Gnration chiquier
init_board();
// Gnration de la structure de coups
// Rem : les tables de valeur et l'chiquier sont utilises
// mais il faudra revoir la valeur des priorits
make_struct_moves(); 


// Initialisation des paramtres de hash tables
xhash_table=NULL;
xhash_pawn_table=NULL;
xhash_size=DEFAULT_HASH_SIZE;
xpawn_hash_size=PAWN_HASH_SIZE;


// Modification des options en mode UCI
// aprs l'allocation des hash_tables
// - les hash tables sont alloues sur la commande UCI pour leur 
//   valeur par dfaut
// - on peut les modifier avant ou aprs le isready
UCI_MODE;
cout << "id name " << RELEASE_VERSION << "\n"; cout.flush();
cout << "id author Eric Marathe\n"; cout.flush();
// Fixation des options et uciok 
#if PERMANENT_BRAIN==1 
	cout << "option name Ponder type check default false\n";
	cout.flush();
#endif
#if ENABLE_SOUND==1
	cout << "option name Sound type check default true\n";
#endif
#if USE_HASH_TABLE==1
	cout << "option name Hash type spin default "
		 << DEFAULT_HASH_SIZE
		 << " min 0 max " 
		 << MAX_HASH_SIZE << "\n";
	cout.flush();
#else 
	cout << "option name Hash type spin default 0 min 0 max 0\n";
	cout.flush();
#endif
#if USE_OPENING_BOOK==1
	cout << "option name Ownbook type check default true\n";
	cout.flush();
#endif

cout << "option name Allow_5_seconds_to_play_moves_on_real_bord type check default false\n";
cout << "uciok\n"; 
cout.flush();

/*
cout << "option name Number_of_threads type spin default " << DEFAULT_NUMBER_OF_THREADS;
cout << " min " << MIN_NUMBER_OF_THREADS;
cout << " max " << MAX_NUMBER_OF_THREADS << "\n";
*/



do 
{
Sleep(1);
uci_interface::get_uci_buffer();
if ( strcmpi(uci_interface::uci_buffer,"isready")==0 ) 
{
	// la fonction purge en effet le buffer
	uci_interface::process_uci_buffer(0);
    break;
}
else uci_interface::process_uci_buffer(0); // pour les options
}
while(1);
END_MODE;


// Cration des hash tables (une seule fois)
// aprs le readyok (la taille des hash tables est donne avant)
if (xhash_table==NULL)
{
	set_hash_tables(xhash_size,xpawn_hash_size);
}

xfischer_add[0]=DEFAULT_FISCHER_ADDITIONAL_TIME_SECONDS;
xfischer_add[1]=DEFAULT_FISCHER_ADDITIONAL_TIME_SECONDS;
#if COLLECT_STATS==1
for (i=0; i<=sizeof(xlevel_hits)/sizeof(xlevel_hits)-1; i++)
		 xlevel_hits[i]=0;
xratio[1]=xratio[0]=20;
#endif
xtimecumul[0]=xtimecumul[1]=0;
#if ALLOW_FOR_CONTEMPT==1 
xcontempt=CONTEMPT;
#endif
xuse_book_stats=(bool)USE_BOOK_STATS;
xenable_book_learning=(bool)ENABLE_BOOK_LEARNING;
xreset_book_stats=(bool)RESET_BOOK_STATS;
xtimer_fixed_time_per_move=(TIMER_ON_FIXED_GAME_LENGTH_MINUTES*60)/50;
xbook_default_stat=BOOK_DEFAULT_STAT;
xdepthmax_struct=DEPTHMAX_STRUCT;
xpourcentage_temps_de_base=POURCENTAGE_TEMPS_DE_BASE;
xresigns=false;
// Explication 
// Au levelmax, on peut trouver la rponse dans les hash_tables
// Dans ce cas la ligne est complte par le coup trouv dans les hash tables
// plus le code de fin de ligne, ce qui reprsente +2 par rapport  DEPTHMAX
if (xdepthmax_struct>STMAX-2) xdepthmax_struct=STMAX-2;
if (xdepthmax_struct<0) xdepthmax_struct=0;
#if ALLOW_EXTEND_PASSE==1
xextend12=false;
xextend12_level=0;
xextend11=false;
xextend11_level=0;
#endif
#if ALLOW_VERIFIED_NULLMOVE==1
xlevel_verified_nullmove=0;
#endif

#if TIMER_ON==1
xF_timer_on=true; 
#else
xF_timer_on=false;
#endif
#if TIMER_ON_MODE==1
xTIMER_ON_MODE=1; 
#else
xF_TIMER_ON_MODE=false;
#endif
xF_uci_temps_manipulation=false;
xtimer_off_number_of_nodes=TIMER_OFF_NUMBER_OF_NODES;
xenable_sound=ENABLE_SOUND;
//xprofondeur_avant_elagages_blanc=PROFONDEUR_AVANT_ELAGAGES_BLANC;
//xprofondeur_avant_elagages_noir=PROFONDEUR_AVANT_ELAGAGES_NOIR;
// Calcul des paramtres f(x)=ax+b
// pour modulation developpemnt et mobilit ( voir val )
a_developpement = (float)
		100/(DEVELOPPEMENT_NBCOUPS_A-DEVELOPPEMENT_NBCOUPS_B);
b_developpement = 100 - a_developpement*DEVELOPPEMENT_NBCOUPS_A;
a_roque = (float)
		100/(ROQUE_NBCOUPS_A-ROQUE_NBCOUPS_B);
b_roque = 100 - a_roque*ROQUE_NBCOUPS_A;
a_mobilite = (float) (100-MOBILITE_POURCENTAGE_INITIAL)/(MOBILITE_NBCOUPS_B);
b_mobilite = MOBILITE_POURCENTAGE_INITIAL;

for (i=0;i<=DEVELOPPEMENT_NBCOUPS_B;i++)
{
	// dgressif de 100  0
	// f(x) = ax + b
	xmodulation_developpement[i]=
		 a_developpement*i  + b_developpement;
	if (i<=DEVELOPPEMENT_NBCOUPS_A) 
	{
		xmodulation_developpement[i]=100;
	}
}
for (i=0;i<=MOBILITE_NBCOUPS_B;i++)
{
	// progressif, de mobilite initiale  100
	// f(x) = ax + b
	xmodulation_mobilite[i] =
		 a_mobilite*i + b_mobilite;
}
#if MODULATION_ROQUE==1
for (i=0;i<=ROQUE_NBCOUPS_B;i++)
{
	// dgressif de 100  0
	// f(x) = ax + b
	xmodulation_droit_roque[i]=
		 a_roque*i  + b_roque;
	if (i<=ROQUE_NBCOUPS_A) xmodulation_droit_roque[i]=100;
}
#endif



// Initialiser xopeningbook
xopeningbook_allowed=USE_OPENING_BOOK; // doit figurer dans debut pour read_bib et init pour take_back
xopeningbook_in_use=xopeningbook_allowed; // par dfaut
xlast_opening_move_used=0; // dans debut, pas dans init
xopening_selection_size=OPENING_BOOK_SELECTION_SIZE;
xchoose_random_opening=CHOOSE_RANDOM_OPENING;
xchoose_first_opening=CHOOSE_FIRST_OPENING;
xchoose_best_opening=CHOOSE_BEST_OPENING;
// Contrle cohrence des paramtres
if (xchoose_best_opening)
{ 
xchoose_random_opening=false; 
xchoose_first_opening=false;
}
else 
{
if (xchoose_random_opening) xchoose_first_opening=false;
else xchoose_first_opening=true;
}






// Ouverture flux d'erreur
#if LOG_CRITICAL_ERRORS_TO_FILE==1 || LOG_MOVES==1
struct stat stat_struct;
// tronquer le fichierlog si taille dpasse 100K
cc=stat(ERROR_LOG_FILENAME, &stat_struct);
if ( cc==1 && stat_struct.st_size/1024/100>1 ) 
{ 
	xhandle_logfile=open(ERROR_LOG_FILENAME,O_WRONLY | O_CREAT | O_BINARY | O_TRUNC, S_IREAD | S_IWRITE);
	close(xhandle_logfile);
}
if ((xhandle_logfile=open(ERROR_LOG_FILENAME,O_WRONLY | O_CREAT | O_BINARY | O_APPEND, S_IREAD | S_IWRITE )) == -1)
{
log_error("\nErreur P_925 : Impossible d'ouvrir fichier log!");
} 
write(xhandle_logfile,"\nNouvelle Partie\n", (unsigned int)strlen("\nNouvelle partie\n"));
#endif




// Chargement de la bibiothque d'ouverture
// Allocation d'espace pour la bibliothque d'ouverture
// Lecture de la bibiothque d'ouverture
if (xopeningbook_in_use)
{
#if USE_BOOK_TRANSPOSITIONS==1
// Cration du tableau xbibliotheque_xx[xbibliotheque_nb_games][OPENING_BOOK_LENGTH]
// On commence par allouer 100 parties
xbibliotheque_nb_games_allocated=100;
//xbibliotheque_88=(ENTREE_BIBLIOTHEQUE_88 (*)[OPENING_BOOK_LENGTH+1])calloc(xbibliotheque_nb_games_allocated,
//					(OPENING_BOOK_LENGTH+1)*sizeof(ENTREE_BIBLIOTHEQUE_88));
xbibliotheque_88=(ENTREE_BIBLIOTHEQUE_88 (*)[OPENING_BOOK_LENGTH+1])malloc(xbibliotheque_nb_games_allocated*
					(OPENING_BOOK_LENGTH+1)*sizeof(ENTREE_BIBLIOTHEQUE_88));
#endif
read_bibliotheque(1);
}

// Initialisation gnrateur coup alatoires
// Dans tous les cas sauf xchoose_best_opening
xtime=get_time_in_seconds();
srand((unsigned int)xtime);


// Conversation utilisateur
// Double while
do // Boucle de vrification
{
verif=0;
nn='N';
while (nn!='O')
{

// Initialisations par dfaut
CONSOLE_MODE;
xmode='B';
END_MODE;
UCI_MODE;
xmode='C'; // Sinon on part immdiatement en search !
END_MODE;


// Pas de position  rentrer par dfaut
F_saisie_position=false;

// Position de dpart standard par dfaut
xF_start_from_standard_position=true;

// Trait par dfaut
xtrait=1;
xwtm=1;

// Temps par dfaut ( 1 minutes )
xavailable_time[1]=1*60L;
xavailable_time[0]=1*60L;


// Valeurs par dfauts paramtres d'affichage
xstop=0;
xstop3=0;
xstop4=0;
xlstop=0;

// Nom du fichier de position par dfaut
strcpy(xnom_pos,"chessbd.pos");
	
// Nom du fichier de partie par dfaut
strcpy(xnom_game,"Chess.pgn");


// Affichage paramtres par dfaut	
if (xconsole_mode)
{
printf("\nWhite to move");
printf("\nSame time for white and black");
printf("\nNo stop between moves");
printf("\nTime credit for manipulator to play computer moves (sec.) : %d",xconsole_tempsmanip1);
printf("\nTime credit for manipulator to input moves (sec.) : %d",xconsole_tempsmanip2);
printf("\nFischer time credit (sec.) : %d",xfischer_add[0]);
printf("\nRegister game to \"Chess.gam\"");
printf("\nContempt factor = 0");

if (xpermanentbrain_is_on)
{
printf("\nThinking on opponent time : Yes");
}
else
{
printf("\nThinking on opponent time : No");
}
printf("\nComputer plays white");
printf("\nWhite and black have castling rights");
printf("\nStart position in chessbd.pos (default)");


// Gestion problme interface CIOManager
// il fait faire un enter supplmentaire (pour une cause inconnue)
printf("\nPress <Enter><Enter> to continue");
getch();


printf("\nDo you accept following parameters (Y/n) : ");
cc=getON("ONY");

if (cc=='N')
{
// Remplacement des paramtres par dfaut


printf("\nTime for white (minutes) : ");
xavailable_time[1]=getlong(4);
xavailable_time[1]=xavailable_time[1]*60L;
printf("\nTime for black (minutes) : ");
xavailable_time[0]=getlong(3);
xavailable_time[0]=xavailable_time[0]*60L;

printf("\nTime credit to play moves (sec.) : ");
xconsole_tempsmanip1=(char)getlong(3);

printf("\nTime credit to input moves (sec.) : ");
xconsole_tempsmanip2=(char)getlong(3);

printf("\nFischer time credit (sec.) : ");
xfischer_add[0]=(short) getlong(3);
xfischer_add[1]=xfischer_add[0];

#if ALLOW_FOR_CONTEMPT==1
printf("\nContempt factor (1 pawn = 100 - if not choose 0) : ");
xcontempt=getlong(5);
#endif

#if DEBUG==1
xstopm=0;
printf("\nStop at move number (else 0) : ");
xstopm=getlong(10);
#endif

if (xenable_permanentbrain_option)
{
printf("\nThinking on opponent time (y/N) : ");
cc=getON("YON");
if (cc=='O' || cc=='Y') xpermanentbrain_is_on=true; 
else xpermanentbrain_is_on=false;
}

/* A CONSERVER
printf("\nFile game name : ");
getstring(xnom_game,8);
putsuffixe(xnom_game,'p','g','n');
*/

/*
printf("\nLe programme doit-il fonctionner sans Ansi.sys (y/n)-  Rpondre oui : ");
cc=getON("ONY");
if (cc=='O' || cc=='Y') xansi=false; else xansi=true;
*/

printf("\nDisplay tree (y/N) : ");
cc=getON("ONY");
if (cc=='O' || cc=='Y') xstop3=true; 
else xstop3=false;

printf("\nStop between nodes (y/N) : ");
cc=getON("ONY");
if (cc=='O' || cc=='Y') {xstop=true; xstop3=true;}
else xstop=false;



printf("\nDo you want to enter a position (y/N) : ");
cc=getON("ONY");
if (cc=='O' || cc=='Y') F_saisie_position=true; else F_saisie_position=false;


printf("\nStart from standard position (Y/n) : ");
cc=getON("ONY");
if (cc=='O' || cc=='Y') xF_start_from_standard_position=true; 
else 
{
xF_start_from_standard_position=false;
xopeningbook_in_use=false;
}


// Saisir les paramtres spcifiques de position si position non standard
if (!xF_start_from_standard_position)
{
printf("\nSide to play - W=white=blanc B=black=noir : ");
cc=getON("WB");
if (cc=='W') xtrait=1;
else		 xtrait=0;


// Initialisation roques
xstates[0].droit_roque[0]=0;
xstates[0].droit_roque[1]=0;

printf("\n\nWhite can castle short (y/n) : ");
cc=getON("ONY");
if (cc=='O' || cc=='Y') maj_droit_roque(xstates[0].droit_roque[1],ATTRIBUTION_DROIT_PETIT_ROQUE);

printf("\nWhite can castle long (y/n) : ");
cc=getON("ONY");
if (cc=='O' || cc=='Y') maj_droit_roque(xstates[0].droit_roque[1],ATTRIBUTION_DROIT_GRAND_ROQUE);

printf("\nBlack can castle short (y/n) : ");
cc=getON("ONY");
if (cc=='O' || cc=='Y') maj_droit_roque(xstates[0].droit_roque[0],ATTRIBUTION_DROIT_PETIT_ROQUE);

printf("\nBlack can castle long (y/n) : ");
cc=getON("ONY");
maj_droit_roque(xstates[0].droit_roque[0],ATTRIBUTION_DROIT_GRAND_ROQUE);


// Maj roque et code_roque
//xstates[0].droit_roque[0]=xstates[0].o_o_o[0]+xstates[0].o_o[0];
//xstates[0].droit_roque[1]=xstates[0].o_o_o[1]+xstates[0].o_o[1];
//xstates[0].code_roque=xstates[0].droit_roque[1]|(xstates[0].droit_roque[0]*10);


printf("\nWhat is the filename to read ");
printf("\n(Give \"chessbd\" without quotes");
printf("\n for standard start position)  : ");
getstring(xnom_pos,20);
putsuffixe(xnom_pos,'p','o','s');

} // fin saisie des paramtres non standards

} // Fin redfinition des paramtres



else // Paramtres accepts
{
#if DEBUG!=0
xstopm=false;
#endif
printf("\nTime credit for each player (minutes) : ");
xavailable_time[1]=getlong(3);
xavailable_time[1]=xavailable_time[1]*60L;
xavailable_time[0]=xavailable_time[1];
} // fin paramtres accepts


printf("\nAutoplay (y/n) : ");
cc=getON("ONY");
if (cc=='N')
{
printf("\nComputer is w(White), b(Black) or c(Control) : ");
cc=getON("WBC");
xmode=cc;
// if (xmode=='C') xpeermanentbrain=false;
}
else
{
xmode='A';
xconsole_tempsmanip1 = 1L; 
xconsole_tempsmanip2 = 0L;
}

printf("\nStop when back to level 1 (y/N) : ");
cc=getON("ONY");
if (cc=='O' || cc=='Y') {xstop4=true;xlstop=0;} 
else {xstop4=false;xlstop=0;}


printf("\nPause between played moves (y/N) : ");
cc=getON("ONY");
if (cc=='N') xstop2=false; else xstop2=true;

printf("\n\nHash table size : %d Mbytes", xhash_tab_entries*xhash_tab_entry_size/1048576);
printf("\nAre you OK with parameters (Y/n) : ");
nn=getON("ONY"); if (nn=='Y') nn='O';

printf("\n\n");

} // END_MODE // fin saisie console des paramtres

// Initialisations spcifiques au mode UCI 
if (xuci_mode)
{
break; 
} // END_MODE

} // fin while(nn!='O')

printf("\n\n\n");



/* Paramtrage initial de la profondeur de rflexion */
for (j=0;j<=1;j++)
{
i=3;
if (xavailable_time[j]/60L <= 5) /* moins de 5 minutes */
{
xdepth_average[0]=30;
xdepth_average[1]=30;
}
if (xavailable_time[j]/60L > 5) /* plus de 5 minutes */
{
xdepth_average[0]=40;
xdepth_average[1]=40;
}
if (xavailable_time[j]/60L > 10) /* plus de 10 minutes */
{
xdepth_average[0]=44;
xdepth_average[1]=44;
}
if (xavailable_time[j]/60L >= 20) /* plus de 20 minutes */
{
xdepth_average[0]=50;
xdepth_average[1]=50;
}
}


// Ouverture du fichier de sauvegarde-partie
if ((xhandle=open(xnom_game, O_WRONLY | O_CREAT | O_BINARY | O_TRUNC,
S_IREAD | S_IWRITE)) == -1)
{
log_error("\nErr I_007 - Fichier inexistant\n!");
}


#if HASHTRACE==1
// Ouverture du fichier de trace hash
if ((xhandle2=open("Hash.tra", O_WRONLY | O_CREAT | O_BINARY | O_TRUNC,
S_IREAD | S_IWRITE)) == -1)
{
log_error("\nErr I_017 - Fichier inexistant\n!");
}
#endif


// Saisie d'une position en mode console
CONSOLE_MODE;
if (F_saisie_position)
{
printf("\nEmpty square : EE(Empty) or VV(vide)");
printf("\nPawn=P - Knight=N - Rook=R - Queen=Q - King=K");
printf("\nWhite=W - Black=B");
printf("\nExemple : black pawn=BP");
saisie_board();
}
END_MODE;

// Vrification - initialisation
verif=true; // si erreur : verif=false;

CONSOLE_MODE;
// Obtention des pices
cc=get_board(xnom_pos);
if (cc==0)
{
if ( xenable_sound ) printf("\a");
printf("\nBoard problem");
verif=false;
continue;
}

// Phase d'initialisation (plus de dialogue)
cc=init();
if (cc==0)
{
log_error("\nInitialisation problem");
verif=false;
continue;
}

// Vrifications (prsence des rois)
cc=0;
for (i=0; i<=xw_size[1];i++)
{
if (IS_KING(&xw[i])) cc++;
}
dd=0;
for (i=16; i<=xw_size[0];i++)
{
if (IS_KING(&xw[i])) dd++;
}
if (cc!=1 || dd!=1)
{
log_error("\nError king count");
verif=false;
continue;
}

// Distance entre les rois
xp=X64(xw[xnum_roi[0]].pos);
xq=Y64(xw[xnum_roi[0]].pos);
xr=X64(xw[xnum_roi[1]].pos);
xs=Y64(xw[xnum_roi[1]].pos);
cc=abs(xp-xr);
dd=abs(xq-xs);
if (cc<=1 && dd<=1)
{
log_error("\nError king position");
verif=false;
}

// Absence de pions sur la premire et la dernire range
cc=0;
for (i=31; i>=0;i--)
{
if (xw[i].nature!='P') continue;
if (Y64(xw[i].pos)!=0 && Y64(xw[i].pos)!=7) continue;
log_error("\nI_589");
verif=false;
continue;
}
// fin mode console
END_MODE;

// Conclusion vrification
} while (verif!=1);



} // fin debut




void ajustement_parametres_globaux(void)
{
char finale;
STATEVALUES *s;

// Initialisations
xsearch_level[0]->maj_indicateur_finale();
s=&xstates[0];
finale=s->finale;

#if DEBUG==1
char i,nature;
short int si1, si2;
PIECE *wptr;
si1=si2=0;
wptr=&xw[31];
for (i=31; i>=0; i--,wptr--)
{
nature=wptr->nature;
if (nature==0) continue;
if (nature=='R') continue; // roi exclu de matriel pices
if (nature=='P') continue;

// si1 et si2 tous deux positifs
if (i<16) si1+=wptr->value;
else      si2-=wptr->value;
}
// Contrle xstates[0].materiel_pieces
if ( si1!=xstates[0].materiel_pieces[1] || si2!=xstates[0].materiel_pieces[0] )
{
log_error("\nErreur I_150");
}
#endif


// Rvision valeur des pions pour grand_roque
if ( (    (parametres_globaux::xF_roi_posx_mem[0]!=s->roi_posx[0])
	   || (parametres_globaux::xF_roi_posx_mem[1]!=s->roi_posx[1])
	 )
     && !parametres_globaux::xF_make_posval_finale 
   )
{
makeposvalue(); // dtermine les nouvelles valeurs de cases
xboard_posvalue(); // stocke les valeurs dans xboard
// Actualisation des priorits des coups 
recompute_move_priorities(); 
// Prise en compte des nouvelles posvalues des pices
xlv1_wtm=xwtm; // pour searchmove
// Ractualisation car modification des paramtres de valeur de position
xsearch_level[0]->actualise_all(); //check=xsearch_level[xlevel].check;
// Actualisation des variables mmoire
parametres_globaux::xF_roi_posx_mem[0]=s->roi_posx[0];
parametres_globaux::xF_roi_posx_mem[1]=s->roi_posx[1];
// Recopie au niveau suprieur 
// ( car la copie a dja t faite prcdemment et il convient de la refaire )
xstates[1].position=xstates[0].position;  
}


// Revision valeur position des pions
if ( (finale>0 || xnbcoups>=80) 
	&& !parametres_globaux::xF_make_posval_finale )
{
parametres_globaux::xF_make_posval_finale=true;
makeposvalue_finale(); // dtermine les nouvelles valeurs de cases
xboard_posvalue(); // stocke les valeurs dans xboard
// Actualisation des priorits des coups 
recompute_move_priorities(); 
// Prise en compte des nouvelles posvalues
xlv1_wtm=xwtm; // pour searchmove
xsearch_level[0]->actualise_all(); // check=xsearch_level[0].check;
// Recopie au niveau suprieur 
// ( car la copie a dja t faite prcdemment et il convient de la refaire )
xstates[1].position=xstates[0].position;  
}


// Vrification xmateriel
#if DEBUG==0
// En mode reset si DEBUG==0
xsearch_level[0]->check_reset_state_values(0,1);
#endif
#if DEBUG==1 
if ( xconsole_mode )
{
	xsearch_level[0]->check_reset_state_values(0,0);
}
#endif

} // fin ajustements_parametres_globaux


char init(void)
{
// char a;
// char cc;
char i;
char j,k;
char m,n;
char board[SIZE_OF_BOARD_88];
char dep, arr;
char color01;
char num;


// Initialisations
xpourcentage_temps_de_base=POURCENTAGE_TEMPS_DE_BASE;
xlastvalue0=0;
//xlastvaluemat0=0;
//xF_lastvalue1_recapture_prevue=false;
//xlastvaluemat1=0;
xouverture=false; // Ligne bibliothque d'ouverture !
xlastprise1=0;
xstates[0].lastprise2=0;
xstates[1].lastprise2=0;
xcptlignes=0; // lignes d'aff. du meilleur coup courant
F_lastmove_was_onlymove=false;
xopeningbook_in_use=xopeningbook_allowed;
// Ne pas rinitialiser ce dernier paramtre
// xopeningbook_has_been_used=false; 
#if USE_FRUIT_PRUNING==1
#if USE_FRUIT_PRUNING_PERCENTAGE==1
xfruit_pruning_adjustable_hit_ratio_threshold=33;
#endif
#endif

long xhash_first_part_hits=0;
long xhash_second_part_hits=0;
long xpawnhash_first_part_hits=0;
long xpawnhash_second_part_hits=0;


xpasse=false;
parametres_globaux::xF_make_posval_finale=false;
parametres_globaux::xF_roi_posx_mem[0]=0;
parametres_globaux::xF_roi_posx_mem[1]=0;


// Gnration chiquier 
init_board();

// Droits  roquer
// xstates[0].o_o[1]	= 1;  
// xstates[0].o_o_o[1] = 2;
// xstates[0].o_o[0]	= 1;
// xstates[0].o_o_o[0] = 2;
// Maj roque et code_roque
//xstates[0].droit_roque[0]=xstates[0].o_o_o[0]+xstates[0].o_o[0];
//xstates[0].droit_roque[1]=xstates[0].o_o_o[1]+xstates[0].o_o[1];
xstates[0].droit_roque[0]=DROIT_PETIT_ROQUE|DROIT_GRAND_ROQUE;
xstates[0].droit_roque[1]=DROIT_PETIT_ROQUE|DROIT_GRAND_ROQUE;
// xstates[0].code_roque=xstates[0].droit_roque[1]|(xstates[0].droit_roque[0]*10);

// xroqueini est initialis dans pose_pieces
//xroqueini[1][0]	= 1;  
//xroqueini[1][1] = 2;
//xroqueini[0][0]	= 1;
//xroqueini[0][1] = 2;


// Gnration des pices

// Tours
// Rserves aux numros de pices 0,17,14,31
// Attention : il faut donc rinitialiser xw[i].nature
// Rois : pices 8 et 25
for (i=31;i>=0;i--) xw[i].nature=0;
for (i=88;i>=0;i--) board[i]=xxboard_original_french[i];
if (board[51]=='R')
{
makepiece(32,8,1);
board[51]=0;
}
else { xstates[0].droit_roque[1]=0; /*xstates[0].o_o[1]=0; xstates[0].o_o_o[1]=0;*/ }
if (-board[58]=='R')
{
makepiece(TO64(58),25,-1);
board[58]=0;
}
else { xstates[0].droit_roque[0]=0; /*xstates[0].o_o[0]=0; xstates[0].o_o_o[0]=0;*/ }

if (board[11] =='T')
{
makepiece(TO64(11),0,1);
board[11]=0;
}
else maj_droit_roque(xstates[0].droit_roque[1],PERTE_DROIT_GRAND_ROQUE); // xstates[0].o_o_o[1]=0;
if (-board[18] =='T')
{
makepiece(TO64(18),17,-1);
board[18]=0;
}
else maj_droit_roque(xstates[0].droit_roque[0],PERTE_DROIT_GRAND_ROQUE); // xstates[0].o_o_o[0]=0;
if ( board[81]=='T')
{
makepiece(TO64(81),14,1);
board[81]=0;
}
else maj_droit_roque(xstates[0].droit_roque[1],PERTE_DROIT_PETIT_ROQUE); // xstates[0].o_o[1]=0;
if (-board[88]=='T')
{
makepiece(TO64(88),31,-1);
board[88]=0;
}
else maj_droit_roque(xstates[0].droit_roque[0],PERTE_DROIT_PETIT_ROQUE); // xstates[0].o_o[0]=0;

// Maj roque et code_roque
// xstates[0].droit_roque[0]=xstates[0].o_o_o[0]+xstates[0].o_o[0];
// xstates[0].droit_roque[1]=xstates[0].o_o_o[1]+xstates[0].o_o[1];
// xstates[0].code_roque=xstates[0].droit_roque[1]|(xstates[0].droit_roque[0]+10);


m=n=0;
j=-1;k=15;
for (i=11;i<=88;i++)
{
if (board[i]!=0)
{
//attribution d'un numro de pice
//dtermination du paramtre numro de pice
if (board[i]>0)
{
m++;j++;
if (xw[j].nature!=0) {j++;m++;} // Pice dja attribue ( roi ou tour )
if (m>16) return(0); // max 16 pices
makepiece(TO64(i),j,1);
}
else // (board[i]<0)
{
n++;k++;
if (xw[k].nature!=0) {k++;n++;} // Pice dja attribue ( roi ou tour )
if (n>16) return(0);
makepiece(TO64(i),k,-1);
}
} // fin if diffrent de vide
} // fin for



// Initialisation des valeurs de position
genere_xw(); 
// Initialisation de l'chiquier
pose_pieces();

// Ajustement des paramtres globaux
ajustement_parametres_globaux();


// Initialisation xlastmove (aprs la pose des pices)
// Remarque : aprs la pose des pices, il n'y a pas forcment 
// d'autres coups, en particuler si fenstrings, c'est donc logique
xlastmove=0;

if (uci_interface::fenstring_ep!=0)
{
		dep=(char) uci_interface::fenstring_ep+1*(2*xtrait-1);
		arr=(char) uci_interface::fenstring_ep-1*(2*xtrait-1);
		num=xboard[arr].num_piece;
		color01=xboard[dep].color01;
		xsearch_level[xlevel+1]->ep_square64=TO64(arr)-TO_COLOR(color01);
        //xlastmove=MOVE_MAKE(num,'P',color01,TO64(dep),TO64(arr),0,0,0); // le coup lui-mme n'est pas en passant !
		//xlastmove=MOVE_MAKE(xboard[dep].nature,color01,TO64(dep),TO64(arr),0,0); // le coup lui-mme n'est pas en passant !
		xlastmove=MOVE_MAKE(xboard[dep].nature,TO64(dep),TO64(arr),0,0); // le coup lui-mme n'est pas en passant !
}



// Maj roque et code_roque
// xstates[0].droit_roque[0]=xstates[0].o_o_o[0]+xstates[0].o_o[0];
// xstates[0].droit_roque[1]=xstates[0].o_o_o[1]+xstates[0].o_o[1];
// xstates[0].code_roque=xstates[0].droit_roque[1]|(xstates[0].droit_roque[0]+10);


//  Initialisation xliste50
xliste50[0]=gen_code(0);
// xliste50[0]=MOVE_MAKE(0,0,0,0);
// Le coup prcdent et non enregistr a la couleur oppose au trait


#if CHECK_REPET==1
#if DEBUG==1
char *ptr;
PIECE *wptr2;
char ci;
// Copie de la position - rgle des 50 coups
ptr=&xpositions[0][0];
wptr2=&xw[31];
for (ci=31; ci>=0; ci--, wptr2--, ptr++)
{
if (wptr2->nature==0) { *ptr=0; continue; }
*ptr=wptr2->pos;
}
#endif
#endif

// Initialisation pawnstruct
xsearch_level[0]->eval_pawnstruct();



// Gnration de l'ensemble des coups
xlevel=0;
xlv1_wtm=xwtm; // pour searchmove
xsearch_level[0]->actualise_all(); // check=xsearch_level[xlevel].check;
#if DEBUG==1
STATEVALUES *s;
if ( xF_start_from_standard_position )
{
s=&xstates[0];
if ( s->position!=0 || 
     s->materiel!=0 || 	 
	 s->tower!=0 || 
	 // s->mobility!=0 || // peut tre diffrent de zro
	 #if SUIVI_PRISES==1
	 s->prises_pion[0]!=0 || 
	 s->prises_pion[1]!=0 || 
	 s->prises[0]!=0 || 
	 s->prises[1]!=0 || 
	 s->force[0]!=0 || 
	 s->force[1]!=0 || 
	 #endif
	 //s->o_o[0]!=1 || 
	 //s->o_o[1]!=1 || 
	 //s->o_o_o[0]!=2 || 
	 //s->o_o_o[1]!=2 || 
	 s->droit_roque[0]!=(DROIT_PETIT_ROQUE|DROIT_GRAND_ROQUE) || 
	 s->droit_roque[1]!=(DROIT_PETIT_ROQUE|DROIT_GRAND_ROQUE) || 
	 s->pawnstruct!=0 )
{ log_error("\nErreur I_950");}
}
#endif



// Gnration liste de coup de level 0
xwtm=xtrait;
liste_coups_legaux();


// Recopie de xstates au level 1
//xstates[1]=xstates[0];


return 1; // succs

} // fin init


#if HASHTRACE==1
void hashtrace(h_code h)
{		
char tab[25];

ltoa(xnbcoups,tab,10); 
write(xhandle2,&tab,strlen(tab));
write(xhandle2,"//",2);
ultoa(h.address,tab,10);
write(xhandle2,&tab,strlen(tab));
write(xhandle2,"/",1);
ultoa(h.key,tab,10);
write(xhandle2,&tab,strlen(tab));
write(xhandle2,"\n",1);
} // fin hashtrace
#endif



void genere_xw(void)
{
PIECE *wptr;
PIECE_SET *psptr;
char i;
#if _DEBUG==1
//char j;
#endif
STATEVALUES *s;

s=&xstates[0];
s->materiel=0; // doit tre initialis pour les takeback
s->mobility=0; // doit tre initialis pour les takeback
s->materiel_pieces[0]=0; // doit tre initialis pour les takeback
s->materiel_pieces[1]=0; // doit tre initialis pour les takeback
s->materiel_pions[0]=0; // doit tre initialis pour les takeback
s->materiel_pions[1]=0; // doit tre initialis pour les takeback
s->materiel_dames[0]=0; // doit tre initialis pour les takeback
s->materiel_dames[1]=0; // doit tre initialis pour les takeback
s->materiel_tours[0]=0; // doit tre initialis pour les takeback
s->materiel_tours[1]=0; // doit tre initialis pour les takeback
s->materiel_fous[0]=0; // doit tre initialis pour les takeback
s->materiel_fous[1]=0; // doit tre initialis pour les takeback

#if ALLOW_PAWN_SQUARE_CONTROL==1
s->nombre_de_pions_par_couleur_de_cases[0][0]=0;
s->nombre_de_pions_par_couleur_de_cases[0][1]=0;
s->nombre_de_pions_par_couleur_de_cases[1][0]=0;
s->nombre_de_pions_par_couleur_de_cases[1][1]=0;
#endif
s->fou_de_couleur[0][0]=0;
s->fou_de_couleur[0][1]=0;
s->fou_de_couleur[1][0]=0;
s->fou_de_couleur[1][1]=0;
s->materiel_cavaliers[0]=0; // doit tre initialis pour les takeback
s->materiel_cavaliers[1]=0; // doit tre initialis pour les takeback
s->finale=0;
s->F_echange_dame[0]=false;
s->F_echange_dame[1]=false;
s->position=0; // doit tre initialis pour les takeback
s->developpement[0]=0; // doit tre initialis pour les takeback 
s->developpement[1]=0; // doit tre initialis pour les takeback 
s->tower=0;
s->passed[0]=0;
s->passed[1]=0;
s->cases_echec_dame[0]=0;
s->cases_echec_fou[0]=0;
s->cases_echec_tour[0]=0;
//s->cases_echec_pion[0]=0;
//memset(s->clouages,0,32);
#if EVALUATION_CLOUAGES==1
s->nb_pieces_clouees[0]=0;
s->nb_pieces_clouees[1]=0;
#endif


xnbcoups=0;  // doit tre initialis pour les takeback
xlastprise1=0;

wptr=&xw[31];
for (i=31; i>=0; i--, wptr--)
{
if (wptr->nature==0) continue;
// matriel
setvalue(wptr);
xstates[0].materiel += wptr->value;
if (wptr->nature!='P' && wptr->nature!='R') 
{ xstates[0].materiel_pieces[wptr->color01] +=abs(wptr->value); }
else if (wptr->nature=='P') // pions
//{ xstates[0].materiel_pions[wptr->color01]+=abs(wptr->value); }
{ 
	s->materiel_pions[wptr->color01]++;
	#if ALLOW_PAWN_SQUARE_CONTROL==1
	s->nombre_de_pions_par_couleur_de_cases[wptr->color01][M_2(wptr->posx+wptr->posy)]++;
	#endif
}
switch ( wptr->nature )
{
#if KING_SAFETY==1
case 'D' :	//xstates[0].materiel_dames[wptr->color01]+=abs(wptr->value);
			s->materiel_dames[wptr->color01]++;
			break;
case 'T' :	//xstates[0].materiel_tours[wptr->color01]+=abs(wptr->value);
			s->materiel_tours[wptr->color01]++;
			break;
#endif
case 'F' :	//xstates[0].materiel_fous[wptr->color01]+=abs(wptr->value);
			s->materiel_fous[wptr->color01]++;
			// 31 => fou cases noires en [0]
			// 61 => fou cases blanches en [1]
			// 38 => fou cases blanches en [1]
			// 68 = > fou cases noires en [0]
			s->fou_de_couleur[wptr->color01][M_2(X64(wptr->pos)+Y64(wptr->pos))]=1;
			break;
case 'C' :	//xstates[0].materiel_cavaliers[wptr->color01]+=abs(wptr->value);
			s->materiel_cavaliers[wptr->color01]++;
			break;
case 'R':   break;
default : break;
}
// piece set
wptr->psptr=&xpset[i][0];
psptr=wptr->psptr;
// piece_set
// rem : seul le level 0 a besoin d'tre initialis
//       les autres niveaux sont crass quand subactualise est invoque      
psptr->posvalue=0;
psptr->develop=0;
psptr->mobility=0;
psptr->mobility2=0;
psptr->tower=0;
psptr->levelmoves=0;
//psptr->full_levelmoves=0;
psptr->oldptr=&xpset[i][0]; 
// suite
}//close for

// Renseignement xw_size
// Compact_piece_list() ne peut pas tre appele
// car xboard n'est pas remplie et on ne peut pas actualiser()
xw_size[1]=15; xw_size[0]=31;

// Renseignement change des dames
if (xstates[0].materiel_dames[0]==0) s->F_echange_dame[0]=true;
if (xstates[0].materiel_dames[1]==0) s->F_echange_dame[1]=true;

// Renseignement de la position des roi
xsearch_level[0]->maj_coordonnees_roi(1);
xsearch_level[0]->maj_coordonnees_roi(0);

#if VALUE_MINOR_PIECES==1
maj_liste_minor_pieces();
#endif 

} // fin fonction




void init_board(void)
{
CASE *cptr;
//CASE2 *cptr2;
char pos;
// Remplissage echiquier
for (pos=63; pos>=0; pos--)
{
cptr=&xboard[pos];
//cptr2=&xboard2[pos];
cptr->pos=pos;
//cptr2->pos=pos;
cptr->posx=X64(pos);
cptr->posy=Y64(pos);
//cptr2->posx=X64(pos);
//cptr2->posy=Y64(pos);
cptr->diag1=DIAG64_1(pos);
cptr->diag2=DIAG64_2(pos);
//cptr2->diag1=DIAG64_1(pos);
//cptr2->diag2=DIAG64_2(pos);
cptr->color=0;
cptr->color01=-1;
cptr->num_piece=99;
cptr->piece_value=0;
cptr->wptr=&xwnull;
cptr->nature=0;
}

// Remplissage de xboard[].posval
xboard_posvalue();

} // fin init_board



void xboard_posvalue(void)
{
char type; 
char color;
char nature;
char pos;

// Remplissage de xboard[].posval
for (type=0; type<=11; type++)
{
switch(type)
{
case 0 : color=1;nature='P';
		 break;
case 1 : color=-1;nature='P';
		 break;
case 2 : color=1;nature='C';
		 break;
case 3 : color=-1;nature='C';
		 break;
case 4 : color=1;nature='F';
		 break;
case 5 : color=-1;nature='F';
		 break;
case 6 : color=1;nature='T';
		 break;
case 7 : color=-1;nature='T';
		 break;
case 8 : color=1;nature='D';
		 break;
case 9 : color=-1;nature='D';
		 break;
case 10: color=1;nature='R';
		 break;
case 11: color=-1;nature='R';
		 break;
}


for (pos=63;pos>=0;pos--)
{
xboard[pos].posvalue[type]=COLOR(color,getposvalue(nature,TO_COLOR01(color),pos));
// xboard2
}
} // fin code 2

} // fin xboard_posval


void pose_pieces(void)
{
char i;
PIECE *wptr;
CASE *cptr;

xstates[0].cases_pions[1]=0;
xstates[0].cases_pions[0]=0;
xstates[0].cases_pieces[1]=0;
xstates[0].cases_pieces[0]=0;
#if FOLLOW_KNIGHTS==1
xstates[0].cases_cavaliers[0]=0;
xstates[0].cases_cavaliers[1]=0;
#endif

#if USE_BITBOARD_MOVE_GENERATION==1 || CHECK_MOVE_GENERATION_WITH_BITBOARDS==1
xstates[0].cases_toutes_pieces[1]=0;
xstates[0].cases_toutes_pieces[0]=0;
#endif
// Pose des pices
wptr=&xw[31];
for (i=31; i>=0; i--, wptr--)
{
if (wptr->nature==0) continue;
cptr=&xboard[wptr->pos];
cptr->nature=wptr->nature;
cptr->num_piece=wptr->num_piece;
cptr->color=wptr->color;
cptr->color01=wptr->color01;
cptr->piece_value=abs(wptr->value);
cptr->wptr=wptr;
if (wptr->nature=='P')
{
set_bit_to_1(xstates[0].cases_pions[wptr->color01],cptr->pos);
}
else
{
set_bit_to_1(xstates[0].cases_pieces[wptr->color01],cptr->pos);
#if FOLLOW_KNIGHTS==1
if (wptr->nature=='C') set_bit_to_1(xstates[0].cases_cavaliers[wptr->color01],cptr->pos);
#endif
}
#if USE_BITBOARD_MOVE_GENERATION==1 || CHECK_MOVE_GENERATION_WITH_BITBOARDS==1
set_bit_to_1(xstates[0].cases_toutes_pieces[wptr->color01],cptr->pos);
#endif

} // fin for


// Contr"le et ajustement des droits de roquer annoncs
if (xboard[32].nature!='R')
{xstates[0].droit_roque[1]=0; /* xstates[0].o_o[1]=0; xstates[0].o_o_o[1]=0; */ }
if (xboard[56].nature!='T')
{maj_droit_roque(xstates[0].droit_roque[1],PERTE_DROIT_PETIT_ROQUE); /*xstates[0].o_o[1]=0;*/}
if (xboard[0].nature!='T')
{maj_droit_roque(xstates[0].droit_roque[1],PERTE_DROIT_GRAND_ROQUE); /*xstates[0].o_o_o[1]=0;*/ }
if (xboard[39].nature!='R')
{xstates[0].droit_roque[0]=0; /* xstates[0].o_o[1]=0; xstates[0].o_o_o[1]=0; */ }
if (xboard[63].nature!='T')
{maj_droit_roque(xstates[0].droit_roque[0],PERTE_DROIT_PETIT_ROQUE); /*xstates[0].o_o[0]=0;*/}
if (xboard[7].nature!='T')
{maj_droit_roque(xstates[0].droit_roque[0],PERTE_DROIT_GRAND_ROQUE); /*xstates[0].o_o_o[0]=0;*/ }

// Maj roque et code_roque
// xstates[0].droit_roque[0]=xstates[0].o_o_o[0]+xstates[0].o_o[0];
// xstates[0].droit_roque[1]=xstates[0].o_o_o[1]+xstates[0].o_o[1];
// xstates[0].code_roque=xstates[0].droit_roque[1]|(xstates[0].droit_roque[0]+10);


// Sauvegarde des droits  roquer initiaux
// xroqueini[color][type_roque]
//xroqueini[0][0]=xstates[0].o_o[0];
//xroqueini[0][1]=xstates[0].o_o_o[0];
//xroqueini[1][0]=xstates[0].o_o[1];
//xroqueini[1][1]=xstates[0].o_o_o[1];
xroqueini[0]=xstates[0].droit_roque[0];
xroqueini[1]=xstates[0].droit_roque[1];


} // fin pose_pieces




void setvalue(PIECE *wptr)
{
// code pice pour routine d'actualisation 
// et type pice pour CASE->valpos[12] 
char cc;
char color;

// Pice vide
if ( wptr->nature==0 ) return;

color=wptr->color;
// De 0  11
switch (wptr->nature)
{
case 'P': wptr->value=COLOR(color,VALEUR_PION);
		if ( color==1 ) 
			{ wptr->maxdir=1; 
		      //wptr->code=0; 
			  wptr->type=0; 
			}
		else   
			{ wptr->maxdir=1; 
		      //wptr->code=0; 
			  wptr->type=1; }
 	    break;
case 'C': wptr->value=COLOR(color,VALEUR_CAVALIER);
		if ( color==1 ) 
			{ wptr->maxdir=1; 
			  //wptr->code=1; 
			  wptr->type=2; }
		else   
			{ wptr->maxdir=1; 
			  //wptr->code=1; 
		      wptr->type=3; }
    	      break;
case 'F': wptr->value=COLOR(color,VALEUR_FOU);
		if ( color==1 ) 
			{ wptr->maxdir=4; 
		      //wptr->code=2; 
		      wptr->type=4; }
		else   
			{ wptr->maxdir=4; 
		      //wptr->code=2; 
		      wptr->type=5; }
    	      break;
case 'T': wptr->value=COLOR(color,VALEUR_TOUR);
		if ( color==1 ) 
			{ wptr->maxdir=4; 
		      //wptr->code=3; 
		      wptr->type=6; }
		else   
			{ wptr->maxdir=4; 
		      //wptr->code=3; 
		      wptr->type=7; }
    	      break;
case 'D': wptr->value=COLOR(color,VALEUR_DAME);
		if ( color==1 ) 
			{ wptr->maxdir=8; 
		      //wptr->code=4; 
		      wptr->type=8; }
		else   
			{ wptr->maxdir=8; 
		      //wptr->code=4; 
		      wptr->type=9; }
    	      break;
case 'R': wptr->value=COLOR(color,VALEUR_ROI); 
		if ( color==1 ) 
			{ wptr->maxdir=1; 
		      //wptr->code=5; 
		      wptr->type=10; }
		else   
			{ wptr->maxdir=1; 
		      //wptr->code=5; 
		      wptr->type=11; }
    	break;
default : log_error("\nErreur I_002 : %d",xcompteur);
	      cc=1;
} //close switch


wptr->hash_code=xhval[wptr->type][wptr->pos];

} // fin setvalue()




void saisie_board(void)
{
char i,j;
int handle;
char rep[5];
char c,cc;
char color;
char square;
char buff[20];
char nature;
//char si;
//char *ptr;

for (i=0;i<=88;i++) xxboard_original_french[i]=0;

for (j=8;j>=1;j--)
{
for (i=1;i<=8;i++)
{
while (1)
{
square=i*10+j;
printf("\n");
affiche(square);
printf(" : ");
getstring(rep,3);
//ptr=rep;
// for (si=0; si<=1; si++, ptr++) *ptr=toupper(*ptr);
_strupr(rep);
switch (rep[0])
{
case 'W': c=1; break;
case 'B': c=2; break;
case 'V': rep[0]=' '; cc=1; break; // Vide
case 'E': rep[0]=' '; cc=1; break; // Empty
default : c=0;
}
switch (rep[1])
{
case 'P': cc=1; break;
case 'N': cc=1; break;
case 'B': cc=1; break;
case 'R': cc=1; break;
case 'Q': cc=1; break;
case 'K': cc=1; break;
default : cc=0;
}

if (c*cc==0 && rep[0]!=' ')
{
#if xenable_sound
#if COMPILER==1
{sound(83); delay (100); nosound();}
#endif
if ( xenable_sound ) printf("\a");
#endif
}
else
{
if (c==2) rep[1]=-rep[1];
xxboard_original_french[square]=english_to_french(abs(rep[1]))*SIGNE(rep[1]);
break;
}
} // fermeture while
} // fermeture for
} // fermeture for


printf("\nFilename to create : ");
getstring(xnom_pos,8);
putsuffixe(xnom_pos,'p','o','s');
if ((handle=open(xnom_pos, O_WRONLY | O_CREAT | O_BINARY | O_TRUNC,
S_IREAD | S_IWRITE)) == -1)
{
log_error("\nErr I_003 !");
// Test essentiel - mais pas de blocage !!
dispose_engine();
}
for (j=8;j>=1;j--)
{
for (i=1;i<=8;i++)
{
strcpy(buff,"|");
write(handle,buff,1);
square=10*i+j;
if (xxboard_original_french[square]>0) color='W';
if (xxboard_original_french[square]<0) color='B';
if (xxboard_original_french[square]==' ') color=' ';
nature=french_to_english(abs(xxboard_original_french[square]));
if (nature==0) nature=' ';
buff[0]=color; buff[1]='\0';
write(handle,buff,1);
buff[0]=nature;buff[1]='\0';
write(handle,buff,1);
} // fin for
strcpy(buff,"|\n\r");
write(handle,buff,2);
} // fin for
close(handle);

} // fin saisie_board



char get_board(char *nom_fich)
{
char handle;
char i;
char board_standard[SIZE_OF_BOARD_88];
char cc;
long size; 
long curseur;
char *handle_mem;
char color;
char ligne, colonne, colonne_par_3;
char *ptr;
char square;
char nature;
char language; // 1=franais - 2=anglais - j'ai switch du franais  l'anglais pour les fichiers .pos
bool F_separateur_donne;
bool F_piece_donnee;
bool F_couleur_donnee;

memset(board_standard,0,sizeof(board_standard));

// Remplissage de l'chiquier
// Blancs
board_standard[11]='T';
board_standard[12]='P';
board_standard[21]='C';
board_standard[22]='P';
board_standard[31]='F';
board_standard[32]='P';
board_standard[41]='D';
board_standard[42]='P';
board_standard[51]='R';
board_standard[52]='P';
board_standard[61]='F';
board_standard[62]='P';
board_standard[71]='C';
board_standard[72]='P';
board_standard[81]='T';
board_standard[82]='P';
// Noirs
board_standard[18]=-'T';
board_standard[17]=-'P';
board_standard[28]=-'C';
board_standard[27]=-'P';
board_standard[38]=-'F';
board_standard[37]=-'P';
board_standard[48]=-'D';
board_standard[47]=-'P';
board_standard[58]=-'R';
board_standard[57]=-'P';
board_standard[68]=-'F';
board_standard[67]=-'P';
board_standard[78]=-'C';
board_standard[77]=-'P';
board_standard[88]=-'T';
board_standard[87]=-'P';


// Position de dpart standard 
if (xF_start_from_standard_position || nom_fich==NULL)
{
memcpy(xxboard_original_french,board_standard,SIZE_OF_BOARD_88);
/*
for (i=0; i<=88; i++)
{
xxboard_original_french[i]=board_standard[i];
}
*/
}
else 
// Chargement xxboard_original_french
{
if ((handle=open(nom_fich, O_BINARY, S_IREAD | S_IWRITE)) == -1)
{
log_error("\nErreur I_005 !");
return 0;
}
// Chargement du fichier pos
//handle_mem=(char *) calloc(2000,1);
handle_mem=(char *) malloc(2000);
size=0;
while(size<2000 && read(handle,handle_mem+size,1)!=0) size++;
close(handle);
handle_mem=(char *)realloc(handle_mem,size);
if ( handle_mem==NULL )
{
	log_error("\nErreur I_104 - Echec realloc");
}


if (!(size==64 || size==216)) return 0;

/* for (i=0;i<=88;i++) xxboard_original_french[i]=0;*/

language=0;
for (curseur=0;curseur<=size-1;curseur++)
{
	ptr=handle_mem+curseur;
	if (*ptr=='C') { language=1; break;} // Franais 
	if (*ptr=='K') { language=2; break;} // Anglais 
}
if (language==0) return 0;

memset(xxboard_original_french,0,SIZE_OF_BOARD_88);
F_separateur_donne=true;
F_couleur_donnee=false;
F_piece_donnee=false;
for (curseur=0;curseur<=size-1;curseur++)
{
ptr=handle_mem+curseur;
// Nouveau format
if (size==216)
{ 
if ( *ptr==10) continue; // Retour charriot
if ( *ptr==13) continue; // Carriage return
if (language==1) // Franais
{
	if ( F_separateur_donne
           && (	*ptr=='D' || *ptr=='T' || *ptr=='F' || *ptr=='C' || 
			*ptr=='R' || *ptr=='P' || *ptr==' ' ) 
	     )
		{ F_separateur_donne=false; F_piece_donnee=true; nature=*ptr; continue; }
	if ( F_piece_donnee && *ptr=='B' ) { color=1; F_separateur_donne=false; F_couleur_donnee=true; goto REGISTER; }
	if ( F_piece_donnee && *ptr=='N' ) { color=-1; F_separateur_donne=false; F_couleur_donnee=true; goto REGISTER; }
	if ( F_piece_donnee && *ptr==' ' ) { color=0; F_separateur_donne=false; F_couleur_donnee=true; goto REGISTER; }
	if ( *ptr=='|' ) { color=0; F_separateur_donne=true; F_couleur_donnee=false; F_piece_donnee=false; continue;}
	if (!F_piece_donnee || !F_couleur_donnee) { continue;}
	
}
else // Anglais
{
	// en Anglais, on a le problme 'BB'
	// Enfin, en anglais, la couleur est en premier
	if ( F_couleur_donnee
           && (
		  	*ptr=='R' || *ptr=='P' || 
	            *ptr=='Q' || *ptr=='N' || *ptr=='B' || *ptr=='K' || *ptr==' ') 
	   )
		{ F_couleur_donnee=false; F_piece_donnee=true; nature=*ptr; goto REGISTER; }
	if ( F_separateur_donne && *ptr=='W' ) { color=1;  F_separateur_donne=false; F_couleur_donnee=true; continue;}
	if ( F_separateur_donne && *ptr=='B' ) { color=-1; F_separateur_donne=false; F_couleur_donnee=true; continue;}
	if ( F_separateur_donne && *ptr==' ' ) { color=0; F_separateur_donne=false; F_couleur_donnee=true; continue;}
	if ( *ptr=='|' ) { color=0; F_separateur_donne=true; F_couleur_donnee=false; F_piece_donnee=false; continue;}
	if (!F_piece_donnee || !F_couleur_donnee) { continue;}
}

// Nombre de caractres par ligne du fichier position == 26
REGISTER:
if (nature==' ') nature=0;
colonne_par_3=(char)((long) (curseur+1)%27);
colonne=colonne_par_3/3;
ligne=(char)((long) (216-(curseur+1-colonne_par_3))/27);
square=10*colonne+ligne;
if (language==1) xxboard_original_french[square]=nature*color;
else 		     xxboard_original_french[square]=english_to_french(nature)*color;
}
// Ancien format (franais forcment) 
else if (size==64)
{
ptr=handle_mem+curseur;
square=(char) (long)((curseur-curseur%8)/8*10+(curseur%8)+11);
xxboard_original_french[square]=*ptr;
if (xxboard_original_french[square]=='V') xxboard_original_french[square]=0;
} // fin else if 
} // fin for
	
// Exploitation du ficher pos  

//close(handle); dja fait

} // fin else chargement


/* Affichage de l'chiquier
char i;
!!Conserver pour des raisons historiques
printf("\n");
for (i=0; i<=63; i++) printf("%c",xxboard_original_french[i]);
printf("\n");
*/

// Test position standard
cc=0;
for (i=0;i<=88;i++)
{
	if (xxboard_original_french[i]!=board_standard[i]) {cc=1; break;}
}
if (cc==0) 
{
// Flag position standard
xF_start_from_standard_position=true;
// Droits  roquer
//xstates[0].o_o[1]=1;
//xstates[0].o_o_o[1]=2;
//xstates[0].o_o[0]=1;
//xstates[0].o_o_o[0]=2;
xstates[0].droit_roque[0]=DROIT_PETIT_ROQUE|DROIT_GRAND_ROQUE;;
xstates[0].droit_roque[1]=DROIT_PETIT_ROQUE|DROIT_GRAND_ROQUE;;
// Maj roque et code_roque
//xstates[0].droit_roque[0]=xstates[0].o_o_o[0]+xstates[0].o_o[0];
//xstates[0].droit_roque[1]=xstates[0].o_o_o[1]+xstates[0].o_o[1];
// xstates[0].code_roque=xstates[0].droit_roque[1]|(xstates[0].droit_roque[0]<<SHIFT_ROQUE_NOIR);
}

return 1;
}




void makeposvalue(void)
{
char *ptr;
char i;
STATEVALUES *s;

// Il ne faut pas se baser sur les roques
// mais sur la position des rois 
//  cause des roques  la main
// On utilise donc des variables se substituant aux roques effectifs

s=&xstates[0];

// Boucle sur blanc et noir
// Colonnes A-B-C
for (i=0;i<=1;i++)
{
// pion
ptr=&xpion[i][0];
// Grand roque blanc
if (s->equivalent_droit_roque[i]==GRAND_ROQUE)
{
// A
*ptr++=0;
*ptr++=1;
*ptr++=-10;
*ptr++=-50;
*ptr++=-40;
*ptr++=30;
*ptr++=100;
*ptr++=120;

// B
*ptr++=0;
*ptr++=1;
*ptr++=-10;
*ptr++=-50;
*ptr++=-40;
*ptr++=30;
*ptr++=100;
*ptr++=120;

// C
*ptr++=0;
*ptr++=1;
*ptr++=0;
*ptr++=-50;
*ptr++=-40;
*ptr++=30;
*ptr++=100;
*ptr++=120;

}
// Grand roque noir sans grand roque blanc
else if (s->equivalent_droit_roque[1-i]==GRAND_ROQUE && s->equivalent_droit_roque[i]!=GRAND_ROQUE)
{
// A
*ptr++=0;
*ptr++=0;
*ptr++=10;
*ptr++=50;
*ptr++=70;
*ptr++=90;
*ptr++=100;
*ptr++=120;

// B
*ptr++=0;
*ptr++=0;
*ptr++=10;
*ptr++=50;
*ptr++=70;
*ptr++=90;
*ptr++=100;
*ptr++=120;

// C
*ptr++=0;
*ptr++=0;
*ptr++=10;
*ptr++=30;
*ptr++=40;
*ptr++=50;
*ptr++=100;
*ptr++=120;
}
else // Cas standard
{
// A
*ptr++=0;
*ptr++=1;
*ptr++=2;
*ptr++=3;
*ptr++=4;
*ptr++=35;
*ptr++=100;
*ptr++=120;

// B
*ptr++=0;
*ptr++=1;
*ptr++=2;
*ptr++=3;
*ptr++=4;
*ptr++=35;
*ptr++=100;
*ptr++=120;

// C
*ptr++=0;
*ptr++=-10;
*ptr++=20;
*ptr++=50;
*ptr++=52;
*ptr++=55;
*ptr++=100;
*ptr++=120;
}


// D
*ptr++=0;
*ptr++=-30;
*ptr++=20;
*ptr++=50;
*ptr++=52;
*ptr++=55;
*ptr++=100;
*ptr++=120;

// E
*ptr++=0;
*ptr++=-30;
*ptr++=20;
*ptr++=50;
*ptr++=52;
*ptr++=55;
*ptr++=100;
*ptr++=120;

// Petit roque blanc fait ou possible
if (s->equivalent_droit_roque[i]==PETIT_ROQUE || s->equivalent_droit_roque[i]==DROIT_PETIT_ROQUE)
{
// F
*ptr++=0;
*ptr++=1;
*ptr++=1;
*ptr++=2;
*ptr++=50;
*ptr++=80;
*ptr++=100;
*ptr++=120;

// G
*ptr++=0;
*ptr++=1;
*ptr++=-10;
*ptr++=-50;
*ptr++=-40;
*ptr++=30;
*ptr++=100;
*ptr++=120;

// H
*ptr++=0;
*ptr++=1;
*ptr++=-10;
*ptr++=-50;
*ptr++=-40;
*ptr++=30;
*ptr++=100;
*ptr++=120;

} 
// Petit roque noir sans petit roque blanc
else if (s->equivalent_droit_roque[1-i]==PETIT_ROQUE && s->equivalent_droit_roque[1-i]!=PETIT_ROQUE)
{
// F
*ptr++=0;
*ptr++=0;
*ptr++=10;
*ptr++=20;
*ptr++=20;
*ptr++=50;
*ptr++=100;
*ptr++=120;

// G
*ptr++=0;
*ptr++=0;
*ptr++=10;
*ptr++=50;
*ptr++=70;
*ptr++=90;
*ptr++=100;
*ptr++=120;

// H
*ptr++=0;
*ptr++=0;
*ptr++=10;
*ptr++=50;
*ptr++=70;
*ptr++=90;
*ptr++=100;
*ptr++=120;
} 
else // Autres cas avec petit roque impossible
{
// F
*ptr++=0;
*ptr++=1;
*ptr++=0;
*ptr++=10;
*ptr++=20;
*ptr++=40;
*ptr++=60;
*ptr++=120;

// G
*ptr++=0;
*ptr++=1;
*ptr++=0;
*ptr++=10;
*ptr++=20;
*ptr++=40;
*ptr++=60;
*ptr++=120;

// H
*ptr++=0;
*ptr++=1;
*ptr++=0;
*ptr++=10;
*ptr++=20;
*ptr++=40;
*ptr++=60;
*ptr++=120;
}
} // fin for


// cavalier
ptr=&xcavalier[0];
// A
*ptr++=-100;
*ptr++=-80;
*ptr++=-60;
*ptr++=-60;
*ptr++=-60;
*ptr++=-60;
*ptr++=-60;
*ptr++=-120;

// B
*ptr++=-70;
*ptr++=-50;
*ptr++=20;
*ptr++=40;
*ptr++=60;
*ptr++=70;
*ptr++=40;
*ptr++=20;

// C
*ptr++=-20;
*ptr++=1;
*ptr++=40;
*ptr++=30;
*ptr++=40;
*ptr++=40;
*ptr++=70;
*ptr++=50;

// D
*ptr++=-20;
*ptr++=20;
*ptr++=20;
*ptr++=60;
*ptr++=60;
*ptr++=40;
*ptr++=30;
*ptr++=20;

// E
*ptr++=-20;
*ptr++=20;
*ptr++=30;
*ptr++=50;
*ptr++=70;
*ptr++=50;
*ptr++=30;
*ptr++=20;

// F
*ptr++=-20;
*ptr++=20;
*ptr++=40;
*ptr++=30;
*ptr++=50;
*ptr++=60;
*ptr++=60;
*ptr++=20;

// G
*ptr++=-20;
*ptr++=0;
*ptr++=20;
*ptr++=20;
*ptr++=20;
*ptr++=20;
*ptr++=10;
*ptr++=0;

// H
*ptr++=-100;
*ptr++=-80;
*ptr++=-60;
*ptr++=-60;
*ptr++=-60;
*ptr++=-60;
*ptr++=-60;
*ptr++=-120;


// fou
ptr=&xfou[0];
// A
*ptr++=0;
*ptr++=0;
*ptr++=0;
*ptr++=10;
*ptr++=0;
*ptr++=0;
*ptr++=0;
*ptr++=0;

// B
*ptr++=0;
*ptr++=20;
*ptr++=20;
*ptr++=0;
*ptr++=40;
*ptr++=40;
*ptr++=0;
*ptr++=0;

// C
*ptr++=-50;
*ptr++=20;
*ptr++=10;
*ptr++=40;
*ptr++=10;
*ptr++=10;
*ptr++=20;
*ptr++=0;

// D
*ptr++=-10;
*ptr++=-5;
*ptr++=10;
*ptr++=10;
*ptr++=10;
*ptr++=10;
*ptr++=0;
*ptr++=0;

// E
*ptr++=0;
*ptr++=40;
*ptr++=0;
*ptr++=40;
*ptr++=20;
*ptr++=30;
*ptr++=0;
*ptr++=0;

// F
*ptr++=-70;
*ptr++=0;
*ptr++=20;
*ptr++=20;
*ptr++=20;
*ptr++=20;
*ptr++=50;
*ptr++=0;

// G
*ptr++=0;
*ptr++=20;
*ptr++=0;
*ptr++=0;
*ptr++=40;
*ptr++=0;
*ptr++=20;
*ptr++=0;

// H
*ptr++=0;
*ptr++=0;
*ptr++=0;
*ptr++=0;
*ptr++=0;
*ptr++=0;
*ptr++=0;
*ptr++=20;

// tour
ptr=&xtour[0];
// A
*ptr++=0;
*ptr++=0;
*ptr++=10;
*ptr++=20;
*ptr++=20;
*ptr++=70;
*ptr++=120;
*ptr++=70;

// B
*ptr++=0;
*ptr++=0;
*ptr++=10;
*ptr++=20;
*ptr++=20;
*ptr++=70;
*ptr++=120;
*ptr++=70;

// C
*ptr++=40;
*ptr++=0;
*ptr++=30;
*ptr++=30;
*ptr++=40;
*ptr++=70;
*ptr++=120;
*ptr++=70;

// D
*ptr++=50;
*ptr++=0;
*ptr++=30;
*ptr++=30;
*ptr++=40;
*ptr++=70;
*ptr++=120;
*ptr++=70;

// E
*ptr++=70;
*ptr++=0;
*ptr++=30;
*ptr++=30;
*ptr++=40;
*ptr++=70;
*ptr++=120;
*ptr++=70;

// F
*ptr++=0;
*ptr++=0;
*ptr++=30;
*ptr++=30,
*ptr++=40;
*ptr++=70;
*ptr++=120;
*ptr++=70;

// G
*ptr++=0;
*ptr++=0;
*ptr++=30;
*ptr++=30;
*ptr++=40;
*ptr++=70;
*ptr++=120;
*ptr++=70;

// H
*ptr++=20;
*ptr++=0;
*ptr++=30;
*ptr++=30;
*ptr++=40;
*ptr++=70;
*ptr++=120;
*ptr++=70;

// dame
ptr=&xdame[0];
// A
*ptr++=0;
*ptr++=0;
*ptr++=5;
*ptr++=10;
*ptr++=10;
*ptr++=5;
*ptr++=10;
*ptr++=20;

// B
*ptr++=0;
*ptr++=0;
*ptr++=10;
*ptr++=10;
*ptr++=20;
*ptr++=20;
*ptr++=100;
*ptr++=20;

// C
*ptr++=0;
*ptr++=20;
*ptr++=20;
*ptr++=30;
*ptr++=40;
*ptr++=50;
*ptr++=100;
*ptr++=60;

// D
*ptr++=0;
*ptr++=20;
*ptr++=20;
*ptr++=30;
*ptr++=40;
*ptr++=50;
*ptr++=100;
*ptr++=60;

// E
*ptr++=0;
*ptr++=20;
*ptr++=20;
*ptr++=30;
*ptr++=40;
*ptr++=50;
*ptr++=100;
*ptr++=60;

// F
*ptr++=0;
*ptr++=20;
*ptr++=20;
*ptr++=30;
*ptr++=40;
*ptr++=50;
*ptr++=100;
*ptr++=60;

// G
*ptr++=0;
*ptr++=20;
*ptr++=20;
*ptr++=30;
*ptr++=40;
*ptr++=50;
*ptr++=100;
*ptr++=60;

// H
*ptr++=0;
*ptr++=20;
*ptr++=20;
*ptr++=30;
*ptr++=40;
*ptr++=50;
*ptr++=100;
*ptr++=60;

// Roi
ptr=&xroi[0];
// A
*ptr++=0;
*ptr++=1;
*ptr++=5;
*ptr++=10;
*ptr++=15;
*ptr++=20;
*ptr++=25;
*ptr++=20;

// B
*ptr++=5;
*ptr++=10;
*ptr++=15;
*ptr++=20;
*ptr++=25;
*ptr++=30;
*ptr++=35;
*ptr++=30;

// C
*ptr++=10;
*ptr++=15;
*ptr++=20;
*ptr++=25;
*ptr++=30;
*ptr++=35;
*ptr++=40;
*ptr++=35;

// D
*ptr++=20;
*ptr++=25;
*ptr++=30;
*ptr++=35;
*ptr++=40;
*ptr++=45;
*ptr++=50;
*ptr++=45;

// E
*ptr++=20;
*ptr++=25;
*ptr++=30;
*ptr++=35;
*ptr++=40;
*ptr++=45;
*ptr++=50;
*ptr++=45;

// F
*ptr++=10;
*ptr++=15;
*ptr++=20;
*ptr++=25;
*ptr++=30;
*ptr++=35;
*ptr++=40;
*ptr++=35;

// G
*ptr++=5;
*ptr++=10;
*ptr++=15;
*ptr++=20;
*ptr++=25;
*ptr++=30;
*ptr++=35;
*ptr++=30;

// H
*ptr++=0;
*ptr++=1;
*ptr++=5;
*ptr++=10;
*ptr++=15;
*ptr++=20;
*ptr++=25;
*ptr++=20;

} // fin makeposvalue



void makeposvalue_finale(void)
{
char *ptr;
char i;

// Boucle sur blanc et noir
for (i=0;i<=1;i++)
{
// pion
ptr=&xpion[i][0];
// A
*ptr++=0;
*ptr++=1;
*ptr++=20;
*ptr++=40;
*ptr++=60;
*ptr++=80;
*ptr++=100;
*ptr++=120;


// B
*ptr++=0;
*ptr++=1;
*ptr++=20;
*ptr++=40;
*ptr++=60;
*ptr++=80;
*ptr++=100;
*ptr++=120;


// C
*ptr++=0;
*ptr++=1;
*ptr++=20;
*ptr++=40;
*ptr++=60;
*ptr++=80;
*ptr++=100;
*ptr++=120;


// D
*ptr++=0;
*ptr++=1;
*ptr++=20;
*ptr++=40;
*ptr++=60;
*ptr++=80;
*ptr++=100;
*ptr++=120;


// E
*ptr++=0;
*ptr++=1;
*ptr++=20;
*ptr++=40;
*ptr++=60;
*ptr++=80;
*ptr++=100;
*ptr++=120;


// F
*ptr++=0;
*ptr++=1;
*ptr++=20;
*ptr++=40;
*ptr++=60;
*ptr++=80;
*ptr++=100;
*ptr++=120;


// G
*ptr++=0;
*ptr++=1;
*ptr++=20;
*ptr++=40;
*ptr++=60;
*ptr++=80;
*ptr++=100;
*ptr++=120;


// H
*ptr++=0;
*ptr++=1;
*ptr++=20;
*ptr++=40;
*ptr++=60;
*ptr++=80;
*ptr++=100;
*ptr++=120;



// Roi
ptr=&xroi[0];
// Ne pas faire de distinction entre les colonnes
// A
*ptr++=0;
*ptr++=10;
*ptr++=20;
*ptr++=30;
*ptr++=40;
*ptr++=50;
*ptr++=60;
*ptr++=40;


// B
*ptr++=0;
*ptr++=15;
*ptr++=25;
*ptr++=35;
*ptr++=45;
*ptr++=55;
*ptr++=65;
*ptr++=45;


// C
*ptr++=0;
*ptr++=20;
*ptr++=30;
*ptr++=40;
*ptr++=50;
*ptr++=60;
*ptr++=70;
*ptr++=60;


// D
*ptr++=5;
*ptr++=25;
*ptr++=35;
*ptr++=45;
*ptr++=55;
*ptr++=65;
*ptr++=75;
*ptr++=65;


// E
*ptr++=5;
*ptr++=25;
*ptr++=35;
*ptr++=45;
*ptr++=55;
*ptr++=65;
*ptr++=75;
*ptr++=65;


// F
*ptr++=0;
*ptr++=20;
*ptr++=30;
*ptr++=40;
*ptr++=50;
*ptr++=60;
*ptr++=70;
*ptr++=60;


// G
*ptr++=0;
*ptr++=15;
*ptr++=25;
*ptr++=35;
*ptr++=45;
*ptr++=55;
*ptr++=65;
*ptr++=45;


// H
*ptr++=0;
*ptr++=10;
*ptr++=20;
*ptr++=30;
*ptr++=40;
*ptr++=50;
*ptr++=60;
*ptr++=40;


} // fin for



} // fin makeposvalue_finale()



char getON(char *string_ptr)
{
int rep;
int cc; 
char *ptr;
cc=0;

while(1)
{
rep=toupper(getch());
if (rep==0) getch();  // limination des touches de fonction
		      // le deuxime appel rend le code de la touche
ptr=string_ptr;
while (*ptr!='\0')
{
if ((char)rep==*ptr)
{
putch(tolower(rep));
cc=1;
break;
}
ptr++;
} // fin while 2

if (cc==1) break;
} // fin while 1

return (char) rep;
} // fin fonction getON()





long getlong(char maxlength)
{
char rep2;
char rep[20];
char num=0;
char nbcar=0;  // nombre de caractres sans le + ou le -
char nbcar2=0; // nombre de caractres avec le + ou le -


do
{
rep2=getch();

if (rep2==0)
{
getch();
// donne le code de la touche de fonction
continue;
}

rep[num]=rep2;

if (rep[num]!=13) // CR
{
if (rep[num]==8)
{
if (nbcar2==0 && (rep[num-1]==45 || rep[num-1]==43))
{
putch(8); putch(0); putch(8);
--num;
// nbcar--;
nbcar2--;
}
if (nbcar2>=1)
{
putch(8); putch(0); putch(8);
--num;
nbcar--;
nbcar2--;
}
continue;
}
else
{
if (nbcar2==0 && (rep[num]==45 || rep[num]==43))  // + et -
{
putch(rep[num]);
// nbcar++;
nbcar2++;
num++;
continue;
}
if (nbcar==maxlength || rep[num]<48 || rep[num]>57 ) {putch(7); continue;}
putch(rep[num]);
nbcar++;
nbcar2++;
num++;
} // fin else *ptr!=8
} // fin if *ptr==13
else  // CR
{
if (nbcar>0) // au moins un caractre pour breaker
{
rep[num]=0; // fin de chaine
break;
}
}
} // fin do
while (1);


return atol(rep);
} // fin getlong



char getstring(char *ptr, char maxlength)
{
char nbcar=0;
char rep;
char i;
for (i=0;i<=maxlength;i++,*ptr=0); // marque la fin de la chane

while(1)
{
rep=getch();if (rep==0)
{
getch();
// donne le code des touches de fonction
}
*ptr=rep;
if (*ptr!=13) // CR
{
if (*ptr==8)
{
if (nbcar>=1)
{
putch(8); putch(0); putch(8);
ptr--;
nbcar--;
}
continue;
}
else
{
// 32 est l'espace
if (*ptr<=32 || nbcar==maxlength-1) {putch(7); continue;}
putch(*ptr);
nbcar++;
ptr++;
} // fin else *ptr!=8
} // fin if *ptr==13
else  // CR
{
if (nbcar>0) // au moins un caractre pour breaker
{
*ptr=0; // fin de chaine
break;
}
}
} // fin while (1);

return nbcar;
} // fin getstring()



char getstring_move(char *ptr)
{
char nbcar=0;
char rep;
char i;
char maxlength=5;
for (i=0;i<=maxlength;i++,*ptr=0); // marque la fin de la chane


while(1)
{
rep=getch();if (rep==0)
{
getch();
// donne le code des touches de fonction
}
*ptr=rep;

// Conversion minuscules/majuscules

switch(*ptr)
{
case '&'  : *ptr='1'; break;
case -126 : *ptr='2'; break;
case '"'  : *ptr='3'; break;
case '\'' : *ptr='4'; break;
case '('  : *ptr='5'; break;
case '-'  : *ptr='6'; break;
case -118 : *ptr='7'; break;
case '_'  : *ptr='8'; break;
case -121 : *ptr='9'; break;
case -123 : *ptr='0'; break;
case 'a' :*ptr='A'; break;
case 'b' :*ptr='B'; break;
case 'c' :*ptr='C'; break;
case 'd' :*ptr='D'; break;
case 'e' :*ptr='E'; break;
case 'f' :*ptr='F'; break;
case 'g' :*ptr='G'; break;
case 'h' :*ptr='H'; break;
case 't' :*ptr='T'; break;
case 'm' :*ptr='M'; break;
case 'p' :*ptr='P'; break;
case 'r' :*ptr='R'; break;
case 'w' :*ptr='W'; break;
case 'n' :*ptr='N'; break;
}


// Continuer s'il ne s'agit pas d'un caractere acceptable
if (*ptr!=13 && *ptr!=8 
	&& *ptr!='1'
	&& *ptr!='2'
	&& *ptr!='3'
	&& *ptr!='4'
	&& *ptr!='5'
	&& *ptr!='6'
	&& *ptr!='7'
	&& *ptr!='8'
	&& *ptr!='9'
	&& *ptr!='0'
	&& *ptr!='A'
	&& *ptr!='B'
	&& *ptr!='C'
	&& *ptr!='D'
	&& *ptr!='E'
	&& *ptr!='F'
	&& *ptr!='G'
	&& *ptr!='H'
	&& *ptr!='M'  // pour cm
	&& *ptr!='T'  // pour ct
	&& *ptr!='P'  // pour p
	&& *ptr!='N'
	&& *ptr!='R'
	&& *ptr!='W'
	) continue;	  


if (*ptr!=13) // CR
{
if (*ptr==8)
{
if (nbcar>=1)
{
putch(8); putch(0); putch(8);
ptr--;
nbcar--;
}
continue;
}
else
{
// 32 est l'espace
if (*ptr<=32 || nbcar==maxlength-1) {putch(7); continue;}
putch(*ptr);
nbcar++;
ptr++;
} // fin else *ptr!=8
} // fin if *ptr==13
else  // CR
{
if (nbcar>0) // au moins un caractre pour breaker
{
*ptr=0; // fin de chaine
break;
}
}
} // fin while (1);

return nbcar;
} // fin getstring_move()




void makepiece(char pos,char num, char color)
{
PIECE *wptr;
CASE *cptr;

wptr=&xw[num];
wptr->num_piece=num;
wptr->nature=color*xxboard_original_french[TO88(pos)];
wptr->color=color;
wptr->color01=TO_COLOR01(color);
//wptr->piece_doublement_tour=-1;
if (wptr->nature=='R')
{
xnum_roi[TO_COLOR01(color)]=num;
}
wptr->pos=pos;
cptr=&xboard[pos];
wptr->posx=cptr->posx;
wptr->posy=cptr->posy;
//wptr->diag1=cptr->diag1;
//wptr->diag2=cptr->diag2;

} // fin makepiece



// Fonction askmove
// Demande de coup adverse avec ou sans permanent brain
char askmove()
{
char rep[6];
char confirm;
char i;
char cc,ee;
MOVE move;
char check;
char dep,arr;
char prom;
char length;
//char num;
char Fquestion;
double time;
PIECE *wptr;
//char *ptr;

// Initialisations 
ee=0;

// Initialisation xask au cas o la recherche sur temps
// adverse est interrompue pour permettre un take_back
strcpy(xask,"");


// Lancement ventuel de la recherche sur temps adverse
if (xconsole_mode)
{
if (xpermanentbrain_is_on && xmode!='C' 
	&& xnbcoups>0)
{

// Jeu du coup adverse en anticipation
// Permanent brain = recherche sur temps adverse
start_permanent_brain();

} // Fin lancement start_permanent_brain
} // END_MODE;

// Attente en mode UCI
if (xuci_mode)
{
strcpy(uci_interface::trace_location,"Waiting ....");
do
{
xsearch_on=false; // Le programme est de nouveau disponible
uci_interface::get_and_process_uci_buffer(0);

// Sortie
if ( uci_interface::F_go || uci_interface::F_go_ponder )
{
	break;
}

// Temporisation
Sleep(100);
}
	while (1);  


// Dmarrer le pondering
if ( uci_interface::F_go_ponder ) 
{
uci_interface::F_go_ponder=false;
if (xpermanentbrain_is_on && xnbcoups>0)
{
// Jeu du coup adverse en anticipation
// Permanent brain = recherche sur temps adverse
if (xtrait==1)
{
	if (xwtm==1) xmode='B';
	else xmode='N';
}
else // xtrait==0
{
	if (xwtm==0) xmode='N';
	else xmode='B';
}

start_permanent_brain();
} 
} // Fin lancement start_permanent_brain en mode UCI

// Si go, le coup a dja t jou en mode UCI
if ( uci_interface::F_go ) 
{ 
	uci_interface::F_go=false;
	// Ajustement de xmode
	if (xtrait==1)
	{
		if (xwtm==1) xmode='B';
		else xmode='N';
	}
	else // xtrait==0
	{
		if (xwtm==0) xmode='N';
		else xmode='B';
	}
	goto SORTIE; 
}

} // END_MODE



if (xconsole_mode)
{
// Initialisations
xlv1_wtm=xwtm; // pour searchmove
ASSERT(xlevel==0);
xsearch_level[0]->actualise_all();
check=xsearch_level[0]->check;
xsearch_level[0]->reactu_liste_nombre=0;
} // END_MODE



// Obtention du coup
do // 1
{

// Aucun coup n'a t obtenu pralablement pendant le pondering
if (!xpb_move_has_been_entered)
{
if (xconsole_mode)
{
// Obtention du coup au clavier
Fquestion=false; // question complmentaire pour les promotions
// si le coup a t jou en permanent brain, 
// la question a dja t pose
if (strcmpi(xask,"")==0) 
{
printf("\nVotre coup : ");
length=getstring_move(rep);
}
// Ou coup dans xask 
else strcpy(rep,xask); 


// Suite coup entr au clavier
if (strcmpi(rep,"TB")==0) 
{
strcpy(rep,""); // rinitialisation
strcpy(xask,""); // rinitialisation
if (xnbcoups==0)
{
printf("\nTake back impossible - Position de dpart");
}
else // OK pour Take_back
{
//==0 les deux chanes sont identiques
// traitement du takeback
ee=TAKE_BACK;
break;
}
}

if (strcmpi(rep,"CTB")==0)  // Change time blanc
{
strcpy(rep,""); // rinitialisation
strcpy(xask,""); // rinitialisation
//==0 les deux chanes sont identiques
printf("\nEntrer le temps restant en minutes : ");
time=getlong(4);
// Ajustement du temps cumul de l'autre joueur
xtimecumul[1]=xavailable_time[1]-(long)time*60;
ee=CHANGE_TIME;
continue;
}


if (strcmpi(rep,"CTN")==0)  // Change time noir
{
strcpy(rep,""); // rinitialisation
strcpy(xask,""); // rinitialisation
//==0 les deux chanes sont identiques
printf("\nEntrer le temps restant en minutes : ");
time=getlong(4);
// Ajustement du temps cumul de l'autre joueur
xtimecumul[0]=xavailable_time[0]-(long)time*60;
ee=CHANGE_TIME;
continue;
}


if (strcmpi(rep,"CM")==0) // Change Mode
{
strcpy(rep,""); // rinitialisation
strcpy(xask,""); // rinitialisation
//==0 les deux chanes sont identiques
// traitement du takeback
printf("\nChange Mode");
printf("\nMode automatique : A");
printf("\nOrdinateur=blanc=white : B");
printf("\nOrdinateur=noir=black  : N");
printf("\nContrle coups   : C");
printf("\nEntrez le mode slectionn : ");
cc=getON("ABNC");
do
{
if (cc==xmode) break; // on continue si xmode est inchang
if (xmode=='B' && xwtm==1) break; // continuer
if (xmode=='N' && xwtm==0) break; // continuer
xmode=cc; // inversion de couleur ou mode automatique
ee=CHANGE_MODE; // signature
break;
}while(1);
if (ee==CHANGE_MODE) break; // sortie de askmove
} // fin CM - Change Mode



if (strcmpi(rep,"P")==0 || strcmpi(rep,"CC")==0) // Play - Change color)
{
printf("\nPlaying...\n");
strcpy(rep,""); // rinitialisation
strcpy(xask,""); // rinitialisation
// Change color
ee=CHANGE_MODE; // signature
if (xwtm==0) xmode='N';
if (xwtm==1) xmode='B';
break;
} // fin P ou ChangeColor


if (strcmpi(rep,"C")==0) // Mode contrle)
{
strcpy(rep,""); // rinitialisation
strcpy(xask,""); // rinitialisation
// Change color
ee=CHANGE_MODE; // signature
xmode='C';
break;
} // fin CM - Change Mode



// Abandon blanc
if ( strcmpi(rep,"WR")==0  ||
     strcmpi(rep,"AB")==0  ||
     strcmpi(rep,"BA")==0 )  
{
if ( !xresigns )
{
printf("\nConfirmer (y/n) : ");
confirm=getON("ON");
if ( confirm=='O' ) xresigns=true;
}
if ( xresigns )	
{
strcpy(rep,""); // rinitialisation
strcpy(xask,""); // rinitialisation
ee=WHITE_RESIGNS;
break;
} 
} // fin abandon blanc 



// Abandon noir
if ( strcmpi(rep,"BR")==0  ||
     strcmpi(rep,"AN")==0  ||
     strcmpi(rep,"NA")==0   )
{
if ( !xresigns )
{
printf("\nConfirmer (y/n) : ");
confirm=getON("ON");
if ( confirm=='O' ) xresigns=true;
}
if ( xresigns )	
{
strcpy(rep,""); // rinitialisation
strcpy(xask,""); // rinitialisation
ee=BLACK_RESIGNS;
break;
} 
} // fin abandon noir


if (length!=4) continue;
//ptr=rep;
// for (i=0; i<=3; i++, ptr++) *ptr=toupper(*ptr);
_strupr(rep);
if (rep[0]<'A' || rep[0]>'H') continue;
if (rep[2]<'A' || rep[2]>'H') continue;
if (rep[1]<'1' || rep[1]>'8') continue;
if (rep[3]<'1' || rep[3]>'8') continue;

//dep88=(rep[0]-64)*10+rep[1]-48;
//arr88=(rep[2]-64)*10+rep[3]-48;

dep=(rep[0]-65)*8+rep[1]-49;
arr=(rep[2]-65)*8+rep[3]-49;


wptr=xboard[dep].wptr;


// Contrle de lgalit du coup
// pour les coups saisis au clavier
// A conserver dans l'immdiat et ensuite supprimer !
Fquestion=false; // Flag question pice pose pour les promotions


do //2 Premire boucle pour grer les sorties immdiates
{
ee=0;

// Pice de la bonne couleur
if (wptr->color01!=xwtm) break;

// Pice existante
if (wptr->nature==0) break;

// Solution 2
// Prsence dans la liste des coups
for (i=0;i<=LENGTH_SEARCHLISTMOVES;i++)
{
move=xtablexx[i];
if (move==NULL) break;

if (MOVE_DEP64(move)!=dep || MOVE_ARR64(move)!=arr) continue;

// Note : pb pour les prises de pions en septime
// Le programme peut les refuser parce qu'il n'y a pas prise en
// passant. Il sort alors que la prise normale est possible.
// Il faut donc boucler sur la totalit de la liste en bouclant
// le nombre de coups valides

// Question supplmentaire pour les promotions
if (MOVE_IS_PROMOTION(move))
// les deux conditions sont a priori vrifies
{

if (!Fquestion && !xpb_move_has_been_entered)
{	
if ( xenable_sound ) printf("\a");
printf("\nEntrez la pice promue (DTFC) : ");
prom=getON("DTFC");
Fquestion=true;
}


if (prom!=MOVE_PROMOTION(move))
{
// la bonne promotion n'a pas encore t selectionne
continue; 
}
} // fin move est promotion


// Contr"le de lgalit du coup (hors clouage)
// La lgalit a dja t vrifie
// Le coup existe et est lgal

// Sortie en succs
ee=1;
// Enregistrement du coup
xkeep[1]=move;
xkeep[2]=LigneEndAskmove;

break; // sort du while sur un succs
} // fin for xtablexx

break; // sort du do 2 (utile pour les sorties immdiates
} while (1); // do 2

END_MODE;

// Entre du coup jou par l'adversaire en mode UCI aprs pondering en chec
// UCI a arrt le pondering par un stop ou on en est sorti pour cause de mat par exemple
// UCI arrte toujours le pondering en cas d'chec par un stop et donc !xpb_move_has_been_entered
UCI_MODE;
strcpy(uci_interface::trace_location,"Waiting permanent-brain uci");
xsearch_on=false; // le programme est bien disponible
do
{
uci_interface::get_and_process_uci_buffer(0);

// Sortie sur un go ou un ponderhit
// Go
if ( uci_interface::F_go )
{
	uci_interface::F_go=false;
	// Ajustement de xmode
	if (xtrait==1)
	{
		if (xwtm==1) xmode='B';
		else xmode='N';
	}
	else // xtrait==0
	{
		if (xwtm==0) xmode='N';
		else xmode='B';
	}
	goto SORTIE;	
}

// Ponderhit
// UCI envoie d'abord "stop" pour arrter le pondering
// => on est sorti du pondering en cas de ponderhit
// => rem : on en sort galement si il y a mat de toute faon en mode CONSOLE comme UCI
if ( xpb_move_has_been_entered )
{
// Enregistrement du coup
xkeep[1]=xpb_move_entered;
xkeep[2]=0;
ee=1; // marque succs reconnaissance coup
break; // sort du while
}

// Temporisation
Sleep(100);
}
while (1);  

END_MODE;

} // Fin pas de coup pralablement entr
else 
// Coup dja saisi saisi pendant la rflexion de l'ordinateur
// (xpb_move_has_been_entered)
// a priori donc en mode CONSOLE car en mode UCI on sort sur un stop et donc !xpb_move_has_been_entered
{
// Enregistrement du coup entr par l'adversaire
xkeep[1]=xpb_move_entered;
xkeep[2]=0;
ee=1; // marque succs reconnaissance coup
}


// Succs ou pas succs
if (ee==0)
{
if ( xenable_sound ) printf("\a");
// en dbut de do 1 : Fquestion=false; // question compmentaire des promotions
continue; // continue le do 1
}
else break;
}
while (1); // do 1


// Traitement abandon blanc et noir
if (ee==BLACK_RESIGNS) 
	return BLACK_RESIGNS;
if (ee==WHITE_RESIGNS) 
	return WHITE_RESIGNS;


// Traitement du Takeback
if (ee==TAKE_BACK) // takeback
{
xpondering_result_is_available=false;
xmove_has_been_pondered=false;
take_back();
return TAKE_BACK;
}

// Traitement du Change Mode
if (ee==CHANGE_MODE)
{
xpondering_result_is_available=false;
xmove_has_been_pondered=false;
return CHANGE_MODE;
}

// Coup examin sur le temps de l'adversaire
if (xpermanentbrain_is_on && xpondering_result_is_available)
{
if (SAME_MOVE(xkeep[1],xpondered_move)) xmove_has_been_pondered=true;
else						  xmove_has_been_pondered=false;
}

// Sortie 
SORTIE:
// Valeurs retournes par le coup adverse
xlastvalue1=xlastvalue0; // On laisse xlastvalue1 inchang
//xlastvaluemat1=xstates[0].materiel;
return 0; 
} // fin fonction askmove




void start_permanent_brain() // Jeu du coup adverse en anticipation
{
PIECE *wptr;
char cc;
char ee;
char game;
MOVE move;
MOVE *moveptr;
char check;
short lastprise1_mem; // pas char !!!
STATEVALUES states_mem;
MOVE lastmove_mem;
short nbcoups_mem;
short lastvalpos0_mem;
//short lastvalposmat0_mem;
//bool F_legal_par_1;
//LEGALITY legal_par_2;
char phase;
char num;

// Remarque : en mode UCI le coup a dja t jou
// via un ordre position startpos moves suivi d'un go ponder

CONSOLE_MODE;
// Vrification de l'existence et de la lgalit
// du coup slectionn
// Prcaution afin d'viter qu'un coup illgal
// (a priori impossible, mais ...)
// ne dtriore les donnes.


// Retour immdiat si pas de coup sur lequel partir
// Elimination des passe
if (!MOVE_IS_FOR_PLAY(xkeep[2])) return;


// Objectif : Vrifier que le coup est lgal
// Au niveau 0, tout a dja t actualis
// une actualisation nouvelle n'est pas utile

// Initialisations
xpb_move_has_been_entered=false;
xpondering_result_is_available=false; // Dbut de la recherche

// REM : xkeep2 contient le coup concern
// sur lequel faire dmarrer la recherche
//wptr=MOVE_PIECE(xkeep[2]);
wptr=xboard[MOVE_DEP64(xkeep[2])].wptr;
num=wptr->num_piece;

// Mmorisations
nbcoups_mem=xnbcoups;
states_mem=xstates[0];
lastprise1_mem=xlastprise1;
// Sauvegarde de paramtres de base
// Attention : lastmove_mem et xlastmove pointent sur une instance de coup
// propre
lastmove_mem=xlastmove;
lastvalpos0_mem=xlastvalue0;
//lastvalposmat0_mem=xlastvaluemat0;

// Autres initialisations
xlevel=0;
xnbcoups++;
if (xnbcoups>xmaxnbcoups) 
{
xpartie=(ENREGISTREMENT*)realloc(xpartie,(xmaxnbcoups+50+2)*sizeof(ENREGISTREMENT));
if (xpartie==0)
	log_error("\nErr Sm 172");
xmaxnbcoups+=50;
}


// Suite initialisations
check=xsearch_level[xlevel]->check;


do //1 Boucle pour grer les sorties immdiates
{
ee=0;

// Pice de la bonne couleur
if (PIECE_COLOR01(wptr)!=xwtm) break;

// Pice existante
if (PIECE_NATURE(wptr)==0) break;

//moveptr=&xw_liste_coups_piece[0][num][0]-1;
moveptr=xw[num].psptr->moves-1;
phase=AUTRES_COUPS;
do // Boucle sur la pice
{
	moveptr++;
	move=(MOVE)*moveptr;
	if (move==0)
	{
		if (phase==AUTRES_COUPS)
		{
			phase=PRISES;
			//moveptr=&xw_liste_coups2_piece[0][num][0]-1;
			moveptr=xw[num].psptr->moves2-1;
			continue;
		}
		else break;
	} // Fin fin de liste

	// Test correspondance
	if (!SAME_MOVE(move,xkeep[2])) continue;

	// Test de lgalit du coup
	num=xboard[MOVE_DEP64(move)].num_piece;
	cc=xsearch_level[0]->legal(num,move,xnum_roi[xwtm],xlastmove);
	// Illgal
	if (cc!=LEGAL) continue;;
	
	// Recopie du coup sur xkeep[1] pour jeu
	xkeep[1]=move;
	ee=1; // le coup existe et est lgal
	break;
} while(1); // fin do bouclage sur la pice 



break; // sort du do 2 (utile pour les sorties immdiates
} while (1); // do 2


if (ee==0)
{
	// Echec de la rflexion sur temps adverse
	goto SORTIE_STARTPB;
}


// Jeu du coup slectionn

// Stockage du coup suppos de l'adversaire
xpondered_move=move;
//xpondered_move.num_piece=actual_num_piece;
//xpondered_move.prise_nat=actual_prise_nat;
//xpondered_move.prise_num=actual_prise_num;


// MAJ xlastprise1
if (MOVE_CHANGES_LASTPRISE(xpondered_move))
{
xlastprise1=xnbcoups;
xstates[0].lastprise2=xnbcoups;
}
if (xnbcoups-xlastprise1>=100)
{
// le coup envisageable aboutit  un dpassement de coups
// il est inutile de le tester
// reprendre un coup sans question au joueur
goto ECHEC_PB; // le GOTO est ici le plus simple !
}


// Jeu du coup
ASSERT(xlevel==0);
xsearch_level[0]->jouer(move); // MAJ xstates[0]
xsearch_level[0]->maj_roque(move); 
//if (++xhash_indice_generation==127) xhash_indice_generation=0;
xlastmove=xpondered_move;
//copieMOVE_special(&xlastmove,&xpondered_move);
// Actualisation des coups
//actualise(&xpondered_move,actualise);
xsearch_level[0]->actualise_all(); 
//check=xsearch_level[0]->check;

// Recopie du xstates[0] mis  jour par jouer au level 1
//xstates[1]=xstates[0];

// Rinitalisation
// En effet, on risquerait sinon de dborder au fil du temps
// car cette valeur n'est sinon jamais rinitialise
xsearch_level[0]->reactu_liste_nombre=0;


// Enregistrement du coup sur fichier
// enregistrer(dep, arr, prom, special, prise_nat, prise_num);
// Pas d'enregistrement du coup
// Il est seulement djou  la fin

// Rgle des 50 coups
// mise  jour lastprise1 et lastprise2

// Copie du coup dans la xliste50
//xliste50[xnbcoups-xlastprise1]=move;
xliste50[xnbcoups-xlastprise1]=gen_code(0);


#if DEBUG==1
#if CHECK_REPET==1
char dd;
// Copie de la position - rptition
// aprs le coup
xptr=&xpositions[xnbcoups-xlastprise1][0];
wptr2=&xw[31];
for (xp=31; xp>=0; xp--, wptr2--, xptr++)
{
if (wptr2->nature==0) { *xptr=0; continue; }
*xptr=wptr2->pos;
}
dd=fct_repetition2(move,xlastprise1);
#endif
#endif


// Vrification rptition de coup
//cc=fct_repetition(move,xlastprise1);
cc=fct_repetition(move,gen_code(0),xlastprise1);
if (cc!=NOT_DRAW)
{
// rptition : inutile d'analyser le coup
// reprendre un coup sans question au joueur
goto ECHEC_PB; // le GOTO est ici le plus simple !
}

END_MODE; // fin mode console


UCI_MODE;
// En mode UCI, le coup a dja t jou
xpondered_move=xlastmove;
END_MODE;


// Diffrentiel temporaire d'valuation
// (aprs le jeu du coup)
// diffrence entre l'valuation de la position et la situation
// matrielle relle
//xsearch_level[1].valposmat=TO_PLAYER(xwtm)*(long)xstates[0].materiel;
//xdiffval=xlastvaluemat0-xsearch_level[1].valposmat*TO_PLAYER(xwtm);
//xdiffval=xlastvaluemat0-PLAYER(TO_PLAYER(xwtm),xstates[0].materiel);
// Note : ceci peut tre laiss en start_permanent_brain


// Lancement de la recherche
xpb_move_has_been_entered=false;
xpb_explo=true;
xpb_fail=false;
xpb_guessed=false;
CONSOLE_MODE;
printf ("\nThinking (S to stop)..."); 
END_MODE;
game=searchstart_pb();

// Non rinitialis
// Initialis en dbut de search normal
// xpb_explo=false;
// pas de rinitialisation immdiate de xpb_move_has_been_entered


// Arrt de la pendule si celle-ci a t mise en marche
if (xpb_move_has_been_entered) 
{
// si un coup a t saisi, l'horloge a t mise en marche
// il faut dcompter
xtime=get_time_in_seconds();
xtempscoup=(long) (xtime-xtdebut);
// Note : pas de prise en compte du temps de 
// manipulation  ce niveau
// En effet : le temps de manipulation existe
// que la recherche ait t interrompue OU que la 
// recherche soit alle  son terme
// L'enregistrement du temps de manipulation a donc lieu
// au moment de tester xmove_has_been_pondered avant askmove dans chess.cpp
if (xtempscoup==0) xtempscoup=1;
xtimecumul[xwtm]+=xtempscoup;

} // fin if
// le temps ultrieur est ngligeable



// Pas de vrification en mode UCI
// Si chec de rflexion, UCI enverra de toute faon "ponderhit" et attendra de toute faon
// une rponse => il faudrait grr ce cas et simuler un "position startpos moves" suivi d'un "go"
// Trop compliqu
// En mode UCI, on suppose que le coup retourn par le permanent brain est toujours OK
//UCI_MODE;
//goto REGISTER_MOVE;
//END_MODE;


// Retour immdiat si chec
if (xpb_fail ||
	END_OF_LINE(xkeep[1])
	) 
{

ECHEC_PB: // Label ECHEC

// Reset des hash tables
// en cas d'chec cr il n'y	a pas d'affichage
// du coup jou => on va partir sur une autre recherche
#if USE_HASH_TABLE==1
#if RESET_HASH_TABLE==1 
// Le flag sert  l'alternance blanc noir
reset_hash_table();
#endif
#endif


// Djouer le coup propos de l'adversaire
ASSERT(xlevel==0);
xsearch_level[0]->dejouer(xpondered_move,1);
xnbcoups--;
// Attention : en recherche sur le temps adverse
// le coup de l'adversaire a t jou et le pointeur de pice
// pointe pour la pice joue sur le niveau 0
// APRES QUE LE COUP AIT ETE JOUE 
// Il faut donc ractualiser
// Seule solution
xlv1_wtm=xwtm; // pour searchmove
xsearch_level[0]->actualise_all(); 
check=xsearch_level[xlevel]->check;

// Rinitalisation
// En effet, on risquerait sinon de dborder au fil du temps
// car cette valeur n'est sinon jamais rinitialise
xsearch_level[0]->reactu_liste_nombre=0;

// Echec de la rflexion sur temps adverse
// statut=0;
goto SORTIE_STARTPB;
}


// Vrification de la lgalit du coup propos en retour
// (par prcaution et pour viter une ventuelle
//  erreur de lecture dans xbest)
xlevel=0;
//dep=xkeep[1].movedep;
//arr=xkeep[1].movearr;
//prom=xkeep[1].movepiece_prom;
//special=xkeep[1].movepecial;
//prise_nat=xkeep[1].prise_nat;
//prise_num=xkeep[1].prise_num;

wptr=MOVE_PIECE(xkeep[1]);
num=wptr->num_piece;
check=xsearch_level[xlevel]->check; // suivant actu prcdente
	
do //1 Boucle pour grer les sorties immdiates
{
ee=0;

// Pice de la bonne couleur
if (PIECE_COLOR01(wptr)!=xwtm) break;

// Pice existante
if (PIECE_NATURE(wptr)==0) break;


//moveptr=&xw_liste_coups_piece[0][num][0]-1;
moveptr=xw[num].psptr->moves-1;
phase=AUTRES_COUPS;
do // Boucle sur la pice
{
	moveptr++;
	move=*moveptr;
	if (move==0)
	{
		if (phase==AUTRES_COUPS)
		{
			phase=PRISES;
			//moveptr=&xw_liste_coups2_piece[0][num][0]-1;
			moveptr=xw[num].psptr->moves2-1;
			continue;
		}
		else break;
	} // Fin fin de liste

	// Test correspondance
	if (!SAME_MOVE(move,xkeep[1])) continue;

	// Test de lgalit du coup
	cc=xsearch_level[0]->legal(MOVE_NUM_PIECE(move),move,xnum_roi[xwtm],xlastmove);
	// Illgal
	if (cc!=LEGAL)
	
	ee=1; // le coup existe et est lgal
	break;
} while(1); // fin do bouclage sur la pice 




break; // sort du do 2 (utile pour les sorties immdiates
} while (1); // do 2

if (ee==0) goto ECHEC_PB; 
// Le coup propos n'est pas lgal


// Stockage de la rponse au coup adverse
// REGISTER_MOVE:
xpondering_answer=xkeep[1];
xpondering_answer_answer=xkeep[2];
xpondering_answervalue=xlastvalue1;
//xpondering_answervaluemat=xlastvaluemat1;
xpondering_result_is_available=true;


// Djouer le coup propos de l'adversaire
ASSERT(xlevel==0);
xsearch_level[0]->dejouer(xpondered_move,1);
xnbcoups--;
// Attention : en recherche sur le temps adverse
// le coup de l'adversaire a t jou et le pointeur de pice
// pointe pour la pice joue sur le niveau 0
// APRES QUE LE COUP AIT ETE JOUE 
// Il faut donc ractualiser
// Mais la pice n'occupe pas la case d'arrive
// mais la case de dpart ( le coup a t djou !! )
// il faudrait donc inverser dep et arr !!
// problme : il y a les roques aussi
// Donc le plus simple : actualisation
xlv1_wtm=xwtm; // pour searchmove
xsearch_level[0]->actualise_all(); 
check=xsearch_level[0]->check;

// Rinitalisation
// En effet, on risquerait sinon de dborder au fil du temps
// car cette valeur n'est sinon jamais rinitialise
xsearch_level[0]->reactu_liste_nombre=0;;

SORTIE_STARTPB:

CONSOLE_MODE;
// Rinitialisations
xstates[0]=states_mem;
xlastprise1=lastprise1_mem;
xnbcoups=nbcoups_mem;
//copieMOVE_special(&xlastmove,&lastmove_mem);
xlastmove=lastmove_mem;
xlastvalue0=lastvalpos0_mem;
//xlastvaluemat0=lastvalposmat0_mem;
END_MODE;

xpb_fail=false; 
xpb_guessed=false;

// Retour
return; // succs de la recherche sur temps adverse
} // fin start_permanent_brain







char searchstart_pb()
{
// Cette fonction lance la recherche 
// sur le temps de l'adversaire
char game;


// Lancement du chronomtre
// Ide : 40 coups ... jouer sur le temps restant
// Acclerer la cadence pour respecter cette rgle

// Fixation du temps en permanent brain
fixe_bornetemps();


// Calcul du temps en secondes 
// xtdebut est rinitialis si le coup est devin
// xtdebut_original peut servir au calcul de la vitesse
xtdebut=get_time_in_seconds();
xtdebut_original=xtdebut;


// Lancement de la recherche
game=searchstart();


return game;
} // fin searchstart_pb



// Demande coup adversaire en permanent brain
char askmove_search(void)
{
char rep[10];
char confirm;
char length;
char i;
char dep, arr, prom;
prom=0;
MOVE move;
char ee;
//char *ptr;

// char Fquestion;

// Obtention du coup
do
{
printf("\nVotre coup : ");

length=getstring_move(rep);


if (strcmpi(rep,"TB")==0) 
{
//==0 les deux chanes sont identiques
// traitement du takeback
strcpy(xask,rep);
return 2; // Mettre fin  la rflexion sur temps adverse
}


if (strcmpi(rep,"CTB")==0)  // Change time blanc
{
strcpy(xask,rep);
return 2; // Mettre fin  la rflexion sur temps adverse
}


if (strcmpi(rep,"CTN")==0)  // Change time noir
{
strcpy(xask,rep);
return 2;
}


if (strcmpi(rep,"CM")==0) // Change Mode
{
strcpy(xask,rep);
return 2;
} // fin CM - Change Mode



if (strcmpi(rep,"P")==0 || strcmpi(rep,"CC")==0) // Play - Change color)
{
strcpy(xask,rep);
return 2;
} // fin CM - Change Mode


if (strcmpi(rep,"C")==0) // Mode contrle)
{
strcpy(xask,rep);
return 2;
} // fin CM - Change Mode


// Abandon blanc
if ( ( strcmpi(rep,"WR")==0  ||
       strcmpi(rep,"AB")==0  ||
       strcmpi(rep,"BA")==0   ) &&
     xwtm==1 )
{
printf("\nConfirmer (y/n) : ");
confirm=getON("ON");
if ( confirm='O' )
{
xresigns=true;
strcpy(xask,rep);
return 2;
} 
} // fin abandon blanc 



// Abandon noir
if ( ( strcmpi(rep,"BR")==0  ||
       strcmpi(rep,"AN")==0  ||
       strcmpi(rep,"NA")==0   ) &&
     xwtm==0 )
{
xresigns=true;
printf("\nConfirmer (y/n) : ");
confirm=getON("ON");
if ( confirm='O')
{
strcpy(xask,rep);
return 2;
} 
} // fin abandon noir




if (length!=4) continue;
//ptr=rep;
//for (i=0; i<=3; i++, ptr++) *ptr=toupper(*ptr);
_strupr(rep);
if (rep[0]<'A' || rep[0]>'H') continue;
if (rep[2]<'A' || rep[2]>'H') continue;
if (rep[1]<'1' || rep[1]>'8') continue;
if (rep[3]<'1' || rep[3]>'8') continue;

//dep88=(rep[0]-64)*10+rep[1]-48;
//arr88=(rep[2]-64)*10+rep[3]-48;

dep=(rep[0]-65)*8+rep[1]-49;
arr=(rep[2]-65)*8+rep[3]-49;


// Complment d'information pour les promotions
if ((Y64(dep)==1 && Y64(arr)==0)|| (Y64(dep)==6 && Y64(arr)==7) )
{
if (abs(xmempos[dep])=='P')
// 80 = 'P'
{	
if ( xenable_sound ) printf("\a");
printf("\nEntrez la pice promue (DTFC) : ");
prom=getON("DTFC");
}
}


// Vrifier la lgalit du coup
// Demander un coup lgal sinon en reprenant la boucle

// Prsence dans la liste des coups
ee=0; 
for (i=0;i<=LENGTH_SEARCHLISTMOVES;i++)
{
move=xtablexx[i];
if (move==0) break;

if (MOVE_DEP64(move)!=dep || MOVE_ARR64(move)!=arr) continue;

// Note : pb pour les prises de pions en septime
// Le programme peut les refuser parce qu'il n'y a pas prise en
// passant. Il sort alors que la prise normale est possible.
// Il faut donc boucler sur la totalit de la liste en bouclant
// le nombre de coups valides

// Question supplmentaire pour les promotions
if (MOVE_IS_PROMOTION(move))
// les deux conditions sont a priori vrifies
{


if (prom!=MOVE_PROMOTION(move))
{
// Fquestion=true; // question a t pose et mmorise
// la bonne promotion n'a pas encore t selectionne
continue; 
}
} // fin move_is_promotion


// Contr"le de lgalit du coup (hors clouage)
// La lgalit a dja t vrifie
// Le coup existe et est lgal
ee=1;
break; // sort du while sur un succs
} // fin for xtablexx

// Si succs (coup lgal), break
if (ee==1) break;
// Sinon continue

} while (1);


// Obtention du temps de dbut de rflexion
// mais une fois que la saisie est faite
// sinon cela revient  ajouter plusieurs fois le 
// temp de manipulation

xtdebut=get_time_in_seconds();


// Mmorisation du compteur 
// ( coups effectivement dcompts - aprs entre du coup adverse )
// Ne sera utils que si xmove_has_been_pondered
// xcompteur_start=xcompteur;
// n'est en fait pas utilis

// Stockage du coup entr
xpb_move_entered=move;
//xpb_move_entered.num_piece=move_actual_num_piece;
//xpb_move_entered.prise_nat=move_actual_prise_nat;
//xpb_move_entered.prise_num=move_actual_prise_num;
xpb_move_has_been_entered=true;


// Test : le coup entr est-il celui anticip
if (dep==MOVE_DEP64(xpondered_move))
{
if (arr==MOVE_ARR64(xpondered_move))
{
if (prom==MOVE_PROMOTION(xpondered_move)) return 1; // match
else							return 0; // nomatch
}
}
return 0; // par dfaut et pour la compatibilit Turbo C
} // fin askmove_search



void putsuffixe(char *nom_fich, char a, char b, char c)
{
char i=1;
while (*nom_fich!='\0' && i<20)
{
nom_fich++;
i++;
}
#if DEBUG==1
if (i==20)
{
log_error("\nI_931");
}
#endif
*nom_fich++='.';
*nom_fich++=a;
*nom_fich++=b;
*nom_fich++=c;
*nom_fich='\0';
} // fin putsuffixe




void formatte_move_to_uci( MOVE move, char *uci_move )
{
uci_move[0]=(X64(MOVE_DEP64(move)))+'a';
uci_move[1]=(Y64(MOVE_DEP64(move)))+'1';
uci_move[2]=(X64(MOVE_ARR64(move)))+'a';
uci_move[3]=(Y64(MOVE_ARR64(move)))+'1';
if (MOVE_IS_PROMOTION(move)) 
{
	uci_move[4]=french_to_english(MOVE_PROMOTION(move));
	uci_move[5]='\0';
	_strlwr(uci_move); // convertit Q en q
}
else uci_move[4]='\0';
} // formatte_move_to_uci



void display_info(char *info_message)
{
#if UCI_DEBUG==1
	UCI_MODE;
	return;
	END_MODE;
#endif
// Sortie UCI && CONSOLE  ( utiliser cout pour ARENA ) 
	UCI_MODE;
		while (info_message[0]=='\n') { info_message++; }; 
		cout << "info "; 
	END_MODE;
	cout << info_message; 
	PRINT_UCI_END_CHARACTER; 
	cout.flush();
}

void display_info_force(char *info_message)
{
	// Sortie UCI && CONSOLE  ( utiliser cout pour ARENA ) 
	UCI_MODE;
	while (info_message[0]=='\n') { info_message++; };
    cout << "info "; 
	END_MODE;
	cout << info_message; 
	PRINT_UCI_END_CHARACTER; 
	cout.flush();
}



void display_info_string(char *info_message)
{
#if UCI_DEBUG==1
	UCI_MODE;
		return;
	END_MODE;
#endif
// Sortie UCI && CONSOLE  ( utiliser cout pour ARENA ) 
	UCI_MODE;
		while (info_message[0]=='\n') { info_message++; }; 
		cout << "info string "; 
	END_MODE;
	cout << info_message; 
	PRINT_UCI_END_CHARACTER; 
	cout.flush();
}


void display_info_debug(char *info_message)
{
// Sortie UCI && CONSOLE  ( utiliser cout pour ARENA ) 
	UCI_MODE;
		while (info_message[0]=='\n') { info_message++; }; 
		cout << "info string "; 
	END_MODE;
	cout << info_message; 
	PRINT_UCI_END_CHARACTER; 
	cout.flush();
}


void log_to_file(char *log_entry)
{
	if (++xnb_logfile_entries<=MAX_LOGFILE_ENTRIES)
	{ 
		//if (xnb_logfile_entries==1) 
		//{
		//	write(xhandle_logfile,"New game\n\r", (unsigned) strlen("New game\n\r")); 
		//}
		write(xhandle_logfile,log_entry, (unsigned int)strlen(log_entry)); 
		write(xhandle_logfile,"\n\r", (unsigned) strlen("\n\r")); 
	}
}

#if LOG_MOVES==1
void log_moves_to_file(char *log_entry)
{
	{ write(xhandle_logfile,log_entry, (unsigned int)strlen(log_entry)); }
}
#endif


void log_error(char *error_message)
{
#if DISPLAY_NO_ERROR==1 && DEBUG==0
	return;
#endif
UCI_MODE;
	PRINT_UCI_INFO_STRING;
	while (error_message[0]=='\n') { error_message++; }
END_MODE;
cout << error_message; 
UCI_MODE;
	PRINT_UCI_END_CHARACTER;
END_MODE;
cout.flush();
CONSOLE_MODE;
getch();
END_MODE;
UCI_MODE;
#if UCI_STOP_ON_ERROR==1
char cc;
//getch();
cc=0;cc=1/cc;
cc=0;
#endif
END_MODE;
}

void log_error(char *error_message, unsigned __int64 compteur)
{
#if DISPLAY_NO_ERROR==1 && DEBUG==0
	return;
#endif
UCI_MODE;
	PRINT_UCI_INFO_STRING;
	while (error_message[0]=='\n') { error_message++; }
END_MODE;
cout << error_message << " en : " << compteur; 
UCI_MODE;
	PRINT_UCI_END_CHARACTER;
END_MODE;
cout.flush();
#if _DEBUG
CONSOLE_MODE;
char cc;
cc=0;cc=1/cc;
END_MODE;
#if UCI_STOP_ON_ERROR==1
UCI_MODE;
char cc;
cc=0;cc=1/cc;
cc=0;
END_MODE;
#endif
#endif
}



void log_info(char *message, unsigned __int64 compteur)
{
UCI_MODE;
	PRINT_UCI_INFO_STRING;
	while (message[0]=='\n') {message++; }
END_MODE;
CONSOLE_MODE;
	cout << "\n";
END_MODE;
cout << message << compteur; 
UCI_MODE;
	PRINT_UCI_END_CHARACTER;
END_MODE;
cout.flush();
}


void log_info(char *message, short compteur)
{
UCI_MODE;
	PRINT_UCI_INFO_STRING;
	while (message[0]=='\n') {message++; }
END_MODE;
cout << message << compteur; 
UCI_MODE;
	PRINT_UCI_END_CHARACTER;
END_MODE;
cout.flush();
}


void log_info(char *message, char compteur)
{
UCI_MODE;
	PRINT_UCI_INFO_STRING;
	while (message[0]=='\n') {message++; }
END_MODE;
cout << message << (short) compteur; 
UCI_MODE;
	PRINT_UCI_END_CHARACTER;
END_MODE;
cout.flush();
}



void log_info(char *message, bool compteur)
{
UCI_MODE;
	PRINT_UCI_INFO_STRING;
	while (message[0]=='\n') {message++; }
END_MODE;
cout << message << compteur; 
UCI_MODE;
	PRINT_UCI_END_CHARACTER;
END_MODE;
cout.flush();
}

void log_info(char *message)
{
UCI_MODE;
	PRINT_UCI_INFO_STRING;
	while (message[0]=='\n') {message++; }
END_MODE;
cout << message;
UCI_MODE;
	PRINT_UCI_END_CHARACTER;
END_MODE;
cout.flush();
}


void log_error_no_stop(char *error_message, unsigned __int64 compteur)
{
UCI_MODE;
	PRINT_UCI_INFO_STRING;
	while (error_message[0]=='\n') { error_message++; }
END_MODE;
cout << error_message << " en : " << compteur; 
cout << "\n";
UCI_MODE;
	PRINT_UCI_END_CHARACTER;
END_MODE;
cout.flush();
}



double get_time_in_seconds(void)
{
double time;
#if COMPILER==1
gettime(&xtimep);
time   =+(double)xtimep.ti_hour*60*60
        +(double)xtimep.ti_min*60
        +(double)xtimep.ti_sec
        +(double)xtimep.ti_hund/100;
#endif
#if COMPILER==2
_ftime(&xtimeptr);
// Secondes et millisecondes
time =+(double)xtimeptr.time
      +(double)xtimeptr.millitm/(double)1000;
// time(&xtdebut); Autre option donnant le temps en secondes
#endif
return time;
}



void dispose_engine(void)
{
free(xbibliotheque_88);
free(xbibliotheque);
free(xpartie);
free(xlc);
free(xhash_table);
uci_interface::Dispose();
exit(0);
}



void affiche_stat_elag(void)
{
/*
CONNSOLE_MODE;
#if COLLECT_STATS==1
printf("\nxelag 1 : Mieux aprs passe : %d" , xelag1);
printf("\nxelag 2 : Aplha-beta a priori : %d" , xelag2);
printf("\nxelag 4 : Mat en levelmax : %d" , xelag4);
printf("\nxelag 5 : Passe suffisant en levelmax : %d" , xelag5);
printf("\nxelag 6 : Alpha-beta : %d" , xelag6);
printf("\nxelag 7 : Suite suffisante %d" , xelag7);
printf("\nxelag 8 : Couverture d'checs suffisante : %d" , xelag8);
printf("\nxelag 9 : Suite suffisante en cas de passe : %d" , xelag9);
printf("\nxelag 11 : Elagage par insuffisance de suites %d" , xelag11);
printf("\nxelag 12 : Remplacement suite calme %d" , xelag12);
#endif
END_MODE;
*/}



void SEARCH::maj_coordonnees_roi(char color01)
{
char pos;

//wptr=&xw[xnum_roi[color01]];
pos=xw[xnum_roi[color01]].pos;

s->roi_pos[color01]=pos;
s->roi_posx[color01]=X64(pos);
s->roi_posy[color01]=Y64(pos);

// Maj quivalent_roque
if (s->roi_posx[color01]<=2) s->equivalent_droit_roque[color01]=GRAND_ROQUE;
else
{
	if (s->roi_posx[color01]>=5) s->equivalent_droit_roque[color01]=PETIT_ROQUE;
	else s->equivalent_droit_roque[color01]=s->droit_roque[color01];
}

} // fin maj_coordonnees_roi



void compact_piece_list()
{
PIECE *wptr;
char i, j;

#if DEBUG==1
	xsearch_level[0]->check_reset_state_values(0,0);
#endif

// Pas si xpb_explo
// En effet, en pondering, on joue un coup, puis on lance la recherche
// Ce coup peut avoir supprim une pice
// En retour de pondering, on djoue ce coup et on obtient une pice fantme
// qui n'existe pas dans xw
// Normalement, le problme ne se pose qu'en mode CONSOLE car le cout n'est pas djou en mode UCI
if (xpb_explo) return;

// BLanc
wptr=&xw[0];
for (i=0,j=0;i<=15;i++,wptr++)
{
if (wptr->nature==0) continue;
if (i==j) { j++; continue; }
xw[j]=*wptr;
xw[j].num_piece=j;
// Normal : le xw[j].psptr pointe vers le xpset[j][0]
xw[j].psptr=&xpset[j][0];
// Mauvaise formulation
// On recopie le contenu de l'ancien xpset[i][0]
// Donc le xpset[j].moves peut pointer vers une liste[i] ce qui est ennuyeux !
//*xw[j].psptr=*wptr->psptr;
// On souhaite toutefois copier les valeurs 
// Donc le plus simple est de faire cela mais de rinitialiser ensuite les pointeurs de liste
*xw[j].psptr=*wptr->psptr;
xw[j].psptr->moves=&xw_liste_coups_piece[0][j][0];
xw[j].psptr->moves2=&xw_liste_coups2_piece[0][j][0];
xw[j].psptr->oldptr=xw[j].psptr; // Au niveau 0
xboard[wptr->pos].num_piece=j;
xboard[wptr->pos].wptr=&xw[j];
if (wptr->nature=='R') xnum_roi[1]=j;
//if (MOVE_NUM_PIECE(xlastmove)==i) SET_MOVE_NUM_PIECE(xlastmove,j);
//if (MOVE_NUM_PIECE(xpondered_move)==i) SET_MOVE_NUM_PIECE(xpondered_move,j);

// Suppression ancienne pice
wptr->nature=0;
// Prochaine pice  remplacer
j++;
}
xw_size[1]=j-1;

// Noir
wptr=&xw[16];
for (i=16,j=16;i<=31;i++,wptr++)
{
if (wptr->nature==0) continue;
if (i==j) { j++; continue; }
xw[j]=*wptr;
xw[j].num_piece=j;
xw[j].psptr=&xpset[j][0];
// Mauvaise formulation
// On recopie le contenu de l'ancien xpset[i][0]
// Donc le xpset[j].moves peut pointer vers une liste[i] ce qui est ennuyeux !
//*xw[j].psptr=*wptr->psptr;
// On souhaite toutefois copier les valeurs 
// Donc le plus simple est de faire cela mais de rinitialiser ensuite les pointeurs de liste
*xw[j].psptr=*wptr->psptr;
xw[j].psptr->moves=&xw_liste_coups_piece[0][j][0];
xw[j].psptr->moves2=&xw_liste_coups2_piece[0][j][0];
xw[j].psptr->oldptr=xw[j].psptr;
xboard[wptr->pos].num_piece=j;
xboard[wptr->pos].wptr=&xw[j];
if (wptr->nature=='R') xnum_roi[0]=j;
//if (MOVE_NUM_PIECE(xlastmove)==i) SET_MOVE_NUM_PIECE(xlastmove,j);
//if (MOVE_NUM_PIECE(xpondered_move)==i) SET_MOVE_NUM_PIECE(xpondered_move,j);
// Suppression ancienne pice
wptr->nature=0;
// Prochaine pice  remplacer
j++;
}
xw_size[0]=j-1;

// L'actualisation permet ensuite de mettre  jour les __int32 de STATEVALUES, relatifs aux pices
// Mais  titre de prcaution, on actualise ici aussi
// Ceci a un impact par exemple sur statesptr->clouages[num]
// Ceci suppose que xboard a t initialis
xlv1_wtm=xwtm; // pour searchmove
xsearch_level[0]->actualise_all();
// Ncessaire aprs le compactage
#if _DEBUG
	xsearch_level[0]->check_reset_state_values(0,0); // no_reset
#endif
// Inutile : xsearch_level[0]->check_reset_state_values(0,1); // reset

#if VALUE_MINOR_PIECES==1
maj_liste_minor_pieces();
#endif

} // fin compact_piece_list()


#if VALUE_MINOR_PIECES==1
void maj_liste_minor_pieces()
{
PIECE *wptr;
char i,j;
// rem : il pourrait y avoir plus de 8 pices tant donn les promotions !!
// on se limite  8 (4 de chaque cot !)
#if VALUE_KNIGHTS_ONLY==1
for (j=0;j<=3;j++) xliste_minor_pieces[j]=-1;
for (i=0,j=0,wptr=&xw[0];i<=31 && j<=3;i++,wptr++)
{
	   if (wptr->nature!='C') continue;
	   xliste_minor_pieces[j++]=i;
}
#else
for (j=0;j<=7;j++) xliste_minor_pieces[j]=-1;
for (i=0,j=0,wptr=&xw[0];i<=31 && j<=7;i++,wptr++)
{
	   if (wptr->nature!='F' && wptr->nature!='C') continue;
	   xliste_minor_pieces[j++]=i;
}
#endif
}
#endif


void take_back(void)
{
short nbcoups_original;
short nbcoups;
short i;
static char F_multi_takeback; // A rinitialiser  zro en retour
static int nbcoupsrepris;
char F_first_takeback; 
// local : sert dans la suite de la routine
char cc;
char num,dep,arr,prom,special,prise_nat,prise_num;
ENREGISTREMENT *rptr; // record
MOVE move;
MOVE_BASE flag_prom, flag;
char color01;
char nature;

// Initialisations
// Si multi_take back ne pas initialiser Ffirst_takeback  1
if (!F_multi_takeback) F_first_takeback=true;
else				   F_first_takeback=false;
if (F_first_takeback) nbcoupsrepris=0;


// Nombre de coups au dpart
nbcoups_original=xnbcoups;
xnbcoups=0;

// Restauration des possibilits de roque initiales
// xstates[0].o_o[0]=xroqueini[0][0];
// xstates[0].o_o_o[0]=xroqueini[0][1];
// xstates[0].o_o[1]=xroqueini[1][0];
// xstates[0].o_o_o[1]=xroqueini[1][1];
// Maj roque et code_roque
// xstates[0].droit_roque[0]=xstates[0].o_o_o[0]+xstates[0].o_o[0];
// xstates[0].droit_roque[1]=xstates[0].o_o_o[1]+xstates[0].o_o[1];
xstates[0].droit_roque[0]=xroqueini[0];
xstates[0].droit_roque[1]=xroqueini[1];
// xstates[0].code_roque=xstates[0].droit_roque[1]|(xstates[0].droit_roque[0]<<SHIFT_ROQUE_NOIR);


// Init
cc=init();
// initialise via initvalue xposition et xmateriel

if (cc==0)
{
log_error("\nI_496 : Problme chiquier");
}


// Jeu des coups  partir du fichier temporaire
if (xtrait==1) xwtm=1;
else		   xwtm=0;
for (i=1;i<=nbcoups_original-1;i++)
{
rptr=&xpartie[i];
dep=TO64(rptr->dep88);
arr=TO64(rptr->arr88);
prom=rptr->prom;
special=rptr->special;
num=rptr->piece_num;
prise_nat=rptr->prise_nat;
prise_num=rptr->prise_num;
nature=xboard[dep].nature;
color01=xboard[dep].color01;
flag=0; flag_prom=0;

switch(special)
{
case 0 : flag=0; break;
case 1 : flag=MoveCastle; break;
case 2 : flag=MoveEnPassant; break;
case 3 : flag=MovePromote;
	switch(rptr->prom)
	{
	case 'C' :  flag_prom=MovePromoteKnight;
			break;
	case 'F' :  flag_prom=MovePromoteBishop;
			break;
	case 'T' :  flag_prom=MovePromoteRook;
			break;
	case 'D' :  flag_prom=MovePromoteQueen;
			break;
	default : log_error("\nErr I_689");
	}
	break;
}

move=MOVE_MAKE(nature,dep,arr,flag|flag_prom,0);

ASSERT(xlevel==0);
xsearch_level[0]->jouer(move);
xsearch_level[0]->maj_roque(move); // aprs jouer
xnbcoups++; 
if (xnbcoups>xmaxnbcoups) 
{
xpartie=(ENREGISTREMENT*)realloc(xpartie,(xmaxnbcoups+50+2)*sizeof(ENREGISTREMENT));
if (xpartie==0)
	log_error("\nErr Sm 190");
xmaxnbcoups+=50;
}


// Actualiser xlastmove  chaque fois
// Cela est ncessaire pour actualiser
// xlastprise 1 !!!!

// MAJ lastmove
// Important : voil pourquoi xlastmove pointe sur sa propre
// structure de coup !!!
// Ncessaire pour l'valuation de la prise en passant
//  placer avant l'actualisation donc
xlastmove=move;


// Rgle des 50 coups
// mise ... jour lastprise1 et lastprise2
// Attention : num n'est plus fiable !
if (MOVE_CHANGES_LASTPRISE(xlastmove))
{
xlastprise1=xnbcoups;
}
xstates[0].lastprise2=xlastprise1;


// Copie du coup dans la xliste50
//xliste50[xnbcoups-xlastprise1]=move;
xliste50[xnbcoups-xlastprise1]=gen_code(0);



#if CHECK_REPET==1
#if DEBUG==1
PIECE *wptr2;
char *ptr;
char ci1;
// Copie de la position - rptition
// aprs le coup
ptr=&xpositions[xnbcoups-xlastprise1][0];
wptr2=&xw[31];
for (ci1=31; ci1>=0; ci1--, wptr2--, ptr++)
{
if (wptr2->nature==0) { *ptr=0; continue; }
*ptr=wptr2->pos;
}
#endif
#endif

} // fin boucle sur liste de coups



// Affichage des dix derniers coup
nbcoups=xnbcoups-10;
nbcoups-=M_2(nbcoups)-1;
if ( nbcoups<1) nbcoups=1;
if ( xnbcoups==0 ) printf("\n=>Debut de partie");
for (;nbcoups<=xnbcoups;nbcoups++)
{
if (M_2(nbcoups)==1) printf("\n%d ",xpartie[nbcoups].ynbcoups);
printf("%6s ",xpartie[nbcoups].pgn);
}
printf("\n");

// Question : faut-il reprendre un autre coup ?
// (en boucle)

if (xnbcoups>=0)
{
if (xtrait==1) xwtm=1-xnbcoups%2;
else		   xwtm=xnbcoups%2;
printf("\n %d coup", ++nbcoupsrepris);
if (nbcoupsrepris>1) printf("s");
printf(" repris - ");
if (xwtm==0) printf("Noir  jouer");
else		 printf("Blanc  jouer");

// Proposer de reprendre un coup seulement si cela est possible
if (nbcoups_original-1>0)
{
printf("\nFaut-il reprendre un autre coup (y/n) : ");
cc=getON("ONY");
}
else cc='N'; // Impossible de reprendre un autre coup
if (cc=='O' || cc=='Y') 
{
F_multi_takeback=true;
take_back();
}
else // Fin de la reprise des coups
{
F_multi_takeback=false; // A initialiser
}
} // fin if question


// Rinitialisation de xpartie et de xpartie_pgn
// pour le coup repris
strcpy(xpartie[nbcoups_original].pgn, "\0");
xpartie[nbcoups_original].xnbcoups=0;
xpartie[nbcoups_original].ynbcoups=0;
xpartie[nbcoups_original].demicoup=0;
xpartie[nbcoups_original].dep88=0;
xpartie[nbcoups_original].arr88=0;
xpartie[nbcoups_original].status=0;
xpartie[nbcoups_original].check=0;


// Fin de take_back
if (F_first_takeback) 
{ 
    // Initialisations en fin de take-back
	xlv1_wtm=xwtm; // pour searchmove
	xsearch_level[0]->actualise_all(); // check=xsearch_level[0].check;
	xsearch_level[0]->reactu_liste_nombre=0;;
	liste_coups_legaux();
	// Mise  jour paramtres globaux
	ajustement_parametres_globaux();
	xsearch_level[0]->eval_pawnstruct();
	// Passage des tats au level 1
	//xstates[1]=xstates[0];
	// Autres valeurs
	xlastvalue0=xsearch_level[0]->fctn_eval();
	xlastvalue1=xlastvalue0;
	//xsearch_level[0].valposmat=TO_PLAYER(xwtm)*(long)xstates[0].materiel;
	//xsearch_level[1].valposmat=xsearch_level[0].valposmat;
	//xdiffval=0;
	if ( xlast_opening_move_used > xnbcoups ) 
	{ xlast_opening_move_used = xnbcoups; }
	// Recration de la partie au format PGN
	xhandle=cree_partie_pgn(xhandle,xnom_game,xpartie,xnbcoups);
// Remarque :
// il n'est utile de gnrer les coups
// que lorsque l'ensemble des take_backs ont t effectus
// Ceci correspond  la sortie de la fonction take_back
// sur le premier take_back
// ( en effet, les autres take_back sont appels depuis 
//   la fonction take_back elle mme )
}


// Rinitialisation Fmulti_takeback
// => inutile car il s'agit d'une variable STATIC
// if (F_first_takeback)
//	 F_multi_takeback=false;

// Dtermination des paramtres de reprise
// Inutile : xwtm est ok
//if (xtrait==1) xwtm=1-xnbcoups%2;
//else		   xwtm=xnbcoups%2;

xmode='C';
} // fin take_back()




void init_bitboards_and_others()
{
char i,j,k;
char inc,inc88;
char arr88, arr88_2, arr64_2;
char si;
char position_depart,dir;
//char si1, si2;

/*
xmasque_bordure=~0;
for (i=63;i>=0;i--)
{
if (i%8==0) { set_bit_to_0(xmasque_bordure_bas,i); continue; }
if (i%8==7) { set_bit_to_0(xmasque_bordure_haut,i); continue; }
//if (i<=7)   { set_bit_to_0(xmasque_bordure,i); continue; }
//if (i>=56)  { set_bit_to_0(xmasque_bordure,i); continue; }
}
*/

/*
// Initialisation des masques
xmasque_colonne_a=~0;
xmasque_colonne_h=~0;
for (i=63;i>=0;i--) 
{ 
	if (i<=7 ) set_bit_to_0(xmasque_colonne_a,i); 
	if (i>=56) set_bit_to_0(xmasque_colonne_h,i); 
} 
*/

// Initialisation des masques de septime
xmasque_septieme[1]=0;
xmasque_septieme[0]=0;
for (i=63;i>=0;i--) 
{ 
	if ((i&7)==6) set_bit_to_1(xmasque_septieme[1],i); 
	if ((i&7)==1) set_bit_to_1(xmasque_septieme[0],i); 
} 


// Nombre d'incrments par directions (8 directions normales)
// Pices
for (i=63;i>=0;i--)
{
for (j=7;j>=0;j--)
{
inc88=xinc88[j];
inc=xinc64[j];
arr88=TO88(i);
arr88_2=arr88;
si=0;
for (k=0;k<8;k++)
{
arr88_2+=inc88;
if (arr88_2<11 || arr88_2>88) break;
if (arr88_2%10==0) break;
if (arr88_2%10==9) break;
#if DEBUG==1
char dep,arr,cc,dd,ee,ff,gg;
dep=i;
arr=TO64(arr88_2);
dd=(X64(arr)-X64(dep));
ee=(Y64(arr)-Y64(dep));
cc=arr>=0 && arr<=63 && (
     dd==0 || ee==0 
	 || (abs(abs(dd)-abs(ee)))<2 );
#endif
#if DEBUG==1
ASSERT(MOVE_IS_OK_ASSERT(i,TO64(arr88_2),inc,IsNotKnight));
#endif
si++;
}
xnbinc_par_direction[i][j]=si;
}
}
// Cavaliers
for (i=63;i>=0;i--)
{
for (j=8;j<16;j++)
{
inc88=xinc88[j];
inc=xinc64[j];
si=0;
arr88=TO88(i);
for (k=0;k<8;k++)
{
arr88_2=arr88+inc88;
if (arr88_2<11 || arr88_2>88) break;
if (arr88_2%10==0) break;
if (arr88_2%10==9) break;
#if DEBUG==1
ASSERT(MOVE_IS_OK_ASSERT(i,TO64(arr88_2),inc,IsKnight));
#endif
si++; 
break; // au maximum 1 pour les cavaliers
}
xnbinc_par_direction[i][j]=si;
ASSERT(si<=7);
}
}


// Bilan attaque-dfense
BILAN_AD *bptr;
for (position_depart=63;position_depart>=0;position_depart--)
{
bptr=&xbilan_ad[position_depart][0];
for (dir=0; dir<=15; dir++, bptr++ )
{
if (dir<8) bptr->F_dir_cavalier=false;
else       bptr->F_dir_cavalier=true;
bptr->inc=xinc64[dir];
bptr->pos=position_depart+bptr->inc; 
bptr->nb_inc=1;
bptr->nbinc_max=xnbinc_par_direction[position_depart][dir];
bptr->direction_interrompue=0;
}
}



// Cases d'arrive des cavaliers
for (i=63;i>=0;i--)
{
xcases_arrivee_cavalier[i]=0;
arr88=TO88(i);
for (j=8;j<16;j++)
{
inc=xinc88[j];
arr88_2=arr88+inc;
if (arr88_2<11 || arr88_2>88) continue;
if (arr88_2%10==0) continue;
if (arr88_2%10==9) continue;
arr64_2=TO64(arr88_2);
set_bit_to_1(xcases_arrivee_cavalier[i],arr64_2); 
}
}


// Cases d'arrive roi
for (i=63;i>=0;i--)
{
xcases_arrivee_roi[i]=0;
arr88=TO88(i);
for (j=0;j<8;j++)
{
inc=xinc88[j];
arr88_2=arr88+inc;
if (arr88_2<11 || arr88_2>88) continue;
if (arr88_2%10==0) continue;
if (arr88_2%10==9) continue;
arr64_2=TO64(arr88_2);
set_bit_to_1(xcases_arrivee_roi[i],arr64_2); 
}
}

// Cases d'arrive fou
for (i=63;i>=0;i--)
{
xcases_arrivee_fou[i]=0;
arr88=TO88(i);
for (j=0;j<8;j++)
{
inc=xinc88[j];
if (abs(inc)!=9 && abs(inc)!=11) continue;
arr88_2=arr88;
do	{
	arr88_2+=inc;
	if (arr88_2<11) break;
	if (arr88_2>88) break;
	if (arr88_2%10==0) break;
	if (arr88_2%10==9) break;
	arr64_2=TO64(arr88_2);
	set_bit_to_1(xcases_arrivee_fou[i],arr64_2); 
	} while(1);
} // fin for dir
} // fin for


// Tour
for (i=63;i>=0;i--)
{
xcases_arrivee_tour[i]=0;
arr88=TO88(i);
for (j=0;j<8;j++)
{
inc=xinc88[j];
if (abs(inc)!=1 && abs(inc)!=10) continue;
arr88_2=arr88;
do	{
	arr88_2+=inc;
	if (arr88_2<11) break;
	if (arr88_2>88) break;
	if (arr88_2%10==0) break;
	if (arr88_2%10==9) break;
	arr64_2=TO64(arr88_2);
	set_bit_to_1(xcases_arrivee_tour[i],arr64_2); 
	} while(1);
} // fin for dir
} // fin for


// Dame
for(i=63;i>=0;i--)
{
xcases_arrivee_dame[i]=xcases_arrivee_fou[i]|xcases_arrivee_tour[i];
xcases_arrivee_all[i]=xcases_arrivee_dame[i]|xcases_arrivee_cavalier[i];
}



//// Compatibilit des cavaliers avec un chec futur possible
//for(i=63;i>=0;i--)
//{
//for (si1=8; si1<=15; si1++)
//{
//j=i+xinc64[si1];
//if (!bit(xcases_arrivee_cavalier[i],j)) { continue; }
//for (si2=8; si2<=15; si2++)
//{
//k=j+xinc64[si2];
//if (i==k) continue;
//if (!bit(xcases_arrivee_cavalier[j],k)) { continue; }
//xcases_echec_futur_cavalier[i][k]=true;
//}
//}
//}

// Cases d'checs des pions
for (i=63;i>=0;i--)
{
xcases_echec_pion[0][i]=0;
set_bit_to_1(xcases_echec_pion[0][i],i-7);
set_bit_to_1(xcases_echec_pion[0][i],i+9);
xcases_echec_pion[1][i]=0;
set_bit_to_1(xcases_echec_pion[1][i],i+7);
set_bit_to_1(xcases_echec_pion[1][i],i-9);
}






#if USE_CASES_ACTUALISATION==1
for (i=63;i>=0;i--)
{
xcases_actualisation_pion[1][i]=0;
if (Y64(i)==0 || Y64(i)==7) continue;
set_bit_to_1(xcases_actualisation_pion[1][i],i+1); 
if (Y64(i)==1)
{	
	set_bit_to_1(xcases_actualisation_pion[1][i],i+2); 
}	
if (X64(i)>0)
{
	set_bit_to_1(xcases_actualisation_pion[1][i],i-7); 
}
if (X64(i)<7)
{
	set_bit_to_1(xcases_actualisation_pion[1][i],i+9); 
}
} // fin for


for (i=63;i>=0;i--)
{
xcases_actualisation_pion[0][i]=0;
if (Y64(i)==0 || Y64(i)==7) continue;
set_bit_to_1(xcases_actualisation_pion[0][i],i-1); 
if (Y64(i)==6)
{	
	set_bit_to_1(xcases_actualisation_pion[0][i],i-2); 
}	
if (X64(i)>0)
{
	set_bit_to_1(xcases_actualisation_pion[0][i],i-9); 
}
if (X64(i)<7)
{
	set_bit_to_1(xcases_actualisation_pion[0][i],i+7); 
}
} // fin for
#endif



// Masque et masque inverses de directions
// (ne sert pas seulement  l'actualisation bitmap)
for (i=63;i>=0;i--)
{
arr88=TO88(i);
for (j=0;j<8;j++) // Directions de pices
{
inc=xinc88[j];
xmasque_direction[i][j]=0;
//xmasque=0;
arr88_2=arr88;
do
	{ 
	arr88_2+=inc;
	if (arr88_2<11) break;
	if (arr88_2>88) break;
	if (arr88_2%10==0) break;
	if (arr88_2%10==9) break;
	arr64_2=TO64(arr88_2);
	set_bit_to_1(xmasque_direction[i][j],arr64_2); 
	//set_bit_to_1(xmasque,arr64_2); 
	} while(1);
	// Inversion 
	xmasque_inverse_direction[i][j]=~xmasque_direction[i][j];
	//xmasque_inverse_direction[i][j]=~xmasque;
}
/*
for (j=8;j<16;j++) // Directions de cavaliers
{
inc=xinc88[j];
//xmasque_direction[i][j]=0;
xmasque=0;
arr88_2=arr88;
do
	{ 
	arr88_2+=inc;
	if (arr88_2<11) break;
	if (arr88_2>88) break;
	if (arr88_2%10==0) break;
	if (arr88_2%10==9) break;
	arr64_2=TO64(arr88_2);
	//set_bit_to_1(xmasque_direction[i][j],arr64_2); 
	set_bit_to_1(xmasque,arr64_2); 
	break; // une seule itration pour les directions de cavalier
	} while(1);
	// Inversion 
	// Pas de masque inverse pour les directions de cavalier
	//xmasque_inverse_direction[i][j]=~xmasque_direction[i][j];
}
*/
} // fon for cases


// Masque pions passs
for (j=0;j<=1;j++)
{
for (i=63;i>=0;i--)
{
	xmasque_pion_passe[j][i]=0;
	for (k=63;k>=0;k--)
	{
		if (X64(k)<X64(i)-1) continue;
		if (X64(k)>X64(i)+1) continue;
		if (j==1) // blancs
		{
			if (Y64(k)>Y64(i)) set_bit_to_1(xmasque_pion_passe[j][i],k);
		}
		else
		{
			if (Y64(k)<Y64(i)) set_bit_to_1(xmasque_pion_passe[j][i],k);
		}
	}
}
}


/*
// Masque pions candidats
for (j=0;j<=1;j++)
{
for (i=63;i>=0;i--)
{
	xmasque_pion_candidat[j][i]=0;
	for (k=63;k>=0;k--)
	{
		if (X64(k)!=X64(i)) continue;
		if (j==1)
		{
			if (Y64(k)>Y64(i)) set_bit_to_1(xmasque_pion_candidat[j][i],k);
		}
		else
		{
			if (Y64(k)<Y64(i)) set_bit_to_1(xmasque_pion_candidat[j][i],k);
		}
	}
}
}
*/


#if VALUE_MINOR_PIECES==1
// Masque pices passes
for (j=0;j<=1;j++)
{
for (i=63;i>=0;i--)
{
	xmasque_piece_passee_gauche[j][i]=0;
	xmasque_piece_passee_droite[j][i]=0;
	for (k=63;k>=0;k--)
	{
		if (X64(k)<X64(i)-1) continue;
		if (X64(k)>X64(i)+1) continue;
		if (X64(k)==X64(i)) continue;
		if (j==1) // blancs
		{
			if (Y64(k)>Y64(i)) 
			{ 
				// Gauche
				if (X64(k)==X64(i)-1)
					set_bit_to_1(xmasque_piece_passee_gauche[j][i],k);
				// Droite
				else
					set_bit_to_1(xmasque_piece_passee_droite[j][i],k);
			}
		}
		else
		{
			if (Y64(k)<Y64(i)) 
			{
				// Gauche
				if (X64(k)==X64(i)-1)
					set_bit_to_1(xmasque_piece_passee_gauche[j][i],k);
				// Droite
				else
					set_bit_to_1(xmasque_piece_passee_droite[j][i],k);
			}
		}
	}
}
}
#endif

#if USE_CASES_ACTUALISATION==1
for (j=0;j<=1;j++)
{
	if (Y64(j)==0)
	{
		set_bit_to_1(xcases_couloir[1],j);
	}
	else if (Y64(j)==7)
	{
		set_bit_to_1(xcases_couloir[0],j);

	}
	else
	{
		set_bit_to_1(xcases_hors_couloirs,j);
	}
}
#endif



} // fin init_bitboards
