#include "stdafx.h"
#include "Cchess_1.h"
#include "Cchess_2.h"
#include "Move.h"
//#include "Cchess_3.h"
#include "Cchess_4.h"
#include "Cchess_5.h"
#include "Cchess_6.h"
//#include <stdio.h>
//#include <stdlib.h>


// CATEGORIES DE COUPS
// 0 : coups favorables
// 4 : changes de pices
// 5 : changes de pions
// 7 : prises de pions par pices
// 9 : valeur standard
// 12 : prise de pion protg par pice





// Fonctions locales
static void promotion(PIECE *wptr, char i);
static void pion(PIECE *wptr);
static void fou(PIECE *wptr);
static void cava(PIECE *wptr);
static void tour(PIECE *wptr);
static void dame(PIECE *wptr);
static void roi(PIECE *wptr);
static void put_xb(PIECE *wptr,char inc, char dir, bool F_cava, bool F_roi);
static void prise_pion(PIECE *wptr,char arr);
static void complete_liste(PIECE *wptr,char arr, unsigned __int32 flag_prom,
						 unsigned __int32 flag, char inc, char prise_pion);
static char getpriority(char color01, char nature, char dep, char arr);
static void promotion2(char i);



void make_struct_moves()
{
char type_piece;
char pos;
//char p;
PIECE une_piece;
PIECE *wptr;
//char color01;


// Directions
// Pour le roi : 1 direction et fonction spcifique
// Pour le pion : une direction et fonction spcifique
// Pour le cavalier : une direction
// Pour les tours fous : le pointeur de coup pointe sur une structure
//  4 directions
// Pour les dames : 8 directions

// Initialisations
xidx=xlc; 			
xlc_highwatermark=1;
wptr=&une_piece; // pour disposer d'une structure de pice


for (pos=63; pos>=0 ; pos--)
{
for (type_piece=11; type_piece>=0; type_piece--)
{
// Note :
// searchmove n'a besoin que de wptr;
// et pas de xnum qui est initialis dans la fonction

// Initialisations globales
// Initialisations
wptr->pos=pos;
wptr->type=type_piece;
wptr->nature=xmap_type_to_piece[type_piece];
wptr->color01=1-M_2(type_piece);
wptr->color=TO_COLOR(wptr->color01);

// Initialisation xidx
// Il y a t-il un sparateur
if (xidx>xlc)
{
while (! (*(xidx-1)==0 && *xidx==0) )
{
	*++xidx=0; xlc_highwatermark++;
}
}
// Nouvelle valeur
// Pointeur sur le premier coup avec la direction 0
xmoves[pos][type_piece][0]=xidx;


// Gnration des coups
switch (wptr->nature)
{
case 'P': pion(wptr) ;	break;
case 'C': cava(wptr) ;	break;
case 'F': fou(wptr);	break;
case 'T': tour(wptr);	break;
case 'D': dame(wptr);	break;
case 'R': roi(wptr)  ;	break;
default:			break;
} // close switch


} // fin for type
} // fin for pos 

// Marquage fin de liste 
*xidx=0;


ASSERT(xlc_highwatermark<xmaxlistmoves
	   && xmaxlistmoves<xlc_highwatermark+100);

#if DEBUG==4
char handle1;
if ((handle1=open("make_struct_move.txt",O_WRONLY | O_CREAT | O_BINARY , S_IREAD | S_IWRITE )) == -1)
{
log_error("\nErreur M_456");
}
else
{
xidx=xlc;
short si;
for(si=0; si<=xlc_highwatermark; xidx++, si++)
{
	sprintf(xbuffer,"\r\n%c %d %d %d",
		MOVE_NATURE(*xidx),MOVE_DEP88(*xidx),MOVE_ARR88(*xidx));
	si1=(char) strlen(xbuffer);
	write(handle1,xbuffer,(char) strlen(xbuffer));
}
close(handle1);
si=0;
}
#endif




// Restauration xlevel
} // fin make_struct_moves 



void recompute_move_priorities()
{
MOVE *mpt;
char nature;
char color01;
MOVE move;
char i,j,k;
short priority;
char categorie;

for (i=63;i>=0;i--)
{
for (j=11;j>=0;j--)
{
switch (j)
{
case 0 : nature='P'; color01=1;
		break;
case 1 : nature='P'; color01=0;
		break;
case 2 : nature='C'; color01=1;
		break;
case 3 : nature='C'; color01=0;
		break;
case 4 : nature='F'; color01=1;
		break;
case 5 : nature='F'; color01=0;
		break;
case 6 : nature='T'; color01=1;
		break;
case 7 : nature='T'; color01=0;
		break;
case 8 : nature='D'; color01=1;
		break;
case 9 : nature='D'; color01=0;
		break;
case 10 : nature='R'; color01=1;
		break;
case 11 : nature='R'; color01=0;
		break;
}
for (k=0;k<8;k++)
{
if (k>0 && (nature=='C' || nature=='R' || nature=='P')) break;
if (k>3 && nature!='D') break;

for(mpt=xmoves[i][j][k];*mpt!=0;mpt++) 
{
move=*mpt;
priority=getpriority(color01,nature,MOVE_DEP64(move),MOVE_ARR64(move));
xpriority[j][MOVE_DEP64(move)][MOVE_ARR64(move)]=priority;
//SET_MOVE_PRIORITY(*mpt,priority); // et pas move !!!
categorie=MOVE_CATEGORY(move);
//if (categorie==AUTRE_COUP || categorie==AUTRE_COUP_2)
//{
//	if (priority>=0) categorie=AUTRE_COUP;
//	else       categorie=AUTRE_COUP_2;
//	SET_MOVE_CATEGORY(*mpt,categorie);
//}
//SET_MOVE_PRIORITY(*mpt,priority); // et pas move !!!
}
}
}
}
} // fin recompute_move_priorities



static char getpriority(char color01, char nature, char dep, char arr)
{
// Cette fonction retourne la priorit, positive pour les 2 camps
// Il faut ensuite la multiplier par color
//char nature, color01;
char priority;
// Calcul
//nature=MOVE_NATURE(move);
priority=-getposvalue(nature,color01,dep);
priority+=getposvalue(nature,color01,arr);
// Priorit des roques
if (nature=='R')
{
	// Petit roque
	if (arr-dep==16) 
		priority=COLOR01(color01,60);
	else if ((arr-dep)==-16)
		priority=COLOR01(color01,40);
}
ASSERT(abs(priority)<128);
return priority;
}



char getposvalue(char nature, char color01, char arr64)
{
char finale;
char posvalue=0;
char idx;

finale=xstates[0].finale;

if (finale>=FIN_DE_PARTIE_1 && nature!='C' && nature!='P') return 0;

// Finalement indexation 64
if (color01==1) idx=arr64;
else	          idx=arr64-(Y64(arr64)<<1)+7;



switch (nature)
{
case 'P': posvalue=xpion[color01][idx]; break;
case 'F': posvalue=xfou[idx];          	break;
case 'C': posvalue=xcavalier[idx];      break;
case 'T': posvalue=xtour[idx];		break;
case 'D': posvalue=xdame[idx]; 		break;
case 'R': posvalue=xroi[idx]; 		break;
default : return 0;
}
return posvalue;
}




void SEARCH::searchmove(PIECE *wptr) 
// => il faut fixer aussi s
// F_maj_developpement s'explique parce que le dveloppement
// est mis  jour seulement pour les pices joues
// de faon  tre restaur par dejouer
// Ex : une pice est joue puis ractualise sans jouer
// la valeur du dveloppement est modifie
// puis le coup est djoue, mais l'image n'est pas  jour

// Pour position, les pices ne sont pas actualises
// systmatiquement en extend
// Les images enregistres par jouer ne sont pas forcment OK
// et djouer ne joue pas son office 
// La pice est joue et xposition est inchang
// La pice est actualise, xposition augmente
// puis n'est pas diminu par djouer
// une autre solution aurait consist  avoir 
// developpement et position sans xstates
{
// Note : searchmove ne DOIT pas tre excut deux fois de suite 
// pour une pice : en effet, il y aurait crasement du oldptr
// Garde fou : le psptr->levelmoves qui interdit d'actualiser le mme level 2 fois

char color;
char pos;
char nature;
char color01;
char num_piece;
//char inc;
#if USE_CASES_ACTUALISATION==0
char side_checked01;
#endif
PIECE_SET *psptr, *psoldptr;
char *promoptr, *mob_prises_ptr, *mob_others_ptr,*mob2ptr, *towerptr;

// Nature
nature=wptr->nature;

// Prcaution
if (nature==0) return;

// La pice a-t-elle dja t actualise ?
if (wptr->psptr->levelmoves==xlevel && xlevel>0)
{
#if USE_CASES_ACTUALISATION==0
// il faut vrifier les checs pour les cavaliers
// en effet, en cas de 2 actualise conscutifs
// sl->chkptr est rinitialis mais les cavaliers ne sont pas reactualiss
// (pas 2 fois au mme niveau)
if (nature=='C')
{
inc=abs(wptr->pos-s->roi_pos[1-wptr->color01]);
//if (inc==21 || inc==12 || inc==19 || inc==8)
if (inc==17 || inc==10 || inc==19 || inc==6)
{
if (KNIGHT_MOVE_DEP_ARR_COMPATIBILITY(wptr->pos,s->roi_pos[1-wptr->color01]))
{
			side_checked01=1-wptr->color01;
			#if DEBUG==1
			if (side_checked01!=xwtm) // Le camp en chec doit tre celui au trait
			log_error("\nErr M_2112 - Echec non couvert");
			#endif
			if (chkptr[side_checked01]==NULL) 
			{ 
			   chkptr[side_checked01]=wptr;
			}
			else if (wptr!=chkptr[side_checked01])
			chkptr2[side_checked01]=wptr; // Echec double
}
} // fin echec
} // fin if cavalier
#endif

// Non ractualisation
return; 
}



// Initialisation
num_piece=wptr->num_piece;

// Initialisations - inscription dans la liste de ractualisation du level
if (xlevel>0) reactu_liste[reactu_liste_nombre++]=wptr;
#if DEBUG==1
if (reactu_liste_nombre>32)
	log_error("\nM_900", xcompteur);
#endif


// Note :
// searchmove n'a besoin que de wptr;

// Actualisation levelmoves
// et changement de PIECE_SET
// Nouveau PIECE_SET
psoldptr=wptr->psptr; // ancien ps
psptr=&xpset[num_piece][xlevel];

// Autres
color=wptr->color;
color01=TO_COLOR01(color);
pos=wptr->pos;
//color01=wptr->color01;


// Mise  jour du statut d'actualisation
// et du levelmoves d'actualisation
// Mise  jour du statut d'actualisation
// et du levelmoves d'actualisation
psptr->oldptr=psoldptr; // nouveau ps
wptr->psptr=psptr; // affectation nouveau ps
if (xlevel==0) psptr->oldptr=psptr;
// Pointeurs sur listes de coups
psptr->levelmoves=xlevel;
// les psptr->moves sont fixs dans les fonctions

//#if USE_CASES_CONTROLEES==1
//#if USE_EXTEND_CASES_CONTROLEES==0
//if (!xextend)
//#endif
//{
//	psptr->cases_controlees=0;
//}
//#endif

#if USE_CASES_ACTUALISATION==1
switch(wptr->nature)
{
case 'P' : 
	psptr->cases_actualisation=xcases_actualisation_pion[color01][pos];
	break;
case 'C' : 
	psptr->cases_actualisation=xcases_arrivee_cavalier[pos];
	break;
case 'R' : 
	psptr->cases_actualisation=xcases_arrivee_roi[pos];
	break;
default : 
	psptr->cases_actualisation=0; 
	break;
}
#endif


#if USE_CASES_COUPS_FORCANTS==1
psptr->cases_coup_forcant=0;
#endif
#if USE_PIECES_ATTAQUEES==1
#if SEARCH_UNDEFENDED_PIECES!=0 
psptr->pieces_attaquees=0;
#endif
#endif
// Maj position
s->position -= psoldptr->posvalue;
psptr->posvalue=xboard[wptr->pos].posvalue[wptr->type];
s->position += psptr->posvalue;

// Maj mobility et tours
s->mobility -= COLOR(color,psoldptr->mobility+psoldptr->mobility2);
s->tower -= COLOR(color,psoldptr->tower);
towerptr=&psptr->tower;
mob_prises_ptr=&psptr->mobility_prises;
mob_others_ptr=&psptr->mobility_others;
mob2ptr=&psptr->mobility2;
*mob_others_ptr=0; 
*mob_prises_ptr=0; 
*mob2ptr=0;
*towerptr=0;
s->developpement[color01]-=psoldptr->develop;
psptr->develop=0;

// Maj force et prises et promotions
//s->nb_cases_coup_forcant[color01] -= psoldptr->nb_cases_coup_forcant;
//s->nb_menaces_promotion[color01] -= psoldptr->F_menace_promotion;
//xforceptr=&psptr->nb_cases_coup_forcant;
s->nb_promotions[color01] -= (psoldptr->F_promotion?1:0);
promoptr=(char*)&psptr->F_promotion;
*promoptr=0;
#if SUIVI_PRISES==1
s->prises[color01] -= psoldptr->prises;
s->prises_pion[color01] -= psoldptr->prises_pion;
xprisesptr=&psptr->prises;
xprisespionptr=&psptr->prises_pion;
*xprisesptr=0;
*xprisespionptr=0;
#endif



#if USE_BITBOARD_MOVE_GENERATION==0
// Gnration des coups
switch (nature)
{
case 'P': pion2(wptr,psptr,*mob_others_ptr,*mob_prises_ptr,*mob2ptr,*promoptr);  break;
case 'C': cava2(wptr,psptr,*mob_others_ptr,*mob_prises_ptr,*mob2ptr);  break;
case 'F': fou2(wptr,psptr,*mob_others_ptr,*mob_prises_ptr,*mob2ptr) ;  
		  break;
case 'T': tour2(wptr,psptr,*mob_others_ptr,*mob_prises_ptr,*mob2ptr,*towerptr) ; 
		  break;
case 'D': dame2(wptr,psptr,*mob_others_ptr,*mob_prises_ptr,*mob2ptr,*towerptr);  break;
case 'R': roi2(wptr,psptr,*mob_others_ptr,*mob_prises_ptr,*mob2ptr) ;
	// Evaluation king_safety
	#if  KING_SAFETY==1
	king_safety(color01);
	#endif
	break;
case '\0':          break;
} // close switch
#endif

#if USE_BITBOARD_MOVE_GENERATION==1
// Gnration des coups
switch (nature)
{
case 'P': pion2(wptr,psptr,*mob_others_ptr,*mob_prises_ptr,*mob2ptr,*promoptr);  break;
case 'C': get_moves_CR(wptr, psptr,*mob_others_ptr,*mob_prises_ptr);  break;
case 'F': get_moves_DTF(wptr, psptr,*mob_others_ptr,*mob_prises_ptr) ;  break;
case 'T': get_moves_DTF(wptr, psptr,*mob_others_ptr,*mob_prises_ptr) ; break;
case 'D': get_moves_DTF(wptr, psptr,*mob_others_ptr,*mob_prises_ptr);  break;
case 'R': get_moves_CR(wptr, psptr,*mob_others_ptr,*mob_prises_ptr) ;
	// Evaluation king_safety
	#if  KING_SAFETY==1
	king_safety(color01);
	#endif
	break;
case '\0':          break;
} // close switch
#endif

#if SORT_BITBOARD_AND_LISTMOVES_SAME_WAY_FOR_DEBUG==1
qsort(&xw_liste_coups_piece[xlevel][num_piece][0],psptr->mobility_others,sizeof(unsigned __int32),uint32_compare);
qsort(&xw_liste_coups2_piece[xlevel][num_piece][0],psptr->mobility_prises,sizeof(unsigned __int32),uint32_compare);
#endif

// MAJ mobilit
#if ZERO_MOBILITY2==1
psptr->mobility2=0;
#endif
#if ZERO_TOWER==1
psptr->tower=0;
#endif
#if ZERO_DEVELOPPEMENT==1
#endif
psptr->mobility=psptr->mobility_others+psptr->mobility_prises;
s->mobility += COLOR(color,psptr->mobility+psptr->mobility2);
// Maj tower 
s->tower += COLOR(color,*towerptr);
// Autres 
//s->nb_cases_coup_forcant[color01] += *forceptr;
s->nb_promotions[color01] += (*promoptr?1:0);
#if SUIVI_PRISES==1
s->prises[color01]+= *xprisesptr;
s->prises_pion[color01]+= *xprisespionptr;
#endif

// Maj dveloppement
// Ncessite la connaissance de psptr->mobility
//if (xfinale_variable_globale>0) 
//if (s->finale>0) 
//{ 
//  psptr->develop=0; 
//  s->developpement[0]=0; 
//  s->developpement[1]=0; 
//}
//else // finale==0
{
// psptr->develop peut avoir t modifi dans les fonctions tour2 et fou2
switch (color)
{
case 1  : switch (nature)
		  {
	      case 'P' :   break;
		  case 'D' : if (psptr->mobility<3) psptr->develop=-2;
					 else if (psptr->mobility<6) psptr->develop=-1;
					 break; 
		  case 'F' : // Fianchetto en g2
					 if (pos==49) 
					 { if (psptr->develop==0
					       && xboard[50].nature=='P' 
					       && xboard[50].color==1)
					   { psptr->develop=0; break; }
					 }

					 // Anti Fd3 avec pion en d2
					 if (pos==26) 
					 {	 
					   if (xboard[25].nature=='P' &&
						   xboard[25].color==1)
					   { psptr->develop=-2; break; }
					 }
 					 // Faible mobilit
					 if (psptr->mobility<3) 
					 {	psptr->develop=-1; break; }
					 break; 
          case 'T' : if (psptr->mobility<3) 
					 {	psptr->develop=-1; break; }
			  		 break;      		  
	    case 'C' : 	if ( pos==7 )
		                 {	psptr->develop=-2; break; }
				if (  Y64(pos)<=1 || 
					Y64(pos)==7 ||
					X64(pos)==0 ||
					X64(pos)==7 )
		                 {	psptr->develop=-1; break; }
					 if (psptr->mobility<3) 
						{	psptr->develop=-1; break; }
					 break; 
		  case 'R' : 
					// Simple
				    // Roi en premire ligne, en a, b, g, h
				    if (xnbcoups<=50)
					{
				    if ( Y64(pos)==0
						 && 
						 (X64(pos)<=1 || X64(pos)>=6)
				     	)
					{ psptr->develop=0; }
					else { psptr->develop=-1; }
					}
                    break;
		  } // fin switch nature
          break;
case -1 : switch (nature)
		  {
          case 'P' : break;
		  case 'D' : if (psptr->mobility<3) psptr->develop=-2;
					 else if (psptr->mobility<3) psptr->develop=-1;
					 break;
		  case 'F' : 
   					 // Fianchetto en g2
					 if (pos==54) 
					 { 
						 if (psptr->develop==0 
							 && xboard[53].nature=='P'
					       && xboard[53].color==-1)
					   { psptr->develop=0; break; }
					 }

					 // Anti Fd3 avec pion en d2
					 if (pos==29) 
					 {	 
					   if (xboard[30].nature=='P' &&
						   xboard[30].color==-1)
					   { psptr->develop=-2; break; }
					 }

					 // Faible mobilit
					 if (psptr->mobility<3) 
					 { psptr->develop=-1; break; }
					 break; 

		  case 'T' :  if (psptr->mobility<3) psptr->develop=-1;
			  		 break;      		  
		  case 'C' :  if (pos==0)
				  { psptr->develop=-2; break; }
				  if (Y64(pos)==0 || 
					Y64(pos)>=6 ||
					X64(pos)==0 ||
					X64(pos)==7 )
					 { psptr->develop=-1; break; }
					 if (psptr->mobility<3) 
					 { psptr->develop=-1; break; }
                     break; 
  	      case 'R' :     
  				    if (xnbcoups<=50)
					{
				    if ( Y64(pos)==7
						 && 
						 (X64(pos)<=1 || X64(pos)>=6)
				     	)
					{ psptr->develop=0; }
					else { psptr->develop=-1; }
					}
			  break;
          default :  break;
		  }
          break;
} // fin case
s->developpement[color01] += psptr->develop;

} // fin else finale==0;

return;
} // close searchmove




static void put_xb(PIECE *wptr,char inc, char dir, bool F_cava, bool F_roi)
{
// pris sert pour les prises de pions
// fonctionne avec wptr
char arr;
char dep,new_dep;
char inc128;
#if DEBUG==1
	char arr88;
	char inc88;
#endif


dep=wptr->pos;
arr=dep;

#if DEBUG==1
char dep88;
dep88=arr88=TO88(dep);
switch(inc)
{
case 1 : inc88=1; break;
case 9 : inc88=11; break;
case 8 : inc88=10; break;
case 7 : inc88=9; break;
case -1 : inc88=-1; break;
case -9 : inc88=-11; break;
case -8 : inc88=-10; break;
case -7 : inc88=-9; break;
case 10 : inc88=12; break;
case 17 : inc88=21; break;
case 15 : inc88=19; break;
case 6 : inc88=8; break;
case -10 : inc88=-12; break;
case -17 : inc88=-21; break;
case -15 : inc88=-19; break;
case -6 : inc88=-8; break;
default : break;
}
#endif

// Attribution direction dame, tour et fou
// et initialisation
if (!F_roi && !F_cava)
{
xmoves[wptr->pos][wptr->type][dir]=xidx;
}

do
{
new_dep=arr;
arr+=inc;

// Contr"le limites chiquier 

inc128=xinc128[INDICE_INC64(inc)];
if (!(MOVE_IS_OK_128(new_dep,inc128)))
{
	#if DEBUG==1
	ASSERT(!MOVE_IS_OK_ASSERT(dep,arr,inc,F_cava));
	#endif
	break;
}
#if DEBUG==1
ASSERT(MOVE_IS_OK_ASSERT(dep,arr,inc,F_cava));
#endif

#if DEBUG==1
arr88+=inc88;
if (arr88<0 || arr88>88 || arr88%10==0 || arr88%10==9)
log_error("\nM_936");
#endif



complete_liste(wptr,arr,0,MoveNormal,inc,0);
if (F_cava || F_roi) break;
else            continue;    

}
while(1); // do sur incrmentation


// Marquage changement de direction
// Coups de dame, de tour et de fou
if (!F_cava && !F_roi)
{
// Attention : il faut que les directions vides 
// pointent vers des entres vides
// Cela peut vouloir dire des successions de 
// lignes blanches dans le fichier 
*++xidx=0; xlc_highwatermark++;
}

return;
} // fin fonction put_xb




static void complete_liste(PIECE *wptr,char arr, unsigned __int32 flag_prom, unsigned __int32 flag, char inc, char prise_pion)
{
MOVE *mpt; // forcment un pointeur pour modifier 
char nature;
char color01;
long valeur_prise;
//char y;
char dep; 
PIECE piece;
#if DEBUG==1
short int si1;
#endif
char categorie;

// Initialisation
nature=wptr->nature;
color01=wptr->color01;
valeur_prise=0;
dep=wptr->pos;
mpt=xidx;
// Numro de pice : on ne connait pas encore la pice !!
// priority=getpriority(color01,nature,dep,arr);
xpriority[wptr->type][dep][arr]=getpriority(color01,nature,dep,arr);
//if (xpriority[wptr->type][dep][arr]>=0)
//{categorie=AUTRE_COUP;} else {categorie=AUTRE_COUP_2;} 
categorie=AUTRE_COUP;
*mpt=MOVE_MAKE(nature,dep,arr,flag|flag_prom,categorie);
ASSERT(categorie==MOVE_CATEGORY(*mpt));
#if DEBUG==1
si1=MOVE_NATURE(*mpt);
#endif

// Promotions
if (flag_prom!=0) 
{ 
	piece.nature=MOVE_PROMOTION(*mpt);
	piece.pos=arr;
	setvalue(&piece);
	valeur_prise=abs(piece.value)-VALEUR_PION; // Pouvant tre augment
	//SET_MOVE_CAPTURE_VALUE(*mpt,valeur_prise);
	//SET_MOVE_CATEGORY_AND_PAWNSTRUCT_FLAG(*mpt,COUP_FORCANT); 
	SET_MOVE_CATEGORY(*mpt,PROMOTION); 
	//xzz=MOVE_CATEGORY(*mpt);
	//xzz=MOVE_CAPTURE_VALUE(*mpt);
/*
	y=Y64(arr);
	if (y==0 || y==7) 
	{
		if (MOVE_PROMOTION(*mpt)=='D') 
		{
			SET_MOVE_CATEGORY(*mpt,COUP_FORCANT); 
			//SET_MOVE_CATEGORY_AND_PAWNSTRUCT_FLAG(*mpt,COUP_FORCANT); 
		}
		else 
		{
			//SET_MOVE_CATEGORY_AND_PAWNSTRUCT_FLAG(*mpt,AUTRE_COUP); 
			SET_MOVE_CATEGORY(*mpt,COUP_FORCANT); 
		}
	}
*/
}

//if (flag==MoveCastle)
//{
	//SET_MOVE_PRIORITY(*mpt,60);
	//SET_MOVE_CHANGES_PAWNSTRUCT(move);  
//}

// Prise en passant
if (flag==MoveEnPassant)
{
    SET_MOVE_CAPTURE(*mpt,'P');
    //SET_MOVE_CAPTURE_VALUE(*mpt,VALEUR_PION);
	SET_MOVE_CATEGORY(*mpt,ECHANGE_PION);
	//SET_MOVE_CHANGES_PAWNSTRUCT(*mpt,1);
	//SET_MOVE_CATEGORY_AND_PAWNSTRUCT_FLAG(move,ECHANGE_PION); 
}


// Impact possible sur le roque
// Intgr dans le MOVE_MAKE
//if (    bit(xmasque_impact_droit_roque,dep)
//    ||  bit(xmasque_impact_droit_roque,arr) ) 
//{ SET_MOVE_MAY_IMPACT_ROQUE(*mpt); }


// Prises de pions
if (prise_pion==1)
{
    SET_MOVE_CAPTURE(*mpt,'P');
	//SET_MOVE_CAPTURE_VALUE(*mpt,VALEUR_PION);
	SET_MOVE_CATEGORY(*mpt,ECHANGE_PION);
	//SET_MOVE_CHANGES_PAWNSTRUCT(*mpt,1);
	//SET_MOVE_CATEGORY_AND_PAWNSTRUCT_FLAG(move,ECHANGE_PION); 
}

// Catgorie des menaces de promotions
// Les promotions sont traites avant
//if (nature=='P')
//{
// Obligatoire pour les coups de pions standard! (mais dja fait pour les promotions et prises en passant)
////SET_MOVE_CHANGES_PAWNSTRUCT(move);
//y=Y64(arr);
//if (y==1 || y==6) SET_MOVE_CATEGORY(*mpt,COUP_CATEGORIE_1);
//}

// Mise  jour pointeur de liste
*++xidx=0; xlc_highwatermark++; xlc_real_moves++;
#if DEBUG==1
if (xlc_highwatermark >= xmaxlistmoves)
{
	printf("\nxlc_highwatermark : %d", xlc_highwatermark);
	log_error("\nErreur I_105");
}
#endif

// Fin
return;
} // fin complete_liste




static void pion(PIECE *wptr)
{
char arr;
char pos;
char color;
char y;
pos=wptr->pos;
color=wptr->color;

// Case de dpart diffrente de premire et dernire range
y=Y64(pos);
if (y==0 || y==7) return;

// Avance d'une case
arr=pos+color;
y=Y64(arr);
if (y!=0 && y!=7) complete_liste(wptr,arr,0,MoveNormal,0,0);
else	    	      promotion(wptr,arr);


// Avance de deux cases
// Fait aprs l'avance du pion d'une case !!!
if (color==1 && y==2) // Avance d'une case
{
arr=pos+2; // avance de deux cases
complete_liste(wptr,arr,0,MoveNormal,0,0);
}


if (color==-1 && y==5) // Avance d'une case
{
arr=pos-2; // avance de deux cases
complete_liste(wptr,arr,0,MoveNormal,0,0);
}


// Prend pice  gauche
if (pos>=8)
{
prise_pion(wptr,pos-8+color);
}

// Prend pice droite
if (pos<=55)
{
prise_pion(wptr,pos+8+color);
}

// Prise en passant
// (trait au niveau de prise_pion)


} // fin pion





static void prise_pion(PIECE *wptr,char arr)
{
char p;
char color;
CASE *cptr;

color = wptr->color;
cptr=&xboard[arr];
p=Y64(arr);

// Prise ou promotion avec prise
if (p!=0 && p!=7) complete_liste(wptr,arr,0,MoveNormal,0,1);
else		      promotion(wptr,arr); 

// Traitement de la prise en passant
// (mme si la case est occupe !!!!)

if ((color==1 && p==5) || (color==-1 && p==2))
{
complete_liste(wptr,arr,0,MoveEnPassant,0,1);
// CONCLUSION
// Les prises en passant, sont ajoutes  la liste
// des coups. Leur lgalit est ensuite teste
// par legal.
} // fin if

} // fin prise_pion



static void promotion(PIECE *wptr, char arr)
{
complete_liste(wptr,arr,MovePromoteQueen,MovePromote,0,0);
complete_liste(wptr,arr,MovePromoteRook,MovePromote,0,0);
complete_liste(wptr,arr,MovePromoteBishop,MovePromote,0,0);
complete_liste(wptr,arr,MovePromoteKnight,MovePromote,0,0);
}


static void cava(PIECE *wptr)
{
put_xb(wptr,+10,0,IsKnight,IsNotKing);
put_xb(wptr,+17,0,IsKnight,IsNotKing);
put_xb(wptr,+15,0,IsKnight,IsNotKing);
put_xb(wptr, +6,0,IsKnight,IsNotKing);
put_xb(wptr,-10,0,IsKnight,IsNotKing);
put_xb(wptr,-17,0,IsKnight,IsNotKing);
put_xb(wptr,-15,0,IsKnight,IsNotKing);
put_xb(wptr, -6,0,IsKnight,IsNotKing);
} // fin cavalier



static void fou(PIECE *wptr)
{
	put_xb(wptr,+9,0,false,false);
	put_xb(wptr,+7,1,false,false);
	put_xb(wptr,-7,2,false,false);
	put_xb(wptr,-9,3,false,false);
} // fin fou



static void tour(PIECE *wptr)
{
	put_xb(wptr,+1,0,false,false);
	put_xb(wptr,-1,1,false,false);
	put_xb(wptr,+8,2,false,false);
	put_xb(wptr,-8,3,false,false);
} // fin tour



static void dame(PIECE *wptr)
{
	put_xb(wptr,+1,0,false,false);
	put_xb(wptr,+9,1,false,false);
	put_xb(wptr,+8,2,false,false);
	put_xb(wptr,+7,3,false,false);
	put_xb(wptr,-1,4,false,false);
	put_xb(wptr,-9,5,false,false);
	put_xb(wptr,-8,6,false,false);
	put_xb(wptr,-7,7,false,false);
}


static void roi(PIECE *wptr)
{
char color;
char pos;
pos = wptr->pos;
color = wptr->color;

// Mme traitement que pour les cavaliers
put_xb(wptr,+1,0,false,IsKing);
put_xb(wptr,+9,0,false,IsKing);
put_xb(wptr,+8,0,false,IsKing);
put_xb(wptr,+7,0,false,IsKing);
put_xb(wptr,-1,0,false,IsKing);
put_xb(wptr,-9,0,false,IsKing);
put_xb(wptr,-8,0,false,IsKing);
put_xb(wptr,-7,0,false,IsKing);


// Roques

if (color==1 && pos==32)
{
complete_liste(wptr,48,0,MoveCastle,0,0); /* Petit roque blanc */
complete_liste(wptr,16,0,MoveCastle,0,0);
}

if (color==-1 && pos==39)
{
complete_liste(wptr,55,0,MoveCastle,0,0); /* Petit roque noir */
complete_liste(wptr,23,0,MoveCastle,0,0);
}

} // fin roi




void SEARCH::actualise(MOVE lastmove)
{
char dep, arr;
char case_couverture;
char num;
bool F_faire_maj_king_safety_0;
bool F_faire_maj_king_safety_1;
char color01;
bool F_mouvement_roi[2];
PIECE *local_chkptr;
char local_chk_inc;
char roi_pos;
char j;
PIECE *wptr;
#if USE_CASES_ACTUALISATION==0
char inc;
bool F_do_knights;
char nb_knights_on_arrival_square;
#endif
#if USE_CASES_ACTUALISATION==1
unsigned __int64 arrival_squares;
#if USE_MATE_IN_ONE==1
#if MATE_IN_ONE_CHECK_INTERCEPTIONS==1
unsigned __int64 cases_avancee_pion_adversaire;
#endif
#endif
#endif
char lastmove_nature;
char nature;
char local_player;

#if FORCE_MOUVEMENT_ROI==1
F_mouvement_roi[1]=true;
#endif

// Pas d'actualisation si passe
// A faire en premier pour rinitialiser sl->chkptr
// sans faire les autres initialisations

// Initialisations communes (y compris si nullmove)
#if USE_CASES_ACTUALISATION==1
pieces_clouees=0;
#endif
#if USE_CASES_ACTUALISATION==1
arrival_squares=0;
#endif
check=0;
chkptr[0]=NULL; chkptr2[0]=NULL; 
chkptr[1]=NULL; chkptr2[1]=NULL; 
cases_occupees=s->cases_pieces[0]|s->cases_pieces[1]|s->cases_pions[0]|s->cases_pions[1];
F_faire_maj_king_safety_0=false;
F_faire_maj_king_safety_1=false;
#if CHECK_CHECKS==1
chkptr3[xwtm]=NULL;chkptr4[xwtm]=NULL;
#endif
  

if (!MOVE_IS_FOR_PLAY(lastmove))
{
ASSERT(lastmove==AllMoves || lastmove==NullMove);
if (lastmove==NullMove) // Attention : ne pas empcher la subactualisation complete
{
  #if USE_CASES_ACTUALISATION==1
  goto MAJ_CASES_CONTROLEES;
  #endif
  return; 
}
}


// Autres initialisations 
// s=&xstates[xlevel];
#if USE_CASES_ACTUALISATION==1
//F_mettre_a_jour_clouages[0]=false;
//F_mettre_a_jour_clouages[1]=false;
#endif
dep=MOVE_DEP64(lastmove);
arr=MOVE_ARR64(lastmove);
xF_dir_actualisation_roi[0]=0;
xF_dir_actualisation_roi[1]=0;
F_mouvement_roi[0]=false;
F_mouvement_roi[1]=false;
lastmove_nature=MOVE_NATURE(lastmove);

#if CHECK_CHECKS==1
chkptr3[0]=NULL;chkptr4[0]=NULL;
chkptr3[1]=NULL;chkptr4[1]=NULL;
#endif
// Pour les clouages

/*
#if DEBUG==1
if (compteur_mem==65252)
{
	char cc;
	cc=0;
	cc=1/cc;
}
#endif
*/

// Actualisation gnrale si move = AllMoves
if (lastmove==AllMoves)
{
#if TRACK_QUEEN_POSITION==1
s->queen_position[0]=-1;
s->queen_position[1]=-1;
#endif
// Mises  zro de prcaution
//s->cases_echec_pion[0]=0;
//s->cases_echec_pion[1]=0;
//s->cases_echec_cavalier[0]=0;
//s->cases_echec_cavalier[1]=0;
s->cases_echec_fou[0]=0;
s->cases_echec_fou[1]=0;
s->cases_echec_tour[0]=0;
s->cases_echec_tour[1]=0;
s->cases_echec_dame[0]=0;
s->cases_echec_dame[1]=0;
//s->cases_attaque_pion_d[0];
//s->cases_attaque_pion_d[1];
//s->cases_attaque_pion_g[0];
//s->cases_attaque_pion_g[1];
//memset(&s->clouages[0],0,31);
#if KING_SAFETY==1
s->king_open_diagonals[1];
s->king_open_diagonals[0];
s->king_open_lines[1];
s->king_open_lines[0];
s->king_open_columns[1];
s->king_open_columns[0];
#endif
#if USE_PIECES_ATTAQUEES==1
#if USE_SEARCH_ALL_UNDEFENDED_PIECES==1 
s->pieces_attaquees=0;
#endif
#endif
#if USE_CASES_COUPS_FORCANTS==1
s->cases_coup_forcant[1];
s->cases_coup_forcant[0];
#endif


// Pour actualisation complte des checs (hors cavalier)
F_mouvement_roi[0]=true;
F_mouvement_roi[1]=true;
// Maj des coordonnes de roi
// Ici plutt que dans searchmove
maj_coordonnees_roi(0);
maj_coordonnees_roi(1);


wptr=&xw[0];
for (num=0; num<=31; num++,wptr++)
{
// Lancement searchmove
nature=wptr->nature;
if (nature==0) continue;
/* BUG
// Garantir l'actualisation en cas d'actualise all
wptr->psptr->levelmoves=-1;
*/
searchmove(wptr);
// Echecs D,T,F,P
// Voir l'inventaire des cases d'checs 
// Echecs de cavalier
if (wptr->nature=='C')
{
	if (bit(xcases_arrivee_cavalier[wptr->pos],s->roi_pos[1-wptr->color01]))
	{
		if (chkptr[1-wptr->color01]==NULL) 
		{ 
		    chkptr[1-wptr->color01]=wptr;
		}
		else if (wptr!=chkptr[1-wptr->color01])
		{
			chkptr2[1-wptr->color01]=wptr; // Echec double
		}
	}
}


} // fin for
} // fin actualise all
else 
#if USE_CASES_ACTUALISATION==0
{ // Actualisation dernier coup

// Actualisation

// Attention : lastmove est 
if (lastmove_nature=='R')
{
	color01=1-xwtm;
	ASSERT(color01==xboard[MOVE_ARR64(lastmove)].color01);
	ASSERT(xboard[MOVE_ARR64(lastmove)].nature=='R');

	F_mouvement_roi[color01]=true;
	maj_coordonnees_roi(color01);
}

inc=xinc64_from64_to64[dep][arr];
if (xboard[arr].nature=='C') nb_knights_on_arrival_square=1;
else 				    nb_knights_on_arrival_square=0;
if (-nb_knights_on_arrival_square+s->materiel_cavaliers[1]+s->materiel_cavaliers[0]>0)
		F_do_knights=true;
else		F_do_knights=false;
subactualise(dep,false,inc,F_do_knights);
subactualise(arr,true,-inc,F_do_knights);

// Subactualiser roques
if (MOVE_IS_SPECIAL(lastmove))
{
	if (MOVE_IS_CASTLE(lastmove))
	{
		switch (arr)
		{
		case 48 : // Petit roque blanc
			 // un seul subactualise de dpart possible
			 subactualise(56,false,-8,F_do_knights);
			 subactualise(40,true,+8,F_do_knights);
			 break;
		case 16 : // Grand roque blanc
			 // un seul subactualise de dpart possible
			 subactualise(0,false,+8,F_do_knights);
			 subactualise(24,true,-8,F_do_knights);
		   	 break;
		case 55 : // Petit roque noir
			 // un seul subactualise de dpart possible
			 subactualise(63,false,-8,F_do_knights);
			 subactualise(47,true,+8,F_do_knights);
			 break;
		case 23 : // Grand roque noir
			 // un seul subactualise de dpart possible
			 subactualise(7,false,+8,F_do_knights);
			 subactualise(31,true,-8,F_do_knights);
			 break;
		}
	}	
	else if (MOVE_IS_EN_PASSANT(lastmove))
	{
		//subactualise(arr-xboard[MOVE_ARR64(lastmove)].color,false,0,F_do_knights);
		subactualise(arr+TO_COLOR(xwtm),false,0,F_do_knights);
	}
} // move special

} // fin else actualisation dernier coup
#endif
#if USE_CASES_ACTUALISATION==1
{ // Actualisation dernier coup

// Actualisation

// Attention : lastmove 
if (lastmove_nature=='R')
{
	F_mouvement_roi[1-xwtm]=true;
}



// Ncessaire en cas de retour pour actualisation
// sur xF_acualise_testcheck_only=1 mais check>0
//#if ANTICIPATE_EXTEND_CUTOFF==1
//ACTUALISE:
//#endif


set_bit_to_1(arrival_squares,dep);
set_bit_to_1(arrival_squares,arr);
subactualise_cases_echecs_roi(dep,false);
subactualise_cases_echecs_roi(arr,true);
// Inutile d'actualiser la pice de dpart
// En effet, sa case d'arrive est dans ses arrival_squares
// searchmove(xboard[arr].wptr);


// Subactualiser roques
if (MOVE_IS_SPECIAL(lastmove))
{
	if (MOVE_IS_CASTLE(lastmove))
	{
		switch (arr)
		{
		case 48 : // Petit roque blanc
			 // un seul subactualise de dpart possible
			 set_bit_to_1(arrival_squares,56);
 			 set_bit_to_1(arrival_squares,40);
			 subactualise_cases_echecs_roi(56,false);
			 subactualise_cases_echecs_roi(40,false);
 			 // Actualisation roi et tour
			 searchmove(xboard[48].wptr);
			 searchmove(xboard[40].wptr);
			 break;
		case 16 : // Grand roque blanc
			 // un seul subactualise de dpart possible
			 set_bit_to_1(arrival_squares,0);
 			 set_bit_to_1(arrival_squares,24);
 			 subactualise_cases_echecs_roi(0,false);
			 subactualise_cases_echecs_roi(24,false);
			 // Actualisation roi et tour
			 searchmove(xboard[16].wptr);
			 searchmove(xboard[24].wptr);
			 break;
		case 55 : // Petit roque noir
			 // un seul subactualise de dpart possible
 			 set_bit_to_1(arrival_squares,63);
 			 set_bit_to_1(arrival_squares,47);
 			 subactualise_cases_echecs_roi(63,false);
			 subactualise_cases_echecs_roi(47,false);
			 // Actualisation roi et tour
			 searchmove(xboard[55].wptr);
			 searchmove(xboard[47].wptr);
			 break;
		case 23 : // Grand roque noir
			 // un seul subactualise de dpart possible
			 set_bit_to_1(arrival_squares,7);
 			 set_bit_to_1(arrival_squares,31);
  			 subactualise_cases_echecs_roi(7,false);
			 subactualise_cases_echecs_roi(31,false);
			 // Actualisation roi et tour
			 searchmove(xboard[23].wptr);
			 searchmove(xboard[31].wptr);
			 break;
		}
	}	
	else if (MOVE_IS_EN_PASSANT(lastmove))
	{
		set_bit_to_1(arrival_squares,arr+TO_COLOR(xwtm));
		subactualise_cases_echecs_roi(arr+TO_COLOR(xwtm),false);
	}
} // move special

} // fin else actualisation dernier coup


// Flagage actualisation des clouages, cases d'checs et couvertures d'chec
// AVANT la boucle sur les pices
if ( !F_mouvement_roi[0] )
{
// Maj case d'checs dame
if (xF_dir_actualisation_roi[0]!=0)
{
s->cases_echec_dame[1]=s->cases_echec_tour[1] | s->cases_echec_fou[1];
//F_mettre_a_jour_clouages[0]=true;
}
} // fin pas de mouvement de roi
else // F_mouvement_roi[0]==true
{
// Maj coordonnes roi
// fait ds le dpart car utile pour la king safety
// Traitement king_safety
// => est fait par l'actualisation du roi
// Rinitialisation cases d'checs et de clouage
// Couleur de l'autre joueur
// Facultatif
s->cases_echec_tour[1]=0;
s->cases_echec_fou[1]=0;
//s->cases_echec_pion[1]=0;
// Recherche cases chec
local_player=-1;
roi_pos=s->roi_pos[0];
inventaire_cases_echecs(local_player,roi_pos,'F',-7);
inventaire_cases_echecs(local_player,roi_pos,'F',+7);
inventaire_cases_echecs(local_player,roi_pos,'F',-9);
inventaire_cases_echecs(local_player,roi_pos,'F',+9);
inventaire_cases_echecs(local_player,roi_pos,'T',-1);
inventaire_cases_echecs(local_player,roi_pos,'T',+1);
inventaire_cases_echecs(local_player,roi_pos,'T',-8);
inventaire_cases_echecs(local_player,roi_pos,'T',+8);
// Obtention par | logique des cases d'checs de dame
s->cases_echec_dame[1]=s->cases_echec_tour[1] | s->cases_echec_fou[1];
//F_mettre_a_jour_clouages[0]=true;
} // fin mouvement de roi



// BLanc
if ( !F_mouvement_roi[1] )
{
if (xF_dir_actualisation_roi[1]!=0)
{
s->cases_echec_dame[0]=s->cases_echec_tour[0] | s->cases_echec_fou[0];
//F_mettre_a_jour_clouages[1]=true;
}
} // fin mouvement de roi==0
else // F_mouvement_roi[1]==true 
{
// Maj coordonnes roi
// Fait ds le dbut car utile pour la king safety
// Traitement king_safety
// => fait par l'actualisation
// Couleur de l'autre joueur
// Facultatif
s->cases_echec_tour[0]=0;
s->cases_echec_fou[0]=0;
//s->cases_echec_pion[0]=0;
// Recherche clouages
local_player=1;
roi_pos=s->roi_pos[1];
inventaire_cases_echecs(local_player,roi_pos,'F',-7);
inventaire_cases_echecs(local_player,roi_pos,'F',+7);
inventaire_cases_echecs(local_player,roi_pos,'F',-9);
inventaire_cases_echecs(local_player,roi_pos,'F',+9);
inventaire_cases_echecs(local_player,roi_pos,'T',-1);
inventaire_cases_echecs(local_player,roi_pos,'T',+1);
inventaire_cases_echecs(local_player,roi_pos,'T',-8);
inventaire_cases_echecs(local_player,roi_pos,'T',+8);
// Obtention par | logique des cases d'checs de dame
s->cases_echec_dame[0]=s->cases_echec_tour[0] | s->cases_echec_fou[0];
//F_mettre_a_jour_clouages[1]=true;
} // fin mouvement de roi



// Dtermination origine chec
// Remarque : pour les cavaliers cela passe par subactualise_cases_echecs_roi
// Mais on aurait pu aussi tester la position du roi adverse par rapport  une case 
// d'arrive de cavalier
if ( chkptr[xwtm]==NULL ) 
{
	check=0;
}
else if (chkptr2[xwtm]==NULL ) 
{
	ECHEC_SIMPLE:
	local_chkptr=chkptr[xwtm];
	local_chk_inc=chk_inc[xwtm];
	check=local_chkptr->nature;
	// Case de couverture d'chec
	if ( check=='C' )
	{
		cases_couverture_echecs=((unsigned __int64)1<<local_chkptr->pos);	
	}
	else // echec par F,T,D
	{
		#if DEBUG==1
		if (local_chkptr->color01!=1-xwtm)
		{
			log_error("\nM_484");
			sprintf(xbuffer,"\nxwtm %d", xwtm );
			log_error(xbuffer);
			sprintf(xbuffer,"\nPosroi %d", s->roi_pos[1-xwtm] );
			log_error(xbuffer);
			sprintf(xbuffer,"\nLevel %d", xlevel );
			log_error(xbuffer);
			sprintf(xbuffer,"\nxpasse %d", xpasse);
			log_error(xbuffer);
			sprintf(xbuffer,"\nCode %d", MOVE_ROLE(xlastmove) );
			log_error(xbuffer);
			sprintf(xbuffer,"\ndep %d", MOVE_DEP88(xlastmove) );
			log_error(xbuffer);
			sprintf(xbuffer,"\narr %d", MOVE_ARR88(xlastmove) );
			log_error(xbuffer);
			sprintf(xbuffer,"\narr %c", MOVE_NATURE(xligne[xlevel-2]));
			log_error(xbuffer);
		}	
		#endif	


		// Ennregistrement des cases de couvertures d'checs
	   	//ptr64=&sl->cases_couverture_echecs;
		//*ptr64=0;
		cases_couverture_echecs=0;

		// Dtermination de xchk_inc dans search_echecs_clouages		
		roi_pos=s->roi_pos[xwtm];

		// Cases de couvertue : au moins la case de la pice donnant checs
		set_bit_to_1(cases_couverture_echecs,local_chkptr->pos);	
		
		for (case_couverture=roi_pos+local_chk_inc;
			 case_couverture!=local_chkptr->pos;
			 case_couverture+=local_chk_inc)
		{
		      // Scurit anti-boucle
			//if ( case_couverture<0 ||case_couverture>63 )
			if (case_couverture&(~63)) 
			{
				#if DEBUG==1
				log_error("\nM_485");
				sprintf(xbuffer,"\nPosroi %d", roi_pos);
				log_error(xbuffer);
				sprintf(xbuffer,"\nPoschk %d", chkptr[xwtm]->pos);
				log_error(xbuffer);
				sprintf(xbuffer,"\nPosnat %c", chkptr[xwtm]->nature);
				log_error(xbuffer);
				#endif
				break;
			}
			set_bit_to_1(cases_couverture_echecs,case_couverture);	
		}
	}
}
else // echec double
{	
	ECHEC_DOUBLE:
	check=ECHEC_DOUBLE;
	// Pas de cases de couverture d'chec
	cases_couverture_echecs=0;
}



// Clouage adversaires et cases contrles
// et des cases d'attaques pour les pions
MAJ_CASES_CONTROLEES:
if (xwtm==0)
{
cases_controlees_pion_adversaire=
	(s->cases_pions[1]<<9) // attention sens dcalage
	|
    (s->cases_pions[1]>>7); // attention sens dcalage
//cases_attaque_pion=
//	(s->cases_pieces[1]>>9) // attention sens dcalage
//	|
//    (s->cases_pieces[1]<<7); // attention sens dcalage
}
else
{
cases_controlees_pion_adversaire=
	(s->cases_pions[0]<<7) // attention sens dcalage
	|
	(s->cases_pions[0]>>9); // attention sens dcalage
//cases_attaque_pion=
//	(s->cases_pieces[0]>>7) // attention sens dcalage
//	|
//    (s->cases_pieces[0]<<9); // attention sens dcalage
}	   

// Dtermination des cases d'arrives adverses
cases_controlees_adversaire=0;
//cases_controlees_pion_adversaire=0; initialis ci-dessus.
cases_controlees_cavalier_adversaire=0;
cases_controlees_fou_adversaire=0;
cases_controlees_tour_adversaire=0;
cases_controlees_dame_adversaire=0;
// cases_controlees_roi_adversaire=0; inutile car un seul roi
//cases_controlees_clouage_possible_adversaire; initialis ailleurs
//#if EXTEND_ON_MATE_THREATS==1
//cases_de_mat_adversaire=0;
//#endif
//cases_de_mat_conjuguees=0;
//cases_de_mat=0;

#if _DEBUG
F_calculate_case_controlees_joueur=false;
#endif
#if USE_CASES_CONTROLEES_JOUEUR==1
//if ( true 
	//(xlevel>xextendlevel+1 && s->materiel_dames>0)
	//|| check!=0 // Pour le classement du bilan simlifi
	//check==0 && NOOOON : car le classement des coups est important
	//s->materiel_dames[xwtm]>0 
	//&& xlevel<=xextendlevel+10
//)
#if _DEBUG
{ F_calculate_case_controlees_joueur=true; }
#endif
{
cases_controle_exclusif_dame=0;
cases_controle_exclusif_tour=0;
cases_controle_exclusif_fou=0;
cases_controle_exclusif_cavalier=0;
// cases_controle_exclusif_roi=0; inutile

if (xwtm==1)
{
cases_controle_exclusif_pion=
	(s->cases_pions[1]<<9) // attention sens dcalage
	|
    (s->cases_pions[1]>>7); // attention sens dcalage
}
else
{
cases_controle_exclusif_pion=
	(s->cases_pions[0]<<7) // attention sens dcalage
	|
	(s->cases_pions[0]>>9); // attention sens dcalage
}	   
}
#endif


// Boucler sur le psptr de toutes les pices pour searchmove si besoin
// et pour placer les flags de clouages des pices du level
char k;
// Si chec, toutes les pices peuvent avoir des coups illgaux
if (check!=0) pieces_with_possible_illegal_moves=(~0);
else pieces_with_possible_illegal_moves=0;


// Boucle sur les pices adverses
// En premier pour dterminer les cases controlees de l'adversaire 
// dont on a besoin pour les pices cloues
// En effet, une pice cloue fait partie des cases d'checs dame 
// mais aussi des cases controlees dame de l'adversaire 
// Pices adverses
color01=1-xwtm; // Eviter wtm qui n'est pas dfini en 0 !
{
    wptr=&xw[0+((1-color01)<<4)];
    // Boucle sur les pices
    for (k=0+((1-color01)<<4);k<=xw_size[color01];k++,wptr++)
    {
        if (wptr->nature==0) continue;
        if ((wptr->psptr->cases_actualisation&arrival_squares)!=0)
        {
            searchmove(wptr);
        }
        switch(wptr->nature)
        {
            case 0   :  continue;
            case 'P' :  // dja fait
                        // cases_controlees_pion_adversaire|=psptr->cases_controlees;
                        break;
            case 'C' :
                        cases_controlees_cavalier_adversaire|=wptr->psptr->cases_actualisation;
                        break;
            case 'F' :  
                        cases_controlees_fou_adversaire|=wptr->psptr->cases_actualisation;
                        break;
            case 'T' :  
                        cases_controlees_tour_adversaire|=wptr->psptr->cases_actualisation;
                        break;
            case 'D' :  
                        cases_controlees_dame_adversaire|=wptr->psptr->cases_actualisation;
                        break;
            case 'R' :  //psptr=wptr->psptr;
						// On peut crire une galit car il y a un seul roi
                        cases_controlees_roi_adversaire=wptr->psptr->cases_actualisation;
                        break;
        }
            #if _DEBUG
                if (bit(wptr->psptr->cases_actualisation,wptr->pos))
                { log_error("Err M_7422", xcompteur); }
            #endif
    }
}   
// Fin des "oring"
// Attention
// Fou contient pion, fou et cavalier
// Tour contient Tour, Fou, Cavalier et pion
// cases_controlles contient la dame et leroi, soit tout
// REspecter l'ordre d'affectation
cases_clouage_possible=
        (
		 cases_controlees_fou_adversaire // ne contient pas encore les cases de cavalier
		|cases_controlees_tour_adversaire
		|cases_controlees_dame_adversaire
		)
		& s->cases_echec_dame[1-xwtm];
// Cumul des cases contrlees
// Les cases contrles sont utilises pour la fonction de bilan coup simplifie
// qui est pas ou peu utilise.

//#if EXTEND_ON_MATE_THREATS==1
//cases_controle_exclusif_dame_adversaire=cases_controlees_dame_adversaire;
//#endif
cases_controlees_fou_adversaire|=cases_controlees_pion_adversaire;
cases_controlees_fou_adversaire|=cases_controlees_cavalier_adversaire;
cases_controlees_tour_adversaire|=cases_controlees_fou_adversaire;
cases_controlees_dame_adversaire|=cases_controlees_tour_adversaire;
cases_controlees_adversaire|=cases_controlees_dame_adversaire;
#if USE_MATE_IN_ONE==1
cases_controlees_adversaire_hors_roi=cases_controlees_adversaire;
#endif
cases_controlees_adversaire|=cases_controlees_roi_adversaire;
//cases_controlees[1-wtm]=cases_controlees_adversaire;                         


// Pices amies
color01=xwtm;
{
    wptr=&xw[0+((1-color01)<<4)];
    // Boucle sur les pices amies
    for (k=0+((1-color01)<<4);k<=xw_size[color01];k++,wptr++)
    {
        if (wptr->nature==0) continue;
        if ((wptr->psptr->cases_actualisation&arrival_squares)!=0)
        {
            searchmove(wptr);
        }
        if (check==0) // Si check!=0, pieces_with_possible_illegal_moves=(~0);
        {
            switch(wptr->nature)
            {
            case 'R' : set_bit_to_1(pieces_with_possible_illegal_moves,k);
                       break;
            case 'P' : if (color01==1)
                          {
                                 if (wptr->posy==4)
                                 { set_bit_to_1(pieces_with_possible_illegal_moves,k); break; }
                          }
                          else // color01==0
                          {
                                 if (wptr->posy==3)
                                 { set_bit_to_1(pieces_with_possible_illegal_moves,k); break; }
                          }
                          if (bit(cases_clouage_possible,wptr->pos))
                          {
							     // Coteux
                                 // if (SEARCH::testcheck_clouage(color01,s->roi_pos[color01],wptr->pos))
							     // Mieux vaut analyser plus tard et cumuler l'info au moment o le clouage est tabli
                                 { set_bit_to_1(pieces_with_possible_illegal_moves,k); break; }
                                 break;
                          }
            default :   if (bit(cases_clouage_possible,wptr->pos))
                        {
							      
							     // Coteux
                                 // if (SEARCH::testcheck_clouage(color01,s->roi_pos[color01],wptr->pos))
							     // Mieux vaut analyser plus tard et cumuler l'info au moment o le clouage est tabli
                                  { set_bit_to_1(pieces_with_possible_illegal_moves,k); break; }
                                   break;
                        }
			}
		}
			#if USE_CASES_CONTROLEES_JOUEUR==1
			ASSERT(F_calculate_case_controlees_joueur);
            switch(wptr->nature)
            {
            case 0   :  continue;
            case 'P' :  // dja fait
                        //psptr=wptr->psptr;
                        // cases_controlees_pion|=psptr->cases_controlees;
                        break;
            case 'C' :  //psptr=wptr->psptr;
						// on cumule sur le fou car on n'a pas besoin de l'information relative aux cavaliers
                        cases_controle_exclusif_cavalier|=wptr->psptr->cases_actualisation;
                        break;
            case 'F' :  //psptr=wptr->psptr;
                        cases_controle_exclusif_fou|=wptr->psptr->cases_actualisation;
                        break;
            case 'T' :  //psptr=wptr->psptr;
                        cases_controle_exclusif_tour|=wptr->psptr->cases_actualisation;
                        break;
            case 'D' :
                        cases_controle_exclusif_dame|=wptr->psptr->cases_actualisation;
                        break;
            case 'R' :
                        // Fou intentionnellement
						// On peut crire une galit car il y a un seul roi
                        cases_controle_exclusif_roi=wptr->psptr->cases_actualisation;
                        break;
            default  :  break;
            }
 			#endif
        }
}   
cases_controlees_joueur=cases_controle_exclusif_pion
                |cases_controle_exclusif_cavalier
				|cases_controle_exclusif_fou
				|cases_controle_exclusif_tour
				|cases_controle_exclusif_dame
				|cases_controle_exclusif_roi;
//cases_controlees[wtm]=cases_controlees_joueur;

//#if EXTEND_ON_MATE_THREATS==1
//cases_controlees_hors_roi=cases_controle_exclusif_pion
//                         |cases_controle_exclusif_fou
//      if                   |cases_controle_exclusif_tour
//                         |cases_controle_exclusif_dame; 
//#endif



#if USE_MATE_IN_ONE==1
if (
	// Car Dame+1pion = FIN_DE_PARTIE_1
	(finale==MILIEU_DE_PARTIE || s->materiel_dames[xwtm]>0) 
	&& !check
	//&& xextend
	)
{
// En search, on veut vrifier si les checs adverses ne retardent pas un mat
ASSERT(finale==s->finale);
roi_pos_other=s->roi_pos[other_wtm];
cases_arrivee_roi_adverse=xcases_arrivee_roi[roi_pos_other];


#if MATE_IN_ONE_CHECK_INTERCEPTIONS==1
if (xwtm)
{ 
	// Pions noirs
	cases_avancee_pion_adversaire=	s->cases_pions[1-xwtm]>>1  
								 |  (s->cases_pions[1-xwtm]&xmasque_septieme[1])>>2;
}
else
{
	// Pions blanc
	cases_avancee_pion_adversaire=	s->cases_pions[1-xwtm]<<1  
								 |  (s->cases_pions[1-xwtm]&xmasque_septieme[0])<<2;
}
cases_interception_adversaire=  
							  (
								cases_controlees_cavalier_adversaire
							  | cases_controlees_fou_adversaire
							  | cases_controlees_tour_adversaire
							  | cases_controlees_dame_adversaire
							  | cases_avancee_pion_adversaire
							  );
						      // On n'exclut pas les cases de contact du roi adverse

#endif



// Il faut (hlas) faire une deuxime boucle sur les pices
// car dans la premire, les cases contrles ne sont pas encore connues

color01=xwtm;
{
    wptr=&xw[0+((1-color01)<<4)];
    // Boucle sur les pices amies
    for (k=0+((1-color01)<<4);k<=xw_size[color01];k++,wptr++)
    {
		switch(wptr->nature)
		{
			case 'D' :
				maj_cases_de_mat(wptr,'D', s->cases_echec_dame[xwtm]);
				break;
			case 'T' :
				maj_cases_de_mat(wptr,'T', s->cases_echec_tour[xwtm]);
				break;
			case 'F' :
				//maj_cases_de_mat(wptr,'F', s->cases_echec_fou[xwtm]);
				break;
			case 'C' :
				// Souvent le cavalier ne donne pas mat
				// parce qu'il intercepte les pices amies.
				//maj_cases_de_mat(wptr,'C', xcases_arrivee_cavalier[roi_pos_other]);
				break;
			case 'P' : 
				//if (wptr->psptr->cases_actualisation&cases_arrivee_roi_adverse)
				//{
				//	maj_cases_de_mat(wptr,'P',s->cases_echec_dame[xwtm]);
				//}
				break;
			default : break;
		}
	}
}
}
#endif
#endif


#if USE_CASES_ACTUALISATION==0
// Actualisation des clouages, cases d'checs et couvertures d'chec
// Noir 
if ( !F_mouvement_roi[0] )
{
// Maj case d'checs dame
if (xF_dir_actualisation_roi[0]!=0)
{
s->cases_echec_dame[1]=s->cases_echec_tour[1] | s->cases_echec_fou[1];
}
} // fin pas de mouvement de roi
else // F_mouvement_roi[0]==true
{
// Maj coordonnes roi
// fait ds le dpart car utile pour la king safety
// Traitement king_safety
// => est fait par l'actualisation du roi
// Rinitialisation cases d'checs et de clouage
// Couleur de l'autre joueur
// Facultatif
s->cases_echec_tour[1]=0;
s->cases_echec_fou[1]=0;
//s->cases_echec_pion[1]=0;
// Recherche cases chec
local_player=-1;
roi_pos=s->roi_pos[0];
inventaire_cases_echecs(local_player,roi_pos,'F',-7);
inventaire_cases_echecs(local_player,roi_pos,'F',+7);
inventaire_cases_echecs(local_player,roi_pos,'F',-9);
inventaire_cases_echecs(local_player,roi_pos,'F',+9);
inventaire_cases_echecs(local_player,roi_pos,'T',-1);
inventaire_cases_echecs(local_player,roi_pos,'T',+1);
inventaire_cases_echecs(local_player,roi_pos,'T',-8);
inventaire_cases_echecs(local_player,roi_pos,'T',+8);
// Obtention par | logique des cases d'checs de dame
s->cases_echec_dame[1]=s->cases_echec_tour[1] | s->cases_echec_fou[1];
} // fin mouvement de roi


// BLanc
if ( !F_mouvement_roi[1] )
{
if (xF_dir_actualisation_roi[1]!=0)
{
s->cases_echec_dame[0]=s->cases_echec_tour[0] | s->cases_echec_fou[0];
}
} // fin mouvement de roi==0
else // F_mouvement_roi[1]==true 
{
// Maj coordonnes roi
// Fait ds le dbut car utile pour la king safety
// Traitement king_safety
// => fait par l'actualisation
// Couleur de l'autre joueur
// Facultatif
s->cases_echec_tour[0]=0;
s->cases_echec_fou[0]=0;
//s->cases_echec_pion[0]=0;
// Recherche clouages
local_player=1;
roi_pos=s->roi_pos[1];
inventaire_cases_echecs(local_player,roi_pos,'F',-7);
inventaire_cases_echecs(local_player,roi_pos,'F',+7);
inventaire_cases_echecs(local_player,roi_pos,'F',-9);
inventaire_cases_echecs(local_player,roi_pos,'F',+9);
inventaire_cases_echecs(local_player,roi_pos,'T',-1);
inventaire_cases_echecs(local_player,roi_pos,'T',+1);
inventaire_cases_echecs(local_player,roi_pos,'T',-8);
inventaire_cases_echecs(local_player,roi_pos,'T',+8);
// Obtention par | logique des cases d'checs de dame
s->cases_echec_dame[0]=s->cases_echec_tour[0] | s->cases_echec_fou[0];
} // fin mouvement de roi

// Rem
// les checs de pices sont dtermins via s->chkptr et
// - inventaire_cases_echecs() pour les P,F,T,D
// - searchmove pour les checs de cavaliers 
//     => l'actualisation des coups de cavaliers est obligatoire
// Ceci permet :
// - de dterminer l'origine des checs mme si actualisation partielle
// - de rechercher les clouages indispensables au contrle de lgalit des coups
// Une recherche des checs seulement par actualisation ne donnerait pas les clouages

// Dtermination origine chec
if ( chkptr[xwtm]==NULL ) 
{
	check=0;
}
else if (chkptr2[xwtm]==NULL ) 
{
	local_chkptr=chkptr[xwtm];
	local_chk_inc=chk_inc[xwtm];
	check=local_chkptr->nature;
	// Case de couverture d'chec
	if ( check=='C' )
	{
		cases_couverture_echecs=((unsigned __int64)1<<local_chkptr->pos);	
	}
	else // echec par F,T,D
	{
		#if DEBUG==1
		if (local_chkptr->color01!=1-xwtm)
		{
			log_error("\nM_484");
			sprintf(xbuffer,"\nxwtm %d", xwtm );
			log_error(xbuffer);
			sprintf(xbuffer,"\nPosroi %d", s->roi_pos[1-xwtm] );
			log_error(xbuffer);
			sprintf(xbuffer,"\nLevel %d", xlevel );
			log_error(xbuffer);
			sprintf(xbuffer,"\nxpasse %d", xpasse);
			log_error(xbuffer);
			sprintf(xbuffer,"\nCode %d", MOVE_ROLE(xlastmove) );
			log_error(xbuffer);
			sprintf(xbuffer,"\ndep %d", MOVE_DEP88(xlastmove) );
			log_error(xbuffer);
			sprintf(xbuffer,"\narr %d", MOVE_ARR88(xlastmove) );
			log_error(xbuffer);
			sprintf(xbuffer,"\narr %c", MOVE_NATURE(xligne[xlevel-2]));
			log_error(xbuffer);
		}	
		#endif	


		// Ennregistrement des cases de couvertures d'checs
	   	//ptr64=&sl->cases_couverture_echecs;
		//*ptr64=0;
		cases_couverture_echecs=0;

		// Dtermination de xchk_inc dans search_echecs_clouages		
		roi_pos=s->roi_pos[xwtm];

		// Cases de couvertue : au moins la case de la pice donnant checs
		set_bit_to_1(cases_couverture_echecs,local_chkptr->pos);	
		
		for (case_couverture=roi_pos+local_chk_inc;
			 case_couverture!=local_chkptr->pos;
			 case_couverture+=local_chk_inc)
		{
		      // Scurit anti-boucle
			//if ( case_couverture<0 ||case_couverture>63 )
			if (case_couverture&(~63)) 
			{
				#if DEBUG==1
				log_error("\nM_485");
				sprintf(xbuffer,"\nPosroi %d", roi_pos);
				log_error(xbuffer);
				sprintf(xbuffer,"\nPoschk %d", chkptr[xwtm]->pos);
				log_error(xbuffer);
				sprintf(xbuffer,"\nPosnat %c", chkptr[xwtm]->nature);
				log_error(xbuffer);
				#endif
				break;
			}
			set_bit_to_1(cases_couverture_echecs,case_couverture);	
		}
	}
}
else // echec double
{	
	check=ECHEC_DOUBLE;
	// Pas de cases de couverture d'chec
	cases_couverture_echecs=0;
}
#endif


#if RECHERCHE_DECOUVERTES==1
if (finale<FIN_DE_PARTIE_1 && check==0)
{
if (
	#if DECOUVERTES_ON_EXTEND==1
    (xextend && xlevel==xextendlevel)
	 ||
    #endif
	(!xextend && xlevel>=depthtarget_level-2)
)
{
ASSERT(xwtm==wtm);
u64=(unsigned __int64) (
	// Laisser tomber les dcouvertes de pions 
	//(s->cases_pieces[wtm]|s->cases_pions[wtm])
	s->cases_pieces[wtm]
	& s->cases_echec_dame[wtm]
	// Et pas une dcouverte de roi non plus !
	& (~((unsigned __int64)1<<s->roi_pos[wtm]))
	);
while(u64!=0)
{
	char arr64_original ,arr64, inc64, i, nbinc;
	arr64_original=bitScanForward_Clear(u64);
	arr64=arr64_original;
	j=xdirections64_from64_to64[s->roi_pos[1-wtm]][arr64];
	if (xmasque_direction[arr64_original][j]
	    & 
		s->cases_pieces[wtm]
	    //& (~((unsigned __int64)1<<s->roi_pos[wtm]))
	    )
	{
	inc64=xinc64_from64_to64[s->roi_pos[1-wtm]][arr64];
	nbinc=xnbinc_par_direction[arr64][j];
	for (i=1;i<=nbinc;i++)
	{
		arr64+=inc64;
		if (xboard[arr64].nature==0) continue;
		if (xboard[arr64].color01==1-wtm) break;
		nature=xboard[arr64].nature;
		if (nature=='D'
			|| (nature=='T' && (abs(inc64)==1 || abs(inc64)==8))
			|| (nature=='F' && (abs(inc64)==7 || abs(inc64)==9))
			)
		{
			// En extend, au dela de xextendlevel, 
			// limiter les dcouvertes aux dcouvertes de dame et tour
			//if (xextend && xlevel>xextendlevel && nature!='D' && nature!='T') break;
			F_decouverte=true;
			decouverte_num=xboard[arr64_original].num_piece;
			break;
		}
		break;
	}
	}
};
}
}
#endif

// Traitement king safety
#if KING_SAFETY==1
if (F_faire_maj_king_safety_0)
{
king_safety(0);
}
if (F_faire_maj_king_safety_1)
{
king_safety(1);
}
#endif



} // fin actualise




#if USE_CASES_ACTUALISATION==1
#if USE_MATE_IN_ONE==1
void SEARCH::maj_cases_de_mat(PIECE *wptr,char nature, unsigned __int64 &cases_echec)
{
	char i;
	unsigned __int64 cases_de_mat, cases_de_fuite, i64;
	unsigned __int64 move;
	#if MATE_IN_ONE_CHECK_INTERCEPTIONS==1
	unsigned __int64 cases_interception;
	#endif
	bool F_promotion;
	char pos;
	bool F_contact;
	char cc;
    char delta_x, delta_y;
	char pos_1, pos_2;

	// Cases de menace mat
	switch(nature)
	{
		case 'P' :
				if (wptr->color01==1 && wptr->posy==6)
				{
					F_promotion=true;
					cases_de_mat=0;
					pos=wptr->pos;
					if (xboard[pos-7].nature!=0) // Si on veut prendre
					{ cases_de_mat|=((unsigned __int64) 1<<(pos-7)); }
					if (xboard[pos+9].nature!=0) // Si on veut prendre
					{ cases_de_mat|=((unsigned __int64) 1<<(pos+9)); }
					if (xboard[pos+1].nature==0) // Si on veut avancer
					{ cases_de_mat|=((unsigned __int64) 1<<(pos+1)); }
					cases_de_mat&=(~cases_controlees_adversaire_hors_roi)
							       &cases_echec // dame
 				   				   //  conserver car fait plus loin
								   //&(~cases_pieces_amies)
								   ;
				}
				else if (wptr->color01==0 && wptr->posy==1)
				{ 
					F_promotion=true;
					cases_de_mat=0;
					pos=wptr->pos;
					if (xboard[pos+7].nature!=0) // Si on veut prendre
					{ cases_de_mat|=((unsigned __int64) 1<<(pos+7)); }
					if (xboard[pos-9].nature!=0) // Si on veut prendre
					{ cases_de_mat|=((unsigned __int64) 1<<(pos-9)); }
					if (xboard[pos-1].nature==0) // Si on veut avancer
					{ cases_de_mat|=((unsigned __int64) 1<<(pos-1)); }
					cases_de_mat&=(~cases_controlees_adversaire_hors_roi)
							       &cases_echec // dame
			  					   //  conserver car fait plus loin
								   //&(~cases_pieces_amies)
								   ;
				}
				else
				{
					F_promotion=false;
					cases_de_mat=
					(  ((unsigned __int64) 1<<(wptr->pos-COLOR(wptr->color,7)))
					  |((unsigned __int64) 1<<(wptr->pos+COLOR(wptr->color,9)))
					)
					&xcases_arrivee_roi[roi_pos_other]
					&(~cases_controlees_adversaire_hors_roi)
					//  conserver car fait plus loin
					//&(~cases_pieces_amies)
					;
				}
				break;
	default : 
				cases_de_mat=
					wptr->psptr->cases_actualisation
					&(~cases_controlees_adversaire_hors_roi)
					&cases_echec
					//  conserver car fait plus loin
				    //&(~cases_pieces_amies) 
					;
				break;
	}


    // Valider que les cases de mat donnent mat
	// (absence de case de fuite pour le roi)
	if (cases_de_mat)
	{
		switch(nature)
		{
		case 'D' :
			i64=cases_de_mat;
			while (i64!=0)
			{
				i=SEARCH::bitScanForward_Clear(i64);
				// Vrifier que la case n'est pas occupe par une 
				// pice amie qui figure dans les cases d'actualisation
				if (xboard[i].color01==xwtm)
				{ 
					// dja fait set_bit_to_0(i64,i); 
					continue; 
				}
				// Rem : la pice n'est pas attaque
				// par une pice adverse autre que le roi
				// cela a t vrifi pralablement


				// S'agit-il d'une case contrle pa le roi adverse
				if (bit(cases_arrivee_roi_adverse,i))
				{
					F_contact=true;
					// Vrifier que la pice est protge
					// pour donner chec au roi adverse
					if (!bit(cases_controle_exclusif_tour
							|cases_controle_exclusif_fou
							|cases_controle_exclusif_cavalier
							|cases_controle_exclusif_pion
							|cases_controle_exclusif_roi
							, i))
					{ 
						// dja fait set_bit_to_0(i64,i); 
						continue; 
					}
				}
				else
				{
					F_contact=false;
					#if MATE_IN_ONE_CHECK_INTERCEPTIONS==1
					// Cases d'interception possibles
					cases_interception= (xmasque_direction[i][xdirections64_from64_to64[i][roi_pos_other]]
									  &xmasque_direction[roi_pos_other][xdirections64_from64_to64[roi_pos_other][i]])
									&cases_interception_adversaire;
					if (cases_interception!=0)
					{ 
						// dja fait : 
						// set_bit_to_0(i64,i); 
						continue; 
					}
					#endif
				}
				cases_de_fuite=cases_arrivee_roi_adverse
					   &
					(~(
					    cases_controle_exclusif_tour
					   |cases_controle_exclusif_fou
					   |cases_controle_exclusif_cavalier
					   |cases_controle_exclusif_pion
					   |cases_controle_exclusif_roi
				       |s->cases_pieces[1-xwtm]
				       |s->cases_pions[1-xwtm]
					   |xcases_arrivee_dame[i]
					   )
					);
				if (cases_de_fuite==0)
				{
					// Il faut vrifier le cas suivant 
					// Blanc donne chec en f7
					// roi va en d7 avec un pion en e7
					// il n'y a pas mat, en dpit du fait 
					// que les cases d'arrive de la dame en 
					// f7 couvrent d7
					if (F_contact)
					{
					cc=abs(roi_pos_other-i);
					// Il faut que la dame donne chec en
					// diagonale
					if (cc==7 || cc==9)
					{
						delta_x=(X64(roi_pos_other)-X64(i)>0?8:-8);
						delta_y=Y64(roi_pos_other)-Y64(i);

						// Premire case  vrifier 
						// deux cases  gauche
						pos_1=i+delta_x;
						pos_2=pos_1+delta_x;

						if (pos_2>=0 && pos_2<=63
							&& bit(xcases_arrivee_roi[roi_pos_other],pos_2)
							)
						{
							// pos_1 intercepte avec une pice
							if (xboard[pos_1].nature!=0)
							{
								// pos2 est libre pour le roi
								// et n'est pas en chec
							    if ( 
									 bit(
									     cases_controle_exclusif_tour
								 	    |cases_controle_exclusif_fou
								 	    |cases_controle_exclusif_cavalier
									    |cases_controle_exclusif_pion
									    |cases_controle_exclusif_roi
									    |s->cases_pieces[1-xwtm]
									    |s->cases_pions[1-xwtm],
									 pos_2
									 )==0
								   )
									{
									   // pos2 n'est pas en chec ou occupe
									   // par une pice amie
									   // Donc, c'est une cas de fuite
				  					   { 
										   // Dja fait 
										   // set_bit_to_0(i64,i); 
										   continue; 
									   }
									}
							}
						}

						// Deuxime case  vrifier 
						// Deux cases au dessus
						pos_1=i+delta_y;
						pos_2=pos_1+delta_y;

						if (pos_2>=0 && pos_2<=63
							&& bit(xcases_arrivee_roi[roi_pos_other],pos_2)
							)
						{
							// pos_1 intercepte avec une pice
							if (xboard[pos_1].nature!=0)
							{
								// pos2 est libre pour le roi
								// et n'est pas en chec
							    if ( 
									 bit(
									     cases_controle_exclusif_tour
								 	    |cases_controle_exclusif_fou
								 	    |cases_controle_exclusif_cavalier
									    |cases_controle_exclusif_pion
									    |cases_controle_exclusif_roi
									    |s->cases_pieces[1-xwtm]
									    |s->cases_pions[1-xwtm],
									 pos_2
									 )==0
								   )
									{
									   // pos2 n'est pas en chec ou occupe
									   // par une pice amie
									   // Donc, c'est une cas de fuite
				  					   { 
										   // dja fait 
										   // set_bit_to_0(i64,i); 
										   continue; 
									   }
									}
							}
						}
					} // fin contact diagonal
					} // fin if contact
					move=MOVE_MAKE('D',wptr->pos,i,0,COUP_FORCANT);
					SET_MOVE_CAPTURE(move,xboard[i].nature);
					cc=legal(MOVE_NUM_PIECE(move),move,xnum_roi[xwtm],0);
					if (cc!=1)
					{ 
					  // dja fait 
					  // set_bit_to_0(i64,i); 
						continue; 
					}
					hint_move=move;
					F_case_de_mat=true;	
					return;
				}
			};
			break;
		case 'T' :
			i64=cases_de_mat;
			while (i64!=0)
			{
				i=SEARCH::bitScanForward_Clear(i64);
				// Vrifier que la case n'est pas occupe par une 
				// pice amie qui figure dans les cases d'actualisation
				if (xboard[i].color01==xwtm)
				{ 
					// dja  fait set_bit_to_0(i64,i); 
					continue; 
				}
				// Rem : la pice n'est pas attaque
				// par une pice adverse autre que le roi 
				// cela a t vrifi pralablement

				// S'agit-il d'une case de roi adverse
				if (bit(cases_arrivee_roi_adverse,i))
				{
					// Vrifier que la pice est protge
					// pour donner chec au roi adverse
					if (!bit(cases_controle_exclusif_tour
							|cases_controle_exclusif_fou
							|cases_controle_exclusif_cavalier
							|cases_controle_exclusif_pion
							|cases_controle_exclusif_roi
							, i))
					{ 
					  // dja fait 
					  // set_bit_to_0(i64,i); 
						continue; 
					}
				}
				#if MATE_IN_ONE_CHECK_INTERCEPTIONS==1
				else
				{
					// Cases d'interception possibles
					cases_interception= (xmasque_direction[i][xdirections64_from64_to64[i][roi_pos_other]]
									  &xmasque_direction[roi_pos_other][xdirections64_from64_to64[roi_pos_other][i]])
									&cases_interception_adversaire;
					if (cases_interception!=0)
					{
						// set_bit_to_0(i64,i);
						continue; 
					}
				}
				#endif
				cases_de_fuite=cases_arrivee_roi_adverse
					   &
					(~(
					    cases_controle_exclusif_dame
					   |cases_controle_exclusif_fou
					   |cases_controle_exclusif_cavalier
					   |cases_controle_exclusif_pion
					   |cases_controle_exclusif_roi
				       |s->cases_pieces[1-xwtm]
				       |s->cases_pions[1-xwtm]
					   |xcases_arrivee_tour[i]
					   )
					);
				if (cases_de_fuite==0)
				{
					hint_move=MOVE_MAKE('T',wptr->pos,i,0,COUP_FORCANT);
					SET_MOVE_CAPTURE(hint_move,xboard[i].nature);
					cc=legal(MOVE_NUM_PIECE(hint_move),hint_move,xnum_roi[xwtm],0);
					if (cc!=1) 
					{ 
					  // dja fait 
					  // set_bit_to_0(i64,i); 
						continue; 
					}
					F_case_de_mat=true;	
					return;

				}
			};
			break;
		case 'F' :
			i64=cases_de_mat;
			while (i64!=0)
			{
				i=SEARCH::bitScanForward_Clear(i64);
				// Vrifier que la case n'est pasoccupe par une 
				// pice amie qui figure dans les cases d'actualisation
				if (xboard[i].color01==xwtm)
				{ 
					  // dja fait 
					  // set_bit_to_0(i64,i); 
						continue; 
				}
				// Rem : la pice n'est pas attaque
							// par une pice adverse autre que le roi
							// cela a t vrifi pralablement

				// S'agit-il d'une case de roi adverse
				if (bit(cases_arrivee_roi_adverse,i))
				{
					// Vrifier que la pice est protge
					// pour donner chec au roi adverse
					if (!bit(cases_controle_exclusif_tour
							|cases_controle_exclusif_fou
							|cases_controle_exclusif_cavalier
							|cases_controle_exclusif_pion
							|cases_controle_exclusif_roi
							, i))
					{ 
					  // dja fait 
					  // set_bit_to_0(i64,i); 
						continue; 
					}
				}
				#if MATE_IN_ONE_CHECK_INTERCEPTIONS==1
				else
				{
					// Cases d'interception possibles
					cases_interception= (xmasque_direction[i][xdirections64_from64_to64[i][roi_pos_other]]
									  &xmasque_direction[roi_pos_other][xdirections64_from64_to64[roi_pos_other][i]])
									&cases_interception_adversaire;
					if (cases_interception!=0)
					{ 
					  // dja fait 
					  // set_bit_to_0(i64,i); 
						continue; 
					}
				}
				#endif
				cases_de_fuite=cases_arrivee_roi_adverse
					   &
					(~(
					    cases_controle_exclusif_dame
					   |cases_controle_exclusif_tour
					   |cases_controle_exclusif_cavalier
					   |cases_controle_exclusif_pion
					   |cases_controle_exclusif_roi
				       |s->cases_pieces[1-xwtm]
				       |s->cases_pions[1-xwtm]
					   |xcases_arrivee_fou[i]
					   )
					);
				if (cases_de_fuite==0)
				{
					hint_move=MOVE_MAKE('F',wptr->pos,i,0,COUP_FORCANT);
					SET_MOVE_CAPTURE(hint_move,xboard[i].nature);
					cc=legal(MOVE_NUM_PIECE(hint_move),hint_move,xnum_roi[xwtm],0);
					if (cc!=1) 
					{ 
					  // dja fait 
					  // set_bit_to_0(i64,i); 
						continue; 
					}
					F_case_de_mat=true;	
					return;
				}
			};
			break;
		case 'C' :
			i64=cases_de_mat;
			while (i64!=0)
			{
				// Problme : le cavalier intercepte souvent 
				// les pices amies, et le plus souvent, il n'y a pas mat
				i=SEARCH::bitScanForward_Clear(i64);
				// Vrifier que la case n'est pas occupe par une 
				// pice amie qui figure dans les cases d'actualisation
				if (xboard[i].color01==xwtm)
				{ 
					  // dja fait 
					  // set_bit_to_0(i64,i); 
						continue; 
				}
				// S'agit-il d'une case de roi adverse
				// Impossible pour un cavalier
				// Et pas de cases d'interception
				cases_de_fuite=cases_arrivee_roi_adverse
					 & (~
					   (cases_controle_exclusif_dame
					   |cases_controle_exclusif_tour
					   |cases_controle_exclusif_fou
					   |cases_controle_exclusif_pion
					   |cases_controle_exclusif_roi
				       |s->cases_pieces[1-xwtm]
				       |s->cases_pions[1-xwtm]
					   |xcases_arrivee_cavalier[i])
					  );
				if (cases_de_fuite==0)
				{
					hint_move=MOVE_MAKE('C',wptr->pos,i,0,COUP_FORCANT);
					SET_MOVE_CAPTURE(hint_move,xboard[i].nature);
					cc=legal(MOVE_NUM_PIECE(hint_move),hint_move,xnum_roi[xwtm],0);
					if (cc!=1) 
					{ 
					  // dja fait 
					  // set_bit_to_0(i64,i); 
						continue; 
					}
					F_case_de_mat=true;	
					return;
				}
			};
			break;
		case 'P' :
			i64=cases_de_mat;
			while (i64!=0)
			{
				i=SEARCH::bitScanForward_Clear(i64);
				// Vrifier que la case n'est pas occupe par une 
				// pice amie qui figure dans les cases d'actualisation
				if (xboard[i].color01==xwtm)
				{ 
					  // dja fait 
					  // set_bit_to_0(i64,i); 
						continue; 
				}
				if (F_promotion)
				{
					// S'agit-il d'une case de roi adverse
					// ou d'une case controles par l'adversaire
					if (bit(cases_arrivee_roi_adverse,i))
					{
						// Rem : la pice n'est pas attaque
						// par une pice adverse autre que le roi
						// cela a t vrifi pralablement

						// Vrifier que la pice est protge
						// pour donner chec au roi adverse
						if (!bit(cases_controle_exclusif_tour
								|cases_controle_exclusif_fou
								|cases_controle_exclusif_cavalier
								|cases_controle_exclusif_pion
								|cases_controle_exclusif_roi
								, i))
					{ 
					  // dja fait 
					  // set_bit_to_0(i64,i); 
						continue; 
					}
					}
					#if MATE_IN_ONE_CHECK_INTERCEPTIONS==1
					else
					{
						// Cases d'interception possibles
						cases_interception= (xmasque_direction[i][xdirections64_from64_to64[i][roi_pos_other]]
										  &xmasque_direction[roi_pos_other][xdirections64_from64_to64[roi_pos_other][i]])
										&cases_interception_adversaire;
						if (cases_interception!=0)
						{ 
						  // dja fait 
						  // set_bit_to_0(i64,i); 
							continue; 
						}
					}
					#endif
					// Case de fuite promotion
					cases_de_fuite=cases_arrivee_roi_adverse
						  &(~
							(cases_controle_exclusif_dame
							|cases_controle_exclusif_tour
							|cases_controle_exclusif_fou
							|cases_controle_exclusif_cavalier
							|cases_controle_exclusif_pion // peut rester
							|cases_controle_exclusif_roi
							|s->cases_pieces[1-xwtm]
							|s->cases_pions[1-xwtm]
							|xcases_arrivee_dame[i])
						  );
				}
				else // Cas normal : pas de promotion
				{
					// Vrifier que le pion est protg
					// car il est sur une case du roi
						if (!bit(cases_controle_exclusif_dame
								|cases_controle_exclusif_tour
								|cases_controle_exclusif_fou
								|cases_controle_exclusif_cavalier
								|cases_controle_exclusif_roi
								, i))
						{ 
						  // dja fait 
						  // set_bit_to_0(i64,i); 
							continue; 
						}

					    // Rappel : la case d'chec est protege
						// et est donc exclue des cases de fuite par l'opration suivante
						cases_de_fuite=cases_arrivee_roi_adverse
						   & (~
							  (cases_controle_exclusif_dame
							|cases_controle_exclusif_tour
							|cases_controle_exclusif_fou
							|cases_controle_exclusif_cavalier
							|cases_controle_exclusif_roi
							|s->cases_pieces[1-xwtm]
							|s->cases_pions[1-xwtm])
							);
				}
				if (cases_de_fuite==0)
				{
					if (F_promotion)
					{
						if (wptr->color01==1 && wptr->posy==6)
						{
							hint_move=MOVE_MAKE('P',wptr->pos,i,MovePromote|MovePromoteQueen,COUP_FORCANT);
							// Important pour rechercher le coup dans les listes disponibles
							SET_MOVE_CAPTURE(hint_move,xboard[i].nature);
							cc=legal(MOVE_NUM_PIECE(hint_move),hint_move,xnum_roi[xwtm],0);
							if (cc!=1)
							{ 
							  // dja fait 
							  // set_bit_to_0(i64,i); 
							  continue; 
							}
							F_case_de_mat=true;	
							return;
						}
						else if (wptr->color01==0 && wptr->posy==1)
						{
							F_case_de_mat=true;
							hint_move=MOVE_MAKE('P',wptr->pos,i,MovePromote|MovePromoteQueen,COUP_FORCANT);
							// Important pour rechercher le coup dans les listes disponibles
							SET_MOVE_CAPTURE(hint_move,xboard[i].nature);
							cc=legal(MOVE_NUM_PIECE(hint_move),hint_move,xnum_roi[xwtm],0);
							if (cc!=1) 
							{ 
							  // dja fait 
							  // set_bit_to_0(i64,i); 
								continue; 
							}
							F_case_de_mat=true;	
							return;
						}
					}
					else
					{
						F_case_de_mat=true;
						hint_move=MOVE_MAKE('P',wptr->pos,i,0,COUP_FORCANT);
						// Important pour rechercher le coup dans les listes disponibles
						SET_MOVE_CAPTURE(hint_move,xboard[i].nature);
						cc=legal(MOVE_NUM_PIECE(hint_move),hint_move,xnum_roi[xwtm],0);
						if (cc!=1) 
						{ 
						  // dja fait 
						  // set_bit_to_0(i64,i); 
							continue; 
						}
						F_case_de_mat=true;	
						return;
					}
					return;
				}
			};
			break;
		default : ASSERT(false); break;
		} // fin switch nature
	} // fin test

	return;
}
#endif
#endif


#if USE_CASES_ACTUALISATION==1
void SEARCH::subactualise_cases_echecs_roi(char dep_or_arr, bool F_case_possible_arrivee_cavalier)
{
char inc;
char roi_pos;
CASE *aptr;
char indice_inc;
PIECE *wptr;

// Initialisations
aptr=&xboard[dep_or_arr];

// Flagage des directions si directions de roi
// ( ncessite cptr! )
// Noir
//if (    aptr->posx==s->roi_posx[0]
//	 || aptr->posy==s->roi_posy[0]
//	 || aptr->diag1==s->roi_diag1[0]
//	 || aptr->diag2==s->roi_diag2[0] 
//   )
if (bit(s->cases_echec_dame[1],dep_or_arr))
{
roi_pos=s->roi_pos[0];
// Les coups de roi donnent lieu de toute faon  actualisation du roi
if (dep_or_arr!=roi_pos)
{
inc=xinc64_from64_to64[roi_pos][dep_or_arr];
#if DEBUG==1
if (   inc!=1 && inc!=-1 && inc!=8 && inc!=-8
	&& inc!=7 && inc!=-7 && inc!=9 && inc!=-9)
	log_error("\nErr M_267");
#endif
indice_inc=INDICE_INC64(inc);
if (bit(xF_dir_actualisation_roi[0],indice_inc)==0)
{
	set_bit_to_1(xF_dir_actualisation_roi[0],indice_inc);
	if (inc==1 || inc==-1 || inc==8 || inc==-8)
		inventaire_cases_echecs(-1,roi_pos,'T',inc);
	else 
		inventaire_cases_echecs(-1,roi_pos,'F',inc);
}
} // fin condition
} // fin condition


// Blanc
//if (    aptr->posx==s->roi_posx[1]
//	 || aptr->posy==s->roi_posy[1]
//	 || aptr->diag1==s->roi_diag1[1]
//	 || aptr->diag2==s->roi_diag2[1] 
//   )
if (bit(s->cases_echec_dame[0],dep_or_arr))
{
roi_pos=s->roi_pos[1];
// Les coups de roi donnent lieu de toute faon  actualisation du roi 
if (dep_or_arr!=roi_pos) 	
{
inc=xinc64_from64_to64[roi_pos][dep_or_arr];
#if DEBUG==1
if (   inc!=1 && inc!=-1 && inc!=8 && inc!=-8
	&& inc!=7 && inc!=-7 && inc!=9 && inc!=-9)
	log_error("\nErr M_267");
#endif
indice_inc=INDICE_INC64(inc);
if (bit(xF_dir_actualisation_roi[1],indice_inc)==0)
{
	set_bit_to_1(xF_dir_actualisation_roi[1],indice_inc);
	if (inc==1 || inc==-1 || inc==8 || inc==-8)
		inventaire_cases_echecs(1,roi_pos,'T',inc);
	else 
		inventaire_cases_echecs(1,roi_pos,'F',inc);
}
} // condition sur case d'arrive
} // condition sur case d'arrive	

// Recherche des checs de cavalier si case d'arrive pice
if (F_case_possible_arrivee_cavalier)
{
	// Coup de cavalier ou promotion en cavalier
	// Attention  la promotion !
	// (ici il s'agit d'une case d'arrive)
	if (xboard[dep_or_arr].nature=='C')
	{
		if (bit(xcases_arrivee_cavalier[dep_or_arr],s->roi_pos[xwtm]))
		{
				// xwtm==side_checked01
				wptr=xboard[dep_or_arr].wptr;
				if (chkptr[xwtm]==NULL) 
				{ 
				    chkptr[xwtm]=wptr;
				}
				else if (wptr!=chkptr[xwtm])
				{
					chkptr2[xwtm]=wptr; // Echec double
				}
		}
	}
}
} // fin fonction
#endif

#if USE_CASES_ACTUALISATION==0
void SEARCH::subactualise(char dep_or_arr,bool F_case_arrivee,char inc_dep_arr,bool F_do_knights)
{
// Attention wptr est modifie par searchmove
// et dans le cas des roques il y a 2 pices dplaces
//char cc,dd;
//char dd;
//char nature;
//PIECE *wptr;
char arr;
char i;
char inc;
#if USE_BITBOARD_SUBACTUALISE==0
char *inc_ptr;

char arr2;
char nb_inc;
char nbinc_max;
#endif
#if USE_BITBOARD_SUBACTUALISE==1 || USE_BITBOARD_VERIFICATION==1
unsigned __int64 bb_all, bb_all_util, i64;
char nature, target, distance;
char cases_pieces_candidates[32];
char nb_pieces_candidates;
CASE *target_ptr;
char *squarenum;
#endif
#if USE_BITBOARD_VERIFICATION==1
unsigned __int64 normal_searchmove=0;
unsigned __int64 bitboard_searchmove=0;
#endif
char roi_pos;
//unsigned __int64 cases_arrivee_cavalier;
CASE *aptr, *cptr;
char indice_inc;
char nb_knights_on_arrival_square=0;

// Initialisation
aptr=&xboard[dep_or_arr];

// Flagage des directions si directions de roi
// ( ncessite cptr! )
// Noir
//if (    aptr->posx==s->roi_posx[0]
//	 || aptr->posy==s->roi_posy[0]
//	 || aptr->diag1==s->roi_diag1[0]
//	 || aptr->diag2==s->roi_diag2[0] 
//   )
if (bit(s->cases_echec_dame[1],dep_or_arr))
{
roi_pos=s->roi_pos[0];
// Les coups de roi donnent lieu de toute faon  actualisation du roi
if (dep_or_arr!=roi_pos)
{
inc=xinc64_from64_to64[roi_pos][dep_or_arr];
#if DEBUG==1
if (   inc!=1 && inc!=-1 && inc!=8 && inc!=-8
	&& inc!=7 && inc!=-7 && inc!=9 && inc!=-9)
	log_error("\nErr M_267");
#endif
indice_inc=INDICE_INC64(inc);
if (bit(xF_dir_actualisation_roi[0],indice_inc)==0)
{
	set_bit_to_1(xF_dir_actualisation_roi[0],indice_inc);
	if (inc==1 || inc==-1 || inc==8 || inc==-8)
		inventaire_cases_echecs(-1,roi_pos,'T',inc);
	else 
		inventaire_cases_echecs(-1,roi_pos,'F',inc);
}
} // fin condition
} // fin condition


// Blanc
//if (    aptr->posx==s->roi_posx[1]
//	 || aptr->posy==s->roi_posy[1]
//	 || aptr->diag1==s->roi_diag1[1]
//	 || aptr->diag2==s->roi_diag2[1] 
//   )
if (bit(s->cases_echec_dame[0],dep_or_arr))
{
roi_pos=s->roi_pos[1];
// Les coups de roi donnent lieu de toute faon  actualisation du roi 
if (dep_or_arr!=roi_pos) 	
{
inc=xinc64_from64_to64[roi_pos][dep_or_arr];
#if DEBUG==1
if (   inc!=1 && inc!=-1 && inc!=8 && inc!=-8
	&& inc!=7 && inc!=-7 && inc!=9 && inc!=-9)
	log_error("\nErr M_267");
#endif
indice_inc=INDICE_INC64(inc);
if (bit(xF_dir_actualisation_roi[1],indice_inc)==0)
{
	set_bit_to_1(xF_dir_actualisation_roi[1],indice_inc);
	if (inc==1 || inc==-1 || inc==8 || inc==-8)
		inventaire_cases_echecs(1,roi_pos,'T',inc);
	else 
		inventaire_cases_echecs(1,roi_pos,'F',inc);
}
} // condition sur case d'arrive
} // condition sur case d'arrive


// Actualisation de la pice occupant la case
// ou marquage non actualise
if (F_case_arrivee)
{
// Il faut actualiser les coups de cavalier 
// pour la dtection des checs quoi qu'il arrive
// et en search pour dtecter les pices menaces
// En extend, cela permet aussi de mettre  jour develop
// et de connatre immdiatement 
// l'existence de coups forcants

// Searchmove
searchmove(aptr->wptr);
}  // Fin case arrive

 
#if USE_BITBOARD_SUBACTUALISE==0 
// Recherche P, F, T, D par rayonnement
inc_ptr=&xinc64[0];
for (i=0;i<8;i++,inc_ptr++)
{
inc=*inc_ptr;

// Ne pas analyser dans cette direction - La pice dplace est forcment actualise
if (inc==inc_dep_arr) continue;

// Passer  la direction suivante si la direction est vide
// if ((cases_occupees & xmasque_direction[dep_or_arr][i])==0) continue;
 
// i doit etre de 8  16
nbinc_max=xnbinc_par_direction[dep_or_arr][i];

// wptr : pointeur de pice  actualiser

// Contrle non-dbordement du tableau
for(arr=dep_or_arr+inc
	,nb_inc=1
	;
    nb_inc<=nbinc_max
    ;
	nb_inc++, 
	arr+=inc)
{
ASSERT(arr>=0 && arr<=63);
ASSERT(nb_inc<=xnbinc_par_direction[dep_or_arr][i]);
if (bit(cases_occupees,arr)==0) 
{
	ASSERT(xboard[arr].nature==0);
	continue;
}
ASSERT(xboard[arr].nature!=0);
cptr=&xboard[arr];
// Pointeur de pice  actualiser
switch(cptr->nature)
{
case 0 : continue; // case suivante
case 'P': 
	  if (nb_inc==1)
	  {
		  if (cptr->color==1)
		  {
		    switch(inc)
			{
				case -1 : searchmove(cptr->wptr); 
						  #if USE_BITBOARD_VERIFICATION==1
								set_bit_to_1(normal_searchmove,cptr->pos);
						  #endif
						  break;
				case -9 : searchmove(cptr->wptr);
						  #if USE_BITBOARD_VERIFICATION==1
								set_bit_to_1(normal_searchmove,cptr->pos);
						  #endif
						  break;
				case +7 : searchmove(cptr->wptr); 
						  #if USE_BITBOARD_VERIFICATION==1
								set_bit_to_1(normal_searchmove,cptr->pos);
						  #endif
					      break;
			}
			break;
		  }
		  else // wptr->color==-1
	      {
		    switch(inc)
			{
				case +1 : searchmove(cptr->wptr); 
						  #if USE_BITBOARD_VERIFICATION==1
							set_bit_to_1(normal_searchmove,cptr->pos);
						  #endif
					      break;
				case +9 : searchmove(cptr->wptr); 
						  #if USE_BITBOARD_VERIFICATION==1
								set_bit_to_1(normal_searchmove,cptr->pos);
						  #endif
					      break;
				case -7 : searchmove(cptr->wptr); 
						  #if USE_BITBOARD_VERIFICATION==1
								set_bit_to_1(normal_searchmove,cptr->pos);
						  #endif
					      break;
			}
			break;
		  }
	  } // fin nb_inc==1
	  else
	  {
	  if (nb_inc==2)
	  {
	  	if (cptr->color==1)
		{
		  if (inc==-1 && cptr->posy==1)
		  {
				searchmove(cptr->wptr); 
 			    #if USE_BITBOARD_VERIFICATION==1
				set_bit_to_1(normal_searchmove,cptr->pos);
				#endif
				break;
		  }
		  break;
	    }
		else // cptr->color==-1
  	    {  
		  if (inc==+1 && cptr->posy==6)
		  {
				searchmove(cptr->wptr); 
				#if USE_BITBOARD_VERIFICATION==1
				set_bit_to_1(normal_searchmove,cptr->pos);
				#endif
				break;
		  }
                break;
	    }
	  } // fin nb_inc==2
	  } // fin else
	  break;
case 'C': 
	  break;
case 'F': 
	  switch(inc)
	  {
		case +9 : searchmove(cptr->wptr); 
				  #if USE_BITBOARD_VERIFICATION==1
						set_bit_to_1(normal_searchmove,cptr->pos);
				  #endif
			      break;
		case -9 : searchmove(cptr->wptr); 
				  #if USE_BITBOARD_VERIFICATION==1
						set_bit_to_1(normal_searchmove,cptr->pos);
				  #endif
			      break;
		case -7 : searchmove(cptr->wptr); 
				  #if USE_BITBOARD_VERIFICATION==1
						set_bit_to_1(normal_searchmove,cptr->pos);
				  #endif
			      break;
		case +7 : searchmove(cptr->wptr); 
				  #if USE_BITBOARD_VERIFICATION==1
						set_bit_to_1(normal_searchmove,cptr->pos);
				  #endif
			      break;
	  }
      break;
case 'T': 
	  switch(inc)
	  {
		case +1 : searchmove(cptr->wptr); 
				  #if USE_BITBOARD_VERIFICATION==1
						set_bit_to_1(normal_searchmove,cptr->pos);
				  #endif
			      break;
		case -1 : searchmove(cptr->wptr); 
				  #if USE_BITBOARD_VERIFICATION==1
						set_bit_to_1(normal_searchmove,cptr->pos);
				  #endif
			      break;
		case -8 : searchmove(cptr->wptr); 
				  #if USE_BITBOARD_VERIFICATION==1
						set_bit_to_1(normal_searchmove,cptr->pos);
				  #endif
			      break;
		case +8 : searchmove(cptr->wptr); 
				  #if USE_BITBOARD_VERIFICATION==1
						set_bit_to_1(normal_searchmove,cptr->pos);
				  #endif
			      break;
	  }
	  break;
case 'D': 
      searchmove(cptr->wptr);
	  #if USE_BITBOARD_VERIFICATION==1
		set_bit_to_1(normal_searchmove,cptr->pos);
	  #endif
      break;
case 'R': 
	  // Le roi est toujours subactualis 
	  // pour valuer la KING_SAFETY
	  // On n'actualise le roi 
	  // que si la pice demandant l'actualisation
	  // est un des pions du roi
	  // ou si nb_inc==1 plutt ce qui est plus simple
	  if (nb_inc==1)
	  {
 		  searchmove(cptr->wptr); 
		  #if USE_BITBOARD_VERIFICATION==1
				set_bit_to_1(normal_searchmove,cptr->pos);
		  #endif
	      break;
	  }
	  break;
default : 
	  #if DEBUG==1
	  log_error("\n\aErr M_003");
	  #endif
	  break;
} // fin switch

// La  dirction est interrompue
break; // fin de direction
}; // fin while nbinc_max


} // fin for xdirections FTDR


// Recherche cavalier par rayonnement
#if FOLLOW_KNIGHTS==1
unsigned __int64 int64, int64_2;
char target;

int64=(s->cases_cavaliers[0]|s->cases_cavaliers[1])&xcases_arrivee_cavalier[dep_or_arr];
ASSERT(bit(int64,dep_or_arr)==0);
target=0;
while(int64!=0)
{
	if ((int64&1))
	{
		ASSERT((int64&1)==1);
		searchmove(xboard[target].wptr);
	}
	target++;
	int64>>=1;
}
#endif


#if FOLLOW_KNIGHTS==0
if (F_do_knights)
{
inc_ptr=&xinc64[8];
for (i=8;i>0;i--,inc_ptr++)
{
inc=*inc_ptr;
// La pice de la case d'arrive a deja t actualise
// et la case de dpart est vide
ASSERT(xinc64[INDICE_INC64(inc)]==inc);
arr2=dep_or_arr+inc; 
if (!WITHIN_BOARD(arr2))
{
	ASSERT(arr2<0 || arr2>63);
	continue;
}
ASSERT (arr2>=0 && arr2<=63);
if (xboard[arr2].nature!='C') continue; 
if (inc==inc_dep_arr) continue;
//if (!bit(cases_arrivee_cavalier,arr2)) continue;
//if (!bit(xcases_arrivee_cavalier[dep_or_arr],arr2)) continue;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             
if (!KNIGHT_MOVE_DEP_ARR_COMPATIBILITY(dep_or_arr,arr2)) continue;
#if DEBUG==1
ASSERT(MOVE_IS_OK_ASSERT(dep_or_arr,arr2,10,IsKnight));
#endif
// Inscription de la pice touche dans la liste d'actualisation
// de la pice de dpart
// Si la pice de dpart bouge, le cavalier doit tre initialis
//wptr=xboard[arr2].wptr;
//searchmove(wptr);
searchmove(xboard[arr2].wptr);
#if USE_BITBOARD_VERIFICATION==1
set_bit_to_1(normal_searchmove,arr2);
#endif
}
}
#endif
#endif

#if USE_BITBOARD_SUBACTUALISE==1
//char inc_indice;
// Attention : il peut y avoir plus de 8 pices candidates 
//  cause des pices masques
// mais pas plus de 4*7 + 8 = 36 cases


// Initialisations
nb_pieces_candidates=0;
//memset(cases_pieces_candidates,0,32); inutile !
//bb_all=xcases_arrivee_all[dep_or_arr]&(s->cases_toutes_pieces[0]|s->cases_toutes_pieces[1]);
bb_all=xcases_arrivee_all[dep_or_arr]
   &(
		 s->cases_pieces[0]
		|s->cases_pieces[1]
		|s->cases_pions[0]
		|s->cases_pions[1]
	);
ASSERT(bit(xcases_arrivee_all[dep_or_arr],dep_or_arr)==0);
bb_all_util=bb_all;

/* anciennement 
for(target=0;bb_all_util;target++,bb_all_util>>=1)
{
if (bb_all_util&1)
{
*/

while(bb_all_util!=0)
{
//i64=(bb_all_util&(~bb_all_util+1));
//i64=(bb_all_util^(bb_all_util-1));
i64=bb_all_util&(-bb_all_util);

/*
target=0;
while(i64!=1)
{
	target++;
	i64>>=1;
}*/

ASSERT(i64<=(unsigned __int64)1<<63);
switch(i64)
{
	case (unsigned __int64) 1<<0  : target= 0; break;
	case (unsigned __int64) 1<<1  : target= 1; break;
	case (unsigned __int64) 1<<2  : target= 2; break;
	case (unsigned __int64) 1<<3  : target= 3; break;
	case (unsigned __int64) 1<<4  : target= 4; break;
	case (unsigned __int64) 1<<5  : target= 5; break;
	case (unsigned __int64) 1<<6  : target= 6; break;
	case (unsigned __int64) 1<<7  : target= 7; break;
	case (unsigned __int64) 1<<8  : target= 8; break;
	case (unsigned __int64) 1<<9  : target= 9; break;
	case (unsigned __int64) 1<<10 : target=10; break;
	case (unsigned __int64) 1<<11 : target=11; break;
	case (unsigned __int64) 1<<12 : target=12; break;
	case (unsigned __int64) 1<<13 : target=13; break;
	case (unsigned __int64) 1<<14 : target=14; break;
	case (unsigned __int64) 1<<15 : target=15; break;
	case (unsigned __int64) 1<<16 : target=16; break;
	case (unsigned __int64) 1<<17 : target=17; break;
	case (unsigned __int64) 1<<18 : target=18; break;
	case (unsigned __int64) 1<<19 : target=19; break;
	case (unsigned __int64) 1<<20 : target=20; break;
	case (unsigned __int64) 1<<21 : target=21; break;
	case (unsigned __int64) 1<<22 : target=22; break;
	case (unsigned __int64) 1<<23 : target=23; break;
	case (unsigned __int64) 1<<24 : target=24; break;
	case (unsigned __int64) 1<<25 : target=25; break;
	case (unsigned __int64) 1<<26 : target=26; break;
	case (unsigned __int64) 1<<27 : target=27; break;
	case (unsigned __int64) 1<<28 : target=28; break;
	case (unsigned __int64) 1<<29 : target=29; break;
	case (unsigned __int64) 1<<30 : target=30; break;
	case (unsigned __int64) 1<<31 : target=31; break;
	case (unsigned __int64) 1<<32 : target=32; break;
	case (unsigned __int64) 1<<33 : target=33; break;
	case (unsigned __int64) 1<<34 : target=34; break;
	case (unsigned __int64) 1<<35 : target=35; break;
	case (unsigned __int64) 1<<36 : target=36; break;
	case (unsigned __int64) 1<<37 : target=37; break;
	case (unsigned __int64) 1<<38 : target=38; break;
	case (unsigned __int64) 1<<39 : target=39; break;
	case (unsigned __int64) 1<<40 : target=40; break;
	case (unsigned __int64) 1<<41 : target=41; break;
	case (unsigned __int64) 1<<42 : target=42; break;
	case (unsigned __int64) 1<<43 : target=43; break;
	case (unsigned __int64) 1<<44 : target=44; break;
	case (unsigned __int64) 1<<45 : target=45; break;
	case (unsigned __int64) 1<<46 : target=46; break;
	case (unsigned __int64) 1<<47 : target=47; break;
	case (unsigned __int64) 1<<48 : target=48; break;
	case (unsigned __int64) 1<<49 : target=49; break;
	case (unsigned __int64) 1<<50 : target=50; break;
	case (unsigned __int64) 1<<51 : target=51; break;
	case (unsigned __int64) 1<<52 : target=52; break;
	case (unsigned __int64) 1<<53 : target=53; break;
	case (unsigned __int64) 1<<54 : target=54; break;
	case (unsigned __int64) 1<<55 : target=55; break;
	case (unsigned __int64) 1<<56 : target=56; break;
	case (unsigned __int64) 1<<57 : target=57; break;
	case (unsigned __int64) 1<<58 : target=58; break;
	case (unsigned __int64) 1<<59 : target=59; break;
	case (unsigned __int64) 1<<60 : target=60; break;
	case (unsigned __int64) 1<<61 : target=61; break;
	case (unsigned __int64) 1<<62 : target=62; break;
	case (unsigned __int64) 1<<63 : target=63; break;
}
ASSERT(target>=0 && target<=63);
// Pb : comment obtenir la position ?
// on ne peut pas faire un tableau ?


	set_bit_to_0(bb_all_util,target); 
	//if (target==dep_or_arr+inc_dep_arr) 
	if (xinc64_from64_to64[dep_or_arr][target]==inc_dep_arr)
	{
		continue;
	}
	target_ptr=&xboard[target];
	nature=target_ptr->nature;
	if (nature=='C')
	{
		if (bit(xcases_arrivee_cavalier[target],dep_or_arr)==1)
		{
			searchmove(target_ptr->wptr);
			#if USE_BITBOARD_VERIFICATION==1
			set_bit_to_1(normal_searchmove,target);
			#endif
			// inutile : set_bit_to_0(bb_all,target); // vite un deuxime searchmove
			continue;
		}	
		else
		{
			// On masque les cases au dela de la pice concerne
			i64=(~xmasque_direction[target][xdirections64_from64_to64[dep_or_arr][target]]);
			bb_all_util&=i64;
			bb_all&=i64;
			// La pice n'est pas candidate car c'est un cavalier 
			// qui n'est pas sur une direction de cavalier
			// inutile : set_bit_to_0(bb_all,target); // vite un deuxime searchmove
			continue;
		}
	}	
	else // Pas cavalier
	{
			// Si la case est une case de cavalier, pas de masquage dans la direction
			if (bit(xcases_arrivee_cavalier[dep_or_arr],target)==1) 
			{
				// Et la pice n'est pas  actualiser
				// inutile : set_bit_to_0(bb_all,target); 
				// set_bit_to_0(bb_all_util,target); 
				continue;
			}

			// On masque les cases au dela de la pice concerne
			i64=(~xmasque_direction[target][xdirections64_from64_to64[dep_or_arr][target]]);
			bb_all_util&=i64;
			bb_all&=i64;
			cases_pieces_candidates[nb_pieces_candidates++]=target;
			continue;
	}
} // fin test sur bb_util



// Bouclage sur les pices candidates
for (i=0,squarenum=&cases_pieces_candidates[0];i<nb_pieces_candidates;i++)
{
	target=cases_pieces_candidates[i];

	// La pice est-elle en dfinitive masque ?
	if (bit(bb_all,target)==0) continue;

	// Actualisation
	nature=xboard[target].nature;
	
	switch ((int)nature)
	{
		case 'P' :
			distance=target-dep_or_arr;
			if (distance==1 || distance==-7 || distance==9)
			{
				cptr=&xboard[target];
				if (cptr->color01==0)
				{
					searchmove(cptr->wptr);
					#if USE_BITBOARD_VERIFICATION==1
					set_bit_to_1(normal_searchmove,target);
					#endif
				}
			}
			else if (distance==-1 || distance==+7 || distance==-9)
			{
				cptr=&xboard[target];
				if (cptr->color01==1)
				{
					searchmove(cptr->wptr);
					#if USE_BITBOARD_VERIFICATION==1
					set_bit_to_1(normal_searchmove,target);
					#endif
				}
			}
			else if (distance==2)
			{
				cptr=&xboard[target];
				if (cptr->color01==0)
				{
					if (cptr->posy==6)
					{
						searchmove(cptr->wptr);
						#if USE_BITBOARD_VERIFICATION==1
						set_bit_to_1(normal_searchmove,target);
						#endif
					}
				}
			}
			else if (distance==-2)
			{
				cptr=&xboard[target];
				if (cptr->color01==1)
				{
					if (cptr->posy==1)
					{
						searchmove(cptr->wptr);
						#if USE_BITBOARD_VERIFICATION==1
						set_bit_to_1(normal_searchmove,target);
						#endif
					}
				}
			}
		break;
		case 'F' :
			if (bit(xcases_arrivee_fou[target],dep_or_arr))
			{
				searchmove(xboard[target].wptr);
				#if USE_BITBOARD_VERIFICATION==1
				set_bit_to_1(normal_searchmove,target);
				#endif
			}
		break;	
		case 'T' :
			if (bit(xcases_arrivee_tour[target],dep_or_arr))
			{
				searchmove(xboard[target].wptr);
				#if USE_BITBOARD_VERIFICATION==1
				set_bit_to_1(normal_searchmove,target);
				#endif
			}
		break;
		case 'D' :
			if (bit(xcases_arrivee_dame[target],dep_or_arr))
			{
				searchmove(xboard[target].wptr);
				#if USE_BITBOARD_VERIFICATION==1
				set_bit_to_1(normal_searchmove,target);
				#endif
			}
		break;
		case 'R' :
			if (bit(xcases_arrivee_roi[target],dep_or_arr))
			{
				searchmove(xboard[target].wptr);
				#if USE_BITBOARD_VERIFICATION==1
				set_bit_to_1(normal_searchmove,target);
				#endif
			}
		break;
	} // fin switch
} // fin boucle sur les pices candidates
#endif


#if USE_BITBOARD_VERIFICATION==1
//char inc_indice;
// Attention : il peut y avoir plus de 8 pices candidates 
//  cause des pices masques
// mais pas plus de 4*7 + 8 = 36 cases

// Initialisations
nb_pieces_candidates=0;
//memset(cases_pieces_candidates,0,32); inutile !
//bb_all=xcases_arrivee_all[dep_or_arr]&(s->cases_toutes_pieces[0]|s->cases_toutes_pieces[1]);
bb_all=xcases_arrivee_all[dep_or_arr]
   &(
		 s->cases_pieces[0]
		|s->cases_pieces[1]
		|s->cases_pions[0]
		|s->cases_pions[1]
	);
ASSERT(bit(xcases_arrivee_all[dep_or_arr],dep_or_arr)==0);
bb_all_util=bb_all;

/* anciennement 
for(target=0;bb_all_util;target++,bb_all_util>>=1)
{
if (bb_all_util&1)
{
*/

while(bb_all_util!=0)
{
unsigned __int64 i64;
//i64=(bb_all_util&(~bb_all_util+1));
//i64=(bb_all_util^(bb_all_util-1));
i64=bb_all_util&(-bb_all_util);

target=0;
while(i64!=1)
{
	target++;
	i64>>=1;
}
ASSERT(target>=0 && target<=63);
// Pb : comment obtenir la position ?
// on ne peut pas faire un tableau ?


	set_bit_to_0(bb_all_util,target); 
	//if (target==dep_or_arr+inc_dep_arr) 
	if (xinc64_from64_to64[dep_or_arr][target]==inc_dep_arr)
	{
		continue;
	}
	target_ptr=&xboard[target];
	nature=target_ptr->nature;
	if (nature=='C')
	{
		if (bit(xcases_arrivee_cavalier[target],dep_or_arr)==1)
		{
			set_bit_to_1(bitboard_searchmove,target);
			// inutile : set_bit_to_0(bb_all,target); // vite un deuxime searchmove
			continue;
		}	
		else
		{
			// On masque les cases au dela de la pice concerne
			i64=(~xmasque_direction[target][xdirections64_from64_to64[dep_or_arr][target]]);
			bb_all_util&=i64;
			bb_all&=i64;
			// La pice n'est pas candidate car c'est un cavalier 
			// qui n'est pas sur une direction de cavalier
			// inutile : set_bit_to_0(bb_all,target); // vite un deuxime searchmove
			continue;
		}
	}	
	else // Pas cavalier
	{
			// Si la case est une case de cavalier, pas de masquage dans la direction
			if (bit(xcases_arrivee_cavalier[dep_or_arr],target)==1) 
			{
				// Et la pice n'est pas  actualiser
				// inutile : set_bit_to_0(bb_all,target); 
				continue;
			}

			// On masque les cases au dela de la pice concerne
			i64=(~xmasque_direction[target][xdirections64_from64_to64[dep_or_arr][target]]);
			bb_all_util&=i64;
			bb_all&=i64;
			cases_pieces_candidates[nb_pieces_candidates++]=target;
			continue;
	}
} // fin test sur bb_util



// Bouclage sur les pices candidates
for (i=0,squarenum=&cases_pieces_candidates[0];i<nb_pieces_candidates;i++)
{
	target=cases_pieces_candidates[i];

	// La pice est-elle en dfinitive masque ?
	if (bit(bb_all,target)==0) continue;

	// Actualisation
	nature=xboard[target].nature;
	
	switch ((int)nature)
	{
		case 'P' :
			distance=target-dep_or_arr;
			if (distance==1 || distance==-7 || distance==9)
			{
				cptr=&xboard[target];
				if (cptr->color01==0)
				{
					set_bit_to_1(bitboard_searchmove,target);
				}
			}
			else if (distance==-1 || distance==+7 || distance==-9)
			{
				cptr=&xboard[target];
				if (cptr->color01==1)
				{
					set_bit_to_1(bitboard_searchmove,target);
				}
			}
			else if (distance==2)
			{
				cptr=&xboard[target];
				if (cptr->color01==0)
				{
					if (cptr->posy==6)
					{
						set_bit_to_1(bitboard_searchmove,target);
					}
				}
			}
			else if (distance==-2)
			{
				cptr=&xboard[target];
				if (cptr->color01==1)
				{
					if (cptr->posy==1)
					{
						set_bit_to_1(bitboard_searchmove,target);
					}
				}
			}
		break;
		case 'F' :
			if (bit(xcases_arrivee_fou[target],dep_or_arr))
			{
				set_bit_to_1(bitboard_searchmove,target);
			}
		break;	
		case 'T' :
			if (bit(xcases_arrivee_tour[target],dep_or_arr))
			{
				set_bit_to_1(bitboard_searchmove,target);
			}
		break;
		case 'D' :
			if (bit(xcases_arrivee_dame[target],dep_or_arr))
			{
				set_bit_to_1(bitboard_searchmove,target);
			}
		break;
		case 'R' :
			if (bit(xcases_arrivee_roi[target],dep_or_arr))
			{
				set_bit_to_1(bitboard_searchmove,target);
			}
		break;
	} // fin switch
} // fin boucle sur les pices candidates

if (bitboard_searchmove!=normal_searchmove)
{
for(i=63;i>=0;i--)
{
	char cc,dd;
	cc=bit(normal_searchmove,i);
	dd=bit(bitboard_searchmove,i);
	if (cc!=dd)
	{
		cc=0;
	}
}
	log_error("\nErr M_6564");
}


#endif


} // fin subactualise()
#endif




void SEARCH::actualise_all()
{
     wtm=xwtm;
	 actualise(AllMoves);
	 #if DEBUG==1
		xsearch_level[xlevel]->check_reset_state_values(xlevel,0);
	 #endif
} // fin actualise_all



void maj_droit_roque(unsigned char &roque, char droit)
{
switch(droit)
{
	case ATTRIBUTION_DROIT_PETIT_ROQUE: 
		roque|=DROIT_PETIT_ROQUE;
		roque&=(DROIT_PETIT_ROQUE|DROIT_GRAND_ROQUE); // Supprime un roque ventuel prcdent
		break;
	case ATTRIBUTION_DROIT_GRAND_ROQUE: 
		roque|=DROIT_GRAND_ROQUE;
		roque&=(DROIT_PETIT_ROQUE|DROIT_GRAND_ROQUE); // Supprime un roque ventuel prcdent
		break;
	case PERTE_DROIT_PETIT_ROQUE :
		roque&=(~DROIT_PETIT_ROQUE);
		break;
	case PERTE_DROIT_GRAND_ROQUE :
		roque&=(~DROIT_GRAND_ROQUE);
		break;
	case PERTE_TOUT_DROIT_ROQUE: 
		roque=0;
		break;
	case EFFECTUE_PETIT_ROQUE: 
		roque=PETIT_ROQUE;
		break;
	case EFFECTUE_GRAND_ROQUE: 
		roque=GRAND_ROQUE;
		break;
}
} // fin maj_droit_roque



void SEARCH::maj_roque(MOVE move)
{
char num, dep, arr;
// inutile : char roque0_mem, roque1_mem;

// Attention ne pas modifier num, dep et arr

// Important
// Considrations sur le roque
// Le roque est gnr seulement si xo_o et xo_o_o sont gaux  zro
// au level 0.
// Sinon, le coup est systmatiquement gnr.
// Si le roque est impossible, il est interdit par le contr"le de lgalit

// xroque==0 : droquement
// xroque==4 : roque effectu petit
// xroque==8 : roque effectu grand

// o_o   ==4 : petit roque effectu
// o_o_o ==8 : grand roque effectu
// o_o   ==0 : petit roque impossible
// o_o_o ==0 : grand roque impossible
// o_o   ==1 : petit roque possible
// o_o_o ==2 : grand roque possible
// 

// De cette faon, la somme de o_o+o_o_o (roque)
// donne une valeur discrimante de 0  5 pour le droit
//  roquer d'un camp
// Somme
// 0 : droqu
// 1 : peut effectuer le petit roque
// 2 : peut effectuer le grand roque
// 3 : peut effectuer les deux roques
// 4 : a effectu le petit roque
// 8  : a effectu le grand roque
// code_roque=droit_roque[1]+droit_roque[0]*16 prend une valeur entre 0 et 137


if (!MOVE_MAY_IMPACT_ROQUE(move)) return;


// Pas d'actualisation si les droits  roquer ne sont plus impactables
if (!((s->droit_roque[1]|s->droit_roque[0])&(DROIT_PETIT_ROQUE|DROIT_GRAND_ROQUE)))
{
	goto RETURN;
}

 
dep=MOVE_DEP64(move);
arr=MOVE_ARR64(move);

ASSERT(dep==32 || dep==39 || arr==32 || arr==39 ||
	dep==0 || dep==7 || dep==56 || dep==63 ||
	arr==0 || arr==7 || arr==56 || arr==63 );


/* 
// Attention  IMPORTANT : les cas ne sont pas exclusifs !!
// ex: dep=11 arr=18
if (move==0) return;
*/

// Initialisations
num=xboard[arr].num_piece;

// Mise  jour (dpend de l'tat du roque)
// Blancs
if (s->droit_roque[1]&DROIT_PETIT_ROQUE)
	submajroque(1,num,dep,arr,56,s->droit_roque[1],PERTE_DROIT_PETIT_ROQUE);
if (s->droit_roque[1]&DROIT_GRAND_ROQUE)
	submajroque(1,num,dep,arr,0,s->droit_roque[1],PERTE_DROIT_GRAND_ROQUE);

// Noirs
if (s->droit_roque[0]&DROIT_PETIT_ROQUE)
	submajroque(0,num,dep,arr,63,s->droit_roque[0],PERTE_DROIT_PETIT_ROQUE);
if (s->droit_roque[0]&DROIT_GRAND_ROQUE)
	submajroque(0,num,dep,arr,7,s->droit_roque[0],PERTE_DROIT_GRAND_ROQUE);

// si les droits  roquer son modifis
// la king safety est revise en actualisation

RETURN:

// Maj quivalent_roque
if (s->roi_posx[1]<=2) s->equivalent_droit_roque[1]=GRAND_ROQUE;
else
{
	if (s->roi_posx[1]>=5) s->equivalent_droit_roque[1]=PETIT_ROQUE;
	else s->equivalent_droit_roque[1]=s->droit_roque[1];
}
if (s->roi_posx[0]<=2) s->equivalent_droit_roque[0]=GRAND_ROQUE;
else
{
	if (s->roi_posx[0]>=5) s->equivalent_droit_roque[0]=PETIT_ROQUE;
	else s->equivalent_droit_roque[0]=s->droit_roque[0];
}

} // fin maj_roque2



void SEARCH::submajroque (char couleur_droit, char num, char dep,char arr,
					 char position_tour_pour_le_droit,
					 unsigned char &roque,
					 char perte_droit_roque)
{
char cc;


// Test dplacement du roi
if (num==xnum_roi[couleur_droit])
{
// **** coup de roi
cc=0;
if (couleur_droit==1 && dep==32 && arr==48) cc=1;
if (couleur_droit==1 && dep==32 && arr==16) cc=2;
if (couleur_droit==0 && dep==39 && arr==55) cc=1;
if (couleur_droit==0 && dep==39 && arr==23) cc=2;
if (cc>=1)
{
// Petit roque
if (cc==1) 
{
s->droit_roque[couleur_droit]=PETIT_ROQUE; 
// s->o_o_o[couleur_droit]=0; 
return;
}
// Grand roque
if (cc==2) 
{
//s->o_o[couleur_droit]=0; 
s->droit_roque[couleur_droit]=GRAND_ROQUE; 
return;
}
} // Fin cc>=1
else
{
// Droquement par dplacement du roi
s->droit_roque[couleur_droit]=0;
// s->o_o_o[couleur_droit]=0;
return;
}
}


// Test prise de la tour ou jeu de la tour
// note : attention : le cas prcdent et celui-ci ne sont pas exclusifs
// l'un de l'autre : le roi noir peut venir prendre la tour h1 !!
// et dans ce cas, num!=xnum_roi[couleur_droit]
if (dep==position_tour_pour_le_droit || arr==position_tour_pour_le_droit)
{
// **** Dplacement tour ou prise tour
maj_droit_roque(roque,perte_droit_roque);  // valeur transmise par rfrence et modifie
// agit sur le roque transmis
}

return;
} // fin submajroque



void SEARCH::pion2(PIECE *wptr,PIECE_SET *psptr,char &mob_others,char &mob_prises,char &mobility2,char &promo)
{
char color, color01;
char pos;
char cc;
char num;
char y;
char dep,arr;
//char mobility;
char F_avance_deux_cases_possible;
MOVE move;
MOVE *liste_coups_piece_ptr,*liste_coups2_piece_ptr;
CASE *aptr;


// Initialisations 
num=wptr->num_piece;
//psptr->moves=liste_coups_piece_ptr=&xw_liste_coups_piece[xlevel][num][0]; 
//psptr->moves2=liste_coups2_piece_ptr=&xw_liste_coups2_piece[xlevel][num][0]; 
ASSERT(psptr->moves==&xw_liste_coups_piece[xlevel][num][0]);
ASSERT(psptr->moves2==&xw_liste_coups2_piece[xlevel][num][0]);
liste_coups_piece_ptr=psptr->moves;
liste_coups2_piece_ptr=psptr->moves2;
cc=0;
pos=wptr->pos;
color=wptr->color;
color01=TO_COLOR01(color);
F_avance_deux_cases_possible=0;
xidx=xmoves[wptr->pos][wptr->type][0];




for(;*xidx!=0;xidx++)
{
move=*xidx;
arr=MOVE_ARR64(move);
dep=MOVE_DEP64(move);;
aptr=&xboard[arr];

// Pion avance d'un case
if (abs(arr-dep)==1)
{
	if (aptr->color==0) 
	{
	F_avance_deux_cases_possible=1;
	// Promotions et menaces de promotion
	if (MOVE_IS_PROMOTION(move)) 
	{ 
		//SET_MOVE_NUM_PIECE(move,num);
		promo=1;
		#if USE_PIECES_ATTAQUEES==1 || USE_CASES_COUPS_FORCANTS==1 || USE_SEARCH_UNDEFENDED_PIECES==1
		maj_prise(wptr,arr,0,1); 
		#endif
		if (MOVE_PROMOTION(move)=='D')
		{
			*liste_coups2_piece_ptr++=move; 
			mob_prises++;
		}
		else
		{
			*liste_coups_piece_ptr++=move; 
			mob_others++;
		}
	}
	else // Avance pion sans promotion
	{
		//SET_MOVE_NUM_PIECE(move,num);
		//si1=MOVE_NUM_PIECE(move);
		*liste_coups_piece_ptr++=move; 
		mob_others++;
	}
	}
}
else
{
	// Pion avance de deux cases
	// ATTENTION
	// Seulement si le pion peut avancer au moins d'une case !!
	if (abs(arr-dep)==2)
	{
		if (aptr->color==0
		      && F_avance_deux_cases_possible==1
		   )
		{
			//SET_MOVE_NUM_PIECE(move,num);
			*liste_coups_piece_ptr++=move;
			 mob_others++;
		}
	}
	else 
	// Prise forcment
	{
	// Prise en passant
	if (MOVE_IS_EN_PASSANT(move))
	{
		 // Important : Ne pas renseigner la liste des prises pour la prise en passant !!!
		 // Le numro de pice prise est renseign dans legal
	       // La valeur de prise est dja fixe dans pion()
		 //SET_MOVE_NUM_PIECE(move,num);
		 //SET_MOVE_CAPTURE(move,'P'); dja fait
		 //SET_MOVE_CAPTURE_VALUE(move,VALEUR_PION);
		 *liste_coups2_piece_ptr++=move;
	 	 mob_prises++;
	}
	else // Prises normales
	{
	    if (aptr->color==-color)
	    {
		// Les pions attaqus par des pions 
		// sont toujours considrs attaqus
            if (aptr->nature=='P') 
	      {
			//SET_MOVE_NUM_PIECE(move,num);
			SET_MOVE_CAPTURE(move,'P');
			//SET_MOVE_CAPTURE_VALUE(move,VALEUR_PION);
			*liste_coups2_piece_ptr++=move;
			mob_prises++;
			#if USE_PIECES_ATTAQUEES==1 || USE_CASES_COUPS_FORCANTS==1 || USE_SEARCH_UNDEFENDED_PIECES==1
			if (!xextend) maj_prise(wptr,arr,1,0);
			#endif
			}
	 	else // coups forants "normaux" - prise pice par pion
		{   
			y=aptr->posy;
		    if (y==0 || y==7)
			{
			// On ajoute la valeur de la pice prise  celle d'une promotion ventuelle
			SET_MOVE_CAPTURE(move,aptr->nature);
			//SET_MOVE_CAPTURE_VALUE(move,MOVE_CAPTURE_VALUE(move)+aptr->piece_value);
			promo=1; 
			}
			//else // pas promotion
			//{
			SET_MOVE_CAPTURE(move,aptr->nature);
			//SET_MOVE_CAPTURE_VALUE(move,aptr->piece_value);
			//}
      		SET_MOVE_CATEGORY(move,COUP_FORCANT);
			//SET_MOVE_NUM_PIECE(move,num);
	  	      (*liste_coups2_piece_ptr++)=move;
			mob_prises++;
			#if USE_PIECES_ATTAQUEES==1 || USE_CASES_COUPS_FORCANTS==1 || USE_SEARCH_UNDEFENDED_PIECES==1
			if (!xextend) maj_prise(wptr,arr,1,1);
			#endif
		}
	    }
		/* A CONSERVER ABSOLUMENT
		else // Case controle sans prise
		{ 

		   #if USE_CASES_CONTROLEES==1
		   #if USE_EXTEND_CASES_CONTROLEES==0
		   if (!xextend)
		   #endif
		   {
 		   set_bit_to_1(psptr->cases_controlees,arr);
		   }
		   #endif
		}
		*/

	} // fin autres prises
	} // fin else Prise
} 

} // fin while

// Clture listes
*liste_coups_piece_ptr=0;
*liste_coups2_piece_ptr=0;

} // fin pion2




#if USE_BITBOARD_MOVE_GENERATION==0
void SEARCH::cava2(PIECE *wptr,PIECE_SET *psptr,char &mob_others, char &mob_prises,char &mobility2)
{
char ycolor;
char color;
char num;
//char mobility, mobility2;
char side_checked01;
MOVE move;
char arr;
char arr2;
char color01;
MOVE *liste_coups_piece_ptr,*liste_coups2_piece_ptr;
CASE *aptr;

// Initialisations 
num=wptr->num_piece;
//psptr->moves=liste_coups_piece_ptr=&xw_liste_coups_piece[xlevel][num][0]; 
//psptr->moves2=liste_coups2_piece_ptr=&xw_liste_coups2_piece[xlevel][num][0]; 
ASSERT(psptr->moves==&xw_liste_coups_piece[xlevel][num][0]);
ASSERT(psptr->moves2==&xw_liste_coups2_piece[xlevel][num][0]);
liste_coups_piece_ptr=psptr->moves;
liste_coups2_piece_ptr=psptr->moves2;
color=wptr->color;
color01=TO_COLOR01(color);
xidx=xmoves[wptr->pos][wptr->type][0];

for (;*xidx!=0;xidx++)
{
move=*xidx;
arr=MOVE_ARR64(move);
aptr=&xboard[arr];
ycolor=aptr->color;


if (ycolor==0)
{
	// Cases contrles par des pions adverses
	do
	{
		arr2=arr-COLOR(color,7);
		if (arr2>=1 && arr2<=62
		&& bit(s->cases_pions[1-color01],arr2)==1)
		{ mobility2-=2; break; }
		arr2=arr+COLOR(color,9);
		if (arr2>=1 && arr2<=62
		&& bit(s->cases_pions[1-color01],arr2)==1)
		{ mobility2-=2; break; }
		break;
	} while(1);

	//#if USE_CASES_CONTROLEES==1
	//#if USE_EXTEND_CASES_CONTROLEES==0
	//if (!xextend)
	//#endif
	//{
 //	set_bit_to_1(psptr->cases_controlees,arr);
	//}
	//#endif
	//SET_MOVE_NUM_PIECE(move,num);
	*liste_coups_piece_ptr++=move;
	mob_others++;
	continue;
}
else if (ycolor==color)
{
    //#if USE_CASES_CONTROLEES==1
    //#if USE_EXTEND_CASES_CONTROLEES==0
    //if (!xextend)
    //#endif
    //{
 	  // set_bit_to_1(psptr->cases_controlees,arr);
    //}
    //#endif
    mobility2-=2; // anti "pice lie en dfense" 
}
else if (ycolor==-color)
{
         switch (aptr->nature)
		 {
		 case 'P' : 
			        mobility2+=2;
 				do
				{
					arr2=arr-COLOR(color,7);
					if (arr2>=1 && arr2<=62
					&& bit(s->cases_pions[1-TO_COLOR01(color)],arr2)==1)
					{ mobility2-=1; break; }
					arr2=arr+COLOR(color,9);
					if (arr2>=1 && arr2<=62
					&& bit(s->cases_pions[1-TO_COLOR01(color)],arr2)==1)
					{ mobility2-=1; break; }
					break;
				} while(1);
					//SET_MOVE_CATEGORY_AND_PAWNSTRUCT_FLAG(move,PRISE_PION_PAR_PIECE); 
					SET_MOVE_CATEGORY(move,PRISE_PION_PAR_PIECE); 
					#if SUIVI_PRISES==1
					(*xprisespionptr)++;
					#endif
					#if USE_PIECES_ATTAQUEES==1 || USE_CASES_COUPS_FORCANTS==1 || USE_SEARCH_UNDEFENDED_PIECES==1
					#if LISTER_PIONS_ATTAQUES==1
					if (!xextend) maj_prise(wptr,arr,1,0);
					#endif
					#endif
					break; 
		 case 'C' : 
					SET_MOVE_CATEGORY(move,ECHANGE_PIECE); 
					//SET_MOVE_CHANGES_PAWNSTRUCT(*mpt,0);
					#if USE_PIECES_ATTAQUEES==1 || USE_CASES_COUPS_FORCANTS==1 || USE_SEARCH_UNDEFENDED_PIECES==1
					 if (!xextend) maj_prise(wptr,arr,1,0);
					#endif
					break; 
		 case 'F' : 
			  		mobility2+=4;
					SET_MOVE_CATEGORY(move,ECHANGE_PIECE); 
					#if USE_PIECES_ATTAQUEES==1 || USE_CASES_COUPS_FORCANTS==1 || USE_SEARCH_UNDEFENDED_PIECES==1
					if (!xextend) maj_prise(wptr,arr,1,0);
					#endif
		 			break; 
		 case 'T' : 
 			  		mobility2+=4;
					SET_MOVE_CATEGORY(move,COUP_FORCANT);
					#if USE_PIECES_ATTAQUEES==1 || USE_CASES_COUPS_FORCANTS==1 || USE_SEARCH_UNDEFENDED_PIECES==1
				    if (!xextend) maj_prise(wptr,arr,1,1);
					#endif
					break; 
		 case 'D' : 
 			  		mobility2+=4;
					SET_MOVE_CATEGORY(move,COUP_FORCANT);
					#if USE_PIECES_ATTAQUEES==1 || USE_CASES_COUPS_FORCANTS==1 || USE_SEARCH_UNDEFENDED_PIECES==1
					if (!xextend) maj_prise(wptr,arr,1,1);
					#endif
		 	        break; 
		 case 'R' : //SET_MOVE_CATEGORY(move,COUP_FORCANT);
	  		mobility2+=2;
			side_checked01=aptr->color01;
			#if DEBUG==1
			if (side_checked01!=xwtm) // Le camp en chec doit tre celui au trait
			log_error("\nErr M_211 - Echec non couvert");
			#endif
			#if USE_CASES_ACTUALISATION==0
			if (chkptr[side_checked01]==NULL) 
			{ 
			   chkptr[side_checked01]=wptr;
			}
			else if (wptr!=chkptr[side_checked01])
			chkptr2[side_checked01]=wptr; // Echec double
			#endif
			break;
		 }

		// Prise
		//SET_MOVE_NUM_PIECE(move,num);
		SET_MOVE_CAPTURE(move,aptr->nature);
		//SET_MOVE_CAPTURE_VALUE(move,aptr->piece_value);
		*liste_coups2_piece_ptr++=move;
		mob_prises++; 

		continue;
} // fin else
} // fin while

// Report mobilit
//*xmobptr=mobility;
// Pnalit pour les mauvaises mobilits
//*xmob2ptr=mobility2+((mobility-4)<<1); 
mobility2+=((mob_others+mob_prises-4)<<1); 

// Clture listes
*liste_coups_piece_ptr=0;
*liste_coups2_piece_ptr=0;

// Vrification de liste
#if CHECK_MOVE_GENERATION_WITH_BITBOARDS==1
char mob_others2, mob_prises2;
mob_prises2=0; mob_others2=0;
get_moves_CR(wptr, psptr, mob_others2, mob_prises2);
if (mob_others!=mob_others2 || mob_prises!=mob_prises2)
{
	qsort(&xw_liste_coups_piece[xlevel][num][0],mob_others,sizeof(unsigned __int32),uint32_compare);
	qsort(&xw_liste_coups2_piece[xlevel][num][0],mob_prises,sizeof(unsigned __int32),uint32_compare);
	qsort(&xw_liste_coups_piece_check[0],mob_others2,sizeof(unsigned __int32),uint32_compare);
	qsort(&xw_liste_coups2_piece_check[0],mob_prises2,sizeof(unsigned __int32),uint32_compare);
	log_error("M_1234_cavalier", xcompteur);
}
#if COPY_BITBOARD_MOVES_TO_LIST_MOVES==1
memcpy(&xw_liste_coups_piece[xlevel][num][0] ,&xw_liste_coups_piece_check[0],mob_others*sizeof(unsigned __int32));
memcpy(&xw_liste_coups2_piece[xlevel][num][0],&xw_liste_coups2_piece_check[0],mob_prises*sizeof(unsigned __int32));
#endif
#if CHECK_MOVE_GENERATION_WITH_BITBOARDS==1
	qsort(&xw_liste_coups_piece[xlevel][num][0],mob_others,sizeof(unsigned __int32),uint32_compare);
	qsort(&xw_liste_coups2_piece[xlevel][num][0],mob_prises,sizeof(unsigned __int32),uint32_compare);
	qsort(&xw_liste_coups_piece_check[0],mob_others2,sizeof(unsigned __int32),uint32_compare);
	qsort(&xw_liste_coups2_piece_check[0],mob_prises2,sizeof(unsigned __int32),uint32_compare);
	char cc, i, a1, a2, a3, dep1, dep2, arr1;
	MOVE move1, move2;
	for (i=0;i<mob_others;i++)
	{

		if (xw_liste_coups_piece[xlevel][num][i]!=xw_liste_coups_piece_check[i])
		{
			move1=xw_liste_coups_piece[xlevel][num][i];
			move2=xw_liste_coups_piece_check[i];
			cc=0;
		}
	}
	for (i=0;i<mob_prises;i++)
	{

		if (xw_liste_coups2_piece[xlevel][num][i]!=xw_liste_coups2_piece_check[i])
		{
			move1=xw_liste_coups2_piece[xlevel][num][i];
			move2=xw_liste_coups2_piece_check[i];
			cc=0;
		}
	}
#endif
#endif

	
} // fin cavalier




void SEARCH::fou2(PIECE *wptr,PIECE_SET *psptr,char &mob_others, char &mob_prises,char &mobility2)
{
char color,color01;
char num;
char ycolor;
char dir;
//char mobility, mobility2;
CASE *aptr;
char arr2;
MOVE move;
char arr;
MOVE *liste_coups_piece_ptr,*liste_coups2_piece_ptr;
char mobility;
bool F_possible_probleme_developpement;

// Initialisations 
num=wptr->num_piece;
//psptr->moves=liste_coups_piece_ptr=&xw_liste_coups_piece[xlevel][num][0]; 
//psptr->moves2=liste_coups2_piece_ptr=&xw_liste_coups2_piece[xlevel][num][0]; 
ASSERT(psptr->moves==&xw_liste_coups_piece[xlevel][num][0]);
ASSERT(psptr->moves2==&xw_liste_coups2_piece[xlevel][num][0]);
liste_coups_piece_ptr=psptr->moves;
liste_coups2_piece_ptr=psptr->moves2;
color=wptr->color;
color01=TO_COLOR01(color);
F_possible_probleme_developpement=false;


// Boucles sur les 4 diffrentes directions
for (dir=0; dir<=3; dir++)
{
xidx=xmoves[wptr->pos][wptr->type][dir];
for (;*xidx!=0;xidx++)
{
move=*xidx;
arr=MOVE_ARR64(move);
//dep=MOVE_DEP64(move);;
aptr=&xboard[arr];
ycolor=aptr->color;
#if USE_CASES_ACTUALISATION==1
set_bit_to_1(psptr->cases_actualisation,arr);
#endif


if (ycolor==0)
{
//SET_MOVE_NUM_PIECE(move,num);
*liste_coups_piece_ptr++=move;
//mobilite[dir]++;
mob_others++;
//#if USE_CASES_CONTROLEES==1
//#if USE_EXTEND_CASES_CONTROLEES==0
//if (!xextend)
//#endif
//{
//set_bit_to_1(psptr->cases_controlees,arr);
//}
//#endif
continue;
}// fin 1
else if (ycolor == color)
{ // else 1
// Pice amie
// Rduction mobilit direction si fou bloqu par un pion ami vers l'avant
//#if USE_CASES_CONTROLEES==1
//#if USE_EXTEND_CASES_CONTROLEES==0
//if (!xextend)
//#endif
//{
//set_bit_to_1(psptr->cases_controlees,arr);
//}
//#endif
switch(aptr->nature)
{
case 'P' :
	switch((int) color)
	{
		case 1 : 
			// Support pion pass par fou => gros bonus
			// car les autres pices sont libres
			if (aptr->posy==6)
			{
				if (s->finale<FIN_DE_PARTIE_2)
				{
					mobility2+=30;
				}
				break;
			}
			if (wptr->posy<aptr->posy)
				mobility2-=4;
			break;
		case -1 : 
			// Support pion pass par fou => gros bonus
			// car les autres pices sont libres
			if (aptr->posy==1)
			{
				if (s->finale<FIN_DE_PARTIE_2)
				{
					mobility2+=30;
				}
				break;
			}
			if (wptr->posy>aptr->posy)
				mobility2-=4;
			break;
		default : break;
	}
	break;
default : mobility2-=2; // anti pice lie en dfense 
	break;
}

break;  // direction coupe - passer  la direction suivante
} // fin else 1
// Prise
else if (ycolor == -color) // dernire possibilit
{ // else 2
switch (aptr->nature)
{
case 'P' : 
	mobility2+=2;
	do
	{
		arr2=arr-COLOR(color,7);
		if (arr2>=1 && arr2<=62
		&& bit(s->cases_pions[1-color01],arr2)==1)
		{ 
			mobility2-=2; 
			F_possible_probleme_developpement=true;
			break;
		}
		arr2=arr+COLOR(color,9);
		if (arr2>=1 && arr2<=62
		&& bit(s->cases_pions[1-color01],arr2)==1)
		{ 
			mobility2-=2; 
			F_possible_probleme_developpement=true;
			break; 
		}
		break;
	} while(1);
	
		SET_MOVE_CATEGORY(move,PRISE_PION_PAR_PIECE); 
		//SET_MOVE_CATEGORY_AND_PAWNSTRUCT_FLAG(move,PRISE_PION_PAR_PIECE); 

		#if SUIVI_PRISES==1
		(*xprisespionptr)++;
		#endif
		#if USE_PIECES_ATTAQUEES==1 || USE_CASES_COUPS_FORCANTS==1 || USE_SEARCH_UNDEFENDED_PIECES==1
		#if LISTER_PIONS_ATTAQUES==1
		if (!xextend) maj_prise(wptr,arr,1,0);
		#endif
		#endif
	break; 
case 'T' : 
		mobility2+=2;
		SET_MOVE_CATEGORY(move,COUP_FORCANT);
		#if USE_PIECES_ATTAQUEES==1 || USE_CASES_COUPS_FORCANTS==1 || USE_SEARCH_UNDEFENDED_PIECES==1
		if (!xextend) maj_prise(wptr,arr,1,1);
		#endif
break; 
case 'D' : 
		mobility2+=4;
		SET_MOVE_CATEGORY(move,COUP_FORCANT);
		#if USE_PIECES_ATTAQUEES==1 || USE_CASES_COUPS_FORCANTS==1 || USE_SEARCH_UNDEFENDED_PIECES==1
		if (!xextend) maj_prise(wptr,arr,1,1);
		#endif
	break; 
case 'R' :
	//SET_MOVE_CATEGORY(move,COUP_FORCANT);
	#if DEBUG==1
	if (TO_COLOR01(color)==xwtm) // Le camp en chec doit tre celui au trait
	log_error("\nErr M_211 - Echec non couvert");
	#endif
	break;
default : 
		if (aptr->nature!='F') mobility2+=2;
		SET_MOVE_CATEGORY(move,ECHANGE_PIECE); 
		#if USE_PIECES_ATTAQUEES==1 || USE_CASES_COUPS_FORCANTS==1 || USE_SEARCH_UNDEFENDED_PIECES==1
		if (!xextend) maj_prise(wptr,arr,1,0);
		#endif
	  break; 
}

//SET_MOVE_NUM_PIECE(move,num);
SET_MOVE_CAPTURE(move,aptr->nature);
//SET_MOVE_CAPTURE_VALUE(move,aptr->piece_value);
*liste_coups2_piece_ptr++=move;
mob_prises++;


break;  // Direction coupe - passer  la direction suivante
} // fin else 2
} // fin for 2
} // fin for 1

// Pour les fous la mobilit doit tre
// exponentielle pour favoriser leur meilleur dploiement

/*
// Maximum = 4*7=28
si1=mobilite[0]
  +mobilite[1]
  +mobilite[2]
  +mobilite[3];
// Pnalit poue mobilit insuffisante
// Il arrive que les fous se fassent enfermer
if (xp<=2) xp+=-10; // -5 auparavant
*xmobptr=xp;
*/

mobility=mob_prises+mob_others;
if (F_possible_probleme_developpement && mobility<6)
{
	// Exemple : Fg2 bloqu par pion e4
	// e4,f3,h1,f1,h3 : 5 coups
	psptr->develop=-1;
}
if (color01==xlv1_wtm)
{
if      (mobility<2) mobility2+=-15;
else if (mobility<5) mobility2+=-10;
else if (mobility<8) mobility2+=-7;
else if (mobility<10)mobility2+=+5;
else                 mobility2+=+10;
}
else
{
if      (mobility<2) mobility2+=-10;
else if (mobility<5) mobility2+=-5;
else if (mobility<8) mobility2+=-2;
else if (mobility<10)mobility2+=+5;
else                 mobility2+=+10;
}

// Clture listes
*liste_coups_piece_ptr=0;
*liste_coups2_piece_ptr=0;

// Vrification de liste
#if CHECK_MOVE_GENERATION_WITH_BITBOARDS==1
char mob_others2, mob_prises2;
mob_prises2=0; mob_others2=0;
get_moves_DTF(wptr, psptr, mob_others2, mob_prises2);
if (mob_others!=mob_others2 || mob_prises!=mob_prises2)
{
	qsort(&xw_liste_coups_piece[xlevel][num][0],mob_others,sizeof(unsigned __int32),uint32_compare);
	qsort(&xw_liste_coups2_piece[xlevel][num][0],mob_prises,sizeof(unsigned __int32),uint32_compare);
	qsort(&xw_liste_coups_piece_check[0],mob_others2,sizeof(unsigned __int32),uint32_compare);
	qsort(&xw_liste_coups2_piece_check[0],mob_prises2,sizeof(unsigned __int32),uint32_compare);
	log_error("M_1234_fou", xcompteur);
}
#if COPY_BITBOARD_MOVES_TO_LIST_MOVES==1
memcpy(&xw_liste_coups_piece[xlevel][num][0] ,&xw_liste_coups_piece_check[0],mob_others*sizeof(unsigned __int32));
memcpy(&xw_liste_coups2_piece[xlevel][num][0],&xw_liste_coups2_piece_check[0],mob_prises*sizeof(unsigned __int32));
#endif
#if CHECK_MOVE_GENERATION_WITH_BITBOARDS==1
	qsort(&xw_liste_coups_piece[xlevel][num][0],mob_others,sizeof(unsigned __int32),uint32_compare);
	qsort(&xw_liste_coups2_piece[xlevel][num][0],mob_prises,sizeof(unsigned __int32),uint32_compare);
	qsort(&xw_liste_coups_piece_check[0],mob_others2,sizeof(unsigned __int32),uint32_compare);
	qsort(&xw_liste_coups2_piece_check[0],mob_prises2,sizeof(unsigned __int32),uint32_compare);
	char cc, i, a1, a2, a3, dep1, dep2, arr1;
	MOVE move1, move2;
	for (i=0;i<mob_others;i++)
	{

		if (xw_liste_coups_piece[xlevel][num][i]!=xw_liste_coups_piece_check[i])
		{
			move1=xw_liste_coups_piece[xlevel][num][i];
			move2=xw_liste_coups_piece_check[i];
			cc=0;
		}
	}
	for (i=0;i<mob_prises;i++)
	{

		if (xw_liste_coups2_piece[xlevel][num][i]!=xw_liste_coups2_piece_check[i])
		{
			move1=xw_liste_coups2_piece[xlevel][num][i];
			move2=xw_liste_coups2_piece_check[i];
			cc=0;
		}
	}
#endif
#endif

return;
} // fin fou2



void SEARCH::tour2(PIECE *wptr,PIECE_SET *psptr,char &mob_others, char &mob_prises,char &mobility2,char &tower)
{
char color, color01;
char num;
char ycolor;
char dir;
char mobilite[4]={0,0,0,0};
//char mobility, mobility2;
char arr2;
bool F_defense_pion;
char arr;
CASE *aptr;
MOVE move;
MOVE *liste_coups_piece_ptr,*liste_coups2_piece_ptr;
char mobility;

// Initialisations 
num=wptr->num_piece;
//psptr->moves=liste_coups_piece_ptr=&xw_liste_coups_piece[xlevel][num][0]; 
//psptr->moves2=liste_coups2_piece_ptr=&xw_liste_coups2_piece[xlevel][num][0]; 
ASSERT(psptr->moves==&xw_liste_coups_piece[xlevel][num][0]);
ASSERT(psptr->moves2==&xw_liste_coups2_piece[xlevel][num][0]);
liste_coups_piece_ptr=psptr->moves;
liste_coups2_piece_ptr=psptr->moves2;
color=wptr->color;
color01=TO_COLOR01(color);
//color01=wptr->color01;
F_defense_pion=false;


#if DEBUG==1
if (s!=&xstates[xlevel])
log_error("\nM_258");
#endif
if (bit(s->colonnes_ouvertes,wptr->posx)==1)
{
	tower=10;
}


// Boucles sur les 4 diffrentes directions
for (dir=0; dir<=3; dir++)
{
xidx=xmoves[wptr->pos][wptr->type][dir];
for (;*xidx!=0;xidx++)
{
move=*xidx;
arr=MOVE_ARR64(move);
//dep=MOVE_DEP64(move);
aptr=&xboard[arr];
ycolor=aptr->color;
#if USE_CASES_ACTUALISATION==1
set_bit_to_1(psptr->cases_actualisation,arr);
#endif




if (ycolor==0)
{
//SET_MOVE_NUM_PIECE(move,num);
*liste_coups_piece_ptr++=move;
mobilite[dir]++;
mob_others++;
//mobility++;
//#if USE_CASES_CONTROLEES==1
//#if USE_EXTEND_CASES_CONTROLEES==0
//if (!xextend)
//#endif
//{
//set_bit_to_1(psptr->cases_controlees,arr);
//}
//#endif
continue;
}
else if (ycolor == color)
{ // else 1
//#if USE_CASES_CONTROLEES==1
//if (!xextend)
//{
//set_bit_to_1(psptr->cases_controlees,arr);
//}
//#endif
mobility2-=2; // anti pice lie en dfense 
switch(aptr->nature)
{
case 'P' :
	// Rduction mobilit direction 
	// - si faible mobilit de la tour
	// - si bloque verticalement par un pion ami
	if (dir==0 && color==+1)
	{
		if (!EST_PION_PASSE(1,arr,s))
		{
			F_defense_pion=true;
		}
		else // pion pass
		{
			if (s->finale>0)
			{
				mobility2+=15;
			}
		}
	}
	if (dir==1 && color==-1)
	{
		if (!EST_PION_PASSE(0,arr,s))
		{
			F_defense_pion=true;
		}
		else // pion pass
		{
			if (s->finale>0)
			{
				mobility2+=15;
			}
		}
	}
	break;
//case 'C' : break;
//case 'F' : break;
//case 'T' : break;
default : break;
}


// Connexion de tours 
if (aptr->nature=='T' || aptr->nature=='D')
{
// Blanc
if (color==1)
{
// Doublement horizontal en septime
if (wptr->posy==aptr->posy && aptr->posy>=6) 
{
	tower=15;
}

// Doublement simple vertical
// sur colonne ouverte ou semi-ouverte
else
{
if (wptr->posx==aptr->posx)
{
if (   bit(s->colonnes_ouvertes,wptr->posx)
	//|| bit(s->colonnes_semi_ouvertes[1],wptr->posx) 
	)
{
	tower=15;
}

}
}
}
else
// Noir
{
if (wptr->posy==aptr->posy && aptr->posy<=1) 
{
	tower=15;
}
else
{
if (wptr->posx==aptr->posx)
{
if (   bit(s->colonnes_ouvertes,wptr->posx)
	//|| bit(s->colonnes_semi_ouvertes[0],wptr->posx) 
	)
{
	tower=15;
}

}
}
}
} // fin doublement des tours

break;  // direction coupe - passer  la direction suivante
} // fin else 1
// Prise
else if (ycolor == -color) // dernire possibilit
{
switch (aptr->nature)
{
case 'P' : 
	// Rduire la mobilit si le pion est protg
    mobility2+=2;
	do
	{
		arr2=arr-COLOR(color,7);
		if (arr2>=1 && arr2<=62
		&& bit(s->cases_pions[1-color01],arr2))
		{ mobility2-=2; break; }
		arr2=arr+COLOR(color,9);
		if (arr2>=1 && arr2<=62
		&& bit(s->cases_pions[1-color01],arr2))
		{ mobility2-=2; break; }
		break;
	} while(1);
	
		SET_MOVE_CATEGORY(move,PRISE_PION_PAR_PIECE); 
		//SET_MOVE_CATEGORY_AND_PAWNSTRUCT_FLAG(move,PRISE_PION_PAR_PIECE); 

		#if SUIVI_PRISES==1
		(*xprisespionptr)++;
		#endif
		#if USE_PIECES_ATTAQUEES==1 || USE_CASES_COUPS_FORCANTS==1 || USE_SEARCH_UNDEFENDED_PIECES==1
		#if LISTER_PIONS_ATTAQUES==1
		if (!xextend) maj_prise(wptr,arr,1,0);
		#endif
		#endif
	break; 
case 'D' : 
		// Prise de pice
		mobility2+=2;
		SET_MOVE_CATEGORY(move,COUP_FORCANT);
		#if USE_PIECES_ATTAQUEES==1 || USE_CASES_COUPS_FORCANTS==1 || USE_SEARCH_UNDEFENDED_PIECES==1
		if (!xextend) maj_prise(wptr,arr,1,1);
		#endif
	break; 
case 'T' : SET_MOVE_CATEGORY(move,ECHANGE_PIECE);
		#if USE_PIECES_ATTAQUEES==1 || USE_CASES_COUPS_FORCANTS==1 || USE_SEARCH_UNDEFENDED_PIECES==1
		if (!xextend) maj_prise(wptr,arr,1,0);
		#endif
	break; 
case 'R' :
	#if DEBUG==1
	if (TO_COLOR01(color)==xwtm) // Le camp en chec doit tre celui au trait
	log_error("\nErr M_211 - Echec non couvert");
	#endif
	break;
default : 
		// Prise de pice cavalier ou fou
		mobility2+=2;
		#if ALLOW_EXTEND_ROOK_SACRIFICES==1
		SET_MOVE_CATEGORY(move,ECHANGE_PIECE); 
		#endif
		#if ALLOW_EXTEND_ROOK_SACRIFICES==0
		SET_MOVE_CATEGORY(move,PRISE_PIECE_INFERIEURE); 
		#endif
		#if USE_PIECES_ATTAQUEES==1 || USE_CASES_COUPS_FORCANTS==1 || USE_SEARCH_UNDEFENDED_PIECES==1
		if (!xextend) maj_prise(wptr,arr,1,0);
		#endif
break; 
}

//SET_MOVE_NUM_PIECE(move,num);
SET_MOVE_CAPTURE(move,aptr->nature);
//SET_MOVE_CAPTURE_VALUE(move,aptr->piece_value);
*liste_coups2_piece_ptr++=move;
mobilite[dir]++;
mob_prises++;


break;  // Direction coupe - passer  la direction suivante
} // fin else 2
} // fin for 2
} // fin for 1


// Report mobilit
mobility=
       mobilite[0]       // Vertical
	  +mobilite[1]       // Vertical
	  +(mobilite[2]>>1)     // Horizontal
	  +(mobilite[3]>>1);    // Horizontal


if      (mobility<2) mobility2+=-20;
else if (mobility<5) mobility2+=-15;
else if (mobility<8) mobility2+=-10;
else if (mobility<10)mobility2+=+5;
else                 mobility2+=+15;
if (F_defense_pion && mobilite[0]+mobilite[1]<=3) 
{
	mobility2+=-7;
	// Exemple : tour qui dfend un pion en quatrime (e2-e3)
	if (wptr->posx==0 || wptr->posx==7) 
		 psptr->develop=-2;
	else psptr->develop=-1;
}


// Ajustement finale 
// Tours en septime
// avec des pions adverses en septime 
if (s->finale>0)
{
switch(color01)
{
case 1 : 
	if (wptr->posy==6) 
	{
		if ((s->cases_pions[0]&xmasque_septieme[1])>0) 
			tower+=20;
	}
	break;
case 0 :
	if (wptr->posy==1) 
	{
		if ((s->cases_pions[1]&xmasque_septieme[0])>0) 
			tower-=20;
	}
	break;
}
}

// Clture listes
*liste_coups_piece_ptr=0;
*liste_coups2_piece_ptr=0;

// Vrification de liste
#if CHECK_MOVE_GENERATION_WITH_BITBOARDS==1
char mob_others2, mob_prises2;
mob_prises2=0; mob_others2=0;
get_moves_DTF(wptr, psptr, mob_others2, mob_prises2);
if (mob_others!=mob_others2 || mob_prises!=mob_prises2)
{
	qsort(&xw_liste_coups_piece[xlevel][num][0],mob_others,sizeof(unsigned __int32),uint32_compare);
	qsort(&xw_liste_coups2_piece[xlevel][num][0],mob_prises,sizeof(unsigned __int32),uint32_compare);
	qsort(&xw_liste_coups_piece_check[0],mob_others2,sizeof(unsigned __int32),uint32_compare);
	qsort(&xw_liste_coups2_piece_check[0],mob_prises2,sizeof(unsigned __int32),uint32_compare);
	log_error("M_1234_tour", xcompteur);
}
#if COPY_BITBOARD_MOVES_TO_LIST_MOVES==1
memcpy(&xw_liste_coups_piece[xlevel][num][0] ,&xw_liste_coups_piece_check[0],mob_others*sizeof(unsigned __int32));
memcpy(&xw_liste_coups2_piece[xlevel][num][0],&xw_liste_coups2_piece_check[0],mob_prises*sizeof(unsigned __int32));
#endif
#if CHECK_MOVE_GENERATION_WITH_BITBOARDS==1
	qsort(&xw_liste_coups_piece[xlevel][num][0],mob_others,sizeof(unsigned __int32),uint32_compare);
	qsort(&xw_liste_coups2_piece[xlevel][num][0],mob_prises,sizeof(unsigned __int32),uint32_compare);
	qsort(&xw_liste_coups_piece_check[0],mob_others2,sizeof(unsigned __int32),uint32_compare);
	qsort(&xw_liste_coups2_piece_check[0],mob_prises2,sizeof(unsigned __int32),uint32_compare);
	char cc, i, a1, a2, a3, dep1, dep2, arr1;
	MOVE move1, move2;
	for (i=0;i<mob_others;i++)
	{

		if (xw_liste_coups_piece[xlevel][num][i]!=xw_liste_coups_piece_check[i])
		{
			move1=xw_liste_coups_piece[xlevel][num][i];
			move2=xw_liste_coups_piece_check[i];
			cc=0;
		}
	}
	for (i=0;i<mob_prises;i++)
	{

		if (xw_liste_coups2_piece[xlevel][num][i]!=xw_liste_coups2_piece_check[i])
		{
			move1=xw_liste_coups2_piece[xlevel][num][i];
			move2=xw_liste_coups2_piece_check[i];
			cc=0;
		}
	}
#endif
#endif


} // fin tour2





void SEARCH::dame2(PIECE *wptr,PIECE_SET *psptr,char &mob_others, char &mob_prises,char &mobility2,char &tower)
{
char color, color01;
char ycolor;
char dir;
char num;
char arr;
MOVE move;
#if DEBUG==1
//char cc;
#endif
char arr2;
MOVE *liste_coups_piece_ptr,*liste_coups2_piece_ptr;
CASE *aptr;
char mobility;

// Initialisations 
num=wptr->num_piece;
//psptr->moves=liste_coups_piece_ptr=&xw_liste_coups_piece[xlevel][num][0]; 
//psptr->moves2=liste_coups2_piece_ptr=&xw_liste_coups2_piece[xlevel][num][0]; 
ASSERT(psptr->moves==&xw_liste_coups_piece[xlevel][num][0]);
ASSERT(psptr->moves2==&xw_liste_coups2_piece[xlevel][num][0]);
liste_coups_piece_ptr=psptr->moves;
liste_coups2_piece_ptr=psptr->moves2;
color=wptr->color;
color01=TO_COLOR01(color);

#if TRACK_QUEEN_POSITION==1
s->queen_position[color01]=wptr->pos;
#endif

// Boucles sur les 8 diffrentes directions
for (dir=0; dir<=7; dir++)
{
xidx=xmoves[wptr->pos][wptr->type][dir];
for (;*xidx!=0;xidx++)
{
move=*xidx;
arr=MOVE_ARR64(move);
//dep=MOVE_DEP64(move);;
aptr=&xboard[arr];
ycolor=aptr->color;
#if USE_CASES_ACTUALISATION==1
set_bit_to_1(psptr->cases_actualisation,arr);
#endif


if (ycolor==0)
{
//#if USE_CASES_CONTROLEES==1
//#if USE_EXTEND_CASES_CONTROLEES==0
//if (!xextend)
//#endif
//{
//    set_bit_to_1(psptr->cases_controlees,arr);
//}
//#endif
//SET_MOVE_NUM_PIECE(move, num);
*liste_coups_piece_ptr++=move;
mob_others++;

//char cc;
//cc=MOVE_CATEGORY(move);

continue;
}
else
{
if (ycolor==color)
{
//#if USE_CASES_CONTROLEES==1
//#if USE_EXTEND_CASES_CONTROLEES==0
//if (!xextend)
//#endif
//{
//set_bit_to_1(psptr->cases_controlees,arr);
//}
//#endif
mobility2-=2; // anti pice lie en dfense 
/*
// Pice amie
switch(aptr->nature)
{
case 'P' :
	// Rduction mobilit direction 
	mobility2-=2;
	break;
//case 'C' : mobility2+=2; break;
//case 'F' : mobility2+=2; break;
//case 'T' : mobility2+=2; break;
default : break;
}
*/

// Connexion de pices lourdes
if (aptr->nature=='T' || aptr->nature=='D')
{
// Blanc
if (color==1)
{
// Doublement en septime
if (wptr->posy==aptr->posy && aptr->posy>=6) 
{
	tower=15;
	/*
	// Prise en compte de l'autre pice
	s->tower+=
				( + tower
				  - aptr->wptr->tower ) * color;			
	aptr->wptr->tower=tower;
	wptr->piece_doublement_tour=aptr->num_piece;
	aptr->wptr->piece_doublement_tour=wptr->num_piece;
	*/
}

// Doublement 
// sur colonne ouverte ou semi-ouverte
else
{
if (wptr->posx==aptr->posx)
{
#if DEBUG==1
if (s!=&xstates[xlevel])
log_error("\nL_258");
#endif
//if (bit(s->colonnes_semi_ouvertes[1],wptr->posx)==1)
// ==> tower=1;
if (bit(s->colonnes_ouvertes,wptr->posx))
{
	tower=15;
	/*
	// Prise en compte de l'autre pice
	s->tower-=aptr->wptr->tower;
	aptr->wptr->tower=tower;
	s->tower+=aptr->wptr->tower;
	wptr->piece_doublement_tour=aptr->num_piece;
	aptr->wptr->piece_doublement_tour=wptr->num_piece;
	*/
}


// Problme : ces valeurs ne sont pas tenues  jour 
//du fait du hashage 
//cc=xcol[wptr->color01][wptr->posx][0]; 
//if (wptr->posx==aptr->posx 
//	&& (cc==COLONNE_OUVERTE || cc==COLONNE_SEMI_OUVERTE) )
// ==> tower=5;

}
}
} // fin blanc
else // noir
{
// Doublement en septime
if (wptr->posy==aptr->posy && aptr->posy<=1) 
{
	tower=15;
	/*
	// Prise en compte de l'autre pice
	s->tower-=aptr->wptr->tower;
	aptr->wptr->tower=tower;
	s->tower+=aptr->wptr->tower;
	wptr->piece_doublement_tour=aptr->num_piece;
	aptr->wptr->piece_doublement_tour=wptr->num_piece;
	*/
}
else
{
if (wptr->posx==aptr->posx)
{
// Doublement 
// sur colonne ouverte ou semi-ouverte
#if DEBUG==1
if (s!=&xstates[xlevel])
log_error("\nL_258");
#endif
//if (bit(s->colonnes_semi_ouvertes[0],wptr->posx)==1)
// ==>	tower=1;
if (bit(s->colonnes_ouvertes,wptr->posx))
{
	tower=15;
	/*
	// Prise en compte de l'autre pice
	s->tower-=aptr->wptr->tower;
	aptr->wptr->tower=tower;
	s->tower+=aptr->wptr->tower;
	wptr->piece_doublement_tour=aptr->num_piece;
	aptr->wptr->piece_doublement_tour=wptr->num_piece;
	*/
}


}
}
}
} // fin doublement pices lourdes


break;  // direction coupe - passer  la direction suivante
}
// Prise
if (ycolor == -color) // dernire possibilit
{

switch (aptr->nature)
{
case 'P' : 
		  // Rduire la mobilit si le pion est protg
		  do
		  {
				arr2=arr-COLOR(color,7);
				if (arr2>=1 && arr2<=62
				&& bit(s->cases_pions[1-color01],arr2)==1)
				{ mobility2-=2; break; }
				arr2=arr+COLOR(color,9);
				if (arr2>=1 && arr2<=62
				&& bit(s->cases_pions[1-color01],arr2)==1)
				{ mobility2-=2; break; }
				break;
		   } while(1);

		   SET_MOVE_CATEGORY(move,PRISE_PION_PAR_PIECE); 
		   //SET_MOVE_CATEGORY_AND_PAWNSTRUCT_FLAG(move,PRISE_PION_PAR_PIECE); 

		   #if SUIVI_PRISES==1
		   (*xprisespionptr)++;
		   #endif
   		   #if USE_PIECES_ATTAQUEES==1 || USE_CASES_COUPS_FORCANTS==1 || USE_SEARCH_UNDEFENDED_PIECES==1
		   #if LISTER_PIONS_ATTAQUES==1
		   if (!xextend) maj_prise(wptr,arr,1,0);
		   #endif
		   #endif
		   break; 
case 'D' : SET_MOVE_CATEGORY(move,ECHANGE_PIECE);
		#if USE_PIECES_ATTAQUEES==1 || USE_CASES_COUPS_FORCANTS==1 || USE_SEARCH_UNDEFENDED_PIECES==1
		if (!xextend)maj_prise(wptr,arr,1,0);
		#endif
	break; 
case 'R' :
	#if DEBUG==1
	if (TO_COLOR01(color)==xwtm) // Le camp en chec doit tre celui au trait
	log_error("\nErr M_211 - Echec non couvert");
	#endif
	break;
default :  
	    SET_MOVE_CATEGORY(move,PRISE_PIECE_INFERIEURE); 
	    // Augmentation mobilit direction pour menace de pice
	    mobility2+=6;
		#if USE_PIECES_ATTAQUEES==1 || USE_CASES_COUPS_FORCANTS==1 || USE_SEARCH_UNDEFENDED_PIECES==1
		if (!xextend) maj_prise(wptr,arr,1,0);
		#endif
        break;
}


//SET_MOVE_NUM_PIECE(move, num);
SET_MOVE_CAPTURE(move,aptr->nature);
//SET_MOVE_CAPTURE_VALUE(move,aptr->piece_value);
*liste_coups2_piece_ptr++=move;
mob_prises++;

break;  // direction coupe - passer  la direction suivante
}
} // fin else
} // fin while
} // fin boucle for sur les directions

// Rduction mobilit pour la dame	
// Maximum = 4*7=28

/*
// Report mobilit
mobility= 
       mobilite[0]        
	  +mobilite[1]        
	  +mobilite[2]        
	  +mobilite[3]  
	  +mobilite[4]  
	  +mobilite[5]  
	  +mobilite[6]  
	  +mobilite[7];
*/


mobility=mob_prises+mob_others;
if (color01==xlv1_wtm)
{
if   (mobility< 4)	mobility2+=-15;
// On ne prend au total que la moitic de la mobilit de la dame
// On retranche donc la mobilit mais on ajoute le quart de la mobilit
//else				mobility2-=(mobility-(mobility>>2));
else				mobility2-=(mobility>>1);
}
else
{
if   (mobility< 4)	mobility2+=-10;
// On ne prend au total que le quart de la mobilit de la dame
// On retranche donc la mobilit mais on ajoute le quart de la mobilit
//else				mobility2-=(mobility-(mobility>>2));
else				mobility2-=(mobility>>1);
}

// Clture listes
*liste_coups_piece_ptr=0;
*liste_coups2_piece_ptr=0;

// Vrification de liste
#if CHECK_MOVE_GENERATION_WITH_BITBOARDS==1
char mob_others2, mob_prises2;
mob_prises2=0; mob_others2=0;
get_moves_DTF(wptr, psptr, mob_others2, mob_prises2);
if (mob_others!=mob_others2 || mob_prises!=mob_prises2)
{
	qsort(&xw_liste_coups_piece[xlevel][num][0],mob_others,sizeof(unsigned __int32),uint32_compare);
	qsort(&xw_liste_coups2_piece[xlevel][num][0],mob_prises,sizeof(unsigned __int32),uint32_compare);
	qsort(&xw_liste_coups_piece_check[0],mob_others2,sizeof(unsigned __int32),uint32_compare);
	qsort(&xw_liste_coups2_piece_check[0],mob_prises2,sizeof(unsigned __int32),uint32_compare);
	log_error("M_1234_dame", xcompteur);
}
#if COPY_BITBOARD_MOVES_TO_LIST_MOVES==1
memcpy(&xw_liste_coups_piece[xlevel][num][0] ,&xw_liste_coups_piece_check[0],mob_others*sizeof(unsigned __int32));
memcpy(&xw_liste_coups2_piece[xlevel][num][0],&xw_liste_coups2_piece_check[0],mob_prises*sizeof(unsigned __int32));
#endif
#if CHECK_MOVE_GENERATION_WITH_BITBOARDS==1
	qsort(&xw_liste_coups_piece[xlevel][num][0],mob_others,sizeof(unsigned __int32),uint32_compare);
	qsort(&xw_liste_coups2_piece[xlevel][num][0],mob_prises,sizeof(unsigned __int32),uint32_compare);
	qsort(&xw_liste_coups_piece_check[0],mob_others2,sizeof(unsigned __int32),uint32_compare);
	qsort(&xw_liste_coups2_piece_check[0],mob_prises2,sizeof(unsigned __int32),uint32_compare);
	char cc, i, a1, a2, a3, dep1, dep2, arr1;
	MOVE move1, move2;
	for (i=0;i<mob_others;i++)
	{

		if (xw_liste_coups_piece[xlevel][num][i]!=xw_liste_coups_piece_check[i])
		{
			move1=xw_liste_coups_piece[xlevel][num][i];
			move2=xw_liste_coups_piece_check[i];
			cc=0;
		}
	}
	for (i=0;i<mob_prises;i++)
	{

		if (xw_liste_coups2_piece[xlevel][num][i]!=xw_liste_coups2_piece_check[i])
		{
			move1=xw_liste_coups2_piece[xlevel][num][i];
			move2=xw_liste_coups2_piece_check[i];
			cc=0;
		}
	}
#endif
#endif



} // fin dame2




void SEARCH::roi2(PIECE *wptr,PIECE_SET *psptr,char &mob_others,char &mob_prises,char &mobility2)
{
char ycolor;
char color;
char color01;
//char mobility,mobility2;
char arr;
CASE *aptr;
MOVE move;
char num;
// Initialisations
// mobility=0; mobility2=0;
color=wptr->color;
color01=TO_COLOR01(color);
num=wptr->num_piece;
MOVE *liste_coups_piece_ptr,*liste_coups2_piece_ptr;

// Initialisations 
//psptr->moves=liste_coups_piece_ptr=&xw_liste_coups_piece[xlevel][num][0]; 
//psptr->moves2=liste_coups2_piece_ptr=&xw_liste_coups2_piece[xlevel][num][0]; 
ASSERT(psptr->moves==&xw_liste_coups_piece[xlevel][num][0]);
ASSERT(psptr->moves2==&xw_liste_coups2_piece[xlevel][num][0]);
liste_coups_piece_ptr=psptr->moves;
liste_coups2_piece_ptr=psptr->moves2;

/*
// Attention : l'valuation des droit  roquer
// se fonde sur les droits en level 0 !!!!
// les coups de roque sont "valids"
// quitte  tre invalids par la fonction legal
s=&xstates[0];
*/


// Coups normaux
xidx=xmoves[wptr->pos][wptr->type][0];
for (;*xidx!=0 && MOVE_IS_NORMAL(*xidx); xidx++)
{
move=*xidx;
arr=MOVE_ARR64(move);
aptr=&xboard[arr];
ycolor=aptr->color;


if (ycolor==0)
{
 // Case vide

		 //SET_MOVE_NUM_PIECE(move, num);
		 *liste_coups_piece_ptr++=move;
		 mob_others++; 
		 //#if USE_CASES_CONTROLEES==1
		 //#if USE_EXTEND_CASES_CONTROLEES==0
		 //if (!xextend)
	  //     #endif
		 //{
		 //   set_bit_to_1(psptr->cases_controlees,arr);
		 //}
		 //#endif
}
else
{
if (ycolor==color)
{
	// Pice amie
	//#if USE_CASES_CONTROLEES==1
	//#if USE_EXTEND_CASES_CONTROLEES==0
	//if (!xextend)
	//#endif
	//{
	//set_bit_to_1(psptr->cases_controlees,arr);
	//}
	//#endif
}
else
{
if (ycolor==-color)
{
// Prise
		 switch (aptr->nature)
		 {
		 // Classer les coups COUP_FORCANT
		 case 'P' : 
				SET_MOVE_CATEGORY(move,PRISE_PION_PAR_PIECE); 
				//SET_MOVE_CATEGORY_AND_PAWNSTRUCT_FLAG(move,PRISE_PION_PAR_PIECE); 

			      #if SUIVI_PRISES==1
				(*xprisespionptr)++; 
				#endif
				#if USE_PIECES_ATTAQUEES==1 || USE_CASES_COUPS_FORCANTS==1 || USE_SEARCH_UNDEFENDED_PIECES==1
				#if LISTER_PIONS_ATTAQUES==1
					if (!xextend) maj_prise(wptr,arr,1,0);
				#endif
				#endif
				break; 
		 #if DEBUG==1
		 case 'R' : log_error("\nErr M_633"); break;
		 #endif
		 default :  mobility2+=2;
					SET_MOVE_CATEGORY(move,COUP_FORCANT); 
					#if USE_PIECES_ATTAQUEES==1 || USE_CASES_COUPS_FORCANTS==1 || USE_SEARCH_UNDEFENDED_PIECES==1
					if (!xextend)  maj_prise(wptr,arr,1,1);
					#endif
			 break;  
		 }

		 //SET_MOVE_NUM_PIECE(move,num);
		 SET_MOVE_CAPTURE(move,aptr->nature);
		 //SET_MOVE_CAPTURE_VALUE(move,aptr->piece_value);
		 *liste_coups2_piece_ptr++=move;
		 mob_prises++;
			
} // fin if
} // fin else
} // fin else
continue;
} // fin while


// Roques (aprs les coups normaux)
for(;*xidx!=0;xidx++) 
{
move=*xidx;
arr=MOVE_ARR64(move);

// Petit roque
if (arr==48 || arr==55)
{
if (s->droit_roque[color01]&1) 
{
			////SET_MOVE_NUM_PIECE(move, num);
			*liste_coups_piece_ptr++=move;
			mob_others++;
}
}
// Grand roque
else if (arr==16 || arr==23)
{
if (s->droit_roque[color01]&2) 
		{
			//SET_MOVE_NUM_PIECE(move, num);
			*liste_coups_piece_ptr++=move;
			mob_others++;
		}
}

} // fin for

// Clture listes
*liste_coups_piece_ptr=0;
*liste_coups2_piece_ptr=0;

#if CHECK_MOVE_GENERATION_WITH_BITBOARDS==1
char mob_others2, mob_prises2;
mob_prises2=0; mob_others2=0;
get_moves_CR(wptr, psptr, mob_others2, mob_prises2);
if (mob_others!=mob_others2 || mob_prises!=mob_prises2)
{
	qsort(&xw_liste_coups_piece[xlevel][num][0],mob_others,sizeof(unsigned __int32),uint32_compare);
	qsort(&xw_liste_coups2_piece[xlevel][num][0],mob_prises,sizeof(unsigned __int32),uint32_compare);
	qsort(&xw_liste_coups_piece_check[0],mob_others2,sizeof(unsigned __int32),uint32_compare);
	qsort(&xw_liste_coups2_piece_check[0],mob_prises2,sizeof(unsigned __int32),uint32_compare);
	log_error("M_1234_roi", xcompteur);
}
#if COPY_BITBOARD_MOVES_TO_LIST_MOVES==1
memcpy(&xw_liste_coups_piece[xlevel][num][0] ,&xw_liste_coups_piece_check[0],mob_others*sizeof(unsigned __int32));
memcpy(&xw_liste_coups2_piece[xlevel][num][0],&xw_liste_coups2_piece_check[0],mob_prises*sizeof(unsigned __int32));
#endif
#if CHECK_MOVE_GENERATION_WITH_BITBOARDS==1
	qsort(&xw_liste_coups_piece[xlevel][num][0],mob_others,sizeof(unsigned __int32),uint32_compare);
	qsort(&xw_liste_coups2_piece[xlevel][num][0],mob_prises,sizeof(unsigned __int32),uint32_compare);
	qsort(&xw_liste_coups_piece_check[0],mob_others2,sizeof(unsigned __int32),uint32_compare);
	qsort(&xw_liste_coups2_piece_check[0],mob_prises2,sizeof(unsigned __int32),uint32_compare);
	char cc, i, a1, a2, a3, dep1, dep2, arr1;
	MOVE move1, move2;
	for (i=0;i<mob_others;i++)
	{

		if (xw_liste_coups_piece[xlevel][num][i]!=xw_liste_coups_piece_check[i])
		{
			move1=xw_liste_coups_piece[xlevel][num][i];
			move2=xw_liste_coups_piece_check[i];
			cc=0;
		}
	}
	for (i=0;i<mob_prises;i++)
	{

		if (xw_liste_coups2_piece[xlevel][num][i]!=xw_liste_coups2_piece_check[i])
		{
			move1=xw_liste_coups2_piece[xlevel][num][i];
			move2=xw_liste_coups2_piece_check[i];
			cc=0;
		}
	}
#endif
#endif

} // fin roi2


// Fin USE_BITBOARD_MOVE_GENERATION==0
#endif



#if USE_PIECES_ATTAQUEES==1 || USE_CASES_COUPS_FORCANTS==1 || USE_SEARCH_UNDEFENDED_PIECES==1
void SEARCH::maj_prise(PIECE* wptr, char arr64, char F_prise,char F_coup_forcant)
{
#if USE_CASES_COUPS_FORCANTS==1
unsigned __int64 *cases_coup_forcant;
#endif
#if USE_PIECES_ATTAQUEES==1
#if USE_SEARCH_ALL_UNDEFENDED_PIECES==1
unsigned __int32 *pieces_attaquees;
char prise_num;
#endif
#endif
char color01;
#if SUIVI_PRISES==1
(*xprisesptr)++;
#endif

color01=wptr->color01;

ASSERT(arr64>=0 && arr64<=63);
ASSERT(xboard[arr64].nature!=0 || !F_prise);

#if USE_CASES_COUPS_FORCANTS==1
// Mise  jour des cases de coups forcants
if (F_coup_forcant==1)
{
//(*xforceptr)++;
cases_coup_forcant=&(wptr->psptr->cases_coup_forcant);

// Maj pice
set_bit_to_1(*cases_coup_forcant,arr64);

// Maj xstates
set_bit_to_1(s->cases_coup_forcant[color01],arr64);
}
#endif

// Mise  jour pices attaques
if (F_prise==1)
{
#if USE_SEARCH_ALL_UNDEFENDED_PIECES==0
set_bit_to_1(xsearch_level[xlevel]->pieces_attaquees_dernier_coup,
			 xboard[arr64].num_piece);
#endif



#if USE_PIECES_ATTAQUEES==1
#if USE_SEARCH_ALL_UNDEFENDED_PIECES!=0 
// wptr pice attaquante
prise_num=xboard[arr64].num_piece;
pieces_attaquees=&wptr->psptr->pieces_attaquees;

// Maj xw
set_bit_to_1(*pieces_attaquees, prise_num);

// Maj xstates
set_bit_to_1(s->pieces_attaquees,prise_num);
#endif
#endif

} // fin F_prise
} // fin maj_prise
#endif



MOVE_ITERATOR::MOVE_ITERATOR(void)
{
s=&xstates[xlevel]; 
#if USE_EXTENDED_MOVE_ITERATOR==1
F_maj_mobility=1;
F_maj_pieces_attaquees=1;
s_pieces_attaquees=&s->pieces_attaquees;
#endif
}

void MOVE_ITERATOR::init_tableau(void)
{
char i;
for (i=0;i<=STMAX;i++)
{
xmove_iterator[i].s=&xstates[i];
#if USE_EXTENDED_MOVE_ITERATOR==1
xmove_iterator[i].s_pieces_attaquees
	=&xstates[i].pieces_attaquees;
#endif
}
}


void MOVE_ITERATOR::init_piece(PIECE* numptr)
{
this->numptr=numptr;
nature=numptr->nature;
num_piece=numptr->num_piece;
mpt=xmoves[numptr->pos][numptr->type][0]-1;
dir=0;
maxdir=numptr->maxdir;
color=numptr->color;
color01=numptr->color01;
direction_interrompue=0;
valid=true; // pour permettre l'avance de 2 cases
#if USE_EXTENDED_MOVE_ITERATOR==1
mobility=0;
if (F_maj_pieces_attaquees==1)
{
	nouveau_pieces_attaquees=0;
}
nouveau_cases_coup_forcant=0;
nouveau_cases_controlees=0;
s_cases_coup_forcant=&s->cases_coup_forcant[color01];
#endif
}


MOVE MOVE_ITERATOR::get_move(void)
{
char ci;
CASE *cptr;
char dep, arr;
char categorie;
char cc;
// Gestion direction interrompue (prise)
if (direction_interrompue==1)
{
	direction_interrompue=0;
	dir++;
	if (dir>maxdir-1) goto RETURN_NULL;
	mpt=xmoves[numptr->pos][numptr->type][dir]-1;
}


do
{
if (nature=='P') validite_coup_precedent=valid;
valid=false; mpt++;

// Contrle de validit du coup
if (*mpt==0) 
{
if (maxdir==1)
{
goto RETURN_NULL;
}
else 
{
dir++;
if (dir>maxdir-1) goto RETURN_NULL;
mpt=xmoves[numptr->pos][numptr->type][dir]-1;
continue;
}
}

move=*mpt;
dep=MOVE_DEP64(move);
arr=MOVE_ARR64(move);

// Roques
if (MOVE_IS_CASTLE(move))
{
// Petit roque
if (arr==48 || arr==55)
{
if (s->droit_roque[color01]&1) 
{
		goto RETURN_MOVE;
}
}
// Grand roque
else if (arr==16 || arr==23)
{
if (s->droit_roque[color01]&2) 
		{
		goto RETURN_MOVE;
		}
}
}

// Pice amie
color_case=xboard[arr].color;
if (color_case==color) 
{ 
	if (maxdir==1) 
	{	
		valid=false;
		continue;
	}
	#if USE_EXTENDED_MOVE_ITERATOR==1
	//  Doublement de pices lourdes
	if (nature=='T' || nature=='D')
	{
		nature2=xboard[arr].nature;
		if (nature2=='T' || nature2=='D')
		{
		inc=abs(INC(move));
		if (inc==8 || inc==1)
		{
		// Blanc
		if (color==1)
		{
		// Doublement en septime
		if (numptr->posy==6 && move->arr_posy==6)
		{
			s->tower+=
				10-pv->tower;
			pv->tower=10;
		}
		// Doublement 
		// sur colonne ouverte ou semi-ouverte
		else
		{
		if (numptr->posx==move->arr_posx)
		{
		// ==> valeur_doublement_pieces_lourdes=1;
		if (bit(s->colonnes_ouvertes,numptr->posx))
		{
			s->tower+=6-pv->tower;
			pv->tower=6;
		}
		} 
		} // fin else
		} // fin blanc
		else // noir
		{
		// Doublement en septime
		if (numptr->posy==1 && move->arr_posy==1)
		{
			s->tower-=
				10-pv->tower;
			pv->tower=10;
		}
		// Doublement 
		// sur colonne ouverte ou semi-ouverte
		else
		{
		if (numptr->posx==move->arr_posx)
		{
		// ==> valeur_doublement_pieces_lourdes=1;
		if (bit(s->colonnes_ouvertes,numptr->posx)==1)
		{
			s->tower-=6-pv->tower;
			pv->tower=6;
		}
		} 
		} // fin else
		} // fin noir
		}
		}
	} // fin test doublement
	#endif

	// Changement de direction
	dir++;
	if (dir>maxdir-1) goto RETURN_NULL;
	mpt=xmoves[numptr->pos][numptr->type][dir]-1;
	continue;
}


// Prises
if (color_case==-color) 
{ 
	// Prise par pion
	if (nature=='P')
	{
		ci=abs(MOVE_DELTA64(move));
		if (ci==1 || ci==2)
		{
		valid=false;
		continue;
		}
		cptr=&xboard[MOVE_ARR64(move)];
		prise_nat=cptr->nature;
		SET_MOVE_CAPTURE(move,prise_nat);
		//SET_MOVE_CAPTURE_VALUE(move,cptr->piece_value); //>0
		#if USE_EXTENDED_MOVE_ITERATOR==1
		if (F_maj_pieces_attaquees==1)
		{
		#if USE_MOVE_ITERATOR_REPORT_FINAL==0
		set_bit_to_1(*s_pieces_attaquees,move->actual_prise_num);
		#endif
		set_bit_to_1(nouveau_pieces_attaquees,move->actual_prise_num);
		}
		#endif
		if (prise_nat=='P')
		{
			SET_MOVE_CATEGORY(move,ECHANGE_PION);
			//SET_MOVE_CATEGORY_AND_PAWNSTRUCT_FLAG(move,ECHANGE_PION); 
		}
		else    
		{
		SET_MOVE_CATEGORY(move,COUP_FORCANT);
		//arr64=MOVE_ARR64(move);
		#if USE_EXTENDED_MOVE_ITERATOR==1
		#if USE_MOVE_ITERATOR_REPORT_FINAL==0
		set_bit_to_1(*s_cases_coup_forcant,arr64);
		#endif
		set_bit_to_1(nouveau_cases_coup_forcant,arr64);
		#endif
		}
	}
	else // prise par une piece
	{
		cptr=&xboard[MOVE_ARR64(arr)];
		prise_nat=cptr->nature;

		// Switch par catgorie
		// en premier pour liminer les roques
		// (qui ne peuvent pas prendre mme si legal limine)
		switch(MOVE_NATURE(move))
		{
		case 'C' :
			if (prise_nat=='T' || prise_nat=='D')
			{
			SET_MOVE_CATEGORY(move,COUP_FORCANT);
			//arr64=MOVE_ARR64(move);
			#if USE_EXTENDED_MOVE_ITERATOR==1
			if (F_maj_coups_forcants==1)
			{
			#if USE_MOVE_ITERATOR_REPORT_FINAL==0
			set_bit_to_1(*s_cases_coup_forcant,arr64);
			#endif
			set_bit_to_1(nouveau_cases_coup_forcant,arr64);
			}
			#endif
			}
			else if (prise_nat=='C' || prise_nat=='F')
			{
				SET_MOVE_CATEGORY(move,ECHANGE_PIECE);
			}
			else if (prise_nat=='P')
			{
				//SET_MOVE_CATEGORY_AND_PAWNSTRUCT_FLAG(move,PRISE_PION_PAR_PIECE); 
				SET_MOVE_CATEGORY(move,PRISE_PION_PAR_PIECE);
			}
			else 
			{
				//if (xpriority[numptr->type][dep][arr]>=0)
				//{categorie=AUTRE_COUP;} else {categorie=AUTRE_COUP_2;} 
				categorie=AUTRE_COUP;
				SET_MOVE_CATEGORY(move,categorie); 
			}
			break;
		case 'F' :
			if (prise_nat=='T' || prise_nat=='D')
			{
			SET_MOVE_CATEGORY(move,COUP_FORCANT);
			//arr64=MOVE_ARR64(move);
			#if USE_EXTENDED_MOVE_ITERATOR==1
			if (F_maj_coups_forcants==1)
			{
			#if USE_MOVE_ITERATOR_REPORT_FINAL==0
			set_bit_to_1(*s_cases_coup_forcant,arr64);
			#endif
			set_bit_to_1(nouveau_cases_coup_forcant,arr64);
			}
			#endif
			}
			else if (prise_nat=='C' || prise_nat=='F')
			{
				SET_MOVE_CATEGORY(move,ECHANGE_PIECE);
			}
			else if (prise_nat=='P')
			{
				//SET_MOVE_CATEGORY_AND_PAWNSTRUCT_FLAG(move,PRISE_PION_PAR_PIECE); 
				SET_MOVE_CATEGORY(move,PRISE_PION_PAR_PIECE);
			}
			else
			{ 
				// (xpriority[numptr->type][dep][arr]>=0)
				// {categorie=AUTRE_COUP;} else {categorie=AUTRE_COUP_2;} 
				categorie=AUTRE_COUP;
				SET_MOVE_CATEGORY(move,categorie); 
			}
			break;
		case 'T' :
			if (prise_nat=='D')
			{
			SET_MOVE_CATEGORY(move,COUP_FORCANT);
			//arr64=MOVE_ARR64(move);
			#if USE_EXTENDED_MOVE_ITERATOR==1
			if (F_maj_coups_forcants==1)
			{
			#if USE_MOVE_ITERATOR_REPORT_FINAL==0
			set_bit_to_1(*s_cases_coup_forcant,arr64);
			#endif
			set_bit_to_1(nouveau_cases_coup_forcant,arr64);
			}
			#endif
			}
			else if (prise_nat=='T')
			{
				SET_MOVE_CATEGORY(move,ECHANGE_PIECE);
			}
			else if (prise_nat=='P')
			{
				//SET_MOVE_CATEGORY_AND_PAWNSTRUCT_FLAG(move,PRISE_PION_PAR_PIECE); 
				SET_MOVE_CATEGORY(move,PRISE_PION_PAR_PIECE);
			}
			else 
			{
				//if (xpriority[numptr->type][dep][arr]>=0)
				//{categorie=AUTRE_COUP;} else {categorie=AUTRE_COUP_2;} 
				categorie=AUTRE_COUP;
				SET_MOVE_CATEGORY(move,categorie); 
			}
			break;
		case 'D' :
			if (prise_nat=='D')
			{
				SET_MOVE_CATEGORY(move,ECHANGE_PIECE);
			}
			else if (prise_nat=='P')
			{
				//SET_MOVE_CATEGORY_AND_PAWNSTRUCT_FLAG(move,PRISE_PION_PAR_PIECE); 
				SET_MOVE_CATEGORY(move,PRISE_PION_PAR_PIECE);
			}
			else
			{ 
				//if (xpriority[numptr->type][dep][arr]>=0)
				//{categorie=AUTRE_COUP;} else {categorie=AUTRE_COUP_2;} 
				categorie=AUTRE_COUP;
				SET_MOVE_CATEGORY(move,categorie); 
			}
			break;	
		case 'R' :
			// Elimination des roques
			if (MOVE_IS_CASTLE(move)) continue;
			if (prise_nat=='P')
			{
				//SET_MOVE_CATEGORY_AND_PAWNSTRUCT_FLAG(move,PRISE_PION_PAR_PIECE); 
				SET_MOVE_CATEGORY(move,PRISE_PION_PAR_PIECE);
			}
			else 
			{
				//if (xpriority[numptr->type][dep][arr]>=0)
				//{categorie=AUTRE_COUP;} else {categorie=AUTRE_COUP_2;} 
				categorie=AUTRE_COUP;
				SET_MOVE_CATEGORY(move,categorie); 
			}
			break;
		}

		// Suites initialisations
		SET_MOVE_CAPTURE(move,prise_nat);
		//SET_MOVE_CAPTURE_VALUE(move,cptr->piece_value); //>0
		#if USE_EXTENDED_MOVE_ITERATOR==1
		if (F_maj_pieces_attaquees==1)
		{ 
			#if USE_MOVE_ITERATOR_REPORT_FINAL==0
			set_bit_to_1(*s_pieces_attaquees,move->actual_prise_num); 
			#endif
			set_bit_to_1(nouveau_pieces_attaquees,move->actual_prise_num);
		}
		#endif
	} // fin prise par pice


	if (maxdir==1) 
	{	
		goto RETURN_MOVE;
	}
	else 
	{
		direction_interrompue=1;
		goto RETURN_MOVE;
	}
}


// Cases vides
if (nature=='P')
{
// Prise en passant
if (MOVE_IS_EN_PASSANT(move))
{
	SET_MOVE_CAPTURE(move,'P');
	SET_MOVE_CATEGORY(move,ECHANGE_PION);
	//SET_MOVE_CATEGORY_AND_PAWNSTRUCT_FLAG(move,ECHANGE_PION); 
	goto RETURN_MOVE;
}
// Validit avance de deux cases
ci=(abs(MOVE_DELTA64(move)));
// Avance d'une case
if (ci==1)
{
//if (xpriority[numptr->type][dep][arr]>=0)
//{categorie=AUTRE_COUP;} else {categorie=AUTRE_COUP_2;} 
categorie=AUTRE_COUP;
SET_MOVE_CATEGORY(move,categorie);
ASSERT(arr==MOVE_ARR64(move));
cc=Y64(arr);
//if (cc==1 || cc==6) 
//	SET_MOVE_CATEGORY(move,COUP_CATEGORIE_1);
//else
if (cc==0 || cc==7) 
{
		SET_MOVE_CATEGORY(move,PROMOTION);
		//SET_MOVE_CATEGORY_AND_PAWNSTRUCT_FLAG(move,PROMOTION); 
		//switch(MOVE_PROMOTION(move))
		//{
		//case 'C' : SET_MOVE_CAPTURE_VALUE(move,MOVE_CAPTURE_VALUE(move)+VALEUR_CAVALIER-VALEUR_PION);
		//	       break;
		//case 'F' : SET_MOVE_CAPTURE_VALUE(move,MOVE_CAPTURE_VALUE(move)+VALEUR_FOU-VALEUR_PION);
		//	       break;
		//case 'T' : SET_MOVE_CAPTURE_VALUE(move,MOVE_CAPTURE_VALUE(move)+VALEUR_TOUR-VALEUR_PION);
		//	       break;
		//case 'D' : SET_MOVE_CAPTURE_VALUE(move,MOVE_CAPTURE_VALUE(move)+VALEUR_DAME-VALEUR_PION);
		//	       break;
		//}
}
goto RETURN_MOVE;
}
if (ci==2)
{
if (!validite_coup_precedent) 
{ continue;}
//if (xpriority[numptr->type][dep][arr]>=0)
//{categorie=AUTRE_COUP;} else {categorie=AUTRE_COUP_2;} 
categorie=AUTRE_COUP;
SET_MOVE_CATEGORY(move,categorie);
//SET_MOVE_CATEGORY_AND_PAWNSTRUCT_FLAG(move,AUTRE_COUP); 
goto RETURN_MOVE;
}
// Pas de prise sur case vide
continue;
} // fin pion
else // pice et roi
{
// Pas de traitement spcifique pour les roques
// la lgalit est vrifie ultrieurement
//if (xpriority[numptr->type][dep][arr]>=0)
//{categorie=AUTRE_COUP;} else {categorie=AUTRE_COUP_2;} 
categorie=AUTRE_COUP;
SET_MOVE_CATEGORY(move,categorie);
goto RETURN_MOVE;
}
} while(1);


RETURN_NULL:
{
#if USE_EXTENDED_MOVE_ITERATOR==1
// Mettre  jour la mobilit
if (F_maj_mobility==1)
{
if (nature!='R' && nature !='P' && nature!='C')
{
	switch(nature)
	{
	case 'F' : if (mobility<4) mobility=mobility>>1; 
		break;
	case 'T' : 
		if      (mobility<4) m=0;
		else if (mobility<6) m=mobility;
		else if (mobility<8) m=mobility+2;
		else if (mobility<10)m=mobility+6; // max 15
		else                 m=mobility*2; // 20
		mobility=m;
		break;
	case 'D' : 
		if      (mobility< 4) m=mobility;
		else if (mobility<10) m=6;
		else if (mobility<15) m=8;
		else if (mobility<20) m=9;
		else                  m=10; // *xmobptr>=20
		mobility=m;
		break;
	default : break;
	}
	s->mobility+=
			 ( + mobility
			   - pv->mobility
			   ) * color;
	pv->mobility=mobility;
}
}
// Mettre  jour les cases de pieces_attaquees
// et de coups forcants
if (F_maj_pieces_attaquees==1)
{
// On enlve l'ancienne valeur et on substitue la nouvelle
*s_pieces_attaquees&=!numptr->pieces_attaquees;
numptr->pieces_attaquees=nouveau_pieces_attaquees;
*s_pieces_attaquees|=nouveau_pieces_attaquees;
}
if (F_maj_coups_forcants==1)
{
*s_cases_coup_forcant=!numptr->cases_coup_forcant;
numptr->cases_coup_forcant=nouveau_cases_coup_forcant;
*s_cases_coup_forcant|=nouveau_cases_coup_forcant;
}

// Maj cases controles
if (F_maj_cases_controlees==1)
{
	numptr->cases_controlees=nouveau_cases_controlees;
}
#endif

return NULL;
}


RETURN_MOVE:
valid=true;
//SET_MOVE_NUM_PIECE(move,num_piece);
 
#if USE_EXTENDED_MOVE_ITERATOR==1
mobility++;
if (F_maj_cases_controlees)
{
set_bit_to_1(numptr->cases_controlees,move->arr);
set_bit_to_1(nouveau_cases_controlees,move->arr);
}
#endif

return move;
}



char SEARCH::bitScanForward_Clear(unsigned __int64 &bb) 
{
   char index;
   unsigned __int64  debruijn64 =(unsigned __int64)(0x07EDD5E59A4E28C2);
   ASSERT (bb != 0);
   // Ignorer le warning de compilation
   index=xindex64[((bb & -bb) * debruijn64) >> 58];
   set_bit_to_0(bb, index);
   return index;
}



#if USE_BITBOARD_MOVE_GENERATION==1 || CHECK_MOVE_GENERATION_WITH_BITBOARDS==1 



void SEARCH::get_moves_DTF(PIECE *wptr, PIECE_SET *psptr,char &mob_others, char &mob_prises)
{
char dir;
unsigned __int64 bb_all;
unsigned __int64 shift;
unsigned __int64 cumul_shift;
unsigned __int64 pieces_ennemies, pieces_amies;

char inc;
char cat;
MOVE move;
char j;
char prise_num;
char prise_nat;
char num_piece;
//char dep88, arr88;
char dep64, arr64;
char color01,color;
char type;
char posvalue;
CASE *arr_ptr;
char nature;
unsigned __int64 masque_direction;
//short priority;
char delta_dir;
char depart;
MOVE *liste_coups_piece_ptr,*liste_coups2_piece_ptr;
#if DEBUG==1
short int si1, si2;
char arr64_2;
unsigned __int64 bb_all_mem;
#endif



// Initialisations
bb_all=0;
num_piece=wptr->num_piece;
psptr=wptr->psptr;
nature=wptr->nature;
dep64=wptr->pos;
ASSERT(psptr->moves==&xw_liste_coups_piece[xlevel][num_piece][0]);
ASSERT(psptr->moves2==&xw_liste_coups2_piece[xlevel][num_piece][0]);
liste_coups_piece_ptr=psptr->moves;
liste_coups2_piece_ptr=psptr->moves2;
#if CHECK_MOVE_GENERATION_WITH_BITBOARDS==1
liste_coups_piece_ptr=&xw_liste_coups_piece_check[0];
liste_coups2_piece_ptr=&xw_liste_coups2_piece_check[0];
#endif
pieces_amies=s->cases_toutes_pieces[wptr->color01];
pieces_ennemies=s->cases_toutes_pieces[1-wptr->color01];


#if ALLOW_FUTILITY11==1
char dir,abs_dir,dir_inv;
#endif

switch(nature)
{
case 'D' :	//masquage_tab=&xmasquage_dame;
		depart=0; delta_dir=1;
		break;
case 'T' :	//masquage_tab=&xmasquage_tour;
		depart=0; delta_dir=2;
		break;
case 'F' :	//masquage_tab=&xmasquage_fou;
		depart=1; delta_dir=2;
		break;
}

// for sur toutes les directions de la pice
for (dir=depart;dir<8;dir+=delta_dir)
{
inc=xinc64[dir]; 
//masquage=masquage_tab+dir;
//masque_direction=&xmasque_direction[dep64][dir];

// La direction correspond  la direction de shift
//  gauche			 		>> 8
//  droite 				>>-8
// vers le bas				>> 1 et masquage pralable range du bas
// vers le haut 				>>-1 et masquage pralable range du haut
// diagonale  gauche et en bas	>>9  et masquage p ralable range du bas
// diagonale  gauche et en haut    >>7  et masquage pralable range du haut
// diagonale  droite et en haut    >>-9 et masquage pralable range du haut
// diagonale  droite et en bas     >>-7 et masquage pralable range du bas

// Shift initial
// En effet, la pice d'interception peut tre une pice adverse
// et peut tre  prise
// Le masquage de direction initial est suffisant
masque_direction=xmasque_direction[dep64][dir];
// Le masquage sert  viter alors qu'on actualise depuis 0 vers le haut
// que la case 8 "rapparaisse" en 7 en cas de dcalage vers le bas
// Mais il est inutile du fait de l'application du masque de direction
//shift=(shift&(*masquage))>>inc;
//cumul_shift=shift;

// 5 Shifts suivants 
// Pourquoi 5 shifts ?
// Soit une tour en 11, son roi en 21 et le roi adverse en 81
// Le shift initial est fait car mme les pices amies ne sont pas shiftes initialement
// Le shift initial fait commencer en 31
// les 5 shifts suivants sont donc 31,41,51,61,71,81
if (inc>0)
{
	shift= ((pieces_amies&~((unsigned __int64) 1<<dep64) | pieces_ennemies)<<inc)
  	        &masque_direction;
    cumul_shift=shift;
	
	shift<<=inc; cumul_shift|=shift;
	shift<<=inc; cumul_shift|=shift;
	shift<<=inc; cumul_shift|=shift;
	shift<<=inc; cumul_shift|=shift;
	shift<<=inc; cumul_shift|=shift;
	/*
	for(j=0;j<5;j++)
	{
	shift=shift<<inc;
	cumul_shift|=shift;
	}
	*/
}
else
{
	shift= ((pieces_amies&~((unsigned __int64) 1<<dep64) | pieces_ennemies)>>(-inc))
  	        &masque_direction;
    cumul_shift=shift;

	shift>>=(-inc); cumul_shift|=shift;
	shift>>=(-inc); cumul_shift|=shift;
	shift>>=(-inc); cumul_shift|=shift;
	shift>>=(-inc); cumul_shift|=shift;
	shift>>=(-inc); cumul_shift|=shift;
	/*
	for(j=0;j<5;j++)
	{
	//shift=(shift&(*masquage))>>8;
	shift=shift>>(-inc); // aprs inversion de inc
	cumul_shift|=shift;
	// Cumul_shift vaut 1 pour les cases masques aprs la case d'interception
	// la case d'interception reste un coup jouable jusqu' vrification piece adverse
	}
	*/
}

// Ajouts coups jouables dans cette direction
// Les coups jouables s'obtiennent par ou exclusif avec les cases shiftees
bb_all|=masque_direction&(~cumul_shift);;

} // fin for directions




// Mise  jour cases controles
// Avant la consommation de bb_all
//  psptr->cases_controlees=bb_all;


// Note aprs 64 dcalages, on arrive forcment  zro
color01=wptr->color01;
type=wptr->type;
posvalue=wptr->psptr->posvalue;
color=wptr->color;


// bb_all_mem=bb_all;


#if USE_DEBRUIJN_BITSCAN==1
while(bb_all!=0)
{
	arr64=bitScanForward_Clear(bb_all);
#endif
#if USE_DEBRUIJN_BITSCAN==0
for(arr64=0;bb_all!=0;arr64++,bb_all=bb_all>>1)
{ 
if (bb_all&1) // le coup est jouable
{
#endif


	arr_ptr=&xboard[arr64];
	//arr64_2=bitScanForward_Clear(bb_all_mem);
	//#if _DEBUG
    //if (arr64_2!=arr64) log_error("M_7843", xcompteur);
	//#endif

	// Test le coup est-il une pice adverse
	if (bit(pieces_ennemies,arr64)==1)
	{
	prise_num=arr_ptr->num_piece;
	prise_nat=arr_ptr->nature;
	#if USE_PIECES_ATTAQUEES==1
	set_bit_to_1(s->pieces_attaquees,prise_num);
	  set_bit_to_1(psptr->pieces_attaquees, prise_num);
	#endif
  	//#if USE_PIECES_ATTAQUEES==0
	//#if USE_SEARCH_ALL_UNDEFENDED_PIECES==0
	//  set_bit_to_1(xsearch_level[xlevel]->pieces_attaquees_dernier_coup, prise_num);
	//#endif
	//#endif
	#if USE_CASES_COUPS_FORCANTS==1
	if (cat==COUP_FORCANT)
	{
		set_bit_to_1(s->cases_coup_forcant[color01],arr64);
		  set_bit_to_1(psptr->cases_coup_forcant,arr64);
	}
	#endif


	switch(nature)
	{
	case 'D' : 
				switch(prise_nat)
				{
				case 'P' : cat=PRISE_PION_PAR_PIECE; break;
				case 'D' : cat=ECHANGE_PIECE; break;
				case 'R' : cat=AUTRE_COUP; break;
				default : cat=PRISE_PIECE_INFERIEURE; break;
				}
				break;
	case 'T' : 
				switch(prise_nat)
				{
				case 'P' : cat=PRISE_PION_PAR_PIECE; break;
				#if ALLOW_EXTEND_ROOK_SACRIFICES==0
				case 'C' : cat=PRISE_PIECE_INFERIEURE; break;
				case 'F' : cat=PRISE_PIECE_INFERIEURE; break;
				#endif
				#if ALLOW_EXTEND_ROOK_SACRIFICES==1
				case 'C' : cat=ECHANGE_PIECE; break;
				case 'F' : cat=ECHANGE_PIECE; break;
				#endif
				case 'T' : cat=ECHANGE_PIECE; break;
				case 'D' : cat=COUP_FORCANT; break;
				case 'R' : cat=AUTRE_COUP; break;
				default : cat=ECHANGE_PIECE; break;
				}
				break;
	default : 
				switch(prise_nat)
				{
				case 'P' : cat=PRISE_PION_PAR_PIECE; break;
				case 'D' : cat=COUP_FORCANT; break;
				case 'T' : cat=COUP_FORCANT; break;
				case 'R' : cat=AUTRE_COUP; break;
				default : cat=ECHANGE_PIECE; break;
				}
				break;
	}
	
	// Traitement en prises
    // move=MOVE_MAKE2(num_piece,nature,color01,dep64,arr64,MoveNormal,cat,0,arr_ptr->nature,arr_ptr->piece_value);
	//priority=getpriority(color01,nature,dep64,arr64);
	//move=MOVE_MAKE(num_piece,nature,color01,dep64,arr64,MoveNormal,cat,priority);
	move=MOVE_MAKE(nature,dep64,arr64,MoveNormal,cat);
	SET_MOVE_CAPTURE(move,prise_nat);
	mob_prises++;
	#if USE_CASES_ACTUALISATION==1
	set_bit_to_1(psptr->cases_actualisation,arr64);
	#endif
	*liste_coups2_piece_ptr++=move;
	#if DEBUG==1
	si1=MOVE_CAPTURE(move);
	si2=MOVE_CAPTURE_VALUE(move);
	if (si2==0 ||si1==0) 
		log_error("\nErr M_894");
		si1=0;
	#endif

	} // fin prise
	else if (bit(pieces_amies,arr64)==1)
	{
		#if USE_CASES_ACTUALISATION==1
		set_bit_to_1(psptr->cases_actualisation,arr64);
		#endif
	}
	else // coups normaux
	{
		// Priorit
		// Il n'est pas ncessaire de multiplier par color car c'est dja fait dans posvalue
		//priority=arr_ptr->posval[type]-posvalue;
		//priority=xboard_posvalue[arr_ptr->num_piece][type]-posvalue;
		//priority=getpriority(color01,nature,dep64,arr64);
		//move=MOVE_MAKE(num_piece,nature,color01,dep64,arr64,MoveNormal,AUTRE_COUP,priority);
    	move=MOVE_MAKE(nature,dep64,arr64,MoveNormal,AUTRE_COUP);
		mob_others++;
		#if USE_CASES_ACTUALISATION==1
		set_bit_to_1(psptr->cases_actualisation,arr64);
		#endif
		*liste_coups_piece_ptr++=move;

	} // fin coup normal
#if USE_DEBRUIJN_BITSCAN==1
}; // fin while
#endif
#if USE_DEBRUIJN_BITSCAN==0
} // fin coup
} // fin for
#endif

// Clture listes
*liste_coups_piece_ptr=0;
*liste_coups2_piece_ptr=0;

} // fin fonction get_moves_DTF



void SEARCH::get_moves_CR(PIECE* wptr, PIECE_SET* psptr,char &mob_others,char &mob_prises)
{
unsigned __int64 bb_all;
unsigned __int64 pieces_ennemies, pieces_amies;
char cat;
MOVE move;
char prise_nat;
char prise_num;
char num_piece;
// char dep88, arr88;
char dep64, arr64;
char color01;
char type;
char posvalue;
CASE *arr_ptr;
char nature;
MOVE *liste_coups_piece_ptr,*liste_coups2_piece_ptr;


// Initialisations
num_piece=wptr->num_piece;
//dep88=wptr->pos;
//dep64=TO64(dep88);
dep64=wptr->pos;
nature=wptr->nature;
ASSERT(psptr->moves==&xw_liste_coups_piece[xlevel][num_piece][0]);
ASSERT(psptr->moves2==&xw_liste_coups2_piece[xlevel][num_piece][0]);
liste_coups_piece_ptr=psptr->moves;
liste_coups2_piece_ptr=psptr->moves2;
#if CHECK_MOVE_GENERATION_WITH_BITBOARDS==1
liste_coups_piece_ptr=&xw_liste_coups_piece_check[0];
liste_coups2_piece_ptr=&xw_liste_coups2_piece_check[0];
#endif
pieces_amies=s->cases_toutes_pieces[wptr->color01];
pieces_ennemies=s->cases_toutes_pieces[1-wptr->color01];

// Obtention immdiate des coups
switch(nature)
{
case 'C' : bb_all=xcases_arrivee_cavalier[dep64];
	     break;
case 'R' : bb_all=xcases_arrivee_roi[dep64];
           break;
}

// Mise  jour cases controles
// Avant la consommation de bb_all
//psptr->cases_controlees=bb_all;
#if USE_CASES_ACTUALISATION==1
psptr->cases_actualisation=bb_all;
#endif

// Note aprs 64 dcalages, on arrive forcment  zro
type=wptr->type;
posvalue=wptr->psptr->posvalue;
//color=wptr->color;
color01=wptr->color01;
for(arr64=0;bb_all!=0;arr64++,bb_all=bb_all>>1)
{
if (bb_all&1) // le coup est jouable
{
	//arr88=TO88(arr64);
	arr_ptr=&xboard[arr64];

	// Test le coup est-il une prise
	if (bit(pieces_ennemies,arr64)==1)
	{
	prise_num=arr_ptr->num_piece;
	prise_nat=arr_ptr->nature;
	#if USE_PIECES_ATTAQUEES==1
	set_bit_to_1(s->pieces_attaquees,num_piece);
	  set_bit_to_1(psptr->pieces_attaquees, num_piece);
	#endif
	//#if USE_PIECES_ATTAQUEES==0
	//#if USE_SEARCH_ALL_UNDEFENDED_PIECES==0
	//  set_bit_to_1(xlevelptr->pieces_attaquees_dernier_coup,num_piece);
	//#endif
	//#endif
    switch(nature)
	{
	case 'R' : 
		switch(prise_nat)
		{
			case 'P' : cat=PRISE_PION_PAR_PIECE; break;
			default  : cat=COUP_FORCANT; break;  		
		}
		break;
	case 'C' : 
		switch(prise_nat)
		{
			case 'P' : cat=PRISE_PION_PAR_PIECE; break;
			case 'C' : cat=ECHANGE_PIECE; break;
			case 'F' : cat=ECHANGE_PIECE; break;
			case 'R' : cat=AUTRE_COUP;
					   // Note : il n'y a pas lieu  erreur
				       // mais le coup ne devra pas tre jou !
		 			   #if USE_CASES_ACTUALISATION==0
							if (chkptr[side_checked01]==NULL) 
							{ 
							chkptr[side_checked01]=wptr;
							}
							else if (wptr!=chkptr[side_checked01])
							{ 
								chkptr2[side_checked01]=wptr; // Echec double
							}
					   #endif
					   break;
			default  : cat=COUP_FORCANT; break;  		
		}
		break;
	}

	#if USE_CASES_COUPS_FORCANTS==1
	if (cat==COUP_FORCANT)
	{
		set_bit_to_1(s->cases_coup_forcant[color01],arr64);
		  set_bit_to_1(psptr->cases_coup_forcant,arr64);
	}
	#endif



	// Traitement en prises
	move=MOVE_MAKE(nature,dep64,arr64,MoveNormal,cat);
	SET_MOVE_CAPTURE(move,prise_nat);
	mob_prises++;
	*liste_coups2_piece_ptr++=move;
	#if DEBUG==1
	char cc;
	cc=MOVE_NUM_PIECE(move);
	#endif

	} // fin prise
	else if (bit(pieces_amies,arr64)==1)
	{
		// NoOp
	}
	else // Coups normaux
	{
		// Priorit
		// Il n'est pas ncessaire de multiplier par color car c'est dja fait dans posvalue
		//priority=arr_ptr->posval[type]-posvalue;
		// Traitement en prises
		//priority=getpriority(color01,nature,dep64,arr64);
		move=MOVE_MAKE(nature,dep64,arr64,MoveNormal,AUTRE_COUP);
		mob_others++;
		*liste_coups_piece_ptr++=move;

	} // fin coup normal

} // fin coup jouable
} // fin for


// Ajout des roques
if (nature=='R')
{
if (color01==1)
{
	if (s->droit_roque[1]&DROIT_PETIT_ROQUE)
	{
		//move=MOVE_MAKE(num_piece,nature,color01,dep64,arr64,MoveNormal,cat,priority);
		move=MOVE_MAKE(nature,32,48,MoveCastle,AUTRE_COUP);
	*liste_coups_piece_ptr++=move;
	mob_others++;
}
	if (s->droit_roque[1]&DROIT_GRAND_ROQUE) 
{
		//move=MOVE_MAKE(num_piece,nature,color01,32,16,MoveCastle,COUP_SELECTIONNE,60);
		move=MOVE_MAKE(nature,32,16,MoveCastle,AUTRE_COUP);
	*liste_coups_piece_ptr++=move;
	mob_others++;
}
}
else
{
	if (s->droit_roque[0]&DROIT_PETIT_ROQUE)
{
		move=MOVE_MAKE(nature,39,55,MoveCastle,AUTRE_COUP);
	*liste_coups_piece_ptr++=move;
	mob_others++;
}
	if (s->droit_roque[0]&DROIT_GRAND_ROQUE) 
{
		//move=MOVE_MAKE(num_piece,nature,color01,39,23,MoveCastle,COUP_SELECTIONNE,60);
		move=MOVE_MAKE(nature,39,23,MoveCastle,AUTRE_COUP);
	*liste_coups_piece_ptr++=move;
	mob_others++;
}
}
} // fin test roques

// Clture listes
*liste_coups_piece_ptr=0;
*liste_coups2_piece_ptr=0;

} // fin fonction get_moves_CR

#endif



